      SUBROUTINE IMF(ACN,ZCN,TEMP,EE,ZIMF,AIMF,BIMF,SBIMF,TIMF,
     &                                                IRNDM,SLOPE,JPRF)

C     input variables (compound nucleus) Acn, Zcn, Temp, EE
C     output variable (IMF) Zimf,Aimf,Bimf,Sbimf,IRNDM
C
C     SBIMF = separation energy + coulomb barrier
C
C     SDW(Z) is the sum over all isotopes for a given Z of the decay widths
C     DW(Z,A) is the decay width of a certain nuclide
C
C  Last update:
C             28/10/13 - JLRS - from abrablav4 (AK)

      REAL*8 ACN,ZCN,ZIMF,AIMF,SBIMF,BIMF,ZIMF_1,AIMF_1,DENSIMF,NIMF
      REAL*8 MARES,MAIMF,MAZ,OMEGAP,IMFARG,WIDTH_IMF,TEMP,EE,TIMF,WIDTH1
      REAL*8 DW(3:95,4:250),WIDTH,SDWprevious,SUM_Z,SUMDW_N_TOT,SUM_A
      REAL*8 SUMDW_TOT,SUM,SDW(3:95),SSBIMF(3:95,4:250),X,XX,
     &       BBIMF(3:95,4:250)
      REAL*8 AKAP,BET,HOMEGA,KOEFF,BSHELL,DEFBET,DENSCN,TEMPCN
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98)
      REAL*8 ALPHA(0:153,0:98),BSIMF,SLOPE,DEFBETIMF,EROT,JPRF,EROTCN
      REAL*8 FISSILITY,XXX,Y,BIPOL,SPDEF,ECOR,A1PAR,A2PAR,IINERT,EEDAUG
      REAL*8 GIMF,GIMF3,BS,BK,QR_FACT,PI,QR,QRCN
      REAL*8 BETA2(0:250,0:136),BETA4(0:250,0:136)
      REAL*4 HAZ,XRNDM,RTEST
      INTEGER*4 IFIS,OPTSHP,OPTXFIS,OPTCOL,IEROT
      INTEGER*4 IZIMF,IAIMF,INIMF,INMI,INMA,IRNDM,IZIMFMAX,INMAXLIM,
     &          INMINMEM,INMAXMEM,OPTSHPIMF
      INTEGER*4 IA,IZ,IZSTOP,I_ZIMF,II_ZIMF,III_ZIMF,IIA,IINIMF,INCN
      INTEGER*4 ILIMMAX,IZCN,INMIN,INNMAX,IIINIMF,INIMFMA,INIMFMI,IZMEM
      INTEGER itesting ,I_CHECK
      COMMON /ZIMFRANGE/ IZIMFMAX
      COMMON /FIS/AKAP,BET,HOMEGA,KOEFF,IFIS,OPTSHP,
     &        OPTXFIS,OPTCOL
      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
      COMMON/GIMF_TESTING/GIMF,GIMF3
      COMMON/IEROT/IEROT
      COMMON/OPTIMF/OPTSHPIMF

      itesting = 0
      PI = 3.141592653589793238D0
c      itesting = I_CHECK
      IF (itesting.EQ.1) WRITE(6,*) 'IMF entered'

c     Loop to calculate the decay widths ************************
c      write(6,*) '=============ACN,ZCN,TEMP,EE',ACN,ZCN,TEMP,EE

c      take the half of the CN and transform it in integer (floor it)
      IZIMFMAX = IDINT(ZCN / 2.D0)
      IF (IZIMFMAX.LT.3) THEN
         WRITE(6,*) 'CHARGE_IMF line 46'
         WRITE(6,*) 'Problem: IZIMFMAX < 3 !'
         write(6,*) 'ZCN,IZIMFMAX',ZCN,IZIMFMAX
      ENDIF

C Deformation of the mother nucleus
      BSHELL = ECGNZ(IDNINT(ACN-ZCN),IDNINT(ZCN)) -
     &                        VGSLD(IDNINT(ACN-ZCN),IDNINT(ZCN))
      DEFBET = BETA2(IDNINT(ACN-ZCN),IDNINT(ZCN))

          CALL BSBK(ACN,ZCN,BS,BK)

c           CALL  DENSNIV(ACN,ZCN,EE,0.D0,
c     &	DENSCN,BSHELL,BS,BK,TEMPCN,OPTSHP,OPTCOL,DEFBET,ECOR,JPRF,0,QRCN)

           CALL  DENSNIV(ACN,ZCN,EE,0.D0,
     &	DENSCN,BSHELL,BS,BK,TEMPCN,0,0,DEFBET,ECOR,JPRF,0,QRCN)

      IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ACN**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
      EROTCN = JPRF * JPRF * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
      IF(IEROT.EQ.1) EROT = 0.D0

c      print*,'IZIMFMAX:',IZIMFMAX
      DO IZIMF = 3, IZIMFMAX

        SDW(IZIMF) = 0.D0
        ZIMF_1 = DFLOAT(IZIMF)

C     *** Find the limits that both IMF and partner are bound :

        CALL ISOSTAB_LIM(IZIMF,INIMFMI,INIMFMA)   ! Bound isotopes for IZIMF from INMIN to INIMFMA
C Idea - very proton-rich nuclei can live long enough to evaporate IMF before decaying:
         INIMFMI = MAX(1,INIMFMI-2)

        IZCN = IDINT(ZCN)                       ! Z of CN
        INCN = IDINT(ACN) - IZCN                ! N of CN

        CALL ISOSTAB_LIM(IZCN-IZIMF,INMI,INMA)  ! Daughter nucleus after IMF emission,
                                                ! limits of bound isotopes
         INMI = MAX(1,INMI-2)

        INMIN = MAX(INIMFMI,INCN-INMA)          ! Both IMF and daughter must be bound
        INNMAX = MIN(INIMFMA,INCN-INMI)          !   "

        ILIMMAX = MAX(INNMAX,INMIN)    ! In order to keep the variables below
C     ***

        DO INIMF = INMIN,ILIMMAX, 1             ! Range of possible IMF isotopes
          IAIMF = IZIMF + INIMF
          DW(IZIMF,IAIMF) = 0.D0
          AIMF_1 = DFLOAT(IAIMF)

C         Q-values
          CALL MGLMS(ACN-AIMF_1,ZCN-ZIMF_1,OPTSHPIMF,MARES)
          CALL MGLMS(AIMF_1,ZIMF_1,OPTSHPIMF,MAIMF)
          CALL MGLMS(ACN,ZCN,OPTSHPIMF,MAZ)

C         Barrier
          IF(ACN.LE.AIMF_1)THEN
            SSBIMF(IZIMF,IAIMF) = 1.D+37
          ELSE
            CALL BARRS(EE/ACN,ZCN-ZIMF_1,ACN-AIMF_1,ZIMF_1,AIMF_1,
     +                BIMF,OMEGAP)
            SSBIMF(IZIMF,IAIMF) = MAIMF + MARES - MAZ + BIMF
            BBIMF(IZIMF,IAIMF) = BIMF
          ENDIF

c           CALL  DENSNIV(ACN,ZCN,EE,SSBIMF(IZIMF,IAIMF),
c     &	DENSCN,0.D0,BS,BK,TEMPCN,OPTSHP,0,DEFBET,ECOR,JPRF,2,QR)

C *****  Width *********************
       DEFBETIMF = BETA2(IDNINT(AIMF_1-ZIMF_1),IDNINT(ZIMF_1)) +
     &           BETA2(IDNINT(ACN-AIMF_1-ZCN+ZIMF_1),IDNINT(ZCN-ZIMF_1))
       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ACN**(5.D0/3.D0)*
     &          (AIMF_1**(5.D0/3.D0) + (ACN - AIMF_1)**(5.D0/3.D0)) +
     &          931.49D0 * 1.16D0**2 * AIMF_1 * (ACN-AIMF_1) / ACN *
     &          (AIMF_1**(1.D0/3.D0) + (ACN - AIMF_1)**(1.D0/3.D0))**2


       EROT = JPRF * JPRF * 197.328d0 * 197.328d0 /(2.D0 * IINERT)

       IF(IEROT.EQ.1) EROT = 0.D0

          IF (EE.LT.(SSBIMF(IZIMF,IAIMF)+EROT).OR.DENSCN.EQ.0.D0) THEN
           WIDTH_IMF = 0.D0
c          PRINT*,IDNINT(ACN),IDNINT(ZCN),IZIMF,IAIMF
          ELSE
C          here the temperature at "saddle point" is used
C Increase of the level densitiy at the barrier due to deformation; see comment in ABLA
c          BSIMF = ((ACN-AIMF_1)**(2.D0/3.D0) + AIMF_1**(2.D0/3.D0))/
c     &                ACN**(2.D0/3.D0)
           BSIMF = BS
           CALL  DENSNIV(ACN,ZCN,EE,SSBIMF(IZIMF,IAIMF),DENSIMF,
     &     0.D0,BSIMF,1.D0,TIMF,0,0,DEFBETIMF,ECOR,JPRF,2,QR)
           IMFARG = (SSBIMF(IZIMF,IAIMF)+EROTCN-EROT)/TIMF
           IF(IMFARG. GT. 200.D0) IMFARG = 200.D0

           WIDTH1 = WIDTH(ACN,ZCN,AIMF_1,ZIMF_1,TIMF,BIMF,
     &                    SSBIMF(IZIMF,IAIMF),EE-EROT)

           WIDTH_IMF = WIDTH1 * DEXP(-IMFARG) * QR / QRCN
c     &                 * DENSIMF / DENSCN


          IF(WIDTH_IMF.LE.0.D0)THEN
          WRITE(*,*)'GAMMA_IMF=0 -> LOOK IN GAMMA_IMF CALCULATIONS!'
          WRITE(*,*)'ACN,ZCN,AIMF,ZIMF:',IDNINT(ACN),IDNINT(ZCN),
     &                                   IDNINT(AIMF_1),IDNINT(ZIMF_1)
          WRITE(*,*)'SSBIMF,TIMF : ',SSBIMF(IZIMF,IAIMF),TIMF
          WRITE(*,*)'DEXP(-IMFARG) = ',DEXP(-IMFARG)
          WRITE(*,*) 'WIDTH1 = ',WIDTH1
          ENDIF

          ENDIF

          SDW(IZIMF) = SDW(IZIMF) + WIDTH_IMF

          DW(IZIMF,IAIMF) = WIDTH_IMF

        ENDDO

c     *****

      ENDDO
c     End loop to calculate the decay widths ************************
C     ***************************************************************

C     For nuclei below the Businaro-Gallone point ( (ZCN**2D0/ACN).lt.22 )
C     the decay width are left as they are. For nuclei above, the decay
C     widths are truncated after the first minimum of SDW(ZIMF)

c      WRITE(6,*) 'x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x'
c      DO III_ZIMF = 3, IZIMFMAX
c      WRITE(6,*) 'Z,SDW = ',III_ZIMF,SDW(III_ZIMF)
c      ENDDO
c      WRITE(6,*) 'x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x'


cc      IF((ZCN**2.D0/ACN).lt.22.D0) THEN
cc        IZSTOP = IZIMFMAX
cc        GOTO 15
cc      ENDIF


c     Loop to calculate where the gamma of IMF has the minimum ******

c     1.D20 = arbitrary large value to initiate SDWprevious
      SDWprevious = 1.D20
      IZSTOP = 0.D0

c      WRITE(6,*) 'x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x'
c      DO III_ZIMF = 3, IZIMFMAX
c      WRITE(6,*) 'Z,SDW = ',III_ZIMF,SDW(III_ZIMF)
c      ENDDO
c      WRITE(6,*) 'x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x'


      DO III_ZIMF = 3, IZIMFMAX

c      WRITE(6,*) 'Z,SDWpr.,SDW = ',III_ZIMF,SDWprevious,SDW(III_ZIMF)
c      WRITE(6,*) 'Z,SDW = ',III_ZIMF,SDW(III_ZIMF)

         IF (SDW(III_ZIMF).eq.0.D0) THEN
            IZSTOP = III_ZIMF - 1
           if (IZSTOP.EQ.3) write(*,*) 'IZSTOP = 3, SDW = 0'
            GOTO 30
         ENDIF

         IF (SDW(III_ZIMF).gt.SDWprevious) THEN
            IZSTOP = III_ZIMF - 1
            GOTO 30
         ELSE
            SDWprevious = SDW(III_ZIMF)
         ENDIF

      ENDDO

 30    CONTINUE

c       WRITE(6,*) 'IZSTOP = ',IZSTOP, IZIMFMAX

      IF(IZSTOP.LE.6)THEN
       IZSTOP = IZIMFMAX
       GOTO 15
      ENDIF

      A1PAR = DLOG10(SDW(IZSTOP)/SDW(IZSTOP-2))/
     &        DLOG10(DFLOAT(IZSTOP)/DFLOAT(IZSTOP-2))

      A2PAR = DLOG10(SDW(IZSTOP)) - A1PAR * DLOG10(DFLOAT(IZSTOP))

c      print*,a1par,a2par

c     End loop to calculate where gamma of IMF has the minimum ******
C     ***************************************************************

      DO II_ZIMF = IZSTOP, IZIMFMAX
c        SDW(II_ZIMF)  = SDW(IZSTOP)    ! Flattening
c         SDW(II_ZIMF)  = SDW(IZSTOP) - (SDW(II_ZIMF) - SDW(IZSTOP)) ! Mirrowing

       SDW(II_ZIMF) =  10.D0**A2PAR * (DFLOAT(II_ZIMF))**A1PAR  ! Power-low

       IF (SDW(II_ZIMF).LT.0.D0) SDW(II_ZIMF) = 0.D0

      ENDDO

C     *** Sum of all decay widths (for normalisation) ***************

 15   CONTINUE

      SUMDW_TOT = 0.0D0

      DO I_ZIMF = 3, IZIMFMAX
        SUMDW_TOT = SUMDW_TOT + SDW(I_ZIMF)
c      WRITE(6,*) 'Z,SDW = ',I_ZIMF,SDW(I_ZIMF)
      ENDDO
      IF (SUMDW_TOT.LE.0.D0) THEN
        WRITE(6,*)'*********************'
        WRITE(6,*) 'CHARGE_IMF line 227'
        WRITE(6,*) 'SUM of decay widths = ',SUMDW_TOT,
     &       ' IZIMFMAX = ',IZIMFMAX
        WRITE(6,*) 'IZSTOP = ',IZSTOP
      DO I_ZIMF = 3, 3
       IF(I_ZIMF.EQ.3)PRINT*,'GIMF FOR Z =3',GIMF3,SDW(I_ZIMF)
      ENDDO
      ENDIF

C     *** End of Sum of all decay widths (for normalisation) *********

c     Loop to sample the nuclide that is emitted ********************

C     ------- sample Z -----------

 10     CONTINUE
      XRNDM = HAZ(1)
      X = DBLE(XRNDM)*SUMDW_TOT

c      IF(X.EQ.0.D0) PRINT*,'WARNING: X=0',XRNDM,SUMDW_TOT
      SUM_Z = 0.D0
      ZIMF = 0.D0
      IZMEM = 0

      DO IZ = 3,IZIMFMAX
          SUM_Z = SUM_Z + SDW(IZ)
c      print*,'Z random',IZ,x,SUM_Z,SDW(IZ)
          IF(X.LT.SUM_Z) THEN
            ZIMF = DFLOAT(IZ)
            IZMEM = IZ
            GOTO 20
          ENDIF
      ENDDO

 20   CONTINUE
c      write(6,*)'1)IZ, ZIMF', ZIMF

C     ------- sample N -----------

      CALL ISOSTAB_LIM(IZMEM,INMINMEM,INMAXMEM)
       INMINMEM = MAX(1,INMINMEM-2)

      CALL ISOSTAB_LIM(IZCN-IZMEM,INMI,INMA)  ! Daughter nucleus after IMF emission,
         INMI = MAX(1,INMI-2)
                                                ! limits of bound isotopes

        INMINMEM = MAX(INMINMEM,INCN-INMA)          ! Both IMF and daughter must be bound
        INMAXMEM = MIN(INMAXMEM,INCN-INMI)          !   "

        INMAXMEM = MAX(INMINMEM,INMAXMEM)

      IA = 0
      SUMDW_N_TOT = 0.D0
      DO IIINIMF = INMINMEM,INMAXMEM, 1
        IA = IZMEM + IIINIMF
      IF(IZMEM.GE.3.AND.IZMEM.LE.95.AND.IA.GE.4.AND.IA.LE.250)THEN
        SUMDW_N_TOT = SUMDW_N_TOT + DW(IZMEM,IA)
      ELSE
         PRINT*,'CHARGE IMF OUT OF RANGE',IZMEM,IA,IDNINT(ACN),
     &           IDNINT(ZCN),TEMP
      ENDIF
      ENDDO

      XX = DBLE(HAZ(1))*SUMDW_N_TOT
      IIA = 0
      SUM_A = 0.D0
      DO IINIMF = INMINMEM,INMAXMEM, 1
        IIA = IZMEM + IINIMF
        SUM_A = SUM_A + DW(IZ,IIA)
        IF(XX.LT.SUM_A) THEN
          AIMF = DFLOAT(IIA)
          GOTO 25
        ENDIF
      ENDDO


 25   CONTINUE

C     CHECK POINT 1
      NIMF = AIMF - ZIMF

      IF((ACN-ZCN-NIMF).LE.0.D0 .OR. (ZCN-ZIMF) .LE. 0.D0)THEN
       WRITE(6,*)'IMF Partner unstable:'
       WRITE(6,*)'System: Acn,Zcn,NCN:'
       WRITE(6,*)IDNINT(ACN),IDNINT(ZCN),IDNINT(ACN-ZCN)
       WRITE(6,*)'IMF: A,Z,N:'
       WRITE(6,*)IDNINT(AIMF),IDNINT(ZIMF),IDNINT(AIMF-ZIMF)
       WRITE(6,*)'Partner: A,Z,N:'
       WRITE(6,*)IDNINT(ACN-AIMF),IDNINT(ZCN-ZIMF),IDNINT(ACN-ZCN-NIMF)
      GOTO 10
      ENDIF

      IF(ZIMF.GE.ZCN.or.AIMF.GE.ACN.or.ZIMF.LE.2.or.AIMF.LE.3) THEN
        write(6,*)'----nmin,nmax',INMINMEM,INMAXMEM
        write(6,*)'----- warning: Zimf=',zimf,'Aimf=',Aimf
        write(6,*)'----- look in subroutine IMF'
        write(6,*) 'ACN,ZCN,ZIMF,AIMF,temp,EE',ACN,ZCN,ZIMF,AIMF,temp,EE
        write(6,*)'WIDTHS',GIMF, SUMDW_TOT, SUMDW_N_TOT,IZIMFMAX
c       write(6,*) 'IMF will be resampled'
C       GOTO 10
c        ZIMF = 1.D0  ! provisorisch KHS
c        AIMF = 2.D0
        ZIMF = 3.D0  ! provisorisch AK
        AIMF = 4.D0
      ENDIF

C Characteristics of selected IMF (AIMF, ZIMF, BIMF, SBIMF, TIMF)
      SBIMF = SSBIMF(IDINT(ZIMF),IDINT(AIMF))
      BIMF = BBIMF(IDINT(ZIMF),IDINT(AIMF))

      if((zcn-zimf).le.0.d0)print*,'CHARGE_IMF ZIMF > ZCN'
      if((acn-aimf).le.0.d0)print*,'CHARGE_IMF AIMF > ACN'

      BSHELL = ECGNZ(IDNINT(ACN-ZCN-NIMF),IDNINT(ZCN-ZIMF)) -
     &                  VGSLD(IDNINT(ACN-ZCN-NIMF),IDNINT(ZCN-ZIMF))
      DEFBET = BETA2(IDNINT(ACN-ZCN-NIMF),IDNINT(ZCN-ZIMF))
      EEDAUG = (EE - SBIMF) * (ACN - AIMF) / ACN
      CALL BSBK(ACN - AIMF,ZCN-ZIMF,BS,BK)
      CALL  DENSNIV(ACN-AIMF,ZCN-ZIMF,EEDAUG,0.D0,
     &   DENSIMF,BSHELL,BS,BK,TIMF,0,0,DEFBET,ECOR,0.D0,0,QR)

c      write(6,*)IZ,IiA,zimf,Aimf,sbimf,SSBIMF(IDINT(ZIMF),IDINT(AIMF))


C     CHECK POINT 2
      IF (SBIMF.gt.EE) THEN
        write(6,*)'----- warning: EE=',EE,'S+Bimf=',SBimf
        write(6,*)'----- look in subroutine IMF'
        write(6,*) ACN,ZCN,AIMF,ZIMF,EE,BIMF,SBIMF-BIMF
        write(6,*)'IMF will be resampled'
      itesting = itesting + 1
      print*,'itesting=',itesting
        GOTO 10
      ENDIF
c        write(6,*)'IMF=',ZIMF,AIMF

      RETURN
      END
C
C********************************************************************************
C
      SUBROUTINE ISOSTAB_LIM(Z, NMIN, NMAX)
C
      INTEGER*4 Z, NMIN, NMAX

      INTEGER*4 VISOSTAB(2,95)
      DATA VISOSTAB/                          0,7,     !  1
     &                                        1,8,     !  2
     &                                        1,9,     !  3
     &                                        2,12,    !  4
     &                                        2,14,    !  5
     &                                        2,16,    !  6
     &                                        3,18,    !  7
     &                                        4,22,    !  8
     &                                        6,22,    !  9
     &                                        6,28,    ! 10
     &                                        7,28,    ! 11
     &                                        7,30,    ! 12
     &                                        8,28,    ! 13
     &                                        8,36,    ! 14
     &                                        10,38,   ! 15
     &                                        10,40,   ! 16
     &                                        11,38,   ! 17
     &                                        10,42,   ! 18
     &                                        13,50,   ! 19
     &                                        14,50,   ! 20
     &                                        15,52,   ! 21
     &                                        16,52,   ! 22
     &                                        17,54,   ! 23
     &                                        18,54,   ! 24
     &                                        19,60,   ! 25
     &                                        19,62,   ! 26
     &                                        21,64,   ! 27
     &                                        20,66,   ! 28
     &                                        23,66,   ! 29
     &                                        24,70,   ! 30
     &                                        25,70,   ! 31
     &                                        26,74,   ! 32
     &                                        27,78,   ! 33
     &                                        29,82,   ! 34
     &                                        33,82,   ! 35
     &                                        31,82,   ! 36
     &                                        35,82,   ! 37
     &                                        34,84,   ! 38
     &                                        40,84,   ! 39
     &                                        36,86,   ! 40
     &                                        40,92,   ! 41
     &                                        38,96,   ! 42
     &                                        42,102,   ! 43
     &                                        42,102,   ! 44
     &                                        44,102,   ! 45
     &                                        42,106,   ! 46
     &                                        47,112,   ! 47
     &                                        44,114,   ! 48
     &                                        49,116,  ! 49
     &                                        46,118,  ! 50
     &                                        52,120,  ! 51
     &                                        52,124,  ! 52
     &                                        55,126,  ! 53
     &                                        54,126,  ! 54
     &                                        57,126,  ! 55
     &                                        57,126,  ! 56
     &                                        60,126,  ! 57
     &                                        58,130,  ! 58
     &                                        62,132,  ! 59
     &                                        60,140,  ! 60
     &                                        67,138,  ! 61
     &                                        64,142,  ! 62
     &                                        67,144,  ! 63
     &                                        68,146,  ! 64
     &                                        70,148,  ! 65
     &                                        70,152,  ! 66
     &                                        73,152,  ! 67
     &                                        72,154,  ! 68
     &                                        75,156,  ! 69
     &                                        77,162,  ! 70
     &                                        79,164,  ! 71
     &                                        78,164,  ! 72
     &                                        82,166,  ! 73
     &                                        80,166,  ! 74
     &                                        85,168,  ! 75
     &                                        83,176,  ! 76
     &                                        87,178,  ! 77
     &                                        88,178,  ! 78
     &                                        91,182,  ! 79
     &                                        90,184,  ! 80
     &                                        96,184,  ! 81
     &                                        95,184,  ! 82
     &                                        99,184,  ! 83
     &                                        98,184, ! 84
     &                                        105,194, ! 85
     &                                        102,194, ! 86
     &                                        108,196, ! 87
     &                                        106,198, ! 88
     &                                        115,204, ! 89
     &                                        110,206, ! 90
     &                                        119,210, ! 91
     &                                        114,210, ! 92
     &                                        124,210, ! 93
     &                                        117,212, ! 94
     &                                        130,212/  ! 95


c     IF (Z.LT.0 .OR. Z.GT.95) THEN
      IF (Z.LT.0) THEN
        NMIN = 0
        NMAX = 0
      ELSEIF (Z.EQ.0)THEN
        NMIN = 1
        NMAX = 1
C AK (Dez2010) - Just to avoid numerical problems
      ELSEIF (Z.GT.95) THEN
        NMIN = 130
        NMAX = 200
      ELSEIF(Z.GE.1.AND.Z.LE.95)THEN
        NMIN = VISOSTAB(1,Z)
        NMAX = VISOSTAB(2,Z)
      ENDIF

      RETURN
      END
