       FUNCTION HAZ(K)
#ifndef ABLA07_USE_USER_RNG
       INTEGER*4 K
       real*4 haz,R_RND
C***      SI K=<-1 ON INITIALISE
C***      SI K=-1 C'EST REPRODUCTIBLE
C***      SI K<>-1 CE N'EST PAS REPRODUCTIBLE

          IF (K.LE.-1) THEN
            IF (K.LT.-1) THEN
              CALL SEED(INT(SECNDS(0.0)))   ! debut aleatoire
            ELSE
              CALL SEED(7531)         ! debut reproductible
            ENDIF
          ENDIF
          CALL RANDOM(R_RND)          ! valeur nouvelle
          HAZ = R_RND
          RETURN
#else
      haz = abla07userrng()
      return
#endif
       END
C**********************************************************************
        FUNCTION GAUSSHAZ(K,XMOY,SIG)
C*** TIRAGE ALEATOIRE DANS UNE GAUSSIENNE DE LARGEUR SIG ET MOYENNE XMOY
        real*4 GAUSSHAZ,v1,v2,r,fac,gset,xmoy,sig,haz
        integer*4 K,iset

        save gset,iset

        DATA ISET/0/
        IF(ISET.EQ.0) THEN
1          V1=2.*HAZ(K)-1.
           V2=2.*HAZ(K)-1.
           R=V1**2+V2**2
           IF(R.GE.1.)GO TO 1
           if(r.eq.0.)go to 1
           FAC=SQRT(-2.*LOG(R)/R)
           GSET=V1*FAC
           GAUSSHAZ=V2*FAC*SIG+XMOY
           ISET=1
        ELSE
           GAUSSHAZ=GSET*SIG+XMOY
           ISET=0
        END IF
        RETURN
        END
C**********************************************************************
        FUNCTION EXPOHAZ(K,T)
        real*4 expohaz,T,haz
        integer*4 K
C*** TIRAGE ALEATOIRE DANS UNE EXPONENTIELLLE : Y=EXP(-X/T)
         EXPOHAZ=-T*LOG(HAZ(K))
         RETURN
        END
C**********************************************************************
C  Random generator according to the
C  Powerfunction y = x**(lambda) in the range from xmin to infinity.
C  xmin and y are reals.
C  lambda must be negative and <= -2 !!
C
        FUNCTION POWERHAZ(K,LAMBDA,XMIN)
        real*4 powerhaz,lambda,xmin,rlim,haz
        integer*4 k
          if (lambda.gt.-2.E0) then
            write(*,*) 'POWERHAZ: exponent > -2 not allowed!'
            POWERHAZ = 0.E0
            RETURN
          endif
          rlim = -1.E0 /(lambda + 1.E0) * (xmin)**(lambda + 1.E0)
431       POWERHAZ = EXP( (LOG(HAZ(K)*rlim)+ LOG(-(lambda + 1.E0)))/
     &         (lambda + 1.E0) )
          IF (POWERHAZ.LT.XMIN) GOTO 431 ! To avoid problems due to rounding
          RETURN
        END
C**********************************************************************
C  Random generator according to the
C  powerfunction y = x**(lambda) in the range from xmin to infinity.
C  xmin and y are integers.
C  lambda must be negative and <= -2 !!
C
        FUNCTION IPOWERHAZ(K,LAMBDA,XMIN)
        real*4 lambda,rlim,haz
        integer*4 k,ipowerhaz,xmin
          if (lambda.gt.-2.E0) then
            write(*,*) 'IPOWERHAZ: exponent > -2 not allowed!'
            IPOWERHAZ = 0
            RETURN
          endif
          rlim = -1.E0 /(lambda + 1.E0) *
     &             (float(xmin)-0.5E0)**(lambda + 1.E0)
 432      IPOWERHAZ = NINT(EXP( (LOG(HAZ(K)*rlim)+
     &         LOG(-(lambda + 1.E0)))/(lambda + 1.E0) ))
          IF (IPOWERHAZ.LT.XMIN) GOTO 432 ! To avoid problems due to rounding
          RETURN
        END
C**********************************************************************
C  Random generator according to the
C  powerfunction y = x**(lambda) in the range from xmin to xmax
C  xmin, xmax and y are integers.
C  lambda must be different from -1 !

       FUNCTION IPOWERLIMHAZ(K,LAMBDA,XMIN,XMAX)
       real*4 lambda,haz,y,l_plus,rxmin,rxmax
       integer*4 k,ipowerlimhaz,xmin,xmax
         l_plus = lambda + 1.E0
         rxmin = real(xmin) - 0.5E0
         rxmax = real(xmax) + 0.5E0
         y=(HAZ(k)*(rxmax**l_plus-rxmin**l_plus)
     &     + rxmin**l_plus)**(1.E0/l_plus)
         IPOWERLIMHAZ = NINT(y)
         RETURN
       END
C**********************************************************************
C Random generator according to the
C Maxwell distribution for neutrons according to KHS
C      Y = X * EXP(-X/T) (exact:)
      FUNCTION FMAXHAZ_NEUT(K,T)
      REAL*4 FMAXHAZ_NEUT, T, HAZ
      INTEGER K
      FMAXHAZ_NEUT = (-T * LOG(HAZ(K)) - T * LOG(HAZ(K)))
      RETURN
      END
C**********************************************************************
C Random generator according to a distribution similar to a
C Maxwell distribution for charged particles according to KHS
C      Y = X * X / (B+X) * EXP(-X/T) (approximation:)
      FUNCTION FMAXHAZ(K,T)
      REAL*4 FMAXHAZ, T, HAZ
      INTEGER K
      FMAXHAZ= (-T * LOG(HAZ(K)) - T * LOG(HAZ(K))- T * LOG(HAZ(K)))
      RETURN
      END
C**********************************************************************
C Random generator according to a distribution similar to a
C Maxwell distribution with quantum-mech. x-section for neutrons according to KHS
C      Y = SQRT(X) * EXP(-X/T) (approximation:)
      FUNCTION FVMAXHAZ_NEUT(K,T)
      REAL*4 FVMAXHAZ_NEUT, T, HAZ
      INTEGER K
      FVMAXHAZ_NEUT = 2.E0 * T * SQRT(LOG(HAZ(K)) * LOG(HAZ(K)))
      RETURN
      END
C**********************************************************************
C Random generator according to a distribution similar to a
C Maxwell distribution with quantum-mech. x-section for charged particles according to KHS
C      Y = X**(1.5E0) / (B+X) * EXP(-X/T) (approximation:)
      FUNCTION FVMAXHAZ(K,T)
      REAL*4 FVMAXHAZ, T, HAZ
      INTEGER K
      FVMAXHAZ=3.E0*T*
     &    (-LOG(HAZ(K))*LOG(HAZ(K))*LOG(HAZ(K)))**(0.3333333E0)
      RETURN
      END
C------------------  DISTRIBUTION DE MAXWELL  -------------------------
        FUNCTION FD(E)
        real*4 fd,e
           FD=E*EXP(-E)
        END
C**********************************************************************
C------------------ FONCTION INTEGRALE DE FD(E) -----------------------
        FUNCTION F(E)
        real*4 f,e
           F=1-(E+1)*EXP(-E)
        END
C**********************************************************************
C------------  TIRAGE ALEATOIRE DANS UNE MAXWELLIENNE  ----------------
        FUNCTION FMAXHAZ_OLD(K,T)

C       T : TEMPERATURE
C------ DECLARATION DES VARIABLES
        real*4 fmaxhaz_old,t,x,x1,f,fd,y,P(100),haz
        integer*4 itest,i,k

        DATA ITEST/0/
C------ PROGRAMME PRINCIPAL
        ITEST = 0
        IF (ITEST.EQ.1) GO TO 120
C       CALCUL DES P(I) PAR APPROXIMATION DE NEWTON
        P(100)=8.
        X=0.1
        DO I=1,99
20         X1=X-(F(X)-float(I)/100.)/FD(X)
           X=X1
           IF (ABS(F(X)-float(I)/100.).LT.1D-5) GO TO 100
           GO TO 20
100        P(I)=X
        END DO
        ITEST=1
C------ TIRAGE ALEATOIRE ET CALCUL DU X CORRESPONDANT
C       PAR REGRESSION LINEAIRE
120     Y=HAZ(K)
        I=NINT(Y*100.)
        IF (I.EQ.1) THEN
            X=P(I)*Y*100.
        ELSE
            X=(P(I)-P(I-1))*(Y*100.-float(I))+P(I)
        END IF
        FMAXHAZ_OLD=X*T
        END
C**********************************************************************
C------------  TIRAGE ALEATOIRE DANS UNE POISSONNIENNE  ---------------
        Function PoissonHaz(idum,xm)
        Integer idum,iem
        Real*4 poissonHaz,xm,pi
        Real*8 argum,gammln,xmdoub,emdoub
        Parameter (PI=3.141592654)
c       Uses Gammln,Haz
        Real*4 alxm,em,g,oldm,sq,t,y,haz
        Save alxm,g,oldm,sq
        Data oldm /-1./
        If (xm.lt.12.) Then
          If (xm.ne.oldm) Then
            oldm=xm
            g=exp(-xm)
          Endif
          em=-1.
          t=1.
  2       em=em+1.
          t=t*Haz(idum)
          If (t.gt.g) Goto 2
        Else
          If (xm.ne.oldm) Then
            oldm=xm
            sq=sqrt(2.*xm)
            alxm=log(xm)
            xmdoub = dble(xm)
            g=xm*alxm-gammln(xmdoub+1.d0)
          Endif
  1       y=tan(PI*Haz(idum))
          em=sq*y+xm
          If (em.lt.0.) goto 1
          iem=int(em)
          emdoub = dfloat(iem)
          argum = emdoub*dble(alxm)-gammln(emdoub+1.d0)-dble(g)
          if(argum.lt.-700.d0)argum = -700.d0
          if(argum.gt.700.d0)argum = 700.d0
          t=0.9*(1.+y**2)*sngl(dexp(argum))
          If (haz(idum).gt.t) Goto 1
        Endif
        poissonhaz=em
        Return
        End

C**********************************************************************
C---------------  LOGARITHM OF THE GAMM FUNCTION  ---------------------
        Function GammLn(xx)
        Real*8 gammln,xx
        Integer j
        Double Precision ser,stp,tmp,x,cof(6),y
        Save cof,stp
        Data cof,stp/76.18009172947146d0,-86.50532032941677d0,
     x   24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     x   -.5395239384953d-5,2.5066282746310005d0/
        x=xx
        y=x
        tmp=x+5.5d0
        tmp=(x+0.5d0)*dlog(tmp)-tmp
        ser=1.000000000190015d0
        Do j=1,6
          y=y+1.d0
          ser=ser+cof(j)/y
        Enddo
        gammln=tmp+dlog(stp*ser/x)
        Return
        End
