      subroutine ablantuple(IBERT,ibw)
      
      implicit real*8 (a-h,o-z)                               

      integer*4 i
      integer*4 nbin,nniv,ww,nna,nnz,izf,iaf
      real*8 ppx,ppy,ppz,esf
      parameter (nbiv=300)

      common /zablaout/ppx(nbiv),ppy(nbiv),ppz(nbiv),eekin(nbiv),
     &     ww(nbiv),nna(nbiv),nnz(nbiv),nniv,kprocout,izf,iaf,esf

      integer isecdec
      common /ablasmop/ isecdec,imultbu,kproc

      REAL*8 BU_TAB(200,11),EV_TAB(200,5)
      integer hev_tab(200),hbu_tab(200)
      COMMON /EVAPORATION/ EV_TAB,hev_tab
      COMMON/MULTIFRAG/BU_TAB,hbu_tab

      real*8 c
      parameter( c = 29.9792458D0 )
      real*8 fmp,fmn
      parameter( fmp = 938.27231 )
      parameter( fmn = 939.56563 )

      real*8 v2,gamma,etot

      real*8 abu,zbu,avvmass

**********************************************************
      IF(IBERT.EQ.ibw) THEN
      WRITE(6,*) 'IN ABLANTUPLE'
      WRITE(6,*) 'imultbu,isecdec:',imultbu,isecdec
      ENDIF

      nniv = 0
      kprocout = kproc

      do i = 1, imultbu

      IF(IBERT.EQ.ibw) THEN
      WRITE(6,*) 'bu_tab:',(bu_tab(i,jloc),jloc=5,9)
      ENDIF
      
c         if(bu_tab(i,9).le.0) cycle

         nniv = nniv + 1

         nnz(nniv) = nint(bu_tab(i,8))
         nna(nniv) = nint(bu_tab(i,9))

         v2 = bu_tab(i,5)**2+bu_tab(i,6)**2+bu_tab(i,7)**2
         gamma = dsqrt(1.000d0 - v2 / (c*c))
         avvmass = nnz(nniv)*fmp + (nna(nniv)-nnz(nniv))*fmn
     &        + eflmac(nna(nniv),nnz(nniv),0,3)
         etot = avvmass / gamma
         ppx(nniv) = etot * bu_tab(i,5) / c
         ppy(nniv) = etot * bu_tab(i,6) / c
         ppz(nniv) = etot * bu_tab(i,7) / c
         eekin(nniv) = etot - avvmass

         ww(nniv) = hbu_tab(i)

      end do

      do i = 1, isecdec

      IF(IBERT.EQ.ibw) THEN
      WRITE(6,*) 'ev_tab:',(ev_tab(i,jloc),jloc=1,5)
      ENDIF
      
c         if(ev_tab(i,2).le.0) cycle

         nniv = nniv + 1

         nnz(nniv) = nint(ev_tab(i,1))
         nna(nniv) = nint(ev_tab(i,2))

         if(nna(nniv).gt.0) then
            v2 = ev_tab(i,3)**2+ev_tab(i,4)**2+ev_tab(i,5)**2
            gamma = dsqrt(1.000d0 - v2 / (c*c))
            avvmass = nnz(nniv)*fmp + (nna(nniv)-nnz(nniv))*fmn
     &           + eflmac(nna(nniv),nnz(nniv),0,3)
            etot = avvmass / gamma
            ppx(nniv) = etot * ev_tab(i,3) / c
            ppy(nniv) = etot * ev_tab(i,4) / c
            ppz(nniv) = etot * ev_tab(i,5) / c
            eekin(nniv) = etot - avvmass
         else
            ppx(nniv) = ev_tab(i,3)
            ppy(nniv) = ev_tab(i,4)
            ppz(nniv) = ev_tab(i,5)
            eekin(nniv) = sqrt(ppx(nniv)**2+ppy(nniv)**2+ppz(nniv)**2)
         endif

         ww(nniv) = hev_tab(i)

      end do

      return
      end

      subroutine addtohist(isteps, prev)

      integer isteps,steps, prev

      integer maxhist
      parameter( maxhist=100000000 )
      integer step_ev, step_er, step_bu, step_imfl, step_imfh,
     +   step_fisl, step_fish, step_s2s, step_unst
      parameter( step_ev = 1 )
      parameter( step_er = 2 )
      parameter( step_bu = 3 )
      parameter( step_imfl = 4 )
      parameter( step_imfh = 5 )
      parameter( step_fisl = 6 )
      parameter( step_fish = 7 )
      parameter( step_s2s = 8 )
      parameter( step_unst = 9 )

      integer last,step,divisor

      steps = isteps
      divisor=10**floor(log10(real(steps)))

      do while( divisor.gt.0 )

      step = steps / divisor
      last = mod(prev,10)

      if( last.eq.step_er .and. step.eq.step_ev ) then
        prev = prev - step_er + step_ev
      else if( last.eq.step_er .and. step.eq.step_er ) then
        prev = prev
      else if( prev.lt.maxhist ) then
        prev = prev*10 + step
      else
        prev = mod(prev,maxhist)*10 + step
      end if

      steps = steps - (steps/divisor) * divisor
      divisor = divisor / 10

      end do

      end subroutine addtohist
