C
      FUNCTION SIGMANUC(AP1,ZP1,AT1,ZT1,EAP1)
C
C-----------------------------------------------------------------------
C  --------------------------------------------------------------------/
C  /                                                                   /
C  /    Calculation of the total nuclear interaction cross section     /
C  /    according to Karol (Phys. Rev. C11 (1975) 1203)                /
C  /    with modifications introduced by:                              /
C  /    Th. Brohm Nucl. Phys. A 569 (1994) 821 and F. Vives (2000).    /
C  /-------------------------------------------------------------------/
C-----------------------------------------------------------------------
      IMPLICIT NONE
      REAL*8    AP,ZP,AT,ZT,EAP,PI,AP1,ZP1,AT1,ZT1,EAP1
      COMMON /CRNUCIN/ AP,ZP,AT,ZT,EAP,PI

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // COMMON ARRAYS //++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 NARRAY
      PARAMETER(NARRAY =  50)
      REAL*8 NLOSS, PLOSS, NVARI, PVARI, NPLOSS, NPVARI, STEP
      DIMENSION NLOSS(0:NARRAY)
      DIMENSION NVARI(0:NARRAY)
      DIMENSION PLOSS(0:NARRAY)
      DIMENSION PVARI(0:NARRAY)
      DIMENSION NPLOSS(0:NARRAY)
      DIMENSION NPVARI(0:NARRAY)
      COMMON /ARRAYS/ NLOSS, PLOSS, NVARI, PVARI, NPLOSS, NPVARI, STEP
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // TOTAL NN CROSS SECTIONS //++++++++++++++++++++++++++++++++++++++++
C       TOTAL NN CROSS SECTION FROM: LOCK + MEASDAY, INTERMEDIATE ENERGY
C       NUCLEAR PHYSICS, METHUEN, LONDON 1970, P. 180 FF.
      INTEGER*4 N1TAB, N2TAB
      PARAMETER( N1TAB = 12 )
      REAL*8 E1TAB(N1TAB) /
     #  10.D0, 20.D0, 50.D0, 100.D0, 150.D0, 250.D0, 300.D0, 400.D0,
     # 500.D0, 700.D0, 800.D0,1000.D0 /
      REAL*8 S1TAB(N1TAB) /
     #  300.D0, 150.D0, 52.D0, 28.D0, 24.D0, 23.D0, 23.5D0, 25.5D0,
     # 30.5D0, 44.5D0, 47.D0, 48.D0/
      PARAMETER( N2TAB = 12 )
      REAL*8 E2TAB(N2TAB) /
     #  10.D0, 20.D0, 50.D0, 100.D0, 150.D0, 250.D0, 300.D0, 400.D0,
     # 500.D0, 700.D0, 800.D0,1000.D0 /
      REAL*8 S2TAB(N2TAB) /
     #  1000.D0, 500.D0, 167.D0, 77.D0, 50.D0, 36.D0, 35.D0, 33.D0,
     #    33.5D0, 36.D0, 38.D0, 40.D0/
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C // SPLINE VARIABLE //+++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 NN
      REAL*8    X, BF, XROT(1:20), YROT(1:20), ESO, SEVAL,
     &          PAREN, ABAR(20), BBAR(20), CBAR(20)
      DATA XROT/0.0D0, 0.05D0, 0.10D0, 0.15D0, 0.20D0, 0.25D0, 0.30D0,
     &          0.35D0, 0.40D0, 0.45D0, 0.50D0, 0.55D0, 0.60D0, 0.65D0,
     &          0.70D0, 0.75D0, 0.80D0, 0.85D0, 0.90D0, 0.95D0/
      DATA YROT/0.28D0, 0.243D0, 0.221D0, 0.208D0, 0.195D0, 0.18D0,
     &          0.1695D0, 0.1515D0, 0.133D0, 0.1155D0, 0.0949D0,
     &          0.0755D0, 0.0564D0, 0.0382D0, 0.0223D0,
     &          0.0121D0, 0.00588D0, 0.00242D0, 0.00069D0,0.0001D0/
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 Z,N,I,NM,N1,N3
      INTEGER*4 J,K,IO,INOW(2)
      REAL*8    NVARIA, NVARIB, NVARIC,SIGMANUC
      REAL*8    NDELTA,NLOSSA,NLOSSB,NLOSSC,NMEANLOSS,NMEANVAR,NPDELTA
      REAL*8    NPLOSSA,NPLOSSB,NPLOSSC,NPMEANLOSS,NPMEANVAR,NPVARIA
      REAL*8    NPVARIB,NPVARIC,PDELTA,PLOSSA,PLOSSB,PLOSSC,PMEANLOSS
      REAL*8    PMEANVAR,PVARIA,PVARIB,PVARIC,RB,RINT1DL,SIYINT
      REAL*8    VARIN,VARINP,VARIP,VAXINT,DMXINT
      REAL*8    R13, SPMIN, BBSIM, BBSIM1, BINTM, BP, CUTOFF
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // DECLARATION OF EXTERNAL FUNCTIONS //++++++++++++++++++++++++++++++
      EXTERNAL BBSIM1, RINT1DL, DMXINT, SIYINT, BBSIM, VAXINT
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**********************************************************************
      PI = 3.141592653589793D0
      R13 = 1.D0/3.D0

C   Projectile should be smaller than target
C   in order to avoid numerical problems in integration

      IF(ZP1 .LT. ZT1) THEN
       ZP = ZP1
       AP = AP1
       ZT = ZT1
       AT = AT1
      ELSE
       ZP = ZT1
       AP = AT1
       ZT = ZP1
       AT = AP1
      ENDIF
      EAP = EAP1
C
C---- DEFAULT FOR INTEGRATION PRECISION -------------------------
C
      REPS = 0.02D0
      PARTICLE = 10
C
C---- DEFAULTS FOR DROPLET DENSITIES ----------------------------
C
      LDMK = 240.D0
      LDMA = 23.D0
      LDMC = 0.7322D0
      LDMQ = 45.D0
      LDMJ = 29.5D0
      LDML = -35.D0
      LDMR = 1.15735D0
C
C---- DETERMINATION OF DIFFUSENESS ------------------------------------
C     CALCULATION ACCORDING TO MYERS, PHYS.LETT. B61(1976)125
C
C     SURFACE WIDTH OF SEMI-FINITE NUCLEAR MATTER
C
      LDMD = 1.985D0
      CALL DIFFUSE(AP,ZP,TNP,TPP)
      CALL DIFFUSE(AT,ZT,TNT,TPT)
C     FACTOR=1.0D0
C     TNT=FACTOR*TNT
C     TPT=FACTOR*TPT
C
C
C---- INTERPOLATION OF NUCLEON-NUCLEON CROSS SECTIONS ------------------
C     RESULTING VALUES IN FM**2 !
C
      IF (EAP.LE.1000.D0) THEN
        SIGPP=RINT1DL(EAP, E1TAB, S1TAB, N1TAB)/10.D0
        SIGNP=RINT1DL(EAP, E2TAB, S2TAB, N2TAB)/10.D0
      ELSE
        SIGPP = 48.D0/10.D0
        SIGNP = 40.D0/10.D0
        WRITE(6,*) 'WARNING: E/A MORE THAN 1A*GEV !'
      ENDIF
C
C---- CUTOFF FOR INTEGRATION PROCEDURES --------------------------------
C
      CUTOFF = 2.4D0
      IF ( AP .EQ. 1.D0 .OR. AT .EQ. 1.D0) THEN
        CUTOFF = 1.5D0
      ENDIF
C
C---- LIMITS FOR INTEGRATION -------------------------------------------
C
      LIMP = CUTOFF*AP**(1.D0/3.D0)
      LIMT = CUTOFF*AT**(1.D0/3.D0)
      BINTM = LIMP + LIMT
C
C---- CALCULATION OF NUCLEAR REACTION CROSS SECTION -------------------
C
      SIGMANUC = BBSIM(SIYINT, 0.D0, BINTM, REPS)

      RETURN
      END
C
C**********************************************************************
C***********************************************************************
C
      FUNCTION SIYINT(RB)
C  /-------------------------------------------------------------------/
C  / FUNCTION FOR TOTAL CROSS SECTION                                  /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RB, SIYINT, TRA, RES, PI/3.141592654D0/
      REAL*8 BBSIM1, SIXINT
      EXTERNAL BBSIM1, SIXINT
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C

c      write(*,*) 'rb = ',rb

      RBA=RB
      RES = BBSIM1(SIXINT, -LIMP, LIMP, REPS)
      IF (RES.GT.100.D0) THEN
        TRA = 0.D0
        ELSE
        TRA = DEXP(-RES)
      ENDIF
      SIYINT = 20.D0*PI*(1.D0-TRA)*RBA
      RETURN
      END
C
C***********************************************************************
C
      FUNCTION SIXINT(RY)
C  /-------------------------------------------------------------------/
C  /  FUNCTION FOR TOTAL CROSS SECTION                                 /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RY, SIXINT
      REAL*8 BBSIM2, SI
      EXTERNAL BBSIM2, SI
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
c      write(*,*) 'ry = ',ry
      RYA=RY
      SIXINT = BBSIM2( SI, -LIMP, 0.D0, REPS)*2.D0
      RETURN
      END
C
C***********************************************************************
C
      FUNCTION SI(RX)
C  /-------------------------------------------------------------------/
C  /  FUNCTIONS FOR TOTAL CROSS SECTION                                /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RX, SI, DPROB, DRHOPT, DRHONT, DRHOPP, DRHONP
      REAL*8 BBSIM3, RHOPT, RHONT, RHOPP, RHONP
      EXTERNAL BBSIM3, RHOPT, RHONT, RHOPP, RHONP
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      RXA=RX
C
C     BEI GEG. RXA, RYA, RBA, DICHTEN UEBER Z INTEGRIEREN.
C
      DRHOPT = BBSIM3(RHOPT,-LIMT,0.D0,REPS)*2.D0
      DRHOPTA = DRHOPT
      DRHONT = BBSIM3(RHONT,-LIMT,0.D0,REPS)*2.D0
      DRHONTA = DRHONT
      DRHOPP = BBSIM3(RHOPP,-LIMP,0.D0,REPS)*2.D0
      DRHOPPA = DRHOPP
      DRHONP = BBSIM3(RHONP,-LIMP,0.D0,REPS)*2.D0
      DRHONPA = DRHONP
C
C---- PROBABILITY FOR COLLISION IN THIS ROW ---------------------------
C
      DPROB = (DRHOPP*DRHOPT+0.94D0*DRHONP*DRHONT)*SIGPP
     #       +(DRHOPP*DRHONT+DRHONP*DRHOPT)*SIGNP
      SI = DPROB
C     WRITE(6,*) SI
C
      RETURN
      END
C

C
C***********************************************************************
C**** SUBROUTINES AND FUNCTIONS FOR NUCLEAR DENSITY                 ****
C***********************************************************************
C
C  NUCLEAR DENSITY DISTRIBUTIONS:
C
C  F. Vives, K.-H. Schmidt, 15.9.2000.
C  For A<=20 Gaussian dsitributions,
C  RMS experimental values, if available
C  from H. de Vries et al., Atomic Data and
C  Nuclear Data Tables, Vol. 36, No 3, May 1987.
C
C  FOR A<=10 VOLUME-NORMALIZED GAUSSIAN
C  (OR SURFACE-NORMALIZED IF RMS RADIUS KNOWN)
C  LITERATURE: KAROL, PHYS. REV. C11 (1975) 1203.
C
C  FOR A>10  DROPLET-DENSITIES ACCORDING TO
C  MYERS AND SWIATECKI, ANN. OF. PHYS. 84 (1974) 186,
C  DROPLET PARAMETERS SEE BERDICHEVSKY AND TONDEUR,
C  Z. PHYS. A322 (1985) 141, AND DIFFUSENESS ACCORDING
C  TO MYERS AND GROOTE, PHYS. LETT. 61B (1976) 125
C
C----------------------------------------------------------------------
C
      FUNCTION RHONT(ZST)
C  /-------------------------------------------------------------------/
C  /  FUNCTIONS FOR NUCLEAR DENSITY                                    /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
      REAL*8    AP,ZP,AT,ZT,EAP,PI
      COMMON /CRNUCIN/ AP,ZP,AT,ZT,EAP,PI
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE,i,j
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RG, ZST, BNT, EPST, DELTAT, RT, DT, RNT, CNT, RHO0NT
      REAL*8 R13, R23, R43, RHONT, AUT
C
C     RMS CHARGE RADII
      REAL*8 RMS(20,4) /
     # 0.84D0, 1.9D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 2.1D0, 1.67D0,
     # 2.43D0, 0.D0, 2.45D0, 2.41D0, 2.54D0, 2.72D0,
     # 0.D0, 0.D0, 0.D0, 2.95D0, 2.95D0,
     # 3.04D0, 0.D0, 3.21D0, 0.D0, 0.D0, 0.D0, 3.5D0,
     # 1.7D0, 0.D0, 2.39D0, 2.5D0, 2.42D0,
     # 2.44D0, 2.54D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 3.07D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 2.77D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 3.50D0 /
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      R13 = 1.D0/3.D0
      R23 = 2.D0/3.D0
      R43 = 4.D0/3.D0

C
C   First index: N-Z+2
C   Second index: Z
C   Some examples:
C      Z    N    A     N-Z     N-Z+2
C      1    0    1      -1       1        proton
C      1    1    2       0       2        deuteron
C      1    2    3       1       3        triton
C      RMS is an array with the value of RMS corresponding to a certain
C      Z value (column) and N value (row), as an example the rms value
C      for a Deuterium projectile is 2.1 and for a Tritium is 1.7

C      RMS CHARGE RADII FORM LANDOLT-BOERNSTEIN, VOL. 2, P.30FF

      RG = DSQRT(RXA**2+(RBA+RYA)**2+ZST**2)
C
      IF( AT .LE. 20.D0 ) THEN
        IF( RMS(IDINT(ZT),IDINT(AT-2.D0*ZT+2.D0)) .GT. 1.D-1 ) THEN
          AUT = RMS(IDINT(ZT),IDINT(AT-2.D0*ZT+2.D0)) * 8.165D-1
          RHO0NT = (AT-ZT) / ( AUT * 1.7725D0)**3
        ELSE
          CNT = 1.07D0 * AT**R13
          AUT = DSQRT(( 4.0D0 * CNT * TNT + TNT**2 ) / 6.43775D0 )
          RHO0NT = 0.5D0 * 3.D0 * (AT-ZT)
     #          / ( 4.D0 * PI * CNT**3
     #          * ( 1.D0 + ( PI**2 * TNT**2 / (19.36D0 * CNT**2) )))
     #          * DEXP( (CNT / AUT)**2)
        ENDIF
        IF( RG/AUT .GE. 5 ) RHONT = 0.D0
        IF( RG/AUT .LT. 5 ) RHONT = RHO0NT * DEXP( - (RG/AUT)**2 )
      ELSE
        BNT = 0.413D0 * TNT
        DELTAT=((AT-2.D0*ZT)/AT+(3.D0/16.D0)*(LDMC/LDMQ)*ZT*AT**(-R23))
     #           / ( 1.D0 + (9.D0/4.D0)*(LDMJ/LDMQ) * AT**(-R13) )
        EPST   = ( -2.D0*LDMA*AT**(-R13)+LDML*DELTAT**2
     #                             + LDMC*ZT**2*AT**(-R43) )/LDMK
        RT     = LDMR * AT**R13 * ( 1.D0 + EPST )
        DT = R23 * ((AT-2.D0*ZT)/AT - DELTAT ) * RT
        RNT = RT + (ZT/AT) * DT
        CNT = RNT * ( 1.D0 - (BNT/RNT)**2 )
C       WRITE(6,*) 'RG = ', RG
C       WRITE(6,*) 'CNT = ', CNT
        RHO0NT = 3.D0 * ( AT - ZT )/ ( 4.D0*PI * CNT**3 *
     #         ( 1.D0 + PI**2 * TNT**2 / (19.36D0 * CNT**2)))
        IF( (RG - CNT) .GT. 80.D0 ) THEN
          RHONT = 0.D0
        ELSE
          RHONT = RHO0NT / ( 1.D0 + DEXP((RG-CNT)/(TNT/4.4D0)) )
C         RHONT = RHO0NT / ( 1.D0 + (DEXP((RG-CNT)/(TNT/4.4D0)))**1.5 )
        ENDIF
      ENDIF
C     WRITE(6,*) 'RG = ', RG, ' RHONT = ', RHONT
      IF( RHONT .LE. 1.D-30 ) RHONT = 0.D0
      RETURN
      END
C
C***********************************************************************
C
      FUNCTION RHOPT(ZST)
C  /-------------------------------------------------------------------/
C  /  FUNCTIONS FOR NUCLEAR DENSITY                                    /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
      REAL*8    AP,ZP,AT,ZT,EAP,PI
      COMMON /CRNUCIN/ AP,ZP,AT,ZT,EAP,PI
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RG, ZST, BPT, EPST, DELTAT, RT, DT, RPT, CPT, RHO0PT
      REAL*8 R13, R23, R43, RHOPT, AUT
      real*8 dummy
C
      REAL*8 RMS(20,4) /
     # 0.84D0, 1.9D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 2.1D0, 1.67D0,
     # 2.43D0, 0.D0, 2.45D0, 2.41D0, 2.54D0, 2.72D0,
     # 0.D0, 0.D0, 0.D0, 2.95D0, 2.95D0,
     # 3.04D0, 0.D0, 3.21D0, 0.D0, 0.D0, 0.D0, 3.5D0,
     # 1.7D0, 0.D0, 2.39D0, 2.5D0, 2.42D0,
     # 2.44D0, 2.54D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 3.07D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 2.77D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 3.50D0 /
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      R13 = 1.D0/3.D0
      R23 = 2.D0/3.D0
      R43 = 4.D0/3.D0
C
      RG = DSQRT(RXA**2+(RBA+RYA)**2+ZST**2)
C
      IF( AT .LE. 20.D0 ) THEN
        IF(RMS(IDINT(ZT),IDINT(AT-2.D0*ZT+2.D0)) .GT. 1.D-1 ) THEN
          AUT = RMS(IDINT(ZT),IDINT(AT-2.D0*ZT+2.D0)) * 0.8165D0
          RHO0PT = ZT / ( AUT * 1.7725D0)**3
        ELSE
          CPT = 1.07D0 * AT**R13
          AUT = DSQRT(( 4.0D0 * CPT * TPT + TPT**2 ) / 6.43775D0 )
          RHO0PT = 0.5D0 * 3.D0 * ZT
     #          / ( 4.D0 * PI * CPT**3
     #          * ( 1.D0 + ( PI**2 * TPT**2 / (19.36D0 * CPT**2) )))
     #          * DEXP( (CPT / AUT)**2)
        ENDIF
        IF( RG/AUT .GE. 5.D0 ) RHOPT = 0.D0
        IF( RG/AUT .LT. 5.D0 ) RHOPT = RHO0PT * DEXP( - (RG/AUT)**2 )
      ELSE
        BPT = 0.413D0 * TPT
        DELTAT=((AT-2.D0*ZT)/AT+(3.D0/16.D0)*(LDMC/LDMQ)*ZT*AT**(-R23))
     #           / ( 1.D0 + (9.D0/4.D0)*(LDMJ/LDMQ) * AT**(-R13) )
        EPST   = ( -2.D0*LDMA*AT**(-R13)+LDML*DELTAT**2
     #                             + LDMC*ZT**2*AT**(-R43) )/LDMK
        RT     = LDMR * AT**R13 * ( 1.D0 + EPST )
        DT = R23 * ((AT-2.D0*ZT)/AT - DELTAT ) * RT
        RPT = RT - ((AT-ZT)/AT) * DT
        CPT = RPT * ( 1.D0 - (BPT/RPT)**2 )
C       WRITE(6,*) 'RG = ', RG
C       WRITE(6,*) 'CPT = ', CPT
        RHO0PT = 3.D0 * ZT / ( 4.D0*PI * CPT**3 *
     #         ( 1.D0 + PI**2 * TPT**2 / (19.36D0 * CPT**2)))
        IF( (RG - CPT) .GT. 80.D0 ) THEN
          RHOPT = 0.D0
        ELSE
          RHOPT = RHO0PT / ( 1.D0 + DEXP((RG-CPT)/(TPT/4.4D0)) )
C         RHOPT = RHO0PT / ( 1.D0 + (DEXP((RG-CPT)/(TPT/4.4D0)))**1.5 )
        ENDIF
      ENDIF
C     WRITE(6,*) ' RG = ',RG , ' RHOPT = ', RHOPT
C     read(5,*) dummy
      IF( RHOPT .LE. 1.D-30 ) RHOPT = 0.D0
      RETURN
      END
C
C***********************************************************************
C
      FUNCTION RHONP(ZST)
C  /-------------------------------------------------------------------/
C  /  FUNCTIONS FOR NUCLEAR DENSITY                                    /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
      REAL*8    AP,ZP,AT,ZT,EAP,PI
      COMMON /CRNUCIN/ AP,ZP,AT,ZT,EAP,PI
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RG, ZST, BNP, EPSP, DELTAP, RP, DP, RNP, CNP, RHO0NP
      REAL*8 R13, R23, R43, RHONP, AUP
C
      REAL*8 RMS(20,4) /
     # 0.84D0, 1.9D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 2.1D0, 1.67D0,
     # 2.43D0, 0.D0, 2.45D0, 2.41D0, 2.54D0, 2.72D0,
     # 0.D0, 0.D0, 0.D0, 2.95D0, 2.95D0,
     # 3.04D0, 0.D0, 3.21D0, 0.D0, 0.D0, 0.D0, 3.5D0,
     # 1.7D0, 0.D0, 2.39D0, 2.5D0, 2.42D0,
     # 2.44D0, 2.54D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 3.07D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 2.77D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 3.50D0 /
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      R13 = 1.D0/3.D0
      R23 = 2.D0/3.D0
      R43 = 4.D0/3.D0
C
      RG = DSQRT(RXA**2+RYA**2+ZST**2)
C
C
      IF( AP .LE. 20.D0  ) THEN
        IF(RMS(IDINT(ZP),IDINT(AP-2.D0*ZP+2.D0)) .GT. 1.D-1 ) THEN
          AUP = RMS(IDINT(ZP),IDINT(AP-2.D0*ZP+2.D0)) * 0.8165D0
          RHO0NP = (AP-ZP) / ( AUP * 1.7725D0)**3
        ELSE
C         TNP =
          CNP = 1.07D0 * AP**R13
          AUP = DSQRT(( 4.0D0 * CNP * TNP + TNP**2 ) / 6.43775D0 )
          RHO0NP = 0.5D0 * 3.D0 * (AP-ZP)
     #          / ( 4.D0 * PI * CNP**3
     #          * ( 1.D0 + ( PI**2 * TNP**2 / (19.36D0 * CNP**2) )))
     #          * DEXP( (CNP / AUP)**2)
        ENDIF
        IF( RG/AUP .GE. 5.D0 ) RHONP = 0.D0
        IF( RG/AUP .LT. 5.D0 ) RHONP = RHO0NP * DEXP( - (RG/AUP)**2 )
      ELSE
C       TNP =
        BNP = 0.413D0 * TNP
        DELTAP=((AP-2.D0*ZP)
     #           /AP+(3.D0/16.D0)*(LDMC/LDMQ)*ZP*AP**(-R23))
     #           / ( 1.D0 + (9.D0/4.D0)*(LDMJ/LDMQ) * AP**(-R13) )
        EPSP   = ( -2.D0*LDMA*AP**(-R13)+LDML*DELTAP**2
     #                             + LDMC*ZP**2*AP**(-R43) )/LDMK
        RP     = LDMR * AP**R13 * ( 1.D0 + EPSP )
        DP = R23 * ((AP-2.D0*ZP)/AP - DELTAP ) * RP
        RNP = RP + (ZP/AP) * DP
        CNP = RNP * ( 1.D0 - (BNP/RNP)**2 )
C       WRITE(6,*) 'RG = ', RG
C       WRITE(6,*) 'CNP = ', CNP
        RHO0NP = 3.D0 * ( AP - ZP )/ ( 4.D0*PI * CNP**3 *
     #         ( 1.D0 + PI**2 * TNP**2 / (19.36D0 * CNP**2)))
        IF( (RG - CNP) .GT. 80.D0 ) THEN
          RHONP = 0.D0
        ELSE
          RHONP = RHO0NP / ( 1.D0 + DEXP((RG-CNP)/(TNP/4.4D0)) )
C         RHONP = RHO0NP / ( 1.D0 + (DEXP((RG-CNP)/(TNP/4.4)))**1.5 )
        ENDIF
      ENDIF
C     WRITE(6,*) 'RG = ',RG, ' RHONP = ', RHONP
      IF( RHONP .LE. 1.D-30 ) RHONP = 0.D0
C     WRITE(6,*) 'I = ',ICROSS, ', RHONP = ', RHONP
      RETURN
      END
C
C----------------------------------------------------------------------
C
      FUNCTION RHOPP(ZST)
C  /-------------------------------------------------------------------/
C  /  FUNCTIONS FOR NUCLEAR DENSITY                                    /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
      REAL*8    AP,ZP,AT,ZT,EAP,PI
      COMMON /CRNUCIN/ AP,ZP,AT,ZT,EAP,PI
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 RG, ZST, BPP, EPSP, DELTAP, RP, DP, RPP, CPP, RHO0PP
      REAL*8 R13, R23, R43, RHOPP, AUP
C
C     RMS CHARGE RADII FORM LANDOLT-BOERNSTEIN, BAND 2, VOL. 2, P.30FF
      REAL*8 RMS(20,4) /
     # 0.84D0, 1.9D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 2.1D0, 1.67D0,
     # 2.43D0, 0.D0, 2.45D0, 2.41D0, 2.54D0, 2.72D0,
     # 0.D0, 0.D0, 0.D0, 2.95D0, 2.95D0,
     # 3.04D0, 0.D0, 3.21D0, 0.D0, 0.D0, 0.D0, 3.5D0,
     # 1.7D0, 0.D0, 2.39D0, 2.5D0, 2.42D0,
     # 2.44D0, 2.54D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 3.07D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 2.77D0, 0.D0, 0.D0, 0.D0, 0.D0,
     # 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 0.D0, 3.50D0 /
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      R13 = 1.D0/3.D0
      R23 = 2.D0/3.D0
      R43 = 4.D0/3.D0
C
      RG = DSQRT(RXA**2+RYA**2+ZST**2)
C
      IF( AP .LE. 20.D0 ) THEN
        IF( RMS(IDINT(ZP),IDINT(AP-2.D0*ZP+2.D0)) .GT. 1.D-1 ) THEN
          AUP = RMS(IDINT(ZP),IDINT(AP-2.D0*ZP+2.D0)) * 0.8165D0
          RHO0PP = ZP / ( AUP * 1.7725D0)**3
        ELSE
C         TPP =
          CPP = 1.07D0 * AP**R13
          AUP = DSQRT(( 4.0D0 * CPP * TPP + TPP**2 ) / 6.43775D0 )
          RHO0PP = 0.5D0 * 3.D0 * ZP
     #          / ( 4.D0 * PI * CPP**3
     #          * ( 1.D0 + ( PI**2 * TPP**2 / (19.36D0 * CPP**2) )))
     #          * DEXP( (CPP / AUP)**2)
        ENDIF
        IF( RG/AUP .GE. 5.D0 ) RHOPP = 0.D0
        IF( RG/AUP .LT. 5.D0 ) RHOPP = RHO0PP * DEXP( - (RG/AUP)**2 )
      ELSE
C       TPP =
        BPP = 0.413D0 * TPP
        DELTAP=((AP-2.D0*ZP)
     #           /AP+(3.D0/16.D0)*(LDMC/LDMQ)*ZP*AP**(-R23))
     #           / ( 1.D0 + (9.D0/4.D0)*(LDMJ/LDMQ) * AP**(-R13) )
        EPSP   = ( -2.D0*LDMA*AP**(-R13)+LDML*DELTAP**2
     #                             + LDMC*ZP**2*AP**(-R43) )/LDMK
        RP     = LDMR * AP**R13 * ( 1.D0 + EPSP )
        DP = R23 * ((AP-2.D0*ZP)/AP - DELTAP ) * RP
        RPP = RP - ((AP-ZP)/AP) * DP
        CPP = RPP * ( 1. - (BPP/RPP)**2 )
C       WRITE(6,*) 'RG = ', RG
C       WRITE(6,*) 'CPP = ', CPP
        RHO0PP = 3.D0 * ZP / ( 4.D0*PI * CPP**3 *
     #         ( 1.D0 + PI**2 * TPP**2 / (19.36D0 * CPP**2)))
        IF( (RG - CPP) .GT. 80.D0 ) THEN
          RHOPP = 0.D0
        ELSE
          RHOPP = RHO0PP / ( 1.D0 + DEXP((RG-CPP)/(TPP/4.4D0)) )
C         RHOPP = RHO0PP / ( 1.D0 + (DEXP((RG-CPP)/(TPP/4.4D0)))**1.5 )
        ENDIF
      ENDIF
C     WRITE(6,*) ' RHO0PP = ', RHO0PP
C     WRITE(6,*) 'RG = ',RG, ' RHOPP = ', RHOPP
      IF( RHOPP .LE. 1.D-30 ) RHOPP = 0.D0
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE DIFFUSE(AIN, ZIN, TN, TZ)
C
C  /-------------------------------------------------------------------/
C  /  ON INPUT: AIN, ZIN                                               /
C  /  ON OUTPUT: TN, TZ                                                /
C  /                                                                   /
C  /  CALCULATION OF DIFFUSENESS FOR DROPLET MODEL                     /
C  /  ACCORDING TO: MYERS AND GROOTE, PHYS. LETT. 61B (1976) 125       /
C  /-------------------------------------------------------------------/
      IMPLICIT NONE
C  // COMMON ABSA //++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER*4 PARTICLE
      REAL*8 REPS, SIGPP, SIGNP
      REAL*8 LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT
      REAL*8 DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA
      REAL*8 TNP,TPP,TNT,TPT
      COMMON /ABSA/ REPS, SIGPP, SIGNP,
     #       LDMK, LDMA, LDMC, LDMQ, LDMJ, LDML, LDMR, LDMD, LIMP, LIMT,
     #       DRHOPTA, DRHONTA, DRHOPPA, DRHONPA, RBA, RXA, RYA,
     #       TNP, TPP, TNT, TPT, PARTICLE
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  // OTHER VARIABLES // +++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 PHI1, PHI2
      REAL*8 DELTA, EPSILON, CHELP, AIN, ZIN
      REAL*8 R13, R53
      REAL*8 BN, BZ, TZ, TN, BNULL
      REAL*8 ETAN, ETAZ
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      R13 = 1.D0/3.D0
      R53 = 5.D0/3.D0
C
      PHI1 = 0.45D0
      PHI2 = 0.23D0
      BNULL = LDMD*0.413D0
C
      DELTA = 1.5D0 * (3.02168D0/2.5D0) * (BNULL/LDMR) * AIN**(-R13)
      EPSILON = PHI2/PHI1
      CHELP = (5.D0*LDMC)/(LDMA*PHI1)*(BNULL/LDMR)**2*ZIN**2*AIN**(-R53)
C
      ETAZ = (CHELP*(1.D0-DELTA))/((1.D0-EPSILON**2)-CHELP*
     &                                                (1.D0-2.D0*DELTA))
      ETAN = EPSILON*ETAZ
C
      BZ = BNULL * (1.D0+ETAZ)
      BN = BNULL * (1.D0+ETAN)
      TZ = BZ/0.413D0
      TN = BN/0.413D0
C
      RETURN
      END
C
C***********************************************************************
C
      FUNCTION BBSIM(FCT, A, B, ACC )
c$DEBUG
C
C     INTEGRATES NUMERICALLY POSITIVE FUNCTION
C                          0 <= A <= X <= B
C
      INTEGER*4 KS, L, IMAX, IOPT
      REAL*8    A, B, EPS, H, S1, S2, S4, SLAST, S, ACC, BBSIM, FCT, BS
C
      EPS = 0.D0
      IOPT = 0
      IF( B .LT. A ) THEN
        WRITE(6,*) '<W> IN BBSIM: INVALID LIMITS '
        IOPT = 1
        BS = A
        A = B
        B = BS
      ENDIF
C
      IMAX = 0
C
      H = 0.5D0 * (B - A)
      S1 = H/3.D0 * ( FCT(A) + FCT(B) )
      S2 = 0.D0
      S4 = 4.D0*H/3.D0 * FCT(A+H)
      S = S1 + S2 + S4
      SLAST = 0.D0
C ***  READY FOR ITERATION
      L = 4
10    CONTINUE
           H = 0.5D0 * H
C ***       INTERVALLHALBIERUNG
           S1 = S1 * 0.5D0
           S2 = S2 * 0.5D0 + S4 * 0.25D0
           S4 = 0.D0
C ***       RESET FOR KS-LOOP
           DO 11 KS=1, L-1, 2
             S4 = S4 + 4.D0*H/3.D0 * FCT(A + DFLOAT(KS)*H)
11         CONTINUE
           SLAST = S
C ***       UPDATING
           S = S1 + S2 + S4
           IF( S .LE. 1.D-50 .AND. SLAST .LE. 1.D-50 ) GOTO 999
           IF( DABS(S+SLAST) .LE. 1.D-50 ) GOTO 19
           EPS = DABS((S-SLAST) / ( S + SLAST )) * 2.D0
           IF( EPS .LE. ACC ) GOTO 999
19         CONTINUE
           IMAX = IMAX + 1
           IF( IMAX .GT. 10 ) GOTO 20
           L = L + L
           GOTO 10
20    CONTINUE
C
      IF( EPS .LE. 1.D-10 ) GOTO 999
      CALL PRTC('<W> FROM BBSIM: SPECIFIED ACCURACY NOT AVAILABLE',6)
      WRITE(6,*) 'ACC = ', ACC, ' EPS = ', EPS
C
999   CONTINUE
      IF( IOPT .EQ. 1 ) THEN
        B = A
        A = BS
      ENDIF
C
      BBSIM = S
C     WRITE(6,*) 'EPS = ', EPS
C     WRITE(6,*) 'SUM = ', S
      END
C******************************************************************************************
C******************************************************************************************
      FUNCTION BBSIM1(FCT, A, B, ACC )
c$DEBUG
C
C     INTEGRATES NUMERICALLY POSITIVE FUNCTION
C                          0 <= A <= X <= B
C
      INTEGER*4 KS, L, IMAX, IOPT
      REAL*8    A, B, EPS, H, S1, S2, S4, SLAST, S, ACC, BBSIM1, BS, FCT
C
      EPS = 0.D0
      IOPT = 0
      IF( B .LT. A ) THEN
        WRITE(6,*) '<W> IN BBSIM1: INVALID LIMITS '
        IOPT = 1
        BS = A
        A = B
        B = BS
      ENDIF
C
      IMAX = 0
C
      H = 0.5D0 * (B - A)
      S1 = H/3.D0 * ( FCT(A) + FCT(B) )
      S2 = 0.D0
      S4 = 4.D0*H/3.D0 * FCT(A+H)
      S = S1 + S2 + S4
      SLAST = 0.D0
C ***  READY FOR ITERATION
      L = 4
10    CONTINUE
           H = 0.5D0 * H
C ***       INTERVALLHALBIERUNG
           S1 = S1 * 0.5D0
           S2 = S2 * 0.5D0 + S4 * 0.25D0
           S4 = 0.D0
C ***       RESET FOR KS-LOOP
           DO 11 KS=1, L-1, 2
             S4 = S4 + 4.D0*H/3.D0 * FCT(A + DFLOAT(KS)*H)
11         CONTINUE
           SLAST = S
C ***       UPDATING
           S = S1 + S2 + S4
           IF( S .LE. 1.D-50 .AND. SLAST .LE. 1.D-50 ) GOTO 999
           IF( DABS(S+SLAST) .LE. 1.D-50 ) GOTO 19
           EPS = DABS((S-SLAST) / ( S + SLAST )) * 2.D0
           IF( EPS .LE. ACC ) GOTO 999
19         CONTINUE
           IMAX = IMAX + 1
           IF( IMAX .GT. 10 ) GOTO 20
           L = L + L
           GOTO 10
20    CONTINUE
C
      IF( EPS .LE. 1.D-10 ) GOTO 999
      CALL PRTC('<W> FROM BBSIM1: SPECIFIED ACCURACY NOT AVAILABLE',6)
      WRITE(6,*) 'ACC = ', ACC, ' EPS = ', EPS
C
999   CONTINUE
      IF( IOPT .EQ. 1 ) THEN
        B = A
        A = BS
      ENDIF
C
      BBSIM1 = S
C     WRITE(6,*) 'EPS = ', EPS
C     WRITE(6,*) 'SUM = ', S
      END
C***************************************************************************************
C***************************************************************************************
      FUNCTION BBSIM2(FCT, A, B, ACC )
c$DEBUG
C
C     INTEGRATES NUMERICALLY POSITIVE FUNCTION
C
      INTEGER*4 KS, L, IMAX, IOPT
      REAL*8    A, B, EPS, H, S1, S2, S4, SLAST, S, ACC, BBSIM2, BS, FCT
C
      EPS = 0.D0
      IOPT = 0
      IF( B .LT. A ) THEN
        WRITE(6,*) '<W> IN BBSIM2: INVALID LIMITS '
        IOPT = 1
        BS = A
        A = B
        B = BS
      ENDIF
C
      IMAX = 0
C
      H = 0.5D0 * (B - A)
      S1 = H/3.D0 * ( FCT(A) + FCT(B) )
      S2 = 0.D0
      S4 = 4.D0*H/3.D0 * FCT(A+H)
      S = S1 + S2 + S4
      SLAST = 0.D0
C ***  READY FOR ITERATION
      L = 4
10    CONTINUE
           H = 0.5D0 * H
C ***       INTERVALLHALBIERUNG
           S1 = S1 * 0.5D0
           S2 = S2 * 0.5D0 + S4 * 0.25D0
           S4 = 0.D0
C ***       RESET FOR KS-LOOP
           DO 11 KS=1, L-1, 2
             S4 = S4 + 4.D0*H/3.D0 * FCT(A + DFLOAT(KS)*H)
11         CONTINUE
           SLAST = S
C ***       UPDATING
           S = S1 + S2 + S4
           IF( S .LE. 1.D-50 .AND. SLAST .LE. 1.D-50 ) GOTO 999
           IF( DABS(S+SLAST) .LE. 1.D-50 ) GOTO 19
           EPS = DABS((S-SLAST) / ( S + SLAST )) * 2.D0
           IF( EPS .LE. ACC ) GOTO 999
19         CONTINUE
           IMAX = IMAX + 1
           IF( IMAX .GT. 10 ) GOTO 20
           L = L + L
           GOTO 10
20    CONTINUE
C
      IF( EPS .LE. 1.D-10 ) GOTO 999
      CALL PRTC('<W> FROM BBSIM2: SPECIFIED ACCURACY NOT AVAILABLE',6)
      WRITE(6,*) 'ACC = ', ACC, ' EPS = ', EPS
C
999   CONTINUE
      IF( IOPT .EQ. 1 ) THEN
        B = A
        A = BS
      ENDIF
C
      BBSIM2 = S
C     WRITE(6,*) 'EPS = ', EPS
C     WRITE(6,*) 'SUM = ', S
      END
C************************************************************************************
C************************************************************************************
      FUNCTION BBSIM3(FCT, A, B, ACC )
c$DEBUG
C
C     INTEGRATES NUMERICALLY POSITIVE FUNCTION
C                          0 <= A <= X <= B
C
      INTEGER*4 KS, L, IMAX, IOPT
      REAL*8    A, B, EPS, H, S1, S2, S4, SLAST, S, ACC, BBSIM3, BS, FCT
C
      EPS = 0.
      IOPT = 0
      IF( B .LT. A ) THEN
        WRITE(6,*) '<W> IN BBSIM3: INVALID LIMITS '
        IOPT = 1
        BS = A
        A = B
        B = BS
      ENDIF
C
      IMAX = 0
C
      H = 0.5D0 * (B - A)
      S1 = H/3.D0 * ( FCT(A) + FCT(B) )
      S2 = 0.D0
      S4 = 4.D0*H/3.D0 * FCT(A+H)
      S = S1 + S2 + S4
      SLAST = 0.D0
C ***  READY FOR ITERATION
      L = 4
10    CONTINUE
           H = 0.5D0 * H
C ***       INTERVALLHALBIERUNG
           S1 = S1 * 0.5D0
           S2 = S2 * 0.5D0 + S4 * 0.25D0
           S4 = 0.D0
C ***       RESET FOR KS-LOOP
           DO 11 KS=1, L-1, 2
             S4 = S4 + 4.D0*H/3.D0 * FCT(A + DFLOAT(KS)*H)
11         CONTINUE
           SLAST = S
C ***       UPDATING
           S = S1 + S2 + S4
           IF( S .LE. 1.D-50 .AND. SLAST .LE. 1.D-50 ) GOTO 999
           IF( DABS(S+SLAST) .LE. 1.D-50 ) GOTO 19
           EPS = DABS((S-SLAST) / ( S + SLAST )) * 2.D0
           IF( EPS .LE. ACC ) GOTO 999
19         CONTINUE
           IMAX = IMAX + 1
           IF( IMAX .GT. 10 ) GOTO 20
           L = L + L
           GOTO 10
20    CONTINUE
C
      IF( EPS .LE. 1.D-10 ) GOTO 999
      CALL PRTC('<W> FROM BBSIM3: SPECIFIED ACCURACY NOT AVAILABLE',6)
      WRITE(6,*) 'ACC = ', ACC, ' EPS = ', EPS
C
999   CONTINUE
      IF( IOPT .EQ. 1 ) THEN
        B = A
        A = BS
      ENDIF
C
      BBSIM3 = S
C     WRITE(6,*) 'EPS = ', EPS
C     WRITE(6,*) 'SUM = ', S
      END
C*****************************************************************************************
C*****************************************************************************************
      FUNCTION RINT1DL( X, XTAB, YTAB, N )
c$DEBUG
C
      INTEGER N, I, ISAVE
      REAL*8 X, XTAB(N), YTAB(N), RINT1DL, Y, XX
C
c      write(*,*) '------ function RINT1DL ------'
c      write(*,*) ' x (1)  = ',x
c      write(*,*) ' xtab:'
c      write(*,*) xtab
c      write(*,*) ' ytab:'
c      write(*,*) ytab
c      write(*,*) ' n = ',n
c      write(*,*) '------ function RINT1DL ------'

      IF( X .EQ. 0.D0 ) X = 1.D-50
      IF( X .LT. 0.D0 ) THEN
        WRITE(6,*) '<E> RINT1DL: NEGATIVE VALUES NOT ALLOWED!'
        RINT1DL = 0.D0
        GOTO 9999
      ENDIF
C

c      write(*,*) '------ test output (a) ------'

      DO 10 I = 1, N
        IF( XTAB(I) .LT. 0.D0 .OR. YTAB(I) .LT. 0.D0 ) THEN
          WRITE(6,*) '<E> RINT1DL: NEGATIVE VALUES NOT ALLOWED!'
          RINT1DL = 0.D0
          GOTO 9999
        ENDIF
        IF( XTAB(I) .EQ. 0.D0 ) XTAB(I) = 1.D-50
        IF( YTAB(I) .EQ. 0.D0 ) YTAB(I) = 1.D-50
        IF( X .EQ. XTAB(I) ) THEN
           Y = DLOG(YTAB(I))
           GOTO 9990
        ENDIF
10    CONTINUE
C
c      write(*,*) '------ test output (b) ------'

      IF( X .LT. XTAB(1) ) THEN
         ISAVE = 1
         GOTO 100
      ENDIF
C
      IF( X .GT. XTAB(N) ) THEN
         ISAVE = N - 1
         GOTO 100
      ENDIF
C
      DO 11 I = 1, N
        IF( X .LT. XTAB(I) ) THEN
           ISAVE = I - 1
           GOTO 100
        ENDIF
11    CONTINUE
C
100   CONTINUE
C
c      write(*,*) '------ test output (c) ------'
c      write(*,*) ' x (2) = ',x
c      write(*,*) ' isave = ',isave
c      write(*,*) ' xtab  = ',xtab(isave)
c      write(*,*) ' ytab  = ',ytab(isave)
c      write(*,*) ' xtabb = ',xtab(isave+1)
c      write(*,*) ' ytabb = ',ytab(isave+1)

      XX = DLOG(X) - DLOG(XTAB(ISAVE))
c      write(*,*) ' xx    = ',xx
      Y = DLOG(YTAB(ISAVE)) + XX
     #  * (DLOG(YTAB(ISAVE+1)) - DLOG(YTAB(ISAVE))) /
     #                       (DLOG(XTAB(ISAVE+1)) - DLOG(XTAB(ISAVE)))

c      write(*,*) '------ test output (d) ------'

9990  RINT1DL = DEXP(Y)
9999  RETURN
      END
C**************************************************************************************
C**************************************************************************************
      SUBROUTINE PRTC( CSTR, IINT  )
c$DEBUG
C
C     PROMPTING - SUBROUTINE FOR TEXT STRING
C
      CHARACTER*(*)  CSTR
      INTEGER*4 IINT
C
      WRITE(IINT, 10) CSTR
10    FORMAT(' ',A,' ' )
C
      RETURN
      END

C*****************************************************************************
C     RATIONALE NAEHERUNG NACH ABRAMOWITZ STEGUN 7.1.26
C     FUER DIE ERRORFUNCTION  DERF(X) = DERFAJ(X) + EPS(X)
C     GENAUIGKEIT EPS(X) < 1.5E-07
      DOUBLE PRECISION FUNCTION DERF(X)
C
      SAVE
      INTEGER VORZ
      DOUBLE PRECISION A1,A2,A3,A4,A5,P,X,T
      VORZ = 1
      P =   0.3275911D0
      A1 =  0.254829592D0
      A2 = -0.284496736D0
      A3 =  1.421413741D0
      A4 = -1.453152027D0
      A5 =  1.061405429D0
      IF (X.LT.0)  VORZ = -1
      T = DBLE((1 + VORZ*P*X)**(-1))
      DERF = VORZ*(1 - (A1*T+A2*T**2+A3*T**3+A4*T**4+A5*T**5)*
     &                   DEXP(-X**2))
      END
C


C***********************************************************************
