C
      DOUBLE PRECISION FUNCTION WIDTH(AMOTHER,ZMOTHER,APART,ZPART,TEMP,
     &                                                      B1,SB1,EXC)

C  Last update:
C             28/10/13 - JLRS - from abrablav4 (AK)

      INTEGER NSTEP,IT,I,K,ITEST,IZPART,IAPART,NMOTHER
      REAL*8 B,HBAR,PI,RGEOM,MPART,MMOTHER,ZPART,EXC,TCN,SB
      REAL*8 BKONST,APART,AMOTHER,C,C2,TEMP,G,APARTNER,MU
      REAL*8 RLAMDA,INT1,INT2,INT3,AKONST,EARG,R0,MPARTNER
      REAL*8 ZMOTHER,RP,RT,ECM,RNASA,ZPARTNER,AEXP,B1,SB1
      REAL*8 ERF,ARG,GAMMA_NUM,EPSILON
      REAL*8 NINT1,NINT2,NINT3
      REAL*8 SUM,TNM,DEL,FMAX,FMIN,FINT,SUM1,SUM2,SUM3,FINT1,FINT2,FINT3
      REAL*8 PAR_A1,PAR_B1,FACT


c     Apart = A of the particle
c     Apartner = A of the complementary nucleus

      PI = 3.141592654D0
      ITEST = 0

      IZPART = IDNINT(ZPART)
      IAPART = IDNINT(APART)

      B = B1
      SB = SB1

      ZPARTNER = ZMOTHER - ZPART
      NMOTHER = IDNINT(AMOTHER-ZMOTHER)

      PAR_A1 = 0.D0
      PAR_B1 = 0.D0

      IF(SB.GT.EXC) THEN
        WIDTH = 0.D0
        RETURN
      ELSE
C in MeV*s
      HBAR = 6.582122D-22
c      HBAR2 = HBAR * HBAR
C in m/s
      C = 2.99792458D+8
      C2 = C * C
      APARTNER = AMOTHER - APART
      MMOTHER = AMOTHER * 931.49D0 / C2
      MPARTNER = APARTNER * 931.49D0 / C2

C           g=(2s+1)
      IF(IAPART.EQ.1.AND.IZPART.EQ.0)THEN
            G = 2.D0
        MPART =  939.56D0 / C2
      ELSEIF(IAPART.EQ.1.AND.IZPART.EQ.1)THEN
            G = 2.D0
        MPART = 938.27D0 / C2
      ELSEIF(IAPART.EQ.2.AND.IZPART.EQ.1)THEN
            G = 3.D0
        MPART = 1876.10D0 / C2
      ELSEIF(IAPART.EQ.3.AND.IZPART.EQ.1)THEN
            G = 2.D0
        MPART = 2809.39D0 / C2
      ELSEIF(IAPART.EQ.3.AND.IZPART.EQ.2)THEN
            G = 2.D0
        MPART = 2809.37D0 / C2
      ELSEIF(IAPART.EQ.4.AND.IZPART.EQ.2)THEN
            G = 1.D0
        MPART = 3728.35 / C2
      ELSE
C IMF
        G = 1.D0
        MPART = APART * 931.49D0 / C2

      ENDIF

C Relative mass in MeV*s^2/m^2
      MU = MPARTNER * MPART / (MPARTNER + MPART)
C in m
      R0 = 1.16D-15

      RGEOM = R0 * (APART**(1.D0/3.D0) +
     &         (AMOTHER-APART)**(1.D0/3.D0))

C in m*sqrt(MeV)
      AKONST = HBAR*DSQRT(1.D0 / MU)

C in  1/(MeV*m^2)
      BKONST =  MPART / ( PI * PI * HBAR * HBAR)
c
C USING ANALYTICAL APPROXIMATION

      INT1 = 2.D0 * TEMP**3 / (2.D0 * TEMP + B)

c      print*,'PART_WIDTH:',TEMP,B,APART,ZPART,EXC

      ARG = DSQRT(B/TEMP)
      EARG = (ERF(ARG) - 1.D0)
      IF(DABS(EARG).LT.1.D-9) EARG = 0.D0
      IF(B.EQ.0.D0)THEN
       INT2 = 0.5D0 * DSQRT(PI) * TEMP**(3.D0/2.D0)
        ELSE
         AEXP = B/TEMP
          IF(AEXP.GT.700.D0) AEXP = 700.D0
         INT2 = (2.D0*B**2 +TEMP*B)/DSQRT(B) + DEXP(AEXP) *
     &        DSQRT(PI/(4.D0*TEMP))*(4.D0*B**2+4.D0*B*TEMP - TEMP**2) *
     &        EARG
        IF(INT2.LT.0.D0) INT2 = 0.D0
C For very low temperatures when EARG=0, INT2 get unreasonably high values
C comming from the first term. Therefore, for these cases INT2 is set to 0.
       IF(EARG.EQ.0.D0) INT2 = 0.D0
      ENDIF

      INT3 = 2.D0*TEMP**3 / (2.D0*TEMP**2 + 4.D0*B*TEMP + B**2)


      IF(IZPART.LT.-1.AND.ZMOTHER.LT.151.D0)THEN
c      IF(IZPART.LT.1)THEN
C For neutrons, the width is given by a mean value between geometrical and QM values;
C Only QM contribution (Rgeom -> Rgeom + Rlamda) seems to be too strong for neutrons
            WIDTH = PI * BKONST *  G *
     &            DSQRT((RGEOM * RGEOM * INT1 +
     &             2.D0 * AKONST * RGEOM * INT2 +
     &             AKONST * AKONST * INT3) * RGEOM * RGEOM * INT1)

      ELSE

      WIDTH = PI * BKONST *  G *
     &            (RGEOM * RGEOM * INT1 +
     &             2.D0 * AKONST * RGEOM * INT2 +
     &             AKONST * AKONST * INT3)

      ENDIF


C AK - Jan 2011 - To correct for too high values of analytical width compared to
C      numerical solution for energies close to the particle threshold:
       IF(IZPART.LT.3)THEN

       IF(AMOTHER.LT.155.D0)THEN
        PAR_A1=DEXP(2.302585D0*0.2083D0*
     &                      DEXP(-0.01548472D0*AMOTHER))-0.05D0
        PAR_B1 = 0.59939389D0 + 0.00915657D0 * AMOTHER

       ELSEIF(AMOTHER.GT.154.D0.AND.AMOTHER.LT.195.D0)THEN
        PAR_A1=1.0086961D0-
     &                      8.629D-5*AMOTHER
        PAR_B1 = 1.5329331D0 + 0.00302074D0 * AMOTHER

       ELSEIF(AMOTHER.GT.194.D0.AND.AMOTHER.LT.208.D0) THEN
        PAR_A1=9.8356347D0-
     &                     0.09294663D0*AMOTHER+2.441D-4*AMOTHER*AMOTHER
        PAR_B1 = 7.7701987D0 - 0.02897401D0 * AMOTHER

       ELSEIF(AMOTHER.GT.207.D0.AND.AMOTHER.LT.228.D0) THEN
        PAR_A1=15.107385D0-
     &                    0.12414415D0*AMOTHER+2.7222D-4*AMOTHER*AMOTHER
        PAR_B1 = -64.078009D0+0.56813179D0*AMOTHER-
     &           0.00121078D0*AMOTHER*AMOTHER

       ELSEIF(AMOTHER.GT.227.D0)THEN
        IF(MOD(NMOTHER,2).EQ.0.AND.NMOTHER.GT.147)THEN
        PAR_A1 = 2.D0*(0.9389118D0 + 6.4559D-5 * AMOTHER)
        ELSEIF(MOD(NMOTHER,2).EQ.1)THEN
        PAR_A1 = 3.D0*(0.9389118D0 + 6.4559D-5 * AMOTHER)
        ENDIF
        PAR_B1 = 2.1507177D0 + 0.00146119D0 * AMOTHER
       ENDIF

       FACT = DEXP((2.302585D0*PAR_A1*DEXP(-PAR_B1*(EXC-SB))))
       IF(FACT.LT.1.D0) FACT = 1.D0
       IF(IZPART.LT.-1.AND.ZMOTHER.LT.151.D0)THEN
c       IF(IZPART.LT.1)THEN
       WIDTH = WIDTH / DSQRT(FACT)
       ELSE
       WIDTH = WIDTH / FACT
       ENDIF
       ENDIF

       IF(WIDTH.LE.0.D0)THEN
       WRITE(*,*)'LOOK IN PARTICLE_WIDTH!'
        WRITE(*,*)'ACN,APART : ',AMOTHER,APART
         WRITE(*,*)'EXC,TEMP,B,SB : ',EXC,TEMP,B,SB
        WRITE(*,*)'INTi, i=1-3 : ',INT1,INT2,INT3
       WRITE(*,*)' '
      ENDIF

      ENDIF



      RETURN

      END
C
C**************************************************************
C
      FUNCTION erf(x)
      REAL*8 erf,x
CU    USES gammp
      REAL*8 gammp
      if(x.lt.0.D0)then
        erf=-gammp(0.5D0,x**2)
      else
        erf=gammp(0.5D0,x**2)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ,U13#(-)F.

C
C**************************************************************
C

      FUNCTION gammp(a,x)
      REAL*8 a,gammp,x
CU    USES gcf,gser
      REAL*8 gammcf,gamser,gln
      if(x.lt.0.D0.or.a.le.0.D0)print *,'bad arguments in gammp'
      if(x.lt.a+1.D0)then
        call gser(gamser,a,x,gln)
        gammp=gamser
      else
        call gcf(gammcf,a,x,gln)
        gammp=1.D0-gammcf
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ,U13#(-)F.
C
C**************************************************************
C
      SUBROUTINE gcf(gammcf,a,x,gln)
      INTEGER ITMAX
      REAL*8 a,gammcf,gln,x,EPS,FPMIN,arg
      PARAMETER (ITMAX=100,EPS=3.D-7,FPMIN=1.D-30)
CU    USES gammln
      INTEGER i
      REAL*8 an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.D0-a
      c=1.D0/FPMIN
      d=1.D0/b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.D0
        d=an*d+b
        if(dabs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(dabs(c).lt.FPMIN)c=FPMIN
        d=1.D0/d
        del=d*c
        h=h*del
        if(dabs(del-1.D0).lt.EPS)goto 1
11    continue
      print *,'a too large, ITMAX too small in gcf'
 1    gammcf=dexp(-x+a*dlog(x)-gln)*h
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ,U13#(-)F.
C
C**************************************************************
C
      SUBROUTINE gser(gamser,a,x,gln)
      INTEGER ITMAX
      REAL*8 a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.d-7)
CU    USES gammln
      INTEGER n
      REAL*8 ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.D0)then
        if(x.lt.0.D0)print *,'x < 0 in gser'
        gamser=0.D0
        return
      endif
      ap=a
      sum=1.D0/a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.D0
        del=del*x/ap
        sum=sum+del
        if(dabs(del).lt.dabs(sum)*EPS)goto 1
11    continue
      print *,'a too large, ITMAX too small in gser'
1     gamser=sum*dexp(-x+a*dlog(x)-gln)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ,U13#(-)F.
C
C**************************************************************
C**************************************************************
      DOUBLE PRECISION FUNCTION FINT(X,RGEOM,AKONST,BKONST,B,TEMP)
      REAL*8 X,RGEOM,AKONST,BKONST,B,TEMP,RLAMDA
       IF(B.EQ.0.D0)THEN
        FINT = RGEOM*RGEOM*X+2.D0*RGEOM*AKONST*DSQRT(X)+AKONST*AKONST
         ELSE
        RLAMDA = AKONST / DSQRT(X)
        FINT = (RGEOM + RLAMDA)**2 * (X - B)**2 / X * DEXP(-(X-B)/TEMP)
       ENDIF
      RETURN
      END
C*****************************************************************
      DOUBLE PRECISION FUNCTION FINT1(X,B,TEMP)
      REAL*8 X,RGEOM,AKONST,BKONST,B,TEMP,RLAMDA
       IF(B.EQ.0.D0)THEN
        FINT1 = X * DEXP(-X/TEMP)
         ELSE
        FINT1 = (X - B)**2 / X * DEXP(-(X-B)/TEMP)
       ENDIF
      RETURN
      END
C*****************************************************************
      DOUBLE PRECISION FUNCTION FINT2(X,B,TEMP)
      REAL*8 X,RGEOM,AKONST,BKONST,B,TEMP,RLAMDA
       IF(B.EQ.0.D0)THEN
        FINT2 = DSQRT(X) * DEXP(-X/TEMP)
         ELSE
        FINT2 = (X - B)**2 / X**1.5D0 * DEXP(-(X-B)/TEMP)
       ENDIF
      RETURN
      END
C*****************************************************************
      DOUBLE PRECISION FUNCTION FINT3(X,B,TEMP)
      REAL*8 X,RGEOM,AKONST,BKONST,B,TEMP,RLAMDA
       IF(B.EQ.0.D0)THEN
        FINT3 = DEXP(-X/TEMP)
         ELSE
        FINT3 = (X-B)**2 / X**2.D0 * DEXP(-(X-B)/TEMP)
       ENDIF
      RETURN
      END
C*****************************************************************
C
