program costs

      implicit none
      integer*4 :: z, a, z0, a0, deltax
      character*1000 :: path

      call get_abla07_tables_path(path)

      call abrainit(path)

      print *, "A, Z, mass interval for scanning?"
      read(5, *) a0, z0, deltax

      ! isotopes
      do a=a0-deltax,a0
            call print_barrs(a,z0)
      enddo

      ! isotones
      do z=z0-deltax,z0-1
            call print_barrs(a0-z0+z,z)
      enddo

end program costs

subroutine print_barrs(a,z)
      implicit none
      integer*4, intent(in) :: a, z
      real*8 :: fa, fz
      real*8 :: adaught, zdaught
      real*8 :: bp, omegap
      real*8 :: ba, omegaa
      real*8 :: maz, ma1z, ma2z, ma1z1, ma2z1, ma3z1, ma3z2, ma4z2
      real*8 :: sn,s2n,sp,sd,st,she,sa
      integer*4, parameter :: optshp=3
      fa = real(a,8)
      fz = real(z,8)

      call mglms(fa,fz,optshp,maz)
      adaught = a - 1.d0
      zdaught = fz
      call mglms(adaught,zdaught,optshp,ma1z)
      adaught = a - 2.d0
      zdaught = fz
      call mglms(adaught,zdaught,optshp,ma2z)
      adaught = a - 1.d0
      zdaught = fz - 1.d0
      call mglms(adaught,zdaught,optshp,ma1z1)
      adaught = a - 2.d0
      zdaught = fz - 1.d0
      call mglms(adaught,zdaught,optshp,ma2z1)
      adaught = a - 3.d0
      zdaught = fz - 1.d0
      call mglms(adaught,zdaught,optshp,ma3z1)
      adaught = a - 3.d0
      zdaught = fz - 2.d0
      call mglms(adaught,zdaught,optshp,ma3z2)
      adaught = a - 4.d0
      zdaught = fz - 2.d0
      call mglms(adaught,zdaught,optshp,ma4z2)

      sn  = ma1z -  maz
      s2n = ma1z - maz + (ma2z - ma1z)
      sp  = ma1z1 - maz
      sd  = ma2z1 - maz - 2.2246d0
      st  = ma3z1 - maz - 8.481977d0
      she = ma3z2 - maz - 7.7181660d0
      sa  = ma4z2 - maz - 28.295992d0

      adaught=real(a-1,8)
      zdaught=real(z-1,8)
      CALL BARRS(real(0.,8),zdaught,adaught,real(1.,8),real(1.,8),bp,omegap)
      adaught=real(a-4,8)
      zdaught=real(z-2,8)
      CALL BARRS(real(0.,8),zdaught,adaught,real(2.,8),real(4.,8),ba,omegaa)
      print *, z, a, sn, sp, bp, sp+bp, sa, ba, sa+ba
end subroutine print_barrs

