#ifndef G4AblaFissionBase_hh
#define G4AblaFissionBase_hh 1

#ifdef ABLAXX_IN_GEANT4_MODE
#include "globals.hh"
#else
#include "G4INCLGeant4Compat.hh"
#endif
//#include "G4InclUtils.hh"

/*
 * Abstract interface to fission models.
 */

class G4AblaFissionBase {

public:
  G4AblaFissionBase();
  virtual ~G4AblaFissionBase();

  virtual void doFission(G4double &A, G4double &Z, G4double &E,
			 G4double &A1, G4double &Z1, G4double &E1, G4double &K1,
			 G4double &A2, G4double &Z2, G4double &E2, G4double &K2) = 0;

  void setVerboseLevel(G4int level) {
    verboseLevel = level;
  }

  void about() {
    //    G4cout << ";; " << aboutModel << G4endl;
  }

  void setAboutString(G4String anAbout) {
    aboutModel = anAbout;
  }

private:
  G4int verboseLevel;
  G4String aboutModel;
};

#endif
