#include "G4INCLCluster.hh"
#include <cassert>

namespace G4INCL {

  void Cluster::initializeParticles() {
    assert(theA>=2);
    const ThreeVector oldPosition = thePosition;
    theParticleSampler->sampleParticlesIntoList(thePosition, particles);
#if !defined(NDEBUG) && !defined(INCLXX_IN_GEANT4_MODE)
    const int theMassNumber = theA;
    const int theChargeNumber = theZ;
#endif
    updateClusterParameters();
    thePosition = oldPosition;
    assert(theMassNumber==theA && theChargeNumber==theZ);
    INCL_DEBUG("Cluster initialized:" << '\n' << print());
  }

  void Cluster::rotatePosition(const double angle, const ThreeVector &axis) {
    Particle::rotatePosition(angle, axis);
    for(ParticleIter p=particles.begin(), e=particles.end(); p!=e; ++p) {
      (*p)->rotatePosition(angle, axis);
    }
  }

  void Cluster::rotateMomentum(const double angle, const ThreeVector &axis) {
    Particle::rotateMomentum(angle, axis);
    for(ParticleIter p=particles.begin(), e=particles.end(); p!=e; ++p) {
      (*p)->rotateMomentum(angle, axis);
    }
  }
}
