#include "G4INCLParticleEntryAvatar.hh"
#include "G4INCLIChannel.hh"
#include "G4INCLParticleEntryChannel.hh"
#include "G4INCLParticleEntryFSIChannel.hh"

namespace G4INCL {
  //  ParticleEntryAvatar::ParticleEntryAvatar()
  //  {
  //  }

  ParticleEntryAvatar::ParticleEntryAvatar(double time,
					   G4INCL::Nucleus *nucleus,
					   G4INCL::Particle *particle)
    :IAvatar(time), theNucleus(nucleus), theParticle(particle)
  {
    setType(ParticleEntryAvatarType);
  }

  ParticleEntryAvatar::ParticleEntryAvatar(double time, std::string flags_fsi,
					   G4INCL::Nucleus *nucleus,
					   G4INCL::Particle *particle)
    :IAvatar(time), flags_fsi(flags_fsi), theNucleus(nucleus), theParticle(particle)
  {
    setType(ParticleEntryAvatarType);
  }

  ParticleEntryAvatar::~ParticleEntryAvatar()
  {}

  std::string ParticleEntryAvatar::dump() const {
    std::stringstream ss;
    ss << "(avatar " << theTime <<" 'particle-entry" << '\n'
      << "(list " << '\n'
       << theParticle->dump()
      << "))" << '\n';
    return ss.str();
  }

  void ParticleEntryAvatar::postInteraction(FinalState * /* fs */) {
    theParticle->rpCorrelate();
  }

  IChannel* ParticleEntryAvatar::getChannel() {
    if (flags_fsi=="FSI") {
      return new ParticleEntryFSIChannel(theNucleus, theParticle);
    }
    return new ParticleEntryChannel(theNucleus, theParticle);
  }

}
