#include "G4INCLPauliStrict.hh"

namespace G4INCL {

  PauliStrict::PauliStrict() {}
  PauliStrict::~PauliStrict() {}

  bool PauliStrict::isBlocked(ParticleList const &pL, Nucleus const * const n) {
    for(ParticleIter p=pL.begin(), e=pL.end(); p!=e; ++p) {
      if(!(*p)->isNucleon()) continue;
      const double pmod2 = (*p)->getMomentum().mag2();
      const double pFermi = n->getPotential()->getFermiMomentum(*p);
      if(pmod2<pFermi*pFermi) return true;
    }
    return false;

  }
}
