#include "G4INCLPauliStrictStandard.hh"
#include "G4INCLPauliStrict.hh"
#include "G4INCLPauliStandard.hh"
#include "G4INCLStore.hh"
#include "G4INCLBook.hh"

namespace G4INCL {
  PauliStrictStandard::PauliStrictStandard() {
    theStrictBlocker = new PauliStrict();
    theStandardBlocker = new PauliStandard();
  }

  PauliStrictStandard::~PauliStrictStandard() {
    delete theStrictBlocker;
    delete theStandardBlocker;
  }

  bool PauliStrictStandard::isBlocked(ParticleList const &particleList, Nucleus const * const nucleus) {
    if(nucleus->getStore()->getBook().getAcceptedCollisions() == 0) {
      return theStrictBlocker->isBlocked(particleList, nucleus);
    } else {
      return theStandardBlocker->isBlocked(particleList, nucleus);
    }
  }
}
