#include "INCLTree.hh"
#include "G4INCLLogger.hh"
#include <string>
#include <sstream>

namespace G4INCL {
  namespace IO {

    void INCLTree::sanityChecks(G4INCL::EventInfo const &eventInfo) const {
      for(int i=0; i<eventInfo.nParticles; ++i) {
        if(eventInfo.EKin[i]<=0.) {
          INCL_WARN("Failing sanity check: EKin=" << eventInfo.EKin[i] << "<=0." << '\n');
        }
        const double p2 = eventInfo.px[i]*eventInfo.px[i] + eventInfo.py[i]*eventInfo.py[i] + eventInfo.pz[i]*eventInfo.pz[i];
        if(p2<=0.) {
          INCL_WARN("Failing sanity check: p2=" << p2 << "<=0." << '\n');
        }
      }
    }

  }
}
