/** \file G4INCLConfigVersion.cc
 * \brief The Config::getVersionID() method.
 *
 * This methods are split out from G4INCLConfig.cc in order to avoid having to
 * recompile the whole file every time the G4INCLVersion.hh header is updated.
 *
 * \date 18 March 2011
 * \author Davide Mancusi
 */

#include "G4INCLConfig.hh"
#include "G4INCLVersion.hh"
#include <string>

namespace G4INCL {

  std::string const Config::getVersionID() { return G4INCL_VERSION_ID; }

  std::string const Config::getVersionHash() { return G4INCL_GIT_HASH; }

}
