/*
 * G4INCLRanecu.cc
 *
 *  \date 7 juin 2009
 * \author Pekka Kaitaniemi
 */

#include "G4INCLRanecu.hh"

namespace G4INCL {

  Ranecu::Ranecu() {
    iseed1 = 666;
    iseed2 = 777;
  }

  Ranecu::Ranecu(const Random::SeedVector &sv) {
    setSeeds(sv);
  }

  Ranecu::~Ranecu() {}

  double Ranecu::flat()
  {
    // This is an adapted version of subroutine ranecu:
    // A. Padal, J. Sempau Computer Physics Cummunications 175 (2006) 440-450
    double uscale=1.0/2.147483563e9;

    int i1=iseed1/53668;
    iseed1=40014*(iseed1-i1*53668)-i1*12211;

    if(iseed1 < 0) iseed1 = iseed1 + 2147483563;

    int i2=iseed2/52774;
    iseed2=40692*(iseed2-i2*52774)-i2*3791;
    if(iseed2 < 0) iseed2=iseed2+2147483399;

    int iz=iseed1-iseed2;
    if(iz < 1) iz=iz+2147483562;

    return iz*uscale;
  }

}
