C****************************************************************************************
      SUBROUTINE EVAPORA(ZPRF,APRF,EE,JPRFIN,ZF,AF,NTOTN,NTOTP,NTOTD,
     &             NTOTT,NTOTHE,NTOTA,NTOT6HE,FF,FIMF,
     &             INTTYPE,INUM,TSUM,TAUC,vx_eva,vy_eva,
     &             vz_eva,TKEIMF,AIMF,ZIMF,JPRFOUT,EVOPT,
     &             EV_TEMP,IEV_TAB_TEMP)
C
C     INPUT:
C
C     ZPRF, APRF, EE(EE IS MODIFIED!), JPRF, FF(FF is modified!)
C     FF            - 1/0 fission allowed/not allowed
C
C     PROJECTILE AND TARGET PARAMETERS + CROSS SECTIONS
C     COMMON /ABRAMAIN/ AP,ZP,AT,ZT,EAP,BETA,BMAXNUC,CRTOT,CRNUC,
C                       R_0,R_P,R_T, INMAX,IRNDM,PI,
C                       BFPRO,SNPRO,SPPRO,SHELL
C
C     AP,ZP,AT,ZT   - PROJECTILE AND TARGET MASSES
C     EAP,BETA      - BEAM ENERGY PER NUCLEON, V/C
C     BMAXNUC       - MAX. IMPACT PARAMETER FOR NUCL. REAC.
C     CRTOT,CRNUC   - TOTAL AND NUCLEAR REACTION CROSS SECTION
C     R_0,R_P,R_T,  - RADIUS PARAMETER, PROJECTILE+ TARGET RADII
C     INMAX,IRNDM,PI - MAXIMUM NUMBER OF EVENTS, DUMMY, 3.141...
C     BFPRO         - FISSION BARRIER OF THE PROJECTILE
C     SNPRO         - NEUTRON SEPARATION ENERGY OF THE PROJECTILE
C     SPPRO         - PROTON    "           "   "    "   "
C     SHELL         - GROUND STATE SHELL CORRECTION
C
C---------------------------------------------------------------------
C     FISSION BARRIERS
C     COMMON /FB/     EFA
C     EFA    - ARRAY OF FISSION BARRIERS
C---------------------------------------------------------------------
C     OUTPUT:
C              ZF, AF, MTOTA, PLEVA, PTEVA, FF, INTTYPE, INUM
C
C     ZF,AF - CHARGE AND MASS OF FINAL FRAGMENT AFTER EVAPORATION
C     MTOTA _ NUMBER OF EVAPORATED ALPHAS
C     PLEEVA,PTEVA - MOMENTUM RECOIL WIDTH BY EVAPORATION
C     INTTYPE - TYPE OF REACTION 0/1 NUCLEAR OR ELECTROMAGNETIC
C     FF      - 0/1 NO FISSION / FISSION EVENT
C     INUM    - EVENTNUMBER
C   ____________________________________________________________________
C  /
C  /  CALCUL DE LA MASSE ET CHARGE FINALES D'UNE CHAINE D'EVAPORATION
C  /
C  /  PROCEDURE FOR CALCULATING THE FINAL MASS AND CHARGE VALUES OF A
C  /  SPECIFIC EVAPORATION CHAIN, STARTING POINT DEFINED BY (APRF, ZPRF,
C  /  EE)
C  /____________________________________________________________________
C
      SAVE
      COMMON /ABRAMAIN/ AP,ZP,AT,ZT,EAP,BETA,BMAXNUC,CRTOT,CRNUC,R_0,
     +                  R_P,R_T,INMAX,IRNDM,PI,BFPRO,SNPRO,SPPRO,SHELL
      REAL*8 AP,ZP,AT,ZT,EAP,BETA,BMAXNUC,CRTOT,CRNUC,R_0,R_P,R_T,PI,
     &       BFPRO,SNPRO,SPPRO,SHELL
      INTEGER*4 INMAX,IRNDM,INUM,iii,jjj,OPTIMF,i,ILOOP,IEV_TAB_TEMP
C
      INTEGER*4 SORTIE,EVOPT,OPTSHPIMF,ISTEPDECAY
      REAL*8 ZF,AF,ZPRF,APRF,EPSILN,EE,E
      REAL*8 PROBP,PROBN,PROBA,PROBIMF,PTOTL,PROBG,PROBD,PROBT,PROBHE,
     &       PROB6HE
      REAL*8 MTOTA,X,AMOINS,ZMOINS
      REAL*8 SN,SBP,SBD,SBT,SBHE,SBA,SB6HE
      REAL*8 BP,BD,BT,BHE,BA,B6HE
      REAL*8 ECN,ECP,ECA,ECG,ECD,ECT,ECHE,EC6HE,SP,SD,ST,SHE,SA,S6HE
      REAL*8 NTOTN,NTOTP,NTOTD,NTOTT,NTOTHE,NTOTA,NTOT6HE
      REAL*8 NN,NP,ND,NT,NHE,NALPHA,N6HE
      REAL*8 PLEVA,PTEVA,JPRF
      REAL*8 PXEVA,PYEVA,ptot,etot
      REAL*8 VX_EVA,VY_EVA,VZ_EVA
      REAL*8 EV_TEMP(200,5),ETOT_LP
      REAL*8 xcv,ycv,zcv,ctet1,phi1,stet1
      REAL*8 AKAP,BET,HOMEGA,KOEFF,BETA_COEFF
      REAL*8 TZEFF,MAIMF,MARES,TCN,AIMF,ZIMF,B_IMF,Z_ARG,
     &       TKEIMF,BIMF,SBIMF,LAMBDA_IMF,zprev,aprev,TS,TIMF
C
      INTEGER*4 J,K,FF,FF_ALLOWED,INTTYPE,OPTSHP,ITEST,IL,IFIS,FIMF
      INTEGER*4 OPTXFIS,OPTCOL,OPTAFAN,FIMF_ALLOWED,FGAMMA
      REAL*8 EFA,PROBF,EF,PC,MALPHA,TSUM,TAUC
      REAL*8 SBFIS,SEGS,SELMAX,RNDT,RNDP
      real*4 RNDM,HAZ,FMAXHAZ,zrndm,GAUSSHAZ
      INTEGER*4 IPOWERHAZ, IDECAYMODE
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98)
      REAL*8 ALPHA(0:153,0:98),BETA2(0:250,0:136),
     &       BETA4(0:250,0:136)
      REAL*8 AV,AS,AK
      REAL*8 c,mu
      REAL*8 JPRFN,JPRFP,JPRFD,JPRFT,JPRFHE,JPRFA,JPRF6HE,JPRFIN,JPRFOUT

      REAL*8 DLOUT,SDLOUT,DJPRF
      real*8 vxout,vyout,vzout,v2,gamma,avvmass
      INTEGER AP1,ZP1
      REAL*8 EAP1

      COMMON /PROJ/ EAP1,AP1,ZP1
      COMMON /ALD/ AV,AS,AK,OPTAFAN
      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
      COMMON /FIS/AKAP,BETA_COEFF,HOMEGA,KOEFF,IFIS,OPTSHP,
     &        OPTXFIS,OPTCOL
      COMMON/OPTIMF/OPTSHPIMF
      COMMON/SORTIE/SORTIE
C
C-----------------------------------------------------------------------
C     IRNDM             DUMMY ARGUMENT FOR RANDOM-NUMBER FUNCTION
C     SORTIE   LOCAL    HELP VARIABLE TO END THE EVAPORATION CHAIN
C     ZF                NUCLEAR CHARGE OF THE FRAGMENT
C     ZPRF              NUCLEAR CHARGE OF THE PREFRAGMENT
C     AF                MASS NUMBER OF THE FRAGMENT
C     APRF              MASS NUMBER OF THE PREFRAGMENT
C     EPSILN            ENERGY BURNED IN EACH EVAPORATION STEP
C     MALPHA   LOCAL    MASS CONTRIBUTION TO MTOTA IN EACH EVAPORATION
C     NN       LOCAL    CONTRIB. TO NTOTN  IN EACH EVAPORATION STEP
C     NP       LOCAL    CONTRIB. TO NTOTP  IN EACH EVAPORATION STEP
C     ND       LOCAL    CONTRIB. TO NTOTD  IN EACH EVAPORATION STEP
C     NT       LOCAL    CONTRIB. TO NTOTT  IN EACH EVAPORATION STEP
C     NHE      LOCAL    CONTRIB. TO NTOTHE IN EACH EVAPORATION STEP
C     NALPHA   LOCAL    CONTRIB. TO NTOTA  IN EACH EVAPORATION STEP
C     N6HE     LOCAL    CONTRIB. TO NTOTHE IN EACH EVAPORATION STEP
C     EE                EXCITATION ENERGY (VARIABLE)
C     PROBN             NEUTRON  EMISSION PROBABILITY
C     PROBP             PROTON   EMISSION PROBABILITY
C     PROBD             DEUTERON EMISSION PROBABILITY
C     PROBT             TRITON   EMISSION PROBABILITY
C     PROBHE            3HE      EMISSION PROBABILITY
C     PROBA             ALPHA    EMISSION PROBABILITY
C     PROB6HE           6HE      EMISSION PROBABILITY
C     PROBIMF           IMF      EMISSION PROBABILITY
C     PROBG             GAMMA    EMISSION PROBABILITY
C     PTOTL             TOTAL    EMISSION PROBABILITY
C     E                 LOWEST PARTICLE-THRESHOLD ENERGY
C     SN                NEUTRON   SEPARAT. ENERGY
C     SBP               PROTON    SEPARAT. ENERGY + EFFECT. COUL. BARR.
C     SBD               DEUTERON  SEPARAT. ENERGY + EFFECT. COUL. BARR.
C     SBT               TRITON    SEPARAT. ENERGY + EFFECT. COUL. BARR.
C     SBHE              3HE       SEPARAT. ENERGY + EFFECT. COUL. BARR.
C     SBA               ALPHA     SEPARAT. ENERGY + EFFECT. COUL. BARR.
C     SB6HE             6HE       SEPARAT. ENERGY + EFFECT. COUL. BARR.
C     BP                PROTON    EFFECTIVE COULOMB BARRIER
C     BD                DEUTERON  EFFECTIVE COULOMB BARRIER
C     BT                TRITON    EFFECTIVE COULOMB BARRIER
C     BHE               3HE       EFFECTIVE COULOMB BARRIER
C     BA                ALPHA     EFFECTIVE COULOMB BARRIER
C     B6HE              6HE       EFFECTIVE COULOMB BARRIER
C     NTOTN             TOTAL NUMBER OF THE EVAPORATED NEUTRONS
C     NTOTP             TOTAL NUMBER OF THE EVAPORATED PROTONS
C     NTOTD             TOTAL NUMBER OF THE EVAPORATED DEUTERONS
C     NTOTT             TOTAL NUMBER OF THE EVAPORATED TRITONS
C     NTOTHE            TOTAL NUMBER OF THE EVAPORATED 3HE PARTICLES
C     NTOTA             TOTAL NUMBER OF THE EVAPORATED ALPHA PARTICLES
C     NTOT6HE           TOTAL NUMBER OF THE EVAPORATED 6HE PARTICLES
C     X                 UNIFORM RANDOM NUMBER FOR NUCLEAR CHARGE
C     AMOINS   LOCAL    MASS NUMBER OF EVAPORATED PARTICLE
C     ZMOINS   LOCAL    NUCLEAR CHARGE OF EVAPORATED PARTICLE
C     ECN               KIN. EN. OF NEUTRON
C     ECP               KIN. EN. OF PROTON   WITHOUT COULOMB REPULSION
C     ECD               KIN. EN. OF DEUTERON WITHOUT COULOMB REPULSION
C     ECT               KIN. EN. OF TRITON   WITHOUT COULOMB REPULSION
C     EC3HE             KIN. EN. OF 3HE      WITHOUT COULOMB REPULSION
C     ECA               KIN. EN. OF ALPHA    WITHOUT COULOMB REPULSION
C     EC6HE             KIN. EN. OF 6HE      WITHOUT COULOMB REPULSION
C     PTEVA             TRANSVERSAL RECOIL MOMENTUM OF EVAPORATION
C     PLEVA             LONGITUDINAL RECOIL MOMENTUM OF EVAPORATION
C     FF                FISSION FLAG
C     INTTYPE           INTERACTION TYPE FLAG
C-----------------------------------------------------------------------
C
      ZF = DFLOAT(IDNINT(ZPRF))
      AF = DFLOAT(IDNINT(APRF))
      JPRF = DNINT(JPRFIN)
      IDECAYMODE = 0
      IEV_TAB_TEMP = 0
      ISTEPDECAY = 0
      DO I = 1,100
       DO K = 1,5
        EV_TEMP(I,K) = 0.D0
       ENDDO
      ENDDO

      c = 29.9792458d0
      mu = 931.494d0

      PLEVA = 0.D0
      PTEVA = 0.D0
      PXEVA = 0.D0
      PYEVA = 0.D0

      vx_eva = 0.d0
      vy_eva = 0.d0
      vz_eva = 0.d0

      MTOTA  = 0.d0
      NTOTN  = 0.d0
      NTOTP  = 0.d0
      NTOTD  = 0.d0
      NTOTT  = 0.d0
      NTOTHE = 0.d0
      NTOTA  = 0.d0
      NTOT6HE = 0.d0

      SORTIE = 0
      FF_ALLOWED = FF
      FIMF_ALLOWED = FIMF
      FF = 0
      FIMF = 0
      FGAMMA = 0
      TKEIMF = 0.D0
      AIMF = 0.D0
      ZIMF = 0.D0
      TSUM = 0.D0
      TAUC = 0.D0
      JPRFOUT = 0.D0

      IF(ZF.EQ.2.D0)THEN
        PRINT*,'ZF = 2 AT THE INPUT OF EVAPORA'
        RETURN
      ENDIF

      IF(ZF.GT.2.D0.AND.ZF.EQ.AF)THEN
      PRINT*,'ZF = AF AT THE INPUT OF EVAPORA',IDNINT(ZF),IDNINT(AF)
      RETURN
      ENDIF

      IF(ZF.GT.AF)THEN
        PRINT*,'ZF > AF AT THE INPUT OF EVAPORA',IDNINT(ZF),IDNINT(AF)
        RETURN
      ENDIF

 10   CONTINUE

      if (itest.eq.1) write(6,*) '------ZF,AF,EE------',
     &            IDNINT(ZF),IDNINT(AF),EE

C
C CALCULATION OF THE PROBABILITIES FOR THE DIFFERENT DECAY CHANNELS
C PLUS SEPARATION ENERGIES AND KINETIC ENERGIES OF THE PARTICLES
C
C
      IF(ZF.EQ.2.D0) THEN
       PRINT*,'WARNING ZF=2 in EVAPORA!',IDNINT(AF)
      ENDIF

      CALL DIRECT(ZF,AF,EE,JPRF,PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,
     +        PROB6HE,PROBIMF,PROBF,PROBG,PTOTL,SN,SBP,SBD,SBT,SBHE,SBA,
     +        SB6HE,ECN,ECP,ECD,ECT,ECHE,ECA,EC6HE,ECG,BP,BD,BT,BHE,BA,
     +        B6HE,SP,SD,ST,SHE,SA,S6HE,EF,INTTYPE,ISTEPDECAY,
     +        INUM,FF_ALLOWED,FIMF_ALLOWED,itest,TSUM,TAUC,TS,B_IMF,TCN,
     +      JPRFN,JPRFP,JPRFD,JPRFT,JPRFHE,JPRFA,JPRF6HE,JPRFIN,EVOPT)
C
      if (itest.eq.1) write(6,*) PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,
     +           PROB6HE,PROBIMF,PROBF,PROBG,PTOTL
C
C HERE THE FINAL STEPS OF THE EVAPORATION ARE CALCULATED
C
       IF (PTOTL.EQ.0.D0) THEN
        GOTO 100
       ENDIF
C
        E = DMIN1(SN,SBP,SBD,SBT,SBHE,SBA,SB6HE)
        IF (E.GT.1.D30) THEN
         WRITE(6,*)'ERROR AT THE EXIT OF EVAPORA,E>1.D30,AF=',AF,
     &             'ZF=',ZF
        END IF

        IF(SORTIE.EQ.1)THEN

         IF (PROBN.NE.0.D0) THEN
          AMOINS = 1.D0
          ZMOINS = 0.D0
          EPSILN = SN+ECN
          PC = DSQRT((1.D0+(ECN)/9.3956D2)**2-1.D0) * 9.3956D2
          MALPHA = 0.D0
          NN     = 1.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 1
         ELSE IF (PROBP.NE.0.D0) THEN
          AMOINS = 1.D0
          ZMOINS = 1.D0
          EPSILN = SP+ECP
          PC = DSQRT((1.D0+ECP/9.3827D2)**2-1.D0) * 9.3827D2
          MALPHA = 0.D0
          NN     = 0.D0
          NP     = 1.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 2
         ELSE IF (PROBD.NE.0.D0) THEN
          AMOINS = 2.D0
          ZMOINS = 1.D0
          EPSILN = SD+ECD
          PC = DSQRT((1.D0+ECD/1.875358D3)**2-1.D0) * 1.875358D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 1.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 3
         ELSE IF (PROBT.NE.0.D0) THEN
          AMOINS = 3.D0
          ZMOINS = 1.D0
          EPSILN = ST+ECT
          PC = DSQRT((1.D0+ECT/2.80828D3)**2-1.D0) * 2.80828D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 1.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 4
         ELSE IF (PROBHE.NE.0.D0) THEN
          AMOINS = 3.D0
          ZMOINS = 2.D0
          PC = DSQRT((1.D0+ECHE/2.80826D3)**2-1.D0) * 2.80826D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 1.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 5
         ELSE IF (PROBA.NE.0.D0) THEN
          AMOINS = 4.D0
          ZMOINS = 2.D0
          EPSILN = SA+ECA
          PC = DSQRT((1.D0+ECA/3.72834D3)**2-1.D0) * 3.72834D3
          MALPHA = 4.D0
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 1.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 6
         ELSE IF (PROB6HE.NE.0.D0) THEN
          AMOINS = 4.D0
          ZMOINS = 2.D0
          PC = DSQRT((1.D0+EC6HE/5.60660267D3)**2-1.D0) * 5.60660267D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 1.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 10
          END IF
          GO TO 99
        END IF

 30   CONTINUE
      IRNDM = IRNDM+1
C
C HERE THE NORMAL EVAPORATION CASCADE STARTS
C
C RANDOM NUMBER FOR THE EVAPORATION
C
      X = DBLE(HAZ(1))*PTOTL

      IF(X.EQ.PTOTL) X=DBLE(HAZ(1))*PTOTL
C
      IF (X.LT.PROB6HE) THEN

C Particle kinetic energy = thermal contribution (a la "Maxwell") + Coulomb
C Energy removed by particle emission = kinetic energy + binding energy
C
C
C 6He EVAPORATION
C
        if (itest.eq.3) write(6,*) '< 6he evaporation >'

        AMOINS = 6.D0
        ZMOINS = 2.D0
        EPSILN = S6HE+EC6HE
        PC = DSQRT((1.D0+EC6HE/5.60660267D3)**2-1.D0) * 5.60660267D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 0.D0
        NHE    = 0.D0
        NALPHA = 0.D0
        N6HE   = 1.D0
        MALPHA = 0.D0
        FF = 0
        FIMF = 0
        FGAMMA = 0
        JPRF = JPRF6HE
        IDECAYMODE = 10
C
      ELSEIF (X.LT.PROB6HE+PROBA) THEN

C Particle kinetic energy = thermal contribution (a la "Maxwell") + Coulomb
C Energy removed by particle emission = kinetic energy + binding energy
C
C
C ALPHA EVAPORATION
C
        if (itest.eq.3) write(6,*) '< alpha evaporation >'

        AMOINS = 4.D0
        ZMOINS = 2.D0
        EPSILN = SA+ECA
        PC = DSQRT((1.D0+ECA/3.72834D3)**2-1.D0) * 3.72834D3
        MALPHA = 4.D0
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 0.D0
        NHE    = 0.D0
        NALPHA = 1.D0
        N6HE   = 0.D0
        FF = 0
        FIMF = 0
        FGAMMA = 0
        JPRF = JPRFA
        IDECAYMODE = 6
C
C 3HELIUM EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE)) THEN

        if (itest.eq.3) write(6,*) '< 3Helium evaporation >'
        AMOINS = 3.D0
        ZMOINS = 2.D0
        EPSILN = SHE+ECHE
        PC = DSQRT((1.D0+ECHE/2.80826D3)**2-1.D0) * 2.80826D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 0.D0
        NHE    = 1.D0
        NALPHA = 0.D0
        N6HE   = 0.D0
        MALPHA = 0.D0
        FF = 0
        FIMF = 0
        FGAMMA = 0
        JPRF = JPRFHE
      IDECAYMODE = 5
C
C TRITON EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT)) THEN

        if (itest.eq.3) write(6,*) '< triton evaporation >'
        AMOINS = 3.D0
        ZMOINS = 1.D0
        EPSILN = ST+ECT
        PC = DSQRT((1.D0+ECT/2.80828D3)**2-1.D0) * 2.80828D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 1.D0
        NHE    = 0.D0
        NALPHA = 0.D0
        N6HE   = 0.D0
        MALPHA = 0.D0
        FF = 0
        FIMF = 0
        FGAMMA = 0
        JPRF = JPRFT
      IDECAYMODE = 4
C
C DEUTERON EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD)) THEN

        if (itest.eq.3) write(6,*) '< deuteron evaporation >'
        AMOINS = 2.D0
        ZMOINS = 1.D0
        EPSILN = SD+ECD
        PC = DSQRT((1.D0+ECD/1.875358D3)**2-1.D0) * 1.875358D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 1.D0
        NT     = 0.D0
        NHE    = 0.D0
        NALPHA = 0.D0
        N6HE   = 0.D0
        MALPHA = 0.D0
        FF = 0
        FIMF = 0
        FGAMMA = 0
        JPRF = JPRFD
      IDECAYMODE = 3

C
C PROTON EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP)) THEN

          if (itest.eq.3) write(6,*) '< proton evaporation >'
          AMOINS = 1.D0
          ZMOINS = 1.D0
          EPSILN = SP+ECP
          PC = DSQRT((1.D0+ECP/9.3827D2)**2-1.D0) * 9.3827D2
          MALPHA = 0.D0
          NN     = 0.D0
          NP     = 1.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          JPRF = JPRFP
      IDECAYMODE = 2

C
C NEUTRON EVAPORATION
C
        ELSEIF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP+PROBN))THEN

          if (itest.eq.3) write(6,*) '< neutron evaporation >'
          AMOINS = 1.D0
          ZMOINS = 0.D0
          EPSILN = SN+ECN
          PC = DSQRT((1.D0+(ECN)/9.3956D2)**2-1.D0) * 9.3956D2
          MALPHA = 0.D0
          NN     = 1.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
        FF = 0
        FIMF = 0
        FGAMMA = 0
        JPRF = JPRFN
      IDECAYMODE = 1

      IF(EPSILN.GT.EE) PRINT*,'NEUTRON',IDNINT(AF),IDNINT(ZF),
     &                 EE,SN,ECN

C
C GAMMA EMISSION
C
        ELSEIF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP+PROBN+
     &                 PROBG)) THEN

         if (itest.eq.3) write(6,*) '<gamma emission >'
          AMOINS = 0.D0
          ZMOINS = 0.D0
          EPSILN = ECG
          PC = ECG
          MALPHA = 0.D0
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE   = 0.D0
          FF = 0
          FIMF = 0
      IDECAYMODE = 7

C Next IF command is to shorten the calculations when gamma-emission is the only
C possible channel  (AK)

      IF(PROBN.EQ.0.D0.AND.PROBP.EQ.0.D0.AND.PROBD.EQ.0.D0.AND.
     +  PROBT.EQ.0.D0.AND.PROBHE.EQ.0.D0.AND.PROBA.EQ.0.D0.AND.
     +  PROB6HE.EQ.0.D0.AND.PROBIMF.EQ.0.D0.AND.PROBF.EQ.0.D0.AND.
     +  PROBG.NE.0.D0)  FGAMMA = 1

C    *****************
C      IMF EMISSION
C    *****************

        ELSEIF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP+PROBN+
     &            PROBG+PROBIMF)) THEN

         if (itest.eq.3) write(6,*) '<IMF emission >'


C AIMF and ZIMF obtained from complete procedure (integration over all
C possible Gamma(IMF) and then randomly picked
        ILOOP = 0
 1973  CALL IMF(AF,ZF,TCN,EE,ZIMF,AIMF,BIMF,SBIMF,TIMF,IRNDM,B_IMF,JPRF)
        ILOOP = ILOOP + 1
        IF (ILOOP.GE.100) THEN
          WRITE(6,*) 'Problem in EVAPORA: IMF called > 100 times'
          WRITE(6,*) 'AF,ZF,TCN,EE:',IDNINT(AF),IDNINT(ZF),TCN,EE
        ENDIF
        IF(ZIMF.GE.(ZF-2.D0)) GOTO 1973

        IF(ZIMF.GT.ZF/2.D0) THEN
          ZIMF = ZF - ZIMF
          AIMF = AF - AIMF
        ENDIF

C      These cases should in principle never happen
        IF(ZIMF.eq.0.D0.or.AIMF.eq.0.D0.or.SBimf.gt.EE) THEN
          write(6,*) 'warning: Look in EVAPORA "CALL IMF"'
          write(6,*) 'ZIMF=',ZIMF,'AIMF=',AIMF,'SBIMF=',SBIMF,'EE=',EE
        ENDIF

C    I sample the total kinetic energy consumed by the system of two nuclei
C    from the distribution determined with the temperature at saddle point
C TKEIMF is the kinetic energy in the centre of mass of IMF and its partner
      I = 0
 1235    TKEIMF = dble(FMAXHAZ(1,sngl(TIMF)))
         I = I+1
         IF(I.GT.100) THEN
c          write(6,*)'WARNING EVAPORA: FMAXHAZ called more than 100 times
c     &      for TKEIMF. A VALUE FOR TKEIMF WILL BE FORCED'
          TKEIMF = MIN(2.D0*TIMF,(EE-SBIMF))
         GOTO 1000
         ENDIF
         IF(TKEIMF.le.0.D0) GOTO 1235
         if(TKEIMF.gt.(ee-sbimf).and.timf.gt.0.5d0) goto 1235
 1000    TKEIMF = TKEIMF + BIMF

         AMOINS = AIMF
         ZMOINS = ZIMF
         EPSILN = (SBIMF-BIMF) + TKEIMF
         PC = 0.D0
          MALPHA = 0.D0
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE    = 0.D0
          FF = 0
          FIMF = 1
          FGAMMA = 0
      IDECAYMODE = 8

        ELSE

C
C FISSION
C
C IN CASE OF FISSION-EVENTS THE FRAGMENT NUCLEUS IS THE MOTHER NUCLEUS
C BEFORE FISSION OCCURS WITH EXCITATION ENERGY ABOVE THE FIS.- BARRIER.
C FISSION FRAGMENT MASS DISTRIBUTION IS CALULATED IN SUBROUTINE FISDIS
C
          if (itest.eq.3) write(6,*) '< fission >'
          AMOINS = 0.D0
          ZMOINS = 0.D0
          EPSILN = EF
          MALPHA = 0.D0
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE    = 0.D0
          PC = 0.D0
          FF = 1
          FIMF = 0
          FGAMMA = 0
      IDECAYMODE = 9
      END IF
C
      if (itest.EQ.1) then
      write(6,*)'SN,SBP,SBD,SBT,SBHE,SBA,SB6HE,EF',SN,SBP,SBD,SBT,SBHE,
     &           SBA,SB6HE,EF
      write(6,*)'PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,PROB6HE,PROBIMF,
     &                PROBG,PROBF,PTOTL'
     &          ,PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,PROB6HE,PROBIMF,
     &                PROBG,PROBF,PTOTL
      endif

  99   CONTINUE

      IF(EE.LT.0.01D0) EE = 0.01D0
C Davide Mancusi (DM) - 2010
      IF(IDECAYMODE.EQ.7.AND.EE.LT.(EPSILN+0.01D0))THEN
        EPSILN = EE - 0.01D0
        FGAMMA = 1
      ENDIF

      IF(EPSILN.LT.0.D0)THEN
       PRINT*,'***WARNING epsilon<0***'
       PRINT*,IDECAYMODE,IDNINT(AF),IDNINT(ZF),EE,EPSILN
      ENDIF

C CALCULATION OF THE DAUGHTER NUCLEUS
C
      AF = AF - AMOINS
      ZF = ZF - ZMOINS
      EE = EE - EPSILN

      if (itest.eq.1) write(16,*) 'af,zf,ee',af,zf,ee

      IF (EE.LE.0.01D0) EE = 0.01D0
      MTOTA = MTOTA+MALPHA
      NTOTN  = NTOTN+NN
      NTOTP  = NTOTP+NP
      NTOTD  = NTOTD+ND
      NTOTT  = NTOTT+NT
      NTOTHE = NTOTHE+NHE
      NTOTA  = NTOTA+NALPHA
      NTOT6HE = NTOT6HE+N6HE
C
C Determination of x,y,z components of momentum from known emission momentum PC
C Changed according to DM in 2010
      IF(FF.EQ.0.AND.FIMF.EQ.0) THEN
        IEV_TAB_TEMP = IEV_TAB_TEMP + 1
        IF(IEV_TAB_TEMP.GT.100) PRINT*,'**** IEV_TAB_TEMP > 100 ****'
        EV_TEMP(IEV_TAB_TEMP,1) = ZMOINS
        EV_TEMP(IEV_TAB_TEMP,2) = AMOINS
        RNDT = DBLE(HAZ(1))
        CTET1 = 2.D0*RNDT-1.D0           ! z component: uniform probability between -1 and 1
        STET1 = DSQRT(1.D0-CTET1**2)     ! component perpendicular to z
        RNDP = DBLE(HAZ(1))
        PHI1 = RNDP*2.D0*3.141592654D0   ! angle in x-y plane: uniform probability between 0 and 2*pi
        xcv =  STET1*DCOS(PHI1)          ! x component
        ycv =  STET1*DSIN(PHI1)          ! y component
        zcv =  CTET1                     ! z component
C In the CM system
        IF(IDECAYMODE.NE.7) THEN
C Light particle
           ETOT_LP = DSQRT(PC**2 + AMOINS**2 * MU**2)
           EV_TEMP(IEV_TAB_TEMP,3) = C * PC * xcv / ETOT_LP
           EV_TEMP(IEV_TAB_TEMP,4) = C * PC * ycv / ETOT_LP
           EV_TEMP(IEV_TAB_TEMP,5) = C * PC * zcv / ETOT_LP
        ELSE
C gamma ray
           EV_TEMP(IEV_TAB_TEMP,3) = PC * xcv
           EV_TEMP(IEV_TAB_TEMP,4) = PC * ycv
           EV_TEMP(IEV_TAB_TEMP,5) = PC * zcv
        ENDIF
        CALL LORENTZ_BOOST(vx_eva,vy_eva,vz_eva,
     &       EV_TEMP(iev_tab_temp,3),EV_TEMP(iev_tab_temp,4),
     &       EV_TEMP(iev_tab_temp,5),
     &       VXOUT,VYOUT,VZOUT)
        ev_temp(iev_tab_temp,3) = VXOUT
        ev_temp(iev_tab_temp,4) = VYOUT
        ev_temp(iev_tab_temp,5) = VZOUT

C Heavy residue
        IF(IDECAYMODE.NE.7)THEN
        v2 = EV_TEMP(IEV_TAB_TEMP,3)**2 +
     &       EV_TEMP(IEV_TAB_TEMP,4)**2 +
     &       EV_TEMP(IEV_TAB_TEMP,5)**2

        gamma = 1.d0/dsqrt(1.000d0 - v2 / (c*c))
        avvmass = amoins*mu
        etot_lp = avvmass * gamma

        PXEVA = PXEVA - EV_TEMP(IEV_TAB_TEMP,3) * etot_lp / c
        PYEVA = PYEVA - EV_TEMP(IEV_TAB_TEMP,4) * etot_lp / c
        PLEVA = PLEVA - EV_TEMP(IEV_TAB_TEMP,5) * etot_lp / c
        ELSE
c in case of gammas, EV_TEMP contains momentum components and not velocity
        PXEVA = PXEVA - EV_TEMP(IEV_TAB_TEMP,3)
        PYEVA = PYEVA - EV_TEMP(IEV_TAB_TEMP,4)
        PLEVA = PLEVA - EV_TEMP(IEV_TAB_TEMP,5)
        ENDIF
        PTEVA = dsqrt(pxeva*pxeva + pyeva*pyeva)
C To be checked:
        etot = dsqrt ( pleva**2 + pteva**2 + AF**2 * mu**2 )
        vx_eva = c * pxeva / etot  ! recoil velocity components of residue due to evaporation
        vy_eva = c * pyeva / etot
        vz_eva = c * pleva / etot
      END IF
c
C    CONDITION FOR END OF EVAPORATION
C
      IF ((ZF.LT.3.D0).OR.(FF.EQ.1).OR.(FIMF.EQ.1).OR.(FGAMMA.EQ.1))
     &   GO TO 100

      IF(ZF.GT.AF) THEN
        PRINT*,'EVAPORA: ZF > AF',AF,ZF,ZPRF,APRF
        GOTO 100
      ENDIF
      IF(ZF.GT.2.D0.AND.ZF.EQ.AF)THEN
        PRINT*,'ZF=AF in EVAPORA',IDNINT(ZF),IDNINT(AF)
        GOTO 100
      ENDIF

      GO TO 10
 100  CONTINUE
      JPRFOUT = JPRF

      RETURN
      END
C
C**********************************************************************
C     Orbital angular momentum
C     KHS 2007

      SUBROUTINE LORB(AMOTHER,ADAUGHTER,LMOTHER,
     &          EEFINAL,LORBITAL,SIGMA_LORBITAL)

        REAL*8 AMOTHER,ADAUGHTER,LMOTHER,EEFINAL
        REAL*8 LORBITAL,SIGMA_LORBITAL
        REAL*8 AFRAGMENT,S4FINAL,ALEVDENS
        REAL*8 THETA_MOTHER,THETA_ORBITAL

C     Values on input:
C       AMOTHER          mass of mother nucleus
C       ADAUGHTER        mass of daughter fragment
C       LMOTHER          angular momentum of mother (may be real)
C       EEFINAL          excitation energy after emission
C                          (sum of daughter and fragment)
C
C     Values on output:
C       LORBITAL         mean value of orbital angular momentum
C                           (assumed to be fully aligned with LMOTHER)
C       SIGMA_LORBITAL   standard deviation of the orbital angular momentum
      IF (EEFINAL.LE.0.01D0) EEFINAL = 0.01D0
        AFRAGMENT = AMOTHER - ADAUGHTER
        ALEVDENS = 0.073D0*AMOTHER + 0.095D0*AMOTHER**(2.D0/3.D0)
        S4FINAL = ALEVDENS * EEFINAL
         IF(S4FINAL .LE. 0.D0 .OR. S4FINAL .GT. 100000.D0) THEN
            write(*,*) 'S4FINAL',S4FINAL,ALEVDENS,EEFINAL,
     &                  IDNINT(AMOTHER),IDNINT(AFRAGMENT)
         ENDIF
        THETA_MOTHER = 0.0111D0 * AMOTHER**1.66667D0
        THETA_ORBITAL = 0.0323D0 / AMOTHER**2 *
     &      (AFRAGMENT**0.33333D0 + ADAUGHTER**0.33333D0)**2 *
     &      AFRAGMENT*ADAUGHTER*(AFRAGMENT+ADAUGHTER)

        LORBITAL = - THETA_ORBITAL *
     &     (LMOTHER / THETA_MOTHER + DSQRT(S4FINAL) /(ALEVDENS*LMOTHER))

        SIGMA_LORBITAL = DSQRT(DSQRT(S4FINAL) * THETA_ORBITAL
     &    / ALEVDENS)

        RETURN
      END

C**********************************************************************
C
      SUBROUTINE DIRECT(ZPRF,A,EE,JPRF,PROBN,PROBP,PROBD,PROBT,PROBHE,
     +      PROBA,PROB6HE,PROBIMF,PROBF,PROBG,PTOTL,SN,SBP,SBD,SBT,SBHE,
     +      SBA,SB6HE,ECN,ECP,ECD,ECT,ECHE,ECA,EC6HE,ECG,BP,BD,BT,BHE,
     +      BA,B6HE,SP,SD,ST,SHE,SA,S6HE,EF,INTTYPE,ISTEPDECAY,
     +      INUM,FF_ALLOWED,FIMF_ALLOWED,itest,TSUM,TAUC,TS1,B_IMF,TCN,
     +      JPRFN,JPRFP,JPRFD,JPRFT,JPRFHE,JPRFA,JPRF6HE,JPRFIN,EVOPT)
C=======================================================================
C
C     ________________________________________________________________
C     /                                                               /
C     /  CALCULATION OF PARTICLE-EMISSION PROBABILITIES & FISSION     /
C     /  BASED ON THE SIMPLIFIED FORMULAS FOR THE DECAY WIDTH BY      /
C     /  MORETTO, ROCHESTER MEETING TO AVOID COMPUTING TIME           /
C     /  INTENSIVE INTEGRATION OF THE LEVEL DENSITIES                 /
C     /  USES EFFECTIVE COULOMB BARRIERS AND AN AVERAGE KINETIC ENERGY/
C     /  OF THE EVAPORATED PARTICLES                                  /
C     /  COLLECTIVE ENHANCMENT OF THE LEVEL DENSITY IS INCLUDED       /
C     /  DYNAMICAL HINDRANCE OF FISSION IS INCLUDED BY A STEP FUNCTION/
C     /  APPROXIMATION. SEE A.R. JUNGHANS DIPLOMA THESIS              /
C     /  SHELL AND PAIRING STRUCTURES IN THE LEVEL DENSITY IS INCLUDED/
C     /_______________________________________________________________/
C
C     INPUT:
C            ZPRF,A,EE  CHARGE, MASS, EXCITATION ENERGY OF COMPOUND
C                       NUCLEUS
C            JPRF       ROOT-MEAN-SQUARED ANGULAR MOMENTUM
C            FF_ALLOWED 1/0 fission allowed/not allowed
C
C     DEFORMATIONS AND G.S. SHELL EFFECTS
C     COMMON /ECLD/   ECGNZ,ECFNZ,VGSLD,ALPHA
C
C     ECGNZ - GROUND STATE SHELL CORR. FRLDM FOR A SPHERICAL G.S.
C     ECFNZ - SHELL CORRECTION FOR THE SADDLE POINT (NOW: == 0)
C     VGSLD - DIFFERENCE BETWEEN DEFORMED G.S. AND LDM VALUE
C     ALPHA - ALPHA GROUND STATE DEFORMATION (THIS IS NOT BETA2!)
C             BETA2 = SQRT((4PI)/5) * ALPHA
C
C     OPTIONS AND PARAMETERS FOR FISSION CHANNEL
C     COMMON /FIS/    AKAP,BET,HOMEGA,KOEFF,IFIS,
C                            OPTSHP,OPTXFIS,OPTCOL
C---------------------------------------------------------------------
C
C     AKAP   - HBAR**2/(2* MN * R_0**2) = 10 MEV, R_0 = 1.4 FM
C     BET    - REDUCED NUCLEAR FRICTION COEFFICIENT IN (10**21 S**-1)
C     HOMEGA - CURVATURE OF THE FISSION BARRIER = 1 MEV
C     KOEFF  - COEFFICIENT FOR THE LD FISSION BARRIER == 1.0
C     IFIS   - 0/1 FISSION CHANNEL OFF/ON
C     OPTSHP - INTEGER SWITCH FOR SHELL CORRECTION IN MASSES/ENERGY
C            = 0 NO MICROSCOPIC CORRECTIONS IN MASSES AND ENERGY
C            = 1 SHELL ,  NO PAIRING
C            = 2 PAIRING, NO SHELL
C            = 3 SHELL AND PAIRING
C     OPTCOL - 0/1 COLLECTIVE ENHANCEMENT SWITCHED ON/OFF
C     OPTXFIS- 0,1,2 FOR MYERS & SWIATECKI, DAHLINGER, ANDREYEV
C              FISSILITY PARAMETER.
C     OPTCOL - 0/1 COLLECTIVE ENHANCEMENT OFF/ON
C---------------------------------------------------------------------
C     LEVEL DENSITY PARAMETERS
C     COMMON /ALD/    AV,AS,AK,OPTAFAN
C     AV,AS,AK - VOLUME,SURFACE,CURVATURE DEPENDENCE OF THE
C                LEVEL DENSITY PARAMETER
C     OPTAFAN - 0/1  AF/AN >=1 OR AF/AN ==1
C               RECOMMENDED IS OPTAFAN = 0
C---------------------------------------------------------------------
C     FISSION BARRIERS
C     COMMON /FB/     EFA
C     EFA    - ARRAY OF FISSION BARRIERS
C---------------------------------------------------------------------
C
C
C     OUTPUT:
C           - PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,PROBG,PROBF,PTOTL:
C             EMISSION PROBABILITIES FOR N, P, D, T, 3HE, ALPHA AND
C             GAMMA PARTICLES, FISSION AND NORMALISATION
C
C           - SN,SBP,SBD,SBT,SBHE,SBA:
C             SEPARATION ENERGY PLUS EFFECTIVE COULOMB BARRIER
C             FOR N, P, D, T, 3HE and ALPHA PARTICLES
C
C           - ECN,ECP,ECD,ECT,ECHE,ECA, ECG:
C             KINETIC ENERGY OF N, P, D, T, 3HE, ALPHA, GAMMA PARTICLES
C             WITHOUT COULOMB REPULSION
C
C           - BP,BD,BT,BHE,BA:
C             P, D, T, 3HE and ALPHA EFFECTIVE COULOMB BARRIER
C
C
      SAVE
      INTEGER*4  REFMOD,K,J,IFIS,OPTSHP,AFP,IZ,IN,OPTXFIS,IAIMF,
     &      INTTYPE,OPTCOL,OPTAFAN,INUM,ILAST,imaxwell,itest,IL,i,
     &      FF_ALLOWED,FIMF_ALLOWED,CHOICE_FISSPART,IADAUGHT,IZDAUGHT,
     &      INDAUGHT,EVOPT,ISTEPDECAY,SORTIE,IS
      INTEGER*4 IZIMF,INMIN,INMAX,IZCN,INCN,INMI,INMA,OPTSHPIMF
      INTEGER IREACT
      REAL*8 RDT,RTT,RHET,RAT,RPT,RNT,R6HET
      REAL*8 SBFIS,SEGS,SELMAX
      REAL*8 A,ZPRF,EE,BSHELLCN,DEFBETCN
      REAL*8 MAZ,MA1Z,MA1Z1,MA2Z1,MA3Z1,MA3Z2,MA4Z2,MA2Z,MAZZ,MA6Z2
      REAL*8 SN,SP,SD,ST,SHE,SA,S6HE,BP,BD,BT,BHE,BA,B6HE,S2N,
     &       SBP,SBD,SBT,SBHE,SBA,SB6HE,ADAUGHT,ZDAUGHT,EDAUGHT
      REAL*8 DENSN,DENSP,DENSD,DENST,DENSHE,DENSA,DENS6HE,DENSG,DENSIMF
      REAL*8 PROBP,PROBN,PROBD,PROBT,PROBHE,PROBA,PROB6HE,PROBG,PTOTL
      REAL*8 ECP,ECN,ECD,ECT,ECHE,ECA,EC6HE,ECG,ECNT
      REAL*8 EF,SBF,DENSF,GF,PROBF,EFA,KOEFF,TAUC,EER
      REAL*8 AKAP,CRAM,TAU,BET,PI,TS1,TSUM
      REAL*8 GD,GT,GHE,GP,GN,GA,G6HE,GG,GFACTOR
      REAL*8 TEMP,AT,PT,NT,DT,TT,HET,HE6T,FT,TCN,TIMF
      REAL*8 WIDTH,DENSCN,BSIMF,ECOR,QR_FACT,QR1
      REAL*8 CF,BSHELL,GSUM,GTOT,BSCN,BKCN,BSSP,BKSP
      REAL*8 XX,Y,BS,BK,BIPOL,AV,AS,AK,FISSILITY,EDYN,HBAR
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98)
      REAL*8 ALPHA(0:153,0:98), DEFBET,JPRF,SPDEF,BETA2(0:250,0:136),
     &       BETA4(0:250,0:136),BTEST(0:153,0:98)
      REAL*8 gff,gfk, BETA_COEFF,YFISS
      REAL*8 T_LAPSE
      REAL*8 MUN,MUP,MUD,MUT,MUHE,MUA,MU6HE,PENP,PEND,PENT,PENHE,PENA,
     &       PEN6HE,HOP,HOT,HOD,HOHE,HOA,HO6HE,OMEGAP,OMEGAD,OMEGAT,
     &       OMEGAHE,OMEGAA,OMEGA6HE
      REAL*8 K1,MFCD,OMEGA,HOMEGA,PONFE,DELTA_E
      REAL*4 FVMAXHAZ, FVMAXHAZ_NEUT,GAUSSHAZ, RTEST,HAZ,FMAXHAZ_NEUT
      INTEGER*4 IPOWERHAZ,IEROT,IDJPRF,IFISSLOW

      REAL*8 GIMF,GIMF3,GIMF5,LAMBDA_IMF,BIMF,AIMF,ZIMF,WIDTH_IMF,
     &       DEFBETIMF,QR,QRCN,GIMF4,GIMF6,GIMF1_AV,GIMF2_AV
      REAL*8 PROBIMF,MAIMF,MARES,IMFARG,SBIMF,A_IMF,B_IMF
      REAL*8 GA_TEST,JPRFN,JPRFP,JPRFD,JPRFT,JPRFHE,JPRFA,JPRF6HE,DJPRF,
     &       DLOUT,SDLOUT,EROT,EROTCN,IINERT,JPRFIN
      REAL*8 EROTN,EROTP,EROTD,EROTT,EROTHE,EROTA,EROT6HE,EMIN
      REAL*8 PA, GAMMA, TGAMMA, ECORCN
      REAL*8 DTEMPTR,TEMPTR,FDUMP,FUNCT1,FUNCT2

      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
      COMMON /FIS/AKAP,BETA_COEFF,HOMEGA,KOEFF,IFIS,OPTSHP,
     &        OPTXFIS,OPTCOL
      COMMON /ALD/AV,AS,AK,OPTAFAN
      COMMON/GIMF_TESTING/GIMF,GIMF3
      COMMON/IEROT/IEROT
      COMMON/BTEST/BTEST
      COMMON/OPTIMF/OPTSHPIMF
      COMMON/SORTIE/SORTIE
      COMMON/GNGF/GN,GF

      INTEGER AP1,ZP1
      REAL*8 EAP1
      COMMON /PROJ/ EAP1,AP1,ZP1

C IREACT = 0 -> full ABRABLA
C        = 1 -> own input + ABLA

      COMMON/IREACT/IREACT
      PARAMETER(PI=3.1415926535D0,HBAR=6.582122D-22)

      SORTIE = 0
      ITEST = 0
C IF IEROT = 1 -> EROT = 0, OTHERWISE, IF IEROT = 0, EROT IS CALCULATED:
      IEROT = 0
C IF IDJPRF = 0 -> CHANGE IN JPRF DUE TO PARTICLE EMISSION IS TAKEN INTO ACCOUNT;
C IF = 1 -> NO CHANGE IN JPRF:
      IDJPRF = 0
      IF(IREACT.EQ.1) IDJPRF = 1

C     Switch to calculate Maxwellian distribution of kinetic energies
      imaxwell = 1
C
C JUST A CHANGE OF NAME UNTIL THE END OF THIS SUBROUTINE
      EER = EE
      IF (INUM.EQ.1) ILAST = 1
C
        K  = IDNINT(ZPRF)
        J  = IDNINT(A - ZPRF)

      JPRF6HE = JPRF
        JPRFA = JPRF
       JPRFHE = JPRF
        JPRFT = JPRF
        JPRFD = JPRF
        JPRFP = JPRF
        JPRFN = JPRF
C
C-------CALCULATION OF MASSES
C
C     REFMOD = 1 ==> MYERS,SWIATECKI MODEL
C     REFMOD = 0 ==> WEIZSAECKER MODEL
C
      REFMOD = 1
C
      IF (REFMOD.EQ.1) THEN
        CALL MGLMS(A,ZPRF,OPTSHP,MAZ)
         ADAUGHT = A - 1.D0
         ZDAUGHT = ZPRF
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA1Z)
         ADAUGHT = A - 2.D0
         ZDAUGHT = ZPRF
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA2Z)
         ADAUGHT = A - 1.D0
         ZDAUGHT = ZPRF - 1.D0
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA1Z1)
         ADAUGHT = A - 2.D0
         ZDAUGHT = ZPRF - 1.D0
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA2Z1)
         ADAUGHT = A - 3.D0
         ZDAUGHT = ZPRF - 1.D0
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA3Z1)
         ADAUGHT = A - 3.D0
         ZDAUGHT = ZPRF - 2.D0
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA3Z2)
         ADAUGHT = A - 4.D0
         ZDAUGHT = ZPRF - 2.D0
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA4Z2)
         ADAUGHT = A - 6.D0
         ZDAUGHT = ZPRF - 2.D0
        CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHP,MA6Z2)
      ELSE
        CALL MGLW(A,ZPRF,OPTSHP,MAZ)
        CALL MGLW(A-1.0D0,ZPRF,OPTSHP,MA1Z)
        CALL MGLW(A-2.0D0,ZPRF,OPTSHP,MA2Z)
        CALL MGLW(A-1.0D0,ZPRF-1.0D0,OPTSHP,MA1Z1)
        CALL MGLW(A-2.0D0,ZPRF-1.0D0,OPTSHP,MA2Z1)
        CALL MGLW(A-3.0D0,ZPRF-1.0D0,OPTSHP,MA3Z1)
        CALL MGLW(A-3.0D0,ZPRF-2.0D0,OPTSHP,MA3Z2)
        CALL MGLW(A-4.0D0,ZPRF-2.0D0,OPTSHP,MA4Z2)
        CALL MGLW(A-4.0D0,ZPRF-2.0D0,OPTSHP,MA6Z2)
      ENDIF

      IF((A-1.D0).EQ.3.D0.AND.(ZPRF-1.D0).EQ.2.D0) MA1Z1=-7.7181660D0
      IF((A-1.D0).EQ.4.D0.AND.(ZPRF-1.D0).EQ.2.D0) MA1Z1=-28.295992D0
      IF((A-1.D0).EQ.6.D0.AND.(ZPRF-1.D0).EQ.2.D0) MA1Z1=-29.269518D0
C
C--------SEPARATION ENERGIES AND COULOMB BARRIERS
C
       SN  = MA1Z -  MAZ
       S2N = MA1Z -  MAZ + (MA2Z - MA1Z)
       SP  = MA1Z1 - MAZ
       SD  = MA2Z1 - MAZ - 2.2246D0
       ST  = MA3Z1 - MAZ - 8.481977D0
       SHE = MA3Z2 - MAZ - 7.7181660D0
       SA  = MA4Z2 - MAZ - 28.295992D0
      S6HE = MA6Z2 - MAZ - 29.269518D0


C PROTON
      IF (ZPRF.LE.1.D0.OR.A.LE.1.D0.OR.(A-ZPRF).LT.0.D0) THEN
         SBP = 1.D+75
          BP = 1.D+75
      ELSE
C*** Barrier for proton evaporation
       ADAUGHT = A - 1.D0
       ZDAUGHT = ZPRF - 1.D0
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,1.D0,1.D0,BP,OMEGAP)
      BP = DMAX1(BP,0.1D0)
      SBP = SP+BP
      ENDIF

C DEUTRONS
      IF (A.LE.2.d0.OR.ZPRF.LE.1.D0.OR.(A-ZPRF).LT.1.D0) THEN
        SBD = 1.D+75
         BD = 1.D+75
      ELSE
c*** Barrier for deuteron evaporation
       ADAUGHT = A - 2.D0
       ZDAUGHT = ZPRF - 1.D0
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,1.D0,2.D0,BD,OMEGAD)
      BD = DMAX1(BD,0.1D0)
      SBD = SD+BD
      ENDIF

C TRITONS
      IF (A.LE.3.0d0.OR.ZPRF.LE.1.D0.OR.(A-ZPRF).LT.2.D0) THEN
        SBT = 1.D+75
         BT = 1.D+75
      ELSE
c*** Barrier for triton evaporation
       ADAUGHT = A - 3.D0
       ZDAUGHT = ZPRF - 1.D0
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,1.D0,3.D0,BT,OMEGAT)
      BT = DMAX1(BT,0.1D0)
      SBT = ST+BT
      ENDIF

C 3Helium
      IF (A.LE.3.D0.OR.ZPRF.LE.2.D0.OR.(A-ZPRF).LT.1.D0) THEN
        SBHE = 1.D+75
         BHE = 1.D+75
      ELSE
c*** Barrier for 3He evaporation
       ADAUGHT = A - 3.D0
       ZDAUGHT = ZPRF - 2.D0
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,2.D0,3.D0,BHE,OMEGAHE)
      BHE = DMAX1(BHE,0.1D0)
      SBHE = SHE+BHE
      ENDIF

C ALPHA
      IF (A.LE.4.D0.OR.ZPRF.LE.2.D0.OR.(A-ZPRF).LT.2.D0) THEN
        SBA = 1.D+75
         BA = 1.D+75
      ELSE
c*** Barrier for alpha evaporation
       ADAUGHT = A - 4.D0
       ZDAUGHT = ZPRF - 2.D0
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,2.D0,4.D0,BA,OMEGAA)
      BA = DMAX1(BA,0.1D0)
      SBA = SA+BA
      ENDIF

C 6He
      IF (A.LE.6.D0.OR.ZPRF.LE.2.D0.OR.(A-ZPRF).LT.4.D0) THEN
        SB6HE = 1.D+75
         B6HE = 1.D+75
      ELSE
c*** Barrier for 6He evaporation
       ADAUGHT = A - 6.D0
       ZDAUGHT = ZPRF - 2.D0
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,2.D0,6.D0,B6He,OMEGA6HE)
      B6HE = DMAX1(B6HE,0.1D0)
      SB6HE = S6HE+B6HE
      ENDIF

      if(itest.eq.1) write(6,*)'Barriers',A,ZPRF,BP,BD,BT,BHE,BA,B6HE

C Dealing with particle-unbound systems
      EMIN = DMIN1(SN,SBP,SBD,SBT,SBHE,SBA,SB6HE)

      IF (EMIN.LT.0.D0) THEN

       SORTIE = 1
       CALL UNBOUND(A,ZPRF,EE,SN,SP,SD,ST,SHE,SA,S6HE,
     &              BP,BD,BT,BHE,BA,B6HE,
     &              PROBF,PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,PROB6HE,
     &              PROBIMF,PROBG,ECN,ECP,ECD,ECT,ECHE,ECA,EC6HE)

        GOTO 70
        ENDIF

C
C---------CALCULATION OF SURFACE AND CURVATURE INTEGRALS NEEDED TO
C         TO CALCULATE THE LEVEL DENSITY PARAMETER (IN DENSNIV)
C
      if (itest.eq.1) write(6,*) 'IFIS = ',IFIS

c      IF(IFIS.EQ.0)PRINT*,'IFIS=0',A,ZPRF,EE

      IF (IFIS.GT.0) THEN
C
C     Now EF is calculated from EFA that depends on the subroutine
C     BARFIT which takes into account the modification on the ang. mom.
C     JB MVR 6-aug-1999
C     NOTE *** shell correction! (ECGNZ)  JB MVR 20-7-1999
C
       IF(J.LE.0 .OR. K.LE.0)THEN
        EF=1.D40
        SBFIS = 1.D40
        BSSP = 1.D0
        BKSP = 1.D0
       ELSE
        IL  = IDNINT(JPRF)
        CALL BARFIT(K,K+J,IL,SBFIS,SEGS,SELMAX)
          IF ((OPTSHP.EQ.1).OR.(OPTSHP.EQ.3)) THEN
            EF = SBFIS -  ECGNZ(J,K)
C AK - Jan 2011 - Corrected values of fission barriers
        IF(K.EQ.90) THEN
         IF(MOD(J,2).EQ.1)THEN
         EF = EF*(4.5114D0-2.2687D0*(A-ZPRF)/ZPRF)
         ELSE
         EF = EF*(3.3931D0-1.5338D0*(A-ZPRF)/ZPRF)
         ENDIF
        ENDIF
        IF(K.EQ.92)THEN
         IF((A-ZPRF)/ZPRF.GT.1.52D0)EF=EF*(1.1222D0-
     &                                 0.10886D0*(A-ZPRF)/ZPRF)
        ENDIF
        IF(K.GE.94.AND.K.LE.98.AND.J.LT.158)THEN   ! Data in this range have been tested
C e-e
        IF(MOD(J,2).eq.0.and.MOD(K,2).eq.0)THEN
        IF(K.GE.94) EF = EF-(11.54108D0*(A-ZPRF)/ZPRF-18.074D0)
        ENDIF
C O-O
        IF(MOD(J,2).eq.1.and.MOD(K,2).eq.1)THEN
        IF(K.GE.95) EF = EF-(14.567D0*(A-ZPRF)/ZPRF-23.266D0)
        ENDIF
C Odd A
        IF(MOD(J,2).eq.0.and.MOD(K,2).eq.1)THEN
        IF(J.GE.144)EF = EF-(13.662D0*(A-ZPRF)/ZPRF-
     &                                   21.656D0)
        ENDIF

        IF(MOD(J,2).eq.1.and.MOD(K,2).eq.0)THEN
        IF(J.GE.144)EF = EF-(13.662D0*(A-ZPRF)/ZPRF-
     &                                   21.656D0)
        ENDIF

         ENDIF

          ELSE
           EF = sbfis
          END IF
        ENDIF
C
C TO AVOID NEGATIVE VALUES FOR IMPOSSIBLE NUCLEI
C THE FISSION BARRIER IS SET TO ZERO IF SMALLER THAN ZERO.
C
        IF (EF.LT.0.D0) EF = 0.D0

        XX = FISSILITY((K+J),K,OPTXFIS,JPRF,0.D0)
        Y=1.0D0-XX
        IF (Y.LT.0.D0) Y = 0.D0
        IF (Y.GT.1.D0) Y = 1.D0
        BSSP = BIPOL(1,Y)
        BKSP = BIPOL(2,Y)
      ELSE
        EF=1.D40
        SBFIS = 1.D40
        BSSP = 1.D0
        BKSP = 1.D0
      END IF

      SBF = EE-EF
      AFP = IDNINT(A)
      IZ = IDNINT(ZPRF)
      IN = AFP - IZ

C
C COMPOUND NUCLEUS LEVEL DENSITY
C
C  AK 2007 - Now DENSNIV called with correct BS, BK

      BSHELLCN = ECGNZ(IN,IZ) - VGSLD(IN,IZ)
      DEFBETCN = BETA2(IN,IZ)

      IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * A**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBETCN)
      EROT = JPRF * JPRF * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
      IF(IEROT.EQ.1) EROT = 0.D0

      CALL BSBK(A,ZPRF,BSCN,BKCN)
      EROTCN = EROT

c      IF(EE .GT. EROT) THEN
       CALL DENSNIV(A,ZPRF,EE,0.D0,DENSG,BSHELLCN,
     &      BSCN,BKCN,TEMP,OPTSHP,OPTCOL,DEFBETCN,ECOR,JPRF,0,QRCN)
       TCN = TEMP
       ECORCN = ECOR
c      ELSE
C If EE < EROT, only gamma emission can take place
c            probf   = 0.D0
c            probn   = 0.D0
c            probp   = 0.D0
c            probd   = 0.D0
c            probt   = 0.D0
c            probhe  = 0.D0
c            proba   = 0.D0
c            probimf = 0.D0
c            probg   = 1.D0
c            go to 70
c      ENDIF
C  ---------------------------------------------------------------
C        LEVEL DENSITIES AND TEMPERATURES OF THE FINAL STATES
C  ---------------------------------------------------------------
C
C  MVR - in case of charged particle emission temperature
C  comes from random kinetic energy from a Maxwelliam distribution
C  if option imaxwell = 1 (otherwise E=2T)
C
C  AK - LEVEL DENSITY AND TEMPERATURE AT THE SADDLE POINT -> now calculated in the subroutine
C FISSION_WIDTH
C
C
C LEVEL DENSITY AND TEMPERATURE IN THE NEUTRON DAUGHTER
C
C KHS, AK 2007 - Reduction of angular momentum due to orbital angular momentum of emitted fragment
C
      IF (IN.GE.2 ) THEN
       JPRFN = JPRF
       ADAUGHT = A - 1.D0
       ZDAUGHT = ZPRF
       EDAUGHT = EE - SN
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0.AND.IDJPRF.EQ.0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRFN = JPRF + DJPRF
         JPRFN = DNINT(DABS(JPRFN))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROTN = JPRFN * JPRFN * 197.328d0 * 197.328d0 /(2.D0 * IINERT)

       IF(IEROT.EQ.1) EROTN = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL DENSNIV(ADAUGHT,ZDAUGHT,EE,SN,DENSN,BSHELL,
     &       BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRFN,0,QR)
        NT = TEMP
        ECN = 0.D0
        IF(DENSN.GT.0.D0)THEN
         IS = 0
         if (imaxwell.eq.1) then
          RNT = NT
 1234      ECN = dble(FVMAXHAZ_NEUT(1,sngl(RNT)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ_NEUT CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING ECN. A VALUE WILL BE FORCED'
            ECN = MIN(2.D0*NT,EE-SN)
            GOTO 1000
           ENDIF
           if (ecn.gt.(ee-sn)) then
            if ((ee-sn).lt.rnt) then
              ecn = ee-sn
            else
              goto 1234
            endif
           endif
          if(ecn.le.0.d0) goto 1234
         else
          ECN = 2.D0 * NT
         endif
        ENDIF
      ELSE
        DENSN = 0.D0
        ECN = 0.D0
        NT = 0.D0
      END IF
 1000 CONTINUE

c      print*,idnint(adaught),idnint(zdaught),bshell
C
C LEVEL DENSITY AND TEMPERATURE IN THE PROTON DAUGHTER
C
C Reduction of angular momentum due to orbital angular momentum of emitted fragment
C

      IF (IZ.GE.2 ) THEN
       JPRFP = JPRF
       ADAUGHT = A - 1.D0
       ZDAUGHT = ZPRF - 1.D0
       EDAUGHT = EE - SBP
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRFP = JPRF + DJPRF
         JPRFP = DNINT(DABS(JPRFP))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROTP = JPRFP * JPRFP * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROTP = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL DENSNIV(ADAUGHT,ZDAUGHT,EE,SBP,DENSP,
     &       BSHELL,BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRFP,0,QR)
        PT = TEMP
        ECP = 0.D0
        IF(DENSP.GT.0.D0)THEN
         IS = 0
         if (imaxwell.eq.1) then
          RPT = PT
 1235      ECP = dble(FVMAXHAZ(1,sngl(RPT)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING ECP. A VALUE WILL BE FORCED'
            ECP = MIN(2.D0*PT+BP,EE-SBP)
            GOTO 1001
           ENDIF
           if (ecp.gt.(ee-sbp)) then
            if ((ee-sbp).lt.rpt) then
              ecp = ee-sbp
            else
              goto 1235
            endif
           endif
          if(ecp.le.0.d0) goto 1235
          ECP = ECP + BP
         else
         ECP = 2.D0 * PT + BP
        endif
       ENDIF
      ELSE
        DENSP = 0.D0
        ECP = 0.D0
        PT = 0.D0
      END IF
 1001 CONTINUE
C
C  FINAL LEVEL DENSITY AND TEMPERATURE AFTER DEUTERON EMISSION
C
C Reduction of angular momentum due to orbital angular momentum of emitted fragment
C
      IF ((IZ.GE.2).AND.(IN.GE.2)) THEN
       JPRFD = JPRF
       ADAUGHT = A - 2.D0
       ZDAUGHT = ZPRF - 1.D0
       EDAUGHT = EE - SBD
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRFD = JPRF + DJPRF
         JPRFD = DNINT(DABS(JPRFD))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROTD = JPRFD * JPRFD * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROTD = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL DENSNIV(ADAUGHT,ZDAUGHT,EE,SBD,DENSD,
     &       BSHELL,BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRFD,0,QR)
C
        DT = TEMP
        ECD = 0.D0
        IF(DENSD.GT.0.D0)THEN
        IS = 0
         if (imaxwell.eq.1) then
          RDT = DT
 1236      ECD = dble(FVMAXHAZ(1,sngl(RDT)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING ECD. A VALUE WILL BE FORCED'
            ECD = MIN(2.D0*DT+BD,EE-SBD)
            GOTO 1002
           ENDIF
            if(ecd.gt.(ee-sbd)) then
             if ((ee-sbd).lt.rdt) then
              ecd = ee-sbd
             else
              goto 1236
            endif
          endif
           if(ecd.le.0.D0) goto 1236
          ECD = ECD + BD
         else
          ECD = 2.D0 * DT + BD ! KHS August 2006
        endif
       ENDIF
      ELSE
        DENSD = 0.D0
        ECD = 0.D0
        DT = 0.D0
      END IF
 1002 CONTINUE
C
C  FINAL LEVEL DENSITY AND TEMPERATURE AFTER TRITON EMISSION
C
C Reduction of angular momentum due to orbital angular momentum of emitted fragment
C
      IF ((IZ.GE.2).AND.(IN.GE.3)) THEN
       JPRFT = JPRF
       ADAUGHT = A - 3.D0
       ZDAUGHT = ZPRF - 1.D0
       EDAUGHT = EE - SBT
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRFT = JPRF + DJPRF
         JPRFT = DNINT(DABS(JPRFT))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROTT = JPRFT * JPRFT * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROTT = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL DENSNIV(ADAUGHT,ZDAUGHT,EE,SBT,DENST,
     &       BSHELL,BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRFT,0,QR)
C
        TT = TEMP
        ECT = 0.D0

        IF(DENST.GT.0.D0)THEN
         IS = 0
         if (imaxwell.eq.1) then
          RTT = TT
 1237      ECT = dble(FVMAXHAZ(1,sngl(RTT)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING ECT. A VALUE WILL BE FORCED'
            ECT = MIN(2.D0*TT+BT,EE-SBT)
            GOTO 1003
             ENDIF
             if(ect.gt.(ee-sbt)) then
              if ((ee-sbt).lt.rtt) then
               ect = ee-sbt
              else
               goto 1237
              endif
             endif
            if(ect.le.0.d0) goto 1237
            ECT = ECT + BT
          else
          ECT = 2.D0 * TT + BT ! KHS August 2006
         endif
        ENDIF
      ELSE
        DENST = 0.D0
        ECT = 0.D0
        TT = 0.D0
      END IF
 1003 CONTINUE
C
C  FINAL LEVEL DENSITY AND TEMPERATURE AFTER 3HE EMISSION
C
C Reduction of angular momentum due to orbital angular momentum of emitted fragment
C
      IF ((IN.GE.2).AND.(IZ.GE.3)) THEN
       JPRFHE = JPRF
       ADAUGHT = A - 3.D0
       ZDAUGHT = ZPRF - 2.D0
       EDAUGHT = EE - SBHE
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRFHE = JPRF + DJPRF
         JPRFHE = DNINT(DABS(JPRFHE))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROTHE = JPRFHE * JPRFHE * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROTHE = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL  DENSNIV(ADAUGHT,ZDAUGHT,EE,SBHE,DENSHE,
     &        BSHELL,BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRFHE,0,QR)
        HET = TEMP
        ECHE = 0.D0
        IF(DENSHE.GT.0.D0)THEN
         IS = 0
         if (imaxwell.eq.1) then
          RHET = HET
 1238      ECHE = dble(FVMAXHAZ(1,sngl(RHET)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING ECHE. A VALUE WILL BE FORCED'
            ECHE = MIN(2.D0*HET+BHE,EE-SBHE)
            GOTO 1004
           ENDIF
             if(eche.gt.(ee-sbhe)) then
              if ((ee-sbhe).lt.rhet) then
               eche = ee-sbhe
                else
               goto 1238
              endif
             endif
            if(eche.le.0.d0) goto 1238
            ECHE = ECHE + BHE
           else
          ECHE = 2.D0 * HET  ! KHS August 2006
         endif
        ENDIF
      ELSE
        DENSHE = 0.D0
        ECHE = 0.D0
        HET = 0.D0
      END IF
 1004 CONTINUE

C
C LEVEL DENSITY AND TEMPERATURE IN THE ALPHA DAUGHTER
C
C Reduction of angular momentum due to orbital angular momentum of emitted fragment
C
      IF ((IN.GE.3).AND.(IZ.GE.3)) THEN
       JPRFA = JPRF
       ADAUGHT = A - 4.D0
       ZDAUGHT = ZPRF - 2.D0
       EDAUGHT = EE - SBA
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRFA = JPRF + DJPRF
         JPRFA = DNINT(DABS(JPRFA))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROTA = JPRFA * JPRFA * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROTA = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL  DENSNIV(ADAUGHT,ZDAUGHT,EE,SBA,DENSA,
     &        BSHELL,BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRFA,0,QR)
        AT = TEMP
        ECA = 0.D0

        IF(DENSA.GT.0.D0)THEN
         IS = 0
         if (imaxwell.eq.1) then
          RAT = AT
 1239      ECA = dble(FVMAXHAZ(1,sngl(RAT)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING ECA. A VALUE WILL BE FORCED'
            ECA = MIN(2.D0*AT+BA,EE-SBA)
            GOTO 1005
           ENDIF
             if(eca.gt.(ee-sba)) then
              if ((ee-sba).lt.rat) then
               eca = ee-sba
                else
               goto 1239
              endif
            endif
            if(eca.le.0.d0) goto 1239
           ECA = ECA + BA
          else
         ECA = 2.D0 * AT + BA ! KHS August 2006
        endif
       ENDIF
      ELSE
        DENSA = 0.D0
        ECA = 0.D0
        AT = 0.D0
      END IF
 1005 CONTINUE
C
C
C LEVEL DENSITY AND TEMPERATURE AFTER 6HE EMISSION
C
C Reduction of angular momentum due to orbital angular momentum of emitted fragment
C
      IF ((IN.GE.5).AND.(IZ.GE.3)) THEN
       JPRFA = JPRF
       ADAUGHT = A - 6.D0
       ZDAUGHT = ZPRF - 2.D0
       EDAUGHT = EE - SB6HE
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT
       IF (JPRF.GT.0.1D0) THEN
         CALL LORB(A,ADAUGHT,JPRF,EDAUGHT,DLOUT,SDLOUT)
         DJPRF = DBLE(GAUSSHAZ(1,SNGL(DLOUT),SNGL(SDLOUT)))
         IF(IDJPRF.EQ.1) DJPRF = 0.D0
         JPRF6HE = JPRF + DJPRF
         JPRF6HE = DNINT(DABS(JPRF6HE))   ! The nucleus just turns the other way around
       ENDIF
       BSHELL = ECGNZ(INDAUGHT,IZDAUGHT) - VGSLD(INDAUGHT,IZDAUGHT)
       DEFBET = BETA2(INDAUGHT,IZDAUGHT)

       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * ADAUGHT**(5.D0/3.D0)*
     &         (1.D0 + 0.5D0*DSQRT(5.D0/(4.D0*PI))*DEFBET)
       EROT6HE = JPRF6HE * JPRF6HE * 197.328d0 * 197.328d0
     &         /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROT6HE = 0.D0

      CALL BSBK(ADAUGHT,ZDAUGHT,BS,BK)
        CALL  DENSNIV(ADAUGHT,ZDAUGHT,EE,SB6HE,DENS6HE,
     &        BSHELL,BS,BK,TEMP,OPTSHP,OPTCOL,DEFBET,ECOR,JPRF6HE,0,QR)
        HE6T = TEMP
        EC6HE = 0.D0

        IF(DENS6HE.GT.0.D0)THEN
         IS = 0
         if (imaxwell.eq.1) then
          R6HET = HE6T
 1240      EC6HE = dble(FVMAXHAZ(1,sngl(R6HET)))
           IS = IS + 1
           IF(IS.GT.100) THEN
            PRINT*,'WARNING: FVMAXHAZ CALLED MORE THAN 100 TIMES
     &      WHEN CALCULATING EC6HE. A VALUE WILL BE FORCED'
            EC6HE = MIN(2.D0*HE6T+B6HE,EE-SB6HE)
            GOTO 1006
           ENDIF
             if(ec6he.gt.(ee-sb6he)) then
              if ((ee-sb6he).lt.r6het) then
               ec6he = ee-sb6he
                else
               goto 1240
              endif
            endif
            if(ec6he.le.0.d0) goto 1240
           EC6HE = EC6HE + B6HE
          else
         EC6HE = 2.D0 * HE6T + B6HE ! KHS August 2006
        endif
       ENDIF
      ELSE
        DENS6HE = 0.D0
        EC6HE = 0.D0
        HE6T = 0.D0
      END IF
 1006 CONTINUE
C
C
      IF ( DENSG.GT.0.D0) THEN
C
C CALCULATION OF THE PARTIAL DECAY WIDTH
C USED FOR BOTH THE TIME SCALE AND THE EVAPORATION DECAY WIDTH
C
C      AKAP = HBAR**2/(2* MN * R_0**2) = 10 MEV    *** input param ***
C
C AK, KHS 2005 - Energy-dependen inverse cross sections included, influence of
C                Coulomb barrier for LCP, tunnelling for LCP

C REDUCED MASSES (IN MeV/C**2)
        MUN = (A - 1.D0) * 1.D0 / A
        MUP = (A - 1.D0) * 1.D0 / A
        MUD = (A - 2.D0) * 2.D0 / A
        MUT = (A - 3.D0) * 3.D0 / A
       MUHE = (A - 3.D0) * 3.D0 / A
        MUA = (A - 4.D0) * 4.D0 / A
      MU6HE = (A - 6.D0) * 6.D0 / A

C ENERGY OF THE INVERSE PARABOLA AT THE POTENTIAL BARRIER (hbar*omega);
C HERE hbar = 197.3287 fm*MeV/c, omega is in c/fm
       HOP = 197.3287D0 * omegap
       HOD = 197.3287D0 * omegad
       HOT = 197.3287D0 * omegat
      HOHE = 197.3287D0 * omegahe
       HOA = 197.3287D0 * omegaa
       HO6HE = 197.3287D0 * omega6he

C CORRECTIONS FOR BARRIER PENETRATION

      IF(PT.EQ.0.D0)THEN
       PENP = 0.D0
        ELSE
       PENP=10.D0**(4.D-4*(PT/(HOP*HOP*MUP**0.25D0))**(-4.3D0/2.3026D0))
      ENDIF

      IF(DT.EQ.0.D0)THEN
       PEND = 0.D0
        ELSE
       PEND=10.D0**(4.D-4*(DT/(HOD*HOD*MUD**0.25D0))**(-4.3D0/2.3026D0))
      ENDIF

      IF(TT.EQ.0.D0)THEN
       PENT = 0.D0
        ELSE
       PENT=10.D0**(4.D-4*(TT/(HOT*HOT*MUT**0.25D0))**(-4.3D0/2.3026D0))
      ENDIF

      IF(HET.EQ.0.D0)THEN
       PENHE = 0.D0
        ELSE
       PENHE=10.D0**(4.D-4*(HET/(HOHE*HOHE*MUHE**0.25D0))**(-4.3D0/
     &              2.3026D0))
      ENDIF

      IF(AT.EQ.0.D0)THEN
       PENA = 0.D0
        ELSE
       PENA=10.D0**(4.D-4*(AT/(HOA*HOA*MUA**0.25D0))**(-4.3D0/2.3026D0))
      ENDIF

      IF(HE6T.EQ.0.D0)THEN
       PEN6HE = 0.D0
        ELSE
       PEN6HE=10.D0**(4.D-4*(HE6T/(HO6HE*HO6HE*
     &        MU6HE**0.25D0))**(-4.3D0/2.3026D0))
      ENDIF

C WIDTHS

       IF(DENSN.EQ.0.D0)THEN
        GN = 0.D0
         ELSE
        GN  = WIDTH(A,ZPRF,1.D0,0.D0,NT,0.D0,SN,EE-EROTN) * DENSN/DENSG
       ENDIF


       IF(DENSP.EQ.0.D0)THEN
        GP = 0.D0
         ELSE
        GP  = WIDTH(A,ZPRF,1.D0,1.D0,PT,BP,SBP,EE-EROTP) * DENSP/DENSG
     &        * PENP
       ENDIF

       IF(DENSD.EQ.0.D0)THEN
        GD = 0.D0
         ELSE
        GD  = WIDTH(A,ZPRF,2.D0,1.D0,DT,BD,SBD,EE-EROTD) * DENSD/DENSG
     &        * PEND
       ENDIF

       IF(DENST.EQ.0.D0)THEN
        GT = 0.D0
         ELSE
        GT  = WIDTH(A,ZPRF,3.D0,1.D0,TT,BT,SBT,EE-EROTT) * DENST/DENSG
     &       * PENT
       ENDIF

       IF(DENSHE.EQ.0.D0)THEN
        GHE = 0.D0
         ELSE
        GHE = WIDTH(A,ZPRF,3.D0,2.D0,HET,BHE,SBHE,EE-EROTHE) *
     &        DENSHE/DENSG * PENHE
       ENDIF

       IF(DENSA.EQ.0.D0)THEN
        GA = 0.D0
         ELSE
        GA  = WIDTH(A,ZPRF,4.D0,2.D0,AT,BA,SBA,EE-EROTA) * DENSA/DENSG
     &        * PENA
       ENDIF

       IF(DENS6HE.EQ.0.D0)THEN
        G6HE = 0.D0
         ELSE
        G6HE  = WIDTH(A,ZPRF,6.D0,2.D0,HE6T,B6HE,SB6HE,EE-EROT6HE)
     &        * DENS6HE/DENSG
     &        * PEN6HE
       ENDIF

c     **************************
C     *  Treatment of IMFs     *
C     * KHS, AK, MVR 2005-2006 *
c     **************************

      IF(FIMF_ALLOWED.EQ.0.OR.ZPRF.LE.5.D0.OR.A.LE.7.D0)THEN

      GIMF = 0.D0

      ELSE

C     Estimate the total decay width for IMFs (Z >= 3)
C     By using the logarithmic slope between GIMF3 and GIMF5

      CALL MGLMS(A,ZPRF,OPTSHPIMF,MAZZ)

      GIMF3 = 0.D0

      ZIMF = 3.D0
      IZIMF = 3
C     *** Find the limits that both IMF and partner are bound :
        IZCN = IDINT(ZPRF)                       ! Z of CN
        INCN = IDINT(A) - IZCN                ! N of CN

        CALL ISOSTAB_LIM(IZIMF,INMIN,INMAX)   ! Bound isotopes for IZIMF from INMIN to INIMFMA
        CALL ISOSTAB_LIM(IZCN-IZIMF,INMI,INMA)  ! Daughter nucleus after IMF emission,
                                                ! limits of bound isotopes
        INMIN = MAX(INMIN,INCN-INMA)          ! Both IMF and daughter must be bound
        INMAX = MIN(INMAX,INCN-INMI)          !   "

        INMAX = MAX(INMAX,INMIN)    ! In order to keep the variables below

       DO IAIMF = IZIMF+INMIN,IZIMF+INMAX, 1
      AIMF = DFLOAT(IAIMF)
      IF(AIMF.GE.A .OR. ZIMF .GE. ZPRF) THEN
       WIDTH_IMF = 0.D0
      ELSE
c Q-values
       ADAUGHT = A - AIMF
       ZDAUGHT = ZPRF - ZIMF
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT

c       print*,'**',IZIMF,IAIMF,IZDAUGHT,IADAUGHT
c      IF(IADAUGHT.LE.IZDAUGHT) GOTO 1991

      CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHPIMF,MARES)
      CALL MGLMS(AIMF,ZIMF,OPTSHPIMF,MAIMF)

C Bass barrier
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,ZIMF,AIMF,BIMF,OMEGAP)
      SBIMF = MAIMF + MARES - MAZZ + BIMF
C Rotation energy
      DEFBETIMF = BETA2(IDNINT(AIMF-ZIMF),IDNINT(ZIMF)) +
     &   BETA2(IDNINT(A-AIMF-ZPRF+ZIMF),IDNINT(ZPRF-ZIMF))
       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * A**(5.D0/3.D0)*
     &          (AIMF**(5.D0/3.D0) + (A - AIMF)**(5.D0/3.D0)) +
     &          931.49D0 * 1.16D0**2 * AIMF * (A-AIMF) / A *
     &          (AIMF**(1.D0/3.D0) + (A - AIMF)**(1.D0/3.D0))**2


       EROT = JPRF * JPRF * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROT = 0.D0
C Width
      IF(DENSG.EQ.0.D0 .OR. EE. LT. (SBIMF + EROT)) THEN
        WIDTH_IMF = 0.D0
      ELSE
C To take into account that at the barrier the system is deformed:
c      BSIMF = ((A-AIMF)**(2.D0/3.D0) + AIMF**(2.D0/3.D0))/A**(2.D0/3.D0)
       BSIMF = BSCN
       CALL  DENSNIV(A,ZPRF,EE,SBIMF,DENSIMF,
     &      0.D0,BSIMF,1.D0,TIMF,0,0,DEFBETIMF,ECOR,JPRF,2,QR)

        IMFARG = (SBIMF+EROTCN-EROT)/TIMF
        IF(IMFARG. GT. 200.D0) IMFARG = 200.D0

C For IMF - The available phase space is given by the level densities in CN at the
C barrier; applaying MOrretto -> G=WIDTH*ro_CN(E-SBIMF)/ro_CN(E).
C Constant temperature approximation: ro(E+dE)/ro(E)=exp(dE/T)
C Ratio  DENSIMF/DENSCN is included to take into account that at the barrier system
C is deformed. If (above) BSIMF = 1 no deformation is considered and this ratio
C is equal to 1.
        WIDTH_IMF = 0.D0
        WIDTH_IMF = WIDTH(A,ZPRF,AIMF,ZIMF,TIMF,BIMF,SBIMF,EE-EROT)*
     &              DEXP(-IMFARG) * QR / QRCN
        ENDIF
      ENDIF
      GIMF3 = GIMF3 + WIDTH_IMF

 1991      ENDDO

C Zimf = 5 *****
c      GOTO 1290

      GIMF5 = 0.D0

      ZIMF = 5.D0
      IZIMF = 5

      CALL ISOSTAB_LIM(IZIMF,INMIN,INMAX)   ! Bound isotopes for IZIMF from INMIN to INIMFMA
      CALL ISOSTAB_LIM(IZCN-IZIMF,INMI,INMA)  ! Daughter nucleus after IMF emission,

                                              ! limits of bound isotopes
      INMIN = MAX(INMIN,INCN-INMA)          ! Both IMF and daughter must be bound
      INMAX = MIN(INMAX,INCN-INMI)          !   "

      INMAX = MAX(INMAX,INMIN)    ! In order to keep the variables below

      DO IAIMF = IZIMF+INMIN,IZIMF+INMAX, 1

      AIMF = DFLOAT(IAIMF)
      IF(AIMF.GE.A .OR. ZIMF .GE. ZPRF) THEN
       WIDTH_IMF = 0.D0
      ELSE
       ADAUGHT = A - AIMF
       ZDAUGHT = ZPRF - ZIMF
       IADAUGHT = IDNINT(ADAUGHT)
       IZDAUGHT = IDNINT(ZDAUGHT)
       INDAUGHT = IADAUGHT - IZDAUGHT

c      IF(IADAUGHT.LE.IZDAUGHT) GOTO 2067

      CALL MGLMS(ADAUGHT,ZDAUGHT,OPTSHPIMF,MARES)
      CALL MGLMS(AIMF,ZIMF,OPTSHPIMF,MAIMF)

C Bass barrier
      CALL BARRS(EE/A,ZDAUGHT,ADAUGHT,ZIMF,AIMF,BIMF,OMEGAP)
      SBIMF = MAIMF + MARES - MAZZ + BIMF

C Rotation energy
      DEFBETIMF = BETA2(IDNINT(AIMF-ZIMF),IDNINT(ZIMF)) +
     &   BETA2(IDNINT(A-AIMF-ZPRF+ZIMF),IDNINT(ZPRF-ZIMF))
       IINERT = 0.4D0 * 931.49D0 * 1.16D0**2 * A**(5.D0/3.D0)*
     &          (AIMF**(5.D0/3.D0) + (A - AIMF)**(5.D0/3.D0)) +
     &          931.49D0 * 1.16D0**2 * AIMF * (A-AIMF) / A *
     &          (AIMF**(1.D0/3.D0) + (A - AIMF)**(1.D0/3.D0))**2

       EROT = JPRF * JPRF * 197.328d0 * 197.328d0 /(2.D0 * IINERT)
       IF(IEROT.EQ.1) EROT = 0.D0
C Width
      IF(DENSG.EQ.0.D0 .OR. EE. LT. (SBIMF + EROT)) THEN
        WIDTH_IMF = 0.D0
      ELSE
C To take into account that at the barrier the system is deformed:
c      BSIMF = ((A-AIMF)**(2.D0/3.D0) + AIMF**(2.D0/3.D0))/A**(2.D0/3.D0)
      BSIMF = BSCN
       CALL  DENSNIV(A,ZPRF,EE,SBIMF,DENSIMF,
     &      0.D0,BSIMF,1.D0,TIMF,0,0,DEFBETIMF,ECOR,JPRF,2,QR)

        IMFARG = (SBIMF+EROTCN-EROT)/TIMF
        IF(IMFARG. GT. 200.D0) IMFARG = 200.D0

C For IMF - The available phase space is given by the level densities in CN at the
C barrier; applaying Morretto -> G=WIDTH*ro_cn(E-SBIMF)/ro_CN(E).
C Constant temperature approximation: ro(E+dE)/ro(E)=exp(dE/T)
C Ratio  DENSIMF/DENSCN is included to take into account that at the barrier system
C is deformed. If (above) BSIMF = 1 no deformation is considered and this ratio
C is equal to 1.
        WIDTH_IMF = 0.D0
        WIDTH_IMF = WIDTH(A,ZPRF,AIMF,ZIMF,TIMF,BIMF,SBIMF,EE-EROT)*
     &              DEXP(-IMFARG) * QR / QRCN
        ENDIF
      ENDIF
      GIMF5 = GIMF5 + WIDTH_IMF
 2067 ENDDO

 1290 CONTINUE
C It is assumed that GIMFi = A_IMF*ZIMF**B_IMF; to get the total GIMF one integrates
C Int(A_IMF*ZIMF**B_IMF)(3->ZPRF)

      IF(GIMF3.LE.0.D0 .OR. GIMF5.LE.0.D0)THEN
c      IF(GIMF3.LE.0.D0 )THEN
       GIMF = 0.D0
       B_IMF = -100.d0
       A_IMF = 0.D0
      ELSE
c       PRINT*,GIMF3,GIMF5
        B_IMF = (DLOG10(GIMF3) - DLOG10(GIMF5)) /
     &                    (DLOG10(3.D0)-DLOG10(5.D0))

       GOTO 1291
C AKH July 2012 - In order to make the code faster, B_IMF calculated acc. to
C above lines is fitted (for system Fe+p,Xe+p, Pb+p, U+p) as a function of TCN.
C These functions are then calculated as a function of ZP.

         FUNCT1 = (-0.5218873D0 + 6.9517D-4 * DFLOAT(ZP1)) * TCN
         IF(FUNCT1.GT.300.D0) FUNCT1 = 300.D0
         IF(FUNCT1.LT.-300.D0) FUNCT1 = -300.D0
         FUNCT2 = (-1.0559055D0 - 0.04379113D0 * DFLOAT(ZP1)) * TCN
         IF(FUNCT2.GT.300.D0) FUNCT2 = 300.D0
         IF(FUNCT2.LT.-300.D0) FUNCT2 = -300.D0
         B_IMF = ((30.323004D0 + 0.11308086D0 * DFLOAT(ZP1)-
     &            0.00259084D0 * DFLOAT(ZP1) * DFLOAT(ZP1)) *
     &           DEXP(FUNCT1) +
     &           (-6742.698D0 + 437.75246D0 * DFLOAT(ZP1)) *
     &           DEXP(FUNCT2))
     &         *  (3.0205835D0 - 0.05431335D0 * DFLOAT(ZP1) +
     &            3.0404D-4*DFLOAT(ZP1)*DFLOAT(ZP1))
         B_IMF = B_IMF * (-1.D0)

 1291    CONTINUE
         IF(B_IMF .GE. -1.01D0) B_IMF = -1.01D0
         IF(B_IMF .LE. -100.D0) THEN
          B_IMF = -100.D0
          A_IMF = 0.D0
          GIMF = 0.D0
          GOTO 2007
         ENDIF

         A_IMF = GIMF3 / 3.D0**B_IMF
         GIMF = A_IMF * (ZPRF**(B_IMF+1.D0) - 3.D0**(B_IMF+1.D0)) /
     &          (B_IMF + 1.D0)

      ENDIF

2007  CONTINUE

c       print*,B_IMF,GIMF,IDNINT(A),IDNINT(ZPRF)

      IF(GIMF .LT. 1.D-10) GIMF = 0.D0

C*******************************************************************
      ENDIF

C AK 2004 - Gamma width
C According to A. Ignatyuk, GG :
C Here BS=BK=1, as this was assumed in the parameterization
      PA = AV*A + AS*A**(2.D0/3.D0) + AK*A**(1.D0/3.D0)
      GAMMA = 2.5D0 * PA * A**(-4.D0/3.D0)
      GFACTOR = 1.D0+GAMMA*ECGNZ(IN,IZ)
      IF(GFACTOR.LT.0.D0)THEN
       PRINT*,'TGAMMA!',IDNINT(A),IDNINT(ZPRF),ECGNZ(IN,IZ),GAMMA,
     &         BTEST(IN,IZ)
       GFACTOR = 0.D0
      ENDIF
      TGAMMA = 17.60D0/(A**0.699D0 * DSQRT(GFACTOR))

C If one switches gammas off, one should also switch off tunneling through the fission barrier.
      GG = 0.624D-9*A**1.6D0*(TGAMMA)**5

C For fission fragments, GG is ~ 2 times larger than for
c "oridnary" nuclei (A. Ignatyuk, private communication).
       IF(EVOPT.eq.1)THEN
        GG = 2.D0 * GG
       ENDIF
      ECG = 4.D0 * TGAMMA

C Fission
	YFISS = 1.D0 - FISSILITY(IDNINT(A),IDNINT(ZPRF),1,JPRF,TCN)

      CALL FISSION_WIDTH(ZPRF,A,EE,BSSP,BKSP,EF,YFISS,GF,FT,JPRF,
     &     IEROT,FF_ALLOWED,OPTCOL,OPTSHP,DENSG,TCN)
C AK 2007 - Assumption: beta has "oposite" behaviour as compared to shell effects:
      DELTA_E = MAX((ECORCN-EROTCN),0.D0)
      PONFE = -2.5D0*PA*DELTA_E*A**(-4.D0/3.D0)
      IF (PONFE.LT.-700.D0)  PONFE=-700.D0
      BET = BETA_COEFF * (1.D0 - DEXP(PONFE))
      IF(BET.LT.1.D-4) BET = 0.D0
c      BET = BETA_COEFF

      if (itest.eq.1.) write(6,*)
     &    'GN,GP,GD,GT,GHE,GA,GIMF,GG,GF',
     &     GN,GP,GD,GT,GHE,GA,GIMF,GG,GF
C
      ELSE
       WRITE(6,*) 'DIRECT: DENSG <= 0.D0',INUM,IDNINT(A),IDNINT(ZPRF),
     c  EE,jprf
         PROBN   = 0.D0
         PROBP   = 0.D0
         PROBD   = 0.D0
         PROBT   = 0.D0
         PROBHE  = 0.D0
         PROBA   = 0.D0
         PROB6HE = 0.D0
         PROBIMF = 0.D0
         PROBF   = 0.D0
         PROBG   = 0.D0
         GOTO 70
      END IF

c       GD = 0.D0
c       GT = 0.D0
c      GHE = 0.D0
c      G6HE = 0.D0
c      GIMF = 0.D0
c      GG = 0.D0

       GSUM = GN + GP + GD + GT + GHE + GA + G6HE + GIMF + GG

      IF (GSUM.GT.0.D0) THEN
        TS1  = HBAR / GSUM
      ELSE
          TS1  = 1.D99
      END IF

      IF (GF.LE.0.D0) GOTO 69  ! KHS
C*****************************************************************************
C FISSION DECAY WIDTH OBTAINED FROM THE ANALYTICAL SOLUTION OF THE FPE       *
C         WITH A NUCLEAR POTENTIAL APPROXIMATD BY A PARABOLA                 *
C                    BEATRIZ JURADO 18/10/2001                               *
C*****************************************************************************
cFirst step of the deexcitation cascade, we set the accumulation of time TSUM to zero
       IF (INUM.GT.ILAST) TSUM = 0.D0
c       write(6,*) 'INUM,IlAST',INUM,ILAST

C If dissipation coef. beta = 0, decay widths are given by statistical model
       IF (BET.LE.1.0D-16) THEN
        GFF = GF
        GTOT = GSUM + GFF

          if(gtot.le.0.d0)then
            probf = 0.D0
            probn = 0.D0
            probp = 0.D0
            probd = 0.D0
            probt = 0.D0
            probhe = 0.D0
            proba = 0.D0
            prob6he = 0.D0
            probimf = 0.D0
            probg = 0.D0
            go to 70

          elseif(gtot.gt.0.d0)then

            PROBF = GFF/GTOT
            PROBN = GN/GTOT
            PROBP = GP/GTOT
            PROBD = GD/GTOT
            PROBT = GT/GTOT
            PROBHE = GHE/GTOT
            PROBA = GA/GTOT
            PROB6HE = G6HE/GTOT
            PROBIMF = GIMF/GTOT
            PROBG = GG/GTOT

            go to 70
          endif
c If beta > 0 -> dynamical description
       ELSE
c If the excitation energy is bigger than zero
        IF (SBF.GT.EF*(-1.D0)) THEN    !  TUNNELING
c        IF (SBF.GT.0.D0) THEN    !  NO TUNNELING
        CALL FOMEGA_SP(A,ZPRF,YFISS,K1,MFCD,OMEGA,HOMEGA)
        CF=CRAM(BET,HOMEGA)

c We calculate now the stationary value of the fission width GFK
        GFK = GF * CF
        IF (itest.eq.1) write(6,*) 'GFK=',GFK

        IF (EF.LE.0.D0) THEN

c Case of nuclei below Businaro-Gallone mass asymmetry point
           if (ZPRF.LE.55.D0) then
           GF = 0.D0
           GTOT = GSUM
              if(gtot.le.0.d0)then
                probf = 0.D0
                probn = 0.D0
                probp = 0.D0
                probd = 0.D0
                probt = 0.D0
               probhe = 0.D0
                proba = 0.D0
                prob6he = 0.D0
                probimf = 0.D0
                probg = 0.D0
                go to 70

              elseif(gtot.gt.0.d0) then
      	  PROBF = 0.D0
                PROBN =   GN/GTOT
                PROBP =   GP/GTOT
                PROBD =   GD/GTOT
                PROBT =   GT/GTOT
                PROBHE =  GHE/GTOT
                PROBA =   GA/GTOT
                PROB6HE =  G6HE/GTOT
                PROBIMF = GIMF/GTOT
                PROBG =   GG/GTOT

           	  GO TO 70
              endif
C Case of very heavy nuclei that have no fission barrier
C For them fission is the only decay channel available
          else
                PROBF = 1.D0
                PROBN = 0.D0
                PROBP = 0.D0
                probd = 0.D0
                probt = 0.D0
                probhe = 0.D0
                PROBA = 0.D0
                PROB6HE = 0.D0
                PROBIMF = 0.D0
                PROBG = 0.D0
                go to 70
          end if
        ELSE           ! IF(EF.GT.0.D0)
c We calculate the transient time
        CALL FOMEGA_GS(A,ZPRF,Y,K1,OMEGA,HOMEGA)
        TAUC=TAU(BET,HOMEGA,EF,FT)

c         write(1470,*) FT,BET,TAUC*1.D+21

c The subroutine part_fiss calculates the fission width GFF that corresponds to the time
c dependence of the probability distribution obtained by solving the FOKKER-PLANCK eq
c using a nucleus potential that is approximated by a parabola. It also gives the
c decay time for this step T_LAPSE that includes all particle decay channels and the
c fission channel. And it decides whether the nucleus decays by particle evaporation
c CHOICE_FISSPART = 1 or fission CHOICE_FISSPART = 2
        CALL PART_FISS(BET,GSUM,GFK,YFISS,TAUC,TS1,TSUM,
     &       CHOICE_FISSPART,ZPRF,A,FT,T_LAPSE,GFF)

        GF = GFF

C We accumulate in TSUM the mean decay for this step including all particle decay
c channels and fission
         TSUM = TSUM + T_LAPSE

C    If fission occurs
		IF(CHOICE_FISSPART.EQ.2) THEN
                   PROBF = 1.D0
      	     PROBP = 0.D0
      	     PROBN = 0.D0
      	     PROBD = 0.D0
      	     PROBT = 0.D0
                   PROBHE = 0.D0
      	     PROBA = 0.D0
      	     PROB6HE = 0.D0
                   PROBIMF = 0.D0
                   PROBG = 0.D0
      	     GO TO 70
c   If particle evaporation occurs
c The probabilities for the different decays are calculated taking into account
c the fission width GFF that corresponds to this step
              ELSE

                   GFF = 0.D0
                   GTOT = GSUM + GFF
                      if(gtot.le.0.d0)then
                        probf = 0.D0
                        probn = 0.D0
                        probp = 0.D0
                        probd = 0.D0
                        probt = 0.D0
                        probhe = 0.D0
                        proba = 0.D0
                        prob6he = 0.D0
                        probimf = 0.D0
                        probg = 0.D0
                        go to 70

                      elseif(gtot.gt.0.d0) then

                        PROBF =   0.D0
                        PROBN =   GN/GTOT
                        PROBP =   GP/GTOT
                        PROBD =   GD/GTOT
                        PROBT =   GT/GTOT
                        PROBHE =  GHE/GTOT
                        PROBA =   GA/GTOT
                        PROB6HE =   G6HE/GTOT
                        PROBIMF = GIMF/GTOT
                        PROBG =   GG/GTOT

                        go to 70
                     endif
              END IF
        END IF
C
C If the excitation energy is not bigger than the fission barrier
c
      ELSE

        GFF = 0.D0
        GTOT = GSUM + GFF

                      if(gtot.le.0.d0)then
                        probf = 0.D0
                        probn = 0.D0
                        probp = 0.D0
                        probd = 0.D0
                        probt = 0.D0
                       probhe = 0.D0
                        proba = 0.D0
                        prob6he = 0.D0
                        probimf = 0.D0
                        probg = 0.D0
                        go to 70
                      elseif(gtot.gt.0.d0) then

                       PROBF =   GFF/GTOT
                       PROBN =   GN/GTOT
                       PROBP =   GP/GTOT
                       PROBD =   GD/GTOT
                       PROBT =   GT/GTOT
                       PROBHE =  GHE/GTOT
                       PROBA =   GA/GTOT
                       PROB6HE =   G6HE/GTOT
                       PROBIMF = GIMF/GTOT
                       PROBG =   GG/GTOT

                       go to 70
                     endif
      end if
      ENDIF

  69  IF (GF.LE.0.D0) THEN
        GTOT = GN+GP+GD+GT+GHE+GA+GIMF+GG
        if(GTOT.LE.0.D0)then
         PROBF = 0.D0
         PROBN = 0.D0
         PROBP = 0.D0
         PROBD = 0.D0
         PROBT = 0.D0
         PROBHE = 0.D0
         PROBG = 0.D0
         PROBA = 0.D0
         PROB6HE = 0.D0
         PROBIMF = 0.D0
       else
         PROBF = 0.D0
         PROBN = GN/GTOT
         PROBP = GP/GTOT
         PROBD = GD/GTOT
         PROBT = GT/GTOT
         PROBHE = GHE/GTOT
         PROBA = GA/GTOT
         PROB6HE = G6HE/GTOT
         PROBIMF = GIMF/GTOT
         PROBG = GG/GTOT
        endif
       ENDIF


  70  CONTINUE

      PTOTL = PROBP+PROBN+PROBD+PROBT+PROBHE+PROBA+PROB6HE+PROBIMF+PROBG
     &      + PROBF

c      print*,'Prob',IDNINT(A),IDNINT(ZPRF),EE,PROBP,PROBN,PROBD,PROBT,
c     &       PROBHE,PROBA,PROB6HE,PROBIMF
c     &       ,PROBG,PROBF,BET

      EE = EER

c      IF(IDNINT(A).EQ.AP1.AND.IDNINT(ZPRF).EQ.ZP1)THEN
c       IF(GF.GT.0.D0) THEN
c         write(99,89) AP1,ZP1,EF,SN,EE,GN,GF
c       ELSE
c         write(88,*)AP1,ZP1,GF
c       ENDIF
c      ENDIF
c 89   FORMAT(i3,x,i3,x,f12.5,x,f12.5,x,f12.5,x,E20.10,x,E20.10)


      ILAST = INUM

      RETURN
      END
C
C**********************************************************************
C
      SUBROUTINE DENSNIV(A,Z,EE,ESOUS,DENS,BSHELL1,BSIN,BKIN,TEMP,
     &                   OPTSHP,OPTCOL,DEFBET,ECOR,JPRF,IFIS,QR)
C
C     INPUT:
C             A,EE,ESOUS,OPTSHP,BS,BK,BSHELL,DEFBET
C
C     LEVEL DENSITY PARAMETERS
C     COMMON /ALD/    AV,AS,AK,OPTAFAN
C     AV,AS,AK - VOLUME,SURFACE,CURVATURE DEPENDENCE OF THE
C                LEVEL DENSITY PARAMETER
C     OPTAFAN - 0/1  AF/AN >=1 OR AF/AN ==1
C               RECOMMENDED IS OPTAFAN = 0
C---------------------------------------------------------------------
C     OUTPUT: DENS,TEMP
C
C   ____________________________________________________________________
C  /
C  /  PROCEDURE FOR CALCULATING THE STATE DENSITY OF A COMPOUND NUCLEUS
C  /____________________________________________________________________
C
      INTEGER AFP,IZ,OPTSHP,OPTCOL,J,OPTAFAN,I,IFIS,ISTART,K,IN
      INTEGER IOPTCT,IREGCT,IPARITE
      REAL*8 A,EE,ESOUS,DENS,E,Y0,Y1,Y2,Y01,Y11,Y21,PA,BS,BK,TEMP
C=====INSERTED BY KUDYAEV===============================================
      COMMON /ALD/ AV,AS,AK,OPTAFAN
      REAL*8 ECR,ER,DELTAU,Z,DELTPP,PARA,PARZ,FE,HE,ECOR,ECOR1,Pi6
      REAL*8 BSHELL,DELTA0,AV,AK,AS,PONNIV,PONFE,DEFBET,QR,SIG_PER,
     &       FP_PER,SIG_PAR,FP_PAR,SIGMA2,PI,FNORM,JPRF,JFACT,EROT
      REAL*8 GAMMA,PASHELL,TEMPCT,E0,ETEST,PASHELL1,DENSCT,EIN,PA0
      REAL*8 BSIN,BKIN,PONQ,JCR,D,LFACT,YSP,ES0,FISSILITY,BC,BF,EDEF0,
     &       BC0,YSP0,BIPOL,Z2OVERA, B_PAR, A_PAR
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98),
     &       BETA2(0:250,0:136),BETA4(0:250,0:136)
      REAL*8 DENSFM,BSHELL1,BSHELLCT,TFM,ELIM

      COMMON /CONSTTEMP/IOPTCT
      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
      COMMON/REGCT/IREGCT
C=======================================================================
C
C
C-----------------------------------------------------------------------
C     A                 MASS NUMBER OF THE DAUGHTER NUCLEUS
C     EE                EXCITATION ENERGY OF THE MOTHER NUCLEUS
C     ESOUS             SEPARATION ENERGY PLUS EFFECTIVE COULOMB BARRIER
C     DENS              STATE DENSITY OF DAUGHTER NUCLEUS AT EE-ESOUS-EC
C     BSHELL            SHELL CORRECTION
C     TEMP              NUCLEAR TEMPERATURE
C     E        LOCAL    EXCITATION ENERGY OF THE DAUGHTER NUCLEUS
C     E1       LOCAL    HELP VARIABLE
C     Y0,Y1,Y2,Y01,Y11,Y21
C              LOCAL    HELP VARIABLES
C     PA       LOCAL    STATE-DENSITY PARAMETER
C     EC                KINETIC ENERGY OF EMITTED PARTICLE WITHOUT
C                        COULOMB REPULSION
C     IDEN              FAKTOR FOR SUBSTRACTING KINETIC ENERGY IDEN*TEMP
C     DELTA0            PAIRING GAP 12 FOR GROUND STATE
C                       14 FOR SADDLE POINT
C     EITERA            HELP VARIABLE FOR TEMPERATURE ITERATION
C     IOPTCT            = 1 : At low EE CT appraoch at higher Fermi
C                       = 0 : Only Fermi approach
C                       Value can be changed in abrainit.for
C-----------------------------------------------------------------------
C
C
      PI6 = 3.1415926535D0**2 / 6.D0
      PI = 3.1415926535D0
      ECR=10.0D0
      ER=28.0D0
      AFP=IDNINT(A)
      IZ=IDNINT(Z)
      Z2OVERA = Z*Z/A
      IN = AFP - IZ
      BS = BSIN
      BK = BKIN
      ISTART = 0
      E0 = 0.D0
      DELTAU = 0.D0
      DELTPP = 0.D0

      IREGCT = 0

      BSHELL = BSHELL1

      IF(IFIS.NE.1) THEN
       BSHELLCT = ECGNZ(IN,IZ)
      ELSE
       BSHELLCT = 0.D0
      ENDIF

       IF(AFP.LE.20) BSHELLCT = 0.D0

          CALL PARITE(A,PARA)
C Odd A
          IF (PARA.LT.0.D0) THEN
            IPARITE = 1
          ELSE
C Even A
            CALL PARITE(Z,PARZ)
            IF (PARZ.GT.0.D0) THEN
C Even Z, even N
                IPARITE = 2
            ELSE
C Odd Z, odd N
                IPARITE = 0
            END IF
          END IF


 11   EIN = EE - ESOUS

      IF (ESOUS.GT.1.0D30) THEN
        DENS = 0.D0
        GO TO 100
      END IF

      E = EE-ESOUS

      IF (E.LT.0.D0.AND.IFIS.NE.1) THEN  ! TUNNELING
c      IF (E.LT.0.D0) THEN   ! NO TUNNELING
        DENS = 0.D0
        DENSFM = 0.D0
        DENSCT = 0.D0
        IF(OPTAFAN.EQ.1) THEN
           PA = AV*A + AS*A**(2.D0/3.D0) + AK*A**(1.D0/3.D0)
        ELSE
           PA = AV*A + AS*BSIN*A**(2.D0/3.D0) + AK*BKIN*A**(1.D0/3.D0)
        END IF
        GAMMA = 2.5D0 * PA * A**(-4.D0/3.D0)
        ECOR=0.0D0
        GO TO 100
      END IF

      IF(IFIS.EQ.0.AND.BS.NE.1.D0)THEN
C AK, KHS 2007 - With increasing excitation energy system in getting less and less deformed:
      PONQ = (E-100.D0)/5.D0
      IF (PONQ.GT.700.D0) PONQ = 700.D0
       BS = 1.D0/(1.D0+DEXP(-PONQ)) + 1.D0/(1.D0+DEXP(PONQ)) * BSIN
       BK = 1.D0/(1.D0+DEXP(-PONQ)) + 1.D0/(1.D0+DEXP(PONQ)) * BKIN
      ENDIF
C
C LEVEL DENSITY PARAMETER
C
      IF(OPTAFAN.EQ.1) THEN
       PA = AV*A + AS*A**(2.D0/3.D0) + AK*A**(1.D0/3.D0)
        ELSE
       PA = AV*A + AS*BS*A**(2.D0/3.D0) + AK*BK*A**(1.D0/3.D0)
      END IF
C
      GAMMA = 2.5D0 * PA * A**(-4.D0/3.D0)

C AK - 2009 - trial, in order to have transition to constant-temperature approach
C Idea - at the phase transition superfluid-normal fluid, TCT = TEMP, and this
C determines critical energy for pairing.
      IF(A.GT.0.D0)THEN
       ECR = PA*17.60D0/(A**0.699D0 * DSQRT(1.D0+GAMMA*BSHELLCT))*
     &       17.60D0/(A**0.699D0 * DSQRT(1.D0+GAMMA*BSHELLCT))
      ENDIF

      PA0 = AV*A + AS*1.D0*A**(2.D0/3.D0) + AK*1.D0*A**(1.D0/3.D0)

C
C PAIRING CORRECTIONS
C
      IF (IFIS.EQ.1) THEN
         DELTA0 = 14.D0
      ELSE
         DELTA0 = 12.D0
      END IF
C
C SHELL CORRECTIONS
C
      IF (OPTSHP.GT.0) THEN
       DELTAU = BSHELL
        IF (OPTSHP.EQ.2) DELTAU = 0.D0
         IF (OPTSHP.GE.2) THEN
C
C  pairing energy shift with condensation energy A.R.J. 10.03.97
C
          DELTPP = -0.25D0 * (DELTA0/DSQRT(A))**2 * PA / PI6
     &             + 22.34D0*A**(-0.464D0)-0.235D0

C Odd A
c           IF(IPARITE.EQ.1) E = E-DELTA0/DSQRT(A)
           IF(IPARITE.EQ.1) E=E-(0.285D0+11.17D0*A**(-0.464D0)-0.390D0-
     &                        0.00058D0*A)

C Even Z, even N
c           IF(IPARITE.EQ.2) E = E-2.D0*DELTA0/DSQRT(A)
          IF(IPARITE.EQ.2) E=E-(22.34D0*A**(-0.464D0)-0.235D0)

C Odd Z, odd N
          IF(IPARITE.EQ.0) THEN
           IF(IN.EQ.IZ)THEN
           E = E
           ELSE
           E = E
           ENDIF
          ENDIF
        ELSE
          DELTPP = 0.D0
        END IF
       ELSE
       DELTAU = 0.D0
       DELTPP = 0.D0
      END IF

      IF (E.LT.0.D0) THEN
        E = 0.D0
        TEMP=0.5D0
      END IF
C
C  WASHING OUT IS MADE STRONGER ! G.K. 3.7.96
C
      PONFE = -2.5D0*PA*E*A**(-4.D0/3.D0)

      IF (PONFE.LT.-700.D0)  PONFE=-700.D0
      FE = 1.D0-DEXP(PONFE)

      IF (E.LT.ECR) THEN
C     priv. comm. K.-H. SCHMIDT
         HE = 1.D0 - (1.D0 - E/ECR)**2
      ELSE
        HE = 1.D0
      END IF

C
C EXCITATION ENERGY CORRECTED FOR PAIRING AND SHELL EFFECTS
C WASHING OUT WITH EXCITATION ENERGY IS INCLUDED
C
      ECOR = E + DELTAU*FE + DELTPP*HE
C
      IF (ECOR.LE.0.1D0) ECOR = 0.1D0
C
C statt 170.d0 a.r.j. 8.11.97
C
C
C ITERATIVE PROCEDURE ACCORDING TO GROSSJEAN AND FELDMEIER
C TO AVOID THE SINGULARITY E = 0
C
      IF (EE.LT.5.0D0) THEN
        Y1 = DSQRT(PA*ECOR)
        DO 20  J = 1,5,1
          Y2 = PA*ECOR*(1.D0-DEXP(-Y1))
          Y1 = DSQRT(Y2)
 20     CONTINUE
        Y0 = PA/Y1
        TEMP=1.0D0/Y0
        DENS = DEXP(Y0*ECOR)/
     &  ((ECOR**3*Y0)**0.5D0*(1.D0-0.5D0*Y0*ECOR*DEXP(-Y1))**0.5D0)*
     &  DEXP(Y1)*(1.D0-DEXP(-Y1))*0.1477045D0
        IF (ECOR.LT.1.D0) THEN
          ECOR1=1.0D0
          Y11 = DSQRT(PA*ECOR1)
 25       CONTINUE
          DO 30  J = 1,7,1
            Y21 = PA*ECOR1*(1.D0-DEXP(-Y11))
            Y11 = DSQRT(Y21)
 30       CONTINUE
          Y01 = PA/Y11
          DENS = DENS*(Y01/Y0)**1.5D0
          TEMP = TEMP*(Y01/Y0)**1.5D0
        END IF

      ELSE
C
        TEMP = DSQRT(ECOR/PA)

        PONNIV = 2.D0*DSQRT(PA*ECOR)
        IF (PONNIV.GT.700.D0) PONNIV = 700.D0
C
C FERMI GAS STATE DENSITY
C 0.1477045 = sqrt(PI)/12
        DENS = 0.1477045D0 * DEXP(PONNIV) /
     +  (PA**(0.25D0) * ECOR**(1.25D0))


      END IF
      DENSFM = DENS
      TFM = TEMP

      IF (IOPTCT.EQ.0) GOTO 100
        TEMPCT = 17.60D0/(A**0.699D0 * DSQRT(1.D0+GAMMA*BSHELLCT))

        IF(IFIS.EQ.1) THEN
         TEMPCT = 1.D0*TEMPCT
        ENDIF

C AK 2006 - CONSTANT-TEMPERATURE LEVEL DENSITY PARAMETER (ONLY AT LOW ENERGIES)
      IF(E .LT. 30.D0 ) THEN
       IF(A.GT.0.D0)THEN
C The lines below to be uncommented if YSP=f(Temp)
c         IF(IFIS.EQ.1)THEN
C Testing tunneling *********
c          YSP = 1.D0 - FISSILITY(IDNINT(A),IDNINT(Z),1,JPRF,TEMPCT)
c           DEFBET = YSP
c           BS = BIPOL(1,YSP)
c          PA = AV*A + AS*BS*A**(2.D0/3.D0) + AK*BK*A**(1.D0/3.D0)
c         GAMMA = 2.5D0 * PA * A**(-4.D0/3.D0)
c         ENDIF
        IF(OPTSHP.GE.2) THEN
C Parametrization of CT model by Ignatyuk; note that E0 is shifted to correspond
C to pairing shift in Fermi-gas model (there, energy is shifted taking odd-odd nuclei
C  as bassis)
c e-o, o-e
            IF(IPARITE.EQ.1) E0 = 0.285D0+11.17D0*A**(-0.464D0) -
     &      0.390D0-0.00058D0*A
c e-e
            IF(IPARITE.EQ.2) E0 = 22.34D0*A**(-0.464D0)-0.235D0
c o-o
            IF(IPARITE.EQ.0) E0 = 0.D0

        ETEST = PA * TEMPCT**2

        PONNIV = (EIN-E0)/TEMPCT
        IF(IFIS.NE.1) PONNIV = MAX(0.D0,(EIN-E0)/TEMPCT)
        IF (PONNIV.GT.700.D0) PONNIV = 700.D0
        DENSCT = DEXP(PONNIV)/TEMPCT
     &           *DEXP(0.079D0*BSHELLCT/TEMPCT)

          ELIM = EIN

        IF(ELIM.GE.ECR.AND.DENSFM.LE.DENSCT)THEN
          DENS = DENSFM
          IREGCT = 0
          ELSE
          DENS = DENSCT
          IREGCT = 1
c          ECOR = DMIN1(EIN-E0,0.1D0)
        ENDIF
        IF(ELIM.GE.ECR.AND.TFM.GE.TEMPCT)THEN
          TEMP = TFM
          ELSE
          TEMP = TEMPCT
        ENDIF


      ELSE
C Case of no pairing considered
        ETEST = PA * TEMPCT**2
        PONNIV = EIN/TEMPCT
        IF (PONNIV.GT.700.D0) PONNIV = 700.D0
        DENSCT = DEXP(PONNIV)/TEMPCT
         IF(EIN.GE.ECR.AND.DENSFM.LE.DENSCT)THEN
          DENS = DENSFM
          TEMP = TFM
          IREGCT = 0
          ELSE
          DENS = DENSCT
          TEMP = TEMPCT
c          ECOR = DMIN1(EIN,0.1D0)
        ENDIF
         IF(EIN.GE.ECR.AND.TFM.GE.TEMPCT)THEN
          TEMP = TFM
          ELSE
          TEMP = TEMPCT
        ENDIF

       ENDIF

       ENDIF

      ENDIF

 100  CONTINUE

      IF(DENS.EQ.0.D0) THEN
        IF(A.GT.0.D0) THEN
C Parametrization of CT model by Ignatyuk done for masses > 20
         TEMP = 17.60D0/(A**0.699D0 * DSQRT(1.D0+GAMMA*BSHELLCT))
        ELSE
         TEMP = 0.5D0
        ENDIF
      ENDIF
C
C SPIN CUTOFF PARAMETER
C
C PERPENDICULAR AND PARALLEL MOMENT OF INERTIA
c fnorm = R0*M0/hbar**2 = 1.16fm*931.49MeV/c**2 /(6.582122e-22 MeVs)**2 and is
c in units 1/MeV
      FNORM = (1.16D0)**2 * 931.49D0 * 1.D-2 / (9.D0 * 6.582122D0**2)

      IF(IFIS.EQ.0 .OR. IFIS.EQ.2 )THEN
C GROUND STATE:
C FP_PER ~ 1+0.5*alpha2, FP_PAR ~ 1-alpha2 (Hasse & Myers, Geom. relat. macr. nucl. phys.)
C alpha2 = sqrt(5/(4*pi))*beta2
      FP_PER =  0.4D0*A**(5.D0/3.D0)*FNORM
     &        *(1.D0 + 0.5D0*DEFBET*DSQRT(5.D0/(4.D0*PI)))
      FP_PAR = 0.4D0*A**(5.D0/3.D0)*FNORM
     &        *(1.D0 - DEFBET*DSQRT(5.D0/(4.D0*PI)))

c      PRINT*,'EVAP',FP_PAR,FP_PER
      ELSEIF(IFIS.EQ.1)THEN
C SADDLE POINT
C See Hasse&Myer, p. 100
C Perpendicular moment of inertia
      FP_PER = 2.D0/5.D0*A**(5.D0/3.D0)*FNORM
     &        *(1.D0 + 7.D0/6.D0*DEFBET*(1.D0+1396.D0/255.D0*DEFBET))
C Parallel moment of inertia
      FP_PAR = 2.D0/5.D0*A**(5.D0/3.D0)*FNORM
     &        *(1.D0 - 7.D0/3.D0*DEFBET*(1.D0-389.D0/255.D0*DEFBET))

c      PRINT*,'FISS',FP_PAR,FP_PER
      ELSEIF(IFIS.EQ.20)THEN
C IMF - two fragments in contact; it is asumed that both are spherical.
C See Hasse&Myers, p.106
C Here, DEFBET = R1/R2, where R1 and R2 are radii of IMF and its partner
C Perpendicular moment of inertia
      FP_PER = 0.4D0*A**(5.D0/3.D0)*FNORM
     &        *3.5D0*(1.D0 + DEFBET**5)/(1.D0 + DEFBET**3)**(5.D0/3.D0)
C Parallel moment of inertia
      FP_PAR = 0.4D0*A**(5.D0/3.D0)*FNORM
     &        * (1.D0 + DEFBET**5)/(1.D0 + DEFBET**3)**(5.D0/3.D0)

c      PRINT*,'IMF',FP_PAR,FP_PER
      ENDIF

      IF(FP_PAR.LT.0.D0) FP_PAR=0.D0
      IF(FP_PER.LT.0.D0) FP_PER=0.D0

c

      SIG_PER = DSQRT(FP_PER * TEMP)
      SIG_PAR = DSQRT(FP_PAR * TEMP)

      SIGMA2  = SIG_PER**2 + SIG_PAR**2

      JFACT = (2.D0*JPRF+1.D0) *
     &       DEXP(-JPRF*(JPRF+1.D0)/(2.D0*SIGMA2))/
     &       (DSQRT(8.D0*PI)*SIGMA2**1.5D0)

      DENS = DENS * JFACT
C
C COLLECTIVE ENHANCEMENT
C
      EROT = JPRF * JPRF / (2.D0 * DSQRT(FP_PAR**2 + FP_PER**2))
      IF (OPTCOL.EQ.1) THEN
        CALL QROT_ARJ(Z,A,DEFBET,SIG_PER,ECOR-EROT,FE,QR)
      ELSE
         QR   = 1.D0
      END IF

      DENS = DENS * QR

      if(dens.lt.1d-300) then
        dens = 0.
      endif

      RETURN
      END
C
C******************************************************************
C
      SUBROUTINE QROT_ARJ(Z,A,DEFBET,SIG,U,FE,QR)
C
C QROT INCLUDING DAMPING
C
C INPUT: Z,A,DEFBET,SIG,U
C
C OUTPUT: QR - COLLECTIVE ENHANCEMENT FACTOR
C
C SEE  JUNGHANS ET AL., NUCL. PHYS. A 629 (1998) 635
C
C
C   FR(U)    EXPONENTIAL FUNCTION TO DEFINE DAMPING
C   UCR      CRITICAL ENERGY FOR DAMPING
C   DCR      WIDTH OF DAMPING
C   DEFBET   BETA-DEFORMATION !
C   SIG      PERPENDICULAR SPIN CUTOFF FACTOR
C     U      ENERGY
C    QR      COEFFICIENT OF COLLECTIVE ENHANCEMENT
C     A      MASS NUMBER
C     Z      CHARGE NUMBER
C
      REAL*8 UCR,DCR,DEFBET,SIG,U,QR,PONQ,A,Z,DN,N,DZ,BET,
     &       SIG_PER,FE
      integer distn, distz, ndist, zdist, nmn(8),nmz(8),i
      data nmn / 2, 8, 14, 20, 28, 50, 82, 126 /
      data nmz / 2, 8, 14, 20, 28, 50, 82, 126 /
c      data nmn / 2, 8, 14, 20, 50, 82, 126 /
c      data nmz / 2, 8, 14, 20, 50, 82, 126 /
C

       DCR = 10.D0
       UCR = 30.D0

       SIG = SIG**2

       IF (DABS(DEFBET)-0.150D0) 10,10,11
C
  10  N = A - Z


      distn = 10000000
      distz = 10000000
      do i = 1, 8
      ndist = abs(idnint(N) - nmn(i))
      if(ndist .lt. distn) distn = ndist
      zdist = abs(idnint(Z) - nmz(i))
      if(zdist .lt. distz) distz = zdist
      enddo
      DZ = dfloat(distz)
      DN = dfloat(distn)
C
      BET = 0.022D0 + 0.003D0*DN + 0.002D0*DZ

      SIG = 50.D0*BET**2 * SIG
C
C  NO VIBRATIONAL ENHANCEMENT
C
C      SIG = 1.D0
C
 11   PONQ = (U-UCR)/DCR
      IF (PONQ.GT.700.D0) PONQ = 700.D0
      IF (SIG.LT.1.D0) SIG = 1.D0
C According to Junghans et al
      QR = 1.D0/(1.D0+DEXP(PONQ)) * (SIG-1.D0) + 1.D0
c      QR = (1.D0-FE) * (SIG-1.D0) + 1.D0
C According to Ignatyuk et al, S. Journ. Nucl. Phys. 30 (1979) 626
c      QR = (SIG-1.D0)*(0.5D0*(1.D0+DEXP(0.35D0*(-10.D0)))/
c     &     (1.D0+DEXP(0.35D0*(U-10.D0)))+
c     &     0.5D0*(1.D0+DEXP(0.15D0*(-10.D0)))/
c     &     (1.D0+DEXP(0.15D0*(U-10.D0)))) + 1.D0

      IF (QR.LT.1.D0) QR = 1.D0
 12   RETURN
      END
C
C******************************************************************
C
      SUBROUTINE MGLW(AF,ZF,REFOPT,EL)
C
C      _______________________________________________________
C     /                                                      /
C     /  MODEL DE LA GOUTTE LIQUIDE DE C. F. WEIZSACKER.     /
C     /  USUALLY AN OBSOLETE OPTION                          /
C     /______________________________________________________/
C
      INTEGER REFOPT
      REAL*8 AF,ZF,XV,XS,XC,XA,EL

C
      IF ((AF.LE.0.01d0).OR.(ZF.LT.0.01d0)) THEN
        EL = 1.0D38
        GO TO 50
      END IF
      XV = -15.56d0*AF
      XS = 17.23D0*AF**(2.d0/3.d0)
      IF (AF.GT.1.d0) THEN
        XC = 0.7d0*ZF*(ZF-1.d0)*(AF-1.d0)**(-1.D0/3.D0)
        ELSE
          XC = 0.d0
      END IF
      XA = 23.6d0*((AF-2.d0*ZF)**2/AF)

      EL = XV+XS+XC+XA

 50   CONTINUE
C
      RETURN
      END

C
C**********************************************************************
C
C ATTENTION: HERE FINITE RANGE LIQUID DROP MODEL IS USED !!!
C
C
      SUBROUTINE MGLMS(A,Z,REFOPT4,EL)
C
C     ON INPUT:  A,Z,REFOPT4
C     ON OUTPUT: EL
C   ____________________________________________________________________
C  /  USING FUNCTION EFLMAC(IA,IZ,0)
C  /
C  /  REFOPT4 = 0 : WITHOUT MICROSCOPIC CORRECTIONS
C  /  REFOPT4 = 1 : WITH SHELL CORRECTION
C  /  REFOPT4 = 2 : WITH PAIRING CORRECTION
C  /  REFOPT4 = 3 : WITH SHELL- AND PAIRING CORRECTION
C  /____________________________________________________________________
C
      INTEGER A1,Z1,REFOPT4,N1
      REAL*8 A,Z,EL,ECNZ,EFLMAC
      COMMON /EC2SUB/ ECNZ(0:153,0:98)

C
C-----------------------------------------------------------------------
C     A1       LOCAL    MASS NUMBER (INTEGER VARIABLE OF A)
C     Z1       LOCAL    NUCLEAR CHARGE (INTEGER VARIABLE OF Z)
C     REFOPT4           OPTION, SPECIFYING THE MASS FORMULA (SEE ABOVE)
C     A                 MASS NUMBER
C     Z                 NUCLEAR CHARGE
C     DEL               PAIRING CORRECTION
C     EL                NEGATIVE BINDING ENERGY: MASS = A*u + EL
C     ECNZ( , )         TABLE OF SHELL CORRECTIONS
C-----------------------------------------------------------------------
C
      A1 = IDNINT(A)
      Z1 = IDNINT(Z)
      N1 = A1 - Z1
C
      IF ( (A1.LE.0).OR.(Z1.LE.0).OR.((A1-Z1).LE.0) )  THEN
        EL = 1.0d38
        GO TO 50
      END IF

C
C BINDING ENERGY INCL. PAIRING CONTR. IS CALCULATED FROM
C FUNCTION EFLMAC

C
      EL = EFLMAC(A1,Z1,0,REFOPT4)
C
      IF (REFOPT4.GT.0) THEN
        IF (REFOPT4.NE.2) EL = EL+ECNZ(A1-Z1,Z1)
      END IF

      IF(Z1.GE.90) THEN
        IF(N1.LE.145)THEN
         EL = EL + (12.552D0-0.1436D0*DFLOAT(Z1))
        ELSEIF(N1.GT.145.AND.N1.LE.152)THEN
         EL = EL + ((152.4D0-1.77D0*DFLOAT(Z1))+
     &                  (-0.972D0+0.0113D0*DFLOAT(Z1))*DFLOAT(N1))
        ENDIF
      ENDIF

 50   CONTINUE
C
      RETURN
      END

C
C CHANGED TO CALCULATE NEGATIVE TOTAL BINDING ENERGY INSTEAD OF MASS EXCESS.
C SWITCH FOR PAIRING INCLUDED AS WELL.
C BINDING = EFLMAC(IA,IZ,0,OPTSHP)
C FORTRAN TRANSCRIPT OF /U/GREWE/LANG/EEX/FRLDM.C
C A.J. 15.07.96
C

C/**********************************************************************
C *
C * this function will calculate the liquid-drop nuclear mass for spheri
C * configuration according to the preprint NUCLEAR GROUND-STATE
C * MASSES and DEFORMATIONS by P. M"oller et al. from August 16, 1993 p.
C * All constants are taken from this publication for consistency.
C *
C * Parameters:
C *   a:    nuclear mass number
C *   z:    nuclear charge
C *   flag:     0       - return mass excess
C *         otherwise   - return pairing (= -1/2 dpn + 1/2 (Dp + Dn))
C **********************************************************************
C
      DOUBLE PRECISION FUNCTION EFLMAC(IA,IZ,FLAG,OPTSHP)
C
      INTEGER*4 IA,IZ,FLAG,IN,OPTSHP,MEXPIOP(0:153,0:12)
      REAL*8 Z,N,A,AV,AS,A0,C1,C4,B1,B3,F,CA,W,DP,DN,DPN,EFL,PI,BK
      REAL*8 RMAC,BS,H,R0,KF,KS,KV,RP,AY,ADEN,X0,Y0,MH,MN,ESQ,AEL,I,
     &       PARZ,PARA,DEL,E0
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98)
      REAL*8 BETA2(0:250,0:136),BETA4(0:250,0:136)
      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
C     *** Table of liquid-drop masses ***
      INTEGER*4 I1,I2,ITAB
      INTEGER*4 MASS_INDEX(4,95)  ! Must fit to the data in table MASSINDEX
      REAL*4 MASS_TAB(4105)  ! Must fit to the data in table MASSTAB
      COMMON/MASS/ MASS_INDEX, MASS_TAB
      REAL*8 BIND(0:153,0:12)
      COMMON/EXPMASS/BIND,MEXPIOP


      PI = 3.141592653589793238D0
      Z   = DFLOAT(IZ)
      A   = DFLOAT(IA)
      IN  = IA-IZ
      N   = DFLOAT(IN)

      IF(FLAG.EQ.1) GOTO 311

      IF(IZ.LT.13.AND.IN.LT.3)THEN
       IF(MEXPIOP(IN,IZ).EQ.1)THEN
          EFLMAC = BIND(IN,IZ)
         RETURN
       ENDIF
      ENDIF

C     *** Read liquid-drop masses from table MASSTAB ***
      IF (FLAG.EQ.10) THEN
        IF (IZ.GT.95.OR.IZ.LT.1) GOTO 311 ! out of range of table
        IF (IN.LT.MASS_INDEX(2,IZ) .OR.
     &      IN.GT.MASS_INDEX(3,IZ)) GOTO 311 ! out of range
        I1 = MASS_INDEX(4,IZ) + 1
        I2 = MASS_INDEX(2,IZ)
        ITAB = I1 + (IN-I2)
        EFL = DBLE(MASS_TAB(ITAB))
c        WRITE(*,*) IZ,IA,I1,'EFLMAC from Table',EFLMAC
        GOTO 312
      ENDIF

311   CONTINUE
C /* fundamental constants */
C /* hydrogen-atom mass excess */
      MH  = 7.289034D0
C /* neutron mass excess       */
      MN  = 8.071431D0
C /* electronic charge squared */
      ESQ = 1.4399764D0
C
C /* constants from considerations other than nucl. masses */
C /* electronic binding        */
      AEL = 1.433D-5
C /* proton rms radius         */
      RP  = 0.8D0
C /* nuclear radius constant   */
      R0  = 1.16D0
C /* range of Yukawa-plus-expon. potential */
      AY  = 0.68D0
C /* range of Yukawa function used to generate
C     nuclear charge distribution */
      ADEN= 0.70D0
C /* Wigner constant           */
      W   = 30.D0
C
C /* adjusted parameters */
C /* Volume energy              */
      AV  = 16.00126D0
C /* volume asymmetry           */
      KV  =  1.92240D0
C /* Surface energy             */
      AS  = 21.18466D0
C /* surface asymmetry          */
      KS  =  2.345D0
C /* A^0 constant               */
      A0  =  2.615D0
C /* charge asymmetry           */
      CA  =  0.10289D0
C
C
      C1  = 3.D0/5.D0*ESQ/R0
      C4  = 5.D0/4.D0*(3.D0/(2.D0*PI))**(2.D0/3.D0) * C1
C
C
      KF  = (9.D0*PI*Z/(4.D0*A))**(1.D0/3.D0)/R0
      F   = -1.D0/8.D0*RP*RP*ESQ/R0**3 *
     &      (145.D0/48.D0 - 327.D0/2880.D0*KF**2 * RP**2 +
     &      1527.D0/1209600.D0*KF**4 * RP**4)
C

      I   = (N-Z)/A
C
      X0  = R0 * A**(1.D0/3.D0) / AY
      Y0  = R0 * A**(1.D0/3.D0) / ADEN
C
      B1  = 1.D0 - 3.D0/(X0**2) +
     &      (1.D0 + X0) * (2.D0 + 3.D0/X0 + 3.D0/X0**2)
     &       * DEXP(-2.D0*X0)
C
      B3  = 1.D0 - 5.D0/Y0**2 * (1.D0 - 15.D0/(8.D0*Y0) +
     &      21.D0/(8.D0 * y0**3) -
     &      3.D0/4.D0 * (1.D0 + 9.D0/(2.D0*Y0) + 7.D0/Y0**2 +
     &      7.D0/(2.D0 * Y0**3)) * DEXP(-2.D0*Y0))
C
C NOW CALULATION OF TOTAL BINDING ENERGY A.J. 16.7.96
C
C      MASS = MH*Z + MN*N + EFL
      EFL = - AV*(1.D0-KV*I*I)*A
     &	    + AS*(1.D0-KS*I*I)*B1 * A**(2.D0/3.D0) + A0
     &	    + C1*Z*Z*B3/A**(1.D0/3.D0)
     &	    - C4*Z**(4.D0/3.D0)/A**(1.D0/3.D0)
     &	    + F*Z**2/A -CA*(N-Z) - AEL * Z**(2.39D0)
C

       EFL= EFL + W * DABS(I)
C
C PAIRING IS MADE OPTIONAL
C

312   CONTINUE

      IF (OPTSHP.GE.2) THEN

      IF ((IN.EQ.IZ).AND.MOD(IN,2).EQ.1.AND.MOD(IZ,2).EQ.1.AND.
     &     IN.GT.0) THEN
        EFL = EFL + W*(1.D0/A)
      END IF

C AK 2008 - Parametrization of CT model by Ignatyuk;
C The following part has been introduced  in order to have correspondance
C between pairing in masses and level densities;
C AK 2010  note that E0 is shifted to correspond to pairing shift in
C Fermi-gas model (there, energy is shifted taking odd-odd nuclei
C  as bassis)


       IF((IN+IZ).GT.0)THEN
          CALL PARITE(DFLOAT(IN+IZ),PARA)
          IF (PARA.LT.0.D0) THEN
c e-o, o-e
            E0 =0.285D0+11.17D0*DFLOAT(IZ+IN)**(-0.464D0) -
     &      0.390D0-0.00058D0*DFLOAT(IN+IZ)
          ELSE
            CALL PARITE(DFLOAT(IZ),PARZ)
            IF (PARZ.GT.0.D0) THEN
c e-e
                E0 = 22.34D0*DFLOAT(IN+IZ)**(-0.464D0)-0.2350D0
            ELSE
c o-o
                E0 = 0.D0
            END IF
          END IF
        EFL = EFL - E0
C ***
       ELSE
C /* constants from considering odd-even mass differences */
C /* average pairing gap       */
      RMAC= 4.80D0
C /* neutron-proton interaction*/
      H   = 6.6D0
C /* we will account for deformation by using the microscopic
C   corrections tabulated from p. 68ff */
      BS=1.D0
      DN = 0.D0
      DP = 0.D0

      IF(IN.GT.0) DN  = RMAC*BS/N**(1.D0/3.D0)
      IF(IZ.GT.0) DP  = RMAC*BS/Z**(1.D0/3.D0)

      DPN = H/BS/A**(2.D0/3.D0)

C AK (2008) - Even-odd effect in FRLDM masses seems to be too strong.
      DN = DN
      DP = DP
      DPN = DPN

C /* average pairing - Mller & Nix*/
        IF (MOD(IN,2).EQ.1.AND.MOD(IZ,2).EQ.1.AND.
     &       IN.GT.0.AND.IZ.GT.0) THEN
c o-o
          EFL = EFL - DPN + DN + DP
        END IF

        IF (MOD(IN,2).EQ.1.AND.MOD(IZ,2).EQ.0.AND.IN.GT.0) THEN
          EFL = EFL + DN
        END IF

        IF (MOD(IZ,2).EQ.1.AND.MOD(IN,2).EQ.0.AND.IZ.GT.0) THEN
           EFL = EFL + DP
        END IF
      ENDIF
C
C END IF FOR PAIRING TERM
C
      END IF
C
         EFLMAC = EFL

      RETURN
      END
C
C*******************************************************************
C
      SUBROUTINE APPARIEM(A,Z,DEL)
C
C     ON INPUT:  A,Z
C     ON OUTPUT: DEL
C   ____________________________________________________________________
C  /
C  /  CALCUL DE LA CORRECTION, DUE A L'APPARIEMENT, DE L'ENERGIE DE
C  /  LIAISON D'UN NOYAU
C  /
C  /  PROCEDURE FOR CALCULATING THE PAIRING CORRECTION TO THE BINDING
C  /  ENERGY OF A SPECIFIC NUCLEUS
C  /____________________________________________________________________
C
      REAL*8 A,Z,PARA,PARZ,DEL
C
C-----------------------------------------------------------------------
C     A                 MASS NUMBER
C     Z                 NUCLEAR CHARGE
C     PARA              HELP VARIABLE FOR PARITY OF A
C     PARZ              HELP VARIABLE FOR PARITY OF Z
C     DEL               PAIRING CORRECTION
C-----------------------------------------------------------------------
C
      CALL PARITE(A,PARA)
      IF (PARA.LT.0.D0) THEN
        DEL = 0.D0
        ELSE
          CALL PARITE(Z,PARZ)
          IF (PARZ.GT.0.D0) THEN
            DEL = -12.D0/DSQRT(A)
            ELSE
              DEL = 12.D0/DSQRT(A)
          END IF
      END IF
C
      RETURN
      END
C
C*******************************************************************
C
      SUBROUTINE PARITE(N,PAR)
C
C     ON INPUT:  N
C     ON OUTPUT: PAR
C   ____________________________________________________________________
C  /
C  /  PROCEDURE FOR CALCULATING THE PARITY OF THE NUMBER N.
C  /  RETURNS -1 IF N IS ODD AND +1 IF N IS EVEN
C  /____________________________________________________________________
C
      REAL*8 N,PAR,N1,N2,N3
C
C-----------------------------------------------------------------------
C     N                 NUMBER TO BE TESTED
C     N1,N2             HELP VARIABLES
C     PAR               HELP VARIABLE FOR PARITY OF N
C-----------------------------------------------------------------------
C
      N3 = DFLOAT(IDNINT(N))
      N1 = N3/2.D0
      N2 = N1-DINT(N1)
      IF (N2.GT.0.D0) THEN
        PAR = -1.D0
        ELSE
          PAR = 1.D0
      END IF
C
      RETURN
      END
C

C**********************************************************************
C
      DOUBLE PRECISION FUNCTION BIPOL(IFLAG,Y)
C
C     CALCULATION OF THE SURFACE BS OR CURVATURE BK OF A NUCLEUS
C     RELATIVE TO THE SPHERICAL CONFIGURATION
C     BASED ON  MYERS, DROPLET MODEL FOR ARBITRARY SHAPES
C
C     INPUT: IFLAG - 0/1 BK/BS CALCULATION
C             Y    - (1 - X) COMPLEMENT OF THE FISSILITY
C
C     LINEAR INTERPOLATION OF BS BK TABLE
C
      INTEGER IFLAG,I
      REAL*8 Y,BS(1:52),BK(1:52)
      DATA
     & BK/1.00000D0,1.00087D0,1.00352D0,1.00799D0,1.01433D0,
     & 1.02265D0,1.03306D0,1.04576D0,1.06099D0,1.07910D0,1.10056D0,
     & 1.12603D0,1.15651D0,1.19348D0,1.23915D0,1.29590D0,1.35951D0,
     & 1.41013D0,1.44103D0,1.46026D0,1.47339D0,1.48308D0,1.49068D0,
     & 1.49692D0,1.50226D0,1.50694D0,1.51114D0,1.51502D0,1.51864D0,
     & 1.52208D0,1.52539D0,1.52861D0,1.53177D0,1.53490D0,1.53803D0,
     & 1.54117D0,1.54473D0,1.54762D0,1.55096D0,1.55440D0,1.55798D0,
     & 1.56173D0,1.56567D0,1.56980D0,1.57413D0,1.57860D0,1.58301D0,
     & 1.58688D0,1.58688D0,1.58688D0,1.58740D0,1.58740D0/
      DATA
     & BS/1.00000D0,1.00086D0,1.00338D0,1.00750D0,1.01319D0,
     &    1.02044D0,1.02927D0,1.03974D0,
     & 1.05195D0,1.06604D0,1.08224D0,1.10085D0,1.12229D0,1.14717D0,
     & 1.17623D0,1.20963D0,1.24296D0,1.26532D0,1.27619D0,1.28126D0,
     & 1.28362D0,1.28458D0,1.28477D0,1.28450D0,1.28394D0,1.28320D0,
     & 1.28235D0,1.28141D0,1.28042D0,1.27941D0,1.27837D0,1.27732D0,
     & 1.27627D0,1.27522D0,1.27418D0,1.27314D0,1.27210D0,1.27108D0,
     & 1.27006D0,1.26906D0,1.26806D0,1.26707D0,1.26610D0,1.26514D0,
     & 1.26418D0,1.26325D0,1.26233D0,1.26147D0,1.26147D0,1.26147D0,
     &1.25992D0,1.25992D0/

      I = IDINT(Y/2.D-02) + 1
      IF (IFLAG.EQ.1) THEN
        BIPOL = BS(I) + (BS(I+1)-BS(I))/2.D-02 * (Y - 2.D-02*(I-1))
      ELSE
        BIPOL = BK(I) + (BK(I+1)-BK(I))/2.D-02 * (Y - 2.D-02*(I-1))
      END IF
      RETURN
      END

C
C******************************************************************
C
      SUBROUTINE BARFIT(IZ,IA,IL,SBFIS,SEGS,SELMAX)
C     VERSION FOR 32BIT COMPUTER
C     THIS SUBROUTINE RETURNS THE BARRIER HEIGHT BFIS, THE
C     GROUND-STATE ENERGY SEGS, IN MEV, AND THE ANGULAR MOMENTUM
C     AT WHICH THE FISSION BARRIER DISAPPEARS, LMAX, IN UNITS OF
C     H-BAR, WHEN CALLED WITH INTEGER AGUMENTS IZ, THE ATOMIC
C     NUMBER, IA, THE ATOMIC MASS NUMBER, AND IL, THE ANGULAR
C     MOMENTUM IN UNITS OF H-BAR. (PLANCK'S CONSTANT DIVIDED BY
C     2*PI).
C
C        THE FISSION BARRIER FO IL = 0 IS CALCULATED FROM A 7TH
C     ORDER FIT IN TWO VARIABLES TO 638 CALCULATED FISSION
C     BARRIERS FOR Z VALUES FROM 20 TO 110. THESE 638 BARRIERS ARE
C     FIT WITH AN RMS DEVIATION OF 0.10 MEV BY THIS 49-PARAMETER
C     FUNCTION.
C     IF BARFIT IS CALLED WITH (IZ,IA) VALUES OUTSIDE THE RANGE OF
C     THE BARRIER HEIGHT IS SET TO 0.0, AND A MESSAGE IS PRINTED
C     ON THE DEFAULT OUTPUT FILE.
C
C        FOR IL VALUES NOT EQUAL TO ZERO, THE VALUES OF L AT WHICH
C     THE BARRIER IS 80% AND 20% OF THE L=0 VALUE ARE RESPECTIVELY
C     FIT TO 20-PARAMETER FUNCTIONS OF Z AND A, OVER A MORE
C     RESTRICTED RANGE OF A VALUES, THAN IS THE CASE FOR L = 0.
C     THE VALUE OF L WHERE THE BARRIER DISAPPEARS, LMAX IS FIT TO
C     A 24-PARAMETER FUNCTION OF Z AND A, WITH THE SAME RANGE OF
C     Z AND A VALUES AS L-80 AND L-20.
C        ONCE AGAIN, IF AN (IZ,IA) PAIR IS OUTSIDE OF THE RANGE OF
C     VALIDITY OF THE FIT, THE BARRIER VALUE IS SET TO 0.0 AND A
C     MESSAGE IS PRINTED. THESE THREE VALUES (BFIS(L=0),L-80, AND
C     L-20) AND THE CONSTRINTS OF BFIS = 0 AND D(BFIS)/DL = 0 AT
C     L = LMAX AND L=0 LEAD TO A FIFTH-ORDER FIT TO BFIS(L) FOR
C     L>L-20. THE FIRST THREE CONSTRAINTS LEAD TO A THIRD-ORDER FIT
C     FOR THE REGION L < L-20.
C
C        THE GROUND STATE ENERGIES ARE CALCULATED FROM A
C     120-PARAMETER FIT IN Z, A, AND L TO 214 GROUND-STATE ENERGIES
C     FOR 36 DIFFERENT Z AND A VALUES.
C     (THE RANGE OF Z AND A IS THE SAME AS FOR L-80, L-20, AND
C     L-MAX)
C
C        THE CALCULATED BARRIERS FROM WHICH THE FITS WERE MADE WERE
C     CALCULATED IN 1983-1984 BY A. J. SIERK OF LOS ALAMOS
C     NATIONAL LABORATORY GROUP T-9, USING YUKAWA-PLUS-EXPONENTIAL
C     DOUBLE FOLDED NUCLEAR ENERGY, EXACT COULOMB DIFFUSENESS
C     CORRECTIONS, AND DIFFUSE-MATTER MOMENTS OF INERTIA.
C     THE PARAMETERS OF THE MODEL R-0 = 1.16 FM, AS 21.13 MEV,
C     KAPPA-S = 2.3, A = 0.68 FM.
C     THE DIFFUSENESS OF THE MATTER AND CHARGE DISTRIBUTIONS USED
C     CORRESPONDS TO A SURFACE DIFFUSENESS PARAMETER (DEFINED BY
C     MYERS) OF 0.99 FM. THE CALCULATED BARRIERS FOR L = 0 ARE
C     ACCURATE TO A LITTLE LESS THAN 0.1 MEV; THE OUTPUT FROM
C     THIS SUBROUTINE IS A LITTLE LESS ACCURATE. WORST ERRORS MAY BE
C     AS LARGE AS 0.5 MEV; CHARACTERISTIC UNCERTAINY IS IN THE RANGE
C     OF 0.1-0.2 MEV. THE RMS DEVIATION OF THE GROUND-STATE FIT
C     FROM THE 214 INPUT VALUES IS 0.20 MEV. THE MAXIMUM ERROR
C     OCCURS FOR LIGHT NUCLEI IN THE REGION WHERE THE GROUND STATE
C     IS PROLATE, AND MAY BE GREATER THAN 1.0 MEV FOR VERY NEUTRON
C     DEFICIENT NUCLEI, WITH L NEAR LMAX. FOR MOST NUCLEI LIKELY TO
C     BE ENCOUNTERED IN REAL EXPERIMENTS, THE MAXIMUM ERROR IS
C     CLOSER TO 0.5 MEV, AGAIN FOR LIGHT NUCLEI AND L NEAR LMAX.
C
C     WRITTEN BY A. J. SIERK, LANL T-9
C     VERSION 1.0 FEBRUARY, 1984
C
C     THE FOLLOWING IS NECESSARY FOR 32-BIT MACHINES LIKE DEC VAX,
C     IBM, ETC
C
C
      REAL*8 SBFIS,SEGS,SELMAX
      REAL*8 ELZCOF,ELMCOF,EMNCOF,PA,PZ,PL,EMXCOF,EGSCOF,EGS1,EGS2
      REAL*8 EGS3,EGS4,A,Z,L,AMIN,AMAX,AMIN2,AMAX2,AA,ZZ,BFIS
      REAL*8 BFIS0,ELL,EL,EGS,EL80,EL20,ELMAX,SEL80,SEL20,X,Y,Q,QA,QB
      REAL*8 AJ,AK,A1,A2
      INTEGER*4 IA,IZ,IL,I,J,K,M, LL
      DIMENSION  ELZCOF(7,7),ELMCOF(5,4),EMNCOF(5,4),PA(7),PZ(7),PL(10)
      DIMENSION  EMXCOF(6,4),EGSCOF(5,6,4),EGS1(5,6),EGS2(5,6),
     1           EGS3(5,6),EGS4(5,6)
      EQUIVALENCE (EGS1(1,1),EGSCOF(1,1,1)), (EGS2(1,1),EGSCOF(1,1,2)),
     1            (EGS3(1,1),EGSCOF(1,1,3)), (EGS4(1,1),EGSCOF(1,1,4))
      DATA EMNCOF
     1/-9.01100D+2,-1.40818D+3, 2.77000D+3,-7.06695D+2, 8.89867D+2,
     2  1.35355D+4,-2.03847D+4, 1.09384D+4,-4.86297D+3,-6.18603D+2,
     3 -3.26367D+3, 1.62447D+3, 1.36856D+3, 1.31731D+3, 1.53372D+2,
     4  7.48863D+3,-1.21581D+4, 5.50281D+3,-1.33630D+3, 5.05367D-2/
      DATA ELMCOF
     1 /1.84542D+3,-5.64002D+3, 5.66730D+3,-3.15150D+3, 9.54160D+2,
     2 -2.24577D+3, 8.56133D+3,-9.67348D+3, 5.81744D+3,-1.86997D+3,
     3  2.79772D+3,-8.73073D+3, 9.19706D+3,-4.91900D+3, 1.37283D+3,
     4 -3.01866D+1, 1.41161D+3,-2.85919D+3, 2.13016D+3,-6.49072D+2/
      DATA EMXCOF /
     19.43596D4,-2.241997D5,2.223237D5,-1.324408D5,4.68922D4,-8.83568D3,
     2-1.655827D5,4.062365D5,-4.236128D5,2.66837D5,-9.93242D4,1.90644D4,
     3 1.705447D5,-4.032D5,3.970312D5,-2.313704D5,7.81147D4,-1.322775D4,
     4-9.274555D4,2.278093D5,-2.422225D5,1.55431D5,-5.78742D4,9.97505D3/
      DATA ELZCOF
     1 /5.11819909D+5,-1.30303186D+6, 1.90119870D+6,-1.20628242D+6,
     2  5.68208488D+5, 5.48346483D+4,-2.45883052D+4,
     3 -1.13269453D+6, 2.97764590D+6,-4.54326326D+6, 3.00464870D+6,
     4 -1.44989274D+6,-1.02026610D+5, 6.27959815D+4,
     5  1.37543304D+6,-3.65808988D+6, 5.47798999D+6,-3.78109283D+6,
     6  1.84131765D+6, 1.53669695D+4,-6.96817834D+4,
     7 -8.56559835D+5, 2.48872266D+6,-4.07349128D+6, 3.12835899D+6,
     8 -1.62394090D+6, 1.19797378D+5, 4.25737058D+4,
     9  3.28723311D+5,-1.09892175D+6, 2.03997269D+6,-1.77185718D+6,
     A  9.96051545D+5,-1.53305699D+5,-1.12982954D+4,
     B  4.15850238D+4, 7.29653408D+4,-4.93776346D+5, 6.01254680D+5,
     C -4.01308292D+5, 9.65968391D+4,-3.49596027D+3,
     D -1.82751044D+5, 3.91386300D+5,-3.03639248D+5, 1.15782417D+5,
     E -4.24399280D+3,-6.11477247D+3, 3.66982647D+2/
      DATA EGS1 /
     2 1.927813D5, 7.666859D5, 6.628436D5, 1.586504D5,-7.786476D3,
     3-4.499687D5,-1.784644D6,-1.546968D6,-4.020658D5,-3.929522D3,
     4 4.667741D5, 1.849838D6, 1.641313D6, 5.229787D5, 5.928137D4,
     5-3.017927D5,-1.206483D6,-1.124685D6,-4.478641D5,-8.682323D4,
     6 1.226517D5, 5.015667D5, 5.032605D5, 2.404477D5, 5.603301D4,
     7-1.752824D4,-7.411621D4,-7.989019D4,-4.175486D4,-1.024194D4/
      DATA EGS2 /
     1-6.459162D5,-2.903581D6,-3.048551D6,-1.004411D6,-6.558220D4,
     2 1.469853D6, 6.564615D6, 6.843078D6, 2.280839D6, 1.802023D5,
     3-1.435116D6,-6.322470D6,-6.531834D6,-2.298744D6,-2.639612D5,
     4 8.665296D5, 3.769159D6, 3.899685D6, 1.520520D6, 2.498728D5,
     5-3.302885D5,-1.429313D6,-1.512075D6,-6.744828D5,-1.398771D5,
     6 4.958167D4, 2.178202D5, 2.400617D5, 1.167815D5, 2.663901D4/
      DATA EGS3 /
     1 3.117030D5, 1.195474D6, 9.036289D5, 6.876190D4,-6.814556D4,
     2-7.394913D5,-2.826468D6,-2.152757D6,-2.459553D5, 1.101414D5,
     3 7.918994D5, 3.030439D6, 2.412611D6, 5.228065D5, 8.542465D3,
     4-5.421004D5,-2.102672D6,-1.813959D6,-6.251700D5,-1.184348D5,
     5 2.370771D5, 9.459043D5, 9.026235D5, 4.116799D5, 1.001348D5,
     6-4.227664D4,-1.738756D5,-1.795906D5,-9.292141D4,-2.397528D4/
      DATA EGS4 /
     1-1.072763D5,-5.973532D5,-6.151814D5, 7.371898D4, 1.255490D5,
     2 2.298769D5, 1.265001D6, 1.252798D6,-2.306276D5,-2.845824D5,
     3-2.093664D5,-1.100874D6,-1.009313D6, 2.705945D5, 2.506562D5,
     4 1.274613D5, 6.190307D5, 5.262822D5,-1.336039D5,-1.115865D5,
     5-5.715764D4,-2.560989D5,-2.228781D5,-3.222789D3, 1.575670D4,
     6 1.189447D4, 5.161815D4, 4.870290D4, 1.266808D4, 2.069603D3/
C-----------------------------------------------------------------------
C     THE PROGRAM STARTS HERE
C
      IF (IZ.LT.19 .OR. IZ.GT.111) GOTO 900
      IF(IZ.GT.102  .AND. IL.GT.0) GOTO 902
      Z=DFLOAT(IZ)
      A=DFLOAT(IA)
      EL=DFLOAT(IL)
      AMIN= 1.2D0*Z + 0.01D0*Z*Z
      AMAX= 5.8D0*Z - 0.024D0*Z*Z
      IF(A .LT. AMIN .OR. A .GT. AMAX) GOTO 910
C-----------------------------------------------------------------------
C                                ANGUL.MOM.ZERO BARRIER
      AA=2.5D-3*A
      ZZ=1.D-2*Z
      ELL=1.D-2*EL
      BFIS0=0.D0
      CALL LPOLY(ZZ,7,PZ)
      CALL LPOLY(AA,7,PA)
      DO 10 I=1,7
      DO 10 J=1,7
      BFIS0=BFIS0+ELZCOF(J,I)*PZ(J)*PA(I)
 10   CONTINUE
      BFIS=BFIS0
      SBFIS=BFIS
      EGS=0.D0
      SEGS=EGS
C-----------------------------------------------------------------------
C                               VALUES OF L AT WHICH THE BARRIER
C                            IS 20%(EL20) AND 80%(EL80) OF L=0 VALUE
      AMIN2=1.4D0*Z + 0.009D0*Z*Z
      AMAX2=20.D0 + 3.0D0*Z
      IF((A.LT.AMIN2-5.D0 .OR. A.GT.AMAX2+10.D0).AND. IL.GT.0) GOTO 920
      CALL LPOLY(ZZ,5,PZ)
      CALL LPOLY(AA,4,PA)
      EL80=0.D0
      EL20=0.D0
      ELMAX=0.D0
      DO 20 I=1,4
      DO 20 J=1,5
      EL80=EL80+ELMCOF(J,I)*PZ(J)*PA(I)
      EL20=EL20+EMNCOF(J,I)*PZ(J)*PA(I)
 20   CONTINUE
      SEL80=EL80
      SEL20=EL20
C     WRITE(6,25) SEL80,SEL20
 25   FORMAT(' EL80=',F8.1,4X,'EL20=',F8.1)
C-----------------------------------------------------------------------
C                               VALUE OF L (ELMAX) WHERE BARRIER DISAPP.
      CALL LPOLY(ZZ,6,PZ)
      CALL LPOLY(ELL,9,PL)
      DO 30 I= 1,4
      DO 30 J=1,6
      ELMAX=ELMAX+EMXCOF(J,I)*PZ(J)*PA(I)
 30   CONTINUE
      SELMAX=ELMAX
C----------------------------------------------------------------------
C                              VALUE OF BARRIER AT ANG.MOM.  L
      IF(IL.LT.1) RETURN
      X=SEL20/SELMAX
      Y=SEL80/SELMAX
      IF(EL.GT.SEL20) GOTO 40
C-------------------                                 LOW L
C
      Q=0.2D0/(SEL20**2*SEL80**2*(SEL20-SEL80))
      QA=Q*(4.D0*SEL80**3 - SEL20**3)
      QB=-Q*(4.D0*SEL80**2 - SEL20**2)
      BFIS=BFIS*(1.D0 + QA*EL**2 + QB*EL**3)
      GOTO 50
C-------------------                                 HIGH L
C
 40   AJ=(-20.D0*X**5 + 25.D0*X**4 - 4.D0)*(Y-1.D0)**2*Y*Y
      AK=(-20.D0*Y**5 + 25.D0*Y**4 - 1.D0) * (X-1.D0)**2*X*X
      Q= 0.2D0/((Y-X)*((1.D0-X)*(1.D0-Y)*X*Y)**2)
      QA=Q*(AJ*Y - AK*X)
      QB=-Q*(AJ*(2.D0*Y+1.D0) - AK*(2.D0*X+1.D0))
      Z=EL/SELMAX
      A1=4.D0*Z**5 - 5.D0*Z**4 + 1.D0
      A2=QA*(2.D0*Z+1.D0)
      BFIS=BFIS*(A1 + (Z-1.D0)*(A2 + QB*Z)*Z*Z*(Z-1.D0))
 50   IF(BFIS.LE.0.0D0) BFIS=0.0D0
      IF(EL.GT.SELMAX) BFIS=0.0D0
      SBFIS=BFIS
C---------------------------------------------------------------
C     NOW CALCULATE ROTATING GROUND STATE ENERGY
C
      IF(EL.GT.SELMAX) RETURN
      DO 70 K=1,4
         DO 70 LL=1,6
            DO 70 M=1,5
            EGS=EGS+EGSCOF(M,LL,K)*PZ(LL)*PA(K)*PL(2*M-1)
 70   CONTINUE
      SEGS=EGS
      IF(SEGS.LT.0.D0) SEGS=0.0D0
      RETURN
 900  CONTINUE
C      WRITE(6,1000)
      SBFIS=0.D0
C
C FOR Z<19 SBFIS SET TO 1.E3
C
      IF (IZ.LT.19)  SBFIS = 1.D3
      SEGS=0.d0
      SELMAX=0.d0
      RETURN
 902  CONTINUE
C      WRITE(6,1002)
      SBFIS=0.d0
      SEGS=0.d0
      SELMAX=0.d0
      RETURN
 910  CONTINUE
C      WRITE(6,1010) IA,IZ
      SBFIS=0.d0
      SEGS=0.d0
      SELMAX=0.d0
      RETURN
 920  CONTINUE
C      WRITE(6,1020) IA,IL
      SBFIS=0.d0
      SEGS=0.d0
      SELMAX=0.d0
      RETURN
C
 1000 FORMAT('**** BARFIT CALLED WITH Z LESS THAN 19 OR',
     1        ' GREATER THAN 111; BFIS IS SET 0.0 ****'/)
 1002 FORMAT('**** BARFIT CALLED WITH Z GREATER THAN 102',
     1        ' AND L NOT EQUAL TO ZERO; BFIS IS SET 0.0 ****'/)
 1010 FORMAT('**** BARFIT CALLED WITH A =',I3,' OUTSIDE ',
     1        ' THE ALLOWED VALUES FOR Z = ',I3,' ****'/)
 1020 FORMAT('**** BARFIT CALLED WITH A =',I3,' OUTSIDE ' ,
     1        'THE ALLOWED VALUES FOR Z = ',I3/26X,'FOR NONZERO L =',I3
     2         ,' ****'/)


      END
C
C----------------------------------------------------------------------
C
      REAL FUNCTION BFMS67(Zms,Ams)
C
C     This subroutine calculates the fission barriers
C     of the liquid-drop model of Myers and Swiatecki (1967).
C     Analytic parameterization of Dahlinger 1982
C     replaces tables. Barrier heights from Myers and Swiatecki !!!
C
      REAL*8  Zms,Ams,Nms,Ims,ksims,xms,ums

      Nms = Ams - Zms
      Ims = (Nms-Zms)/Ams
      ksims= 50.15d0 * (1.d0- 1.78d0 * Ims**2)
      xms = Zms**2 / (Ams * ksims)
      ums = 0.368d0-5.057d0*xms+8.93d0*xms**2-8.71d0*xms**3
      Bfms67 = 0.7322d0*Zms**2/Ams**(0.333333d0)*10.d0**ums

      RETURN
      End
C
C----------------------------------------------------------------------
C
      SUBROUTINE LPOLY(X,N,PL)
C
C     THIS SUBROUTINE CALCULATES THE ORDINARY LEGENDRE POLYNOMIALS OF
C     ORDER 0 TO N-1 OF ARGUMENT X AND STORES THEM IN THE VECTOR PL.
C     THEY ARE CALCULATED BY RECURSION RELATION FROM THE FIRST TWO
C     POLYNOMIALS.
C     WRITTEN BY A.J.SIERK  LANL  T-9  FEBRUARY, 1984
C
C     NOTE: PL AND X MUST BE DOUBLE PRECISION ON 32-BIT COMPUTERS!
C
      DOUBLE PRECISION PL,X
C
       INTEGER*4 I,N
       DIMENSION PL(n)
       PL(1)=1.d0
       PL(2)=X
       DO 10 I=3,N
       PL(I) = (dfloat(2*I-3)*X*PL(I-1)-dfloat(I-2)*PL(I-2))/dfloat(I-1)
 10    CONTINUE
       RETURN
       END

C******************************************************************
C
      DOUBLE PRECISION FUNCTION TAU(BET,HOMEGA,EF,T)
C
C   INPUT : BET, HOMEGA, EF, T
C   OUTPUT: TAU - RISE TIME IN WHICH THE FISSION WIDTH HAS REACHED
C           90 PERCENT OF ITS FINAL VALUE
C
C   BETA   - NUCLEAR VISCOSITY
C   HOMEGA - CURVATURE OF POTENTIAL
C   EF     - FISSION BARRIER
C   T      - NUCLEAR TEMPERATURE
C
      REAL*8 BET,HOMEGA,EF,T,TLIM

      TLIM = 8.D0 * EF
      IF (T.GT.TLIM) T = TLIM

C      modified BJ and KHS 6.1.2000:
      IF (BET/(DSQRT(2.D0)*10.D0*(HOMEGA/6.582122D0)).LE.1.0D0) THEN
       TAU = DLOG(10.0D0*EF/T)/(BET*1.0D+21)
      ELSE
       TAU = DLOG(10.0D0*EF/T)/
     & (2.D0*(10.D0*HOMEGA/6.582122D0)**2)*(BET*1.0D-21)
      END IF



      RETURN
      END
C
C******************************************************************
C
      DOUBLE PRECISION FUNCTION CRAM(BET,HOMEGA)
C
C  INPUT : BET, HOMEGA  NUCLEAR VISCOSITY + CURVATURE OF POTENTIAL
C  OUTPUT: KRAMERS FAKTOR  - REDUCTION OF THE FISSION PROBABILITY
C          INDEPENDENT OF EXCITATION ENERGY
C
      REAL*8 BET,HOMEGA,REL
      REL= BET/(20.D0*HOMEGA/6.582122D0)
      CRAM=DSQRT(1.0D0+REL**2)-REL
C     limitation introduced   6.1.2000  by  KHS
      if (cram.gt.1.D0) cram = 1.D0


      RETURN
      END
C
C----------------------------------------------------------------------------
       SUBROUTINE PART_FISS(BET,GP,GF,Y,TAUF,TS1,TSUM,CHOICE,ZF,
     &            AF,FT,T_LAPSE,GF_LOC)

C     Julien Taieb, written in the year 2000; most comments by KHS

C     THIS SUBROUTINE IS AIMED TO CHOOSE BETWEEN PARTICLE EMISSION
C     AND FISSION
C     WE USE MONTE-CARLO METHODS AND SAMPLE TIME BETWEEN T=0 AND T=1.5*TAUF
c	TO SIMULATE THE TRANSIENT TIME WITH 30 STEPS (0.05*TAUF EACH)
C     FOR t>1.5*TAUF , GF=CONSTANT=ASYMPTOTICAL VALUE (INCLUDING KRAMERS FACTOR)
c------------------------------------------------------------------------
c    Modifications introduced by BEATRIZ JURADO 18/10/01:
c    1. Now this subrutine is included in the rutine direct
c    2. TSUM does not include the current particle decay time
C    3. T_LAPSE is the time until decay, taken as an output variable
C    4. GF_LOC is also taken as an output variable
C    5. BET (Diss. Coeff.) and HOMEGA (Frequency at the ground state
c       are included as input variables because they are needed for FUNC_TRANS
C-----------------------------------------------------------------------
C     ON INPUT:
C       GP                 Partial particle decay width
C       GF                 Asymptotic value of Gamma-f, including Kramers factor
C       AF                 Mass number of nucleus
C       TAUF               Transient time
C       TS1                Partial particle decay time for the next step
C       TSUM               Total sum of partial particle decay times, including
C                               the next expected one, which is in competition
C                               with fission now
C       ZF                 Z of nucleus
C       AF                 A of nucleus
C-----------------------------------------------------------------------
C     ON OUTPUT:
C       CHOICE             Key for decay mode: 0 = no decay (only internal)
C                                              1 = evaporation
C                                              2 = fission
C-----------------------------------------------------------------------
C     VARIABLES:
C       GP                 Partial particle decay width
C       GF                 Asymptotic value of Gamma-f, including Kramers factor
C       TAUF               Transient time
C       TS1                Partial particle decay time
C       TSUM               Total sum of partial particle decay times
C       CHOICE              Key for decay mode
C       ZF                 Z of nucleus
C       AF                 A of nucleus
C       FT                 Used for Fermi function in FUNC_TRANS
C       STEP_LENGTH        Step in time to sample different decays
C       BEGIN_TIME         Total sum of partial particle decay times, excluding
C                               the next expected one, which is in competition
C                               with fission now
C       LOC_TIME_BEGIN     Begin of time interval considered in one step
C       LOC_TIME_END       End of time interval considered in one step
C       GF_LOC             In-grow function for fission width,
c                                 normalized to asymptotic value
C       TS2                Effective partial fission decay time in one time step
C       HBAR               hbar
C       T_LAPSE            Effective decay time in one time step
C       REAC_PROB          Reaction probability in one time step
C       X                  Help variable for random generator
C-----------------------------------------------------------------------

	SAVE
	REAL*8 GP,GF,TSUM,TAUF,TS1,T_LAPSE,BEGIN_TIME,LOC_TIME_BEGIN
      REAL*8 LOC_TIME_END, LAMBDA,Y
	REAL*8 STEP_LENGTH,GF_LOC,HBAR,FISS_PROB,REAC_PROB,X
	REAL*8 AF,ZF,FUNC_TRANS,FT,BET,HOMEGA,OMEGA,C,K1,MFCD
	INTEGER*4 CHOICE
      real*8 ts2,t_0
      REAL*4 haz,expohaz
      PARAMETER(HBAR=6.582122D-22)

      CALL FOMEGA_GS(AF,ZF,Y,K1,OMEGA,HOMEGA)

	IF(GF.LE.0.d0) THEN
		CHOICE = 1
              T_LAPSE=TS1
              GF_LOC = 0.d0
		GO TO 107
	END IF

C ****************************************************************
C     Calculation of the shift in time due to the initial conditions

C     Overdamped regime
      IF (BET**2.GT.4.0D0*OMEGA**2) then
C         REMEMBER THAT HOMEGA IS ACTUALLY HBAR*HOMEGA1=1MeV
C         SO THAT HOMEGA1 = HOMEGA/HBAR
c     Additional factor 1/16 proposed by KHS on 14/7/2010. Takes into
c     account the fact that the curvature of the potential is ~16 times
c     larger than what predicted by the liquid drop model, because of
c     shell effects.
          t_0 = BET*1.0D+21*HBAR**2/(4.D0*HOMEGA*FT)/16.D0

C     Underdamped regime
      ELSE
          if (((2.d0*FT-HOMEGA/16.D0).gt.0.000001D0).AND.
     &        (BET.GT.0.0D0)) then
c     Additional factor 1/16 proposed by KHS on 14/7/2010. Takes into
c     account the fact that the curvature of the potential is ~16 times
c     larger than what predicted by the liquid drop model, because of
c     shell effects.
              t_0 = (DLOG(2.d0*FT/(2.d0*FT-HOMEGA/16.D0)))/(BET*1.0D+21)
          else
c     Neglect fission transients if the time shift t_0 is too
c     large. Suppresses large, spurious fission cross section at very
c     low excitation energy in p+Ta.
c     DM, MVR 16/6/2010
              choice = 0
              goto 106
            endif
      ENDIF
C ********************************************************************+
      CHOICE = 0
      STEP_LENGTH = 1.5d0*TAUF /50.D0

C     AT FIRST WE CACULATE THE REAL CURRENT TIME
C Beatriz Jurado 18/10/01 - TSUM includes only the time elapsed in the previous steps
      BEGIN_TIME = TSUM + t_0

      IF (BEGIN_TIME.LT.0.d0) WRITE(6,*)'CURRENT TIME < 0',BEGIN_TIME
c
      IF (BEGIN_TIME.LT.1.5d0*TAUF) THEN
            LOC_TIME_BEGIN = BEGIN_TIME
c           PART_PROB = 1- DEXP(-STEP_LENGTH/TS1)
            DO WHILE ((LOC_TIME_BEGIN.LT.1.5d0*TAUF).AND.CHOICE.EQ.0)
                  LOC_TIME_END = LOC_TIME_BEGIN + STEP_LENGTH
c
c  NOW WE ESTIMATE THE MEAN VALUE OF THE FISSION WIDTH WITHIN
c   THE SMALL INTERVAL
      GF_LOC=(FUNC_TRANS(LOC_TIME_BEGIN,ZF,AF,BET,Y,HOMEGA,FT,T_0)+
     1       FUNC_TRANS(LOC_TIME_END,ZF,AF,BET,Y,HOMEGA,FT,T_0))/2.D0
c
                  GF_LOC = GF_LOC * GF

c    TS2 IS THE MEAN DECAY TIME OF THE FISSION CHANNEL
                  IF (GF_LOC.GT.0.d0) then
                              TS2 = HBAR/GF_LOC
C++++++++++++++++++++Add by Beatriz 25/10/01+++++++++++++++++++
                      ELSE
                              TS2 = 0.D0
                  END IF
C++++++++++++++++++++Commented by Beatriz 25/10/01 +++++++++++++++++++++
c                 IF(TS1.GT.0.0) THEN
c                       TSTOT  = 1.0/TS1 + 1/TS2
c                 ELSE
c                 WRITE(6,*)'TS1 = 0'
c                 TSTOT = 1.0/TS2
c                 END IF
c++++++++++++++++++++Modified by Beatriz 25/10/01+++++++++++++++++++++
                  IF(TS2.GT.0.d0) THEN
                        LAMBDA  = 1.d0/TS1 + 1.d0/TS2
                  ELSE
                        LAMBDA = 1.d0/TS1
                  END IF
c
c This is the probability to survive the decay at this step
                  REAC_PROB = DEXP(-1.0d0*STEP_LENGTH*LAMBDA)
c     I GENERATE A RANDOM NUMBER
                  X = DBLE(HAZ(1))
c                 WRITE(6,*)'REAC_PROB,X=',REAC_PROB,X
                  IF(X.GT.REAC_PROB) THEN
C     THEN THE EVAPORATION OR FISSION HAS OCCURED
                        FISS_PROB = GF_LOC / (GF_LOC+GP)
                        X = DBLE(HAZ(1))
c                       WRITE(6,*)'X=',X
                        IF(X.LT.FISS_PROB) THEN
C FISSION OCCURED
                              CHOICE = 2
                        ELSE
C EVAPORATION OCCURED
                              CHOICE = 1
                        END IF
c     WRITE(6,*)'FISS_PROB',FISS_PROB
c     WRITE(6,*)'CHOICE',CHOICE
                  END IF

                  LOC_TIME_BEGIN = LOC_TIME_END

            END DO
C Take the real decay time of this decay step
      T_LAPSE = LOC_TIME_END - BEGIN_TIME

      END IF


c NOW, IF NOTHING HAPPENED DURING TRANSIENT TIME
c     WRITE(6,*)'CHOICE FROM TRANSIENT TIME',CHOICE
 106  IF(CHOICE.EQ.0) THEN
            FISS_PROB = GF / (GF+GP)
C AK 2005 - Added for cases where already at the beginning BEGIN_TIME > 1.5d0*TAUF \\\\\\
            IF (GF.GT.0.d0) then
                 TS2 = HBAR/GF
              ELSE
                 TS2 = 0.D0
              END IF

              IF(TS2.GT.0.d0) THEN
                 LAMBDA  = 1.d0/TS1 + 1.d0/TS2
            ELSE
                 LAMBDA = 1.d0/TS1
              END IF
C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
c
c          if((gf+gp).eq.0.d0) write(16,*) gf,gp

c
            X = DBLE(HAZ(1))
            IF(X.LT.FISS_PROB) THEN
C FISSION OCCURED
                  CHOICE = 2
            ELSE
C EVAPORATION OCCURED
                  CHOICE = 1
            END IF
c     WRITE(6,*)'CHOICE FROM ASYMPTOTICAL TENDENCIE',CHOICE

C KHS 2006 - Take the decay time of the stationary exponential in addition
      T_LAPSE = T_LAPSE + DBLE(EXPOHAZ(1,1.E0/SNGL(LAMBDA)))


      END IF
c
 107  CONTINUE
c
      RETURN
      END
C
C*****************************************************************************
      SUBROUTINE FOMEGA_SP(AF,ZF,Y,K1,MFCD,OMEGA,HOMEGA)

c  Y                 1 - Fissility
C  K1                Stiffness of the parabolic potential
c  OMEGA             Frequency at the ground state, in units 1.e-21 s
c  MFCD              Mass of the fission collective degree of freedom

      REAL*8 AF,ZF,K1,MFCD,OMEGA,HOMEGA,C,ES0,Y,MR02

      ES0 = 20.76D0*AF**(2.D0/3.D0)
C In units 1.e-42 MeVs**2; r0 = 1.175e-15 m, u=931.49MeV/c**2=103.4MeV*s**2/m**2
C divided by 1.e-4 to go from 1.e-46 to 1.e-42
      MR02 = AF**(5.D0/3.D0)*1.034D0*0.01D0*1.175D0*1.175D0

c Determination of the inertia of the fission collective degree of freedom
           MFCD = MR02 * 3.D0/10.D0*(1.D0+3.D0*Y)
C Stiffness
           K1 = ES0*DABS(0.8D0*y*(1.D0-848.D0*Y/255.D0))
C Omega at saddle
          OMEGA = DSQRT(ES0/MR02)*
     &            DSQRT(8.D0/3.D0*Y*(1.d0+304.d0*Y/255.d0))

           HOMEGA = 6.58122D0*OMEGA/10.D0

c      PRINT*,'SP-',IDNINT(AF),IDNINT(ZF),K1,OMEGA,HOMEGA,Y

      RETURN
      END
C
C*****************************************************************************
      SUBROUTINE FOMEGA_GS(AF,ZF,Y,K1,OMEGA,HOMEGA)

c  Y                 1 - Fissility
C  K1                Stiffness of the parabolic potential
c  OMEGA             Frequency at the ground state, in units 1.e-21 s
c  MFCD              Mass of the fission collective degree of freedom

      REAL*8 AF,ZF,OMEGA,HOMEGA,ES0,Y,MR02,K1,C,MINERT

      ES0 = 20.76D0*AF**(2.D0/3.D0)
      MR02 = AF**(5.D0/3.D0)*1.034D0*0.01D0*1.175D0*1.175D0
      MINERT = 3.D0*MR02/10.D0
C See Hasse & Myers, P53

c          K1 = ES0 * 4.D0 * (1.D0 - Y) / 5.D0
c          OMEGA = DSQRT(K1/MINERT)
c          HOMEGA = 6.58122D0*OMEGA/10.D0

C AK 2008 - Omega at GS - acc to Nix (Ann.Phys. 41, p52) there is a mistake in Hasse&Myers
C formula for omega_gs: instead of (1-y) it should be y.
C Therefore, omega_gs is caluclated acc to NIx, and curvature from omega_gs
C and inertia

c         OMEGA = DSQRT(ES0/MR02)*DSQRT(8.D0/3.D0 * Y)
c         HOMEGA = 6.58122D0*OMEGA/10.D0
c         K1 = OMEGA*OMEGA*MINERT


          C = 17.9439d0*(1.d0-1.7826d0*((AF-2.d0*ZF)/AF)**2)
          K1 = 0.4d0*C*AF**(2.D0/3.D0)-0.1464d0*ZF**(2)/AF**(1.D0/3.D0)
          OMEGA = DSQRT(K1/MINERT)
          HOMEGA = 6.58122D0*OMEGA/10.D0

c          print*,'hasse',K1

c          print*,'Nix',K1
c      PRINT*,'GS-',IDNINT(AF),IDNINT(ZF),K1,OMEGA,HOMEGA,Y


      RETURN
      END
C
C******************************************************************************
c
	  DOUBLE PRECISION FUNCTION FUNC_TRANS(TIME,ZF,AF,BET,Y,HOMEGA,
     &                                       FT,T_0)
c	This function determines the fission width as a function o time
c     according to the analytical solution of the FPE for the probability distribution
c    at the barrier when the nucleus potential is aproximated by a parabolic
c     potential. It is taken from S. Chandrasekhar, Rev. Mod. Phys. 15 (1943) 1
c                   Included by Beatriz Jurado 18/10/2001
c***********************INPUT PARAMETERS*********************************
c  Time               Time at which we evaluate the fission width
c  ZF                 Z of nucleus
C  AF                 A of nucleus		
c  BET                Reduced dissipation coefficient
c  OMEGA             Frequency at the ground state
c  FT                 Nuclear temperature
C**************************************************************************
C********************************OUTPUT***********************************
C   Fission decay width at the corresponding time of the decay cascade
C*************************************************************************
c****************************OTHER VARIABLES******************************
C  SIGMA_SQR         Square of the width of the prob. distribution
C  XB                Deformation of the nucleus at the saddle point
c  NORM              Normalization factor of the probability distribution
c  W                 Probability distribution at the saddle deformation XB
c  W_INFIN           Probability distr. at XB at infinite time
c  MFCD              Mass of the fission collective degree of freedom
C*************************************************************************
		REAL*8 TIME,ZF,AF,BET,HOMEGA,FT,HBAR,OMEGA_GS,HOMEGA_GS
		REAL*8 K1,C,BET1,SIGMA_SQR,Y,XB,K1_SP
              REAL*8 NORM,W,W_INFIN,W_EXP
              REAL*8 homega2,MFCD,XACT,T_0,DEFO_INIT,KX,OMEGA_X,CRAM
              REAL*8 OMEGA,LOG_SLOPE_ABS,LOG_SLOPE_INF,SIGMA_SQR_INF
              REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),
     &               VGSLD(0:153,0:98),ALPHA(0:153,0:98),
     &               BETA2(0:250,0:136),BETA4(0:250,0:136)
              PARAMETER(HBAR=6.582122D-22)
              REAL*8 AP,ZP,AT,ZT,EAP,BETA,BMAXNUC,CRTOT,CRNUC,R_0,R_P,
     &               R_T,PI,BFPRO,SNPRO,SPPRO,SHELL,FISSILITY
              INTEGER INMAX,IRNDM
              COMMON /ECLD/   ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
              COMMON /ABRAMAIN/ AP,ZP,AT,ZT,EAP,BETA,BMAXNUC,CRTOT,
     &          CRNUC,R_0,R_P,R_T,INMAX,IRNDM,PI,BFPRO,SNPRO,SPPRO,SHELL

              PI = 3.141592654d0

C AK, KHS 2007 - Influence of initial deformation
C Initial alpha2 deformation (GS)
      DEFO_INIT = DSQRT(5.D0/(4.D0*PI))*BETA2(IDNINT(AP-ZP),IDNINT(ZP))
c      DEFO_INIT = 0.D0

      CALL FOMEGA_SP(AF,ZF,Y,K1_SP,MFCD,OMEGA,HOMEGA)
      CALL FOMEGA_GS(AF,ZF,Y,K1,OMEGA_GS,HOMEGA_GS)
C
C Determination of the square of the width of the probability distribution
c For the overdamped regime BET**2 > 4*OMEGA**2
         IF ((BET*BET).GT.4.D0*OMEGA_GS*OMEGA_GS)then
          BET1=dsqrt(BET*BET-4.D0*OMEGA_GS*OMEGA_GS)
c
C         REMEMBER THAT HOMEGA IS ACTUALLY HBAR*HOMEGA1=1MeV
C         SO THAT HOMEGA1 = HOMEGA/HBAR
C
          SIGMA_SQR = (FT/K1)*(1.D0 -
     &           ((2.D0*bet**2.D0/bet1**2*
     &           (0.5D0 * (dexp(0.5D0*(bet1-bet)*1.0D+21*TIME) -
     &          dexp(0.5D0*(-bet1-bet)*1.0D+21*TIME)))**2) + (bet/bet1*
     &         0.5D0 * (dexp((bet1-bet)*1.0D+21*TIME)-dexp((-bet1-bet)*
     &          1.0D+21*TIME))) + 1.D0 * dexp(-bet*1.0D+21*TIME)))

C Evolution of the mean x-value (KHS March 2006)
        XACT = DEFO_INIT * DEXP(-0.5D0*(BET-BET1)*1.0D+21*(TIME-T_0))

c For the underdamped regime BET**2 < 4*HOMEGA**2 BET1 becomes a complex number
c  and the expression with sinh and cosh can be transformed in one with sin and cos
         ELSE

          BET1=dsqrt(4.D0*OMEGA_GS*OMEGA_GS-BET*BET)

          SIGMA_SQR = FT/K1*(1.d0-DEXP(-1.0d0*BET*1.0D+21*TIME)*
     &    (BET*BET/(BET1*BET1)*(1.d0-DCOS(BET1*1.0D+21*TIME)) +
     &     BET/BET1*DSIN(BET1*1.0D+21*TIME) + 1.0D0))

       XACT = DEFO_INIT * DCOS(0.5D0*BET1*1.0D+21*(TIME-T_0))*
     &        DEXP(-BET*1.0D+21*(TIME-T_0))

         ENDIF
c
c Determination of the deformation at the saddle point according to
c "Geometrical relationships of Macroscopic Nucl. Phys." from Hass and Myers page 100
C This corresponds to alpha2 deformation.
       XB = 7.d0/3.d0*Y - 938.d0/765.d0*Y*Y + 9.499768d0*Y*Y*Y
     &    - 8.050944d0*Y*Y*Y*Y
c       print*, defo_init, xb
c
c Determination of the probability distribution at the saddle deformation

              IF (SIGMA_SQR.GT.0.d0) THEN
                 NORM = 1.d0/dsqrt(2.d0*pi*sigma_sqr)
c KHS March 2006
                 W_EXP = -(XB - XACT)**2.D0/(2.D0 * SIGMA_SQR)
                 IF ( W_EXP .LT. (-708.D0) ) W_EXP = -708.D0
                 W = NORM * DEXP( W_EXP ) * FT / (K1 * SIGMA_SQR)
              ELSE
                 W = 0.d0
              END IF
c
c Determination of the fission decay width, we assume we are in the overdamped
c regime
              SIGMA_SQR_INF = FT/K1
              W_EXP = -XB*XB/(2.D0 * SIGMA_SQR_INF)
               IF ( W_EXP .LT. (-708.D0) ) W_EXP = -708.D0
              W_INFIN = DEXP(W_EXP)/dsqrt(2.D0*pi*SIGMA_SQR_INF)
              FUNC_TRANS = W / W_INFIN

C Correction for the variation of the mean velocity at the fission barrier
C  (see B. Jurado et al, Nucl. Phys. A747, p. 14)

              LOG_SLOPE_INF = CRAM(BET,HOMEGA)*BET*MFCD*OMEGA/FT
              LOG_SLOPE_ABS = (XB-XACT)/SIGMA_SQR - XB/SIGMA_SQR_INF+
     &                         CRAM(BET,HOMEGA)*BET*MFCD*OMEGA/FT

               FUNC_TRANS = FUNC_TRANS * LOG_SLOPE_ABS/LOG_SLOPE_INF

c
 		RETURN
c
		END
C
C**********************************************************************
C
      DOUBLE PRECISION FUNCTION SPDEF(A,Z,OPTXFIS,JPRF,T)
      INTEGER A,Z,OPTXFIS,INDEX
      REAL*8 ALPHA2(36),X,FISSILITY,V,DX,JPRF,T
C
C INPUT:  A,Z,OPTXFIS MASS AND CHARGE OF A NUCLEUS,
C         OPTION FOR FISSILITY
C OUTPUT: SPDEF
C
C ALPHA2 SADDLE POINT DEF. COHEN&SWIATECKI ANN.PHYS. 22 (1963) 406
C RANGING FROM FISSILITY X=0.30 TO X=1.00 IN STEPS OF 0.02
C
      DATA ALPHA2
     & / 2.5464D0, 2.4944D0, 2.4410D0, 2.3915D0, 2.3482D0, 2.3014D0,
     &   2.2479D0, 2.1982D0, 2.1432D0, 2.0807D0, 2.0142D0, 1.9419D0,
     &   1.8714D0, 1.8010D0, 1.7272D0, 1.6473D0, 1.5601D0, 1.4526D0,
     &   1.3164D0, 1.1391D0, 0.9662D0, 0.8295D0, 0.7231D0, 0.6360D0,
     &   0.5615D0, 0.4953D0, 0.4354D0, 0.3799D0, 0.3274D0, 0.2779D0,
     &   0.2298D0, 0.1827D0, 0.1373D0, 0.0901D0, 0.0430D0, 0.0000D0/
      DX = 0.02D0
      X  = FISSILITY(A,Z,OPTXFIS,JPRF,T)
      IF (X.GT.1.D0) X = 1.D0
      IF (X.LT.0.D0) X = 0.D0
      V  = (X-0.3D0)/DX + 1.D0
      INDEX = IDNINT(V)
      IF (INDEX.LT.1) THEN
         SPDEF = ALPHA2(1)
         RETURN
      END IF
      IF (INDEX.EQ.36) THEN
         SPDEF = ALPHA2(36)
      ELSE
         SPDEF =  ALPHA2(INDEX) +
     &    ( ALPHA2(INDEX+1) - ALPHA2(INDEX) ) / DX *
     &    ( X - (0.3D0 + DX*DFLOAT(INDEX-1) ) )
      END IF
      RETURN
      END
C
C******************************************************************
C
      DOUBLE PRECISION FUNCTION FISSILITY(A,Z,OPTXFIS,JPRF,T)
C
C    CALCULATION OF FISSILITY PARAMETER
C
C    INPUT: A,Z INTEGER MASS & CHARGE OF NUCLEUS
C           OPTXFIS = 0 : MYERS, SWIATECKI
C                     1 : DAHLINGER
C                     2 : ANDREYEV
C
      INTEGER A,Z,OPTXFIS
      REAL*8 AA,ZZ,I,Z2A,JPRF,JFACT,C_S,R,W,G,G1,G2,A_CC,T

      AA  = DFLOAT(A)
      ZZ  = DFLOAT(Z)
      I   = DFLOAT(A-2*Z) / AA
      Z2A = ZZ**2 / AA

C Influence of angular momentum - its effect is that Z^2/A is effectievly changed;
C The cahnge is given as: Z^2/A -> Z^2/a + JPRF/JFACT, where for JFACT see NPA376, p275
c      JFACT = DSQRT(1.44D0*931.49D0*1.16D0)*AA**(7.D0/6.D0) /
c     &        (2.D0**(5.D0/3.D0)*197.3D0*5.D0/7.D0)
c      Z2A = Z2A + (JPRF/JFACT)**2

C LDM fissility
c      FISSILITY = Z2A /(50.88D0*(1.D0-1.7826D0*I*I))

C AK 2008 - Fissiilty is calculated according to FRLDM, see Sierk, PRC 1984.
         C_S = 21.13d0 * (1.d0 - 2.3d0*I*I)
         R = 1.16d0 * AA**(1.d0/3.d0)
         W = 0.704d0/R
         G1 = 1.d0 - 15.d0/8.d0*W+21.d0/8.d0*W**3
         G2 = 1.d0 + 9.d0/2.d0*W + 7.d0*W**2 + 7.d0/2.d0*W**3
         G = 1.d0 - 5.d0*W*W*(G1 - 3.d0/4.d0*G2*DEXP(-2.d0/W))
         A_CC = 3.d0/5.d0 * 1.44d0 * G / 1.16d0
         FISSILITY = Z2A * A_CC/(2.d0*C_S)

C
C-------------  MYERS & SWIATECKI DROPLET MODELL
C
c      IF (OPTXFIS.EQ.0) THEN
c        FISSILITY = Z2A /50.8830D0 /
c     &         (1.0D0 - 1.7826D0 * I**2)
c      END IF
C
c      IF (OPTXFIS.EQ.1) THEN
C
C-------------- DAHLINGER FIT:
C
cc         FISSILITY = Z2A *
cc     &   (49.22D0*(1.D0 - 0.3803D0*I**2 - 20.489D0*I**4))**(-1)
c      END IF
C
c       IF (OPTXFIS.EQ.2) THEN
C
C-------------- DUBNA FIT:
C
c         FISSILITY = Z2A  /(48.D0*(1.D0 - 17.22D0*I**4))
c       END IF
C

c      FISSILITY = FISSILITY * (1.D0 + 7.1D-3*T*T )

      IF(FISSILITY.GT.1.D0) FISSILITY = 1.D0
      IF(FISSILITY.LT.0.D0) FISSILITY = 0.D0

      RETURN
      END

C
C**********************************************************************
      SUBROUTINE BARRS(EA,Z11,A11,Z22,A22,BARR,OMEGA)

C AK 2004 - Barriers for LCP and IMF are calculated now according to the
C           Bass model (Nucl. Phys. A (1974))
C KHS 2007 - To speed up, barriers are read from tabels; in case thermal
C            expansion is considered, barriers are calculated.
C INPUT:
C EA    - Excitation energy per nucleon
C Z11, A11 - Charge and mass of daughter nucleus
C Z22, A22 - Charge and mass of LCP or IMF
C
C OUTPUT:
C BARR - Barrier
C OMEGA - Curvature of the potential
C
      REAL*8 Z1,Z2,A1,A2,R,R11,R22,R_EPS,RMAX,FMAX,POTENTIAL,MU,EA
      REAL*8 R12,DFU,D,X,R0,AS,D_EXP,a11,z11,a22,z22,BARR,OMEGA,
     &       SEC_DER_POT,BASS_POTENTIAL,BASS_SEC_DER_POT
      REAL*8 R_EXPANSION, R_EXP_COMM
      REAL*8 DENSG,RP,RT,TEMP,ECM,RNASA
      REAL*8 RMS(0:153,0:98),RMSP,RMST
      REAL*4 FMAXHAZ

      common/pote/ a1,z1,a2,z2,R_EXP_COMM
      COMMON/RMS/RMS

      EXTERNAL POTENTIAL
      EXTERNAL SEC_DER_POT
      EXTERNAL BASS_POTENTIAL
      EXTERNAL BASS_SEC_DER_POT
      EXTERNAL R_EXPANSION

      INTEGER*4 IZimf_max,IZres_max,IN1,IN2,IN2_max,I1,I2,I3,I4,I5,Itab,
     &    IZ1,IZ2,IA1,IA2,OPTEXP,OPTBAR
      COMMON/EXPANSION/OPTEXP

C BASS MODEL NPA 1974 - used only if expansion is considered (OPTEXP=1)
C                        or one wants this model explicitely (OPTBAR=1)
C October 2011 - AK - new parametrization of the barrier and its position,
C                    see W.W. Qu et al., NPA 868 (2011) 1; this is now
C                    default option (OPTBAR=0)
      OPTBAR = 0


c     a22,z22  = IMF
c     a11,z11  = compound nucleus - IMF
      a1 = a11
      z1 = z11
      a2 = a22
      z2 = z22

      IZ2 = DINT(Z2)   ! IMF
      IA2 = DINT(A2)
      IZ1 = DINT(Z1)   ! Residue
      IA1 = DINT(A1)

      MU = a1 * a2 * 931.49D0 /(a1 + a2)

      OMEGA = 0.D0

 2    CONTINUE

      IF(OPTBAR.EQ.0) GOTO 77   ! Qu et al
      IF(OPTBAR.EQ.1) GOTO 76   ! Bass

 76   RMAX = 0.D0
c     limits inside which the maximum is searched
      R_EXP_COMM = R_EXPANSION(EA)
      R = R_EXP_COMM * 1.16D0 * (A1**(1.D0/3.D0)+A2**(1.D0/3.D0))
      R11 = R
      R22 = 5.D0 * R
C     precision of the maximum search
      R_EPS = 0.001D0
C     Numerical maximum search:
      RMAX = FMAX(R11,R22,R_EPS,BASS_POTENTIAL)
      BARR = BASS_POTENTIAL(RMAX)
      IF(Z2. GT. 2.D0 .OR. Z2. EQ. 0.D0 .OR. A2. EQ. 0.D0) GOTO 5
      IF((- BASS_SEC_DER_POT(RMAX) / MU).lt.0.d0) THEN
      print*,'d2U/dr > 0 !',z1,z2,a1,a2,R11,R22,RMAX
      print*,'POT',Bass_potential(RMAX-1.d0),Bass_potential(RMAX-0.5d0),
     & Bass_potential(RMAX),Bass_potential(RMAX-0.5d0),
     & Bass_potential(RMAX+1.d0)
      ELSE
      print*,sec_der_pot(rmax), mu,idnint(a2),idnint(z2)
      OMEGA = DSQRT( - BASS_SEC_DER_POT(RMAX) / MU)
      ENDIF

      GOTO 5

 77   CONTINUE

      RMAX = 1.1D0 * (RMS(IA1-IZ1,IZ1)+RMS(IA2-IZ2,IZ2)) + 2.8D0
      BARR = 1.345D0 * Z1 * Z2 / RMAX
C Omega according to Avishai:
      OMEGA = 4.5D0 / 197.3287D0

      IF(IZ1.LT.60)THEN
      IF(IZ2.EQ.1.AND.IA2.EQ.2) BARR = BARR * 1.1D0
      IF(IZ2.EQ.1.AND.IA2.EQ.3) BARR = BARR * 1.1D0
      IF(IZ2.EQ.2.AND.IA2.EQ.3) BARR = BARR * 1.3D0
      IF(IZ2.EQ.2.AND.IA2.EQ.4) BARR = BARR * 1.1D0
      IF(IZ2.EQ.2.AND.IA2.EQ.6) BARR = BARR * 1.5D0
      ELSE
c      IF(IZ2.EQ.2.AND.IA2.EQ.3) BARR = BARR * 0.9D0
      ENDIF


 5    CONTINUE


      RETURN
      END

C***********************************************************************

      DOUBLE PRECISION FUNCTION R_EXPANSION(EA)

C MVR 2006
C Calculate the relative increase of the radius due to thermal expansion
C The parameterization used is derived for a rather soft EOS
      REAL*8 EA      ! Excitation energy per nucleon
      REAL*8 EB      ! Binding energy per nucleon at ground state
      INTEGER*4 OPTEXP
      COMMON/EXPANSION/ OPTEXP

      IF(OPTEXP .EQ. 0) THEN
        R_EXPANSION = 1.D0
      ELSE
C     from PRC 67 034609 (2003) [ EB = binding energy per nucleon]
      EB = 10.D0
      IF (EA.GE.EB) THEN
       R_EXPANSION = 1.25d0
      ELSE
       R_EXPANSION = (0.25D0*(1.D0+dsqrt(9.d0-8.d0*(EA/EB))))**
     &                (-1.d0/3.d0)
      ENDIF
      ENDIF


      RETURN

      END

C***********************************************************************
      DOUBLE PRECISION FUNCTION BASS_POTENTIAL(R)
C
C Calculate the Bass potential (1997). See PhD thesis Manuel de Jong
C
      REAL*8 R,A1,A2,Z1,Z2,C1,C2,A,B,S,D1,D2,R1,R2,DR,BS,RC,VN,VC
      REAL*8 R_EXP_COMM
      common/pote/ a1,z1,a2,z2,R_EXP_COMM

C In fm/MeV
      A = 0.033D0
      B = 0.007D0
C In fm
      D1 = 3.5D0
      D2 = 0.65D0

      IF(A2.LE.4.D0.AND.Z2.LE.2.D0)THEN
      DR = 1.D0
      ELSE
      DR = 0.D0
      ENDIF
      BS = 0.9984D0

      DR = 0.D0 ! KHS

c      write(6,*) IDINT(A1),IDINT(A2),IDINT(Z1),IDINT(Z2)
c      write(6,*)R_EXP_COMM,(A1+A2)

      RC = R_EXP_COMM * 1.3D0 * ( A1**(1.D0/3.D0) + A2**(1.D0/3.D0))

      R1 = R_EXP_COMM * (1.28D0 * A1**(1.D0/3.D0) -
     &                        0.76D0 + 0.8D0/(A1**(1.D0/3.D0))+DR)

      C1 = R1*(1.D0-BS**2/R1**2)

      R2 =  1.28D0 * A2**(1.D0/3.D0) -
     &                        0.76D0 + 0.8D0/(A2**(1.D0/3.D0))+DR

C Proton
            IF(A2.EQ.1.D0.AND.Z2.EQ.1.D0) THEN
c              R2 =  1.32D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.0D0 + 3.0D0

C Deuteron
            ELSEIF(A2.EQ.2.D0.AND.Z2.EQ.1.D0) THEN
c              R2 =  2.128D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.10D0 ! new
              R2 = R2 * 1.0D0 ! old
C Triton
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.1.D0) THEN
c              R2 =  1.95D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.0D0
C 3He
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.2.D0) THEN
c              R2 =  1.95D0
              R1 = R1 * 1.D0
              R2 = R2 * 1.05D0    !new
              R2 = R2 * 1.0D0     ! old
C Alpha
            ELSEIF(A2.EQ.4.D0.AND.Z2.EQ.2.D0) THEN
c             R2 =  1.78D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.0D0 + 1.0D0   ! old
c              R2 = R2 * 1.0D0 + 1.3D0    ! new

C IMF
            ELSEIF(Z2.GE.3.D0)THEN
             R2 = R_EXP_COMM * R2

            ENDIF


              C2 = R2*(1.D0-BS**2/R2**2)

        S = R - C1 - C2
c        print*,s,r1,r2,z2
C Nuclear part
      VN = - C1*C2/((C1 + C2) * (A*DEXP(S/D1) + B*DEXP(S/D2)))

C Coulomb part
      IF(R.GT.RC)THEN
       VC = 1.44D0 * Z1 * Z2 / R
      ELSEIF(R.LE.RC)THEN
       VC = 1.44D0 * Z1 * Z2 * (3.D0 - R**2/RC**2) / (2.D0 * RC)
      ENDIF

      BASS_POTENTIAL = VN + VC

      RETURN

      END
C***********************************************************************
      DOUBLE PRECISION FUNCTION BASS_SEC_DER_POT(R)

      REAL*8 R,A1,A2,Z1,Z2,C1,C2,A,B,S,D1,D2,R1,R2,DR,BS,RC,D2VN,D2VC
      REAL*8 R_EXP_COMM
      common/pote/ a1,z1,a2,z2,R_EXP_COMM

C In fm/MeV
      A = 0.033D0
      B = 0.007D0
C In fm
      D1 = 3.5D0
      D2 = 0.65D0
      IF(A2.LE.4.D0.AND.Z2.LE.2.D0)THEN
      DR = 1.D0
      ELSE
      DR = 0.D0
      ENDIF
      BS = 0.9984D0

      DR = 0.D0 ! KHS

c      write(6,*) IDINT(A1),IDINT(A2),IDINT(Z1),IDINT(Z2)
c      write(6,*) R_EXPAND,ENERG,(A1+A2)

      RC =  R_EXP_COMM * 1.3D0 * ( A1**(1.D0/3.D0) + A2**(1.D0/3.D0))

      R1 = R_EXP_COMM * (1.28D0 * A1**(1.D0/3.D0) -
     &                        0.76D0 + 0.8D0/(A1**(1.D0/3.D0))+DR)

      C1 = R1*(1.D0-BS**2/R1**2)

      R2 =  (1.28D0 * A2**(1.D0/3.D0) -
     &                        0.76D0 + 0.8D0/(A2**(1.D0/3.D0))+DR)

C Proton
            IF(A2.EQ.1.D0.AND.Z2.EQ.1.D0) THEN
c              R2 =  1.32D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.0D0 + 3.0D0

C Deuteron
            ELSEIF(A2.EQ.2.D0.AND.Z2.EQ.1.D0) THEN
c              R2 =  2.128D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.10D0 ! new
              R2 = R2 * 1.0D0 ! old
C Triton
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.1.D0) THEN
c              R2 =  1.95D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.0D0
C 3He
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.2.D0) THEN
c              R2 =  1.95D0
              R1 = R1 * 1.D0
              R2 = R2 * 1.05D0    !new
              R2 = R2 * 1.0D0     ! old
C Alpha
            ELSEIF(A2.EQ.4.D0.AND.Z2.EQ.2.D0) THEN
c             R2 =  1.78D0
              R1 = R1 * 1.0D0
              R2 = R2 * 1.0D0 + 1.0D0   ! old
c              R2 = R2 * 1.0D0 + 1.3D0    ! new

C IMF
            ELSEIF(Z2.GE.3.D0)THEN
             R2 = R_EXP_COMM * R2

            ENDIF

            C2 = R2*(1.D0-BS**2/R2**2)

        S = R - C1 - C2

C Nuclear part
        D2VN = C1*C2/(C1+C2) * (A*B*DEXP(S/D1+S/D2)*
     &         (D1**2+D2**2-4.D0*D1*D2)/(D1**2*D2**2)-
     &         A**2*DEXP(2.D0*S/D1)/D1**2-B**2*DEXP(2.D0*S/D2)/D2**2)/
     &         (A*DEXP(S/D1)+B*DEXP(S/D2))**3

C Coulomb part
      IF(R.GT.RC)THEN
        D2VC = 2.D0 * 1.44D0 * Z1 * Z2 / R**3
      ELSEIF(R.LE.RC)THEN
        D2VC = -1.44D0 * Z1 * Z2 / RC**3
      ENDIF

        BASS_SEC_DER_POT = D2VN + D2VC

      RETURN

      END
C***********************************************************************
      DOUBLE PRECISION FUNCTION POTENTIAL(R)
C
C Potential according to Myers and Swiatecki, PRC62 (2000). Not used
C
      REAL*8 a1,z1,a2,z2,n1,n2,par(6),b,q,r0,j,e2,const,i1,t1,i2,t2,as2
      REAL*8 r001,csmall1,c1,r2,c2,c,k,s,psi,fi,r,r002,csmall2
      REAL*8 R_EXP_COMM
      common/pote/ a1,z1,a2,z2,R_EXP_COMM

      data par / -0.1886d0,-0.2628d0,-0.15216d0,-0.04562d0,0.069136d0,
     &          -0.011454d0/


      N1 = A1 - Z1
      N2 = A2 - Z2

      b = 1.D0
      Q = 35.4D0
      r0 = 1.14D0
      J = 32.65D0
      e2 = 1.44D0
      const = 3.d0*e2/(5.D0*r0)

      I1 = (N1-Z1)/A1
      t1 = 1.5D0*r0*(J*I1-const*Z1*A1**(-1.D0/3.D0)/12.D0)/
     &    (Q+2.25D0*J*A1**(-1.D0/3.D0))
      I2 = (N2-Z2)/A2
      t2 = 1.5D0*r0*(J*I2-const*Z2*A2**(-1.D0/3.D0)/12.D0)/
     &    (Q+2.25D0*J*A2**(-1.D0/3.D0))

      as2 = 18.36 - Q*(t1**2 + t2**2)/(2.d0*r0**2)

      R001 = 1.24D0*A1**(1.D0/3.D0)*(1.d0+1.646D0/A1-0.191D0*I1)
      csmall1 = R001 * (1.D0-3.5D0*B**2/R001**2-6.125D0*B**4/R001**4)
      C1 = csmall1 + N1/A1*t1

      IF(A2.LE.4.D0.AND.Z2.LE.2.D0)THEN
C Proton
            IF(A2.EQ.1.D0.AND.Z2.EQ.1.D0) THEN
              R2 = 1.32D0
C Deuteron
            ELSEIF(A2.EQ.2.D0.AND.Z2.EQ.1.D0) THEN
              R2 = 2.128D0
C Triton
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.1.D0) THEN
              R2 = 1.95D0
C 3He
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.2.D0) THEN
              R2 = 1.95D0
C Alpha
            ELSEIF(A2.EQ.4.D0.AND.Z2.EQ.2.D0) THEN
              R2 = 1.78D0
            ENDIF
              C2 = R2*(1.D0-B**2/R2**2)
      ELSE
      R002 = 1.24D0*A2**(1.D0/3.D0)*(1.d0+1.646D0/A2-0.191D0*I2)
      csmall2 = R002 * (1.D0-3.5D0*B**2/R002**2-6.125D0*B**4/R002**4)
      C2 = csmall2 + N2/A2*t2
      ENDIF


      C = C1 * C2 / (C1 + C2)
      K = b*C*as2/(r0**2)

      S = R - (C1 + C2)
      PSI = S / B

      IF(PSI.LE.2.5D0)THEN
      FI = -0.1353D0 + par(1)*(2.5d0-psi)+
     &                 par(2)*(2.5d0-psi)**2/2.D0+
     &                 par(3)*(2.5d0-psi)**3/3.D0+
     &                 par(4)*(2.5d0-psi)**4/4.D0+
     &                 par(5)*(2.5d0-psi)**5/5.D0+
     &                 par(6)*(2.5d0-psi)**6/6.D0

      ELSEIF(PSI.GT.2.5D0)THEN
      FI = -0.09551D0*DEXP((2.75D0-psi)/0.7176D0)
      ENDIF

      POTENTIAL = Z1 * Z2 * e2 / R + K * FI

      RETURN
      END

C***********************************************************************
      DOUBLE PRECISION FUNCTION SEC_DER_POT(R)

      REAL*8 Z1,Z2,A1,A2,R
      REAL*8 R0,D2FI
      REAL*8 N1,N2,par(6),b,q,j,e2,const,i1,t1,i2,t2,as2
      REAL*8 r001,csmall1,c1,r2,c2,c,k,s,psi,r002,csmall2
      REAL*8 R_EXP_COMM
      common/pote/ a1,z1,a2,z2,R_EXP_COMM
      data par / -0.1886d0,-0.2628d0,-0.15216d0,-0.04562d0,0.069136d0,
     &          -0.011454d0/

      N1 = A1 - Z1
      N2 = A2 - Z2

      b = 1.D0
      Q = 35.4D0
      r0 = 1.14D0
      J = 32.65D0
      e2 = 1.44D0
      const = 3.d0*e2/(5.D0*r0)

      I1 = (N1-Z1)/A1
      t1 = 1.5D0*r0*(J*I1-const*Z1*A1**(-1.D0/3.D0)/12.D0)/
     &    (Q+2.25D0*J*A1**(-1.D0/3.D0))
      I2 = (N2-Z2)/A2
      t2 = 1.5D0*r0*(J*I2-const*Z2*A2**(-1.D0/3.D0)/12.D0)/
     &    (Q+2.25D0*J*A2**(-1.D0/3.D0))

      as2 = 18.36 - Q*(t1**2 + t2**2)/(2.d0*r0**2)

      R001 = 1.24D0*A1**(1.D0/3.D0)*(1.d0+1.646D0/A1-0.191D0*I1)
      csmall1 = R001 * (1.D0-3.5D0*B**2/R001**2-6.125D0*B**4/R001**4)
      C1 = csmall1 + N1/A1*t1

      IF(A2.LE.4.D0.AND.Z2.LE.2.D0)THEN
C Proton
            IF(A2.EQ.1.D0.AND.Z2.EQ.1.D0) THEN
              R2 = 1.32D0
C Deuteron
            ELSEIF(A2.EQ.2.D0.AND.Z2.EQ.1.D0) THEN
              R2 = 2.128D0
C Triton
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.1.D0) THEN
              R2 = 1.95D0
C 3He
            ELSEIF(A2.EQ.3.D0.AND.Z2.EQ.2.D0) THEN
              R2 = 1.95D0
C Alpha
            ELSEIF(A2.EQ.4.D0.AND.Z2.EQ.2.D0) THEN
              R2 = 1.78D0
            ENDIF
              C2 = R2*(1.D0-B**2/R2**2)
      ELSE
      R002 = 1.24D0*A2**(1.D0/3.D0)*(1.d0+1.646D0/A2-0.191D0*I2)
      csmall2 = R002 * (1.D0-3.5D0*B**2/R002**2-6.125D0*B**4/R002**4)
      C2 = csmall2 + N2/A2*t2
      ENDIF

      C = C1 * C2 / (C1 + C2)
      K = b*C*as2/(r0**2)

      S = R - (C1 + C2)
      PSI = S / B

      IF(PSI.LE.2.5D0)THEN
      D2FI =  par(2)+
     &        par(3)*(2.5d0-psi) * 2.D0+
     &        par(4)*(2.5d0-psi)**2 * 3.D0+
     &        par(5)*(2.5d0-psi)**3 * 4.D0+
     &        par(6)*(2.5d0-psi)**4 * 5.D0

      ELSEIF(PSI.GT.2.5D0)THEN
      D2FI = -0.09551D0*DEXP((2.75D0-psi)/0.7176D0)/(0.7176D0*0.7176D0)
      ENDIF

      SEC_DER_POT = 2.D0 * Z1 * Z2 * e2 / (R**3) + K * D2FI / (B * B)

      RETURN
      END
C
C********************************************************************************************
C
      DOUBLE PRECISION FUNCTION FMAX(R1,R2,R_EPS,F)

C       /* ROUTINE, FINDS THE POSITION OF THE MAXIMUM OF A FUNCTION  */
C       /* BETWEEN    R1 <= X <= R2                                  */
C       /* KLAUS PIELENZ 1977                                        */

       Real*8 R1,R2                            ! Limits
       Real*8 R_EPS                            ! Precision
       Real*8 F                               ! Function
       Real*8 X1,X2
       Real*8 DI1,DI2
       Real*8 R_MAX
       Real*8 DELTA_X
       Real*8 V1,V2
       Real*8 QA
       Real*8 R_SIGN

       Delta_x = 0.D0
       QA = 0.618034D0
       R_SIGN = 1.D0                             ! Maximum search
C IF R_SIGN = -1 => Minimum search

          X1 = R1
          X2 = R2
          DELTA_X = X2 - X1
          DI1 = X2 - QA * DELTA_X
          DI2 = X1 + QA * DELTA_X
          V1 = R_SIGN * F(DI1)
          V2 = R_SIGN * F(DI2)

C         Look for extremum
          DO WHILE (DELTA_X.GT.R_EPS)
               IF (V1 .GT. V2) THEN
                    X2 = DI2
                    DI2 = DI1
                    V2 = V1
                    DELTA_X = X2 - X1
                    DI1 = X2 - QA * DELTA_X
                    V1 = R_SIGN * F(DI1)
               ELSE
                    X1 = DI1
                    DI1 = DI2
                    V1 = V2
                    DELTA_X = X2 - X1
                    DI2 = X1 + QA * DELTA_X
                    V2 = R_SIGN * F(DI2)
               ENDIF
          ENDDO
          R_MAX = 0.5D0 * (X1 + X2)
          IF (ABS(R_MAX - R1) .LT. 2.*R_EPS) THEN
c             IF (R_SIGN.EQ.1.) THEN
c               Write(6,*) 'PROBABLY NO MAXIMUM EXISTING'
c             ELSE
c               Write(6,*) 'PROBABLY NO MINIMUM EXISTING'
c             ENDIF
             R_MAX = R1
          ENDIF
          IF (ABS(R2 - R_MAX).LT. 2.*R_EPS) THEN
c             IF (R_SIGN.EQ.1.) THEN
c               Write(6,*) 'PROBABLY NO MAXIMUM EXISTING'
c             ELSE
c               Write(6,*) 'PROBABLY NO MINIMUM EXISTING'
c             ENDIF
             R_MAX = R2
          ENDIF
          Fmax = R_MAX

        END
C
C****************************************************************************
C
      subroutine evap_postsaddle(A,Z,EXC,INUM,EESCISS,AFSCISS,ZFSCISS,
     &           VX_EVA,VY_EVA,VZ_EVA,
     &           NTOTN_POST,NTOTP_POST,NTOTD_POST,NTOTT_POST,
     &           NTOTHE_POST,NTOTA_POST,NTOT6HE_POST)

C  AK 2006 - Now in case of fission deexcitation between saddle and scission
C            is explicitely calculated. Langevin calculations made by P. Nadtochy
C            udes to parametrise saddle-to-scission time

      real*8 AF,ZF,EE,EESCISS,AFSCISS,ZFSCISS,A,Z,EXC,VX_EVA,VY_EVA,
     &       VZ_EVA,PXEVA,PYEVA,PLEVA
      real*8 tau,tau0,a0,a1
      real*8 vxout,vyout,vzout,v2,gamma,avvmass
      real*8 PROBP,PROBN,PROBD,PROBT,PROBHE,PROBA,PROBIMF,PROBF,PROBG,
     &       PTOTL,SN,SBP,SBD,SBT,SBHE,SBA,ECN,ECP,ECD,ECT,ECHE,ECA,ECG,
     &       BP,BD,BT,BHE,BA,TSUM,TAUC,E,X,AMOINS,ZMOINS,EPSILN,PC,
     &       TIME,TS1,B,T,NTOTN_POST,NN,NTOTP_POST,NP,NTOTD_POST,ND,
     &       NTOTT_POST,NT,NTOTHE_POST,NHE,NTOTA_POST,NALPHA,EF,
     &       SP,SD,ST,SHE,SA,JPRFN,JPRFP,JPRFD,JPRFT,JPRFHE,JPRFA,JPRFIN
      real*8 PROB6HE,SB6HE,S6HE,EC6HE,B6HE,NTOT6HE_POST,N6HE,JPRF6HE
      integer INTTYPE,INUM,FF_ALLOWED,itest,IRNDM,it,step,FIMF_ALLOWED,
     &        IFISSLOW,IDECAYMODE,IEV_TAB_SSC,ISTEPDEACY,SORTIE,FF,
     &        FGAMMA,FIMF,I,K
      real*4 rndm,haz
      real*8 rndt,ctet1,stet1,rndp,phi1,xcv,ycv,zcv,pteva,ptot,etot,mu,c
      REAL*8 EV_TAB_SSC(200,5),ETOT_LP
      COMMON/EV_TAB_STS/EV_TAB_SSC,IEV_TAB_SSC
      COMMON/SORTIE/SORTIE

      c = 29.9792458d0
      mu = 931.494d0

      AF = DNINT(A)
      ZF = DNINT(Z)
      EE = EXC

      ff_allowed = 0
      FIMF_ALLOWED = 0
      itest = 0
      it = 0
      IDECAYMODE = 0
      IEV_TAB_SSC = 0
      ISTEPDEACY = 10
C Initialsation
      step = 0
      time = 0.d0
      NTOTN_POST  = 0.D0
      NTOTP_POST  = 0.D0
      NTOTD_POST  = 0.D0
      NTOTT_POST  = 0.D0
      NTOTHE_POST = 0.D0
      NTOTA_POST  = 0.D0
      NTOT6HE_POST = 0.D0
      PXEVA = 0.D0
      PYEVA = 0.D0
      PLEVA = 0.D0
      DO I = 1,200
      DO K = 1,5
      EV_TAB_SSC(I,K) = 0.D0
      ENDDO
      ENDDO
      VX_EVA = 0.D0
      VY_EVA = 0.D0
      VZ_EVA = 0.D0

c in sec
      TAU0 = 1.0D-21
      A0 = 0.66482503D0 - 3.4678935D0 * DEXP(-0.0104002D0*EE)
      A1  = 5.6846D-04 + 0.00574515D0 * DEXP(-0.01114307D0*EE)
      TAU = (A0 + A1 * ZF**2/AF**0.3333333D0) * TAU0

      if (itest.eq.1) write(6,*) '******New event********',af,zf,ee

  10     CALL DIRECT(ZF,AF,EE,0.D0,PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,
     +           PROB6HE,PROBIMF,PROBF,PROBG,PTOTL,SN,SBP,SBD,SBT,SBHE,
     +           SBA,SB6HE,ECN,ECP,ECD,ECT,ECHE,ECA,EC6HE,ECG,BP,BD,BT,
     +           BHE,BA,B6HE,SP,SD,ST,SHE,SA,S6HE,EF,INTTYPE,ISTEPDEACY,
     +           INUM,FF_ALLOWED,FIMF_ALLOWED,it,TSUM,TAUC,TS1,B,T,
     +           JPRFN,JPRFP,JPRFD,JPRFT,JPRFHE,JPRFA,JPRF6HE,JPRFIN,0)
C
       step = step + 1
C HERE THE FINAL STEPS OF THE EVAPORATION ARE CALCULATED
C
c      write(6,*)idnint(zf),idnint(af),ee,sn,probn,probf,probg,ptotl
c      write(6,*)'********'

      IF (PTOTL.EQ.0.D0) GOTO 100
C
C
        E = DMIN1(SN,SBP,SBD,SBT,SBHE,SBA,SB6HE)
        IF (E.GT.1.D30) THEN
         WRITE(6,*)'ERROR AT THE EXIT OF EVAPORA,E>1.D30,AF=',AF,
     &             'ZF=',ZF
        END IF

        IF(SORTIE.EQ.1)THEN
         IF (PROBN.NE.0.D0) THEN
          AMOINS = 1.D0
          ZMOINS = 0.D0
          EPSILN = SN+ECN
          PC = DSQRT((1.D0+(ECN)/9.3956D2)**2-1.D0) * 9.3956D2
          NN     = 1.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 1
         ELSE IF (PROBP.NE.0.D0) THEN
          AMOINS = 1.D0
          ZMOINS = 1.D0
          EPSILN = SP+ECP
          PC = DSQRT((1.D0+ECP/9.3827D2)**2-1.D0) * 9.3827D2
          NN     = 0.D0
          NP     = 1.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 2
         ELSE IF (PROBD.NE.0.D0) THEN
          AMOINS = 2.D0
          ZMOINS = 1.D0
          EPSILN = SD+ECD
          PC = DSQRT((1.D0+ECD/1.875358D3)**2-1.D0) * 1.875358D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 1.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 3
         ELSE IF (PROBT.NE.0.D0) THEN
          AMOINS = 3.D0
          ZMOINS = 1.D0
          EPSILN = ST+ECT
          PC = DSQRT((1.D0+ECT/2.80828D3)**2-1.D0) * 2.80828D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 1.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 4
         ELSE IF (PROBHE.NE.0.D0) THEN
          AMOINS = 3.D0
          ZMOINS = 2.D0
          PC = DSQRT((1.D0+ECHE/2.80826D3)**2-1.D0) * 2.80826D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 1.D0
          NALPHA = 0.D0
          N6HE = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 5
         ELSE IF (PROBA.NE.0.D0) THEN
          AMOINS = 4.D0
          ZMOINS = 2.D0
          EPSILN = SA+ECA
          PC = DSQRT((1.D0+ECA/3.72834D3)**2-1.D0) * 3.72834D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 1.D0
          N6HE = 0.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 6
         ELSE IF (PROB6HE.NE.0.D0) THEN
          AMOINS = 6.D0
          ZMOINS = 2.D0
          EPSILN = S6HE+EC6HE
          PC = DSQRT((1.D0+EC6HE/3.72834D3)**2-1.D0) * 3.72834D3
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 1.D0
          FF = 0
          FIMF = 0
          FGAMMA = 0
          IDECAYMODE = 10
          END IF
          GO TO 99
        END IF

      IRNDM = IRNDM+1
C
C HERE THE NORMAL EVAPORATION CASCADE STARTS
C
C RANDOM NUMBER FOR THE EVAPORATION
C
      X = DBLE(HAZ(1))*PTOTL
C
       IF (X.LT.PROB6HE) THEN
C
C 6HE EVAPORATION
C
        if (itest.eq.3) write(6,*) '<Postsaddle 6he evaporation >'
        AMOINS = 6.D0
        ZMOINS = 2.D0
        EPSILN = S6HE+EC6HE
        PC = DSQRT((1.D0+EC6HE/5.60660267D3)**2-1.D0) * 5.60660267D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 0.D0
        NHE    = 0.D0
        NALPHA = 0.D0
        N6HE   = 1.D0


      ELSEIF (X.LT.PROB6HE+PROBA) THEN
C
C ALPHA EVAPORATION
C
        if (itest.eq.3) write(6,*) '<Postsaddle alpha evaporation >'
        AMOINS = 4.D0
        ZMOINS = 2.D0
        EPSILN = SA+ECA
        PC = DSQRT((1.D0+ECA/3.72834D3)**2-1.D0) * 3.72834D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 0.D0
        NHE    = 0.D0
        NALPHA = 1.D0
        N6HE = 0.D0
C
C 3HELIUM EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE)) THEN

        if (itest.eq.3) write(6,*) '< Postsaddle 3Helium evaporation >'
        AMOINS = 3.D0
        ZMOINS = 2.D0
        EPSILN = SHE+ECHE
        PC = DSQRT((1.D0+ECHE/2.80826D3)**2-1.D0) * 2.80826D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 0.D0
        NHE    = 1.D0
        NALPHA = 0.D0
        N6HE = 0.D0
C
C TRITON EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT)) THEN

        if (itest.eq.3) write(6,*) '< Postsaddle triton evaporation >'
        AMOINS = 3.D0
        ZMOINS = 1.D0
        EPSILN = ST+ECT
        PC = DSQRT((1.D0+ECT/2.80828D3)**2-1.D0) * 2.80828D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 0.D0
        NT     = 1.D0
        NHE    = 0.D0
        NALPHA = 0.D0
        N6HE = 0.D0
C
C DEUTERON EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD)) THEN

        if (itest.eq.3) write(6,*) '< Postsaddle deuteron evaporation >'
        AMOINS = 2.D0
        ZMOINS = 1.D0
        EPSILN = SD+ECD
        PC = DSQRT((1.D0+ECD/1.875358D3)**2-1.D0) * 1.875358D3
        NN     = 0.D0
        NP     = 0.D0
        ND     = 1.D0
        NT     = 0.D0
        NHE    = 0.D0
        NALPHA = 0.D0
        N6HE = 0.D0
C
C PROTON EVAPORATION
C
        ELSE IF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP)) THEN

          if (itest.eq.3) write(6,*) '< Postsaddle proton evaporation >'
          AMOINS = 1.D0
          ZMOINS = 1.D0
          EPSILN = SP+ECP
          PC = DSQRT((1.D0+ECP/9.3827D2)**2-1.D0) * 9.3827D2
          NN     = 0.D0
          NP     = 1.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0
C
C NEUTRON EVAPORATION
C
        ELSEIF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP+PROBN))THEN

          if (itest.eq.3) write(6,*)'< Postsaddle neutron evaporation >'
          AMOINS = 1.D0
          ZMOINS = 0.D0
          EPSILN = SN+ECN
          PC = DSQRT((1.D0+(ECN)/9.3956D2)**2-1.D0) * 9.3956D2
          NN     = 1.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0

C
C GAMMA EMISSION
C
        ELSEIF (X.LT.(PROB6HE+PROBA+PROBHE+PROBT+PROBD+PROBP+PROBN+
     &                 PROBG)) THEN

         if (itest.eq.3) write(6,*) '< Postsaddle gamma emission >'
          AMOINS = 0.D0
          ZMOINS = 0.D0
          EPSILN = ECG
          PC = ECG
          NN     = 0.D0
          NP     = 0.D0
          ND     = 0.D0
          NT     = 0.D0
          NHE    = 0.D0
          NALPHA = 0.D0
          N6HE = 0.D0
          IDECAYMODE = 7

C Next IF command is to shorten the calculations when gamma-emission is the only
C possible channel  (AK)

      IF(PROBN.EQ.0.D0.AND.PROBP.EQ.0.D0.AND.PROBD.EQ.0.D0.AND.
     +  PROBT.EQ.0.D0.AND.PROBHE.EQ.0.D0.AND.PROBA.EQ.0.D0.AND.
     +  PROB6HE.EQ.0.D0.AND.PROBG.NE.0.D0)  GOTO 100

      END IF

C CALCULATION OF THE DAUGHTER NUCLEUS
C
  99  CONTINUE

C DM - 2010
      IF (IDECAYMODE.EQ.7.AND.EE.LE.0.01D0+epsiln) then
         epsiln = ee-0.01d0
         time=tau+1.d0
      endif

      AF = AF-AMOINS
      ZF = ZF-ZMOINS
      EE = EE-EPSILN

      IF (EE.LE.0.01D0) EE = 0.01D0

      NTOTN_POST  = NTOTN_POST + NN
      NTOTP_POST  = NTOTP_POST + NP
      NTOTD_POST  = NTOTD_POST + ND
      NTOTT_POST  = NTOTT_POST + NT
      NTOTHE_POST = NTOTHE_POST + NHE
      NTOTA_POST  = NTOTA_POST + NALPHA
      NTOT6HE_POST  = NTOT6HE_POST + N6HE

      IF (AF.LT.2.5D0) GO TO 100

      TIME = TIME + TS1

      if (itest.eq.1) write(6,*) 'af,zf,ee',af,zf,ee,time,ts1,tau
      if (itest.eq.1) write(6,*) 'step:',step,time,ts1,tau

C Determination of x,y,z components of momentum from known emission momentum PC
C Changed according to DM - 2010
      IEV_TAB_SSC = IEV_TAB_SSC + 1
      EV_TAB_SSC(IEV_TAB_SSC,1) = ZMOINS
      EV_TAB_SSC(IEV_TAB_SSC,2) = AMOINS
      RNDT = DBLE(HAZ(1))
      CTET1 = 2.D0*RNDT-1.D0    ! z component: uniform probability between -1 and 1
      STET1 = DSQRT(1.D0-CTET1**2) ! component perpendicular to z
      RNDP = DBLE(HAZ(1))
      PHI1 = RNDP*2.D0*3.141592654D0 ! angle in x-y plane: uniform probability between 0 and 2*pi
      xcv =  STET1*DCOS(PHI1)   ! x component
      ycv =  STET1*DSIN(PHI1)   ! y component
      zcv =  CTET1              ! z component
C In the CM system
      IF(IDECAYMODE.NE.7) THEN
C Light particle
        ETOT_LP = DSQRT(PC**2 + AMOINS**2 * MU**2)
        EV_TAB_SSC(IEV_TAB_SSC,3) = C * PC * xcv / ETOT_LP
        EV_TAB_SSC(IEV_TAB_SSC,4) = C * PC * ycv / ETOT_LP
        EV_TAB_SSC(IEV_TAB_SSC,5) = C * PC * zcv / ETOT_LP
      else
C gamma ray
        EV_TAB_SSC(IEV_TAB_SSC,3) = PC * xcv
        EV_TAB_SSC(IEV_TAB_SSC,4) = PC * ycv
        EV_TAB_SSC(IEV_TAB_SSC,5) = PC * zcv
      endif
      CALL LORENTZ_BOOST(vx_eva,vy_eva,vz_eva,
     &     EV_TAB_SSC(iev_tab_ssc,3),EV_TAB_SSC(iev_tab_ssc,4),
     &     EV_TAB_SSC(iev_tab_ssc,5),
     &     VXOUT,VYOUT,VZOUT)
      ev_tab_ssc(iev_tab_ssc,3) = VXOUT
      ev_tab_ssc(iev_tab_ssc,4) = VYOUT
      ev_tab_ssc(iev_tab_ssc,5) = VZOUT
      IF(IDECAYMODE.NE.7)THEN
      v2 = EV_TAB_SSC(IEV_TAB_SSC,3)**2 +
     &     EV_TAB_SSC(IEV_TAB_SSC,4)**2 +
     &     EV_TAB_SSC(IEV_TAB_SSC,5)**2
      gamma = dsqrt(1.000d0 - v2 / (c*c))
      avvmass = amoins*mu
      etot_lp = avvmass / gamma
      PXEVA = PXEVA - EV_TAB_SSC(IEV_TAB_SSC,3) * etot_lp / c
      PYEVA = PYEVA - EV_TAB_SSC(IEV_TAB_SSC,4) * etot_lp / c
      PLEVA = PLEVA - EV_TAB_SSC(IEV_TAB_SSC,5) * etot_lp / c
      ELSE
      PXEVA = PXEVA - EV_TAB_SSC(IEV_TAB_SSC,3)
      PYEVA = PYEVA - EV_TAB_SSC(IEV_TAB_SSC,4)
      PLEVA = PLEVA - EV_TAB_SSC(IEV_TAB_SSC,5)
      ENDIF
C In the CM system
      if((pxeva*pxeva + pyeva*pyeva).lt.0.d0)then
       print*,'POSTSADDLE',idecaymode,pxeva,pyeva

      endif
      PTEVA = dsqrt(pxeva*pxeva + pyeva*pyeva)
C To be checked:
      etot = dsqrt ( pteva**2 + pleva**2 + AF**2 * mu**2 )
      vx_eva = c * pxeva / etot ! recoil velocity components of residue due to evaporation
      vy_eva = c * pyeva / etot
      vz_eva = c * pleva / etot

      if(TIME .LT. TAU) GOTO 10

 100  continue

      AFSCISS = AF
      ZFSCISS = ZF
      EESCISS = EE

      if(itest.eq.1) write(6,*)'af,zf,ee at sciss',af,zf,ee,time,tau
      if (itest.eq.1) write(6,*) ' '

      return
      end
C
C**********************************************************************
      SUBROUTINE FISSION_WIDTH(ZPRF,A,EE,BS,BK,EF,Y,GF,TEMP,
     &        JPR,IEROT,FF_ALLOWED,OPTCOL,OPTSHP,DENSG,TEMPCN)

C*** AK 2006 - Inclusion of low-energy fission following the procedure from
C              Gavron et al, PRC13 (1976) 2374 *****

      REAL*8 SIG, SIGSAD, MASS_ASYM_SADD_B, Z2OVERA,FDUMP,ENH_FACT,
     &       SIG_PAR_SP,DENSF,DENSG,ZPRF,A,DEFBET,SPDEF,ECOR,GF,BSHELL,
     &       BS,BK,EF,Y,FNORM,FP_PER,SIG_PER_SP,QR,EE,TEMP,FP_PAR,PI,
     &       SBFIS,DEFBETCN,BSHELLCN,TEMPCN,ECORCN,JPR,EROT,DEFKVIB,
     &       DKVIB,C_COEFF,D_COEFF,A_COEFF,ENH_FACTA,ENH_FACTB,
     &       COMM_FACT,FISSILITY,GFARG,TEMPTR,DTEMPTR,hbom,Ttrans,
     &       GFTUN,JFACT,EXP_FACT,CORR_FUNCT,ENH_FACT_MEM

      REAL*8 UCR,DCR,U,PONQ,DN,N,DZ,kvib_factor,SIG_PAR_GS,SIG_PER_GS
      integer distn, distz, ndist, zdist,i,IZ,IN,OPTAFAN,IEROT,
     &       narray,zarray,OPTCOL,OPTSHP,FF_ALLOWED,IFISSLOW,IREGCT,
     &       AT1,ZT1
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98)
      REAL*8 ALPHA(0:153,0:98),BETA2(0:250,0:136),
     &       BETA4(0:250,0:136)
      real*8 krot,m,r,teta_rb,f,teta_t,kvib,SIG2_GS,SIG2_SP
      REAL*8 AV,AS,AK,PA,PONFE,DEFBETSP,DEFBETEFF
      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4
      COMMON /ALD/ AV,AS,AK,OPTAFAN
      COMMON/REGCT/IREGCT
      COMMON /TARGET/ AT1,ZT1
C

       GF = 0.D0

       kvib_factor = 1.d0

       PI = 3.141592653D0

       IFISSLOW = 0

       IZ  = IDNINT(ZPRF)
       IN  = IDNINT(A - ZPRF)
        N  = DFLOAT(IN)

       DCR = 10.D0
       UCR = 30.D0

c       IF(DABS(BETA2(IN,IZ)).LE.0.150D0) THEN
c       DCR =  8.D0
c       UCR = 30.D0
c       ENDIF

       Z2OVERA = ZPRF * ZPRF / A

C Nuclei below Businaro-Gallone point do not go through fission
      IF ((ZPRF.LE.55.D0).OR.(FF_ALLOWED.EQ.0)) THEN
        GF = 0.D0
        TEMP = 0.5D0
        RETURN
      ENDIF

C Level density above SP
c      DEFBET = 1.58533D0*SPDEF(IZ+IN,IZ,1,0.D0,0.D0)
C Saddle-point deformation is defbet as above. But, FP_PER and FP_PAR
C are calculated for fission in DENSNIV acc to Myers and Hasse, and their
C parametrization is done as function of y
      CALL DENSNIV(A,ZPRF,EE,EF,DENSF,0.D0,BS,BK,TEMP,
     &             OPTSHP,0,Y,ECOR,JPR,1,QR)


      IF(OPTSHP. EQ. 0) THEN
         GF= DENSF/DENSG/PI/2.0D0*TEMP
         RETURN
      ENDIF


C !!! FP-PER and FP_PAR are parametrized as a function of fissility and not alpha2,
C see Hasse&Myers

C FP = 2/5*M0*R0**2/HBAR**2 * A**(5/3) * (1 + DEFBET/3)
C FP is used to calculate the spin-cutoff parameter SIG=FP*TEMP/hbar**2; hbar**2
c is, therefore, included in FP in order to avoid problems with large exponents
C The factor fnorm inlcudes then R0, M0 and hbar**2 -
c fnorm = R0*M0/hbar**2 = 1.2fm*931.49MeV/c**2 /(6.582122e-22 MeVs)**2 and is
c in units 1/MeV
      FNORM = (1.2D0)**2 * 931.49D0 * 1.D-2 / (9.D0 * 6.582122D0**2)
C FP_PER ~ 1+7*y/6, FP_PAR ~ 1-7*y/3 (Hasse & Myers, Geom. relat. macr. nucl. phys.)
C Perpendicular moment of inertia
      FP_PER = 2.D0/5.D0*A**(5.D0/3.D0)*FNORM
     &        *(1.D0 + 7.D0/6.D0*Y*(1.D0+1396.D0/255.D0*Y))

C AK - Jan 2011 - following line is needed, as for these nuclei it seems that
C FP_PER calculated according to above formula has too large values, leading to too
C large ENH_FACT
      IF(Z2OVERA.LE.30.D0) FP_PER = 6.5D0

C Parallel moment of inertia
      FP_PAR = 2.D0/5.D0*A**(5.D0/3.D0)*FNORM
     &        *(1.D0 - 7.D0/3.D0*Y*(1.D0-389.D0/255.D0*Y))
      IF(FP_PAR.LT.0.D0) FP_PAR = 0.D0

      EROT = JPR * JPR / (2.D0 * DSQRT(FP_PAR**2 + FP_PER**2))
      IF(IEROT .EQ. 1) EROT = 0.D0

C Perpendicular spin cut-off parameter
      SIG_PER_SP = DSQRT(FP_PER * TEMP)

      IF(SIG_PER_SP.LT.1.D0) SIG_PER_SP = 1.D0

C Parallel spin cut-off parameter
      SIG_PAR_SP = DSQRT(FP_PAR * TEMP)
      SIG2_SP = SIG_PAR_SP**2 + SIG_PER_SP**2

      ENH_FACT = 1.D0
C

        IF(A.GT.223.D0)THEN
         MASS_ASYM_SADD_B = 2.D0
          ELSE
         MASS_ASYM_SADD_B = 1.D0
        ENDIF

C actinides with low barriers
      IF(Z2OVERA.GT.35.D0.AND.Z2OVERA.LE.(110.D0**2/298.D0))THEN

C Barrier A is axial asymmetric
       ENH_FACTA = DSQRT(8.D0*PI) * SIG_PER_SP**2 * SIG_PAR_SP
C  SIG2_SP**1.5D0

C Barrier B is axial symmetric
      ENH_FACTB = MASS_ASYM_SADD_B * SIG_PER_SP**2
c     &            (DSQRT(SIG2_SP))**3/SIG_PAR_SP
c     &              * DEXP(-0.5D0*JPR*(JPR+1.D0)*
c     &              (-1.D0/SIG_PER_SP**2+1.D0/SIG2_SP))

C Total enhancement
      ENH_FACT = ENH_FACTA * ENH_FACTB / (ENH_FACTA + ENH_FACTB)


C nuclei with high fission barriers (only barrier B plays a role, axial symmetric)
      ELSEIF(Z2OVERA.LE.35.D0)THEN

      ENH_FACT = MASS_ASYM_SADD_B * SIG_PER_SP**2
c     &           * (DSQRT(SIG2_SP))**3/SIG_PAR_SP
c     &           * DEXP(-0.5D0*JPR*(JPR+1.D0)*
c     &             (-1.D0/SIG_PER_SP**2+1.D0/SIG2_SP))


C super-heavy nuclei  (only barrier A plays a role, axial asymmetric)
      ELSEIF(Z2OVERA.GT.(110.D0**2/298.D0))THEN
      ENH_FACT =  DSQRT(8.D0*PI) * SIG_PER_SP**2 * SIG_PAR_SP
C  SIG2_SP**1.5D0

      ENDIF

C Fading-out with excitation energy above the saddle point:
      PONFE = (ECOR-UCR-EROT)/DCR
      IF (PONFE.GT.700.D0) PONFE = 700.D0
C Fading-out according to Junghans:
      ENH_FACT_MEM = ENH_FACT
      ENH_FACT = 1.D0/(1.D0+DEXP(PONFE)) * ENH_FACT + 1.D0
c      print*, EE-EF,ENH_FACT_MEM,ENH_FACT
C Fading-out according to Ignatyuk:
c      ENH_FACT = (ENH_FACT-1.D0)*(0.5D0*(1.D0+DEXP(0.35D0*(-10.D0)))/
c     &     (1.D0+DEXP(0.35D0*(ECOR-EROT-10.D0)))+
c     &     0.5D0*(1.D0+DEXP(0.15D0*(-10.D0)))/
c     &     (1.D0+DEXP(0.15D0*(ECOR-EROT-10.D0)))) + 1.D0

      IF(ENH_FACT.LT.1.D0) ENH_FACT = 1.D0

      IF(OPTCOL.EQ.0) ENH_FACT = 1.D0

      GF= DENSF/DENSG/PI/2.0D0*TEMP*ENH_FACT

c      if(A.EQ.241.D0) write(159,160) EE,DENSF,DENSG,ENH_FACT,
c     &    ENH_FACT_MEM,TEMP
c  160 format(f12.5,x,2e20.10,x,3f12.5)

C Ak - Jan 2011 - Tunneling
      IF(EE.LE.(EF+1.D0))THEN
      CALL TUNNELLING(A,ZPRF,Y,EE,EF,TEMP,DENSG,DENSF,ENH_FACT,GFTUN)
      GF = GFTUN
      ENDIF



      RETURN
      END

C**********************************************************************
      SUBROUTINE TUNNELLING(A,ZPRF,Y,EE,EF,TEMP,DENSG,DENSF,ENH_FACT,
     &                      GFTUN)
C AK - Jan 2011 -Subroutine to caluclate fission width with included effects
c of tunnelling through the fission barrier
      REAL*8 A,ZPRF,Y,EE,EF,TEMP,DENSG,GFTUN,AP,BP,CP,FACT1,FACT2,FACT3
      REAL*8 PI,K1,MFCD,OMEGA,HOMEGA1,E1,E2,HOMEGA2,ENH_FACT,DENSF,E0,
     &       EXP_FACT, CORR_FUNCT
      INTEGER IZ, IN

      PI = 3.14159D0

      IZ = IDNINT(ZPRF)
      IN = IDNINT(A-ZPRF)

c For low energies system "sees" LD barrier
      CALL FOMEGA_SP(A,ZPRF,Y,K1,MFCD,OMEGA,HOMEGA1)
c       homega1= 1.d0
      IF(MOD(IN,2).EQ.0.AND.MOD(IZ,2).EQ.0)THEN    ! e-e
C Due to pairing gap, even-even nuclei cannot tunnel for excitation energy lower
C than pairing gap (no levels at which system can be)
      EE = EE - 12.D0/DSQRT(A)
      HOMEGA2 = 1.04D0
      ENDIF

      IF(MOD(IN,2).EQ.1.AND.MOD(IZ,2).EQ.1)THEN    ! o-o
      HOMEGA2 = 0.65D0
      ENDIF

      IF(MOD(IN,2).EQ.1.AND.MOD(IZ,2).EQ.0)THEN    ! o-e
      HOMEGA2 = 0.8D0
      ENDIF

      IF(MOD(IN,2).EQ.0.AND.MOD(IZ,2).EQ.1)THEN    ! e-0
      HOMEGA2 = 0.8D0
      ENDIF

c      HOMEGA2 = 0.9D0

      E1 = EF + HOMEGA1/2.D0/PI*
     &     DLOG(HOMEGA1*(2.D0*PI+HOMEGA2)/4.D0/PI/PI)

      E2 = EF + HOMEGA2/(2.D0*PI)*
     &     DLOG(1.D0+2.D0*PI/HOMEGA2)

C AKH May 2013 - Due to approximations in the analytical integration, at energies
C just above barrier Pf was to low, at energies below
C barrier it was somewhat higher. LInes below are supposed to correct for this.
C Factor 0.20 in EXP_FACT comes from the slope of the Pf(Eexc) (Gavron's data)
C around fission barrier.
      EXP_FACT = (EE-EF)/(HOMEGA2/(2.D0*PI))
      IF(EXP_FACT.GT.700.D0) EXP_FACT = 700.D0
      CORR_FUNCT = HOMEGA1 * (1.D0-1.D0/(1.D0+DEXP(EXP_FACT)))
      IF(MOD(IN,2).EQ.0.AND.MOD(IZ,2).EQ.0) THEN
      CORR_FUNCT = HOMEGA1 * (1.D0-1.D0/(1.D0+DEXP(EXP_FACT)))
      ENDIF

      FACT1 = HOMEGA1/(2.D0*PI*TEMP+HOMEGA1)
      FACT2 = (2.D0*PI/(2.D0*PI+HOMEGA2)-
     &        HOMEGA1*(2.D0*PI+HOMEGA2)/4.D0/PI/PI)/
     &        (E2-E1)
      FACT3 = HOMEGA2/(2.D0*PI*TEMP-HOMEGA2)

      IF(EE.LT.E1)THEN
      GFTUN = FACT1*(DEXP(EE/TEMP)*DEXP(2.D0*PI*(EE-EF)/HOMEGA1)
     &       -DEXP(-2.D0*PI*EF/HOMEGA1))

      ELSEIF(EE.GE.E1.AND.EE.LT.E2)THEN
      GFTUN = DEXP(EE/TEMP)*(0.5D0+FACT2*(EE-EF-TEMP))
     &       -DEXP(E1/TEMP)*(0.5D0+FACT2*(E1-EF-TEMP))
     &       +FACT1*(DEXP(E1/TEMP)*DEXP(2.D0*PI*(E1-EF)/HOMEGA1)
     &       -DEXP(-2.D0*PI*EF/HOMEGA1))

      ELSEIF(EE.GE.E2)THEN

      GFTUN = DEXP(EE/TEMP)*(1.D0+FACT3*
     &                            DEXP(-2.D0*PI*(EE-EF)/HOMEGA2))
     &       -DEXP(E2/TEMP)*(1.D0+FACT3*
     &                            DEXP(-2.D0*PI*(E2-EF)/HOMEGA2))
     &       +DEXP(E2/TEMP)*(0.5D0+FACT2*(E2-EF-TEMP))
     &       -DEXP(E1/TEMP)*(0.5D0+FACT2*(E1-EF-TEMP))
     &       +FACT1*(DEXP(E1/TEMP)*DEXP(2.D0*PI*(E1-EF)/HOMEGA1)
     &       -DEXP(-2.D0*PI*EF/HOMEGA1))

      ENDIF

c      if(A.EQ.241.D0) write(159,160) EE,GFTUN,DENSF,ENH_FACT,
c     &               DEXP(EE/TEMP),DENSG,TEMP
c  160 format(f12.5,x,5e20.10,x,f12.5)

      GFTUN = GFTUN / DEXP(EE/TEMP) * DENSF * ENH_FACT / DENSG /2.D0/PI

      GFTUN = GFTUN * CORR_FUNCT

      RETURN
      END
C
C**********************************************************************
C
      SUBROUTINE BSBK(A,Z,BS,BK)
C Calculate BS and BK needed for a level-density parameter:
C BETA2 and BETA4 = quadrupole and hexadecapole deformation
      INTEGER IN, IZ
      REAL*8 ALPHA2,ALPHA4,BS,BK,PI,A,Z
      REAL*8 ECGNZ(0:153,0:98),ECFNZ(0:153,0:98),VGSLD(0:153,0:98)
      REAL*8 BETA2(0:250,0:136),BETA4(0:250,0:136)
      COMMON /ECLD/ECGNZ,ECFNZ,VGSLD,BETA2,BETA4

      PI = 3.14159265D0
      IZ = IDNINT(Z)
      IN = IDNINT(A - Z)
C alphaN = sqrt(2*N/(4*pi))*BetaN
      ALPHA2 = DSQRT(5.D0/(4.D0*PI))*BETA2(IN,IZ)
      ALPHA4 = DSQRT(9.D0/(4.D0*PI))*BETA4(IN,IZ)

      BS = 1.D0 + 0.4D0*ALPHA2**2 - 4.D0/105.D0*ALPHA2**3 -
     &     66.D0/175.D0*ALPHA2**4 -
     &     4.D0/35.D0*ALPHA2**2*ALPHA4 + ALPHA4**2

      BK = 1.D0 + 0.4D0*ALPHA2**2 + 16.D0/105.D0*ALPHA2**3 -
     &     82.D0/175.D0*ALPHA2**4 +
     &     2.D0/35.D0*ALPHA2**2*ALPHA4 + ALPHA4**2

      RETURN
      END
C
C**************************************************************************
C
       SUBROUTINE UNBOUND(A,Z,EE,SN,SP,SD,ST,SHE,SA,S6HE,
     &              BP,BD,BT,BHE,BA,B6HE,
     &              PROBF,PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,PROB6HE,
     &              PROBIMF,PROBG,ECN,ECP,ECD,ECT,ECHE,ECA,EC6HE)

       REAL*8 A,Z,EE,SN,SP,SD,ST,SHE,SA,BP,BD,BT,BHE,BA,
     &        PROBF,PROBN,PROBP,PROBD,PROBT,PROBHE,PROBA,PROBIMF,
     &        PROBG,ECN,ECP,ECD,ECT,ECHE,ECA,E,SBP,SBD,SBT,SBHE,SBA,
     &        S6HE,B6HE,PROB6HE,EC6HE,SB6HE


      SBP = SP + BP
      SBD = SD + BD
      SBT = ST + BT
      SBHE = SHE + BHE
      SBA = SA + BA
      SB6HE = S6HE + B6HE

      E = DMIN1(SN,SBP,SBD,SBT,SBHE,SBA,SB6HE)
          IF (SN.EQ.E) THEN
          ECN = (-1.D0) * SN
          ECP = 0.D0
          ECD = 0.D0
          ECT = 0.D0
          ECHE = 0.D0
          ECA = 0.D0
          EC6HE = 0.D0
          PROBN = 1.D0
          PROBP = 0.D0
          PROBD = 0.D0
          PROBT = 0.D0
          PROBHE = 0.D0
          PROBA = 0.D0
          PROB6HE = 0.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ELSE IF (SBP.EQ.E) THEN
          ECP = (-1.D0)*SP + BP
          ECN = 0.D0
          ECD = 0.D0
          ECT = 0.D0
          ECHE = 0.D0
          ECA = 0.D0
          EC6HE = 0.D0
          PROBN = 0.D0
          PROBP = 1.D0
          PROBD = 0.D0
          PROBT = 0.D0
          PROBHE = 0.D0
          PROBA = 0.D0
          PROB6HE = 0.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ELSE IF (SBD.EQ.E) THEN
          ECD = (-1.D0)*SD + BD
          ECP = 0.D0
          ECN = 0.D0
          ECT = 0.D0
          ECHE = 0.D0
          ECA = 0.D0
          EC6HE = 0.D0
          PROBN = 0.D0
          PROBP = 0.D0
          PROBD = 1.D0
          PROBT = 0.D0
          PROBHE = 0.D0
          PROBA = 0.D0
          PROB6HE = 0.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ELSE IF (SBT.EQ.E) THEN
          ECT = (-1.D0)*ST + BT
          ECP = 0.D0
          ECD = 0.D0
          ECN = 0.D0
          ECHE = 0.D0
          ECA = 0.D0
          EC6HE = 0.D0
          PROBN = 0.D0
          PROBP = 0.D0
          PROBD = 0.D0
          PROBT = 1.D0
          PROBHE = 0.D0
          PROBA = 0.D0
          PROB6HE = 0.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ELSE IF (SBHE.EQ.E) THEN
          ECHE = (-1.D0)*SHE + BHE
          ECP = 0.D0
          ECD = 0.D0
          ECT = 0.D0
          ECN = 0.D0
          ECA = 0.D0
          EC6HE = 0.D0
          PROBN = 0.D0
          PROBP = 0.D0
          PROBD = 0.D0
          PROBT = 0.D0
          PROBHE = 1.D0
          PROBA = 0.D0
          PROB6HE = 0.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ELSE IF (SBA.EQ.E) THEN
          ECA = (-1.D0)*SA + BA
          ECP = 0.D0
          ECD = 0.D0
          ECT = 0.D0
          ECHE = 0.D0
          EC6HE = 0.D0
          ECN = 0.D0
          PROBN = 0.D0
          PROBP = 0.D0
          PROBD = 0.D0
          PROBT = 0.D0
          PROBHE = 0.D0
          PROB6HE = 0.D0
          PROBA = 1.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ELSE IF (SB6HE.EQ.E) THEN
          EC6HE = (-1.D0)*S6HE + B6HE
          ECP = 0.D0
          ECD = 0.D0
          ECT = 0.D0
          ECHE = 0.D0
          ECA = 0.D0
          ECN = 0.D0
          PROBN = 0.D0
          PROBP = 0.D0
          PROBD = 0.D0
          PROBT = 0.D0
          PROBHE = 0.D0
          PROB6HE = 1.D0
          PROBA = 0.D0
          PROBIMF = 0.D0
          PROBF = 0.D0
          PROBG = 0.D0
          ENDIF

       RETURN
       END


C**************************************************************************
