c ------------ prepared for S.Leray ; May 2008 --------------
c Mar 2008, FIAS. Correction in 'microcanon' Z/A ratios - low excitations:
c in CALCWE and CHOSZ: 8*G0 instead of 200. in COEFC(A). 
c ------------------------------
c Feb 2008, INR. smm_sp1_ens.for: SMM version for spallation calculations 
c (ALADIN type), made from the version of end 2007: smm_mc842_ens-6Dec.for. 
c Markov chain SMM and 2-nd source developments (not related to 'ALADIN' 
c calculations) are not included. 
c ------------------------------
c Nov 2007 GSI. Including TMUL for multifragmentation at fixed temperature 
c for fixed sources /BTMUL/ITMUL,TMUL (ITMUL=0 - usual - excit. energy) but 
c only for A0>16 and IMETR=0. Changings in ZVEZD1,FRAMIK,CALCWE,
c SCOMPA,FRAGTE,FRAG,FINDT. (However for A<17 - Fermi-break-up is usual.) 
c + Correction in CHOSZ - (increasing width of charge distribution with CP)
c + including detrmination of Be-Li temperature TEMBL0. 
c ---
c June 2007 GSI. Including smooth transition of liquid-drop parameters of 
c hot fragments B00, G00, W00 to multifragmentation region with excitation 
c energy of sources
c May 2007 GSI. New output for S254: HAZ5B...SZ2B - as in smm_mc7_enc.for
c + YAZT1...5 - isotope yields, FNZB1...5 - in different ranges of Zbound.
c ---
c Jan 2007 Mainz. Changing into EVANU2 --> EVAN22 to keep energy balance, 
c + keeping old FINDT for this evaporation.
c ---
c Nov 2006, FIAS. For checking W0 influence on multifragmentation: Adding W00 
c to /BGSYM/, changins W0=W00 in PARAM,METR2,METR4,MIC2,ELIDR,DELAM0.
c ------------------
c April 2006, GSI. Investigation of formal evolution of surface B00 and 
c symetry G00 coefficients in the Myers-Swiatecki formula with disintegration 
c into smaller fragments, with excitation energy: BEMS and GEMS. 
c ---
c June 2005, Bologna. small correct for MFRAG in ZVEMET. 
c --------------------------------------------------------------------
c--- June 2005 Konya. For the case ICOLE=-1 : change in DELAM --> ELIDR
c small correct. in ZVEMET: Including IP00 for accounting MFRAG.
c =====================================================================
c -- making writing (JWRITE=1) without extras (...US1...)
c -- Apr 2005 GSI. New flag IENS=1 - ensemble (RESNUC) calculation, 
c                           IENS=0 - fixed sources, as usually. 
c April 2005, GSI. Including ensemble from smm_mc6_ens_04: for new ALADIN. 
c Inclusion RESNUC in MAINMA. (RESNUC from smm_met7 of 25.11.00).
c as Oct 2004, GSI: Including neutrons(SNZB3) vs Zbou in the ensemble calcul.
c + for max.fragm. HISTMZ,HMAZZ,HMNZZ + in corr.with Zmax HIST1Z...H1AZZ...
c ---
c -- Mar 2005 GSI: change ZVEZD1, ZVEMET - includ.small number of neutrons 
c (<=2) in propagation with charged part., i.e. IP0=IP. Slightly influence 
c spectra of neutrons!
c -- Mar 2005, LNL. calculations for LNL proposal: production and break-up 
c of iron-like sources in central collisions. 
c -- Mar 2005, GSI. made from smm_mc61_iso of Feb.2005. 
c Including calculations for different surface energies B0  also 
c in Markov chain. Including B00 (=B0) in /BGSYM/.  
c -- Feb 2005, GSI. Calcul. for MSU source: (186,168-75) and others. 
c --
c -- Dec 2004, INR. Including EVANU3 (like EVANU2 but with mass changing 
c coupled with probab. of emission and kin.energy of eveporated particles 
c = exact energ.balance), at IEVP=3 ! Not finished !
c -- Oct 2004, GSI. Changing masses of evap.residues during second. deexcit:
c including EVANU1,EVANU2,DELAM0 instead of old EVANUC, see IEVP --
c -- Oct 2004, GSI. Calculations for K-H/Daniella for isoscaling.
c also: Add REAL LT for all /BLOK2/ !
c For isotope output: YZ10A,YZ20A,YZ30A(10,.); avr.charge & N/Z: HIAZZ,HINZZ;
c ***
c Mai 2004, GSI. including phenomenological internal limiting temperature  
c for fragments, for the secondary de-excitation. But this will violate the 
c total energy balance! ITLIM=0 - as usual (no limit. temp.) ; ITLIM=1 - 
c introducing TINLIM=... . Change only for multifragm. channels, not for 
c compound channel! /BTLIM/ITLIM,TINLIM ; in UEVA: U= (A/8)*Tinlim^2 ! 
c ***
c Apr 2004, GSI. Calculations for iso-Arno paper.
c --------------------------------------------------------------
c Apr. 2004, GSI : from the last version smm_mc510.for from TAMU. 
c ====================================================
c *** Feb 2004, TAMU : inclusion of cold masses with shells in microcan.
c  multifragm. - in Metr2,4+Mic2 at ILIDR=-1 ! Change also DELAM (+WEIGHM...) 
c ---
c *** 6 Feb 2004, TAMU : correction in EVANUC, including IMULF=0. 
c *** 30 Jan 2004, TAMU : important correction for calcul.excit.energy at 
c high T (may happen when epsil_0 is very large, in FINDT,UEVA,WEIGHM,WEMIC2,
c WCMIC2,UEMIC2):  BTTDBT=BT2-T*DBT2-B0=0 at T>=Tc! 
c ---
c Jan 2004 TAMU. New normalization for break-up into 2 fragments MIC2 case: 
c to max shift of cm of two touching spherical nuclei. \delat/r_nucl =
c ((A_0-A_max)^{1/3}+A_max^{1/3})*(A_max/A_0)-A_max^{1/3} , which happens 
c at A_max=0.900*A_0  (checked numerically for whole A-range of nuclei) !!!
c Change (CULNOR) in MIC2, PLMIC2, WCMIC2. 
c ---
c Jan 2004 TAMU. Changings in METR4/ZVEMET to avoid initialization problem -
c if initial SNEW,TNEW=0 (introd. NINIT + replac. A0F...)
c ---
c Jan 2004 TAMU. For case of the break-up of the 1-st source in the Coulomb 
c proximity of the 2-nd one ('double system'), moving with some relative 
c velocity: taking into account an angular momentum 'occured' because of 
c shifting cm coordinates of the the both systems at random fragment position 
c generation - since ang.momentum conserv. in the double system must be kept! 
c This rotation is allowed along both X-axis (as usual) and Z-axis. 
c IRWT=1 - included ; IRWT=0 - not included, as usual. 
c Changings in DISN02,POSMET,WEIGHM,PLACM...U,CULI02,POMIC2,PLMIC2; 
c New subr.: OCCUM,SHIF2S,OCCU2,VVOCCU.
c ---
c Introducing the label: ISECS=0 - without second source Coulomb influence.
c ISECS=1 - introd. 2-nd s. influence (as it was done earlier with RYSEC)
c ISECS=2 - introd. 2-nd s. with possib. correl. shift cm of 2-nd s. also.
c --------------------------------------------------------------------------
c Jan 2004 TAMU. For evaporation at proximity ! EVANCR,EVATCR:
c Decreasing a number of "call rndm" at calculation of space positions 
c (in order to increase statistics and avoid the rndm period problem): 
c CANG(3,80) - 80 angles (the same for all evapor. particles) at each step 
c of evapor. cascade - changes in EVANCR,COLBCR,EVATCR,COLTCR. 
c -------------------------------
c Sept 2003 TAMU. in EVATCR:
c *** /TAMU01/LMTAMU - for evaporation of fixed particle (LM=LMTAMU) in the 
c first act of evaporation (LMTAMU=0 - as usual, without preference).
c --------------------------------------------------------------------------
c -- Dec 03 TAMU: Correction DISN02, DISNE0 at IAMOM>0 - right signs for rotat.
c veloc. (+VZ,-VY) - rotation (angular momentum) is assumed along X axis. 
c --
c Dec. 2003: SMM_MC5.for (made from smm_mc4.for of 13 Nov.)
c Includ. break-up only into two fragements (M=2): at IMIC2.ge.1 - call subr. 
c ZMIC2(), MIC2(), POMIC2(), UEMIC2(). 
c To fit other options it should be also IMULF=1 (&IMECH=4 for EVAHOT) 
c For better calculation of Coulomb interaction in case of direct 
c positioning of fragments inside freeze-out: touching spheres approx. ! 
c As expected, important in the case of the second source Coulomb influence 
c at small excit. energies ! new selection subr. - DISNU2().
c "Radius" of nucleon RNCL for touching nuclei taken from Viola systematics 
c for fission for channels with A1>4 (min=1.5), and =1.5 for A1.le.4. 
c Important: Corresponding shifting the center of mass of the second source 
c in order to preserve center of mass conservation in the double system!
c -------
c Nov. 2003: Coulomb influence ICOLE.ge.0 - as usual, ICOLE=-1 - excluding 
c Coulomb from binding energies and no Coulomb barrier. However symmetry 
c term is as usual ! It must be ILIDR=1 if Markov is on!
c Direct including A<5 in ELIDR as 'gas' particles with table masses. 
c ------------
c Nov 2003: New calculations for very big systems (U+U), special interest 
c - big fragments Z>20 (SMBIG,MCOR). Improved print output. Isotopes: 
c AZ22()... . Writing events to /home/jbngroup/jbngroup/data/smm2/. 
c -----------------------------------------------------------------------
c Oct. 2003: Calculations for A=36, Z=16 system, in periph. collisions; 
c (kc=2, iperi=1, Markov with W-S); for 'criticality' in small systems, 
c add.output: momenta distrib., M3 vs M2 for tau param. ...
c Oct.26. JWRJBN=1: to smmdata_jbn: mc36_16_e..dat, for e=2-10MeV/n.
c ---
c Sept. 2003: Change and increase of array /BLIAZN/ (up to 50000) in CHAZ0 !
c Important: Includ in ZVEMET: /BIZVE0/ IZVEM=1 - initial 'fission' partition 
c 'for large angular momenta'; IZVEC=1 - initial compound ! IZVEM,C=0 - 
c usual init.partition - via grand canon.! Changings consistent with this: 
c Correction of arrays filling in FRAMIK: limit 25000 at M=3 ! + excluding 
c FRAMIK from ZVEMET: IMA=0 for Markov ! + determ PKP013 in FINDT ! + 
c determ E11 + call PARAM in ZVEMET for IZVEM,C=1. 
c ---
c ## 19 Sept 2003 TAMU. SMM_MC1 produced from smm_met9m.for of 18 Sept 03 ##
c for calculations of very big nucl.systems (like U+U). ** Idea: in semi-
c periph. collisions of 10-20MeV/n may be produced very big nuclei! As 
c interplay of Coulomb and angular momentum ** 
c ======================================================================
c Calculations for J.Natowitz, for comparizon with AMD: 64-Zn...
c -----
c Sept 2003 TAMU. Includ.in DCR add.output for 4He and 1H (instead of IMF).
c -----
c Sept 2003 TAMU. Test of Coulomb propagation in case of fast second source: 
c veloc.transfor.into cms of the two sources before Coulomb trajec., and back 
c after Coulomb; Change in CULI02: see 'veloc. recalcul', Nonrelativistic! 
c ** Conclusion: no effect what system is !!! ==> Coulomb traject. correct! 
c -----------------------
c Sept. 2003 TAMU! Important correction: in ZVEZD1, ZVEMET, CULIM0 and CULI02 
c after call DISN02 , add ECOR02 - which scale hot fragment velocities to 
c energy conservation (the conservation may be violated after superposition 
c of thermal and rotational/flow velocities!)
c ----------------------------
c Calc. for S.Yenello: break-up of 20F,Ne,Na in the proximity of 2nd source:
c cold fragments+table masses: EPSIL0=99999, ILIDR=0, IEX=1
c ----------------------------
c Aug. 2003, TAMU. 
c Calculations for S.Yenello: A0=116, Z0=52,54,56. for 'Neutron enrichment'.
c 'Central collisiona sources' at 30,40,47MeV/n. 
c Write Isotope yields for Z=1-8 in file on unit 57 ! see JWRIZ=1 
c =====================================================================
c =====================================================================
c 5 July. Changing Coulomb propag.in EVATCR: moving CTRAJ after finding TAUN.
c !!! Coulomb trajectories during TAUN before evaporation of particle !!!
c introduc. max life-time for evapor. 10000000 fm/c to avoid numerical crash.
c last calculations:
c 10 July /data/k1/botvina/o1/t38_ev_e2..4_r10(/40).cad30i - 20000 events:
c 90-38, evapor.@2S IMULF=0 I2S=1, 2..4 MeV/n, EVATCR, ang.mom. 10/40 h-bar, 
c sec.s.- 40-20 at 30 fm ! Traject "sadl-scis". + ITAUR=1: times, coordin.
c ---------------------------------------------------------------------
c 2 July: add.writing (ITAUR=1) of decay times, TAUN, TAU (STAUR(1-3,))
c and coordin. of evapor. (STAUR(4-6,)) & 1S-resid. fragments (STAUR(7-9,)) 
c at break-up: in EVATCR: /BTAUR/ITAUR... . Event by event to a datafile.
c ---------------------------------------------------------------------
c 29 May: including Coulomb trajectories: subr. EVATCR during the particle 
c evaporation, + taking into account the second source Coulomb (ISCUL=1). 
c CHANGINGS: add COLTCR: RN=RADNCL and positions in XYZ...,
c in EVATCR: new structure - momenta, subr. CTRAJ.
c ## Nonrelativistic transform.: PINT0,TINP0,CLPV0 for EVATCR case, RNCL=1.5 !
c =================================================================
c 28 May: including recoil effect in EVANCR, i.e. I2SRC=1! But with 
c 'recalculations of momenta' of emitted particles into the frame of 
c biggest residue: in EVANCR (see after 11 CONTINUE ). 
c -----------------------------------------------------------------------
c *** correction of version EVANCR and ROTECR into 'without recoil' case: 
c no energy transfer to AFJ! i.e. I2SRC=0.
c To fit experimental energy determination which uses residue at rest. 
c ---------------- May 23-25, test for slopes of spectra: ----------------
c +++ incerting random RN in COLBCR: influnce external Coulomb and angular 
c momentum effect (but no changing Coulomb RADNCL). FOUND: No big influnce! 
c *** Conclusion: slopes of energy spectra of emitted particles does not 
c change if take randomly RADNCL !!! Return to the old fixed case !!! ***
c ------------------------------------------------------------------------
c *-- May 2003, IUCF . smm_met9m2 made from smm_met8m29 of May 16. 
c Extension of EVANCR by limitimg widths in GAMCR1: I2SLW=1. Idea: time of 
c fragment separation from residue should be smaller than 'emission time' 
c (used in calculations with angular momentum, at IROT=1)
c ---------------------------------------------
c *** version with EVANCR without momentum recalculation after evaporation 
c of particles , see 'without recoil' !! 
c ---------------------------------------------------------------
c May 2003, IUCF - problem of 'limited rundom numbers' is recognized: 
c changings in starting (seed) numbers change nothing! Only ~20000 events. 
c can be calculated for sure (since random integration over coordinate 
c space at calculating weights increases turn to RNDM by 2 orders!)
c ****************************************************************
c April 2003 IUCF :  SMM_MET8m2.for = SMM_MET8n22.for  of 17 Apr 2003
c Add EVANCR - new evaporation including second source Coulomb !
c  === ************* ==================================================
c April 2003 IUCF :  SMM_MET8n3.for = SMM_MET8p3.for  of 31 March 2003
c In WEIGHM - mom.inertia BMEM of compound as for [(A0-1)+1]~ (R_A0+RN)**2 
c            // New calculations for LASSA //
c ----------------------------------------------
c March 31, 2003 IUCF: Important: there is no internal excitation in 4He, in  
c microcanon. cases - subroutines WEIGHM, CALCWE, UEVA,(+ FINDT, FIXT). 
c At final propagation of charged fragments the thermal translational motion 
c is taken as (M-1)*T instead of M*T - subroutines CULIM0, CULI02 !
c Cheeking in METR4 (by IME7) - PLAROT - rotation of all fragments in 
c freeze-out volume (instead of PLACT). However, this version PLAROT has 
c uncertainty, and doesnot change result essentially. Again excluded ! 
c For W-S placement CULSEC=0. Cheeking WEIGHT with -CULSEC/T : not better 
c since strong dependence on T-fluctuations. New CULSEC in ALL subroutines 
c of placement - PLACes (PLACM,C1,C2,C0,CU,CT,PLAROT) with relation to the 
c compound in the "end of the volume": in microcanics it is taken as part of 
c total excit.energy associated with positioning! 
c ---------------------------------------------- 
c SMM_MET8p1.for ; IUCF March 2003. made from smm_met8i1.for 
c Calculations for R.T.de Souza /Lassa/ experiment:
c 114-48 (50 Mev/nucleons) + 92-42 !
c Evaluate subr.: CLASSA (and ...0,P)
c Calculations , writing to /users/odie/botvina/.../data/k1/botvina/
c !!! output in the syst.of project.source (s.veloc. are not import.)!!!
c ========================================================================
c SMM_MET8I.for ; GSI Sept. 2002 - new calculations for INDRA.
c 18 Oct.2002 - calcul. for influence of angul.momenta and Coulomb on 
c charge distrib. and on relative velocities: Subr. CINDR
c --- write calcul. to directry: /d/kp3/nob/s185/smm2au/ 
c                 for Au+Au peripheral collisions. For details 
c see comments in smm_met8i1.for : 7 Nov 02 -- 24 Feb 03 .
c ========================================================================
c -----------------------------------------
c ### GSI, March 2002, SMM_MET8 - from smm_traut (smm_met7) .
c Calculations with deformed source: standard and markov.
c Long.& transverse directions (Cos(Theta)=+-0.5): NUMZL,T(), EKZL,T().
c Add CELZV1, Correct.in PLACE: for deformation - incl.CCCL=1/sqrt(CELZV1).
c 
c---------------------------------------
c ### GSI, July 2001. Including a variable ("density-dependent") symmetry 
c term in binding energy G0. See G00 /BGSYM/, changings in subr. PARAM, 
c CHOSZ, SELECZ, METR2, METR4, ELIDR !
c -------- GSI, June 2001 : calcul.for Trautmann isotope project. -------
c ## April 2001, IUCF: Including possibility writing hot fragments (without 
c secondary deexcitation) into SPT array. /BLIEX/IEX, IEX=0 - as usual with 
c second. deexcitation, IEX=1 - without second.deexcitation! Changings are 
c in subr. EVANUC and RAZVAL: immediate exit, intern.excit.energ: SPT(2,..)
c ## Arpril 2001, IUCF: adds to DLPC (..RELZ..) for LASSA analysis
c ## APRIL 2001, IUCF: subr. CLPC - cold fragment's "fission" analysis 
c similar to DLPC (made for hot fragments).
c ----- cutting PLACT in METR4 -----
c ## May 2001, GSI: inclusion of quantum statistics in determination of 
c weights (WEIGHM) for particles A=1-3. Other fragm. - Boltzmanns, See IQUAN
c -------------------------------------------------------------------- ##
c ## March 2001, GSI. "Diffusion" process of fragment repositioning is 
c added to the Markov part, corresponds to evolution from "saddle" to 
c "scission" point. New subr.- DIFUS and PLACY. Param.: diffus.time TAU - 
c (in subr.DIFUS), should be important in case of the second source. 
c Sign: IDIFUS=1. In ZVEMET, CULIM0, CULI02: changing of coordinates and 
c Coulomb energy + a change in thermal energy of motion (but not temperature). 
c ! In METR4 - the new final calculations of ECOLB (without second source)!
c In CULI02 - recalculation of Coulomb energy (for second source) + taking 
c into account IDIFUS. 
c -------------------------------------------------------------------- ##
c ##### March 2001, GSI. New weight formula for microcan.translational 
c motion: (1+W_old)/N_i! in WEIGHM (+ CALCWE, FIXT). 
c New notations for ITRAN: =0 - old (not limited, "grand canonical") case. 
c ITRAN=1 - new case S=ln(1+exp(S)). + attention: 
c N_i! introduced globally, not attributed only to the translat.weight. #####
c -----------------------------------------------------------------------
c ** New adds made in GSI 2000.
c --- 10 Oct. Writing in FILE1,3,5,7 cold fragments' characteristics :
c version SMM_MET7_V.
c - 11 Oct. Try to avoid RAZVAL at MILAZ=1 : see in EVANUC (after DO 20...). 
c Only EVANUC as second.deexcit. See infl. on N/Z of cold fragments. CANCELED!
c !!! *** 22 Oct. WEIGHM , FIXT : change PRA32 and PRGA into log values -
c otherwise there is overflow mistake at large multiplicities *** !!!
c - 8 Nov. Writing to units 53,54 for two-sources calcul.: JWRIT2=1
c Extension of writing for cold fragm.: p,d,t,3He,4He,Li,Be,B,C - VYZ1A1,
c VYZ1A2,...,VYZ6 in subroutines CDC... . And write it to units 55,56
c --- 27 Nov.2000. Problem of the fragments' charge-charge correlation: 
c equal size fragments ? Only Z of IMF is accounted. YCOR - charge correlat 
c in separate events, YMIX - "mixed" over all events. See subr. CHACO (B,E)
c ! N.B.: A Very effective way to get "mixed" correlations is to take 
c production of single yields: Y_mix(Z1,Z2)=Y(Z1)*Y(Z2) !!!  Checked!
c ** New adds in GSI 2001.
c --- 2 Jan. 2001. for work with P.Milazzo: calculations for ~Au+Au sources
c ** Increasing of arrays in /BDMR0/ to 200 (DMR subr.), /B1/ to 200 (DCR, 
c DLYN, DLPC, D1LPC, D3LPC subr.) since sum # charg.part. can be >100.
c ! Commented HOTFR6 - there are sizes of arrays too small for Au+Au !
c ** Increasing of arrays in /BLIAZN/ to 20000 (CHAZ subr. for METR4 !)
c --- 11 Jan. 2001. /BLFLY/FLY - share of the total flow along Y-axis (for
c calcul.of midrapid. emiss.in periph. collisions). Inclusion as for FLZ.
c ===========  9 Feb. 2001. condition on free volume VF: ============
c -- /BLIKAP/IKAPPA=1: free volume VF - constant (see FKAPPA) --
c -- IKAPPA=0: free volume VF - standard, multiplicity-dependent --
c *** 12 Feb. Additional write of hot fragments in events: accumul.: HOTFDA 
c in ZVEZD1 and ZVEMET (includ.as FIXT/HOFPC), write from: /BLHFD1/...HFD... 
c in MAINMA (add to normal cold fragm. on unit 59 if JWRIDA=1).
c *** 19 Feb.2001 GSI.    !! Spherical symmetry factor  - ..SYM1.. !! 
c if ISYM1=0 - as usual (no symmetry factor), ISYM1=1 - inclusion to WEIGHM !
c /BLSYM1/ISYM1,SSYM1 (SSYM1- add to entropy, i.e. to probability of partit.)
c Add IWIGSE (as a criterium for fragm.coordinate's involvement) to WEIGHM.
c --- 20 Feb.2001 GSI.    !! Angular momentum symmetry factor - ..SYM2.. !!
c ISYM2=0 - as usual (no symmetry factor), ISYM2=1 - inclusion to WEIGHM !
c /BLSYM2/ISYM2,SSYM2 (SSYM2- add to entropy, i.e. to probability of partit.)
c --- 21 Feb.2001 GSI. !! Rotational symmetry along Y-axis - ..SYM3.. !!
c Applic.: e.g. in case of Second source Coulomb influence on fragmentation. 
c ISYM3=0 - no symmetry, ISYM3=1 - inclusion to WEIGHM !
c /BLSYM3/ISYM3,SSYM3 (SSYM3- add to entropy, i.e. to probability of partit.)
c =======================================================================
c -----------------------------------------------------------------------
c This code is developed by A.S.Botvina. Below comments provide details.
c ----------------------------------------------------------------
c *** SMM_MET7 made from SMM_MET6 (version 22 May) in GANIL, July 2000 ***
c Inclusions: 
c 1) for deformed source in the second source presence: change
c in PLACM,...,PLACU (+DSPR) - "circle" perestanovka coordinates: CELMET give 
c along. in Z-axis but it should be Y (second source axis). As was done for 
c LPC. + correct. PLAC2,PLAC0: deform.case - if "fusion" fragments inside.
c See /BIDEFS/ IDEFS =0: as usual; =1: "circle" works.
c 2) Fix limitation of translational entropy STRAN at partition calculations:
c See CALCWE, WEIGHM (FIXT) - /BSTRAN/ITRAN: itran=0 - STRAN.ge.0 usual 
c (physical) case; itran=1 - no limit i.e. could be STRAN<0. !v.vers.-later!
c 3) Correction of secondary deexcit. made similar to Milazzo PRC [smm_ba2], 
c       it is included by the label /BMILAZ/ MILAZ =1 (=0 - usual!)
c    (a)  RAZVAL - subroutines (see ILEVRA=3)
c    (b)  EVAHOT: immediate exit at MILAZ=1 (but no others corrections 
c  implemented from SMM_BA... !)  + possible the same exit for IMECH=4. 
c    (c) GAM(35) factors in EVA... - subroutines: new GAM3()
c    (d) change EVANUC: "exit" for RAZVAL during evaporation, see IEVAR
c    (e) correct. ZVEZD1, ZVEMET accounting new EVANUC with "exit".
c ------------------------------------------------------
c *******  SMM_MET6 made from SMM_MET5 in GANIL, March 2000. *******
c -- 14.03.00 new checks with second source for LPC ! new subr. DLPC...,
c -- D1LPC..., D3LPC... - analysis of "fission-like" events. --
c -- 15.03.00 including exact angular momemtum conserv.in metropol. AMEM in 
c h-bars, rotation along X-axis, see /BLMEAM/IMEM,... in POSMET,WEIGHM,ZVEMET
c IMEM=0 - no angular mom.influence on partitions, (but IAMOM=1 infl. veloc.)
c IMEM=1 - influence partitions (only), IMEM>1 influence partit.+velocities
c -- 20.03.00 correct. DCR... : PRYIMF, PYV... - for N/Z ratio of fragments.
c ------------------------------------------------------
c * 6-APR: written 50000 to indra43:[.. .MC]MCV13_83_50_v25_m10 (198-83, 5Mev/,
c sigar, celmet=1.2, kc=1.5, xrno=0.75, iperi=0, ang.mom:100h-bar)
c * MAY: calculations for big paper on MC_SMM
c 14 May incl. PMUL(),PSDIS() for statistics.
c 15 May: change CALCWE, CHOSZ to calcul. aver.charge accord.to Grand-canon.
c 15 May: inclusion FRZ,2 in ZVEMET; jwritd on unit 51,52 hot frag + hisa,z .
c -- 19-MAY: for inlucsion of nonisotropic flow FLZ correct. in POS0,POSMET
c 20 May: new output for cold fragm: CDCR + also /bdcr/... for lab.veloc.
c ******************************************************
c ---- GANIL correct. SMM_MET5 (+see also calcul. for J-P Wiel.)  -----
c Jan 2000, GANIL . inclusion SDIS, ASDIS
c Feb 2000, GANIL. METR4 for calculation of small volumes: RN=XRNO*RADNCL 
c (small overlapping of fragments, they are excited and could be deformed)
c -- FEB 2000 (Ganil). modernization: 1) DISNE2 + DISN02 (with FLZ- possible 
c assym.flow) instead of DISNET + DISNE0; 2) new SELECA (SELECA_P - poissons);
c For checking form of the freez-out (sphere, ellipsoid) - momenta of 
c fragemnts (angular dependence) after Coulomb propagation. see .SPEC2 .
c (Possible rotation of coord.system - ROTO2.)
c -- correction in PLAC0! +in all metrop. PLAC...  JTRY/KK are increased --
c March 2000, GANIL. Incl. HOFPC: fragm.-light-charg.part.(LCP) correlations.
c -- in METR2,4: liquid-drop mass formula (as in grand.canon.) ILIDR=1 (or 0)
c -- 6.03.00 check: in metrop PLAC1,2,0 without PLACM !
c -- 12.03.00 add print: DSPR (with SPR() in POSMET) for cheking fragm.coord.
c ******************************************************
c -- Apr.99, Bologna. Adding IWIGSF... (Wigner-Seitz approx.for Coulomb) 
c -- to METR2 (as it was already in METR4). 
c -- May 99, Bo. Adding /BLKFRZ/FRZ(),FRZ2() to ZVEZD1 to have charges and 
c -- charge variances of hot fragments. +(see new or conc.with smmc4_g)SELECA.
c -- + corr. (IP-1) in FINDT and its inclusion (with FIXT) for statistics in 
c -- compound in ZVEZD1.
c -------- 
c ** SMM_MET5 made from smm_met4 by adding the advan. metropolis pass METR4 
c which exactly restore all partitions in A,Z-space by passing with weight=1.
c March, 1999, Bologna.
c --------
c ** SMM_MET4 made from smm_met3 by adding newest metropolis pass METR2 
c which exactly restore all partitions in A-space by passing with weight=1.
c --------
c ** SMM_MET3 made from SMM_MET2.for by
c approx. treatment of the second source: influence on positions and 
c Coulomb trajectories. Bo. Feb. 99. (RXSEC,...,IZSEC,...; ISCUL: CULI02)
c Possible change of freezout volume: prolate or oblate spheroid (ellipsoid), 
c see /BLMETC/CEL, CCCL - approximate treatment for qualitative estimation!
c --------
c ** SMM_MET2 made from smm_met1 by improving metropolis selection (what it 
c must be in fact: including former states) and adding the possibility to 
c restrict a metrop.pass--break-up/exchange only by nucleons (LNUCL) + 
c switch-off/on some pass channels (IME...)
c There is a possibility of metropolis for cold fragments: epsil0=99999.
c For constant transl.volume see: calcwe,fragte,(fixt),weighm.
c Jan.99 Bologna.
c --------
c ** SMM_MET1 made from smm_met by changing PLACM and PLACT into ones with 
c odering (biggest-smallest fragment, see IAM) placing in the volume,
c + including charge-exchange + absorption-emission of nucleons in METROP.
c Dec. 98, Bologna.
c --------
c ** SMM_MET made for metropolis, see METROP.for ... and ZVEMET.for ...**
c Dec. 98, Bologna.
c ----------------------------------------------------
c this version of SMM prepared for NATO project. Feb.98, Bologna.
c Made from the version of SMMAL7.for (last correct. Jan.98, NBI)
c Without preequilibrium parts but with flow and rotation.
c (The version ;9 of 5 March was used for finding connection between proton 
c and neutron energies.)
c-----------------------------------------------------
      subroutine smm_botvina(ia0,iz0,etot,pxrem,pyrem,pzrem,KST1,tpr0,
     &ifis)
      REAL*4 acv,zpcv,pcv,xcv,ycv,zcv
      COMMON/volant/acv(300),zpcv(300),pcv(300),xcv(300),
     s              ycv(300),zcv(300),iv
   
      COMMON /BLFLOW/AAA,EFLOW,IFLOW /BLAMOM/ANMOM,EMOM,IAMOM 
      COMMON /BLPARA/EPSIL0,FKAPPA,FKACOL /BLIKAP/IKAPPA
      COMMON /BPERI/IPERI /BLIDR/ILIDR /BLXRNO/XRNO
      COMMON /BLMETC/CELMET /BLSCUL/ISCUL
      COMMON /BLSECS/IASEC,IZSEC,RXSEC,RYSEC,RZSEC,CULSEC
      COMMON /BVSECS/VXSEC,VYSEC,VZSEC,ISECS
      COMMON /BLMEAM/AMEM,BMEM,EMEM,WMEM,IMEM
      COMMON /BWRITD/JWRITD
      COMMON /BWRJBN/JWRJBN
      COMMON /BDCR/VCMSP,VCMST
      COMMON /BIDEFS/IDEFS
      COMMON /BSTRAN/ITRAN
      COMMON /BMILAZ/MILAZ
      COMMON /BWIGSE/IWIGSE /BLMECH/IMECH /BLMULF/IMULF /BIMETR/IMETR
      COMMON /BWRIT2/JWRIT2
      COMMON /BLFLY/FLY /BLSYM1/SSYM1,ISYM1
      COMMON /BLSYM2/SSYM2,ISYM2 /BLSYM3/SSYM3,ISYM3 
      COMMON /BDIFUS/EDIFUS,IDIFUS /BLIEX/IEX
      COMMON /BQUAN/IQUAN
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00
      COMMON /CELIPS/CELZV1,IPOSF1 /BLFLZ/FLZ 
      COMMON /B2CR1/V2S0,R2S0,R2S,A2S,Z2S,I2S
      COMMON /B2CR6/I2SLW,I2SRC,CTIME
      COMMON /TAMU01/LMTAMU
      COMMON /BIZVE0/IZVEM,IZVEC
      COMMON /BICOLE/ICOLE /BIMIC2/IMIC2
      COMMON /MIC2B8/AMRWX,AMRWY,AMRWZ,AMRW0X,AMRW0Y,AMRW0Z,IRWT
      COMMON /BTLIM/TINLIM,ITLIM
      COMMON /BLEVP/IEVP
      COMMON /BLENS/IENS
      COMMON /BTMUL/TMUL,ITMUL 
      common /smmfrg/ nsmmfr
      integer nsmmfr
      nsmmfr=0
c --------------------------------------------
c      DO 110 IITT=1,10
      DO 110 IITT=1,1
c *********** one can change main INPUT parameters: ***************
c   main INPUT:
c   kinetic energy of the source in GeV/N  (used only for recalculation of 
c   velocities of produced fragments from the source system to lab. system)
      TPR0=tpr0/1000.
c   mass number and charge of the source : IA0,IZ0
c      IA0=197
c      IZ0=79
c calculations for ensemble of nuclei (RESNUC) IENS=1, or for
c fixed sources (as usual) IENS=0. 
c For ensemble parameters see RESNUC. 
      IENS=0
c If multifragmentation channels open IMULF=1 or not IMULF=0
c (only evaporation allowed from compound in the last case).
      IMULF=1
c -- Volume parameter FKACOL (V_total=(1+FKACOL)*V_0)
      FKACOL=2.
c total excitation energy (GeV/N) per nucleon : ETOT, in the case IENS=0.
c But in the case ensemble calculations IENS=1, take ETOT=0. 
c      ETOT=0.005
c   number of events : ITNUM
      ITNUM=1
c possible changing masses of nuclei during secondary deexcitation EVANUC:
c IEVP=1 - EVANU1 - old EVANUC (as usual).  IEVP=2 - EVANU2 - l.d.masses for
c evap. residues with transition to nuclei with shells (tables) at E*-->0.
      IEVP=1
c ********** do NOT change parameters below: *********************
c ---- MSU source ----
c      IA0=186
c      IA0=168
c      IZ0=75
c --------------------
c ALADIN new Sources
c      IA0=197
c      IZ0=79
c      IA0=107
c      IZ0=50
c      IA0=124
c      IZ0=50
c      IA0=124
c      IZ0=57
c --- calculations with fixed temperature TMUL (in ZVEZD1 version) for 
c fixed sources: ITMUL=1; or as usual with fixed excit. energy: ITMUL=0.
      ITMUL=0
      TMUL=8. 
c calculations for ensemble of nuclei (RESNUC) IENS=1, or for 
c fixed sources (as usual) IENS=0
      IF(ITMUL.EQ.1) IENS=0
c -------------------------------------------------------
c phenomelog. including internal limiting temperature TINLIM (MeV) for second. 
c deexcitation, ITLIM=0 - no including, as usual ; ITLIM=1 - including. 
      ITLIM=0
      TINLIM=5.
c no Coulomb in bind.energy + no C-barrier: ICOLE=-1 ! ICOLE.ge.0 -as usual
c      ICOLE=-1
      ICOLE=0
c If the Markov-Metropolis version (IMETR=1) or old ZVEZD1 (IMETR=0) used
      IMETR=0
c the version of Markov used: one component (A-space, METR2) IMECH=2, or two 
c component (A,Z-space, METR4) IMECH=4.
      IMECH=4
c for break-up only into two fragments IMIC2=1 or 2 (IMIC2=0 - as usual !)
c at IMEM=2: IMIC2=1 - no internal rotation of fragments, only orbital
c            IMIC2=2 - internal + orbital rotaion
      IMIC2=0
      IF(IMULF.EQ.0) IMIC2=0
c --------------------------------------------------------
c -- Volume parameter FKACOL (V_total=(1+FKACOL)*V_0)
c -- See changing or not of coulomb volume : V_c=V_0+V_f  --
c -- in ZVEZD1: FRAMIK,FRAGTE (,FIXT).
c -- Translational volume is usualy multiplicity dependent:
c -- See for constant transl.volume CALCWE,FRAGTE,(FIXT) + WEIGHM
c      FKACOL=5.
c -- const.free vol. IKAPPA=1 (=FKAPPA), standard (multipl.depend.) IKAPPA=0
      IKAPPA=0
      FKAPPA=FKACOL
c -- shperical symmetry factor in partition probability: 
c    ISYM1=1 - included, ISYM1=0 - as usual (not included)
      ISYM1=0
c -- rotational/angul.moment symmetry factor in partition probability: 
c    ISYM2=1 - included, ISYM2=0 - as usual (not included)
      ISYM2=0
c -- rotat. symmetry for Y-axis, e.g. in case of second source Coulomb: 
c    ISYM3=1 - included, ISYM3=0 - as usual (not included)
      ISYM3=0
c -- Internal fragment excitation parameter EPSIL0, default =16.
c -- For mass dependence of this parameter see IPERI.
c -- for metropolis for cold primary fragments (epsil0=99999.)
c      EPSIL0=99999.
c parametrization of E11(i): for central collisions- IPERI=0 ,
c for peripherial collisions- IPERI=1
      IPERI=1
c --------------------------------------------------------------
c -- quantum statistics for part. A=1-3 (0 - usual not-incl., 1 -inclusion) 
      IQUAN=0
c possible changing masses of nuclei during secondary deexcitation EVANUC:
c IEVP=1 - EVANU1 - old EVANUC (as usual).  IEVP=2 - EVANU2 - l.d.masses for
c evap. residues with transition to nuclei with shells (tables) at E*-->0.
c IEVP=3 - EVANU3 ! not finished !
c      IEVP=2
c -- possible exits in RAZVAL+EVANUC for writing hot fragments in SPT-array,
c    IEX=0 -as usual (normal second.deexcit.includ.), IEX=1 - for hot fragm.
      IEX=0
      IF(ICOLE.EQ.-1) IEX=1
c      IF(ITMUL.EQ.1) IEX=1
c -- liquid-drop (ELIDR, ILIDR=1) or exact (DELAM, ILIDR=0) mass formula w/o 
c shells for Markov method in WEIGHM, METR2, METR4 (to check isotope distrib.)
c If ILIDR=-1 - mass formula includes shells always! 
      ILIDR=1
c -- changing the symmetry term G0 ("density-dependent"): 
      FKACOG=FKACOL
      G0G=0.
      G00=25.
c -- surface energy of fragments (B0=B00) 
      B00=18.
c -- volume energy (W0=W00)
      W00=16.
c Calculation of entropy (in direct and Markov partitioning):
c limitation for translational entropy STRAN (old ITRAN=0, new =1)
      ITRAN=0
c Details of secondary deexcitation of fragments:
c second. deexcit. as for Milazzo [PRC] paper MILAZ=1 (MILAZ=0 - as usual)
      MILAZ=1
c Calculating Coulomb energy inside freeze-out: in Wigner-Seitz approximation 
c IWIGSE=1 or not =0. IWIGSE=0 means direct positioning of hot fragments, 
c that is necessary for the second source and exact angular momentum treatm.,
c in this case only Markov must be used. IWIGSE=1 can be used in any case.
      IWIGSE=1
c initial partitions for Markov chain calcul. ZVEMET: IZVEC,M=0 - as usual 
c via grand canon.; IZVEC=1 - compound, IZVEM=1 - fission partition. 
      IZVEM=0
      IZVEC=0
c --------------------------------------------------------------
c   INPUT for calculations with radial flow and simple rotation:
c   phenomenological analysis.
c   Existing or not the flow and rotation IFLOW, IAMOM (=1 or 0)
      IFLOW=0
      IAMOM=0
c   the flow along y-axis in FLY times larger than in other axes.
c   FLY=1 - flow uniform in all directions.
      FLY=1.
c   energy of flow and rotation: EFLOW, EMOM in GeV/N
      EFLOW=0.000
      EMOM=0.000
c for including EXACT momentum in Markov part (AMEM in h-bars)
c (IMEM=0 no, =1 includ., IMEM=2 + accounting kin.rotation in POSMET: IAMOM=1)
c -- also for ang.mom. in evaporation EVANCR --
      IMEM=0
      AMEM=0.
c "diffusion" of fragments: limited changing of the coordinates reflecting 
c an evolution from "saddle" to "scission" point (IDIFUS=0 - no, =1 -yes)
      IDIFUS=0
c   total excitation energy (GeV/N) per nucleon : ETOT
c (It must include phenomenological flow/rotation energies if they are given, 
c  the rest is "thermal" excitation. However exact momentum introduced with 
c  IMEM is accounted self-consistently by the Markov without correction ETOT)
c      ETOT=0.001*IITT+EFLOW
c      IF(IITT.EQ.1) ETOT=0.002+EFLOW
c      IF(IITT.EQ.2) ETOT=0.003+EFLOW
c      IF(IITT.EQ.3) ETOT=0.004+EFLOW
c      IF(IITT.EQ.4) ETOT=0.005+EFLOW
c      IF(IITT.EQ.5) ETOT=0.006+EFLOW
c      IF(IITT.EQ.6) ETOT=0.007+EFLOW
c      IF(IITT.EQ.7) ETOT=0.008+EFLOW
c      IF(IITT.EQ.8) ETOT=0.010+EFLOW
c      IF(IITT.EQ.9) ETOT=0.012+EFLOW
c      IF(IITT.EQ.10) ETOT=0.014+EFLOW
c --------------------------------------------------------------
c -- in case ZVEZD1: deformation of coord. volume (PLACE)
      CELZV1=1.
c -- deformation in momentum space FLZ (since only increasing share, 
c equivalence with CELZV1 should be kept FLZ=CELZV1**1.5 at the same flow!)
      FLZ=1.
c -- form of the source,  CELMET - largest(>1) or smallest(<1) axis of 
c -- spheroid in relat.units; other axes are adjusted: the volume is fixed --
c -- Deformation is assumed along Z-axis.
c -- But better (mathematically) to keep it =1, otherwise additional problems 
c with the symmetry can arise at generation of positions in the freezout. 
      CELMET=1.
c -- possibl.overlap.fragm.at position.in freezout; nonoverlap. XRNO=1
c ! it is better (physically) do not allow for overlapping !
      XRNO=1.0
c ---- for FKACOL=3 ----
c      XRNO=0.9 
c ---- for FKACOL=1 ----
c      XRNO=0.7
c --------------------------------------------------------------
c -- for evaporation at second source Coulomb includ. I2S=1-yes, =0-no --
      I2S=0
c -- geometr. limitation of widths in GAMCR1 (I2SLW=0 - no, as usual; =1 -yes)
      I2SLW=0
c -- with recoil effect in EVANCR I2SRC=1 (as usual), without recoil =0 
      I2SRC=1
c -- increasing lifetime by factor CTIME (CTIME=1 - as usual) in EVANCR(/TCR)
      CTIME=1.
c Evaporation of fixed particle (LM=LMTAMU) in the first act of evaporation 
c (LMTAMU=0 - as usual, without preference). [8-6HE,...]        in EVATCR:
      LMTAMU=0
c -----------------------------------------------------------------
c -- includ. 2-nd source Coulomb influence, ISECS=1 -old way, ISECS=2 -taking 
c shift cm of 2-nd also by fixing cm of double system! No includ at ISECS=0 !
      ISECS=0
c -- influence of the second source on Coulomb trajectories of produced 
c    fragments during propagation (NO: ISCUL=0 or YES: ISCUL=1) --
c -- Evaporation@2S: =1 - EVATCR with Coulomb 'tracking' (=0 -EVANCR)
      ISCUL=0
      IF(I2S.EQ.0.AND.ISECS.EQ.0) ISCUL=0
c accounting for additional angular momentum occured at decay of the double 
c system, because of shifting coordinate cm of the both systems. 
c IRWT=0 - is not included, as usual ! IRWT=1 - included, but in this 
c case IMEM>0 and ISECS=2 must be taken additionally. 
      IRWT=0
      IF(ISECS.LE.1) IRWT=0
      IF(IRWT.GT.0.AND.IMEM.EQ.0) AMEM=0.
      IF(IRWT.GT.0.AND.IMEM.EQ.0) IMEM=1
c --
c -- Parameters of the second source! Influence on hot fragment's positions in 
c  freeze-out volume via the Coulomb of the second source in METR2 and METR4. 
c -- Take RYSEC=-10000 in case of NOT influence --
c -- Mass number and charge:
      IASEC=238
      IZSEC=92
c -- Positions of the second source [fm] respective to geometrical center of 
c the main source. The main source and the second one are on Y-axis.
      RXSEC=0.
c      RYSEC=-15.*0.707
c      RYSEC=-15.
c      RYSEC=-30.
      RYSEC=-99999.
c      RZSEC=15.*0.707
      RZSEC=0.
c -- Relative velocity of the second source [c] respective to the main one.
      VXSEC=0.
c
c      VYSEC=0.
      VYSEC=-0.12
c 114-Cd(50MeV/n)+92-Mo (excit. 3 MeV/n, no flow), no add Coul.repul, 
c      VYSEC=-0.2728
c ** from DeSouza experiment 2 MeV/n **
cc      VYSEC=-0.2900 ! before May 16
c      VYSEC=-0.3000
c ** from DeSouza experiment 3 MeV/n **
cc      VYSEC=-0.2567 ! before May 16
c      VYSEC=-0.2700
c ** from DeSouza experiment 4 MeV/n **
cc      VYSEC=-0.2250 ! before May 16
c      VYSEC=-0.2300
c ** from DeSouza experiment 5 MeV/n **
cc      VYSEC=-0.1933 ! before May 16
c      VYSEC=-0.1900
c ** from DeSouza experiment 6 MeV/n **
c      VYSEC=-0.1600
c
      VZSEC=0.
c --- velocities of the sources in lab.system. Only for evaluation of output 
c --- in DCR,CDCR: not affect calculations.
      VCMST=0.
c 114-Cd(50MeV/n)+92-Mo (excit. 3 MeV/n, no flow), no add Coul.repul
c      VCMST=0.0244
c ** from DeSouza experiment 2 MeV/n **
cc      VCMST=0.0133 ! before May 16
c      VCMST=0.0150
c ** from DeSouza experiment 3 MeV/n **
c      VCMST=0.0300
c ** from DeSouza experiment 4 MeV/n **
c      VCMST=0.0450
c ** from DeSouza experiment 5 MeV/n **
c      VCMST=0.0600
c ** from DeSouza experiment 6 MeV/n **
c      VCMST=0.0750
c
      VCMSP=VCMST-VYSEC
c -- for evaporation at second source Coulomb includ. I2S=1-yes, =0-no --
      V2S0=-VYSEC
      A2S=IASEC
      Z2S=IZSEC
c      R2S0=-RYSEC
      R2S0=SQRT(RXSEC**2+RYSEC**2+RZSEC**2)
c ---- in case of deformation at the presence of the second source: 
c -- making deformation along Y-axis: IDEFS=1 (=0: usual deform. along Z axis) 
      IDEFS=0
c --------------------------------------------------------------
c -----------  for writing to different files ------------
      JWRJBN=0
      IF(JWRJBN.EQ.0) GO TO 115
c      IF(IITT.EQ.1) OPEN
c     #(51,NAME='/home/jbngroup/jbngroup/data/smm2/m2_238_m50t_e05.d30M')
c      IF(IITT.EQ.2) OPEN
c     #(51,NAME='/home/jbngroup/jbngroup/data/smm2/mc476_184_e10.dat')
c      IF(IITT.EQ.3) OPEN
c     #(51,NAME='/home/jbngroup/jbngroup/data/smm2/mc476_184_e20.dat')
c      IF(IITT.EQ.4) 
c     *OPEN(51,NAME='/home/jbngroup/botvina/smmdata_jbn/mc36_16_e50.dat')
c      print *,'   open file for writing in units 51'
 115  CONTINUE
c -----------  for writing to different files ------------
      JWRITD=0
      IF(JWRITD.EQ.0) GO TO 101
c      IF(IITT.EQ.1) 
c     *OPEN(51,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e3.zc')
c      IF(IITT.EQ.1) 
c     *OPEN(52,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e3.a')
c      IF(IITT.EQ.2) 
c     *OPEN(51,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e4.zc')
c      IF(IITT.EQ.2) 
c     *OPEN(52,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e4.a')
c      IF(IITT.EQ.3) 
c     *OPEN(51,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e5.zc')
c      IF(IITT.EQ.3) 
c     *OPEN(52,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e5.a')
c      IF(IITT.EQ.4) 
c     *OPEN(51,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e7.zc')
c      IF(IITT.EQ.4) 
c     *OPEN(52,NAME='/home/jbngroup/botvina/smm/data_jbn/f162z69_e7.a')
c      print *,'   open file for writing in units 51,52'
 101  CONTINUE
c ---  for writing to different files for 2-sources calcul. ------
      JWRIT2=0
      IF(JWRIT2.EQ.0) GO TO 1010
c      IF(IITT.EQ.1) OPEN(53,NAME='FILE31')
c      IF(IITT.EQ.1) OPEN(54,NAME='FILE32')
c      IF(IITT.EQ.1) OPEN(55,NAME='FILE33')
c      IF(IITT.EQ.1) OPEN(56,NAME='FILE34')
c      print *,'   open file for writing in units 53-56'
 1010 CONTINUE
cc --------------------------------------------------------
c   number of events : ITNUM
c      ITNUM=3
c      IF(IITT.GT.4) ITNUM=50000
c      IF(IITT.GT.6) ITNUM=20000
c *******************************************************************
c      IF(IMULF.GT.0)
c     *PRINT 1,IA0,IZ0,ETOT,FKACOL,ITNUM
c 1    FORMAT(2X,'IA0,IZ0=',2I5,' ETOT=',F8.5,
c     *' GeV/N  FKACOL=',F5.1,' ITNUM=',I7)
c      IF(IMULF.EQ.0) PRINT 11,IA0,IZ0,ETOT,ITNUM,MILAZ
c 11   FORMAT(2X,'Evaporation: IA0,IZ0=',2I5,' ETOT=',F8.5,
c     *' GeV/N    ITNUM=',I7/2X,'second.deexcit. MILAZ=',I2)
c      IF(IMULF.GT.0.AND.IMIC2.EQ.0) PRINT 52,IMETR
c 52   FORMAT(2X,'METROPOLIS-MARKOV VERSION (or not)  IMETR=',I1)
c      IF(IENS.EQ.1) PRINT 12,IENS
c 12   FORMAT(2X,'*** calcul. ensemble (IENS=1), or fixed source',
c     #' (IENS=0): IENS=',I2)
c      IF(IMULF.GT.0)
c     *PRINT 4,G0G,G00,B00,W00
c 4    FORMAT(2X,'"density-dependent" symmetry term: G0G=',F5.2,
c     #' G00(MeV)=',F5.2/2X,' surface energy B00(MeV)=',F6.2, 
c     $' volume energy W00(MeV)=',F6.2)
c      PRINT 400,IEVP
c 400  FORMAT(2X,'mode of second.deexcit. IEVP=',I2,
c     #' (=1 old EVANUC; =2 EVANU2; =3 EVANU3)')
c      IF(IMULF.GT.0.AND.ICOLE.LT.0) PRINT 41,ICOLE
c 41   FORMAT(2X,'no Coulomb in bind.+ no C-barrier: ICOLE=',I2,' !')
c      IF(IMIC2.GE.1) PRINT 42,IMIC2
c 42   FORMAT(2X,'microcan break-ups into 2 fragments only! IMIC2=',I2)
c      IF(ITLIM.EQ.1) PRINT 43,ITLIM,TINLIM
c 43   FORMAT(2X,'ITLIM=',I1,
c     *' limit.temp.for secon.deexcit. TINLIM(MeV)=',F5.2)
c      IF(IMULF.GT.0)
c     *PRINT 2,IFLOW,IAMOM,EFLOW,EMOM,FLY,FLZ,EPSIL0,IPERI,ILIDR,
c     *MILAZ,IKAPPA,FKAPPA,ITRAN,IEX
c 2    FORMAT(2X,'collect.energ: IFLOW, IAMOM =',2I2,
c     *' EFLOW, EMOM (GeV/N) =',2F9.4/2X,'deform.momentum space: FLY=',
c     *F5.2,' FLZ=',F5.2/
c     *2X,' param.intern.excit. Epsil0=',F8.1,' IPERI=',I2/
c     *2X,'liq.-drop fragm. ILIDR=',I2,2X,'second.deexcit. MILAZ=',I2/
c     *2X,' free-vol. IKAPPA=',I1,' FKAPPA=',F5.2,
c     *' for entrop. ITRAN=',I2/
c     *2X,'hot (=1) or cold (=0) final fragments IEX=',I1)
c      IF(ITMUL.EQ.1) PRINT 44,ITMUL,TMUL
c 44   FORMAT(2X,'ITMUL=',I1,' FIXED TEMPERATURE *** TMUL(MeV)=',F5.1)
c      IF(IMULF.GT.0.AND.IMETR.GT.0) 
c     #PRINT 22,XRNO,IMEM,AMEM,ISYM1,ISYM2,ISYM3,IDIFUS,IQUAN,IZVEC,IZVEM
c 22   FORMAT(2X,' overlap.fragm.at position. XRNO=',F4.2/
c     *2X,'exact ang.momen. in METR (0, 1 or >1): IMEM=',I2,
c     *' AMEM(h-bar)=',F6.1/2X,'spher.symmetry ISYM1=',I1,
c     *' rotat/ang.mom.symmet. ISYM2=',I1,' symmet. Y-axis ISYM3=',I1/
c     *2X,' "diffusion" after freeze-out IDIFUS=',I1/
c     *2X,'quantum statist.for part. A=1-3: IQUAN=',I1/
c     *2X,'init.partit.(Markov) (=0 via Gr.Can.): IZVEC, IZVEM=',2I3)
c      IF(IMULF.EQ.0.AND.I2S.GT.0) PRINT 21,I2S,IMEM,AMEM
c 21   FORMAT(2X,'for EVANCR/EVATCR case  I2S=',I1,' ang.mom.: IMEM=',
c     *I1,' AMEM(h-bar)=',F5.1)
c      IF(I2S.GT.0.OR.ISECS.GT.0) 
c     #PRINT 3,ISECS,IRWT,IASEC,IZSEC,RXSEC,RYSEC,RZSEC,ISCUL,VXSEC,
c     *VYSEC,VZSEC
c 3    FORMAT(2X,'*Second source: ISECS=',I2,' (occur.rotat.)IRWT=',I2,
c     *' mass,charge- A,Z=',2I5/
c     *2X,'*coord.(fm) x,y,z=',3F8.1/2X,'*infl.Cul.traj. ISCUL=',I2,
c     *' veloc.(c) V_x,y,z=',3F7.3)
c      IF(IMULF.GT.0.AND.IMETR.GT.0) PRINT 5,CELMET
c 5    FORMAT(2X,'param.of volume-form for METR (for real posit.): ',
c     *' CELMET=',F5.2)
c      IF(IMULF.GT.0.AND.IMETR.EQ.0) PRINT 51,CELZV1
c 51   FORMAT(2X,'in ZVEZD1 deform.in coord.volume: CELZV1=',F5.2)
c --- statistics on microcanonical temperature
      CALL FIXTB
c --- statistics on hot fragments
      CALL HOTFRB
      CALL DCR00
      CALL CDCR0
c      CALL DLYN00
      CALL HOFPCB
c      CALL DSPRB
      CALL CLPC00
c      CALL DLPC00
c      CALL D1LPC0
c      CALL D3LPC0
      CALL CINDR0
      CALL CLASS0
c --- charge-charge correlations ---
c      CALL CHACOB(IITT)
cc      CALL HOTF6B
c -------------------------------
      CALL MAINMA(IA0,IZ0,ETOT,TPR0,ITNUM,kst1,pxrem,pyrem,pzrem,ifis)
c   Main OUTPUT: prints in MAINMA and all events are written in unit 59 !
c   E.G. (see in MAINMA comments under ccc), one of the possible writing:
c   first line of the event: NUMPAT -number of particles in this event 
c   next NUMPAT lines - characteristics of each particle in this event:
c   IAP - mass number of the particle 
c   IZP - charge of the particle 
c   EKIN - kinetic energy (MeV) in lab. syst. 
c   ANTET - polar angle (theta) respect. to beam axis (0-180 deg.)
c   ANPHI - azimuth.angle (phi) (0-360 deg.)
c ------------------------------------
c ------ All next subroutines for particular analysis prints -------
c -- (One can look in it as examples of data evaluation) --
cc      CALL HOTFRE
c      CALL DCRPR
cc      CALL DLYNPR
c      CALL CDCRP
c -----------------------------------
cc    CALL HOTF6E
c      CALL HOFPCE(IZ0)
      CALL FIXTE
c      CALL DSPRE
c -----------------------------------
c      PRINT 175
c 175  FORMAT(2X,'******* DLPC *** LPC "fission" analysis ')
c      CALL DLPCPR
c      PRINT 178
c 178  FORMAT(2X,'*** CLPC *** LPC "fission" COLD fragments ')
c      CALL CLPCPR
cc      PRINT 176
cc 176  FORMAT(2X,'******* D1LPC *** for Zmax+Zma2=60-70')
cc      CALL D1LPCP
cc      PRINT 177
cc 177  FORMAT(2X,'******* D3LPC *** for Zmax+Zma2=40-50')
cc      CALL D3LPCP
c      PRINT 179
c 179  FORMAT(2X,'*** CINDRP *** INDRA (COLD fragments) ')
c      CALL CINDRP
c      PRINT 180
c 180  FORMAT(2X,'*** CLASSP *** LASSA (COLD fragments) ')
c      CALL CLASSP
c ---------------------------
c --- charge-charge correlations ---
cc      CALL CHACOE
c ----------------------------------
      IF(JWRITD.EQ.0) GO TO 102
c      CLOSE(51)
c      CLOSE(52)
c      print *,' WRITE in file finished  IITT=',IITT
 102  CONTINUE
c ---------------------------
c      PRINT 111
c 111  FORMAT(2X,'----------------------------------------',2X/)
 110  CONTINUE
c      STOP
      END
      SUBROUTINE MAINMA(IA0,IZ0,ETOT,TPR0,ITNUM,kst1,pxrem,pyrem,pzrem,
     *ifis)
C MULTIFRAGMENTION of moving source (NBI-95), with preequil.particles 
c -- + ZVEZD2 -- FOR ALADIN experiment. (see JPRE and also E11(A)).
      REAL*4 acv,zpcv,pcv,xcv,ycv,zcv
      COMMON/volant/acv(300),zpcv(300),pcv(300),xcv(300),
     s              ycv(300),zcv(300),iv

      COMMON /BLOKC/SPT(10,500) /BLFINL/A0F,Z0F,E0F,TF,FL,SRF,WW3F
      COMMON /BLMULF/IMULF /BLOKFR/FRA(500),SNSR,SPSR,S3SR,Z3SR,MFRAG
      COMMON /BLKFRZ/FRZ(500),FRZ2(500)
      COMMON /BLOKF1/EXFRA(500),EKFRA(500)
      COMMON /BLOKF4/SAAM,SEKAM,SEXAM,SSEKX,SSEX
      COMMON /BLPARA/EPSIL0,FKAPPA,FKACOL
      COMMON /BLFLOW/AAA,EFLOW,IFLOW /BLAMOM/ANMOM,EMOM,IAMOM
      COMMON /BLTMIC/TMICR,TMICR2,TMICT,NMICR
      COMMON /BDMR0/
     *PXXX(200),PYYY(200),PZZZ(200),IAAA(200),IZZZ(200),NFRAGG
      COMMON /BLJJJ/JJJ /BLECBS/ECOLBS
      COMMON /BLMET7/SMETS,SMET2,ECMETS,ECMET2,TMETS,TMET2,TMMMS,TMMM2,
     *FMEN,FMEN2,FMEP,FMEP2,FMEA,FMEA2,FMEF,FMEF2,EC2MES,EC2ME2,NUMET
      COMMON /BLMET8/FMA(500),FCHA(500),FCH2(500)
      COMMON /BLMET9/MENEW,MENEWR,LNUCL,IMEC,IME1,IME2,IME3,IME4,IME5,
     *IME6,IME7
      COMMON /BLMET0/IMET0
      COMMON /BLMECH/IMECH /BIMETR/IMETR
      COMMON /BWIGSE/IWIGSE
      COMMON /BLSECS/IASEC,IZSEC,RXSEC,RYSEC,RZSEC,CULSEC
      COMMON /BSECS1/RYIMF(46),AIMF(46),YRL0,ARL0,YRG0,ARG0
      COMMON /BLME11/SDIS(406),ASDIS(406)
      COMMON /BLME12/PMUL(500),PSDIS(406)
      COMMON /BLXPLC/XPLC1,XPLC2,XPLC0,XPLCU,XPLCT
      COMMON /BLMEAM/AMEM,BMEM,EMEM,WMEM,IMEM
      COMMON /BWRITD/JWRITD /BWRITA/HISA(400),HISZ(200),HISZA(200)
      COMMON /BWRJBN/JWRJBN
      COMMON /BDCR/VCMSP,VCMST
      COMMON /BLHFD1/THFD,IPHFD,INHFD,IAHFD(500),IZHFD(500),UHFD(500),
     *PXHFD(500),PYHFD(500),PZHFD(500),ECHFD
      COMMON /B2CR1/V2S0,R2S0,R2S,A2S,Z2S,I2S
      COMMON /B2CR6/I2SLW,I2SRC,CTIME /BLSCUL/ISCUL
      COMMON /BTAUR/STAUR(9,500),XREP(3,500),XR1S(3,500),
     *XTAU(500),XTAN(500),XTIM(500),ITAUR
      COMMON /BICOLE/ICOLE /BIMIC2/IMIC2
      COMMON /BLEVP/IEVP /BLIEX/IEX
      COMMON /BLENS/IENS
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00
      COMMON /BTMUL/TMUL,ITMUL /BTMUL0/ESR,ESRP,ESRP2
      DIMENSION P2SCR(3)
      DIMENSION HISTA(500),HISTZ(200),PNUCL(3),PP(3)
      DIMENSION MCOR(20),MCI3(20)
      DIMENSION SFZFR(200),MZFR(200),ZMZFR(200)
      DIMENSION SFZB3(200),ZMZB3(200),MZB3(200),SNZB3(200)
      DIMENSION APAT(500),ZPAT(500),EKIP(500),TETP(500),PHIP(500)
      DIMENSION EKZ(500),ETRZ(500),NUMZ(500),RPHI(26)
      DIMENSION TZB(200),TZB3(200),MZB(200)
      DIMENSION PCDC(3,500),RCDC(3,500),ACDC(500),ZCDC(500)
      DIMENSION YAZT(25,11),IYAZT(25,11)
      DIMENSION NUMZA(500),PPL(3),PP2(3),VNP(3),VNT(3)
      DIMENSION EKZL(500),EKZT(500),NUMZL(500),NUMZT(500)
      DIMENSION HISM23(75,75)
      DIMENSION HINZA(500),FNZA(500),HIAZZ(200),HINZZ(200)
      DIMENSION AZ22(500),AZ42(500),AZ62(500),AZ82(500)
      DIMENSION YZ10A(10,40),YZ20A(10,50),YZ30A(10,60)
      DIMENSION RY(26),RE(26),ARES(100),ERES(100)
      DIMENSION HISTMZ(200),HMAZZ(200),HMNZZ(200)
      DIMENSION HIST1Z(200),H1AZZ(200),H1NZZ(200)
      DIMENSION HIST2Z(200),H2AZZ(200),H2NZZ(200)
      DIMENSION HAZ5B(200),HAZ6B(200),HAZ7B(200),HAZ8B(200),
     #SPRB(200),SDEB(200),STRB(200),SHE3B(200),SHE4B(200),
     #SZ1B(200),SZ2B(200),NAZ5B(200),NAZ6B(200),NAZ7B(200),NAZ8B(200),
     #RAZ5B(200),RAZ6B(200),RAZ7B(200),RAZ8B(200)
      DIMENSION HAZ5BI(10),HAZ6BI(10),HAZ7BI(10),HAZ8BI(10),
     #NAZ5BI(10),NAZ6BI(10),NAZ7BI(10),NAZ8BI(10),
     #RAZ5BI(10),RAZ6BI(10),RAZ7BI(10),RAZ8BI(10)
      DIMENSION SSZR(5),SNZR(5),SPZR(5),SDZR(5),STZR(5),SHE3ZR(5),
     #SHE4ZR(5),SZ1ZR(5),SZ2ZR(5)
      DIMENSION YAZT1(26,11),YAZT2(26,11),YAZT3(26,11),YAZT4(26,11),
     #YAZT5(26,11)
      DIMENSION FCZB1(200),FCZB2(200),FCZB3(200),FCZB4(200),FCZB5(200)
      DIMENSION FNZB1(200),FNZB2(200),FNZB3(200),FNZB4(200),FNZB5(200)
      REAL NUMBZ
c preparation for RESNUC
      DO 9 I=1,26
      RY(I)=0.
      RE(I)=0.
 9    CONTINUE
c  CMS velocities of the two sources
      VNP(1)=0.
      VNP(2)=VCMSP
      VNP(3)=0.
      VNT(1)=0.
      VNT(2)=VCMST
      VNT(3)=0.
c ----------------------------------
      NEVENT=1
      DO 500 IT=1,NEVENT
      MENEW=0
      MENEWR=0
      XPLC1=0.
      XPLC2=0.
      XPLC0=0.
      XPLCU=0.
      XPLCT=0.
c ------ important for METROP, not for METR2, METR4  -------
      LNUCL=1
      IMEC=0
      IME1=0
      IF(LNUCL.EQ.1) IME1=0
      IME2=0
      IME3=0
      IME4=0
c ----------------------------------------------
      IME5=1
      IME6=1
      IME7=1
      DO 906 IJIJ=1,500
      IF(IJIJ.LE.406) SDIS(IJIJ)=0.
      IF(IJIJ.LE.406) ASDIS(IJIJ)=0.
      IF(IJIJ.LE.406) PSDIS(IJIJ)=0.
      PMUL(IJIJ)=0.
 906  FRA(IJIJ)=0.
      ESR=0.
      ESRP=0.
      ESRP2=0.
      SMETS=0.
      SMET2=0.
      EC2MES=0.
      EC2ME2=0.
      ECMETS=0.
      ECMET2=0.
      TMETS=0.
      TMET2=0.
      TMMMS=0.
      TMMM2=0.
      FMEN=0.
      FMEN2=0.
      FMEP=0.
      FMEP2=0.
      FMEA=0.
      FMEA2=0.
      FMEF=0.
      FMEF2=0.
      NUMET=0
      ANMOMS=0.
      EMOMS=0.
      ECOLBS=0.
      MFRAG=0
      SPSR=0.
      SNSR=0.
      S3SR=0.
      Z3SR=0.
      YRL0=0.
      ARL0=0.
      YRG0=0.
      ARG0=0.
      DO 600 IJIJ=1,500
      IF(IJIJ.LE.46) RYIMF(IJIJ)=0.
      IF(IJIJ.LE.46) AIMF(IJIJ)=0.
      FMA(IJIJ)=0.
      FCHA(IJIJ)=0.
      FCH2(IJIJ)=0.
      EXFRA(IJIJ)=0.
      EKFRA(IJIJ)=0.
      FRZ(IJIJ)=0.
      FRZ2(IJIJ)=0.
      FNZA(IJIJ)=0.
 600  FRA(IJIJ)=0.
      SAAM=0.
      SEKAM=0.
      SEXAM=0.
      SSEKX=0.
      SSEX=0.
      CALL DMR00
      CALL BPOCH1
      CALL BSPEC1
      CALL BSPEC2
      DO 201 I=1,25
      DO 201 J=1,11
 201  YAZT(I,J)=0.
      DO 2010 I=1,26
      DO 2010 J=1,11
      YAZT1(I,J)=0.
      YAZT2(I,J)=0.
      YAZT3(I,J)=0.
      YAZT4(I,J)=0.
 2010 YAZT5(I,J)=0.
      DO 1060 I=1,10
      DO 1060 J=1,60
      IF(J.LE.40) YZ10A(I,J)=0.
      IF(J.LE.50) YZ20A(I,J)=0.
      YZ30A(I,J)=0.
 1060 CONTINUE
c --------- for jbn 'critical' analysis ----------
c momenta of charge distribution
      DO 1052 I=1,75
      DO 1052 J=1,75
      HISM23(I,J)=0.
 1052 CONTINUE
      SM0=0.
      SM1=0.
      SM2=0.
      SM3=0.
c ------------------------------------------------
      INUC=0
      NUMB=0
      NUMBFR=0
      NUMBMS=0
      ITWRI=0
      A00=IA0
      Z00=IZ0
      A0F=1.
      Z0F=1.
      E0F=1.
      TPR=TPR0*IA0
      ETOT0=ETOT*A00
      PPR=SQRT(TPR*(TPR+2.*(IA0*0.940+ETOT0)))
      V00=PPR/SQRT(PPR**2+(0.94*A00+ETOT0)**2)
      IF(IMECH.GE.4) IME5=0
      IF(IMECH.EQ.4.AND.IWIGSE.EQ.1) IME6=0
      IF(IMECH.EQ.4.AND.IWIGSE.EQ.1) IME7=0
      IF(IMECH.EQ.2.AND.IWIGSE.EQ.1) IME6=0
      IF(IMECH.EQ.2.AND.IWIGSE.EQ.1) IME7=0
c      IF(IMULF.GT.0.AND.IMIC2.EQ.0.AND.IMETR.GT.0) 
c     *PRINT 650,IMECH,IWIGSE
c 650  FORMAT(2X,'2-including passes METR2 (A-sp), or 4-METR4 (A,Z-sp)',
c     *' IMECH=',I2/2X,'Coul.energy in Wigner-Seitz(1) or not(0)',
c     *' (METR4): IWIGSE=',I2)
c      IF(IMULF.GT.0.AND.IMETR.GT.0.AND.IMECH.GE.4.AND.IMIC2.EQ.0) 
c     *CALL CHAZ0(IA0,IZ0)
c      IF(IMIC2.GE.1) CALL CHAZ0(IA0,IZ0)
c  **********************************
c      PRINT 131,IMULF,FKACOL,A00,Z00
c 131  FORMAT(2X,' multifrag.: IMULF=',I2,
c     *'  FKACOL=',F5.1,3X,'   A00,Z00 =',2F6.0)
c      IF(IMULF.EQ.0.AND.I2S.GT.0) PRINT 1310,I2S,I2SLW,I2SRC,CTIME
c 1310 FORMAT(2X,'*** only evaporation in presence of second source',
c     *' EVANCR/EVATCR: I2S=',I2/
c     *2X,'in case of rotat.(GAMCR1)- width limit. I2SLW=',I1/
c     *2X,'recoil effect in EVANCR/EVATCR (1-yes, 0-no) I2SRC=',I1/
c     *2X,'evap.lifetime increas.factor in EVA(N/T)CR: CTIME=',F5.2)
c      IF(IMULF.EQ.0.AND.I2S.GT.0.AND.IMEM.GT.0) PRINT 1314,IMEM,AMEM
c 1314 FORMAT(2X,'-- evapor.with ang.momentum IMEM=',I1,' AMEM=',F5.1,
c     *' h-bar')
      IZMAXF=20
c      PRINT 132,ETOT0,PPR,V00
c 132  FORMAT(1X,' tot.ex.- ETOT0=',
c     *F7.3,3X,'tot.moment- PPR=',F8.3,' cms veloc.V00=',F6.4)
c      PRINT 133,IZMAXF
c 133  FORMAT(2X,'definition of IMF: Z=3-',I2)
      CALL THELI0
      CALL BFRENI
      DO 120 I=1,500
      AZ22(I)=0.
      AZ42(I)=0.
      AZ62(I)=0.
      AZ82(I)=0.
      HINZA(I)=0.
 120  HISTA(I)=0.
      DO 121 I=1,200
      IF(I.LE.20) MCOR(I)=0
      IF(I.LE.20) MCI3(I)=0
      MZFR(I)=0
      ZMZFR(I)=0.
      SFZFR(I)=0.
      MZB3(I)=0
      ZMZB3(I)=0.
      SFZB3(I)=0.
      SNZB3(I)=0.
      HAZ5B(I)=0.
      HAZ6B(I)=0.
      HAZ7B(I)=0.
      HAZ8B(I)=0.
      NAZ5B(I)=0
      NAZ6B(I)=0
      NAZ7B(I)=0
      NAZ8B(I)=0
      IF(I.LE.10) HAZ5BI(I)=0.
      IF(I.LE.10) HAZ6BI(I)=0.
      IF(I.LE.10) HAZ7BI(I)=0.
      IF(I.LE.10) HAZ8BI(I)=0.
      IF(I.LE.10) NAZ5BI(I)=0
      IF(I.LE.10) NAZ6BI(I)=0
      IF(I.LE.10) NAZ7BI(I)=0
      IF(I.LE.10) NAZ8BI(I)=0
      SPRB(I)=0.
      SDEB(I)=0.
      STRB(I)=0.
      SHE3B(I)=0.
      SHE4B(I)=0.
      SZ1B(I)=0.
      SZ2B(I)=0.
      IF(I.LE.5) SSZR(I)=0.
      IF(I.LE.5) SNZR(I)=0.
      IF(I.LE.5) SPZR(I)=0.
      IF(I.LE.5) SDZR(I)=0.
      IF(I.LE.5) STZR(I)=0.
      IF(I.LE.5) SHE3ZR(I)=0.
      IF(I.LE.5) SHE4ZR(I)=0.
      IF(I.LE.5) SZ1ZR(I)=0.
      IF(I.LE.5) SZ2ZR(I)=0.
      FCZB1(I)=0.
      FCZB2(I)=0.
      FCZB3(I)=0.
      FCZB4(I)=0.
      FCZB5(I)=0.
      FNZB1(I)=0.
      FNZB2(I)=0.
      FNZB3(I)=0.
      FNZB4(I)=0.
      FNZB5(I)=0.
      MZB(I)=0
      TZB(I)=0.
      TZB3(I)=0.
      HIAZZ(I)=0.
      HINZZ(I)=0.
      HMAZZ(I)=0.
      HMNZZ(I)=0.
      HISTMZ(I)=0.
      H1AZZ(I)=0.
      H1NZZ(I)=0.
      HIST1Z(I)=0.
      H2AZZ(I)=0.
      H2NZZ(I)=0.
      HIST2Z(I)=0.
 121  HISTZ(I)=0.
      ICFI=0
      AFIS=0.
      SZBOU=0.
      SZBOU3=0.
      SZMAX=0.
      SZMA2=0.
      S2ZMAX=0.
      SMIMF=0.
      SMIMF2=0.
      SMBIG=0.
      SMBIG2=0.
      RMZ=0.
      SNC=0.
      SAMAX=0.
      EKMAX=0.
      SNMAX=0.
      EKINZ=0.
      EKINZ2=0.
      NUMBZ=0
c **** generating the thermal source (AN - mass number, ZN - charge,
c **** ENEXT - excitation energy in GeV)
      AN=A00
      ZN=Z00
      ENEXT=ETOT0
      EN0=ENEXT/AN
c      PZE=V00*(ENEXT+0.94*AN)/SQRT(1.-V00**2)
      PZE=PPR
      CALL DELAM(A00,Z00,DLM00,DSH00,BAR00)
      CALL ELIDR(A00,Z00,DLM_EL)
      DLM_EL=DLM_EL+(8.071*A00-0.782*Z00)
c      PRINT 607,DLM00,DLM_EL
c 607  FORMAT(2X,'for IA0,IZ0:  DLM00=',F9.2,' DLM_Bind_elidr=',F9.2)
c -----------------------------------------
      INUC=INUC+1
c      IF(INUC.EQ.1.OR.MOD(INUC,500).EQ.0.) 
c      PRINT 400,ITNUM,AN,ZN,EN0
c 400  FORMAT(2X,'ITNUM=',I6,
c     *'  AN,ZN,EN0=',3F9.4)
c      IF(IFLOW.EQ.1.OR.IAMOM.EQ.1) PRINT 401,IFLOW,IAMOM,EFLOW,EMOM
c 401  FORMAT(2X,'IFLOW,IAMOM=',2I2,'  including in EN0 - EFLOW,EMOM=', 
c     *2F9.4)
      DO 139 I=1,500
      IF(I.LE.26) RPHI(I)=0.
      EKZ(I)=0.
      ETRZ(I)=0.
      NUMZ(I)=0
      NUMZA(I)=0
      EKZL(I)=0.
      NUMZL(I)=0
      EKZT(I)=0.
      NUMZT(I)=0
 139  CONTINUE
c finding BEMS and GEMS for this energy according to Myers-Swiatecki
      BEMS=0.
      GEMS=0.
c *******  open file to write - VAX system ********
      JWRITE=1
      IF(JWRITE.EQ.0) GO TO 181
c      OPEN(59,NAME='/home/botvina/smm_spal/write.dat')
c      print *,'   open file for writing in unit 59'
 181  CONTINUE
c -------- TAMU - isotopes -----------
      JWRIZ=0
      IF(JWRIZ.EQ.0) GO TO 184
c      IF(IZ0.EQ.52) 
c     *OPEN(57,NAME='/home/jbngroup/botvina/smm/data/h52_116_v6_e070.g')
c      IF(IZ0.EQ.54) 
c     *OPEN(57,NAME='/home/jbngroup/botvina/smm/data/h54_116_v6_e070.g')
c      IF(IZ0.EQ.56) 
c     *OPEN(57,NAME='/home/jbngroup/botvina/smm/data/h56_116_v6_e070.g')
 184  CONTINUE
c **************************************
      DO 410 JJJ=1,ITNUM
c --- for checking mom. and energ. balance --------
      PTX=0.
      PTY=0.
      PTZ=0.
      ETM=0.
      ETK=0.
      ATM=0.
      ZTM=0.
      SUAIAZ=0.
c -------------------------------------------------
      IF(IENS.NE.1) GO TO 4007
c **** generating Resirual Nuclei (AN - mass number, ZN - charge,
c **** ENEXT - excitation energy in GeV)
      CALL RESNUC(JJJ,EREL,YREL)
      IF(EREL.LT.0.001) EREL=0.001
      AN=INT(YREL*IA0+0.5)
c ------ for INC: AN/A0=(1-0.025*EREL) -------
c      AN=INT((1.-0.025*EREL)*IA0+0.5)
c --------------------------------------------
      IF(AN.LT.1.) AN=1.
      ZN=INT(IZ0*AN/FLOAT(IA0)+0.5)
      ENEXT=0.001*EREL*AN
c ------------------------------
C for 4-He(3.65 GeV/N) + Au
c      FIA=2.*3.14159*RNDMSMM(-1)
c      PNUCL(1)=AN*0.94*COS(FIA)*0.005*SQRT(EREL)
c      PNUCL(2)=AN*0.94*SIN(FIA)*0.005*SQRT(EREL)
c      PNUCL(3)=AN*0.94*0.001*EREL
c ****
      CALL HIST1(YREL,0.,1.,0.05,RY,26,1.)
      CALL HIST1(EREL,0.,10.,0.5,RE,26,1.)
      IF(JJJ.LE.100) ARES(JJJ)=AN
      IF(JJJ.LE.100) ERES(JJJ)=EREL
c      IF(MOD(JJJ,10000).EQ.0.) PRINT 4000,JJJ,AN,ZN,EREL
c 4000 FORMAT(2X,'resnuc:  JJJ=',I6,' AN,ZN,EREL=',3F9.4)
c      TPZ=TPR0*AN
c      PZE=0.
c      PZE=SQRT(TPZ*(TPZ+2.*(AN*0.940)))
c      PYE=0.
c      PYE=0.94*AN*(1./30.)
 4007 CONTINUE
c -------------------------------------------------
      NUMB=NUMB+1
      IBIG=0
      NZ330=0
      IZBOU=0
      IZBOU3=0
      NPAT=0
      NPROT=0
      NDEUT=0
      NTRIT=0
      NHE4=0
      NHE3=0
      NZ1=0
      NZ2=0
      JMAX=0
      ZMAX=0.
      ZMAX2=0.
      JMAX2=0
      IMF=0
      ITAUR=1
      DO 200 I=1,10
      DO 200 J=1,500
      IF(ITAUR.LE.0) GO TO 2001
      IF(I.LE.9) STAUR(I,J)=0.
      IF(I.LE.3) XREP(I,J)=0.
      IF(I.LE.3) XR1S(I,J)=0.
      IF(I.LE.1) XTAU(J)=0.
      IF(I.LE.1) XTAN(J)=0.
      IF(I.LE.1) XTIM(J)=0.
 2001 CONTINUE
 200  SPT(I,J)=0.
      KSTART=1
      AA=AN
      IF(AA.LT.1.) GO TO 410
      ZZ=ZN
      EE=ENEXT
      IAN=AN
      IZN=ZN
      ETN=ENEXT/AN
c *** reduction of energy by flow and rotation ***
      IF(IFLOW.EQ.1) EE=EE-EFLOW*AA
      IF(IAMOM.EQ.1.AND.IMEM.EQ.0) EE=EE-EMOM*AA
c ********************************
c --- new liquid-drop parameters of hot fragments (depending on 
c excitation energy and N/Z ratio) for this source
c      IF(AA.LT.4.5.OR.ZZ.LT.2.5) GO TO 158
c      ETN0=1000.*EE/AA
c      PNZ0=(AA-ZZ)/ZZ
c      IF(ETN0.LE.2.) B00=18.+5.*(1.5-PNZ0)
c      IF(ETN0.GT.2.AND.ETN0.LT.5.) 
c     #B00=18.+5.*(1.-(ETN0-2.)/3.)*(1.5-PNZ0)
c      IF(ETN0.GE.5.) B00=18.
c      IF(ETN0.LE.2.) G00=25. 
c      IF(ETN0.GT.2.AND.ETN0.LT.5.) G00=25.-10.*(ETN0-2.)/3.
c      IF(ETN0.GE.5.) G00=15.
c      IF(ETN0.LE.2.) W00=16. 
c      IF(ETN0.GT.2.AND.ETN0.LT.5.) W00=16.-2.*(ETN0-2.)/3.
c      IF(ETN0.GE.5.) W00=14.
 158  CONTINUE
C ---
c      PNUCL(1)=0.
c      PNUCL(2)=0.
c      PNUCL(3)=0.
c      PNUCL(3)=PZE
c tentative pour tranfo dans le lab
      PNUCL(1)=pxrem/1000.
      PNUCL(2)=pyrem/1000.
      PNUCL(3)=pzrem/1000.
      PX=PNUCL(1)
      PY=PNUCL(2)
      PZ=PNUCL(3)
      IF(JJJ.GT.3.OR.INUC.GT.2) GO TO 157
      CALL DELAM(AA,ZZ,DLMAA,DSHAA,BARAA)
c      PRINT 154,AA,ZZ,EE,DLMAA
c 154  FORMAT(2X,'Break-up: AA,ZZ, EE(GeV)=',2F6.1,1X,F9.4, 
c     *'  DLMAA=',F8.2)
c      IF(IFLOW.EQ.1) PRINT 159,IFLOW,IAMOM,EFLOW,EMOM
c      IF(IAMOM.EQ.1.AND.IMEM.EQ.0) PRINT 159,IFLOW,IAMOM,EFLOW,EMOM
c 159  FORMAT(2X,'IFLOW,IAMOM=',2I2,'  add.energ.(GeV/N) EFLOW,EMOM =', 
c     *2F9.4)
 157  CONTINUE
ccc      PRINT 502,JJJ,EE,AA,ZZ,KSTART
ccc 502  FORMAT(2X,'ZVEZD1: JJJ=',I4,' EE,AA,ZZ,KSTART=',3F9.3,I5)
      IF(IMULF.EQ.0) CALL EVANUC(EE,AA,ZZ,PX,PY,PZ,KSTART)
c      IF(EE.LE.0.AND.ITMUL.EQ.0) CALL EVANUC(EE,AA,ZZ,PX,PY,PZ,KSTART)
c      IF(ENEXT.LE.0.AND.ITMUL.EQ.0) GO TO 503
c      IF(IMIC2.GE.1) GO TO 504
c      IF(IMULF.EQ.0.AND.I2S.EQ.1.AND.ISCUL.EQ.0) 
c     *CALL EVANCR(EE,AA,ZZ,PX,PY,PZ,KSTART)
c      IF(IMULF.EQ.0.AND.I2S.EQ.1.AND.ISCUL.EQ.1) 
c     *CALL EVATCR(EE,AA,ZZ,PX,PY,PZ,KSTART)
c      IF(IMULF.EQ.0.AND.I2S.EQ.0) CALL EVANUC(EE,AA,ZZ,PX,PY,PZ,KSTART)
      IF(IMULF.EQ.0) GO TO 503
      CALL ZVEZD1(EE,AA,ZZ,PX,PY,PZ,KSTART)
c      IF(IMETR.EQ.0) CALL ZVEZD1(EE,AA,ZZ,PX,PY,PZ,KSTART)
c      IF(IMETR.EQ.1) CALL ZVEMET(EE,AA,ZZ,PX,PY,PZ,KSTART)
c ---------------------------------------
c      GO TO 505
c 504  CONTINUE
c      CALL ZMIC2(EE,AA,ZZ,PX,PY,PZ,KSTART)
c 505  CONTINUE
      ANMOMS=ANMOMS+ANMOM
      EMOMS=EMOMS+EMOM
 503  CONTINUE
      KST1=KSTART-1
      IF(KST1.LT.1) GO TO 410
c      IF(JJJ.LE.3.AND.INUC.LE.2) PRINT 8
c 8    FORMAT(1X,'    BREAK UP.')
      DO 105 J=1,KST1
      IF(IT.GT.2) GO TO 170
c      IF(JJJ.LE.3.AND.INUC.LE.2) PRINT 7,(SPT(JPER,J),JPER=1,10)
c 7    FORMAT(1X,'SPT=',6F7.3,4F8.3)
 170  CONTINUE
      IZ=INT(SPT(8,J)+0.5)
      IA=INT(SPT(9,J)/0.94+0.5)
      IF(SPT(4,J).GT.1.) SPT(4,J)=1.
      IF(SPT(4,J).LT.-1.) SPT(4,J)=-1.
      IF(SPT(5,J).GT.1.) SPT(5,J)=1.
      IF(SPT(5,J).LT.-1.) SPT(5,J)=-1.
      IF(SPT(6,J).GT.1.) SPT(6,J)=1.
      IF(SPT(6,J).LT.-1.) SPT(6,J)=-1.
      COT=SPT(4,J)
      A=IA
      Z=IZ
      IFIS=INT(SPT(3,J)+0.1)
      IF(IFIS.EQ.1) AFIS=AFIS+A
      IF(IFIS.EQ.1) ICFI=ICFI+1
      IF(SPT(8,J).GT.ZMAX) JMAX=J
      IF(SPT(8,J).GT.ZMAX) ZMAX=SPT(8,J)
      IF(IA.LT.1.OR.IA.GT.500) GO TO 304
      HISTA(IA)=HISTA(IA)+1.
      HINZA(IA)=HINZA(IA)+IZ
      IF(IZ.EQ.22) AZ22(IA)=AZ22(IA)+1.
      IF(IZ.EQ.42) AZ42(IA)=AZ42(IA)+1.
c      IF(IZ.EQ.62) AZ62(IA)=AZ62(IA)+1.
c      IF(IZ.EQ.82) AZ82(IA)=AZ82(IA)+1.
      IF(IZ.EQ.28) AZ62(IA)=AZ62(IA)+1.
      IF(IZ.EQ.50) AZ82(IA)=AZ82(IA)+1.
 304  CONTINUE
      IF(IZ.LT.0.OR.IZ.GT.199) GO TO 305
      HISTZ(IZ+1)=HISTZ(IZ+1)+1.
      HIAZZ(IZ+1)=HIAZZ(IZ+1)+IA
 305  CONTINUE
      IF(IA.GT.25) GO TO 203
      IF(IZ.GT.10) GO TO 203
      YAZT(IA,IZ+1)=YAZT(IA,IZ+1)+1.
 203  CONTINUE
c -------------
      IF(IA.LT.1.OR.IA.GT.500.OR.IA.LE.IZ) GO TO 1061
      INN=IA-IZ
      IF(IZ.GE.10.AND.IZ.LE.19.AND.INN.GE.1.AND.INN.LE.40) 
     *YZ10A(IZ-10+1,INN)=YZ10A(IZ-10+1,INN)+1.
      IF(IZ.GE.20.AND.IZ.LE.29.AND.INN.GE.11.AND.INN.LE.60) 
     *YZ20A(IZ-20+1,INN-10)=YZ20A(IZ-20+1,INN-10)+1.
      IF(IZ.GE.30.AND.IZ.LE.39.AND.INN.GE.21.AND.INN.LE.80) 
     *YZ30A(IZ-30+1,INN-20)=YZ30A(IZ-30+1,INN-20)+1.
 1061 CONTINUE
c -------------
      IF(IZ.GT.IZMAXF) IBIG=IBIG+1
      IF(IZ.GE.3.AND.IZ.LE.IZMAXF) NZ330=NZ330+1
      IF(IZ.GE.1) NPAT=NPAT+1 
      IF(IZ.EQ.1) NZ1=NZ1+1
      IF(IZ.EQ.2) NZ2=NZ2+1
      IF(IZ.EQ.1.AND.IA.EQ.1) NPROT=NPROT+1
      IF(IZ.EQ.1.AND.IA.EQ.2) NDEUT=NDEUT+1
      IF(IZ.EQ.1.AND.IA.EQ.3) NTRIT=NTRIT+1
      IF(IZ.EQ.2.AND.IA.EQ.3) NHE3=NHE3+1
      IF(IZ.EQ.2.AND.IA.EQ.4) NHE4=NHE4+1
c      IF(IZ.GE.3) IZBOU3=IZBOU3+IZ 
      IF(IZ.GE.2) IZBOU3=IZBOU3+IZ  
      IF(IZ.GE.2) IZBOU=IZBOU+IZ    
      IF(IZ.GE.3.AND.IZ.LE.20) IMF=IMF+1
 105  CONTINUE
c ------ for max fragments ------
      IZMAX=INT(ZMAX+0.5)
      IAMAX=INT(SPT(9,JMAX)/0.94+0.5)
      IF(IZMAX.LT.0.OR.IZMAX.GT.199) GO TO 3050
      HMAZZ(IZMAX+1)=HMAZZ(IZMAX+1)+IAMAX
      HISTMZ(IZMAX+1)=HISTMZ(IZMAX+1)+1.
 3050 CONTINUE
c ------- jbn 'critical' analysis + second max fragm. ------
      SM0E=0.
      SM1E=0.
      SM2E=0.
      SM3E=0.
      DO 1051 J=1,KST1
      IF(J.EQ.JMAX) GO TO 1051
      IZ=INT(SPT(8,J)+0.5)
      IA=INT(SPT(9,J)/0.94+0.5)
      IF(IZ.LE.0.) GO TO 1051
      A=IA
      Z=IZ
      IF(Z.GT.ZMAX2) JMAX2=J
      IF(Z.GT.ZMAX2) ZMAX2=Z
      SM0=SM0+1.
      SM1=SM1+IZ
      SM2=SM2+IZ*IZ
      SM3=SM3+IZ*IZ*IZ
      SM0E=SM0E+1.
      SM1E=SM1E+IZ
      SM2E=SM2E+IZ*IZ
      SM3E=SM3E+IZ*IZ*IZ
 1051 CONTINUE
      if(sm2e.gt.0. .and. sm3e.gt.0.) then
      ISM2=INT(5.*ALOG(SM2E)+0.5)
      ISM3=INT(5.*ALOG(SM3E)+0.5)
      IF(ISM2.GE.1.AND.ISM2.LE.75.AND.ISM3.GE.1.AND.ISM3.LE.75) 
     *HISM23(ISM2,ISM3)=HISM23(ISM2,ISM3)+1.
      endif
c --------------------------------
      SNMAX=SNMAX+1.
      SAMAX=SAMAX+INT(SPT(9,JMAX)/0.94+0.5)
      EKMAX=EKMAX+1000.*SPT(7,JMAX)
      CALL THELI1(KSTART)
      NUMBFR=NUMBFR+1
      NEUTR=KST1-NPAT
      SZBOU3=SZBOU3+IZBOU3
      SZBOU=SZBOU+IZBOU
      SZMAX=SZMAX+ZMAX
      SZMA2=SZMA2+ZMAX*ZMAX
      S2ZMAX=S2ZMAX+ZMAX2
      SMBIG=SMBIG+IBIG
      SMBIG2=SMBIG2+IBIG*IBIG
      SMIMF=SMIMF+NZ330
      SMIMF2=SMIMF2+NZ330*NZ330
      IF(IZBOU.GT.0.) RMZ=RMZ+FLOAT(NZ330)/FLOAT(IZBOU)
      SNC=SNC+NPAT
      IF(IBIG.GT.0.AND.IBIG.LE.19) MCOR(IBIG+1)=MCOR(IBIG+1)+1
      IF(NZ330.GE.0.AND.NZ330.LE.19) MCI3(NZ330+1)=MCI3(NZ330+1)+1
      IF(IZBOU.GE.1.AND.IZBOU.LE.200)
     *MZB(IZBOU)=MZB(IZBOU)+1
      IF(IZBOU.GE.1.AND.IZBOU.LE.200)
     *TZB(IZBOU)=TZB(IZBOU)+TMICT
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *TZB3(IZBOU3)=TZB3(IZBOU3)+TMICT
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *MZB3(IZBOU3)=MZB3(IZBOU3)+1
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *ZMZB3(IZBOU3)=ZMZB3(IZBOU3)+ZMAX
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SFZB3(IZBOU3)=SFZB3(IZBOU3)+NZ330
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SNZB3(IZBOU3)=SNZB3(IZBOU3)+NEUTR
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SPRB(IZBOU3)=SPRB(IZBOU3)+NPROT
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SDEB(IZBOU3)=SDEB(IZBOU3)+NDEUT
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *STRB(IZBOU3)=STRB(IZBOU3)+NTRIT
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SHE3B(IZBOU3)=SHE3B(IZBOU3)+NHE3
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SHE4B(IZBOU3)=SHE4B(IZBOU3)+NHE4
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SZ1B(IZBOU3)=SZ1B(IZBOU3)+NZ1
      IF(IZBOU3.GE.1.AND.IZBOU3.LE.200)
     *SZ2B(IZBOU3)=SZ2B(IZBOU3)+NZ2
c ----------------------------------
c in 5 intervals of the reduced Zbound
      IZBI5=1+INT(5*FLOAT(IZBOU3)/Z00)
      IF(IZBI5.GT.5) IZBI5=5
      SSZR(IZBI5)=SSZR(IZBI5)+1.
      SNZR(IZBI5)=SNZR(IZBI5)+NEUTR
      SPZR(IZBI5)=SPZR(IZBI5)+NPROT
      SDZR(IZBI5)=SDZR(IZBI5)+NDEUT
      STZR(IZBI5)=STZR(IZBI5)+NTRIT
      SHE3ZR(IZBI5)=SHE3ZR(IZBI5)+NHE3
      SHE4ZR(IZBI5)=SHE4ZR(IZBI5)+NHE4
      SZ1ZR(IZBI5)=SZ1ZR(IZBI5)+NZ1
      SZ2ZR(IZBI5)=SZ2ZR(IZBI5)+NZ2
c ----------------------------------
      IF(NPAT.GE.1.AND.NPAT.LE.200)
     *MZFR(NPAT)=MZFR(NPAT)+1
      IF(NPAT.GE.1.AND.NPAT.LE.200)
     *ZMZFR(NPAT)=ZMZFR(NPAT)+ZMAX
      IF(NPAT.GE.1.AND.NPAT.LE.200)
     *SFZFR(NPAT)=SFZFR(NPAT)+NZ330
c finding B0MS and G0MS for this channel according to Myers-Swiatecki
      B0MS=0.
      G0MS=0.
      AFMS=0.
c ------
      DO 135 J=1,KST1
      IZ=INT(SPT(8,J)+0.5)
      IA=INT(SPT(9,J)/0.94+0.5)
c ------ B0MS and G0MS
      IF(IA.LE.4) GO TO 1351
      AFMS=AFMS+IA
      CALL B0G0MS(IA,IZ,BMS,GMS)
      B0MS=B0MS+BMS*IA
      G0MS=G0MS+GMS*IA
 1351 CONTINUE
c ------
      IF(IA.LE.0) GO TO 135
c -- in correlations with max fragment --
      IF(IZ.LT.0.OR.IZ.GT.199) GO TO 3051
      IF(IZMAX.LT.15) GO TO 3052
      IF(IZMAX.GT.25) GO TO 3053
      GO TO 3051
 3052 H1AZZ(IZ+1)=H1AZZ(IZ+1)+IA
      HIST1Z(IZ+1)=HIST1Z(IZ+1)+1.
      GO TO 3051
 3053 H2AZZ(IZ+1)=H2AZZ(IZ+1)+IA
      HIST2Z(IZ+1)=HIST2Z(IZ+1)+1.
      GO TO 3051
 3051 CONTINUE
c ----------------------------------------
c -- mean masses of fragments in Zbound bins --
      IF(IZ.LT.0.OR.IZ.GT.199) GO TO 3151
      IF(IZBOU3.LT.1.OR.IZBOU3.GT.200) GO TO 3151
      IF(IZ.EQ.5) NAZ5B(IZBOU3)=NAZ5B(IZBOU3)+1
      IF(IZ.EQ.5) HAZ5B(IZBOU3)=HAZ5B(IZBOU3)+IA
      IF(IZ.EQ.6) NAZ6B(IZBOU3)=NAZ6B(IZBOU3)+1
      IF(IZ.EQ.6) HAZ6B(IZBOU3)=HAZ6B(IZBOU3)+IA
      IF(IZ.EQ.7) NAZ7B(IZBOU3)=NAZ7B(IZBOU3)+1
      IF(IZ.EQ.7) HAZ7B(IZBOU3)=HAZ7B(IZBOU3)+IA
      IF(IZ.EQ.8) NAZ8B(IZBOU3)=NAZ8B(IZBOU3)+1
      IF(IZ.EQ.8) HAZ8B(IZBOU3)=HAZ8B(IZBOU3)+IA
 3151 CONTINUE
c in intervals of the reduced Zbound
      IZBI=1+INT(10*FLOAT(IZBOU3)/Z00)
      IF(IZBI.GT.10) IZBI=10
      IF(IZ.EQ.5) NAZ5BI(IZBI)=NAZ5BI(IZBI)+1
      IF(IZ.EQ.5) HAZ5BI(IZBI)=HAZ5BI(IZBI)+IA
      IF(IZ.EQ.6) NAZ6BI(IZBI)=NAZ6BI(IZBI)+1
      IF(IZ.EQ.6) HAZ6BI(IZBI)=HAZ6BI(IZBI)+IA
      IF(IZ.EQ.7) NAZ7BI(IZBI)=NAZ7BI(IZBI)+1
      IF(IZ.EQ.7) HAZ7BI(IZBI)=HAZ7BI(IZBI)+IA
      IF(IZ.EQ.8) NAZ8BI(IZBI)=NAZ8BI(IZBI)+1
      IF(IZ.EQ.8) HAZ8BI(IZBI)=HAZ8BI(IZBI)+IA
      IF(IA.GT.26) GO TO 2011
      IF(IZ.LT.0.OR.IZ.GT.10) GO TO 2011
      IF(IZBI5.EQ.1) YAZT1(IA,IZ+1)=YAZT1(IA,IZ+1)+1.
      IF(IZBI5.EQ.2) YAZT2(IA,IZ+1)=YAZT2(IA,IZ+1)+1.
      IF(IZBI5.EQ.3) YAZT3(IA,IZ+1)=YAZT3(IA,IZ+1)+1.
      IF(IZBI5.EQ.4) YAZT4(IA,IZ+1)=YAZT4(IA,IZ+1)+1.
      IF(IZBI5.EQ.5) YAZT5(IA,IZ+1)=YAZT5(IA,IZ+1)+1.
 2011 CONTINUE
      IF(IZ.LT.1.OR.IZ.GT.200) GO TO 3152
      IF(IZBI5.EQ.1.AND.IZ.GT.0) FCZB1(IZ)=FCZB1(IZ)+1.
      IF(IZBI5.EQ.2.AND.IZ.GT.0) FCZB2(IZ)=FCZB2(IZ)+1.
      IF(IZBI5.EQ.3.AND.IZ.GT.0) FCZB3(IZ)=FCZB3(IZ)+1.
      IF(IZBI5.EQ.4.AND.IZ.GT.0) FCZB4(IZ)=FCZB4(IZ)+1.
      IF(IZBI5.EQ.5.AND.IZ.GT.0) FCZB5(IZ)=FCZB5(IZ)+1.
      IF(IZBI5.EQ.1.AND.IZ.GT.0) FNZB1(IZ)=FNZB1(IZ)+IA
      IF(IZBI5.EQ.2.AND.IZ.GT.0) FNZB2(IZ)=FNZB2(IZ)+IA
      IF(IZBI5.EQ.3.AND.IZ.GT.0) FNZB3(IZ)=FNZB3(IZ)+IA
      IF(IZBI5.EQ.4.AND.IZ.GT.0) FNZB4(IZ)=FNZB4(IZ)+IA
      IF(IZBI5.EQ.5.AND.IZ.GT.0) FNZB5(IZ)=FNZB5(IZ)+IA
 3152 CONTINUE
c ----------------------------------------
      AIA=IA
      ZIZ=IZ
      IF(IEVP.LE.1.OR.IEX.EQ.0) CALL DELAM(AIA,ZIZ,DLIAZ,DSIAZ,BRIAZ)
      UAIAZ=0.
      IUAIAZ=0
      IUAIAZ=INT(SPT(1,J)+0.5)
      IF(IUAIAZ.EQ.1) UAIAZ=1000.*SPT(2,J)/AIA
      IF(IEVP.GT.1.AND.IEX.GT.0) 
     *CALL DELAM0(AIA,ZIZ,DLIAZ,DSIAZ,BRIAZ,UAIAZ,WWIAZ)
      IF(ICOLE.GE.0) ETM=ETM+0.001*DLIAZ
      IF(ICOLE.EQ.-1) CALL ELIDR(AIA,ZIZ,DLIAZ)
      IF(ICOLE.EQ.-1) ETM=ETM+0.001*(DLIAZ+(8.071*AIA-0.782*ZIZ))
      COT=SPT(4,J)
      SIT=SQRT(1.-COT*COT)
      CALL TINP(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
c      CALL TINP0(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
      PTX=PTX+PP(1)
      PTY=PTY+PP(2)
      PTZ=PTZ+PP(3)
      ETK=ETK+SPT(7,J)
      ATM=ATM+SPT(9,J)/0.94
      ZTM=ZTM+SPT(8,J)
      SUAIAZ=SUAIAZ+0.001*AIA*UAIAZ
 135  CONTINUE
c ------ B0MS and G0MS
      IF(AFMS.LE.0.) GO TO 6081
      NUMBMS=NUMBMS+1
      B0MS=B0MS/AFMS
      G0MS=G0MS/AFMS
      BEMS=BEMS+B0MS
      GEMS=GEMS+G0MS
 6081 CONTINUE
c ------
c      IF(JJJ.LE.3) PRINT 608,PTX,PTY,PTZ,ETM,ETK,SUAIAZ,ATM,ZTM
c 608  FORMAT(2X,'sum. balance:      PTX, PTY, PTZ=',3F9.3/
c     *2X,' ETM , ETK=',2F8.4,' SUAIAZ=',F7.4,'   ATM, ZTM=',2F7.2)
c -- writing the event --
      IF(JWRITE.EQ.0) GO TO 182
      ITWRI=ITWRI+1
      NUMPAT=KST1
ccc      WRITE(51,136)NUMPAT
ccc 136  FORMAT(I3)
      ENEXW=ENEXT*1000.
c      WRITE(51,*)NUMPAT,AN,ZN,ENEXW,FKACOL
      NEUTR=KST1-NPAT
c      WRITE(59,*)IZ0,IA0,ETOT,KST1,NEUTR,IMF
c      IF(IENS.NE.1) WRITE(59,591)IZ0,IA0,ETOT,NPAT,NEUTR,IMF
c      IF(IENS.EQ.1) WRITE(59,591)IZN,IAN,ETN,NPAT,NEUTR,IMF,IZBOU
c 591  FORMAT(I4,I4,F8.5,I4,I4,I3,I4)
c --------- writing info on hot fragments ...HFD... ---------
      JWRIDA=0
      IF(JWRIDA.EQ.0) GO TO 593
c THFD-temper., IPHFD-charg.frag., INHFD-neutrons, IAHFD,IZHFD-mass/charge of 
c frag., UHFD-intern.excit.frag., PX,Y,ZHFD-momenta frag., ECHFD-Coul/bar.
c      WRITE(59,594)IPHFD,INHFD,THFD,ECHFD
c 594  FORMAT(I4,I4,F7.3,F8.5)
c      DO 595 J=1,IPHFD
c      WRITE(59,596)IZHFD(J),IAHFD(J),UHFD(J),PXHFD(J),PYHFD(J),PZHFD(J)
c 596  FORMAT(I4,I4,F8.5,F10.5,F10.5,F10.5)
c 595  CONTINUE
 593  CONTINUE
c -----------------------------------------------------------
c      PHIRAN=360.0*RNDMSMM(-1) ! for add. randomization
      zmax=0.
      indice=0
      do kbid=1,200
      
      xcv(kbid)=0.
      ycv(kbid)=0.
      zcv(kbid)=0.
      pcv(kbid)=0.
      enddo
      DO 134 J=1,KST1
      IZP=INT(SPT(8,J)+0.5)
c -- excluding neutrons from writing --
c      IF(IZP.LE.0.) GO TO 134
c -------------------------------------
      IAP=INT(SPT(9,J)/0.94+0.5)
      EKIN=1000.*SPT(7,J)
      COT=SPT(4,J)
      SIT=SQRT(1.-COT*COT)
      COTE=SPT(4,J)
      COFI=SPT(6,J)
      ANTET=(180./3.14159)*ACOS(COTE)
      ANPHI=(180./3.14159)*ACOS(COFI)
      IF(SPT(5,J).LT.0.) ANPHI=360.-ANPHI
      IF(ANPHI.GE.360.) ANPHI=ANPHI-360.
c --- add. randomization on PHI (since rotation is only along X) -------
      IF(IAMOM.GT.0) ANPHI=ANPHI+PHIRAN
      IF(IAMOM.GT.0.AND.ANPHI.GE.360.) ANPHI=ANPHI-360.
      AOFI=(3.14159/180.)*ANPHI
      SPT(6,J)=COS(AOFI)
      SPT(5,J)=SIN(AOFI)
 912  CONTINUE
c ----------------------------------------------------------------------
      CALL TINP(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
c      CALL TINP0(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
      EKIN=1000.*SPT(7,J)
c ---- reajust. for evaporation with 2S: turning Z-axis into Y-axis ----
      IF(IMULF.GT.0) GO TO 1311
      IF(I2S.LE.0) GO TO 1311
      P2SCR(1)=PP(1)
      P2SCR(2)=PP(2)
      P2SCR(3)=PP(3)
      PP(1)=P2SCR(2)
      PP(2)=P2SCR(3)
      PP(3)=P2SCR(1)
 1311 CONTINUE
      R2SP=SPT(10,J)
      IF(R2SP.GT.10000000.0) R2SP=10000000.0
      AS1=SPT(1,J)
      US1=SPT(2,J)
      RS1=SPT(3,J)
c -------------------------------------
ccc      WRITE(51,137)IAP,IZP,EKIN,ANTET,ANPHI
ccc 137  FORMAT(I4,I5,F8.1,F7.2,F7.2)
c      WRITE(51,*)IAP,IZP,EKIN,ANTET,ANPHI
c      WRITE(59,*)IAP,IZP,PP(1),PP(2),PP(3)
c ------ for I2S=1: R2SP-distance from the second source, AS1- mass of the 
c (1-st) source, US1- excit.energy (GeV), RS1 - ang.moment.(h-bar), before 
c evaporation of this particle. -------
c      WRITE(59,592)IAP,IZP,PP(1),PP(2),PP(3),R2SP,AS1,US1,RS1
c      WRITE(59,592)IAP,IZP,PP(1),PP(2),PP(3)
cc ----- in lab.system , with source velocities: VNP and VNT -----
c      PP2(1)=PP(1)
c      PP2(2)=-PP(2)
c      PP2(3)=PP(3)
cc ----- writing for projectile emission in lab.system. For INDRA
c      EPP=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+SPT(9,J)**2)
c      CALL CLPV(PP,VNP,PPL,EPP)
c      WRITE(59,592)IZP,IAP,PPL(1),PPL(2),PPL(3)
cc ----- writing for target emission (= projectile, symmetric) in lab. 
cc ----- system. For INDRA - Au + Au periph. collisions 
c      CALL CLPV(PP2,VNT,PPL,EPP)
c      WRITE(59,592)IZP,IAP,PPL(1),PPL(2),PPL(3)
c -----------------------------------------------
c 592  FORMAT(I4,I4,F10.5,F10.5,F10.5,F11.1,F6.1,F8.5,F7.2)
c -- writing of tau's and coordinates at evaporation moment --
      IF(I2S.LE.0) GO TO 2002
      IF(ITAUR.LE.0) GO TO 2002
      XJJ1=STAUR(4,J)
      YJJ1=STAUR(5,J)
      ZJJ1=STAUR(6,J)
      STAUR(4,J)=YJJ1
      STAUR(5,J)=ZJJ1
      STAUR(6,J)=XJJ1
      XJJ1=STAUR(7,J)
      YJJ1=STAUR(8,J)
      ZJJ1=STAUR(9,J)
      STAUR(7,J)=YJJ1
      STAUR(8,J)=ZJJ1
      STAUR(9,J)=XJJ1
      IF(STAUR(1,J).GT.999900.0) STAUR(1,J)=999900.0
      IF(STAUR(2,J).GT.999900.0) STAUR(2,J)=999900.0
      IF(STAUR(3,J).GT.999900.0) STAUR(3,J)=999900.0
      DO 2003 JJ1=4,9
      IF(STAUR(JJ1,J).GT.99990.0) STAUR(JJ1,J)=99990.0
      IF(STAUR(JJ1,J).LT.-9999.0) STAUR(JJ1,J)=-9999.0
 2003 CONTINUE
c      WRITE(59,692)(STAUR(JJ1,J),JJ1=1,9)
c 692  FORMAT(3F9.1,6F8.2)
 2002 CONTINUE
c ----------------------
      acv(j)=float(IAP)
      zpcv(j)=float(IZP)
      if(zpcv(j).gt.zmax)then
       zmax=zpcv(j)
       indice=j
       endif
c      ecv(j)=EKIN
c      tcv(j)=acos(SPT(4,j))*180/3.1415
c      write(6,*)'sinth',1.-SPTU(4,I3)*SPTU(4,I3),ecv(i3),zcv(i3),acv(i3)
      sinth=0
      aa=1.-SPT(4,j)*SPT(4,j)
      if(aa.le.1.)then
      sinth=sqrt(1.-SPT(4,j)*SPT(4,j))
      endif
c      write(6,*)i3,acv(i3),zcv(i3),ecv(i3),tcv(i3),sinth
      pmod=0.
      if(ekin.gt.0.)then      
      pmod=ekin*sqrt(1.+2.*931.4942*acv(j)/ekin)
      pcv(j)=pmod
       ycv(j)=sinth * SPT(5,j)
       xcv(j)=sinth * SPT(6,j)
       zcv(j)=SPT(4,j)
c       rapiev(j)=zzcv(j)/(ecv(j)+931.4942*acv(j))
       endif
 134  CONTINUE
c      print *,'   writing one event in file    NPAT=',NPAT
 182  CONTINUE
c --- writnig events for JBN projects: small 'critical' + Sup-Heavy systems
      IF(JWRJBN.EQ.0) GO TO 115
      ITWRI=ITWRI+1
      NEUTR=KST1-NPAT
c      WRITE(51,116)IA0,IZ0,ETOT,NPAT,NEUTR
c 116  FORMAT(I4,I4,F8.5,I4,I4)
      DO 117 J=1,KST1
      IZP=INT(SPT(8,J)+0.5)
c -- excluding neutrons from writing --
c      IF(IZP.LE.0.) GO TO 117
c -------------------------------------
      IAP=INT(SPT(9,J)/0.94+0.5)
      COT=SPT(4,J)
      SIT=SQRT(1.-COT*COT)
      CALL TINP(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
c      WRITE(51,118)IAP,IZP,PP(1),PP(2),PP(3)
c 118  FORMAT(I4,I4,F10.5,F10.5,F10.5)
 117  CONTINUE
c      print *,'   writing one event in file    NPAT=',NPAT
 115  CONTINUE
c -----------------------
      EKINZ0=0.
      NUMPAT=KST1
c      PHIRAN=360.0*RNDMSMM(-1)
      NFRAGG=0
      ICDC=0
      DO 138 J=1,KST1
      IZP=INT(SPT(8,J)+0.5)
      IAP=INT(SPT(9,J)/0.94+0.5)
      IF(IZP.LE.0) GO TO 910
      NFRAGG=NFRAGG+1
      IAAA(NFRAGG)=IAP
      IZZZ(NFRAGG)=IZP
      COT=SPT(4,J)
      SIT=SQRT(1.-COT*COT)
      CALL TINP(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
c      CALL TINP0(PP,COT,SIT,SPT(6,J),SPT(5,J),SPT(7,J),SPT(9,J))
c ---- reajust. for evaporation with 2S: turning Z-axis into Y-axis ----
      IF(IMULF.GT.0) GO TO 1312
      IF(I2S.LE.0) GO TO 1312
      P2SCR(1)=PP(1)
      P2SCR(2)=PP(2)
      P2SCR(3)=PP(3)
      PP(1)=P2SCR(2)
      PP(2)=P2SCR(3)
      PP(3)=P2SCR(1)
 1312 CONTINUE
      PXXX(NFRAGG)=1000.*PP(1)
      PYYY(NFRAGG)=1000.*PP(2)
      PZZZ(NFRAGG)=1000.*PP(3)
      ICDC=NFRAGG
      PCDC(1,ICDC)=PP(1)
      PCDC(2,ICDC)=PP(2)
      PCDC(3,ICDC)=PP(3)
      RCDC(1,ICDC)=0.
      RCDC(2,ICDC)=0.
      RCDC(3,ICDC)=0.
      ACDC(ICDC)=IAP*0.94
      ZCDC(ICDC)=IZP
 910  CONTINUE
      EKIN=1000.*SPT(7,J)
      COTE=SPT(4,J)
      SITE=1.-COTE*COTE
      COFI=SPT(6,J)
      ANTET=(180./3.14159)*ACOS(COTE)
      ANPHI=(180./3.14159)*ACOS(COFI)
      IF(SPT(5,J).LT.0.) ANPHI=360.-ANPHI
c --- add. randomization on PHI (since rotation is only along X) -------
c      IF(IAMOM.GT.0) ANPHI=ANPHI+PHIRAN
c      IF(IAMOM.GT.0.AND.ANPHI.GE.360.) ANPHI=ANPHI-360.
c -------------------------------------
c new part. characteristics: IAP,IZP,EKIN,ANTET,ANPHI
      APAT(J)=IAP
      ZPAT(J)=IZP
      EKIP(J)=EKIN
      TETP(J)=ANTET
      PHIP(J)=ANPHI
      IF(IZP.GE.1) EKINZ0=EKINZ0+EKIN*SITE
      IF(IZP.GE.1) EKINZ=EKINZ+EKIN*SITE
      IF(IZP.GE.1) NUMBZ=NUMBZ+1 
      IF(IZP.GE.1) EKZ(IZP)=EKZ(IZP)+EKIN 
      IF(IZP.GE.1) ETRZ(IZP)=ETRZ(IZP)+EKIN*(1.-COTE*COTE)
      IF(IZP.GE.1) NUMZ(IZP)=NUMZ(IZP)+1
      IF(IZP.GE.1) NUMZA(IZP)=NUMZA(IZP)+IAP
c ------------------------
      ACOTE=ABS(COTE)
      IF(IZP.GE.1.AND.ACOTE.GE.0.5) EKZL(IZP)=EKZL(IZP)+EKIN
      IF(IZP.GE.1.AND.ACOTE.GE.0.5) NUMZL(IZP)=NUMZL(IZP)+1
      IF(IZP.GE.1.AND.ACOTE.LT.0.5) EKZT(IZP)=EKZT(IZP)+EKIN
      IF(IZP.GE.1.AND.ACOTE.LT.0.5) NUMZT(IZP)=NUMZT(IZP)+1
c ------------------------
 138  CONTINUE
      EKINZ2=EKINZ2+EKINZ0*EKINZ0 
      CALL CDCR(A00,Z00,ICDC,ACDC,ZCDC,PCDC,RCDC)
c      CALL CHACO(A00,Z00,ICDC,ACDC,ZCDC)
      CALL CLPC(A00,Z00,ICDC,ACDC,ZCDC,PCDC,RCDC)
      CALL DMR
      CALL CPOCH1(NUMPAT)
      CALL CSPEC1(NUMPAT)
      CALL CSPEC2(KST1,APAT,ZPAT,EKIP,TETP,PHIP)
      CALL CINDR(A00,Z00,ICDC,ACDC,ZCDC,PCDC,RCDC)
      CALL CLASSA(A00,Z00,ICDC,ACDC,ZCDC,PCDC,RCDC)
      NUMPA1=NUMPAT-1
      DO 141 J1=1,NUMPA1
      J11=J1+1
      IAP1=APAT(J1)
      IZP1=ZPAT(J1)
      DO 142 J2=J11,NUMPAT
      IAP2=APAT(J2)
      IZP2=ZPAT(J2)
      IF(IAP1.EQ.4.AND.IZP1.EQ.2.AND.IAP2.EQ.4.AND.IZP2.EQ.2) GO TO 143
      GO TO 142
 143  CONTINUE
      DPHI=ABS(PHIP(J1)-PHIP(J2))
      IF(DPHI.GT.180.) DPHI=360.-DPHI
      CALL HIST1(DPHI,0.,180.,9.,RPHI,26,1.)
 142  CONTINUE
 141  CONTINUE
c
 410  CONTINUE
c ******* end of writing in file ******
      IF(JWRITE.EQ.0) GO TO 183
c      CLOSE(59)
c      print *,' WRITE in file finished  ITNUM=',ITNUM,' ITWRI=',ITWRI
 183  CONTINUE
      IF(JWRJBN.EQ.0) GO TO 119
c      CLOSE(51)
c      print *,' WRITE in file finished  ITNUM=',ITNUM,' ITWRI=',ITWRI
 119  CONTINUE
c ***************************************
c      PRINT 5,INUC,NUMB,NUMBFR
c 5    FORMAT(2X,' NUMBER OF NUCL. - INUC=',I6,' NUMB=',I6,
c     *' NUMBFR=',I6)
c ------- BEMS and GEMS: 
      if(numbms.ne.0) then
      BEMS=BEMS/FLOAT(NUMBMS)
      GEMS=GEMS/FLOAT(NUMBMS)
      endif
c      PRINT 1352,BEMS,GEMS
c 1352 FORMAT(2X,'mean frag(A>4) surf/symm ener',
c     *' Myers-Swiatecki: BEMS, GEMS=',2F8.3)
c for RESNUC ensemble ---------
      IF(IENS.NE.1) GO TO 4006
c      PRINT 4001
c 4001 FORMAT(2X,' EVENTS :    AN,ENO:')
c      PRINT 4002,(ARES(I),ERES(I),I=1,100)
c 4002 FORMAT(2X,F5.0,F5.2,3X,F5.0,F5.2,3X,F5.0,F5.2,3X,
c     *F5.0,F5.2,3X,F5.0,F5.2)
c      PRINT 4003
c 4003 FORMAT(2X,'distribution of nuclei in Y (A/A0)',
c     *', from 0 to 1, step-0.05')
c      PRINT 4005,(RY(I),I=1,26)
c      PRINT 4004
c 4004 FORMAT(2X,'distribution of nuclei in E (MeV/n)',
c     *', from 0 to 10, step-0.5')
c      PRINT 4005,(RE(I),I=1,26)
c 4005 FORMAT(2X,10F8.1)
 4006 CONTINUE
c -----------------------------
c
      IF(NUMB.GT.0) EKINZ=EKINZ/FLOAT(NUMB)
      IF(NUMB.GT.0) EKINZ2=EKINZ2/FLOAT(NUMB)
      IF(NUMB.GT.0) NUMBZ=NUMBZ/FLOAT(NUMB)
      DDD=EKINZ2-EKINZ*EKINZ
      IF(DDD.LE.0.) EKINZ2=0.
      IF(DDD.GT.0.) EKINZ2=SQRT(DDD)
c      PRINT 750,NUMBZ,EKINZ,EKINZ2
c 750  FORMAT(1X,' numb.of charg.part. in event NUMBZ=',F6.2/2X,
c     *'their aver.transv.energ. EKINZ=',F8.3,'  and variance =',F7.3)
      IF(IT.GT.2) GO TO 171
      IF(IMULF.EQ.0) GO TO 171
      DO 602 IJIJ=1,IA0
      IF(FRA(IJIJ).GT.0.) EXFRA(IJIJ)=EXFRA(IJIJ)/FRA(IJIJ)
      IF(FRA(IJIJ).GT.0.) EKFRA(IJIJ)=EKFRA(IJIJ)/(IJIJ*FRA(IJIJ))
      IF(FRA(IJIJ).GT.0.) FRZ(IJIJ)=FRZ(IJIJ)/FRA(IJIJ)
      IF(FRA(IJIJ).GT.0.) FRZ2(IJIJ)=FRZ2(IJIJ)/FRA(IJIJ)
      DDD=FRZ2(IJIJ)-FRZ(IJIJ)*FRZ(IJIJ)
      IF(DDD.LE.0.) FRZ2(IJIJ)=0.
      IF(DDD.GT.0.) FRZ2(IJIJ)=SQRT(DDD)
      IF(MFRAG.GT.0) FRA(IJIJ)=FRA(IJIJ)/FLOAT(MFRAG)
 602  CONTINUE
      IF(MFRAG.GT.0) SAAM=SAAM/FLOAT(MFRAG)
      IF(MFRAG.GT.0) SEKAM=SEKAM/(SAAM*FLOAT(MFRAG))
      IF(MFRAG.GT.0) SEXAM=SEXAM/FLOAT(MFRAG)
      IF(MFRAG.GT.0) SSEKX=SSEKX/FLOAT(IA0*MFRAG)
      IF(MFRAG.GT.0) SSEX=SSEX/FLOAT(IA0*MFRAG)
      IF(MFRAG.GT.0) SPSR=SPSR/FLOAT(MFRAG)
      IF(MFRAG.GT.0) SNSR=SNSR/FLOAT(MFRAG)
      IF(MFRAG.GT.0) S3SR=S3SR/FLOAT(MFRAG)
      IF(MFRAG.GT.0) Z3SR=Z3SR/FLOAT(MFRAG)
      IF(MFRAG.GT.0) ECOLBS=ECOLBS/FLOAT(MFRAG)
      IF(ITMUL.EQ.0.OR.MFRAG.LE.0) GO TO 6020
      ESRP=ESRP/FLOAT(MFRAG)
      ESRP2=ESRP2/FLOAT(MFRAG)
      DDD=ESRP2-ESRP*ESRP
      IF(DDD.LE.0.) ESRP2=0.
      IF(DDD.GT.0.) ESRP2=SQRT(DDD)
c      PRINT 6021,TMUL,MFRAG,ESRP,ESRP2
c 6021 FORMAT(2X,'fixed temp (MeV) TMUL=',F6.2,' # events MFRAG=',I7/2X,
c     *'aver.excit.energ. (MeV/N) ESRP=',F9.4,' variance ESRP2=',F8.4)
 6020 CONTINUE
c      PRINT 601,MFRAG,SPSR,S3SR,Z3SR,SNSR,ECOLBS
c 601  FORMAT(2x,'numb. of zvezd1-events: MFRAG=',I6/
c     *2X,'avr.before second.de-excit.: charg.part. SPSR=',F6.2,
c     *' S3SR=',F6.2,' Z3SR=',F6.2/2X,'neutrons: SNSR=',F6.2/
c     *2X,'avr.(W-Z)Coulomb barr. ECOLBS=',F9.4)
c      PRINT 631,SAAM,SEXAM,SEKAM,SSEKX,SSEX
c 631  FORMAT(2X,'hot max fragm: SAAM=',F6.2/
c     *1X,' its exit(MeV/n) SEXAM=',F6.2,' ekin(MeV/n) SEKAM=',F6.2/
c     *2X,'sum: kin.(coul)+exit.energ.of all prim.frag.(MeV/n) SSEKX=',
c     *F6.2/2X,'sum of exit.energ.all prim.frag.(MeV/n) SSEX=',F6.2)
c -- for second source --
      IF(RYSEC.LT.-100.) GO TO 939
c      PRINT 932
c 932  FORMAT(1X,'distr.of IMF.fragm. in Y-coord., -10:+10 fm',
c     *' (step=0.5fm)  RYIMF:')
c      PRINT 933,(RYIMF(J),J=1,40)
c      PRINT 934,(RYIMF(J),J=41,46)
c 933  FORMAT(1X,10F7.0)
c 934  FORMAT(1X,6F12.2)
      DO 935 I=1,40
      IF(RYIMF(I).GT.0.) AIMF(I)=AIMF(I)/RYIMF(I)
 935  CONTINUE
c      PRINT 936
c 936  FORMAT(1X,'masses of IMF.fragm. in Y-coord., -10:+10 fm',
c     *' (step=0.5fm)  AIMF:')
c      PRINT 937,(AIMF(J),J=1,40)
c 937  FORMAT(1X,10F7.2)
c      PRINT 934,(RYIMF(J),J=41,46)
      IF(YRL0.GT.0.) ARL0=ARL0/YRL0
      IF(YRG0.GT.0.) ARG0=ARG0/YRG0
c      PRINT 938,YRL0,ARL0,YRG0,ARG0
c 938  FORMAT(2X,'for coord. <0: yield YRL0=',F7.0,' mass ARL0=',F7.3/
c     *2X,'for coord. >0: yield YRG0=',F7.0,' mass ARG0=',F7.3)
 939  CONTINUE
c --
c      PRINT 623
c 623  FORMAT(12X,'mass distribution of hot fragments')
c      PRINT 603,(FRA(IJIJ),IJIJ=1,IA0)
c 603  FORMAT(3x,'FRA=',10F7.4)
c      PRINT 630
c 630  FORMAT(12X,'charge distribution of hot fragments')
c      PRINT 632,(FRZ(IJIJ),IJIJ=1,IA0)
c 632  FORMAT(3x,'FRZ=',10F7.3)
c      PRINT 633
c 633  FORMAT(12X,'variance of charge of hot fragments')
c      PRINT 634,(FRZ2(IJIJ),IJIJ=1,IA0)
c 634  FORMAT(2x,'FRZ2=',10F7.3)
c      PRINT 621
c 621  FORMAT(12X,'excitation energies (MeV/N) of hot fragments')
c      PRINT 611,(EXFRA(IJIJ),IJIJ=1,IA0)
c 611  FORMAT(1x,'EXFRA=',10F7.3)
c -------- writing on unit 52 vs. fragment masses ---------
      if(numbfr.gt.0) then
      DO 104 L1=1,IZ0
      IF(NUMZ(L1).GT.0) HISZA(L1)=FLOAT(NUMZA(L1))/FLOAT(NUMZ(L1))
 104  HISZ(L1)=FLOAT(NUMZ(L1))/FLOAT(NUMBFR)
      DO 1033 L1=1,IA0
 1033 HISA(L1)=HISTA(L1)/FLOAT(NUMBFR)
      endif
      IF(JWRITD.EQ.0) GO TO 101
      DO 103 L1=1,IA0
c      WRITE(52,102)L1,HISA(L1),FRA(L1),FRZ(L1),FRZ2(L1),EXFRA(L1)
c 102  FORMAT(1X,I4,1X,F8.4,1X,F8.4,1X,F7.3,1X,F6.3,1X,F7.3)
 103  CONTINUE
 101  CONTINUE
c -------------------------------------------------
      CALL BFRENE(IA0,MFRAG)
c      PRINT 622
c 622  FORMAT(12X,'kinetic energies (MeV/N) of hot fragments')
c      PRINT 612,(EKFRA(IJIJ),IJIJ=1,IA0)
c 612  FORMAT(1x,'EKFRA=',10F7.2)
 171  CONTINUE
c
      IF(IMULF.EQ.0) GO TO 931
      IF(IMETR.EQ.0) GO TO 931
c      PRINT 930,MENEW,MENEWR,LNUCL,XPLC1,XPLC2,XPLC0,XPLCU,XPLCT
c 930  FORMAT(2X,'Tot.numb.of new events in gener.metrop.ensemble:',
c     *' MENEW=',I9/2X,'numb.new events with chang.positions only:',
c     *' MENEWR=',I9/2X,'index of metrop.pass-break-up',
c     *' (0-usual random, 1-only via nucleons) LNUCL=',I2/
c     *2X,'numb."empty" position.at freezout:    XPLC1=',F10.0/
c     *2X,'XPLC2=',F10.0,' XPLC0=',F10.0,' XPLCU=',F10.0,
c     *' XPLCT=',F10.0)
c      PRINT 931,IMEC,IME1,IME2,IME3,IME4,IME5,IME6,IME7
c 931  FORMAT(2X,'**indexes including diff.metrop.pass channels**'/2X, 
c     *'  disint.compound: IMEC=',I2,' abs.-emis. nucleon: IME1=',I2/2X,
c     *'break-up into two: IME2=',I2,'  fusion of the two: IME3=',I2/2X,
c     *'redistr.betwn.two: IME4=',I2,' charge-exch.of two: IME5=',I2/2X,
c     *'change posit. one: IME6=',I2,'  change posit. all: IME7=',I2)
c      PRINT 920,IMET0,NUMET
c 920  FORMAT(2X,'after Metropolis sampling freezout: IMET0=',I9,
c     *'  events: NUMET=',I6)
      IF(NUMET.GT.0) SMETS=SMETS/FLOAT(NUMET)
      IF(NUMET.GT.0) SMET2=SMET2/FLOAT(NUMET)
      DDD=SMET2-SMETS*SMETS
      IF(DDD.GT.0.) SMET2=SQRT(DDD)
      IF(DDD.LE.0.) SMET2=0.
      IF(NUMET.GT.0) EC2MES=EC2MES/FLOAT(NUMET)
      IF(NUMET.GT.0) EC2ME2=EC2ME2/FLOAT(NUMET)
      DDD=EC2ME2-EC2MES*EC2MES
      IF(DDD.GT.0.) EC2ME2=SQRT(DDD)
      IF(DDD.LE.0.) EC2ME2=0.
      IF(NUMET.GT.0) ECMETS=ECMETS/FLOAT(NUMET)
      IF(NUMET.GT.0) ECMET2=ECMET2/FLOAT(NUMET)
      DDD=ECMET2-ECMETS*ECMETS
      IF(DDD.GT.0.) ECMET2=SQRT(DDD)
      IF(DDD.LE.0.) ECMET2=0.
      IF(NUMET.GT.0) TMETS=TMETS/FLOAT(NUMET)
      IF(NUMET.GT.0) TMET2=TMET2/FLOAT(NUMET)
      DDD=TMET2-TMETS*TMETS
      IF(DDD.GT.0.) TMET2=SQRT(DDD)
      IF(DDD.LE.0.) TMET2=0.
      IF(NUMET.GT.0) TMMMS=TMMMS/FLOAT(NUMET)
      IF(NUMET.GT.0) TMMM2=TMMM2/FLOAT(NUMET)
      DDD=TMMM2-TMMMS*TMMMS
      IF(DDD.GT.0.) TMMM2=SQRT(DDD)
      IF(DDD.LE.0.) TMMM2=0.
      IF(NUMET.GT.0) FMEN=FMEN/FLOAT(NUMET)
      IF(NUMET.GT.0) FMEN2=FMEN2/FLOAT(NUMET)
      DDD=FMEN2-FMEN*FMEN
      IF(DDD.GT.0.) FMEN2=SQRT(DDD)
      IF(DDD.LE.0.) FMEN2=0.
      IF(NUMET.GT.0) FMEP=FMEP/FLOAT(NUMET)
      IF(NUMET.GT.0) FMEP2=FMEP2/FLOAT(NUMET)
      DDD=FMEP2-FMEP*FMEP
      IF(DDD.GT.0.) FMEP2=SQRT(DDD)
      IF(DDD.LE.0.) FMEP2=0.
      IF(NUMET.GT.0) FMEA=FMEA/FLOAT(NUMET)
      IF(NUMET.GT.0) FMEA2=FMEA2/FLOAT(NUMET)
      DDD=FMEA2-FMEA*FMEA
      IF(DDD.GT.0.) FMEA2=SQRT(DDD)
      IF(DDD.LE.0.) FMEA2=0.
      IF(NUMET.GT.0) FMEF=FMEF/FLOAT(NUMET)
      IF(NUMET.GT.0) FMEF2=FMEF2/FLOAT(NUMET)
      DDD=FMEF2-FMEF*FMEF
      IF(DDD.GT.0.) FMEF2=SQRT(DDD)
      IF(DDD.LE.0.) FMEF2=0.
      DO 921 I=1,IA0
      IF(FMA(I).GT.0.) FCHA(I)=FCHA(I)/FMA(I)
      IF(FMA(I).GT.0.) FCH2(I)=FCH2(I)/FMA(I)
      DDD=FCH2(I)-FCHA(I)*FCHA(I)
      IF(DDD.GT.0.) FCH2(I)=SQRT(DDD)
      IF(DDD.LE.0.) FCH2(I)=0.
 921  CONTINUE
c      PRINT 922,NUMET
c 922  FORMAT(5X,'primary fragments (after ',I6,' events)  FMA(1-IA0):')
c      PRINT 923,(FMA(I),I=1,IA0)
c 923  FORMAT(2X,10F7.0)
c 924  FORMAT(2X,10F7.3)
c      PRINT 925
c 925  FORMAT(5X,'avr. charges of the primary fragments   FCHA(1-IA0):')
c      PRINT 924,(FCHA(I),I=1,IA0)
c      PRINT 926
c 926  FORMAT(9X,'variances of the charges   FCH2(1-IA0):')
c      PRINT 924,(FCH2(I),I=1,IA0)
c      PRINT 927,FMEA,FMEA2,FMEF,FMEF2,FMEN,FMEN2,FMEP,FMEP2
c 927  FORMAT(2X,'numb.all part. FMEA=',F7.3,' +-',F7.3,
c     *'  numb.fragm.(A>4) FMEF=',F7.3,' +-',F7.3/
c     *2X,'numb.neutrons FMEN=',F7.3,' +-',F7.3,
c     *'  numb.protons FMEP=',F7.3,' +-',F7.3)
c      PRINT 928,SMETS,SMET2,ECMETS,ECMET2,TMETS,TMET2,TMMMS,TMMM2,
c     *EC2MES,EC2ME2
c 928  FORMAT(2X,'avr.entropy: SMETS=',F8.3,' +-',F7.3/1X,
c     *'  Coulomb barrier: ECMETS=',F8.3,' +-',F7.3/
c     *2X,'avr.temperature: TMETS=',F7.3,' +-',F6.3/1X,
c     *'  inverse temperature (1/T): TMMMS=',F7.4,' +-',F7.4/
c     *2X,'avr.second source Coulomb barrier: EC2MES=',F8.3,' +-',F7.3)
c ---------------------------------
c      PRINT 958
c 958  FORMAT(2X,'disribution of entropies SDIS',
c     *' (SSR-0.5 to SSR+0.5 1/n, step-0.005):')
c 958  FORMAT(2X,'disribution of entropies SDIS',
c     *' (0 to 4 1/n, step-0.01):')
c      PRINT 959,(SDIS(I),I=1,400)
c 959  FORMAT(2X,10F7.0)
c      PRINT 957,(SDIS(I),I=401,406)
c 957  FORMAT(2X,6F12.3)
c      DO 966 I=1,400
c      IF(SDIS(I).GT.0.) ASDIS(I)=ASDIS(I)/SDIS(I)
c      IF(SDIS(I).GT.0.) PSDIS(I)=PSDIS(I)/SDIS(I)
 966  CONTINUE
c      PRINT 968
c 968  FORMAT(2X,'avr.max.frag. versus entropies (SDIS) ASDIS:')
c      PRINT 969,(ASDIS(I),I=1,400)
c 969  FORMAT(2X,10F7.2)
c      PRINT 967,(ASDIS(I),I=401,406)
c 967  FORMAT(2X,6F12.2)
c      PRINT 970
c 970  FORMAT(2X,'hot fragment.multiplicity vs. entrop. (SDIS) PSDIS:')
c      PRINT 969,(PSDIS(I),I=1,400)
c      PRINT 967,(PSDIS(I),I=401,406)
c      PRINT 971
c 971  FORMAT(2X,'multiplicity hot fragm. distrib. PMUL(1-IA0):')
c      PRINT 959,(PMUL(I),I=1,IA0)
 931  CONTINUE
c ---------------------------------
c      PRINT 929
c 929  FORMAT(10X,'--- Cold fragments ---')
c
      IF(ICFI.GT.0) AFFS=AFIS/FLOAT(ICFI)
c      PRINT 140,ICFI,AFFS
c 140  FORMAT(2X,'NUMBER OF FIS.FRAGM.  ICFI=',I6,5X,
c     *'MEAN FIS.FRAGM.  AFFS=',F8.3)
c      PRINT 312,HISTA(1)
c 312  FORMAT(2X,'MASS YIELD - A (FROM 1 TO IA0) [HISTA(1)=',F9.0,
c     *'] HISTA:')
c      PRINT 310,(HISTA(I),I=1,IA0)
      DO 3120 I=1,IA0
      IF(HISTA(I).GT.0.) HINZA(I)=HINZA(I)/HISTA(I)
 3120 CONTINUE
c      PRINT 3121
c 3121 FORMAT(2X,'average charge of cold fragm. HINZA(1-IA0):')
c      PRINT 3122,(HINZA(I),I=1,IA0)
c 3122 FORMAT(2X,10F7.3)
c      CALL SORTNA(IA0,HISTA)
c      PRINT 311,HISTZ(1)
c 311  FORMAT(2X,'CHARGE YIELD - Z (FROM 0 TO IZ0) [HISTZ(1)=',
c     *F9.0,']  HISTZ:')
c      PRINT 310,(HISTZ(I),I=1,IZ0+1)
c 310  FORMAT(2X,10F7.0)
c ------- selected isotopes --------
c 3100 FORMAT(2X,10F7.0)
c      PRINT 3101
c 3101 FORMAT(2X,'Isotopes (A-distr.) for Z=22, AZ22(31-70):')
c      PRINT 3100,(AZ22(I),I=31,70)
c      PRINT 3102
c 3102 FORMAT(2X,'Isotopes (A-distr.) for Z=42, AZ42(61-130):')
c      PRINT 3100,(AZ42(I),I=61,130)
c      PRINT 3103
cc 3103 FORMAT(2X,'Isotopes (A-distr.) for Z=62, AZ62(91-180):')
c 3103 FORMAT(2X,'Isotopes (A-distr.) for Z=28, AZ62(51-90):')
c      PRINT 3100,(AZ62(I),I=51,90)
c      PRINT 3104
cc 3104 FORMAT(2X,'Isotopes (A-distr.) for Z=82, AZ82(131-230):')
c 3104 FORMAT(2X,'Isotopes (A-distr.) for Z=50, AZ82(101-150):')
c      PRINT 3100,(AZ82(I),I=101,150)
c -----------------------------------
      DO 3123 I=1,IZ0+1
      IF(HISTZ(I).GT.0.) HIAZZ(I)=HIAZZ(I)/HISTZ(I)
 3123 CONTINUE
c      PRINT 3124
c 3124 FORMAT(2X,'average mass of cold fragm. HIAZZ(0-IZ0+1):')
c      PRINT 3048,(HIAZZ(I),I=1,IZ0+1)
c 3048 FORMAT(2X,10F7.2)
      DO 3125 I=2,IZ0+1
      IF(HISTZ(I).LE.0) GO TO 3125
      J=I-1
      HINZZ(J)=(HIAZZ(J+1)-J)/FLOAT(J)
 3125 CONTINUE
c      PRINT 3126
c 3126 FORMAT(2X,'average N/Z of fragm. HINZZ(1-IZ0):')
c      PRINT 3122,(HINZZ(I),I=1,IZ0)
c --------------------------
c      PRINT 3049,HISTMZ(1)
c 3049 FORMAT(2X,'max fragments - Zmax (FROM 0 TO IZ0) [HISTMZ(1)=',
c     *F9.0,']  HISTMZ:')
c      PRINT 310,(HISTMZ(I),I=1,IZ0+1)
      DO 3054 I=1,IZ0+1
      IF(HISTMZ(I).GT.0.) HMAZZ(I)=HMAZZ(I)/HISTMZ(I)
 3054 CONTINUE
c      PRINT 3055
c 3055 FORMAT(2X,'average mass of max fragm. HMAZZ(0-IZ0+1):')
c      PRINT 3048,(HMAZZ(I),I=1,IZ0+1)
      DO 3056 I=2,IZ0+1
      IF(HISTMZ(I).LE.0) GO TO 3056
      J=I-1
      HMNZZ(J)=(HMAZZ(J+1)-J)/FLOAT(J)
 3056 CONTINUE
c      PRINT 3057
c 3057 FORMAT(2X,'average N/Z of max fragm. HMNZZ(1-IZ0):')
c      PRINT 3122,(HMNZZ(I),I=1,IZ0)
c --------------------------
c      PRINT 3058,HIST1Z(1)
c 3058 FORMAT(2X,'fragments @ Zmax<15 (FROM 0 TO IZ0) [HIST1Z(1)=',
c     *F9.0,']  HIST1Z:')
c      PRINT 310,(HIST1Z(I),I=1,IZ0+1)
      DO 3059 I=1,IZ0+1
      IF(HIST1Z(I).GT.0.) H1AZZ(I)=H1AZZ(I)/HIST1Z(I)
 3059 CONTINUE
c      PRINT 3060
c 3060 FORMAT(2X,'average mass of fragm#1 H1AZZ(0-IZ0+1):')
c      PRINT 3048,(H1AZZ(I),I=1,IZ0+1)
      DO 3061 I=2,IZ0+1
      IF(HIST1Z(I).LE.0) GO TO 3061
      J=I-1
      H1NZZ(J)=(H1AZZ(J+1)-J)/FLOAT(J)
 3061 CONTINUE
c      PRINT 3062
c 3062 FORMAT(2X,'average N/Z of fragm#1 H1NZZ(1-IZ0):')
c      PRINT 3122,(H1NZZ(I),I=1,IZ0)
c --------------------------
c      PRINT 3063,HIST2Z(1)
c 3063 FORMAT(2X,'fragments @ Zmax>25 (FROM 0 TO IZ0) [HIST2Z(1)=',
c     *F9.0,']  HIST2Z:')
c      PRINT 310,(HIST2Z(I),I=1,IZ0+1)
      DO 3064 I=1,IZ0+1
      IF(HIST2Z(I).GT.0.) H2AZZ(I)=H2AZZ(I)/HIST2Z(I)
 3064 CONTINUE
c      PRINT 3065
c 3065 FORMAT(2X,'average mass of fragm#2 H2AZZ(0-IZ0+1):')
c      PRINT 3048,(H2AZZ(I),I=1,IZ0+1)
      DO 3066 I=2,IZ0+1
      IF(HIST2Z(I).LE.0) GO TO 3066
      J=I-1
      H2NZZ(J)=(H2AZZ(J+1)-J)/FLOAT(J)
 3066 CONTINUE
c      PRINT 3067
c 3067 FORMAT(2X,'average N/Z of fragm#2 H2NZZ(1-IZ0):')
c      PRINT 3122,(H2NZZ(I),I=1,IZ0)
c --------------------------
c      PRINT 204
c 204  FORMAT(2X,'total Isotope yield: YAZT, axis x- Z=0-10,',
c     *' y- A=1-25')
      DO 205 I=1,25
c      PRINT 206,(YAZT(I,J),J=1,11)
c 206  FORMAT(1X,11F7.0)
 205  CONTINUE
c ----------- yields of large isotopes -----------------
c 1062 FORMAT(1X,I3,1X,10F7.0)
c      PRINT 1063
c 1063 FORMAT(5X,'Yields: Z=10,11,12,13,14,15,16,17,18,19   N=1-40')
      DO 1064 I=1,40
      INN=I
c      PRINT 1062,INN,(YZ10A(J,I),J=1,10)
 1064 CONTINUE
c      PRINT 1065
c 1065 FORMAT(5X,'Yields: Z=20,21,22,23,24,25,26,27,28,29    N=11-60')
      DO 1066 I=1,50
      INN=I+10
c      PRINT 1062,INN,(YZ20A(J,I),J=1,10)
 1066 CONTINUE
c      PRINT 1067
c 1067 FORMAT(5X,'Yields: Z=30,31,32,33,34,35,36,37,38,39    N=21-80')
      DO 1068 I=1,60
      INN=I+20
c      PRINT 1062,INN,(YZ30A(J,I),J=1,10)
 1068 CONTINUE
c -------------------------------------------
      IF(JWRIZ.EQ.0) GO TO 185
      DO 186 I=1,25
      DO 186 J=1,11
 186  IYAZT(I,J)=INT(YAZT(I,J)+0.1)
      DO 187 I=1,20
c      WRITE(57,188)(IYAZT(I,J),J=2,9)
 187  CONTINUE
c 188  FORMAT(1X,I8,1X,I8,1X,6I8)
c      print *,' WRITE in file 57 finished  ITNUM=',ITNUM
c      CLOSE(57)
 185  CONTINUE
c      PRINT 314,IZMAXF
c 314  FORMAT(2X,'EVENTS WITH EMISSION 0,1,2,... HEAVY (Z.GT.',I2,') 
c     *FRAGMENTS')
c      PRINT 315,(MCOR(I),I=1,20)
c 315  FORMAT(1X,10I7)
      IF(SAMAX.GT.0.) EKMAX=EKMAX/SAMAX
      IF(SNMAX.GT.0.) SAMAX=SAMAX/SNMAX
c      PRINT 1020, SNMAX,SAMAX,EKMAX
c 1020 FORMAT(2X,'numb.max.Z-fragm. SNMAX=',F7.0,' mass SAMAX=',F6.2/1X,
c     *' kin.energ.(MeV/u) EKMAX=',F7.2)
c      PRINT 397,IZMAXF
c 397  FORMAT(2X,'DISTR.ON NUMB. OF FRAG. 3.LE.Z.LE.',I2,' (0-19)')
c      PRINT 315,(MCI3(I),I=1,20)
      IF(NUMB.GT.0) ANMOMS=ANMOMS/NUMB
      IF(NUMB.GT.0) EMOMS=EMOMS/NUMB
      IF(NUMBFR.GT.0) SZBOU=SZBOU/NUMBFR
      IF(NUMBFR.GT.0) SZBOU3=SZBOU3/NUMBFR
      IF(NUMBFR.GT.0) SZMAX=SZMAX/NUMBFR
c ------- jbn 'critical' analysis + second max fragm. ------
      IF(NUMBFR.GT.0) S2ZMAX=S2ZMAX/NUMBFR
      IF(NUMBFR.GT.0) SZMA2=SZMA2/NUMBFR
      DDD=SZMA2-SZMAX*SZMAX
      IF(DDD.LE.0.) SZMA2=0.
      IF(DDD.GT.0.) SZMA2=SQRT(DDD)
      IF(NUMBFR.GT.0) SM0=SM0/NUMBFR
      IF(NUMBFR.GT.0) SM1=SM1/NUMBFR
      IF(NUMBFR.GT.0) SM2=SM2/NUMBFR
      IF(NUMBFR.GT.0) SM3=SM3/NUMBFR
c -----------------------------------------------------------
      IF(NUMBFR.GT.0) SMIMF=SMIMF/NUMBFR
      IF(NUMBFR.GT.0) SMIMF2=SMIMF2/NUMBFR
      IF(NUMBFR.GT.0) RMZ=RMZ/NUMBFR
      IF(NUMBFR.GT.0) SNC=SNC/NUMBFR
      DDD=SMIMF2-SMIMF*SMIMF
      IF(DDD.LE.0.) SMIMF2=0.
      IF(DDD.GT.0.) SMIMF2=SQRT(DDD)
      IF(NUMBFR.GT.0) SMBIG=SMBIG/NUMBFR
      IF(NUMBFR.GT.0) SMBIG2=SMBIG2/NUMBFR
      DDD=SMBIG2-SMBIG*SMBIG
      IF(DDD.LE.0.) SMBIG2=0.
      IF(DDD.GT.0.) SMBIG2=SQRT(DDD)
c      PRINT 1111,SMIMF,SMIMF2,SMBIG,SMBIG2
c 1111 FORMAT(2X,'mean IMF: SMIMF=',F7.4,'  variance: SMIMF2=',F7.4/
c     *2X,'mean BIG: SMBIG=',F7.4,'  variance: SMBIG2=',F7.4)
c      PRINT 111,SZBOU,SZBOU3,SZMAX,SZMA2,S2ZMAX,SMIMF,SNC,RMZ
c 111  FORMAT(1X,' avr. bound charge: SZBOU=',F7.3,' SZBOU3=',F7.3/
c     *1X,' max charge: SZMAX=',F7.3,' SZMA2=',F7.3,' second: S2ZMAX=',
c     *F7.3/1X,' SMIMF=',F7.3,' SNC=',F7.3,' RMZ=',F7.3)
c ------- jbn 'critical' analysis: SM3 vs SM2 ------
c      PRINT 1054,SM0,SM1,SM2,SM3
c 1054 FORMAT(2X,'charge moment. SM0,SM1,SM2,SM3=',F9.3,1X,F9.3,1X,
c     *F9.3,1X,F9.3)
c      PRINT 1056
c 1056 FORMAT(2X,'ln(SM3) vs ln (SM2) [for tau] ; HISM23:')
c      DO 1053 J=16,45
c      PRINT 1055,(HISM23(I,J),I=11,25)
c 1055 FORMAT(1X,15F5.0)
c 1053 CONTINUE
c ---------------------------------------------------
c      PRINT 112,ANMOMS,EMOMS
c 112  FORMAT(2X,'avr. ang.mom. ANMOMS(h-bar)=',F8.2,' energ. EMOMS=',
c     *F9.5,' GeV/n')
c      PRINT 901
c 901  FORMAT(2X,'DISTRIB.OF EVENTS IN BOUND CHARGE OF FRAGM.',
c     *'WITH Z>2 : ZB3  -  MZB3(1-IZ0)')
c      PRINT 315,(MZB3(I),I=1,IZ0)
c      PRINT 821
c 821  FORMAT(2X,'DISTR.OF EVENTS WITH FRAGMENT. IN NPAT',
c     *'  : MZFR(1-IZ0)')
c      PRINT 315,(MZFR(I),I=1,IZ0)
      DO 820 I=1,IZ0
      IF(MZFR(I).GT.0) ZMZFR(I)=ZMZFR(I)/FLOAT(MZFR(I))
      IF(MZFR(I).GT.0) SFZFR(I)=SFZFR(I)/FLOAT(MZFR(I))
      IF(MZB3(I).GT.0) ZMZB3(I)=ZMZB3(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SFZB3(I)=SFZB3(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SNZB3(I)=SNZB3(I)/FLOAT(MZB3(I))
      IF(MZB(I).GT.0) TZB(I)=TZB(I)/FLOAT(MZB(I))
      IF(MZB3(I).GT.0) TZB3(I)=TZB3(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SPRB(I)=SPRB(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SDEB(I)=SDEB(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) STRB(I)=STRB(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SZ1B(I)=SZ1B(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SZ2B(I)=SZ2B(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SHE3B(I)=SHE3B(I)/FLOAT(MZB3(I))
      IF(MZB3(I).GT.0) SHE4B(I)=SHE4B(I)/FLOAT(MZB3(I))
      IF(NAZ5B(I).GT.0) HAZ5B(I)=HAZ5B(I)/FLOAT(NAZ5B(I))
      IF(NAZ6B(I).GT.0) HAZ6B(I)=HAZ6B(I)/FLOAT(NAZ6B(I))
      IF(NAZ7B(I).GT.0) HAZ7B(I)=HAZ7B(I)/FLOAT(NAZ7B(I))
      IF(NAZ8B(I).GT.0) HAZ8B(I)=HAZ8B(I)/FLOAT(NAZ8B(I))
      RAZ5B(I)=HAZ5B(I)/5.
      RAZ6B(I)=HAZ6B(I)/6.
      RAZ7B(I)=HAZ7B(I)/7.
      RAZ8B(I)=HAZ8B(I)/8.
 820  CONTINUE
      DO 822 I=1,10
      IF(NAZ5BI(I).GT.0) HAZ5BI(I)=HAZ5BI(I)/FLOAT(NAZ5BI(I))
      IF(NAZ6BI(I).GT.0) HAZ6BI(I)=HAZ6BI(I)/FLOAT(NAZ6BI(I))
      IF(NAZ7BI(I).GT.0) HAZ7BI(I)=HAZ7BI(I)/FLOAT(NAZ7BI(I))
      IF(NAZ8BI(I).GT.0) HAZ8BI(I)=HAZ8BI(I)/FLOAT(NAZ8BI(I))
      RAZ5BI(I)=HAZ5BI(I)/5.
      RAZ6BI(I)=HAZ6BI(I)/6.
      RAZ7BI(I)=HAZ7BI(I)/7.
      RAZ8BI(I)=HAZ8BI(I)/8.
 822  CONTINUE
      DO 824 I=1,5
      IF(SSZR(I).GT.0) SNZR(I)=SNZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) SPZR(I)=SPZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) SDZR(I)=SDZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) STZR(I)=STZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) SHE3ZR(I)=SHE3ZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) SHE4ZR(I)=SHE4ZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) SZ1ZR(I)=SZ1ZR(I)/SSZR(I)
      IF(SSZR(I).GT.0) SZ2ZR(I)=SZ2ZR(I)/SSZR(I)
 824  CONTINUE
c      PRINT 900
c 900  FORMAT(2X,'*****************************************')
c 703  FORMAT(2X,10F7.2)
c      PRINT 702
c 702  FORMAT(2X,'AVERAGE M-can TEMP. IN ZBOU - TZB(1-IZ0)')
c      PRINT 703,(TZB(I),I=1,IZ0)
c      PRINT 704
c 704  FORMAT(2X,'AVERAGE M-can TEMP. IN ZB3 - TZB3(1-IZ0)')
c      PRINT 703,(TZB3(I),I=1,IZ0)
c      PRINT 902
c 902  FORMAT(2X,'AVERAGE MAX CHARGE IN ZB3 - ZMZB3(1-IZ0)')
c      PRINT 805,(ZMZB3(I),I=1,IZ0)
c      PRINT 903
c 903  FORMAT(2X,'AVER.MULT. OF M_IMF IN ZB3 - SFZB3(1-IZ0)')
c      PRINT 805,(SFZB3(I),I=1,IZ0)
c      PRINT 904
c 904  FORMAT(2X,'AVER.MULT. OF Neutr IN ZB3 - SNZB3(1-IZ0)')
c      PRINT 805,(SNZB3(I),I=1,IZ0)
c      PRINT 905
c 905  FORMAT(2X,'aver.mult. of Protons in ZB3 - SPRB(1-IZ0)')
c      PRINT 805,(SPRB(I),I=1,IZ0)
c      PRINT 917
c 917  FORMAT(2X,'aver.mult. of Deutrons in ZB3 - SDEB(1-IZ0)')
c      PRINT 805,(SDEB(I),I=1,IZ0)
c      PRINT 907
c 907  FORMAT(2X,'aver.mult. of Tritons in ZB3 - STRB(1-IZ0)')
c      PRINT 805,(STRB(I),I=1,IZ0)
c      PRINT 908
c 908  FORMAT(2X,'aver.mult. of He-3 in ZB3 - SHE3B(1-IZ0)')
c      PRINT 805,(SHE3B(I),I=1,IZ0)
c      PRINT 909
c 909  FORMAT(2X,'aver.mult. of He-4 in ZB3 - SHE4B(1-IZ0)')
c      PRINT 805,(SHE4B(I),I=1,IZ0)
c      PRINT 911
c 911  FORMAT(2X,'aver.mult. of Z=1 in ZB3 - SZ1B(1-IZ0)')
c      PRINT 805,(SZ1B(I),I=1,IZ0)
c      PRINT 912
c 912  FORMAT(2X,'aver.mult. of Z=2 in ZB3 - SZ2B(1-IZ0)')
c      PRINT 805,(SZ2B(I),I=1,IZ0)
c
c      PRINT 900
c      PRINT 980
c 980  FORMAT(2X,'Number events in 5 reduc.bound charge ranges',
c     *' ZB3/Z00 - SSZR(1-5):')
c 806  FORMAT(2X,10F7.0)
c      PRINT 806,(SSZR(I),I=1,5)
c      PRINT 981
c 981  FORMAT(2X,'aver.mult.of Neutrons in ZB3/Z00 - SNZR(1-5)')
c      PRINT 805,(SNZR(I),I=1,5)
c      PRINT 982
c 982  FORMAT(2X,'aver.mult.of Protons in ZB3/Z00 - SPZR(1-5)')
c      PRINT 805,(SPZR(I),I=1,5)
c      PRINT 983
c 983  FORMAT(2X,'aver.mult.of Deutrons in ZB3/Z00 - SDZR(1-5)')
c      PRINT 805,(SDZR(I),I=1,5)
c      PRINT 984
c 984  FORMAT(2X,'aver.mult.of Tritons in ZB3/Z00 - STZR(1-5)')
c      PRINT 805,(STZR(I),I=1,5)
c      PRINT 985
c 985  FORMAT(2X,'aver.mult.of He-3 in ZB3/Z00 - SHE3ZR(1-5)')
c      PRINT 805,(SHE3ZR(I),I=1,5)
c      PRINT 986
c 986  FORMAT(2X,'aver.mult.of He-4 in ZB3/Z00 - SHE4ZR(1-5)')
c      PRINT 805,(SHE4ZR(I),I=1,5)
c      PRINT 987
c 987  FORMAT(2X,'aver.mult.of Z=1 in ZB3/Z00 - SZ1ZR(1-5)')
c      PRINT 805,(SZ1ZR(I),I=1,5)
c      PRINT 988
c 988  FORMAT(2X,'aver.mult.of Z=2 in ZB3/Z00 - SZ2ZR(1-5)')
c      PRINT 805,(SZ2ZR(I),I=1,5)
c      PRINT 2012
c 2012 FORMAT(2X,'Isotope yield YAZT1 for ZB3/Z00=0.0--0.2 :',
c     *' x- Z=0-10,',' y- A=1-26')
c      DO 2013 I=1,26
c      PRINT 206,(YAZT1(I,J),J=1,11)
c 2013 CONTINUE
c      PRINT 2014
c 2014 FORMAT(2X,'Isotope yield YAZT2 for ZB3/Z00=0.2--0.4 :',
c     *' x- Z=0-10,',' y- A=1-26')
c      DO 2015 I=1,26
c      PRINT 206,(YAZT2(I,J),J=1,11)
c 2015 CONTINUE
c      PRINT 2016
c 2016 FORMAT(2X,'Isotope yield YAZT3 for ZB3/Z00=0.4--0.6 :',
c     *' x- Z=0-10,',' y- A=1-26')
c      DO 2017 I=1,26
c      PRINT 206,(YAZT3(I,J),J=1,11)
c 2017 CONTINUE
c      PRINT 2018
c 2018 FORMAT(2X,'Isotope yield YAZT4 for ZB3/Z00=0.6--0.8 :',
c     *' x- Z=0-10,',' y- A=1-26')
c      DO 2019 I=1,26
c      PRINT 206,(YAZT4(I,J),J=1,11)
c 2019 CONTINUE
c      PRINT 2020
c 2020 FORMAT(2X,'Isotope yield YAZT5 for ZB3/Z00=0.8--1.0 :',
c     *' x- Z=0-10,',' y- A=1-26')
c      DO 2021 I=1,26
c      PRINT 206,(YAZT5(I,J),J=1,11)
c 2021 CONTINUE
      DO 2022 I=1,IZ0
      IF(FCZB1(I).GT.0.) FNZB1(I)=FNZB1(I)/FCZB1(I)
      IF(FCZB2(I).GT.0.) FNZB2(I)=FNZB2(I)/FCZB2(I)
      IF(FCZB3(I).GT.0.) FNZB3(I)=FNZB3(I)/FCZB3(I)
      IF(FCZB4(I).GT.0.) FNZB4(I)=FNZB4(I)/FCZB4(I)
      IF(FCZB5(I).GT.0.) FNZB5(I)=FNZB5(I)/FCZB5(I)
 2022 CONTINUE
      DO 2023 I=1,IZ0
      IF(FCZB1(I).GT.0.) FNZB1(I)=(FNZB1(I)-FLOAT(I))/FLOAT(I)
      IF(FCZB2(I).GT.0.) FNZB2(I)=(FNZB2(I)-FLOAT(I))/FLOAT(I)
      IF(FCZB3(I).GT.0.) FNZB3(I)=(FNZB3(I)-FLOAT(I))/FLOAT(I)
      IF(FCZB4(I).GT.0.) FNZB4(I)=(FNZB4(I)-FLOAT(I))/FLOAT(I)
      IF(FCZB5(I).GT.0.) FNZB5(I)=(FNZB5(I)-FLOAT(I))/FLOAT(I)
 2023 CONTINUE
c      PRINT 2024
c 2024 FORMAT(2X,'Charge yield FCZB1 for ZB3/Z00=0.0--0.2 :',
c     *' Z=1,IZ0')
c      PRINT 310,(FCZB1(I),I=1,IZ0)
c      PRINT 2025
c 2025 FORMAT(2X,'N/Z ratio FNZB1 for ZB3/Z00=0.0--0.2 :',
c     *' Z=1,IZ0')
c      PRINT 3122,(FNZB1(I),I=1,IZ0)
c      PRINT 2026
c 2026 FORMAT(2X,'Charge yield FCZB2 for ZB3/Z00=0.2--0.4 :',
c     *' Z=1,IZ0')
c      PRINT 310,(FCZB2(I),I=1,IZ0)
c      PRINT 2027
c 2027 FORMAT(2X,'N/Z ratio FNZB2 for ZB3/Z00=0.2--0.4 :',
c     *' Z=1,IZ0')
c      PRINT 3122,(FNZB2(I),I=1,IZ0)
c      PRINT 2028
c 2028 FORMAT(2X,'Charge yield FCZB3 for ZB3/Z00=0.4--0.6 :',
c     *' Z=1,IZ0')
c      PRINT 310,(FCZB3(I),I=1,IZ0)
c      PRINT 2029
c 2029 FORMAT(2X,'N/Z ratio FNZB3 for ZB3/Z00=0.4--0.6 :',
c     *' Z=1,IZ0')
c      PRINT 3122,(FNZB3(I),I=1,IZ0)
c      PRINT 2030
c 2030 FORMAT(2X,'Charge yield FCZB4 for ZB3/Z00=0.6--0.8 :',
c     *' Z=1,IZ0')
c      PRINT 310,(FCZB4(I),I=1,IZ0)
c      PRINT 2031
c 2031 FORMAT(2X,'N/Z ratio FNZB4 for ZB3/Z00=0.6--0.8 :',
c     *' Z=1,IZ0')
c      PRINT 3122,(FNZB4(I),I=1,IZ0)
c      PRINT 2032
c 2032 FORMAT(2X,'Charge yield FCZB5 for ZB3/Z00=0.8--1.0 :',
c     *' Z=1,IZ0')
c      PRINT 310,(FCZB5(I),I=1,IZ0)
c      PRINT 2033
c 2033 FORMAT(2X,'N/Z ratio FNZB5 for ZB3/Z00=0.8--1.0 :',
c     *' Z=1,IZ0')
c      PRINT 3122,(FNZB5(I),I=1,IZ0)
c      PRINT 900
c
c      PRINT 913
c 913  FORMAT(2X,'aver.mass of Z=5 in ZB3 - HAZ5B(1-IZ0)')
c      PRINT 805,(HAZ5B(I),I=1,IZ0)
c      PRINT 914
c 914  FORMAT(2X,'aver.mass of Z=6 in ZB3 - HAZ6B(1-IZ0)')
c      PRINT 805,(HAZ6B(I),I=1,IZ0)
c$$$      PRINT 915
c$$$ 915  FORMAT(2X,'aver.mass of Z=7 in ZB3 - HAZ7B(1-IZ0)')
c$$$      PRINT 805,(HAZ7B(I),I=1,IZ0)
c$$$      PRINT 916
c$$$ 916  FORMAT(2X,'aver.mass of Z=8 in ZB3 - HAZ8B(1-IZ0)')
c$$$      PRINT 805,(HAZ8B(I),I=1,IZ0)
c$$$      PRINT 9130
c$$$ 9130 FORMAT(2X,'A/Z - mass/charge ratio of Z=5 in ZB3- RAZ5B(1-IZ0)')
c$$$      PRINT 805,(RAZ5B(I),I=1,IZ0)
c$$$      PRINT 9140
c$$$ 9140 FORMAT(2X,'A/Z - mass/charge ratio of Z=6 in ZB3- RAZ6B(1-IZ0)')
c$$$      PRINT 805,(RAZ6B(I),I=1,IZ0)
c$$$      PRINT 9150
c$$$ 9150 FORMAT(2X,'A/Z - mass/charge ratio of Z=7 in ZB3- RAZ7B(1-IZ0)')
c$$$      PRINT 805,(RAZ7B(I),I=1,IZ0)
c$$$      PRINT 9160
c$$$ 9160 FORMAT(2X,'A/Z - mass/charge ratio of Z=8 in ZB3- RAZ8B(1-IZ0)')
c$$$      PRINT 805,(RAZ8B(I),I=1,IZ0)
c$$$      PRINT 900
c$$$      PRINT 941
c$$$ 941  FORMAT(2X,'aver.mass of Z=5 in ZB3/Z00 interval - HAZ5BI(1-10)')
c$$$      PRINT 805,(HAZ5BI(I),I=1,10)
c$$$      PRINT 942
c$$$ 942  FORMAT(2X,'aver.mass of Z=6 in ZB3/Z00 interval - HAZ6BI(1-10)')
c$$$      PRINT 805,(HAZ6BI(I),I=1,10)
c$$$      PRINT 943
c$$$ 943  FORMAT(2X,'aver.mass of Z=7 in ZB3/Z00 interval - HAZ7BI(1-10)')
c$$$      PRINT 805,(HAZ7BI(I),I=1,10)
c$$$      PRINT 944
c$$$ 944  FORMAT(2X,'aver.mass of Z=8 in ZB3/Z00 interval - HAZ8BI(1-10)')
c$$$      PRINT 805,(HAZ8BI(I),I=1,10)
c$$$      PRINT 9410
c$$$ 9410 FORMAT(2X,'A/Z - mass/charge of Z=5 in ZB3/Z00 - RAZ5BI(1-10)')
c$$$      PRINT 805,(RAZ5BI(I),I=1,10)
c$$$      PRINT 9420
c$$$ 9420 FORMAT(2X,'A/Z - mass/charge of Z=6 in ZB3/Z00 - RAZ6BI(1-10)')
c$$$      PRINT 805,(RAZ6BI(I),I=1,10)
c$$$      PRINT 9430
c$$$ 9430 FORMAT(2X,'A/Z - mass/charge of Z=7 in ZB3/Z00 - RAZ7BI(1-10)')
c$$$      PRINT 805,(RAZ7BI(I),I=1,10)
c$$$      PRINT 9440
c$$$ 9440 FORMAT(2X,'A/Z - mass/charge of Z=8 in ZB3/Z00 - RAZ8BI(1-10)')
c$$$      PRINT 805,(RAZ8BI(I),I=1,10)
c      PRINT 823
c 823  FORMAT(2X,'DISTR.OF AVER.MAX CHARGE IN EVENTS WITH FRAGM.',
c     *' IN NPAT  : ZMZFR(1-IZ0)')
c      PRINT 805,(ZMZFR(I),I=1,IZ0)
c      PRINT 825
c 825  FORMAT(2X,'AVR.MULT. of M_imf ',
c     *' IN NPAT  : SFZFR(1-IZ0)')
c      PRINT 805,(SFZFR(I),I=1,IZ0)
c$$$ 805  FORMAT(2X,10F7.2)
c$$$      PRINT 144
c$$$ 144  FORMAT(2X,'total charge yield NUMZ(1-IZ0):')
c$$$      PRINT 145,(NUMZ(I),I=1,IZ0)
c$$$ 145  FORMAT(2X,10I7)
      DO 146 I=1,IZ0
      IF(NUMZ(I).GT.0) EKZ(I)=EKZ(I)/(2.*I*FLOAT(NUMZ(I)))
      IF(NUMZ(I).GT.0) ETRZ(I)=ETRZ(I)/(2.*I*FLOAT(NUMZ(I)))
 146  CONTINUE
c      PRINT 1147
c 1147 FORMAT(2X,'avr.kinetic energy (MeV/2Z)   EKZ(1-IZ0):')
c      PRINT 805,(EKZ(I),I=1,IZ0)
c      PRINT 147
c 147  FORMAT(2X,'avr.transvers.energy (MeV/2Z)   ETRZ(1-IZ0):')
c      PRINT 805,(ETRZ(I),I=1,IZ0)
c ---------------------------------------------
c      DO 1163 I=1,IZ0
c      IF(NUMZL(I).GT.0) EKZL(I)=EKZL(I)/FLOAT(NUMZL(I))
c      IF(NUMZT(I).GT.0) EKZT(I)=EKZT(I)/FLOAT(NUMZT(I))
c 1163 CONTINUE
c      PRINT 1164
c 1164 FORMAT(2X,'long.(|CosT>0.5|) charge yield NUMZL(1-IZ0):')
c      PRINT 145,(NUMZL(I),I=1,IZ0)
c      PRINT 1165
c 1165 FORMAT(2X,'long.(|CosT>0.5|) avr.kin.energ.(MeV)  EKZL(1-IZ0):')
c      PRINT 805,(EKZL(I),I=1,IZ0)
c      PRINT 1166
c 1166 FORMAT(2X,'transv.(|CosT<0.5|) charge yield NUMZT(1-IZ0):')
c      PRINT 145,(NUMZT(I),I=1,IZ0)
c      PRINT 1167
c 1167 FORMAT(2X,'transv.(|CosT<0.5|) avr.kin.energ.(MeV)  EKZT(1-IZ0):')
c      PRINT 805,(EKZT(I),I=1,IZ0)
c ----------------------------------------------
c      PRINT 148
c 148  FORMAT(2X,'azimuth.angl.correl.of 4-He (all events)',2X,
c     *' RPHI (0-180 deg., step-9):')
c      PRINT 149,(RPHI(I),I=1,20)
c      PRINT 160,(RPHI(I),I=21,26)
c 149  FORMAT(1X,10F8.0)
c 160  FORMAT(1X,6F13.3)
      CALL THELIP
c      PRINT 180
c 180  FORMAT(2X,'******* DMR ******** for fragments Z=3-20')
c      CALL DMRPR
cc      PRINT 165
cc 165  FORMAT(2X,'******* POCH1 ********')
cc      CALL EPOCH1
c      PRINT 166
c 166  FORMAT(2X,'******* SPEC1 ********')
c      CALL ESPEC1
cc      PRINT 167
cc 167  FORMAT(2X,'******* SPEC2 ********')
cc      CALL ESPEC2
 500  CONTINUE
      RETURN
      END
      SUBROUTINE HIST1(X,A,B,H,RX,N,W)
      DIMENSION RX(N)
      LE=(B-A)/H+6
      IF(LE-N) 11,11,12
 12   PRINT 13,LE,N
 13   FORMAT(5X,'ERROR IN DIMENSION IN HIST1  LE=',I4,'  N=',I4)
      RETURN
 11   CONTINUE
      RX(N)=RX(N)+X
      IF(X-A) 1,2,2
 1    RX(N-4)=RX(N-4)+W
      RETURN
 2    IF(X-B) 4,3,3
 3    RX(N-2)=RX(N-2)+W
      RETURN
 4    L=(X-A)/H
      RX(L+1)=RX(L+1)+W
      RX(N-1)=RX(N-1)+X
      RX(N-3)=RX(N-3)+W
      RETURN
      END
      SUBROUTINE SORTNA(IA0,RN)
      DIMENSION RN(500),R(500)
      R(1)=RN(1)
      R(2)=(RN(2)+RN(3)+RN(4)+RN(5))/4.
      IA1=IA0-1
      K=(IA1-5)/5
      IA4=K*5+5+1
      DO 1 I=1,K
      RR=0.
      DO 2 J=1,5
 2    RR=RR+RN(I*5+J)
      RR=RR/5.
      R(2+I)=RR
 1    CONTINUE
      IS=2+K+1
      R(IS)=0.
      IF(IA4.GT.IA1) GO TO 4
      DO 3 I=IA4,IA1
 3    R(IS)=R(IS)+RN(I)
      R(IS)=R(IS)/FLOAT(IA1-IA4+1)
      IS=IS+1
 4    CONTINUE
      R(IS)=RN(IA0)
c      PRINT 5
c 5    FORMAT(2X,'AVERAGE MASS YIELD (IN  A=1,2-5,5-10,...,IA0)
c     *ON CALCULATED EVENTS')
c      PRINT 6,(R(I),I=1,IS)
c 6    FORMAT(5X,10F10.3)
      RETURN
      END

      FUNCTION COLHOT(L,RADNCL)
      COMMON /BLHT06/ZJ(68)/BLHT10/ZFJ(68)/BLHT09/AFJ(68)
     */BLHT05/AJ(68)/BLHT03/U,A,Z
       IF(L-1)1,1,2
1      COLHOT=0.
       RETURN
2      TEMP1=1.44/RADNCL
       COLHOT=TEMP1*((ZJ(L)*ZFJ(L))/(AJ(L)**.33333+AFJ(L)**.33333))
       IF(COLHOT) 3,3,4
3       COLHOT=0.
4       CONTINUE
       RETURN
       END
      FUNCTION GAMHOT(J,A,U,AM,RADNCL)
       COMMON /BLHT09/AFJ(68)/BLHT15/RJ(68)/BLHT14/GAN(68)
      COMMON /BLHT11/VJ(68) /BLHT05/AJ(68)/BLHT06/ZJ(68)
      COMMON /BLHT10/ZFJ(68) /BLHTEX/EXTF(68)
      COMMON /BLHT20/FREP(68)
      IF(RJ(J).LE.0.OR.U.LE.0.) GO TO 12
      PER=2.*SQRT(AM*A*U)
      AMFR=0.5*AM*(1.+(40.**0.333333)/(AJ(J)**0.333333))
      IF(J.GT.6) PER=PER-2.*SQRT(AMFR*AJ(J)*EXTF(J))
      RN=1.5
      CC=0.2
      IF(J.GT.2.AND.J.LE.6)  CC=0.1
      IF(J.GT.6) CC=    (AJ(J)/AFJ(J))**0.6666667
       IF(J-1)1,2,1
2      ALFA=.76+2.2/AFJ(1)**.33333
       BETA=(2.12/AFJ(1)**.66667-.05)/ALFA
      GO TO 3
1      ALFA=1.+CC
       BETA=0.
       GO TO 3
3      Q1=AM*AFJ(J)
       Q2=AM*AFJ(J)*RJ(J)
       Q3=(GAN(J)*AFJ(J)**.66667)*(ALFA/Q1**2)*(AFJ(J)/(AFJ(J)+AJ(J)))
      Q3=Q3*AJ(J)*(3.1416*RN**2)/(2.*41.5*3.1416**2)
      Q3=Q3*FREP(J)
       Q4=(2.*BETA*Q1-3.)/2.+Q2
       Q5=(2.*BETA*Q1-3.)*(SQRT(Q2)-.5)+2.*Q2
      IF(PER-160.) 20,20,21
 20   PEX1=Q4*EXP(-PER)
      GO TO 22
 21   PEX1=0
 22   PP2=PER-2.*SQRT(Q2)
      IF(PP2-160.) 23,23,24
 23   PEX2=Q5*EXP(-PP2)
      GO TO 25
 24   PEX2=0.
 25   GAMHOT=Q3*(PEX1+PEX2)
      IF(J.LE.2) RETURN
      TFORM=AJ(J)*AJ(J)*10.
      GFORM=0.21*940./TFORM
      IF(GAMHOT.GT.GFORM) GAMHOT=GFORM*FREP(J)
      RETURN
 12   GAMHOT=0.
      RETURN
      END
       FUNCTION TKIHOT(L,AM)
       COMMON /BLHT09/AFJ(68)/BLHT15/RJ(68)/BLHT11/VJ(68)
       COMMON /BLHT05/AJ(68)
       RJL=RJ(L)
       RB=4.*AM*AFJ(L)*RJL
       PP1=SQRT(RB)
 5     B1=RNDMSMM(-1)
       IF(B1.LE.0.OR.B1.GT.1) B1=RNDMSMM(-1)
       IF(PP1-160.) 21,21,22
 21    PEX1=EXP(-PP1)
       GO TO 23
 22    PEX1=0.
 23    RK=1.+(1./PP1)*ALOG(B1+(1.-B1)*PEX1)
       IF(L-1) 1,2,1
2      BETA=(2.12/AFJ(1)**0.66667-0.05)/(0.76+2.2/AFJ(1)**0.33333)
       Q1=1.+BETA/RJL
       Q2=Q1*SQRT(Q1)
       FRK=(((3.*SQRT(3.))/2.)/Q2)*(Q1*RK-RK**3)
       GO TO 3
1     FRK=((3.*SQRT(3.))/2.)*(RK-RK**3)
       GO TO 3
 3     B2=RNDMSMM(-1)
       IF(B2-FRK) 4,4,5
4      TKIHOT=  RJL*(1.-RK**2)+VJ(L)
       RETURN
      END
       SUBROUTINE EVAHOT(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KHOT)
C   EVAPORATION OF HOT FRAGMENTS
       COMMON /BLHT05/AJ(68)
     */BLHT06/ZJ(68)/BLHT14/GAN(68)/BLHT11/VJ(68)/BLHT15/RJ(68)
      COMMON /BLHT03/U,A,Z/BLHT09/AFJ(68)/BLHT10/ZFJ(68)
      COMMON /BLANGL/ANGL(4) /BLHTEX/EXTF(68)
      COMMON /SMPHOT/ SMPA(100),SMPZ(100),SMPE(100),SMPP(100,3)
      COMMON /BLSECON/LSECON
      COMMON /BMILAZ/MILAZ /BLMECH/IMECH
      DIMENSION GJ(68),BJ(68),GG(68),VN(3),PN(3),PNL(3),PP(3),PPL(3)
      DIMENSION GGJ(68)
      U=ENEXT*1000.
      A=ATWGHT
      Z=CHARGE
      REMN=940.*A
      PNL(1)=PNX*1000.
      PNL(2)=PNY*1000.
      PNL(3)=PNZ*1000.
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+REMN**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      AM=0.125
      RADNCL=1.5
      DO 1 III=1,100
      SMPA(III)=0.
      SMPZ(III)=0.
      SMPE(III)=0.
      SMPP(III,1)=0.
      SMPP(III,2)=0.
      SMPP(III,3)=0.
 1    CONTINUE
      LSECON=0
      IN=68
      DO 20 K=1,100
      UA=U/A
c -- excluding EVAHOT (exit for any energy) --
      IF(MILAZ.EQ.1.AND.UA.LE.10000.) GO TO 11
      IF(IMECH.EQ.4.AND.UA.LE.10000.) GO TO 11
c --------------------------------------------
      IF(UA.LE.1.7) GO TO 11
      IF(A.LE.16.) GO TO 11
      DO 4 I=1,IN
      VJ(I)=0.
 4    RJ(I)=-1000.
      CALL DELAM(A,Z,DL1,DSHEL1,BAR1)
      DO 6 I=1,IN
      AFJ(I)=A-AJ(I)
      ZFJ(I)=Z-ZJ(I)
        IF(AFJ(I).LT.ZFJ(I)) GO TO 6
        IF(AFJ(I).LT.AJ(I).OR.ZFJ(I).LT.ZJ(I)) GO TO 6
      VJ(I)=COLHOT(I,RADNCL)
      CALL DELAM(AFJ(I),ZFJ(I),DL2,DSHEL2,BAR2)
      CALL DELAM(AJ(I),ZJ(I),DL3,DSHEL3,BAR3)
      BJ(I)=DL2+DL3-DL1
      RR=U-(BJ(I)+VJ(I))
      EXTF(I)=0.
      IF(RR.GT.0.AND.I.GT.6) EXTF(I)=RR*AJ(I)/A
      RJ(I)=RR-EXTF(I)
 6    CONTINUE
       DO 7 I=1,IN
      GJ(I)=GAMHOT(I,A,U,AM,RADNCL)
7     CONTINUE
      G=0.
      DO 10 I=1,IN
10    G=G+GJ(I)
C ***************
c     IF(G.LE.0.) GO TO 11
c     PRINT 33,U,A,Z
c33   FORMAT(2X,' U=',F7.2,' A=',F5.1,' Z=',F5.1)
c     PRINT 30
c30   FORMAT(10X,'absolute widths:')
c     PRINT 31,(GJ(I),I=1,IN)
c31   FORMAT(2X,' GJ=',10E10.3)
c     DO 32 I=1,IN
c     GGJ(I)=GJ(I)/G
c32   CONTINUE
c     PRINT 35
c35   FORMAT(10X,'relative widths:')
c     PRINT 34,(GGJ(I),I=1,IN)
c34   FORMAT(2X,'GGJ=',10F7.4)
C ***************
        IF(G) 11,11,12
 11   PNX=PNL(1)*0.001
      PNY=PNL(2)*0.001
      PNZ=PNL(3)*0.001
      ENEXT=U*0.001
      ATWGHT=A
      CHARGE=Z
      SMPA(K)=A
      SMPZ(K)=Z
      SMPE(K)=ENEXT
      SMPP(K,1)=PNX
      SMPP(K,2)=PNY
      SMPP(K,3)=PNZ
      IF(K.GT.1) LSECON=1
      KHOT=K
      RETURN
 12   CONTINUE
      DO 13 J=2,IN
13    GJ(J)=GJ(J-1)+GJ(J)
      BB=RNDMSMM(-1)
      B=BB*G
      DO 14 J=1,IN
        IF(B-GJ(J)) 15,14,14
15    LM=J
      GO TO 16
 14   CONTINUE
 16   IF(LM.LT.1.OR.LM.GT.IN) PRINT 300,LM
 300  FORMAT(2X,' ERROR IN EPAHOT - LM=',I5)
      IF(LM.LT.1.OR.LM.GT.IN) GO TO 11
      EP1=TKIHOT(LM,AM)
      EP2=ZJ(LM)
      EP3=940.*AJ(LM)
c ********
c     PRINT 36,LM,AJ(LM),ZJ(LM),EP1,EXTF(LM)
c36   FORMAT(2X,'LM=',I3,' AJ,ZJ=',2F5.1,' EP1=',F8.3,' EXTF=',
c    *F8.3)
c ********
      U=U-BJ(LM)-EP1-EXTF(LM)
      A=AFJ(LM)
      Z=ZFJ(LM)
C  VPM - RELATIVE VELOCITY OF FRAGMENT
      VPM=SQRT((2.*EP1)/(EP3*AFJ(LM)/(AFJ(LM)+AJ(LM))))
      CALL ISANGL
C  IN CMS
      PP(1)=VPM*ANGL(4)*ANGL(3)*EP3/(1.+AJ(LM)/A)
      PP(2)=VPM*ANGL(4)*ANGL(2)*EP3/(1.+AJ(LM)/A)
      PP(3)=VPM*ANGL(1)*EP3/(1.+AJ(LM)/A)
      PN(1)=-PP(1)
      PN(2)=-PP(2)
      PN(3)=-PP(3)
      EP=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+EP3**2)
      EN=SQRT(PN(1)**2+PN(2)**2+PN(3)**2+(940.*A)**2)
      CALL CLPV(PP,VN,PPL,EP)
      CALL CLPV(PN,VN,PNL,EN)
      SMPA(K)=AJ(LM)
      SMPZ(K)=ZJ(LM)
      SMPE(K)=EXTF(LM)*0.001
      SMPP(K,1)=PPL(1)*0.001
      SMPP(K,2)=PPL(2)*0.001
      SMPP(K,3)=PPL(3)*0.001
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+(940.*A)**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
20    CONTINUE
c      PRINT 21,U,A,Z
c21    FORMAT(35X,37HMASSIVS SMP EXCEEDED AFTER EVAHOT    /40X,2HU=,
c     *F10.5,4H  A=,F5.1,4H  Z=,F4.1)
       RETURN
       END
      BLOCK DATA EVHO
      COMMON /BLHT05/AJ(68) /BLHT06/ZJ(68) /BLHT14/GAN(68)
      COMMON /BLHT20/FREP(68)
      DATA AJ/
     * 1, 1, 2, 3, 3, 4, 6, 6, 7, 7, 8, 9, 9,10,11,11,12,13,13,14,
     *15,15,16,17,18,18,19,20,20,21,22,22,23,24,24,25,26,26,27,28,
     *28,29,30,30,31,32,32,33,33,34,35,35,36,36,36,37,37,38,39,39,
     *40,40,40,41,41,41,42,42/
      DATA ZJ/
     * 0, 1, 1, 1, 2, 2, 2, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 6, 7, 7,
     * 7, 8, 8, 8, 8, 9, 9, 9,10,10,10,11,11,11,12,12,12,13,13,13,
     *14,14,14,15,15,15,16,15,16,16,16,17,16,17,18,17,18,18,18,19,
     *18,19,20,18,19,20,19,20/
      DATA FREP/6*1.,4*0.5,1.,2*0.5,1.,2*0.5,1.,2*0.5,1.,
     * 2*0.5,1.,1.,2*0.5,1.,2*0.5,1.,2*0.5,1.,2*0.5,1.,2*0.5,1.,0.5,
     * 0.5,1.,2*0.5,1.,4*0.5,1.,2*0.5,3*0.333,2*0.5,1.,2*0.5,
     * 6*0.333,2*0.5/
      DATA GAN/2.,2.,3.,2.,2.,1.,62*1./
      END

c -- for smm_met7 correct.second.deexcit. introduced (see MILAZ, IEVAR) 
c         change ZVEZD1, GAMMA1, E11, EPSIL0 and TC
C  PROGRAM OF MULTIFRAGMENTION (WITH RETURN). SMM1 for Soviet VAX
C
      SUBROUTINE ZVEZD1(EE,AA,ZZ,P1,P2,P3,KST)
C MAIN PROGRAM OF MULTIFRAGMENTATION. INPUT: RES.NUCL. - AA,ZZ ; ITS
C EXCITATION - EE (GEV); MOMENTA IN LAB.SYS. - P1,P2,P3 (GEV/C);
C KST - FREE NUMBER IN SPT-MASSIVE (KST=1 - IN THE BEGIN.);
C OUTPUT: ALL PART. AND FRAGM. IN MASSIVE SPT(9,500).
C   *** CHANGED SWITCH.MICR.TO MACR.: INSTEAD SR00 - WW3  ***
c ****** implementation of radial flow (nonrelativistic) *****
c ** and rotation. EFLOW, EMOM in GeV/N. ANMOM in h-bar. *****
c ******  (with relativistic correction - RELCOR)       *****
      REAL N,MU,K,LT,L,KC
      COMMON /BLOKZV/SRN1(500),SRN2(500),SR1,SR2 /ADDNUC/IZPN,IAPN
      COMMON /BLFINL/A0F,Z0F,E0F,TF,FL,SRF,WW3F /BLIMA/IMA
      COMMON /BLOKN/N(500) /BLOKFR/FRA(500),SNSR,SPSR,S3SR,Z3SR,MFRAG
      COMMON /BLKFRZ/FRZ(500),FRZ2(500)
      COMMON /BLOKF1/EXFRA(500),EKFRA(500)
      COMMON /BLOKF4/SAAM,SEKAM,SEXAM,SSEKX,SSEX
      COMMON /BLPARA/EPSIL0,FKAPPA,FKACOL /BLMOM/AMOM,AM(500),IAMO
      COMMON /BL500/W,W2(250),W3(25000),W4(10000)
      COMMON /BL503/WCOMP,WW2,WW3,WW4,WW5,WEVAP,WW4G
      COMMON /BL502/M2,M3,M4,M5,MC2,MC3,MC4,MC5
      COMMON /BLMULF/IMULF /BENTRO/SSR /BLHKST/IHFKST(500,2)
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE 
      COMMON /SMPHOT/ SMPA(100),SMPZ(100),SMPE(100),SMPP(100,3)
      COMMON /BLFLOW/A00,EFLOW,IFLOW /BLAMOM/ANMOM,EMOM,IAMOM 
      COMMON /BLJJJ/JJJ /BLECBS/ECOLBS /BLECB0/ECBGC
      COMMON /BLEVAR/IEVAR /BMILAZ/MILAZ
      COMMON /BICOLE/ICOLE
      COMMON /BTMUL/TMUL,ITMUL /BTMUL0/ESR,ESRP,ESRP2
      common /smmfrg/ nsmmfr
      DIMENSION PA(500),PAZ(500),AMP(500),ZMP(500)
      DIMENSION PN0(3,500),PNC(3),PNL(3),PN(3),VN(3),UPM(500)
      IAMO=0
      AMOM=0.
      A0=AA
      Z0=ZZ
      IA0=INT(A0+0.5)
C      DO 166 I7=1,IA0
C      AI7=I7
C      IF(I7.LE.4) AM(I7)=0.
C      IF(I7.GT.4) AM(I7)=0.4*2.69*(AI7**1.66667)
C 166  CONTINUE
      SR00=2.60
      IMA4=0
      IF(IMA.EQ.4.AND.A0.LE.110.) IMA4=1
      IF(IMA4.EQ.1) SR00=3.30
      IF(A0.LT.0.9) RETURN
      IREP=0
      E00=(EE/A0)*1000.
      IF(AA-16.) 107,107,108
 107  A=AA
      Z=ZZ
      ERRMI=0
      ERRMA=0
      ERRFR=0
      IF(Z.GT.10.OR.(A-Z).GT.11) GO TO 105
      U=EE
      PN(1)=P1
      PN(2)=P2
      PN(3)=P3
      FRA(IA0)=FRA(IA0)+1.
      FRZ(IA0)=FRZ(IA0)+Z
      FRZ2(IA0)=FRZ2(IA0)+Z*Z
      EXFRA(IA0)=EXFRA(IA0)+EE*1000./FLOAT(IA0)
      EKFRA(IA0)=EKFRA(IA0)+1000.*(P1**2+P2**2+P3**2)/(2.*0.94*IA0)
      MFRAG=MFRAG+1
      IF(Z.GE.1.) SPSR=SPSR+1.
      IF(Z.LE.0.) SNSR=SNSR+1.
      IF(Z.GE.3.) S3SR=S3SR+1.
      IF(Z.GE.3.) Z3SR=Z3SR+Z
      SAAM=SAAM+IA0
      SEKAM=SEKAM+1000.*(P1**2+P2**2+P3**2)/(2.*0.94*IA0)
      SEXAM=SEXAM+EE*1000./FLOAT(IA0)
      SSEKX=SSEKX+1000.*(EE+(P1**2+P2**2+P3**2)/(2.*0.94*IA0))
      SSEX=SSEX+1000.*EE
      GO TO 157
 108  CONTINUE
      IF(IMULF.LE.0) GO TO 163
      IF(ITMUL.EQ.1) GO TO 165
      IF(E00)163,163,165
 163  ERRMI=0
      ERRMA=0
      ERRFR=0
      GO TO 105
 165  CONTINUE
ccc      REMN=0.94*A0
      EDIN=0.
      IF(IFLOW.GE.1) EDIN=EDIN+EFLOW*A0
      IF(IAMOM.GE.1) EDIN=EDIN+EMOM*A0
      REMN=0.940*A0+EE+EDIN
      EWHOLE=SQRT(P1*P1+P2*P2+P3*P3+REMN*REMN)
      VN(1)=P1/EWHOLE
      VN(2)=P2/EWHOLE
      VN(3)=P3/EWHOLE
      K=FKAPPA
      KC=FKACOL
      IF(IMA.EQ.0) WW3=1.
      IF(IMA.EQ.0) GO TO 102
c      IF(A0.EQ.A0F.AND.Z0.EQ.Z0F.AND.E00.EQ.E0F) GO TO 60
      IF(ITMUL.EQ.0.AND.A0.EQ.A0F.AND.Z0.EQ.Z0F.AND.E00.EQ.E0F) GO TO 60
      IF(ITMUL.EQ.1.AND.A0.EQ.A0F.AND.Z0.EQ.Z0F.AND.TMUL.EQ.TF) GO TO 60
      ERRMI=0
      ERRMA=0
      ERRFR=0
      E0I=E00
C      IF(IAMO.EQ.1) E0I=E0I+41.5*(AMOM**2)/(2.*AM(IA0)*A0)
CCC      CALL FRATE3(A0,Z0,E0I,K,KC,EPSIL0,TK,SR)
      CALL FRAMIK(A0,Z0,E0I,K,KC,EPSIL0,TK,SR)
      SR1=SR
      DO 201 IJ=1,IA0
 201  SRN1(IJ)=N(IJ)
C *******
c      PRINT 170,E0I,SR,TK,SSR
c 170  FORMAT(2X,'FRAMIK:  E0I=',F8.3,' SR=',F6.2,' TSR=',F9.4,
c     *' entrop SSR=',F7.2)
c      PRINT 121,(N(I),I=1,IA0)
c      PRINT 169,WCOMP,WW2,WW3,WW4,W
c 169  FORMAT(2X,'WCOMP=',E11.4,' WW2=',E11.4,' WW3=',
c     *E11.4,' WW4=',F7.5,' W=',E11.4)
c      PRINT 168,M2,M3,M4,MC4
c 168  FORMAT(5X,' M2=',I4,' M3=',I6,' M4=',I7,' MC4=',I7)
C *******
      GO TO 62
 60   TK=TF
      L=FL
      SR=SRF
      WW3=WW3F
 62   CONTINUE
      IF(IMA4.EQ.1) GO TO 204
      IF(WW3-0.55) 101,101,102
 204  IF(SR-SR00) 101,101,102
 101  CONTINUE
      CALL CHOSAZ(A0,Z0,TK,IP,PA,PAZ)
      GO TO 103
 102  CONTINUE
c      IF(A0.EQ.A0F.AND.Z0.EQ.Z0F.AND.E00.EQ.E0F) GO TO 61
      IF(ITMUL.EQ.0.AND.A0.EQ.A0F.AND.Z0.EQ.Z0F.AND.E00.EQ.E0F) GO TO 61
      IF(ITMUL.EQ.1.AND.A0.EQ.A0F.AND.Z0.EQ.Z0F.AND.TMUL.EQ.TF) GO TO 61
      CALL FRAGTE(A0,Z0,E00,K,KC,EPSIL0,TK,MU,L,SR)
      SR2=SR
      DO 202 IJ=1,IA0
 202  SRN2(IJ)=N(IJ)
C *******
c      PRINT 171,E00,SR,TK,SSR
c 171  FORMAT(2X,'FRAGTE:  E00=',F8.3,' SR=',F6.2,' TK=',F9.4,
c     *' entrop SSR=',F7.2)
c      PRINT 121,(N(I),I=1,IA0)
C *******
 61   CONTINUE
      IF(IMA4.EQ.1) GO TO 207
      WWW=4.*(WW3-0.55)
      IF(WWW.LT.0.) WWW=0.
      IF(WWW.GT.1.) WWW=1.
      IF(ITMUL.EQ.1) WWW=1.
      DO 203 IJ=1,IA0
 203  N(IJ)=(1.-WWW)*SRN1(IJ)+WWW*SRN2(IJ)
      SR=(1.-WWW)*SR1+WWW*SR2
      CALL SELECT(A0,Z0,N,TK,L,IP,PA,PAZ)
      GO TO 103
 207  CONTINUE
      CALL SELECT(A0,Z0,SRN2,TK,L,IP,PA,PAZ)
 103  CONTINUE
      IPROB=1
      DO 500 I=1,IP
      IA=INT(PA(I)+0.5)
      IZ=INT(PAZ(I)+0.5)
      IF(IA.GT.1.AND.IZ.GE.IA) IPROB=0
 500  IF(IA.GT.1.AND.IZ.LE.0) IPROB=0
      IF(IPROB.EQ.1) GO TO 501
      IF(IMA4.EQ.1) GO TO 205
      IF(WW3-0.55) 101,101,61
 205  IF(SR-SR00) 101,101,61
 501  CONTINUE
      A0F=A0
      Z0F=Z0
      E0F=E00
      TF=TK
      FL=L
      SRF=SR
      WW3F=WW3
C *******
      IF(JJJ.GT.1) GO TO 504
c$$$      PRINT 120,SR,TK,ECBGC
c$$$ 120  FORMAT(3X,'SR=',F7.3,' TK=',F7.3,' MEV',' ECBGC=',F8.3,10X,'N(A)')
c$$$      PRINT 121,(N(I),I=1,IA0)
c$$$ 121  FORMAT(2X,10F7.4)
c$$$      IF(ITMUL.EQ.1) PRINT 1211,ESR
c$$$ 1211 FORMAT(2X,'average excit. energy ESR(MeV/n)=',F9.4)
 504  CONTINUE
      IF(JJJ.GT.3) GO TO 505
c$$$      PRINT 122,IP
c$$$ 122  FORMAT(5X,' IP=',I3,' FRAGMENTS - PA,PAZ:')
c$$$      PRINT 123,(PA(I),PAZ(I),I=1,IP)
c$$$ 123  FORMAT(2X,5(2F6.1,2X))
 505  CONTINUE
C *******
      nsmmfr=ip
      IF(IP-1) 105,105,106
 105  A=AA
      Z=ZZ
      PX=P1
      PY=P2
      PZ=P3
      FRA(IA0)=FRA(IA0)+1.
      FRZ(IA0)=FRZ(IA0)+Z
      FRZ2(IA0)=FRZ2(IA0)+Z*Z
      EKFRA(IA0)=EKFRA(IA0)+1000.*(P1**2+P2**2+P3**2)/(2.*0.94*IA0)
      MFRAG=MFRAG+1
      IF(Z.GE.1.) SPSR=SPSR+1.
      IF(Z.LE.0.) SNSR=SNSR+1.
      IF(Z.GE.3.) S3SR=S3SR+1.
      IF(Z.GE.3.) Z3SR=Z3SR+Z
      SAAM=SAAM+IA0
      SEKAM=SEKAM+1000.*(P1**2+P2**2+P3**2)/(2.*0.94*IA0)
      SSEKX=SSEKX+1000.*(EE+(P1**2+P2**2+P3**2)/(2.*0.94*IA0))
c ------- add statistics for compound ------------
      T=sqrt(E00/0.125)
      IF(ITMUL.EQ.1) T=TMUL
      IP=1
      PA(1)=A
      PAZ(1)=Z
      CALL FINDT(E00,A0,Z0,PA,PAZ,IP,T,ETP,ECOLB,ECP,EEX,EB)
      IF(ITMUL.EQ.1) EE=E00*A0*0.001
      U=EE
      EXFRA(IA0)=EXFRA(IA0)+EE*1000./FLOAT(IA0)
      SEXAM=SEXAM+EE*1000./FLOAT(IA0)
      SSEX=SSEX+1000.*EE
c --- finding new surface parameters
      CALL PARAM2(T,EPSIL0)
      IF(ITMUL.EQ.1) ESRP=ESRP+E00
      IF(ITMUL.EQ.1) ESRP2=ESRP2+E00*E00
c --- statistics on microcanonical temperature
      AMP(1)=0.94*A
      ZMP(1)=Z
      CALL FIXT(T,K,IP,AMP,ZMP)
      IDUM1=0
      IDUM2=0
      EDUM3=0.
      PN0(1,1)=0.
      PN0(2,1)=0.
      PN0(3,1)=0.
      UPM(1)=EE
      CALL HOTFDA(AA,ZZ,EE,T,IP,IDUM1,IDUM2,AMP,ZMP,UPM,PN0,EDUM3)
c -------------------------
      GO TO 156
 106  CONTINUE
      T=TK
      CALL FINDT(E00,A0,Z0,PA,PAZ,IP,T,ETP,ECOLB,ECP,EEX,EB)
      IF(ERRFR.LT.0.5) GO TO 111
C *******
ccc      IF(JJJ.LE.71) GO TO 505
c      PRINT 800,IREP,TK,T,EB,ECOLB
c      PRINT 801,(PA(I),I=1,IP)
c 801  FORMAT(2X,29F4.0)
c 800  FORMAT(2X,'IREP=',I2,' TK,T=',2F9.5,' EB,ECOLB=',2F10.4,'   PA:')
ccc 505  CONTINUE
C *******
      IREP=IREP+1
      IF(IREP.GT.10) GO TO 160
      IF(IMA4.EQ.1) GO TO 206
      IF(WW3-0.55) 101,101,61
 206  IF(SR-SR00) 101,101,61
 111  CONTINUE
c average excit. energy in events 
      IF(ITMUL.EQ.1) ESRP=ESRP+E00
      IF(ITMUL.EQ.1) ESRP2=ESRP2+E00*E00
      IF(ITMUL.EQ.1) EE=E00*A0*0.001
c **** including implementation additional number of protons.
cc     IZPN=INT(0.5*(79.-ZZ))
cc     IAPN=INT(0.5*(197.-AA))
      IF(IZPN.LT.1.OR.IAPN.LT.1) GO TO 411
      IPOLD1=IP+1
      IPNEW=IP+IZPN
      DO 410 J=IPOLD1,IPNEW
      PA(J)=1.
      PAZ(J)=1.
 410  CONTINUE
      IP=IPNEW
      ZZ0=IZPN+ZZ
      AA0=IAPN+AA
      ECOEFC=(0.6*1.44/(1.17*(1.+KC)**0.333333))
      IF(ICOLE.EQ.-1) ECOEFC=0.
      ECOLN=ECOEFC*ZZ0*ZZ0/(AA0**0.333333)
      DO 412 J4=1,IP
      ECOLN=ECOLN-ECOEFC*PAZ(J4)*PAZ(J4)/(PA(J4)**0.333333)
 412  CONTINUE
      ECOLB=ECOLN
 411  CONTINUE
c  *******
      I=0
      INEUTR=0
      DO 400 J=1,IP
      IF(PAZ(J).LE.0.) GO TO 400
      I=I+1
      AMP(I)=0.94*PA(J)
      ZMP(I)=PAZ(J)
 400  CONTINUE
      IP0=I
      DO 401 J=1,IP
      IF(PAZ(J).GT.0.) GO TO 401
      INEUTR=INEUTR+1
      AMP(IP0+INEUTR)=0.94*PA(J)
      ZMP(IP0+INEUTR)=0.
 401  CONTINUE
C *******
      IF(JJJ.GT.3) GO TO 507
c$$$      PRINT 124,T,IP,INEUTR,IP0,ECOLB,ECP,EEX,EB,EE
c$$$ 124  FORMAT(2X,'T=',F7.3,' MEV  IP=',I3,' INEUTR=',I3,' IP0=',I3/
c$$$     *1X,' ECOLB=',F9.4,' MEV  ECP=',F9.4,'  EEX=',F9.4,'  EB=',F10.3/
c$$$     *1X,' prim. excit.energ. in the event EE=',F8.5,' GeV')
 507   CONTINUE
C *******
      SPSR=SPSR+IP0
      SNSR=SNSR+INEUTR
      ECOLBS=ECOLBS+ECOLB
      MFRAG=MFRAG+1
      IF(IP0.LE.1) IP0=IP
c including small number of neutrons in general propagation algorithm
      IF(INEUTR.LE.2) IP0=IP
CCC     TP=0.001*(ECOLB+1.5*IP0*T)
CCC     CALL DISIMP(IP0,AMP,PN0,TP)
      ECOLB=0.001*ECOLB
cc      CALL CULIMP(IP0,A0,Z0,AMP,ZMP,PN0,T,ECOLB)
cc      IF(IP0.GE.IP) GO TO 104
cc      TN=0.001*1.5*INEUTR*T
cc      CALL DISNET(INEUTR,IP0,AMP,PN0,T,TN)
c **** implementation of flow and rotation *************
      CALL POS0(IP,IP0,A0,Z0,AMP,ZMP)
      CALL CULIM0(IP0,A0,Z0,AMP,ZMP,PN0,T,ECOLB)
      IF(IP0.GE.IP) GO TO 104
      TN=0.001*1.5*INEUTR*T
c      CALL DISNE0(INEUTR,IP0,AMP,PN0,T,TN)
      CALL DISN02(INEUTR,IP0,AMP,PN0,T,TN)
      CALL ECOR02(INEUTR,IP0,AMP,PN0,TN)
c --- statistic on energy of hot fragments before coulomb ---
      CALL BFREN(INEUTR,IP0,AMP,PN0)
c **********************************************************
 104  CONTINUE
c --- finding new surface parameters
      CALL PARAM2(T,EPSIL0)
c --- statistics on microcanonical temperature
      CALL FIXT(T,K,IP,AMP,ZMP)
c --- statistics on hot fragments
      CALL HOTFR(IP0,A0,Z0,AMP,ZMP,PN0,T,ECOLB)
c -------------------------------
c **** relativistic correction ****
c      CALL RELCOR(IP,AMP,ZMP,PN0)
c ****
ccc      IF(JJJ.GE.72) PRINT 506
ccc 506  FORMAT(2X,'print after DISNE0')
      KSTI=1
      IAAM=0
      DO 35 I=1,IP
      DO 36 J=1,3
 36   PNC(J)=PN0(J,I)
C *******
c      EPAT=(PNC(1)**2+PNC(2)**2+PNC(3)**2)/(2.*AMP(I))
c      PRINT 125,IP,AMP(I),(PNC(J),J=1,3),EPAT
c 125  FORMAT(2X,'PARTICLE IP=',I3,' AMP=',F7.3,'  PNC(1-3) (GEV/C)=',
c     *3F7.3,' EPAT (GEV)=',F7.3)
C *******
      EN=SQRT(PNC(1)**2+PNC(2)**2+PNC(3)**2+AMP(I)**2)
      CALL CLPV(PNC,VN,PNL,EN)
C *******
c      EPAT=(PNL(1)**2+PNL(2)**2+PNL(3)**2)/(2.*AMP(I))
c      PRINT 126,IP,AMP(I),(PNL(J),J=1,3),EPAT
c 126  FORMAT(2X,'B  [.C.K. IP=',I3,' AMP=',F7.3,'  PNL(1-3) (GEV/C)=',
c     *3F7.3,' EPAT (GEV)=',F7.3)
C *******
      A=AMP(I)/0.94
      Z=ZMP(I)
      IA=INT(A+0.5)
      IZ=INT(Z+0.5)
      IF(IZ.GE.3) S3SR=S3SR+1.
      IF(IZ.GE.3) Z3SR=Z3SR+Z
      IF(IA.GT.0.AND.IA.LE.500) FRA(IA)=FRA(IA)+1.
      IF(IA.GT.0.AND.IA.LE.500) FRZ(IA)=FRZ(IA)+Z
      IF(IA.GT.0.AND.IA.LE.500) FRZ2(IA)=FRZ2(IA)+Z*Z
CCC     GO TO 35
      IF(IA-3) 51,51,52
 51   U=0.
      GO TO 53
 52   U=UEVA(A,T)
 53   CONTINUE
      UPM(I)=U
      IF(IA.GT.0.AND.IA.LE.500.AND.IA.GT.IAAM) EXAM=U*1000./FLOAT(IA)
      IF(IA.GT.0.AND.IA.LE.500.AND.IA.GT.IAAM) 
     *EKAM=1000.*(PNL(1)**2+PNL(2)**2+PNL(3)**2)/(2.*0.94*IA)
      IF(IA.GT.0.AND.IA.LE.500.AND.IA.GT.IAAM) IAAM=IA
      IF(IA.GT.0.AND.IA.LE.500) 
     *EKX=1000.*(U+(PNL(1)**2+PNL(2)**2+PNL(3)**2)/(2.*0.94*IA))
      SSEKX=SSEKX+EKX
      IF(IA.GT.0.AND.IA.LE.500) SSEX=SSEX+1000.*U
      IF(IA.GT.0.AND.IA.LE.500) 
     *EXFRA(IA)=EXFRA(IA)+U*1000./FLOAT(IA)
      IF(IA.GT.0.AND.IA.LE.500) EKFRA(IA)=EKFRA(IA)
     *+1000.*(PNL(1)**2+PNL(2)**2+PNL(3)**2)/(2.*0.94*IA)
      PX=PNL(1)
      PY=PNL(2)
      PZ=PNL(3)
      CALL EVAHOT(U,A,Z,PX,PY,PZ,KHT)
      DO 703 I3=1,KHT
      U=SMPE(I3)
      A=SMPA(I3)
      Z=SMPZ(I3)
      PX=SMPP(I3,1)
      PY=SMPP(I3,2)
      PZ=SMPP(I3,3)
      IA3=INT(A+0.5)
      IZ3=INT(Z+0.5)
c *******************
c      IF(JJJ.EQ.1205.OR.JJJ.EQ.1206.OR.JJJ.EQ.1564.OR.JJJ.EQ.1565) 
c     *PRINT 706,A,Z,U
c 706  FORMAT(2X,'AFTER EVAHOT: A,Z=',2F5.1,' U=',F8.4)
c *******************
      IF(IZ3.GT.10.OR.(IA3-IZ3).GT.11) GO TO 705
      IF(IA3-16) 704,704,705
 704  CONTINUE
      IF(MILAZ.EQ.1) GO TO 705
      PN(1)=PX
      PN(2)=PY
      PN(3)=PZ
c -------- changing secondary de-excit. ----------
      CALL RAZVAL(U,A,Z,PN,KST)
c      CALL EVANUC(U,A,Z,PX,PY,PZ,KST)
c ------------------------------------------------
      GO TO 703
 705  CONTINUE
      CALL EVANUC(U,A,Z,PX,PY,PZ,KST)
      IF(IEVAR.EQ.0) GO TO 601
      PN(1)=PX
      PN(2)=PY
      PN(3)=PZ
      CALL RAZVAL(U,A,Z,PN,KST)
 601  CONTINUE
 703  CONTINUE
c ---------------
      KSTF=KST-1
c **************************
c      IF(JJJ.EQ.1205.OR.JJJ.EQ.1206.OR.JJJ.EQ.1564.OR.JJJ.EQ.1565) 
c     *PRINT 708,IA,IZ,KSTI,KSTF
c 708  FORMAT(2X,'hot.fragm: IA,IZ=',2I4,'  KSTI,KSTF=',2I4)
c **************************
      IHFKST(I,1)=KSTI
      IHFKST(I,2)=KSTF
      KSTI=KST
c ---------------
 35   CONTINUE
      SAAM=SAAM+IAAM
      SEKAM=SEKAM+EKAM
      SEXAM=SEXAM+EXAM
      KST1=KST-1
c **************************
c      IF(JJJ.EQ.1205.OR.JJJ.EQ.1206.OR.JJJ.EQ.1564.OR.JJJ.EQ.1565) 
c     *PRINT 707,JJJ,KST1,KSTI,KSTF
c 707  FORMAT(2X,'JJJ=',I6,' numb.part. KST1=',I3,'  KSTI,KSTF=',2I4)
c **************************
c      CALL HOTFR6(IP,KST1,A0,Z0,AMP,ZMP,PN0,T,ECOLB)
      CALL HOTFDA(AA,ZZ,EE,T,IP,IP0,INEUTR,AMP,ZMP,UPM,PN0,ECOLB)
      CALL HOFPC(IP,KST1,A0,Z0,AMP,ZMP,UPM,PN0,T,ECOLB)
      GO TO 160
c -------- changing secondary de-excit. ----------
 157  CONTINUE
      IF(MILAZ.EQ.1) GO TO 1570
      CALL RAZVAL(U,A,Z,PN,KST)
      GO TO 160
 1570 PX=PN(1)
      PY=PN(2)
      PZ=PN(3)
      CALL EVANUC(U,A,Z,PX,PY,PZ,KST)
      IF(IEVAR.EQ.0) GO TO 602
      PN(1)=PX
      PN(2)=PY
      PN(3)=PZ
      CALL RAZVAL(U,A,Z,PN,KST)
 602  CONTINUE
c ------------------------------------------------
      GO TO 160
 156  CALL EVAHOT(U,A,Z,PX,PY,PZ,KHT)
      DO 700 I2=1,KHT
      U=SMPE(I2)
      A=SMPA(I2)
      Z=SMPZ(I2)
      PX=SMPP(I2,1)
      PY=SMPP(I2,2)
      PZ=SMPP(I2,3)
      IA2=INT(A+0.5)
      IZ2=INT(Z+0.5)
c *******************
c      PRINT 706,A,Z,U,PX,PY,PZ
c *******************
      IF(IZ2.GT.10.OR.(IA2-IZ2).GT.11) GO TO 701
      IF(IA2-16) 702,702,701
 702  CONTINUE
      IF(MILAZ.EQ.1) GO TO 701
      PN(1)=PX
      PN(2)=PY
      PN(3)=PZ
c -------- changing secondary de-excit. ----------
      CALL RAZVAL(U,A,Z,PN,KST)
c      CALL EVANUC(U,A,Z,PX,PY,PZ,KST)
c ------------------------------------------------
      GO TO 700
 701  CALL EVANUC(U,A,Z,PX,PY,PZ,KST)
      IF(IEVAR.EQ.0) GO TO 603
      PN(1)=PX
      PN(2)=PY
      PN(3)=PZ
      CALL RAZVAL(U,A,Z,PN,KST)
 603  CONTINUE
 700  CONTINUE
      GO TO 160
 160  IF(ERRMI.GT.0.5.OR.ERRMA.GT.0.5) PRINT 161,AA,ZZ,EE,ERRMI,ERRMA
 161  FORMAT(2X,'SUSPECTING EVENT: AA,ZZ,EE=',3F9.4,' ERRMI,ERRMA=',
     *2F9.1)
      IF(ERRFR.GT.0.5) PRINT 162,AA,ZZ,EE,ERRFR
 162  FORMAT(5X,'EVENT EXCLUDED: AA,ZZ,EE=',3F9.4,' ERRFR=',F9.1)
      RETURN
      END
      BLOCK DATA ZVEZ
      COMMON /BLMULF/IMULF /BLIMA/IMA /BLPARA/EPSIL0,FKAPPA,FKACOL
      COMMON /RESNU0/EMIN,EMAX,YMIN,YMAX /BPLACE/RFI /ADDNUC/IZPN,IAPN
      COMMON /BLJPRE/JPRE /CELIPS/CEL,IPOSF1
      COMMON /BPERI/IPERI /BLIDR/ILIDR /BLXRNO/XRNO
      COMMON /BLMEAM/AMEM,BMEM,EMEM,WMEM,IMEM /BLIKAP/IKAPPA
      COMMON /BLIEX/IEX
      COMMON /BICOLE/ICOLE
      DATA CEL/1./,IPOSF1/0/
      DATA IMULF/1/,IMA/3/,EPSIL0/16./,FKAPPA/1./,FKACOL/2./
      DATA IZPN/0/,IAPN/0/,RFI/0./,EMIN/0./,EMAX/0./,YMIN/0./,YMAX/0./
      DATA JPRE/0/,IPERI/0/,ILIDR/0/,XRNO/1./,IMEM/0/,IKAPPA/0/
      DATA IEX/0/
      DATA ICOLE/0/
      END

      SUBROUTINE FRAMIK(AA,ZZ,E00,K,KC,EPSIL0,TSR,MSR)
C HAXO[[EH[E [O [HEP[[[ E00 (MEV/N) M[[[T[[PA[MEHTHO[O COCTO[H[[
C B O[[ACT[ MA[[X [HEP[[[ BO[[[[[EH[[
C   ***********    KBA[[-M[KPOKAHOH[KA    *********
      REAL  K,KC,LT,MSR
      COMMON /BL500/W,W2(250),W3(25000),W4(10000) /BLIMA/IMA
      COMMON /BL501/IAF2(250),IAF3(25000),IAF4(10000)
      COMMON /BL502/M2,M3,M4,M5,MC2,MC3,MC4,MC5
      COMMON /BL503/WCOMP,WW2,WW3,WW4,WW5,WEVAP,WW4G
      COMMON /BLDIS/ J(20),IEND,JZ(20),IENDZ
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK3/E11(500),XZ(500),GA(500) /BLOKT/TCON
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 /BLOKN/SRW(500)
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE /BENTRO/SSR
      COMMON /BPERI/IPERI
      COMMON /BICOLE/ICOLE
      COMMON /BTMUL/TMUL,ITMUL /BTMUL0/ESR,ESRP,ESRP2
      ERRMI=0.
      A0=AA
      Z0=ZZ
      IA0=INT(A0+0.5)
      E11(1)=0.
      DO 100 I=2,IA0
      A=I
      IF(IPERI.EQ.0) E11(I)=EPSIL0*(1.+3./(A-1))
C      IF(I.LE.50) E11(I)=EPSIL0*(1.+0.12*(A**0.33333-5.**0.33333))
c 100  IF(I.GT.50) E11(I)=EPSIL0*(1.+0.12*(50.**0.33333-5.**0.33333))
      IF(IPERI.EQ.1) E11(I)=EPSIL0/(1.+0.0020*(A/25.)**2)
 100  CONTINUE
      TCON=SQRT(E00/0.125)
      T=0.
      IF(ITMUL.EQ.1) TCON=TMUL
      IF(ITMUL.EQ.1) T=TMUL
      CALL PARAM(T,K,KC,EPSIL0)
      XZ0=Z0/A0
      A013=A0**0.3333333
      V0=(4.*3.1416/3.)*A0*RADNCL**3
c --- NOT changing of coulomb volume : V_c=V_0+V_f -----
      PKP013=1./(1.+KC)**0.3333333
      CP=0.6*1.44*(1.-PKP013)/RADNCL
      IF(ICOLE.EQ.-1) CP=0.
c ------------------------------------
      E0Q=A0*(-W0+G0*(1.-2*XZ0)**2)+B0*A013*A013
     *+0.6*1.44*Z0*Z0/(RADNCL*A013)
      IF(ICOLE.EQ.-1) E0Q=A0*(-W0+G0*(1.-2*XZ0)**2)+B0*A013*A013
      DO 1 I=1,IA0
      A=I
      GA(I)=1.
      XZ(I)=XZ0
      SRW(I)=0.
 1    CONTINUE
      XZ(2)=0.5
      XZ(3)=0.5
      XZ(4)=0.5
      GA(2)=3.
      GA(3)=4.
      GA(4)=1.
      GA(1)=4.
      W=0.
      MSR=0.
      TSR=0.
      SSR=0.
      WW2=0.
      WW3=0.
      WW4=0.
      WW5=0.
      WEVAP=0.
      WW4G=0.
      ESR=0.
      CALL SCOMPA(E00,K,KC,EPSIL0,SCOMP)
      WCOMP=EXP(SCOMP-SCOMP)
      W=W+WCOMP
      WEVAP=WEVAP+WCOMP
      MSR=MSR+WCOMP*1.
      TSR=TSR+TCON*WCOMP
      SSR=SSR+WCOMP*SCOMP
      IF(ITMUL.EQ.1) ESR=ESR+WCOMP*E00
      SRW(IA0)=SRW(IA0)+WCOMP
      M2=0
      M3=0
      M4=0
      M5=0
      MMAX=3
      IF(IMA.EQ.2) MMAX=2
      IF(IMA.EQ.4.AND.IA0.LE.110) MMAX=4
      DO 10 M=2,MMAX
      MC=0
      J(M)=IA0
      M1=M-1
      DO 2 I=1,M1
 2    J(I)=0
 4    CALL DISA(M)
      IF(IEND.EQ.1) GO TO 10
      IF(M.EQ.3.AND.M3.GE.25000) GO TO 4
      MC=MC+1
c --- changing of coulomb volume : V_c=V_0+V_f -----
c      KC=((1.+1.4*(M**0.333333-1)/(RADNCL*A013))**3-1.)
c      PKP013=1./(1.+KC)**0.3333333
c      CP=0.6*1.44*(1.-PKP013)/RADNCL
c ------------------------------------
      CALL CALCWE(M,J,SCOMP,E00,K,KC,EPSIL0,PR,ECOLB)
C ***********
C      IF(MC.LE.20) PRINT 101,M,TCON,PR,ECOLB,(J(I),I=1,M)
C 101  FORMAT(2X,'M=',I3,' TCON=',F8.3,' PR=',F8.5,' ECOLB=',F8.3,' J=',
C     *5I4)
C ***********
      W=W+PR
      DO 6 I=1,M
      IA=J(I)
 6    SRW(IA)=SRW(IA)+PR
      MSR=MSR+M*PR
      TSR=TSR+TCON*PR
      IF(ITMUL.EQ.1) ESR=ESR+PR*E00
      IF(PR.GT.0.) SSR=SSR+PR*(SCOMP+ALOG(PR))
      IF(M.EQ.2) GO TO 22
      IF(M.EQ.3) GO TO 23
      IF(M.EQ.4) GO TO 24
      IF(M.EQ.5) GO TO 25
 22   MC2=MC
      WW2=WW2+PR
      IF(J(1).LE.4) WEVAP=WEVAP+PR
      M2=M2+1
      W2(M2)=PR
      IAF2(M2)=J(2)+1000*J(1)
      GO TO 4
 23   MC3=MC
      WW3=WW3+PR
      M3=M3+1
      W3(M3)=PR
      IAF3(M3)=J(3)+1000*J(2)+1000000*J(1)
      GO TO 4
 24   MC4=MC
      WW4=WW4+PR
      M4=M4+1
      IF(J(3).LE.4) WW4G=WW4G+PR
      IF(M4.GT.10000) GO TO 4
      W4(M4)=PR
      IAF4(M4)=J(4)+1000*J(3)+100000*J(2)+10000000*J(1)
      GO TO 4
 25   MC5=MC
      WW5=WW5+PR
      M5=M5+1
      GO TO 4
 10   CONTINUE
      IF(M4.GT.10000) M4=10000
      DO 12 I=1,IA0
 12   SRW(I)=SRW(I)/W
      DO 63 I8=1,M2
 63   W2(I8)=W2(I8)/W
      DO 64 I8=1,M3
 64   W3(I8)=W3(I8)/W
      DO 65 I8=1,M4
 65   W4(I8)=W4(I8)/W
      MSR=MSR/W
      TSR=TSR/W
      SSR=SSR/W
      WCOMP=WCOMP/W
      WW2=WW2/W
      WW3=WW3/W
      WW4=WW4/W
      WW4G=WW4G/W
      WW5=WW5/W
      WEVAP=WEVAP/W
      IF(ITMUL.EQ.1) TSR=TMUL
      IF(ITMUL.EQ.1) ESR=ESR/W
      IF(ITMUL.EQ.1) E00=ESR
      RETURN
      END
      SUBROUTINE CALCWE(M,J,SCOMP,E00,K,KC,EPSIL0,PR,ECOLB)
C  O[PE[E[EH[E BEPO[THOCT[ KOH[[[[PA[[[ PR=EXP(S(J(1-M),E0)
C       [ K[[OHOBCKO[O [AP[EPA ECOLB (MEV).
C  BXO[:M [PA[MEHTOB B MACC[BE J(1-M),[HEP[.BO[[.-E00 (MEV/N),
C  [APAMETP[ MO[E[[ K,KC,EPSIL0 [ [HTPO[[[ KOM[.[[PA SCOMP ([[[ [EPEC-
C  [ETA PR).
      REAL LT,K,KC
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK3/E11(500),XZ(500),GA(500) /BLOKT/TCON
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 /BLMOM/AMOM,AM(500),IAMO
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE 
      COMMON /BSTRAN/ITRAN /BLIKAP/IKAPPA
      COMMON /BICOLE/ICOLE
      COMMON /BTMUL/TMUL,ITMUL 
      DIMENSION EA(500),ECOLA(500),SAIN(500),J(20),COEFC(500)
      E0=E00*A0
      A013=A0**0.333333
c --- keep constant or vary with multiplic. translational volume ---
      IF(IKAPPA.EQ.1) VF=K*V0
      IF(IKAPPA.EQ.0) 
     *VF=V0*((1.+1.4*(M**0.333333-1)/(RADNCL*A013))**3-1.)
c ---
      M1=M-1
      FAKT=1.
      DO 32 I=1,M1
      FFF=1.
      IM=I+1
      DO 33 II=IM,M
      IF(J(I).EQ.J(II)) FFF=FFF+1.
 33   CONTINUE
      FAKT=FAKT*FFF
 32   CONTINUE
      PRFAKT=1.
      PRFAKT=PRFAKT*FAKT
      ECON=0.
      ECOLB=0.
      PRGA=1.
      PRA32=1.
      PAM32=1.
C      SAM=0.
c -- calcul. of avr.charge approx. from Grand-Canon. Coulomb infl. --
      ZM0=0.
      DO 10 I=1,M
      IA=J(I)
      A=IA
      COEFC(I)=(1.+(2.*CP*A0**0.666667)/(8.*G0))/
     #(1.+(2.*CP*A**0.666667)/(8.*G0))
      ZM0=ZM0+A*(Z0/A0)*COEFC(I)
 10   CONTINUE
      COEF=Z0/ZM0
      DO 11 I=1,M
      COEFC(I)=COEFC(I)*COEF
 11   CONTINUE
c -------------------------------------------------------------
      DO 34 I=1,M
      IA=J(I)
C      SAM=SAM+AM(IA)
C      IF(AM(IA).GT.0.) PAM32=PAM32*(AM(IA)*SQRT(AM(IA)))
      A=IA
c -- for charge calculation approxim. Coulomb infl. --
      XZ(IA)=(Z0/A0)*COEFC(I)
c ----------------------------------------------------
      PRGA=PRGA*GA(IA)
      PRA32=PRA32*(A*SQRT(A))
      IF(IA-1) 41,41,42
 41   ECOLA(IA)=CP*XZ(IA)*XZ(IA)
      EA(IA)=ECOLA(IA)
      GO TO 50
 42   IF(IA-4) 43,43,44
 43   ECOLA(IA)=CP*XZ(IA)*XZ(IA)*(A**(5./3.))
      IF(IA.EQ.2) EA(IA)=-2.796+ECOLA(IA)
      IF(IA.EQ.3) EA(IA)=-9.224+ECOLA(IA)
      IF(IA.EQ.4) EA(IA)=-30.11+ECOLA(IA)
      GO TO 50
 44   ECOLA(IA)=CP*XZ(IA)*XZ(IA)*(A**(5./3.))
      EA(IA)=(-W0+G0*(1.-2.*XZ(IA))**2)*A+
     #B0*A**0.666667+ECOLA(IA)
 50   CONTINUE
      ECON=ECON+EA(IA)
      ECOLB=ECOLB+ECOLA(IA)
 34   CONTINUE
C      EMOM=41.5*(AMOM**2)/(2*SAM)
      ECOLB=ECOLB+0.6*1.44*Z0*Z0*PKP013/(RADNCL*A013)
      IF(ICOLE.EQ.-1) ECOLB=0.
      ECON=ECON+0.6*1.44*Z0*Z0*PKP013/(RADNCL*A013)
      IF(ICOLE.EQ.-1) ECON=ECON-0.6*1.44*Z0*Z0*PKP013/(RADNCL*A013)
C      IF(IAMO.EQ.1) ECON=ECON+EMOM
      DO 51 I=1,M
      IA=J(I)
      A=IA
      ECOLB=ECOLB-0.6*1.44*XZ(IA)*XZ(IA)*(A**(5./3.))/RADNCL
      IF(ICOLE.EQ.-1) ECOLB=0.
 51   CONTINUE
c      IF((E0+E0Q-ECON).LT.0.003) GO TO 56
      IF(ITMUL.EQ.0.AND.(E0+E0Q-ECON).LT.0.003) GO TO 56
      T=SQRT(E00/0.125)
      IF(T.LT.0.0012) T=0.0012
      IF(ITMUL.EQ.1) T=TMUL
      HT=0.5
      K1=0
      K2=0
      ID=0
      ICNT=0
 24   CONTINUE
      IF(ICNT.GT.120) GO TO 71
      CALL PARAM(T,K,KC,EPSIL0)
      ECON=0.
      DO 61 I=1,M
      IA=J(I)
      A=IA
      IF(IA-1) 55,55,52
 55   EA(IA)=ECOLA(IA)
      GO TO 60
 52   IF(IA-4) 53,53,54
 53   IF(IA.EQ.2) EA(IA)=-2.796+ECOLA(IA)
      IF(IA.EQ.3) EA(IA)=-9.224+ECOLA(IA)
c      IF(IA.EQ.4) EA(IA)=-30.11+ECOLA(IA)+4.*T*T/E11(4)
      IF(IA.EQ.4) EA(IA)=-30.11+ECOLA(IA)
      GO TO 60
 54   EA(IA)=(-W0+T*T/E11(IA)+G0*(1.-2.*XZ(IA))**2)*A+
     #(BT-T*DBT)*A**0.666667+ECOLA(IA)
 60   CONTINUE
      ECON=ECON+EA(IA)
 61   CONTINUE
      ECON=ECON+0.6*1.44*Z0*Z0*PKP013/(RADNCL*A013)+1.5*T*(M-1)
      IF(ICOLE.EQ.-1) ECON=ECON-0.6*1.44*Z0*Z0*PKP013/(RADNCL*A013)
C      IF(IAMO.EQ.1) ECON=ECON+EMOM+1.5*T*(M-1)
      IF(ITMUL.EQ.1) E0=ECON-E0Q
      IF(ITMUL.EQ.1) GO TO 29
      D=(E0+E0Q-ECON)/E0
      IF(ABS(D).LT.0.003) GO TO 29
      ICNT=ICNT+1
      H=SIGN(HT,D)
      IF(D) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.29) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K2=1
      H=HT
      GO TO 21
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.29) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K1=1
      H=HT
      GO TO 22
 71   ERRMI=ERRMI+1
      PRINT 72,ICNT,ID,D,T
 72   FORMAT(5X,'ERROR IN CALCWE  ICNT=',I3,' ID=',I3,' D=',E12.5,
     *'  T=',F8.3)
 56   PR=0.
      RETURN
 29   TCON=T
      SCON=0.
      DO 62 I=1,M
      IA=J(I)
      A=IA
      IF(IA-4) 63,63,64
 63   SAIN(IA)=0.
c      IF(IA.EQ.4) SAIN(IA)=2*T*4./E11(IA)
      GO TO 65
 64   SAIN(IA)=2*T*A/E11(IA)-DBT*A**0.666667
 65   CONTINUE
      SCON=SCON+SAIN(IA)
 62   CONTINUE
      LT=16.15/SQRT(T)
      IF(ITRAN.EQ.1) GO TO 91
      STRAN=ALOG(PRA32/PRFAKT)+(M-1)*ALOG(VF/LT**3)+1.5*(M-1)-
     *ALOG(A0*SQRT(A0))
      GO TO 90
 91   CONTINUE
      STRAN=ALOG(PRA32)+1.5*(M-1)-ALOG(A0*SQRT(A0))+
     *(M-1)*ALOG(VF/LT**3)
      IF(STRAN.LT.10.) STRAN=ALOG(1.+EXP(STRAN))
      STRAN=STRAN-ALOG(PRFAKT)
 90   CONTINUE
c      STRAN=ALOG(PRA32/PRFAKT)+(M-1)*ALOG(VF/LT**3)+1.5*(M-1)-
c     *ALOG(A0*SQRT(A0))
c      IF(STRAN.LT.0.) STRAN=0.
      SCON=SCON+ALOG(PRGA)+STRAN
C      SAMOM=1.5*(M-1)-3*(M-1)*ALOG(LT)+ALOG(PAM32)-
C     *ALOG(SAM*SQRT(SAM))
C      IF(SAMOM.LT.0.) SAMOM=0.
C      IF(IAMO.EQ.1) SCON=SCON+SAMOM
      PR=EXP(SCON-SCOMP)
C     IF(M.LE.2) PRINT 100,M,(J(I),I=1,M),ECOLB,T,STRAN,SAMOM,SCON,PR
C100  FORMAT(2X,'M=',I3,' J=',2I3,' ECOLB=',F7.3,' T=',F7.3,' STRAN=',
C    *F7.3,' SAMOM=',F7.3,' SCON=',F7.3,' PR=',E10.3)
      IF(ITMUL.EQ.1) E00=E0/A0
      RETURN
      END
      SUBROUTINE DISA(K)
C B[[OP O[HO[O PAC[PE[E[EH[[ A0 H[K[OHOB [O K [PA[MEHTAM C [[ETOM HEPA[-
C [[[[MOCT[. KOH[[[[PA[[[: J(1)...J(K)-CO[EP[[T MACC[ [PA[MEHTOB.
C HA[. [C[OB[E: J(K)=A0,J(K-1)=...J(1)=O -[A[AETC[ [EPE[ DISA.
C [P[[HAK KOH[A IEND=1 O[HA[AET,[TO BCE KOH[[[[PA[[[ [[E [C[EP[AH[.
C [P[[HAK BO[MO[HO[ KOH[[[[PA[[[: IEND=0 .
      COMMON /BLDIS/ J(20),IEND,JZ(20),IENDZ
      L=0
 1    L=L+1
      IF(L-K) 3,4,4
 4    IEND=1
      RETURN
 3    JL=J(L)
      JK=J(K)
      J(L)=J(L)+1
      J(K)=J(K)-1
      IF(J(L).GT.J(L+1).OR.J(K-1).GT.J(K)) GO TO 2
      IEND=0
      RETURN
 2    J(L)=1
      J(K)=JK+JL-1
      GO TO 1
      END
      SUBROUTINE CHOSAZ(A0,Z0,T,IP,PA,PAZ)
C B[[OP KAHA[A PA[BA[A [[ BCEX KOH[[[[PA[[[ [O M=4 .
C [A[O[HEH[E MACC[BA PA(1-IP) - B [OP[[KE [[[BAH[[ A.
      DIMENSION PA(500),PAZ(500)
      COMMON /BL500/W,W2(250),W3(25000),W4(10000)
      COMMON /BL501/IAF2(250),IAF3(25000),IAF4(10000)
      COMMON /BL502/M2,M3,M4,M5,MC2,MC3,MC4,MC5
      COMMON /BL503/WCOMP,WW2,WW3,WW4,WW5,WEVAP,WW4G
      WCOWW2=WCOMP+WW2
      WCOWW3=WCOWW2+WW3
      BR=RNDMSMM(-1)
      IP=1
      IF(BR.GT.WCOMP.AND.BR.LE.WCOWW2) IP=2
      IF(BR.GT.WCOWW2.AND.BR.LE.WCOWW3) IP=3
      IF(BR.GT.WCOWW3.AND.WW4.GT.0.) IP=4
      GO TO (1,2,3,4),IP
 1    PA(1)=A0
      PAZ(1)=Z0
      RETURN
 2    WP=WCOMP
      JJ=0
      DO 10 I=1,M2
      WP=WP+W2(I)
      JJ=JJ+1
      IF(WP.GT.BR) GO TO 11
 10   CONTINUE
 11   MCH=JJ
      PA(2)=IAF2(MCH)/1000
      PA(1)=IAF2(MCH)-INT(PA(2))*1000
      GO TO 5
 3    WP=WCOMP+WW2
      JJ=0
      DO 12 I=1,M3
      WP=WP+W3(I)
      JJ=JJ+1
      IF(WP.GT.BR) GO TO 13
 12   CONTINUE
 13   MCH=JJ
      PA(3)=IAF3(MCH)/1000000
      PA(2)=(IAF3(MCH)-INT(PA(3))*1000000)/1000
      PA(1)=IAF3(MCH)-INT(PA(3))*1000000-INT(PA(2))*1000
      GO TO 5
 4    WP=WCOMP+WW2+WW3
      JJ=0
      DO 14 I=1,M4
      JJ=JJ+1
      WP=WP+W4(I)
      IF(WP.GT.BR) GO TO 15
 14   CONTINUE
 15   MCH=JJ
      PA(4)=IAF4(MCH)/10000000
      PA(3)=(IAF4(MCH)-INT(PA(4))*10000000)/100000
      PA(2)=(IAF4(MCH)-INT(PA(4))*10000000-INT(PA(3))*100000)/1000
      PA(1)=IAF4(MCH)-INT(PA(4))*10000000-INT(PA(3))*100000
     *-INT(PA(2))*1000
 5    CONTINUE
      CALL CHOSZ(A0,Z0,T,IP,PA,PAZ)
      RETURN
      END
      SUBROUTINE CHOSZ(A0,Z0,T,IP,PA,PAZ)
      REAL LT
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00 
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013
      DIMENSION PA(500),PAZ(500),COEFC(500)
C O[PE[E[EH[E [AP[[OB IP [PA[MEHTOB B MACC[BE PAZ(1-IP)
      IZ0=INT(Z0+0.5)
c      G0=25.
      G0=G00
c -- calcul. of avr.charge approx. from Grand-Canon. Coulomb infl. --
      ZM0=0.
      DO 10 I=1,IP
      IA=INT(PA(I)+0.5)
      COEFC(I)=(1.+(2.*CP*A0**0.666667)/(8.*G0))/
     #(1.+(2.*CP*PA(I)**0.666667)/(8.*G0))
      ZM0=ZM0+PA(I)*(Z0/A0)*COEFC(I)
 10   CONTINUE
      COEF=Z0/ZM0
      DO 11 I=1,IP
      COEFC(I)=COEFC(I)*COEF
 11   CONTINUE
c -------------------------------------------------------------
 5    ISZ=0
      DO 1 I=1,IP
      IA=INT(PA(I)+0.5)
 3    CALL RANNOR(BR1,BR2)
c      CC=8.*G0
      CC=8.*G0+2.*CP*PA(I)**0.666667
c      ZM=PA(I)*Z0/A0
c      IF(PA(I).GT.1.5.AND.PA(I).LT.4.5) ZM=0.5*PA(I)
c -- calculation of ZM approximately from Grand-Canon. Coulomb infl. --
      ZM=PA(I)*(Z0/A0)*COEFC(I)
c -------------------------------------------------------------
      DZ=SQRT(PA(I)*T/CC)
      Z=BR1*DZ+ZM
      IZ=INT(Z+0.5)
      IF(IZ.GE.0.AND.IZ.LE.IA) GO TO 4
      Z=BR2*DZ+ZM
      IZ=INT(Z+0.5)
      IF(IZ.GE.0.AND.IZ.LE.IA) GO TO 4
      GO TO 3
 4    PAZ(I)=IZ
      ISZ=ISZ+INT(PAZ(I)+0.5)
 1    CONTINUE
      DELZ=IZ0-ISZ
      IF(ABS(DELZ).GT.1.1) GO TO 5
      PAZ(1)=PAZ(1)+DELZ
      RETURN
      END
      SUBROUTINE PARAM(T,K,KC,EPSIL0)
      REAL K,KC,LT
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00
      W0=W00
c      W0=16.
      B0=B00
c      B0=18.
      TC=18.
c      TC=1000000.
c      G0=25.
      G0=G00
      RADNCL=1.17
      IF(T.LT.TC) GO TO 81
      BT=0.
      DBT=0.
      GO TO 82
 81   CONTINUE
      BT=B0*((TC*TC-T*T)/(TC*TC+T*T))**1.25
      DBT=B0*(-5*T*TC*TC/(TC*TC+T*T)**2)*((TC*TC-T*T)/(TC*TC+T*T))**.25
 82   CONTINUE
      IF(EPSIL0.GT.9999.) BT=B0
      IF(EPSIL0.GT.9999.) DBT=0.
      RETURN
      END
      SUBROUTINE PARAM2(T,EPSIL0)
      REAL LT
      COMMON /BLOK1/W0,TC,RADNCL,G0 
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013
      COMMON /BLOK20/BT2,DBT2
c for FINDT : finding surface energy of fragments
      IF(T.LT.TC) GO TO 81
      BT2=0.
      DBT2=0.
      GO TO 82
 81   CONTINUE
      BT2=B0*((TC*TC-T*T)/(TC*TC+T*T))**1.25
      DBT2=B0*(-5*T*TC*TC/(TC*TC+T*T)**2)*
     #((TC*TC-T*T)/(TC*TC+T*T))**.25
 82   CONTINUE
      IF(EPSIL0.GT.9999.) BT2=B0
      IF(EPSIL0.GT.9999.) DBT2=0.
      RETURN
      END
      SUBROUTINE SCOMPA(E00,K,KC,EPSIL0,SCOMP)
C  O[PE[E[EH[E [HTPO[[[ KOM[A[H[ COCTO[H[[
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK3/E11(500),XZ(500),GA(500) /BLOKT/TCON
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 /BLMOM/AMOM,AM(500),IAMO
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE 
      COMMON /BICOLE/ICOLE
      COMMON /BTMUL/TMUL,ITMUL
      REAL K,KC,LT
      E0=E00*A0
C      EMOM=41.5*(AMOM**2)/(2*AM(IA0))
C      IF((E0-EMOM).LT.0.003.AND.IAMO.EQ.1) GO TO 73
      A013=A0**0.333333
      T=SQRT(E00/0.125)
      IF(T.LT.0.0012) T=0.0012
      IF(ITMUL.EQ.1) T=TMUL
      HT=0.5
      K1=0
      K2=0
      ID=0
      ICNT=0
 24   CONTINUE
      IF(ICNT.GT.120) GO TO 71
      CALL PARAM(T,K,KC,EPSIL0)
      ECON=(-W0+T*T/E11(IA0)+G0*(1.-2.*XZ(IA0))**2)*A0+
     *(BT-T*DBT)*A013*A013+0.6*1.44*Z0*Z0/(RADNCL*A013)
      IF(ICOLE.EQ.-1) ECON=(-W0+T*T/E11(IA0)+
     #G0*(1.-2.*XZ(IA0))**2)*A0+(BT-T*DBT)*A013*A013
C      IF(IAMO.EQ.1) ECON=ECON+EMOM
      IF(ITMUL.EQ.1) E0=ECON-E0Q
      IF(ITMUL.EQ.1) GO TO 29
      D=(E0+E0Q-ECON)/E0
      IF(ABS(D).LT.0.003) GO TO 29
      ICNT=ICNT+1
      H=SIGN(HT,D)
      IF(D) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.29) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K2=1
      H=HT
      GO TO 21
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.29) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K1=1
      H=HT
      GO TO 22
 71   ERRMI=ERRMI+1
      PRINT 72,ICNT,ID,D,T
 72   FORMAT(5X,'ERROR IN SCOMPA  ICNT=',I3,' ID=',I3,' D=',E12.5,
     *'  T=',F8.3)
 73   SCOMP=0.
      RETURN
 29   TCON=T
      SCOMP=2*T*A0/E11(IA0)-DBT*A013*A013
      IF(ITMUL.EQ.1) E00=E0/A0
      RETURN
      END
      SUBROUTINE FRAGTE(AA,ZZ,E00,K,KC,EPSIL0,TK,MU,L,SR)
C HAXO[[EH[E TEM[EPAT[P[ TK [ BCE[O M[[[T[[PA[MEHTHO[O COCTO[H[[ N(A),XZ
C [O [HEP[[[ BO[[[[[EH[[ (HA H[K[OH) E00 [[PA A0,Z0 [ [APAM.CB.O[[EMA K.
      REAL N,MU,K,LT,L,KC
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE /BLJPRE/JPRE
      COMMON /BPERI/IPERI /BLIKAP/IKAPPA
      COMMON /BTMUL/TMUL,ITMUL 
      ERRMA=0.
      A0=AA
      Z0=ZZ
      IA0=INT(A0+0.5)
      SM=(1.+2.31*(E00-3.5))*A0/100.
      IF(SM.LT.2.) SM=2.
c --- keep constant or vary with multiplic. translational volume ---
      IF(IKAPPA.EQ.0) 
     *K=(1.+1.44*(SM**0.333333-1.)/(1.17*A0**0.333333))**3-1.
c --- changing of coulomb volume : V_c=V_0+V_f -----
c      KC=K
c ---
      E11(1)=0.
      DO 100 I=2,IA0
      A=I
      IF(IPERI.EQ.0) E11(I)=EPSIL0*(1.+3./(A-1))
C      IF(I.LE.50) E11(I)=EPSIL0*(1.+0.12*(A**0.33333-5.**0.33333))
C 100  IF(I.GT.50) E11(I)=EPSIL0*(1.+0.12*(50.**0.33333-5.**0.33333))
      IF(IPERI.EQ.1) E11(I)=EPSIL0/(1.+0.0020*(A/25.)**2)
 100  CONTINUE
      T=SQRT(E00/0.12)
      IF(JPRE.EQ.1) T=2.*E00/3.
      IF(T.LT.0.0012) T=0.0012
      IF(ITMUL.EQ.1) T=TMUL
      HT=1.0
      IF(JPRE.EQ.1) HT=2.0
      ICNT=0
      K1=0
      K2=0
      ID=0
 24   CONTINUE
      IF(ICNT.GT.200) GO TO 71
      CALL FRAG(A0,Z0,T,K,KC,EPSIL0,MU,L,E0,SR)
C *********
c      PRINT 110,E00,E0,T
c 110  FORMAT(2X,'**FRAGTE** E00=',F11.5,' E0=',F11.5,' T=',F11.5)
C *********
      IF(ITMUL.EQ.1) GO TO 29
      D=(E00-E0)/E00
      IF(ABS(D).LT.0.003) GO TO 29
      ICNT=ICNT+1
      H=SIGN(HT,D)
      IF(D) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.30) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K2=1
      H=HT
      GO TO 21
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.30) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K1=1
      H=HT
      GO TO 22
 29   TK=T
      CALL ECB_GC
      IF(ITMUL.EQ.1) E00=E0
      RETURN
 71   ERRMA=ERRMA+1
      PRINT 72,ICNT,D,T,ID
 72   FORMAT(5X,'ERROR IN FRAGTE   ICNT=',I3,' D=',E12.5,' T=',F8.3,
     *'             ID=',I2)
      TK=T
      CALL ECB_GC
      RETURN
      END
      SUBROUTINE FINDT(E00,A0,Z0,PA,PAZ,IP,TK,ETP,ECOL,ECP,EEX,EB)
c ******* changings to FINDT_2: in case of 'modified initial mass' *********
C HAXO[[EH[E [O IP B[[PAHH[M [PA[MEHTAM [X TEM[EPAT[P[ T [ [HEP[[[,
C C[[TA[,[TO [O[HA[ [HEP[[[ BO[[[[[EH[[ C[CTEM[ E0*A0 - [[KC[POBAHA.
      REAL N,LT
      COMMON /BLOK1/W0,TC,RADNCL,G0 
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLOK20/BT2,DBT2 /BLPARA/EPSIL0,FKAPPA,FKACOL
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE /BLJPRE/JPRE
      COMMON /BICOLE/ICOLE
      COMMON /BTMUL/TMUL,ITMUL 
      DIMENSION PA(500),PAZ(500)
      ERRFR=0.
      A013=A0**0.333333
      E0=E00
      HT=0.5
      IF(JPRE.EQ.1) HT=1.0
      ICNT=0
      K1=0
      K2=0
      ID=0
      T=TK
      IF(T.LT.0.0012) T=0.0012
      IF(ITMUL.EQ.1) T=TMUL
c ground state initial mass ==> temperature (and excit.energy) will be from 
c ground state
      CALL DELAM(A0,Z0,DLM0,DSH0,BAR)
      IF(ICOLE.EQ.-1) CALL ELIDR(A0,Z0,DLM0)
c modified initial mass
c      CALL ELIDR(A0,Z0,DLM0)
      PKP013=1./((1.+FKACOL)**0.3333333)
 24   CONTINUE
      IF(ICNT.GT.200) GO TO 71
      EEX=0.
      EB=-DLM0
      ECP=0.
      ETP=1.5*T*(IP-1)
      CALL PARAM2(T,EPSIL0)
      DO 107 I=1,IP
c ground state initial mass ==> temperature (and excit.energy) will be from 
c ground state
      CALL DELAM(PA(I),PAZ(I),DLM,DSH,BAR)
      IF(ICOLE.EQ.-1) CALL ELIDR(PA(I),PAZ(I),DLM)
c modified initial mass
c      CALL ELIDR(PA(I),PAZ(I),DLM)
      EB=EB+DLM
      PA03=PA(I)**0.333333
      ECP=ECP+(0.6*1.44/RADNCL)*PAZ(I)*PAZ(I)/PA03
      IF(ICOLE.EQ.-1) ECP=0.
      IA=INT(PA(I)+0.1)
c      IF(IA.LE.3) GO TO 107
      IF(IA.LE.4) GO TO 107
      IF(JPRE.EQ.1) GO TO 107
c ---       finding surface energy
c before June 96:     ESUF=PA(I)*T*T*2.5*B0/(TC*TC*PA03)
c                     IF(DBT.EQ.0.) ESUF=0.
c      ESUF=(BT2-T*DBT2-B0)*PA03*PA03
      BTTDBT=(BT2-T*DBT2-B0)
      IF(T.GE.TC) BTTDBT=0.
      ESUF=BTTDBT*PA03*PA03
c ---
      EEX=EEX+PA(I)*T*T/E11(IA)+ESUF
c      IF(IA.EQ.4) EEX=EEX-ESUF
 107  CONTINUE
      ECOL=(0.6*1.44/RADNCL)*Z0*Z0*PKP013/A013-ECP*PKP013
      IF(ICOLE.EQ.-1) ECOL=0.
      E0TP=ETP+EEX+EB+ECOL
      E0TPA0=E0TP/A0
C ********
c      PRINT 110,E0,E0TPA0,T,ETP,EEX,EB,ECOL
c 110  FORMAT(2X,'*FINDT* E0=',F11.5,' E0TP/A0=',F11.5,' T=',F11.5,3X,
c     *'ETP,EEX,EB,ECOL=',4F11.5)
C ********
      IF(ITMUL.EQ.1) GO TO 29
      D=(E0-E0TP/A0)/E0
      IF(ABS(D).LT.0.003) GO TO 29
      ICNT=ICNT+1
      H=SIGN(HT,D)
      IF(D) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.30) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K2=1
      H=HT
      GO TO 21
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      IF(ID.GT.30) GO TO 71
      T=T+H/2**ID
      IF(T.GE.0.001) GO TO 24
      K1=1
      H=HT
      GO TO 22
 29   TK=T
      IF(ITMUL.EQ.1) E00=E0TPA0
      RETURN
 71   ERRFR=ERRFR+1
      PRINT 72,ICNT,ID,D,T,IP
 72   FORMAT(5X,'ERROR IN FINDT    ICNT=',I3,' ID=',I3,' D=',E12.5,
     *' T=',F9.3,'  IP=',I3)
      RETURN
      END
      FUNCTION UEVA(A,T)
C O[PE[E[EH[E [HEP[[[ BO[[[[[EH[[ [PA[MEHTOB [EPE[ [X [C[APEH[EM [[[
C [EPM[-PA[BA[OM (UEVA B [[B, TEM[EPAT[PA T B M[B).
      REAL LT
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 /BLOK1/W0,TC,RADNCL,G0
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLOK20/BT2,DBT2 
      COMMON /BTLIM/TINLIM,ITLIM
      IA=INT(A+0.5)
c ---       finding surface energy
c before June 96:     ESUF=A*T*T*2.5*B0/(TC*TC*A**0.333333))
c                     IF(DBT.EQ.0.) ESUF=0.
c      ESUF=(BT2-T*DBT2-B0)*A**0.666667
      BTTDBT=(BT2-T*DBT2-B0)
      IF(T.GE.TC) BTTDBT=0.
      ESUF=BTTDBT*A**0.666667
c ---
      UEVA=A*T*T/E11(IA)+ESUF
c      IF(IA.EQ.4) UEVA=A*T*T/E11(IA)
      IF(ITLIM.EQ.1) UEVA=0.125*IA*TINLIM*TINLIM
      IF(IA.EQ.4) UEVA=0.
      UEVA=0.001*UEVA
      RETURN
      END
      SUBROUTINE FRAG(AA,ZZ,T,K,KC,EPSIL0,MU,L,EE,SR)
C [PA[MEHTA[[[ [[PA A0,Z0 [P[ [AHHO[ TEM[EPAT[PE T [ [APAM.CB. O[[EMA K.
C [APAMETP[ E11(A) [A[A[TC[ PAHEE B /BLOK2/. HA B[XO[E: X[M.[OT. MU [ L,
C [HEP[[[ E0(M[B/N),[HTPO[[[ S (1/N),CPE[H.[[C[O [PA[MEHTOB SR; MHO[ECTB
C HOCT[ N(A) [ [AP[[OBOE PAC[PE[E[EH[E XZ(A) - HAXO[[TC[ B /BLOK2/.
      REAL N,MU,K,LT,L,KC
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 /BLOKN/N(500) /BENTRO/SSR
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK3/E11(500),XZ(500),GA(500) /BLOKE/E(500)
      COMMON /BICOLE/ICOLE
      COMMON /BTMUL/TMUL,ITMUL /BTMUL0/ESR,ESRP,ESRP2
      A0=AA
      Z0=ZZ
      TK=T
      CALL PARAM(T,K,KC,EPSIL0)
      A013=A0**0.33333333
      A023=A013*A013
      R0=RADNCL*A013
      V0=(4.*3.1415926/3.)*R0*R0*R0
      P0=A0/V0
      R=R0*(1.+KC)**0.33333333
      PKP013=R0/R
      XZ0=Z0/A0
      E0Q=A0*(-W0+G0*(1.-2.*XZ0)**2)+B0*A023+0.6*1.44*Z0*Z0/R0
      IF(ICOLE.EQ.-1) E0Q=A0*(-W0+G0*(1.-2.*XZ0)**2)+B0*A023
      P=P0/(1.+KC)
      CP=(0.6*1.44/RADNCL)*(1.-PKP013)
      IF(ICOLE.EQ.-1) CP=0.
      LT=16.15/SQRT(TK)
      CALL XZA(TK,K,MU,L)
      CALL ENERGA(TK,K)
      CALL ENTROP(TK,K,S)
      SSR=S
      E0T=0.
      DO 10 IT=1,IA0
      E0T=E0T+N(IT)*E(IT)
   10 CONTINUE
      E0T=E0T+0.6*1.44*Z0*Z0/R
      IF(ICOLE.EQ.-1) E0T=E0T-0.6*1.44*Z0*Z0/R
      E0=(E0T-E0Q)/A0
      EE=E0
      IF(ITMUL.EQ.1) ESR=E0
      SR=0.
      DO 31 J=1,IA0
      SR= SR+N(J)
 31   CONTINUE
      RETURN
      END
      SUBROUTINE CALCMU(T,K,MU,L)
C B[[[C[EH[E MU=MU(T) [C[O[[[[[ [PABHEH[E  N(1)*1+...+N(A0)*A0=A0
      REAL N,MU,K,LT,L
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013    /BLOKN/N(500)
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE /BLJPRE/JPRE
      HM=4.
      IF(JPRE.EQ.1) HM=16.
      MU=-W0-T*T/E11(5)-L*XZ(5)+G0*(1.-2*XZ(5))**2
     *+(2./3.)*BT/1.71+5.*CP*XZ(5)*XZ(5)*2.92/3.-1.5*T/5.
      IF(JPRE.EQ.1) MU=-A0/2.
      IF(ABS(MU).LE.HM) MU=-HM-0.01
      KK=0
      K1=0
      K2=0
      ID=0
 24   CONTINUE
      CALL MULTIA(T,K,MU,L)
      A0T=0.
      DO 10 IT=1,IA0
      A0T=A0T+IT*N(IT)
 10   CONTINUE
C *********
c      PRINT 110,A0,A0T,MU
c 110  FORMAT(2X,'**CALCMU** A0=',F7.2,' A0T=',F7.2,' MU=',F8.3)
C *********
      KK=KK+1
      D=(A0-A0T)/A0
      IF(ABS(D).LT.0.001) GO TO 25
      IF(KK.GT.400.OR.ID.GT.30) GO TO 61
      H=SIGN(HM,D)
      IF(D) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      MU=MU+H/2**ID
      GO TO 24
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      MU=MU+H/2**ID
      GO TO 24
 25   CONTINUE
      RETURN
   61 ERRMA=ERRMA+1
      PRINT 62,KK,ID,D,MU,T
   62 FORMAT(5X,'ERROR IN CALCMU  KK=',I3,' ID=',I2,' D=',E12.5,' MU=',
     *F8.3,' T=',F8.3)
      RETURN
       END
c ----- subroutines: Multia, Energa, Entrop, Xza, Selecz ------
      SUBROUTINE MULTIA(T,K,MU,L)
c --- corrected 3-H/3-He ratio , May 97 (GSI) ---
C B[[[C[EH[E MHO[ECTBEHHOCTE[ [PA[MEHTOB - N(A)
      REAL N,MU,K,LT,L
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013   /BLOKN/N(500)
      COMMON /BLOK3/E11(500),XZ(500),GA(500) 
      COMMON /BLYPRE/YNPR,YPPR,YNEQ,YPEQ
      COMMON /BLOKY/YN,YP,YD,YT,YH,YA /BLOKXZ/XZN,XZP,XZD,XZT,XZH,XZAL
      COMMON /BLJPRE/JPRE
      YN=(2*K*V0/(LT*LT*LT))*EXP(MU/T)
      YP=(2*K*V0/(LT*LT*LT))*EXP((MU+L-CP)/T)
      IF(JPRE.EQ.0) YNEQ=YN
      IF(JPRE.EQ.0) YPEQ=YP
      IF(JPRE.EQ.1) YNPR=YN
      IF(JPRE.EQ.1) YPPR=YP
      N(1)=YN+YP
      YD=3*2*SQRT(2.)*K*V0/(LT**3)
      YD=YD*EXP((2.796+2*(MU+L*XZD)-CP*XZD*XZD*(2.**(5./3.)))/T)
cc old: Y3=4*3*SQRT(3.)*K*V0/(LT**3)
cc      Y3=Y3*EXP((9.224+3*(MU+L*XZ(3))-CP*XZ(3)*XZ(3)*(3.**(5./3.)))/T)
      YT=2*3*SQRT(3.)*K*V0/(LT**3)
      YT=YT*EXP((8.48+0.51+3*(MU+L*XZT)-CP*XZT*XZT*(3.**(5./3.)))/T)
      YH=2*3*SQRT(3.)*K*V0/(LT**3)
      YH=YH*EXP((7.72+2.04+3*(MU+L*XZH)-CP*XZH*XZH*(3.**(5./3.)))/T)
      YA=8*K*V0/(LT**3)
      IF(JPRE.EQ.0)
     *YA=YA*EXP((30.11+4*(MU+L*XZAL+T*T/E11(4))
     *-CP*XZAL*XZAL*(4.**(5./3.)))/T)
      IF(JPRE.EQ.1)
     *YA=YA*EXP((30.11+4*(MU+L*XZAL)-CP*XZAL*XZAL*(4.**(5./3.)))/T)
      N(2)=YD
      N(3)=YT+YH
      N(4)=YA
      DO 2 I=5,IA0
      N(I)=0.
      IF(JPRE.EQ.1) GO TO 2
      A=I
      A23=A**0.66666667
      VNE=(MU+L*XZ(I)+W0+T*T/E11(I)-G0*(1.-2*XZ(I))**2)*A
     *-BT*A23-CP*XZ(I)*XZ(I)*A*A23
      VNE=VNE/T
      IF(VNE.GT.30.0) GO TO 1
      VN=EXP(VNE)
      N(I)=(K*V0*SQRT(A)*A/(LT*LT*LT))*VN
      IF(N(I).LT.1.0E-30) N(I)=0.
      GO TO 2
 1    N(I)=999.
 2    CONTINUE
      RETURN
      END
      SUBROUTINE ENERGA(T,K)
c --- corrected 3-H/3-He ratio , May 97 (GSI) ---
C B[[[C[EH[E [HEP[[[ [PA[MEHTOB  E(A)
      REAL N,MU,K,LT,L
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013    /BLOKE/E(500)
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLJPRE/JPRE
      COMMON /BLOKY/YN,YP,YD,YT,YH,YA /BLOKXZ/XZN,XZP,XZD,XZT,XZH,XZAL
      E(1)=1.5*T+CP*XZ(1)
      E(2)=-2.796+CP*XZ(2)*XZ(2)*(2.**(5./3.))+1.5*T
cc old:  E(3)=-9.224+CP*XZ(3)*XZ(3)*(3.**(5./3.))+1.5*T
      ET=-8.48-0.51+CP*XZT*XZT*(3.**(5./3.))+1.5*T
      EH=-7.72-2.04+CP*XZH*XZH*(3.**(5./3.))+1.5*T
      E(3)=(YT*ET+YH*EH)/(YT+YH)
      E(4)=-30.11+CP*XZ(4)*XZ(4)*(4.**(5./3.))+1.5*T+4*T*T/E11(4)
      IF(JPRE.EQ.1) E(4)=E(4)-4*T*T/E11(4)
      DO 2 I=5,IA0
      E(I)=0.
      IF(JPRE.EQ.1) GO TO 2
      A=I
      A23=A**0.66666667
      EV=A*(T*T/E11(I)-W0+G0*(1.-2*XZ(I))**2)
      ES=(BT-T*DBT)*A23
      EC=CP*A23*A*XZ(I)*XZ(I)
      ET=1.5*T
      E(I)=EV+ES+EC+ET
 2    CONTINUE
      RETURN
      END
      SUBROUTINE ENTROP(T,K,S)
c --- corrected 3-H/3-He ratio , May 97 (GSI) ---
C B[[[C[EH[E [HTPO[[[ [[PA [OC[E [PA[MEHTA[[[ - S
      REAL N,MU,K,LT,L
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013    /BLOKN/N(500)
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLJPRE/JPRE
      COMMON /BLOKY/YN,YP,YD,YT,YH,YA 
      S=0.
      IF(YN.GT.0.) S=YN*(2.5+ALOG(2*K*V0/(LT*LT*LT*YN)))
      IF(YP.GT.0.) S=S+YP*(2.5+ALOG(2*K*V0/(LT*LT*LT*YP)))
      IF(YD.GT.0.) S=S+YD*(2.5+ALOG(3*K*V0*2*SQRT(2.)/(YD*LT**3)))
cc old:  IF(Y3.GT.0.) S=S+Y3*(2.5+ALOG(4*K*V0*3*SQRT(3.)/(Y3*LT**3)))
      IF(YT.GT.0.) S=S+YT*(2.5+ALOG(2*K*V0*3*SQRT(3.)/(YT*LT**3)))
      IF(YH.GT.0.) S=S+YH*(2.5+ALOG(2*K*V0*3*SQRT(3.)/(YH*LT**3)))
      IF(YA.GT.0.AND.JPRE.EQ.0) 
     #S=S+YA*(2.5+ALOG(8*K*V0/(YA*LT**3))+8*T/E11(4))
      IF(YA.GT.0.AND.JPRE.EQ.1) 
     #S=S+YA*(2.5+ALOG(8*K*V0/(YA*LT**3)))
      IF(JPRE.EQ.1) RETURN
      DO 1 I=5,IA0
      A=I
      IF(N(I).LE.0.) GO TO 1
      SV=A*2*T/E11(I)
      SS=-DBT*A**0.6666667
      ST=2.5+ALOG(K*V0*SQRT(A)*A/(LT*LT*LT*N(I)))
      S=S+(SV+SS+ST)*N(I)
 1    CONTINUE
      RETURN
      END
      SUBROUTINE XZA(T,K,MU,L)
c --- corrected 3-H/3-He ratio , May 97 (GSI) ---
C B[[[C[EH[E XZ(A) - [O[[ Z B [PA[MEHTE A,[C[O[[[[[ [PABHEH[E
C                 XZ(1)*1*N(1)+...+XZ(A0)*A0*N(A0)=Z0  ([P[[[[[EHHO)
      REAL N,MU,K,LT,L
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013     /BLOKN/N(500)
      COMMON /BLOK3/E11(500),XZ(500),GA(500) 
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE  /BLJPRE/JPRE
      COMMON /BLOKY/YN,YP,YD,YT,YH,YA /BLOKXZ/XZN,XZP,XZD,XZT,XZH,XZAL
      DIMENSION C1(500),C2(500)
      K1=0
      K2=0
      KK=0
      ID=0
      HM=1.
      IF(JPRE.EQ.1) HM=2.
      DO 1 I=5,IA0
      A=I
      CC=8.*G0+2.*CP*A**0.66666667
      C1(I)=4.*G0/CC
      C2(I)=1./CC
 1    CONTINUE
      L=XZ0*(8.*G0+2.*CP*A0**0.6666667)-4.*G0
 6    CONTINUE
      XZN=0.
      XZP=1.
      XZD=0.5
      XZT=0.333333
      XZH=0.666667
      XZAL=0.5
      DO 2 I=5,IA0
 2    XZ(I)=C1(I)+L*C2(I)
      CALL CALCMU(T,K,MU,L)
      XZ(1)=YP/(YP+YN)
      XZ(2)=XZD
      XZ(3)=(YT+2.*YH)/(3.*YT+3*YH)
      XZ(4)=XZAL
      Z0T=0.
      DO 3 I=1,IA0
 3    Z0T=Z0T+XZ(I)*I*N(I)
C *********
c      PRINT 110,Z0,Z0T,L
c 110  FORMAT(2X,'**XZA** Z0=',F7.2,' Z0T=',F7.2,' L=',F8.3)
C *********
      KK=KK+1
      D=(Z0-Z0T)/Z0
      IF(ABS(D).LT.0.002) GO TO 9
      IF(KK.GT.200.OR.ID.GT.30) GO TO 7
      H=SIGN(HM,D)
      IF(D) 4,4,5
 4    K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      L=L+H/2**ID
      GO TO 6
 5    K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      L=L+H/2**ID
      GO TO 6
 9    CONTINUE
      RETURN
 7    ERRMA=ERRMA+1
      PRINT 8,KK,ID,D,L,MU,T
 8    FORMAT(5X,'ERROR IN XZA KK=',I2,' ID=',I2,' D=',E12.5,' L=',F8.3,
     *' MU=',F8.3,' T=',F8.3)
      RETURN
      END
      SUBROUTINE SELECZ(T,L,IZ0,IP,PA,PAZ)
c --- corrected 3-H/3-He ratio , May 97 (GSI) ---
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 
      COMMON /BLYPRE/YNPR,YPPR,YNEQ,YPEQ
      COMMON /BLJPRE/JPRE
      COMMON /BLOKY/YN,YP,YD,YT,YH,YA 
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00
      REAL PA(500),PAZ(500),L,LT
C O[PE[E[EH[E [AP[[OB IP [PA[MEHTOB: B MACC[BE PAZ(1-IP). MACC[ [PA[MEHT
C [AH[ B MACC[BE PA(1-IP),B [OP[[KE [[[BAH[[ A. [AP[[[ [PA[[C[ [[ HOPMA[
C PAC[PE[E[EH[[ C [EHTPOM ZM [ [[C[EPC[E[ DZ. OCTATOK PO[[[P[[A ( OT[[[[
C C[MM[ PAZ OT Z0 HE [O[EE 0,+1,-1 ) [O[AB[[[C[ B PA(1).
c      G0=25.
      G0=G00
 5    ISZ=0
      DO 1 I=1,IP
      IA=INT(PA(I)+0.5)
      IF(IA-1) 2,2,6
 2    BR=RNDMSMM(-1)
      PAZ(I)=0.
cc      IF(BR.GT.(YN/(YN+YP))) PAZ(I)=1.
      IF(JPRE.EQ.0.AND.BR.GT.(YNEQ/(YNEQ+YPEQ))) PAZ(I)=1.
      IF(JPRE.EQ.1.AND.BR.GT.(YNPR/(YNPR+YPPR))) PAZ(I)=1.
      ISZ=ISZ+INT(PAZ(I)+0.5)
      GO TO 1
 6    IF(IA-2) 7,7,8
 7    PAZ(I)=1.
      ISZ=ISZ+INT(PAZ(I)+0.5)
      GO TO 1
 8    IF(IA-3) 9,9,10
 9    BR=RNDMSMM(-1)
      PAZ(I)=1.
      IF(BR.GT.(YT/(YT+YH))) PAZ(I)=2.
cc old: IF(BR.GT.0.5) PAZ(I)=2.
      ISZ=ISZ+INT(PAZ(I)+0.5)
      GO TO 1
 10   IF(IA-4) 11,11,3
 11   PAZ(I)=2.
      ISZ=ISZ+INT(PAZ(I)+0.5)
      GO TO 1
 3    CALL RANNOR(BR1,BR2)
      CC=8.*G0+2.*CP*PA(I)**0.666667
      ZM=PA(I)*(4.*G0+L)/CC
cc      IF(PA(I).GT.1.5.AND.PA(I).LT.4.5) ZM=0.5*PA(I)
      DZ=SQRT(PA(I)*T/CC)
      Z=BR1*DZ+ZM
      IZ=INT(Z+0.5)
      IF(IZ.GE.0.AND.IZ.LE.IA) GO TO 4
      Z=BR2*DZ+ZM
      IZ=INT(Z+0.5)
      IF(IZ.GE.0.AND.IZ.LE.IA) GO TO 4
      GO TO 3
 4    PAZ(I)=IZ
      ISZ=ISZ+INT(PAZ(I)+0.5)
 1    CONTINUE
      DELZ=IZ0-ISZ
      IF(ABS(DELZ).LT.0.1) RETURN
      IF(ABS(DELZ).GT.1.1) GO TO 5
      IF(PA(1).LT.4.5) GO TO 5
      PAZ(1)=PAZ(1)+DELZ
      RETURN
      END
c -----------------------------------------
      SUBROUTINE RANNOR(A,B)
      Y=RNDMSMM(-1)
      Z=RNDMSMM(-1)
      X=6.283185*Z
      A1=SQRT(-2.0*ALOG(Y))
      A=A1*SIN(X)
      B=A1*COS(X)
      RETURN
      END
      SUBROUTINE SELECT(A0,Z0,N,T,L,IP,PA,PAZ)
C C[[[A[HOE PA[[[EH[E [[PA (A0,Z0) HA [PA[MEHT[,B COOTBETCTB[[ C [HK[[[[
C PAC[PE[E[EH[EM N(A) [ HOPMA[[H[M PAC[PE[E[EH[EM [PA[MEHTOB [O Z.
C HA B[XO[E: [[C[O [PA[M.-IP,[X MACC[ -PA(1-IP) /B [OP[[KE [[[BAH[[ A/,
C [ [AP[[[ -PAZ(1-IP).
      INTEGER NA(500)
      REAL N(500),L
      DIMENSION PA(500),PAZ(500)
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
 14   CONTINUE
      CALL SELECA(N,IA0,NA,IP)
C  [A[O[HEH[E MACC[BA PA ( [[ MACC[BA NA )
      IS=0
      DO 305 I=1,IP
      PA(I)=0.
 305  PAZ(I)=0.
      DO 306 IA=1,IA0
      IF(NA(IA).EQ.0) GO TO 306
      JIA=NA(IA)
      DO 307 J=1,JIA
 307  PA(IS+J)=IA
      IS=IS+JIA
 306  CONTINUE
C [EPEH[MEPA[[[ MACC[BA PA B [OP[[KE [[[BAH[[ A
      DO 10 J=1,IP
      PAMAX=0.
      DO 11 I=J,IP
      IF(PA(I)-PAMAX) 11,11,12
 12   IM=I
      PAMAX=PA(IM)
 11   CONTINUE
      PA(IM)=PA(J)
      PA(J)=PAMAX
 10   CONTINUE
      IMINZ=0
      IMAXZ=0
      DO 13 IJ=1,IP
      IMAXZ=IMAXZ+INT((PA(IJ)-0.1)*0.5)+1
 13   IMINZ=IMINZ+INT((PA(IJ)+0.1)*0.5)
      IF(PA(1).LT.5.AND.IMINZ.GE.IZ0) GO TO 14
      IF(PA(1).LT.5.AND.IMAXZ.LE.IZ0) GO TO 14
      CALL SELECZ(T,L,IZ0,IP,PA,PAZ)
      RETURN
      END
c      SUBROUTINE SELECA(N,IA0,NA,IP)
cC C[[[A[H[[ B[[OP [[C[A [PA[MEHTOB IP [ [X MHO[ECTBEHHOCTE[ [O A -NA(A)
cC [[ [[C[A H[K[OHOB IA0 [ [HK[[[[BH[X MHO[ECTBEHHOCTE[ -N(A).
c      REAL GG(500),N(500)
c      INTEGER NA(500)
c      IMAXMA=1
cc      IMAXMA=0
c      IMAXMI=0
c      GH=0.
c      DO 2 I=1,IA0
c 2    GH=GH+N(I)
cc      SQGH=SQRT(GH)+0.5
c      SQGH=2.*SQRT(GH)+1.0
c      GG(1)=N(1)
c      DO 3 I=2,IA0
c 3    GG(I)=GG(I-1)+N(I)
c 4    ISA=0
c      DO 1 I=1,IA0
c 1    NA(I)=0
c      IP=0
c 5    BRND=RNDMSMM(-1)*GH
c      DO 6 I=1,IA0
c      IF(BRND-GG(I)) 7,6,6
c 7    IA=I
c      GO TO 8
c 6    CONTINUE
c 8    IP=IP+1
c      NA(IA)=NA(IA)+1
c      ISA=ISA+IA
c      IAK=IA0-ISA
c      IF(IAK.EQ.0) GO TO 10
c      IF(IAK.GT.IMAXMA) GO TO 5
c      IF(IAK.LT.IMAXMI) GO TO 4
c      IP=IP+1
c      NA(IAK)=NA(IAK)+1
c 10   CONTINUE
c      IF(ABS(GH-IP).GT.SQGH) GO TO 4
c      IF(IP.LE.2) GO TO 4
c      RETURN
c      END
      SUBROUTINE DISNET(INET,IP0,AMP,PN0,T,TN)
C HAXO[[EH[E [HEP[[[ [ [M[[[[COB INET HE[TPOHOB [O [X TEM[EPAT[PE T(MEV)
C [O[HO[ K[H.[HEP[[[ TN(GEV),C[[TA[ PAC[PE[E[EH[E MAKCBE[OBCK[M. AMP(IP0
C -[X MACC[ (B GEV);[M[[[[C[ (GEV/C),B C[MME [A[[[E 0,[O[AB[[[TC[ B MACC
C PN0(3,500) C (IP0+1).
      DIMENSION AMP(500),PN0(3,500),ANL(3),PX(500),PY(500),PZ(500)
      DIMENSION PI(3),PJ(3),PN(3),AR(3),BR(3)
      IF(INET.LE.0) RETURN
      IP01=IP0+1
      IP0M=IP0+INET
      IF(INET-1) 1,1,2
 1    P=SQRT(2.*AMP(IP01)*TN)
      CALL ISOTR(ANL)
      PN0(1,IP01)=P*ANL(1)
      PN0(2,IP01)=P*ANL(2)
      PN0(3,IP01)=P*ANL(3)
      RETURN
 2    IF(INET-2) 3,3,4
 3    P=SQRT(2.*(AMP(IP01)*AMP(IP0M)/(AMP(IP01)+AMP(IP0M)))*TN)
      CALL ISOTR(ANL)
      PN0(1,IP01)=P*ANL(1)
      PN0(2,IP01)=P*ANL(2)
      PN0(3,IP01)=P*ANL(3)
      PN0(1,IP0M)=-PN0(1,IP01)
      PN0(2,IP0M)=-PN0(2,IP01)
      PN0(3,IP0M)=-PN0(3,IP01)
      RETURN
 4    IP0M2=IP0M-2
      ES=0.
      PSX=0.
      PSY=0.
      PSZ=0.
      FEMT=SQRT(0.5*T)*EXP(-0.5)
      DO 5 I=IP01,IP0M2
 7    E=RNDMSMM(-1)*9.*T
      FE=SQRT(E)*EXP(-E/T)
      FERAND=RNDMSMM(-1)*FEMT
      IF(FERAND-FE) 6,6,7
 6    P=SQRT(2.*E*0.001*AMP(I))
      CALL ISOTR(ANL)
      PX(I)=P*ANL(1)
      PY(I)=P*ANL(2)
      PZ(I)=P*ANL(3)
      ES=ES+E*0.001
      PSX=PSX+PX(I)
      PSY=PSY+PY(I)
      PSZ=PSZ+PZ(I)
 5    CONTINUE
      I1=IP0M2+1
      I2=IP0M2+2
      PPX=-PSX
      PPY=-PSY
      PPZ=-PSZ
      P=SQRT(PPX*PPX+PPY*PPY+PPZ*PPZ)
      EE=TN-ES
      EM=P*P/(2.*(AMP(I1)+AMP(I2)))
      IF(EE.LE.EM) GO TO 4
      H=1.+AMP(I2)/AMP(I1)
      CTM12=H*(1.-2.*AMP(I2)*EE/(P*P))
 11   CT1=1.-2.*RNDMSMM(-1)
      IF(CT1*CT1-CTM12) 11,11,12
 12   IF(CTM12) 13,17,17
 13   IZN=1
      GO TO 15
 17   IF(CT1) 11,14,14
 14   IF(RNDMSMM(-1)-0.5) 16,16,13
 16   IZN=-1
 15   CONTINUE
      P1=(P*CT1+IZN*SQRT(P*P*CT1*CT1-P*P*CTM12))/H
      P2=SQRT(P1*P1+P*P-2.*P1*P*CT1)
      PHI=6.28318*RNDMSMM(-1)
      ST1=SQRT(1.-CT1*CT1)
      CPHI1=COS(PHI)
      SPHI1=SIN(PHI)
      CPHI2=-CPHI1
      SPHI2=-SPHI1
      CT2=(P*P+P2*P2-P1*P1)/(2.*P*P2)
      IF(CT2.GT.-1.AND.CT2.LT.1) GO TO 20
      ST2=0.
      GO TO 21
 20   ST2=SQRT(1.-CT2*CT2)
 21   CONTINUE
      PI(1)=P1*ST1*CPHI1
      PI(2)=P1*ST1*SPHI1
      PI(3)=P1*CT1
      PJ(1)=P2*ST2*CPHI2
      PJ(2)=P2*ST2*SPHI2
      PJ(3)=P2*CT2
      AR(1)=PPX
      AR(2)=PPY
      AR(3)=PPZ
      BR(1)=1.
      BR(2)=0.
      BR(3)=0.
      CALL ROTOR(AR,BR,PI,PN)
      PX(I1)=PN(1)
      PY(I1)=PN(2)
      PZ(I1)=PN(3)
      CALL ROTOR(AR,BR,PJ,PN)
      PX(I2)=PN(1)
      PY(I2)=PN(2)
      PZ(I2)=PN(3)
      PSX=PSX+PX(I1)+PX(I2)
      PSY=PSY+PY(I1)+PY(I2)
      PSZ=PSZ+PZ(I1)+PZ(I2)
      ES=ES+(PX(I1)**2+PY(I1)**2+PZ(I1)**2)/(2.*AMP(I1))
     *+(PX(I2)**2+PY(I2)**2+PZ(I2)**2)/(2.*AMP(I2))
      DO 8 I=IP01,IP0M
      PN0(1,I)=PX(I)
      PN0(2,I)=PY(I)
      PN0(3,I)=PZ(I)
 8    CONTINUE
      RETURN
      END
      SUBROUTINE ROTOR (AR,BR,PSTAR,PR)
C--------[[OK [OBOPOTA BEKTOPA PSTAR [[ PA[O[E[ C.[.[. B [CXO[H[[ (PR)
C--------AR, BR-BEKTOPA B [CXO[HO[ C.[.[.
C    BLOCK OF ROTATION.
      DIMENSION AR(3),BR(3),PSTAR(3),PR(3),AN(3)
      SP = 0.
      DO 31 IR=1,3
      SP = SP+AR(IR)*BR(IR)
   31 CONTINUE
      AMOD = SQRT(AR(1)**2+AR(2)**2+AR(3)**2)
      ALPHA1 = SP/AMOD
      BMOD2 = BR(1)**2+BR(2)**2+BR(3)**2
      ALPHA2 = SQRT(BMOD2-ALPHA1**2)
      AN(1) = AR(2)*BR(3)-AR(3)*BR(2)
      AN(2) = AR(3)*BR(1)-AR(1)*BR(3)
      AN(3) = AR(1)*BR(2)-AR(2)*BR(1)
      PR(1)=PSTAR(1)*BR(1)/ALPHA2+(PSTAR(3)-ALPHA1*PSTAR(1)/ALPHA2)
     1*AR(1)/AMOD+(PSTAR(2)*AN(1))/(ALPHA2*AMOD)
      PR(2)=PSTAR(1)*BR(2)/ALPHA2+(PSTAR(3)-ALPHA1*PSTAR(1)/ALPHA2)
     1*AR(2)/AMOD+(PSTAR(2)*AN(2))/(ALPHA2*AMOD)
      PR(3)=PSTAR(1)*BR(3)/ALPHA2+(PSTAR(3)-ALPHA1*PSTAR(1)/ALPHA2)
     1*AR(3)/AMOD+(PSTAR(2)*AN(3))/(ALPHA2*AMOD)
      RETURN
      END
      SUBROUTINE CULIMP(IP0,A0,ZC0,AM,CH,PN0,TEMP,ECOLB)
      DIMENSION X0(199),Y0(199),Z0(199),VX0(199),VY0(199),VZ0(199),
     *VX(199),VY(199),VZ(199),AM(500),CH(500),VN(199),RS(199),
     *PN0(3,500),PNT(3,500)
      COMMON /BLPAT/PA(500),PAZ(500),IP  /BPLACE/RFI
      COMMON /BLCEN2/XC(500),YC(500),ZC(500)  /BLDT/DT,IT
c     DT=10.
      DT=2.
      RN=1.17
      RN0=RN
      IF(RFI.GT.0.001) RN0=RFI
      RSYS=2.0*RN*(A0**0.333333)
      IP=IP0
      DO 50 I=1,IP
      PA(I)=AM(I)/0.94
 50   PAZ(I)=CH(I)
      CALL PLACE2(RSYS,RN0)
      DO 1 I=1,IP
      X0(I)=XC(I)
      Y0(I)=YC(I)
      Z0(I)=ZC(I)
 1    CONTINUE
      ET=1.5*IP*TEMP*0.001
c      CALL DISNET(IP,0,AM,PNT,TEMP,ET)
      CALL DISNE2(IP,0,AM,PNT,TEMP,ET)
      DO 40 I=1,IP
      VX0(I)=PNT(1,I)/AM(I)
      VY0(I)=PNT(2,I)/AM(I)
      VZ0(I)=PNT(3,I)/AM(I)
 40   CONTINUE
      CALL CULON(X0,Y0,Z0,VX0,VY0,VZ0,VX,VY,VZ,AM,CH,VN,RS,IP,ECOLB,ET)
      DO 7 I=1,IP
      PN0(1,I)=AM(I)*VX(I)
      PN0(2,I)=AM(I)*VY(I)
      PN0(3,I)=AM(I)*VZ(I)
 7    CONTINUE
      RETURN
      END
      SUBROUTINE CULON(X0,Y0,Z0,VX0,VY0,VZ0,VX,VY,VZ,AM,CH,VN,RS,M,EC,
     *ET)
      DIMENSION X0(199),Y0(199),Z0(199),VX0(199),VY0(199),VZ0(199),
     *X(199),Y(199),Z(199),VX(199),VY(199),VZ(199),AM(500),CH(500),
     *R(199,199),F(199,199),FX(199,199),FY(199,199),FZ(199,199),
     *FSX(199),FSY(199),FSZ(199),AX(199),AY(199),AZ(199),VS(199),
     *VN(199),RS(199),VSX(199),VSY(199),VSZ(199)
      COMMON /BLDT/DT,IT
      COMMON /BICOLE/ICOLE
c ---- following Coulomb acceleration in time for fragm. ----
      COMMON /BLACCL/ACL(50,199),ITN(50),JJN,NSIGN,ZSIGN(199)
      JJN=0
      JTOLD=0
      NSIGN=0
c -----------------
      IT=0
      TN=0.0
      TS=0.0
      DO 9 I=1,M
      AX(I)=0.0
      AY(I)=0.0
      AZ(I)=0.0
      VS(I)=SQRT(VX0(I)*VX0(I)+VY0(I)*VY0(I)+VZ0(I)*VZ0(I))
      VX(I)=VX0(I)
      VY(I)=VY0(I)
      VZ(I)=VZ0(I)
      X(I)=X0(I)
      Y(I)=Y0(I)
      Z(I)=Z0(I)
      DO 9 J=1,M
      F(I,J)=0.0
      R(I,J)=0.0
      FX(I,J)=0.0
      FY(I,J)=0.0
      FZ(I,J)=0.0
 9    CONTINUE
c -----------------
c      PRINT 201,IT,M,EC,ET
c 201  FORMAT(2X,'start CULON: IT=',I3,' M=',I3,' EC=',E11.4,
c     *' ET=',E11.4)
c -----------------
      IF(EC.LE.0.) RETURN
      IF(ICOLE.EQ.-1) RETURN
      NSIGN=M
 10   CONTINUE
      DO 1 I=1,M
      DO 1 J=1,M
      IF(I.EQ.J) GO TO 1
      R(I,J)=SQRT((X(I)-X(J))*(X(I)-X(J))+(Y(I)-Y(J))*(Y(I)-Y(J))+
     *(Z(I)-Z(J))*(Z(I)-Z(J)))
 1    CONTINUE
      ECULT=0.0
      DO 2 I=1,M
      DO 2 J=1,M
      IF(I.EQ.J) GO TO 2
      F(I,J)=1.44*(CH(I)*CH(J))/(R(I,J)*R(I,J))
      ECULT=ECULT+(1.44*0.5)*(CH(I)*CH(J))/R(I,J)
 2    CONTINUE
      DO 3 I=1,M
      DO 3 J=1,M
      IF(I.EQ.J) GO TO 3
      FX(I,J)=F(I,J)*(X(I)-X(J))/R(I,J)
      FY(I,J)=F(I,J)*(Y(I)-Y(J))/R(I,J)
      FZ(I,J)=F(I,J)*(Z(I)-Z(J))/R(I,J)
 3    CONTINUE
      DO 5 I=1,M
      FSX(I)=0.0
      FSY(I)=0.0
 5    FSZ(I)=0.0
      DO 4 I=1,M
      DO 4 J=1,M
      IF(I.EQ.J) GO TO 4
      FSX(I)=FSX(I)+FX(I,J)
      FSY(I)=FSY(I)+FY(I,J)
      FSZ(I)=FSZ(I)+FZ(I,J)
 4    CONTINUE
C     PRINT 21,((FSX(I),FSY(I),FSZ(I)),I=1,M)
C21   FORMAT(2X,'FXYZ=',9(E11.4,1X))
c ----------------
      JJO=JJN
      JTNEW=TN
      IF((JTOLD+10).GT.JTNEW) GO TO 40
      JTOLD=JTNEW
      JJN=JJN+1
      IF(JJN.LE.50) ITN(JJN)=JTNEW
 40   CONTINUE
c ----------------
      DO 6 I=1,M
      AX(I)=FSX(I)/(AM(I)*1000.0)
      AY(I)=FSY(I)/(AM(I)*1000.0)
      AZ(I)=FSZ(I)/(AM(I)*1000.0)
c ----------------
      IF(JJN.LE.JJO.OR.JJN.GT.50) GO TO 41
      ZSIGN(I)=CH(I)
      ACL(JJN,I)=SQRT(AX(I)**2+AY(I)**2+AZ(I)**2)
 41   CONTINUE
c ----------------
 6    CONTINUE
      TN=TS+DT
      IT=IT+1
      DO 7 I=1,M
      VSX(I)=VX(I)
      VSY(I)=VY(I)
 7    VSZ(I)=VZ(I)
      DO 8 I=1,M
      VX(I)=VSX(I)+AX(I)*(TN-TS)
      VY(I)=VSY(I)+AY(I)*(TN-TS)
      VZ(I)=VSZ(I)+AZ(I)*(TN-TS)
      VS(I)=SQRT(VSX(I)*VSX(I)+VSY(I)*VSY(I)+VSZ(I)*VSZ(I))
      VN(I)=SQRT(VX(I)*VX(I)+VY(I)*VY(I)+VZ(I)*VZ(I))
      X(I)=X(I)+(VSX(I)+VX(I))*(TN-TS)*0.5
      Y(I)=Y(I)+(VSY(I)+VY(I))*(TN-TS)*0.5
      Z(I)=Z(I)+(VSZ(I)+VZ(I))*(TN-TS)*0.5
 8    RS(I)=SQRT(X(I)*X(I)+Y(I)*Y(I)+Z(I)*Z(I))
c -----------------
c      EKINT=0.
c      DO 203 I=1,M
c 203  EKINT=EKINT+(AM(I)*0.5)*VN(I)*VN(I)
c      PRINT 202,IT,ECULT,EKINT,RS(1),RS(2)
c 202  FORMAT(2X,'*IT=',I3,' ECULT=',E11.4,
c     *' EKINT=',E11.4,' RS1=',E10.3,' RS2=',E10.3)
c -----------------
C     PRINT 20,(VN(I),I=1,M),ECULT,(RS(I),I=1,M)
C     PRINT 23,IT
c     IF(IT.GT.50) GO TO 11
      IF(IT.GT.50) DT=4.
      IF(IT.GT.75) DT=10.
      IF(IT.GT.125) DT=15.
      IF(IT.GT.150) DT=20
      IF(IT.GT.200) GO TO 11
      TS=TN
      GO TO 10
 11   CONTINUE
C20   FORMAT(1X,' VN=',3(1X,E11.4),3X,'ECULT=',E11.4,
C    *' RS=',3(1X,E11.4))
C23   FORMAT(2X,'IT=',I5)
      EE=0.
      DO 30 I=1,M
 30   EE=EE+(AM(I)*0.5)*VN(I)*VN(I)
      ETA=SQRT((EC+ET)/EE)
      DO 31 I=1,M
      VX(I)=ETA*VX(I)
      VY(I)=ETA*VY(I)
      VZ(I)=ETA*VZ(I)
 31   CONTINUE
      RETURN
      END
      SUBROUTINE PLACE(RSYS,RN)
      COMMON /BLPAT/ PA(500),PAZ(500),IP
      COMMON /BLCEN/ XC(500),YC(500),ZC(500)
      COMMON /CELIPS/CEL,IPOSF1
      JJJJ=0
C FOR PROLONGED ELLIPSOID CEL>1
c      CEL=1.
c      IF(IPOSF1.EQ.1) RSYS=1.26*RSYS
C FINDING FRAGMENT POSITIONS IN THE SYSTEM
      CCCL=1./SQRT(CEL)
 1    I=1
      R=(RSYS-RN*PA(I)**0.3333333)*(RNDMSMM(-1))**0.3333333
      IF(IPOSF1.EQ.1) R=0.
      CT=1.-2.*RNDMSMM(-1)
      PHI=6.28318*RNDMSMM(-1)
      ST=SQRT(1-CT**2)
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
c      XC(1)=R*ST*CPHI
c      YC(1)=R*ST*SPHI
C      ZC(1)=R*CT
      XC(1)=R*ST*CPHI*CCCL
      YC(1)=R*ST*SPHI*CCCL
      ZC(1)=R*CT*CEL
 3    K=I
      KK=0
      I=I+1
 4    CONTINUE
      KK=KK+1
      IF(KK.GT.1000) GO TO 2
      R=(RSYS-RN*PA(I)**0.3333333)*(RNDMSMM(-1))**0.3333333
      CT=1.-2.*RNDMSMM(-1)
      PHI=6.28318*RNDMSMM(-1)
      ST=SQRT(1-CT**2)
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
c      XC(I)=R*ST*CPHI
c      YC(I)=R*ST*SPHI
C      ZC(I)=R*CT
      XC(I)=R*ST*CPHI*CCCL
      YC(I)=R*ST*SPHI*CCCL
      ZC(I)=R*CT*CEL
      DO 5 J=1,K
      RR=(XC(I)-XC(J))**2+(YC(I)-YC(J))**2+(ZC(I)-ZC(J))**2
      RMIN=RN*PA(I)**0.3333333+RN*PA(J)**0.3333333
      IF(RR-RMIN*RMIN) 4,5,5
 5    CONTINUE
      IF(I.EQ.IP) RETURN
      GO TO 3
 2    CONTINUE
      JJJJ=JJJJ+1
      IF(JJJJ.GE.1000) PRINT 10,KK,I,PA(I),IP
 10   FORMAT(3X,'ERROR IN PLACE - KK=',I4,' I=',I3,' PA(I)=',F5.1,
     *' IP=',I3)
      IF(IPOSF1.EQ.1) RSYS=1.1*RSYS
      GO TO 1
      END
      SUBROUTINE PLACE2(RSYS,RN)
      COMMON /BLPAT/ PA(500),PAZ(500),IP
      COMMON /BLCEN2/ XC(500),YC(500),ZC(500)
C FOR PROLONGED ELLIPSOID CEL>1
      CEL=1.
C FINDING FRAGMENT POSITIONS IN THE SYSTEM
 1    I=1
      R=(RSYS-RN*PA(I)**0.3333333)*(RNDMSMM(-1))**0.3333333
      CT=1.-2.*RNDMSMM(-1)
      PHI=6.28318*RNDMSMM(-1)
      ST=SQRT(1-CT**2)
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
      XC(1)=R*ST*CPHI
      YC(1)=R*ST*SPHI
C      ZC(1)=R*CT
      ZC(1)=R*CT*CEL
 3    K=I
      KK=0
      I=I+1
 4    CONTINUE
      KK=KK+1
      IF(KK.GT.1000) GO TO 2
      R=(RSYS-RN*PA(I)**0.3333333)*(RNDMSMM(-1))**0.3333333
      CT=1.-2.*RNDMSMM(-1)
      PHI=6.28318*RNDMSMM(-1)
      ST=SQRT(1-CT**2)
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
      XC(I)=R*ST*CPHI
      YC(I)=R*ST*SPHI
C      ZC(I)=R*CT
      ZC(I)=R*CT*CEL
      DO 5 J=1,K
      RR=(XC(I)-XC(J))**2+(YC(I)-YC(J))**2+(ZC(I)-ZC(J))**2
      RMIN=RN*PA(I)**0.3333333+RN*PA(J)**0.3333333
      IF(RR-RMIN*RMIN) 4,5,5
 5    CONTINUE
      IF(I.EQ.IP) RETURN
      GO TO 3
 2    CONTINUE
C 2    PRINT 10,KK,I,PA(I),IP
C 10   FORMAT(3X,'ERROR IN PLACE - KK=',I4,' I=',I3,' PA(I)=',F5.1,
C     *' IP=',I3)
      GO TO 1
      END
c ----------------------------------------------------------------------
c *** RAZVAL modernized as for Milazzo paper, if label MILAZ=1. (=0 -old)
c ----------------------------------------------------------------------
c --- version RAZVAL with "limited" excit.levels ~< 5MeV. Sept.99 Bo ---
c ** as Justification: nucleus excitation should be less than energy of 
c emission of one nucleon (N or P) calculated for liquid-drop masses, 
c since in medium shell effects disappear. Used calcul. with LD_MASS.for.
c This is ILEVRA=3, with IAN3, IZN3, ENN3, ISP3: The tables are corrected.
c Possible exit for hot fragments if IEX=1. April 2001, IUCF
c -----------------------------------------------------------------------
c -- (+ Also change in RAZVAL and GMASS: break-up Nn-systems).
      SUBROUTINE RAZVAL(UP,AP,ZP,PN,KST)
C [EPM[ PA[BA[ [E[KO[O [[PA C A=AP [ Z=ZP. [HEP[[[ BO[[[[[EH[[-UP ([[B).
C HA[. [M[[[[C-PN(3) ([[B/C). KST-HOMEP [A[O[HEH[[ MACC[BA SPT.
C ******** HOBA[ BEPC[[ - [ACT[[[ [A[A[TC[ B TA[[[[E *********
C          ( [[[T[BA[TC[ [ACT[[[ [O A=16 )
      COMMON /BLOK79/SFR(6,99) /ILEVRA/ILEVRA
      COMMON /SPDM/ MS(12,11),DM(12,11) /FKAP/FKAP /BLOKC/SPTU(10,500)
      COMMON /WWW/WK(20),WA(20),WN(100) /BLENN/ENN(100) /SUMN/NK(20),NF
      COMMON /BLJ/J(20),IEND /BLIAN/IAN(100) /BLIZN/IZN(100)
      COMMON /BLSECON/LSECON /BMILAZ/MILAZ /BLIEX/IEX
      DIMENSION PN(3),VN(3),PNC(3),PNL(3),PN0(3,500),AMK(500)
      DIMENSION IPA(20),IPZ(20),WCON(2000),JCON(13000)
      LSECON=1
      KSTOLD=KST
      ILEVRA=2
      IF(MILAZ.EQ.1) ILEVRA=3
      FKAP=1.
      IA0=INT(AP+0.5)
      IZ0=INT(ZP+0.5)
      NF=0
      DO 69 I=1,100
 69   WN(I)=0.
      DO 70 I=1,20
      NK(I)=0
      WA(I)=0.
 70   WK(I)=0.
      IF(AP.LT.1.9) GO TO 37
      PQ=PN(1)**2+PN(2)**2+PN(3)**2
      EAP=SQRT(PQ+(0.94*AP)**2)
      DO 40 I=1,3
 40   VN(I)=PN(I)/EAP
c ------- exit for hot fragments (into SPT) -----
      IF(IEX.EQ.1) GO TO 37
c -----------------------------------------------
      CALL HELPRA
      DAZ=UP+GMASS(IA0,IZ0)
      SRQ=0.
      K2=0
      K00=IA0
c      IF(K00.GT.6) K00=6
      DO 71 K=2,K00
      J(1)=0
      DO 72 I=2,K
 72   J(I)=1
 78   CONTINUE
      CALL DISNUM(IA0,IZ0,K)
c      IF(IEND.EQ.1.AND.IA0.LE.4) PRINT 7,(J(I),I=1,K)
c 7    FORMAT(2X,'**** IEND=1 ****  J=',12I5)
      IF(IEND.EQ.1) GO TO 71
      IF(NF.GE.2000.OR.K2.GT.12980) GO TO 71
      NF=NF+1
      NK(K)=NK(K)+1
      TQ=BCUL(K)
      RMQ=WEIGHT(IA0,K,DAZ,TQ)
c      PRINT 300,NF,IA0,IZ0,DAZ,TQ,RMQ
c 300  FORMAT(1X,'NF,IA0,IZ0=',3I4,' DAZ,TQ,RMQ=',2F10.4,E12.4)
c      PRINT 3,(J(I),I=1,K)
c 3    FORMAT(1X,'selec.config.J=',15I4)
      SRQ=SRQ+RMQ
      WCON(NF)=RMQ
      DO 73 I=1,K
      JI=J(I)
      JCON(K2+I)=JI
      IA=IAN(JI)
      IZ=IZN(JI)
      WN(JI)=WN(JI)+RMQ
 73   WA(IA)=WA(IA)+RMQ
      K2=K2+K
      WK(K)=WK(K)+RMQ
      GO TO 78
 71   CONTINUE
      IF(SRQ.LE.0.) GO TO 37
      DO 33 I=1,IA0
      WK(I)=WK(I)/SRQ
 33   WA(I)=WA(I)/SRQ
      DO 34 I=1,100
 34   WN(I)=WN(I)/SRQ
      DO 32 I=1,NF
 32   WCON(I)= WCON(I)/SRQ
 210                 BR=RNDMSMM(-1)
C     PRINT 106,K2,BR
C106  FORMAT(2X,'[[C[O BCEX [ACT[[ B MACC[BE K2=',I5,' C[[[. BR=',F8.5)
      SR=0.
      DO 13 N=1,NF
      NB=N
      SR=SR+WCON(N)
      IF(BR.LT.SR) GO TO 14
 13   CONTINUE
   14 CONTINUE
      NNP=0
      NN=0
      DO 61 I=2,K00
      NNP=NNP+NK(I)*I
      NN=NN+NK(I)
      IF(NN.GE.NB) GO TO 62
 61   CONTINUE
 62   K=I
      NPK1=(NB-(NN-NK(K))-1)*K
      NPK0=(NNP-NK(K)*K)+NPK1
c      PRINT 101,NN,NB,NPK1,NPK0,K
c101   FORMAT(2X,'NN=',I5,' NB=',I5,' NPK1=',I5,' NPK0=',I5,' K=',I5)
      TN=DAZ
      DO 63 I=1,K
      JI=JCON(NPK0+I)
c      PRINT 105,JI
c 105  FORMAT(5X,'JI=',I5)
      IPA(I)=IAN(JI)
      IPZ(I)=IZN(JI)
      AMK(I)=GMASS(IPA(I),IPZ(I))+0.001*ENN(JI)
      TN=TN-AMK(I)
 63   CONTINUE
      IF(TN.LT.0.) GO TO 210
c      PRINT 102,(IPA(I),IPZ(I),I=1,K)
c 102  FORMAT(2X,'IPA,IPZ=',6(2I5,5X))
c      PRINT 103,UP,DAZ,TN,(AMK(I),I=1,K)
c 103  FORMAT(2X,'UP,DAZ,TN=',3F8.4,' AMK=',8F8.4)
      CALL DISIMP(K,AMK,PN0,TN)
      DO 35 I=1,K
      DO 36 II=1,3
 36   PNC(II)=PN0(II,I)
      EN=SQRT(PNC(1)**2+PNC(2)**2+PNC(3)**2+AMK(I)**2)
      CALL CLPV(PNC,VN,PNL,EN)
      CALL PINT(PNL,CT,ST,CF,SF,TK,AMK(I))
C     PRINT 104,AMK(I),TK,(PNL(II),II=1,3)
C104  FORMAT(2X,'AMK=',F8.4,' TK=',F8.4,' PNL=',3F8.4)
      SPTU(4,KST)=CT
      SPTU(5,KST)=SF
      SPTU(6,KST)=CF
      SPTU(7,KST)=TK
      SPTU(8,KST)=IPZ(I)
      SPTU(9,KST)=0.94*INT(AMK(I)/0.94+0.5)
      KST=KST+1
 35   CONTINUE
      GO TO 200
C      RETURN
 37   CONTINUE
      IF(AP.LT.0.99) RETURN
      WK(1)=1.
      WA(IA0)=1.
      NF=1
      NK(1)=1
      DO 38 II=1,100
      IA1=IAN(II)
      IZ1=IZN(II)
      IF(IA0.EQ.IA1.AND.IZ0.EQ.IZ1) WN(II)=WN(II)+1.
      IF(IA0.EQ.IA1.AND.IZ0.EQ.IZ1) GO TO 39
 38   CONTINUE
 39   CONTINUE
      CMN=0.94*AP
      CALL PINT(PN,CT,ST,CF,SF,TMN,CMN)
      SPTU(4,KST)=CT
      SPTU(5,KST)=SF
      SPTU(6,KST)=CF
      SPTU(7,KST)=TMN
      SPTU(8,KST)=ZP
      SPTU(9,KST)=CMN
c      IF(LSECON.GT.0) SPTU(2,KST)=1.
c      IF(IEX.EQ.1) SPTU(2,KST)=UP
      SPTU(2,KST)=UP
      SPTU(1,KST)=1.
      KST=KST+1
c      GO TO 200
      RETURN
 200  KST1=KST-1
C      PRINT 203,KSTOLD,KST1
C 203  FORMAT(5X,'KSTOLD=',I3,' KST1=',I3,' ***** SPTU (BEFORE) *****')
C      PRINT 204,((SPTU(I1,I2),I1=4,9),I2=KSTOLD,KST1)
C 204  FORMAT(2X,6F10.4)
      CALL POVRAZ(KSTOLD,KST1,KST2)
      KSS=KSTOLD-1
      DO 201 IPOV=1,KST2
      KSS=KSS+1
      DO 201 JPOV=1,6
      JPOVN=JPOV+3
      SPTU(JPOVN,KSS)=SFR(JPOV,IPOV)
      SPTU(2,KSS)=1.
 201  CONTINUE
      KST=KSS+1
C      PRINT 205,KST2
C 205  FORMAT(5X,' KST2=',I3,' **** SFR ****')
C      PRINT 204,((SFR(I1,I2),I1=1,6),I2=1,KST2)
C      PRINT 206,KSTOLD,KSS
C 206  FORMAT(5X,' KSTOLD=',I3,' KSS=',I3,' **** SPTU (AFTER) ****')
C      PRINT 204,((SPTU(I1,I2),I1=4,9),I2=KSTOLD,KSS)
      RETURN
      END
      FUNCTION WEIGHT(MA,K,DAZ,TQ)
C O[PE[E[EH[E [P[BE[EHHO[ BEPO[THOCT[ PAC[A[A MA HA K [PA[MEHTOB. HOMEP
C [PA[M. [AH[ B MACC[BE J(I). DAZ-[HEP[[[ MA,BK[[[A[ [HEP[[[ [OKO[. TQ-
C K[[OHOBCK[[ [AP[EP. AKV-[P[BE[EHH[[ O[[EM [[[ O[HO[O [PA[MEHTA. AKM-[P
C BE[EH[E C[[HOB[X [ MACCOB[X [AKTOPOB. RPM-[AKTOP[A[ TO[[ECTBEHH[X [[E-
C HOB. GAM-O[PATHA[ [AMMA-[[HK[[[. TN-K[HET[[ECKA[ [HEP[[[ OCKO[KOB.
      COMMON /SPDM/ MS(12,11),DM(12,11) /VAK/VAK /GAF/GAF(20)
      COMMON /BLJ/J(20),IEND /BLIAN/IAN(100) /BLIZN/IZN(100)
      COMMON /BLISP/ISP(100) /BLENN/ENN(100) /FKAP/FKAP
      COMMON /BMILAZ/MILAZ
      BNQ=DAZ
      RMQ=0.
      SPM=1.
      AKM=1.
      AKV=MA*VAK
c --- correction on multiple-dependent freez-out (translat.) volume ---
      IF(MILAZ.EQ.1) GO TO 50
      AMA03=(FLOAT(MA))**0.333333
      AKV=(AKV/FKAP)*((1.+1.4*(K**0.333333-1)/(1.17*AMA03))**3-1.)
 50   CONTINUE
c ---
      DO 40 I=1,K
      JI=J(I)
      IA=IAN(JI)
      IZ=IZN(JI)
      AKM=AKM*IA
      SPM=SPM*ISP(JI)
      BNQ=BNQ-GMASS(IA,IZ)-0.001*ENN(JI)
 40   CONTINUE
      TN=BNQ
      IF(TN.LE.TQ) GO TO 20
      TN=TN-TQ
      AKM=AKM/MA
      AKM=AKM*SQRT(AKM)*SPM
      IF(K.GT.2) GO TO 29
      RMQ=1.1283792*AKV*AKM*SQRT(TN)
      IF(J(1).EQ.J(2)) RMQ=0.5*RMQ
      GO TO 20
 29   CONTINUE
      KI=K-1
      RPM=1.
      VMK=1.
      TEQ=2.71828183*TN/(1.5*K-2.5)
      VTK=AKV*TEQ*SQRT(TEQ)
      DO 21 I=1,KI
      MRS=1
      IK=I+1
      VMK=VMK*VTK
      DO 22 I1=IK,K
      IF(J(I).EQ.J(I1)) MRS=MRS+1
 22   CONTINUE
      RPM=RPM*MRS
 21   CONTINUE
      GAM=GAF(K)
      RMQ=VMK*GAM*AKM/(TEQ*RPM)
 20   WEIGHT=RMQ
      RETURN
      END
      FUNCTION GMASS(MA,MZ)
C O[PE[E[EH[E MACC[ [E[K[X [[EP B [[B.([C[O[[[[[TC[ [[[EPO[H[E E[[H[[[)
C ( OCHOBHOE COCTO[H[E)
      COMMON /SPDM/ MS(12,11),DM(12,11)
      I2=MZ
      I=MA-I2
      IF(I.LT.0.OR.I.GT.11) GO TO 10
      IF(I2.LT.0.OR.I2.GT.10) GO TO 10
      DMP=DM(I+1,I2+1)
      IF(DMP.GT.90) GO TO 10
      GMASS=0.931437*(I+I2)+0.001*DMP
      RETURN
c 10   GMASS=0.939*MA
c ---- botvina change ----
 10   CONTINUE
      AA=MA
      ZZ=MZ
      CALL DELAM(AA,ZZ,DLMPP,DSH,BAR)
      GMASS=0.931437*AA+0.001*DLMPP
c ----
      RETURN
      END
      FUNCTION BCUL(K)
C  O[PE[E[EH[E K[[OHOBCKO[O [AP[EPA [[[ PA[BA[A HA KOH[[[[PA[[[ J(1-K)
C  [[ K [ACT[[.
      COMMON /FKAP/FKAP /BLJ/J(20),IEND /BLIAN/IAN(100) /BLIZN/IZN(100)
      DIMENSION IA(20),IZ(20)
      A=0.
      Z=0.
      COEF=(3.*1.44/(5.*1.3))*(1./(1.+FKAP)**0.333333)
      DO 1 I=1,K
      JI=J(I)
      IA(I)=IAN(JI)
      A=A+IA(I)
      IZ(I)=IZN(JI)
      Z=Z+IZ(I)
 1    CONTINUE
      EC=0.
      DO 4 I=1,K
      AP=IA(I)
      ZP=IZ(I)
      EC=EC+ZP*ZP/(AP**0.333333)
 4    CONTINUE
      EC=Z*Z/(A**0.333333)-EC
      BCUL=0.001*COEF*EC
      IF(BCUL.LT.0.) BCUL=0.
      RETURN
      END
      SUBROUTINE HELPRA
C MS(I,J)-MACC[B C[[HOB[X [AKTOPOB [E[K[X [[EP =(2*S+1),[[E I=A-Z+1,
C J=Z+1. DM(I,J)-MACC[B [E[EKTOB MACC B [[[EPO[H[X E[[H[[AX. [[[T[BA[TC[
C [[PA C 0.LE.Z.LE.10 [ Z.LE.A.LE.(11+Z); MO[HO C[[TAT[ PA[BA[ [E[K[X
C [[EP C Z0.LE.10 [ (A0-Z0).LE.11.
C ([[[T[BA[TC[ C[[H[             OCHOBH[X      COCTO[H[[,   [EPETC[ [HEP
C [[[ OCHOBHO[O COCTO[H[[ - [[[ [[EP HA[[HA[ C [[T[[).
C KPOME TO[O,[POBO[[TC[ BC[OMO[ATE[[H[E B[[[C[EH[[ [[[ O[PE[E[EH[[ [AMMA
C [[HK[[[ ([O CT[P[[H[[) [ [P[BE[EHHO[O O[[EMA.
      COMMON /VAK/VAK /GAF/GAF(20) /SPDM/MS(12,11),DM(12,11)
      COMMON /FKAP/FKAP /ILEVRA/ILEVRA
      COMMON /BLIAN1/IAN1(100) /BLIZN1/IZN1(100) /BLENN1/ENN1(100)
      COMMON /BLIAN2/IAN2(100) /BLIZN2/IZN2(100) /BLENN2/ENN2(100)
      COMMON /BLIAN/IAN(100) /BLIZN/IZN(100) /BLENN/ENN(100)
      COMMON /BLISP1/ISP1(100) /BLISP2/ISP2(100) /BLISP/ISP(100)
      COMMON /BLIAN3/IAN3(100) /BLIZN3/IZN3(100) /BLENN3/ENN3(100)
      COMMON /BLISP3/ISP3(100)
      DIMENSION IPA(12),JPZ(12),DMP(12),MSP(12),AMP(12),MD(12,11),
     *MS1(12,11)
      DATA MS1/
     * 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     * 2, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     * 0, 2, 1, 4, 1, 0, 1, 0, 0, 0, 0, 0,
     * 0, 0, 4, 3, 4, 5, 4, 0, 0, 0, 0, 0,
     * 0, 0, 1, 4, 1, 4, 1, 2, 1, 0, 0, 0,
     * 0, 0, 0, 5, 4, 7, 4, 3, 4, 0, 0, 0,
     * 0, 0, 0, 4, 1, 4, 1, 2, 1, 2, 1, 0,
     * 0, 0, 0, 0, 0, 3, 2, 3, 2, 5, 2, 0,
     * 0, 0, 0, 0, 0, 4, 1, 2, 1, 6, 1, 6,
     * 0, 0, 0, 0, 0, 0, 0, 1, 6, 3, 2, 5,
     * 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, 4/
      DATA MD/
     *99000,
     * 8071,99999,99999,99999,99999,99999,99999,99999,99999,99999,99999,
     * 7289,
     *13136,14950,25920,33790,99999,99999,99999,99999,99999,99999,99999,
     *99000,
     *14931, 2425,11390,17597,26110,31603,42030,50130,65000,75240,89260,
     *99000,
     *25130,11680,14087,14907,20947,24955,33250,40940,52940,61570,72280,
     *99000,
     *31700,18375,15769, 4942,11348,12607,20179,25072,35720,40720,51210,
     *99000,
     *99999,27940,22920,12416,12052, 8668,13370,16560,24230,29410,37960,
     *99000,
     *99999,35093,28912,15702,10650,00000, 3125, 3020, 9873,13693,17560,
     *99000,99999,99999,99999,25450,17338, 5346, 2864,  102, 5683, 7871,
     *13274,99000,99999,99999,42700,32070,23110, 8010, 2860,-4737, -810,
     * -783, 3332,99000,99999,99999,99999,39700,33380,17610,10693, 1952,
     *  873,-1486,  -16,99000,99999,99999,99999,49400,36400,24110,16470,
     * 5320, 1750,-7040,-5730/
      DO 22 I=1,12
      DO 22 I2=1,11
      MS(I,I2)=MS1(I,I2)
 22   DM(I,I2)=0.001*MD(I,I2)
      VL=1.3/(0.21*SQRT(0.94))
      VOL=FKAP*VL*VL*VL
      VAK=VOL*SQRT(2./3.14159265)*0.333333
      GAF(1)=0.
      GAF(2)=1./SQRT(3.1416)
      DO 10 K=3,20
      QK=1./(1.5*K-2.5)
      GQ=1.+QK*(1./12.+QK*(1./288.-QK*(139./51840.)))
 10   GAF(K)=SQRT(QK*0.1591549)/GQ
      IF(ILEVRA-1) 31,30,31
 30   DO 32 I=1,100
      IAN(I)=IAN1(I)
      IZN(I)=IZN1(I)
      ISP(I)=ISP1(I)
 32   ENN(I)=ENN1(I)
      RETURN
 31   IF(ILEVRA-2) 35,34,35
 34   DO 33 I=1,100
      IAN(I)=IAN2(I)
      IZN(I)=IZN2(I)
      ISP(I)=ISP2(I)
 33   ENN(I)=ENN2(I)
      RETURN
 35   DO 36 I=1,100
      IAN(I)=IAN3(I)
      IZN(I)=IZN3(I)
      ISP(I)=ISP3(I)
 36   ENN(I)=ENN3(I)
      RETURN
      END
      SUBROUTINE DISNUM(IA0,IZ0,K)
C  HAXO[[EH[E K [ACT[[ B KOH[[[[PA[[[ B B[[E [X HOMEPOB J(1-K) B MAC-
C  C[BAX IAN (B [OP[[.BO[POC.A) [ IZN (B [OP[[.BO[POC.Z [P[ [AHHOM A)
C  BO[MO[HA[ KOH[[[[PA[[[ IEND=0, KOHE[ IEND=1.
C  HA[.KOH[[[.J(2-K)=1, J(1)=0 [A[AETC[ [EPE[ DISNUM.
      COMMON /BLIAN/IAN(100) /BLIZN/IZN(100) /BLJ/J(20),IEND
 5    L=0
 1    L=L+1
      IF(L.LT.K) GO TO 10
      IF(L.GE.K) GO TO 11
 10   J(L)=J(L)+1
      IF(J(L).GT.J(L+1)) GO TO 2
      ISA=0
      DO 12 I=1,K
      JI=J(I)
 12   ISA=ISA+IAN(JI)
      IF(ISA.GT.IA0) GO TO 2
      IF(ISA.LT.IA0) GO TO 5
 4    ISZ=0
      DO 13 I=1,K
      JI=J(I)
 13   ISZ=ISZ+IZN(JI)
      IF(ISZ.NE.IZ0) GO TO 5
      IEND=0
      RETURN
 2    J(L)=1
      GO TO 1
 11   J(L)=J(L)+1
      IF(J(L).GT.100) GO TO 15
      ISA=0
      DO 14 I=1,K
      JI=J(I)
 14   ISA=ISA+IAN(JI)
      IF(ISA.LT.IA0) GO TO 5
      IF(ISA.EQ.IA0) GO TO 4
 15   IEND=1
      RETURN
      END
      BLOCK DATA RAZV
C  TA[[[[[,[A[A[[[E MACC[ (IAN),[AP[[[ (IZN),C[[H.MHO[.(ISP),[HEP[.OCH.
C  COCT.(ENN) [ACT[[ .
      COMMON /BLIAN1/IAN1(100) /BLIZN1/IZN1(100) /BLENN1/ENN1(100)
      COMMON /BLIAN2/IAN2(100) /BLIZN2/IZN2(100) /BLENN2/ENN2(100)
      COMMON /BLISP1/ISP1(100) /BLISP2/ISP2(100) /BLISP3/ISP3(100)
      COMMON /BLIAN3/IAN3(100) /BLIZN3/IZN3(100) /BLENN3/ENN3(100)
C ******   OCHOBH.+ [CTO[[[B[E BO[[[[[. COCTO[H[[  ******
      DATA IAN2/
     * 1, 1, 2, 3, 3, 4, 5, 5, 6, 6,   6, 7, 7, 7, 7, 8, 8, 8, 9, 9,
     *10,10,10,10,10,10,10,10,10,10,  10,10,
     *                                11,11,11,11,11,11,11,11,11,11,
     *11,11,11,11,11,11,11,11,11,12,  12,12,12,12,12,13,13,13,13,13,
     *14,14,14,14,14,14,14,14,14,14,  14,14,14,14,14,15,15,15,15,15,
     *15,15,15,15,15,15,15,15,15,15,  16,16,16,16,16,16,16,16/
      DATA IZN2/
     * 0, 1, 1, 1, 2, 2, 2, 3, 2, 3,   3, 3, 3, 4, 4, 3, 3, 4, 4, 5,
     * 4, 4, 4, 4, 4, 5, 5, 5, 5, 5,   6, 6,
     *                                 5, 5, 5, 5, 5, 5, 5, 5, 6, 6,
     * 6, 6, 6, 6, 6, 6, 6, 6, 6, 5,   5, 5, 5, 6, 6, 6, 6, 6, 6, 7,
     * 6, 6, 6, 6, 6, 7, 7, 7, 7, 7,   7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
     * 7, 7, 7, 7, 7, 8, 8, 8, 8, 8,   7, 7, 7, 7, 8, 8, 8, 8/
      DATA ISP2/
     * 2, 2, 3, 2, 2, 1, 4, 4, 1, 3,   1, 4, 2, 4, 2, 5, 3, 1, 4, 4,
     * 1, 5, 8, 1, 5, 7, 3, 1, 3, 5,   3, 5,
     *                                 4, 2, 6, 4,10, 6, 4, 6, 4, 2,
     * 6, 4, 2, 8, 6, 4, 4, 6, 8, 3,   5, 5, 4, 1, 5, 2, 2, 4, 6, 2,
     * 1, 3, 8, 6, 5, 3, 1, 3, 1, 5,   3, 7, 3, 7, 5, 2, 8, 4,10, 8,
     * 2, 4,14,14, 8, 2, 8, 4,10, 8,   5, 1, 7, 3, 1, 8, 5, 3/
      DATA ENN2/
     * 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,16.76,16.66, 0.00, 0.00,
     * 3.56, 0.00, 0.48, 0.00, 0.43, 0.00, 0.98, 0.00, 0.00, 0.00,
     * 0.00, 3.37, 5.96, 6.18, 6.26, 0.00, 0.72, 1.74, 2.15, 3.59,
     * 0.00, 3.35,
     * 0.00, 2.13, 4.44, 5.02, 6.76, 7.29, 7.98, 8.56, 0.00, 2.00,
     * 4.32, 4.80, 6.34, 6.48, 6.90, 7.50, 8.10, 8.42, 8.66, 0.00,
     * 0.95, 1.67, 2.65, 0.00, 4.44, 0.00, 3.09, 3.68, 3.85, 0.00,
     * 0.00, 6.09, 6.69, 6.96, 7.34, 0.00, 2.31, 3.95, 4.92, 5.11,
     * 5.69, 5.83, 6.20, 6.44, 7.03, 0.00, 5.28, 6.32, 7.22, 7.57,
     * 8.31, 8.57, 9.15, 9.79,10.00, 0.00, 5.22, 6.18, 6.83, 7.28,
     * 0.00, 0.12, 0.30, 0.40, 0.00, 6.10, 6.92, 7.12/
C  ******** OCHOBH. COCTO[H[[ *******
      DATA IAN1/
     * 1, 1, 2, 3, 3, 4, 5, 5, 6, 6,   7, 7, 8, 8, 9, 9,10,10,10,11,11,
     *12,12,13,13,14,14,15,15,16,16,  17,18,67*0/
      DATA IZN1/
     * 0, 1, 1, 1, 2, 2, 2, 3, 2, 3,   3, 4, 3, 4, 4, 5, 4, 5, 6, 5, 6,
     * 5, 6, 6, 7, 6, 7, 7, 8, 7, 8,   8, 8,67*0/
      DATA ISP1/
     * 2, 2, 3, 2, 2, 1, 4, 4, 1, 3,   4, 4, 5, 1, 4, 4, 1, 7, 3, 4, 4,
     * 3, 1, 2, 2, 1, 3, 2, 2, 5, 1,   6, 1,67*0/
      DATA ENN1/6*0.,16.76,16.66,92*0./
C ***  ground + excited states (~<5MeV) allowed by liquid-drop masses  ***
c -- made from 2, just put ISP3=0 for some nuclei (for 0 in weights) --
      DATA IAN3/
     * 1, 1, 2, 3, 3, 4, 5, 5, 6, 6,   6, 7, 7, 7, 7, 8, 8, 8, 9, 9,
     *10,10,10,10,10,10,10,10,10,10,  10,10,
     *                                11,11,11,11,11,11,11,11,11,11,
     *11,11,11,11,11,11,11,11,11,12,  12,12,12,12,12,13,13,13,13,13,
     *14,14,14,14,14,14,14,14,14,14,  14,14,14,14,14,15,15,15,15,15,
     *15,15,15,15,15,15,15,15,15,15,  16,16,16,16,16,16,16,16/
      DATA IZN3/
     * 0, 1, 1, 1, 2, 2, 2, 3, 2, 3,   3, 3, 3, 4, 4, 3, 3, 4, 4, 5,
     * 4, 4, 4, 4, 4, 5, 5, 5, 5, 5,   6, 6,
     *                                 5, 5, 5, 5, 5, 5, 5, 5, 6, 6,
     * 6, 6, 6, 6, 6, 6, 6, 6, 6, 5,   5, 5, 5, 6, 6, 6, 6, 6, 6, 7,
     * 6, 6, 6, 6, 6, 7, 7, 7, 7, 7,   7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
     * 7, 7, 7, 7, 7, 8, 8, 8, 8, 8,   7, 7, 7, 7, 8, 8, 8, 8/
      DATA ISP3/
     * 2, 2, 3, 2, 2, 1, 4, 4, 1, 3,   1, 4, 2, 4, 2, 5, 3, 1, 4, 4,
     * 1, 5, 0, 0, 0, 7, 3, 1, 3, 5,   1, 0,
     *                                 4, 2, 6, 4,10, 6, 4, 0, 4, 2,
     * 6, 4, 0, 0, 0, 0, 0, 0, 0, 3,   5, 5, 4, 1, 5, 2, 2, 4, 6, 2,
     * 1, 3, 8, 0, 0, 3, 1, 3, 1, 5,   3, 7, 3, 7, 5, 2, 8, 4,10, 8,
     * 2, 4,14, 0, 0, 2, 8, 0, 0, 0,   5, 1, 7, 3, 1, 8, 5, 3/
      DATA ENN3/
     * 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,16.76,16.66, 0.00, 0.00,
     * 3.56, 0.00, 0.48, 0.00, 0.43, 0.00, 0.98, 0.00, 0.00, 0.00,
     * 0.00, 3.37, 5.96, 6.18, 6.26, 0.00, 0.72, 1.74, 2.15, 3.59,
     * 0.00, 3.35,
     * 0.00, 2.13, 4.44, 5.02, 6.76, 7.29, 7.98, 8.56, 0.00, 2.00,
     * 4.32, 4.80, 6.34, 6.48, 6.90, 7.50, 8.10, 8.42, 8.66, 0.00,
     * 0.95, 1.67, 2.65, 0.00, 4.44, 0.00, 3.09, 3.68, 3.85, 0.00,
     * 0.00, 6.09, 6.69, 6.96, 7.34, 0.00, 2.31, 3.95, 4.92, 5.11,
     * 5.69, 5.83, 6.20, 6.44, 7.03, 0.00, 5.28, 6.32, 7.22, 7.57,
     * 8.31, 8.57, 9.15, 9.79,10.00, 0.00, 5.22, 6.18, 6.83, 7.28,
     * 0.00, 0.12, 0.30, 0.40, 0.00, 6.10, 6.92, 7.12/
      END
      SUBROUTINE PINT(P,CT,ST,CF,SF,T,CM)
C O[PE[E[EH[E [O MACCE CM [ [M[[[[C[ P(3) [ACT[[[,EE K[H. [HEP[[[ T
C [ [[[OB - CT,ST,CF,SF ,O[PE[E[[[[[X HA[PAB[EH[E [O[ETA.
        real*8 pq
      DIMENSION P(3)
      PZ=P(3)**2
      PQ=P(1)**2+P(2)**2+PZ
      IF(PQ.LE.0.) GO TO 11
      CTQ=PZ/PQ
      T=SQRT(PQ+CM**2)-CM
      IF(CTQ.GE.1.) GO TO 10
      CT=SQRT(CTQ)
      IF(P(3).LE.0.) CT=-CT
      ST=SQRT(1.-CTQ)
      PMH=ST*SQRT(PQ)
      CF=P(1)/PMH
      SF=P(2)/PMH
      RETURN
 10   ST=0.
      CT=1.
      SF=0.
      CF=1.
      RETURN
 11   ST=0.
      CT=1.
      SF=0.
      CF=1.
      T=0.
      RETURN
      ENTRY TINP(P,CT,ST,CF,SF,T,CM)
C O[PE[E[EH[E [O MACCE CM,K[H.[HEP[[[ T [ [[[AM [ACT[[[,EE [M[[[[CA P(3)
      if(t.gt.0) then
        PM=SQRT(T*(T+2.*CM))
      else
        pm=0.
      endif
      P(3)=PM*CT
      PM=PM*ST
      P(1)=PM*CF
      P(2)=PM*SF
      RETURN
      END
      SUBROUTINE CLPV(P1,V,P2,E1)
C O[PE[E[EH[E [M[[[[CA [ACT[[[ P2(3) B [.C.K ,C[[TA[,[TO CTAPA[ C.K.([DE
C [M[[[[C [ACT[[[ P1(3)) [B[[ETC[ CO CKOP.V(3).E1-[O[H.[HEP[.[ACT[[[ B C
      DIMENSION P1(3),V(3),P2(3)
      SPV=0.
      V2=0.
      DO 10 I=1,3
      V2=V2+V(I)**2
      SPV=SPV+P1(I)*V(I)
 10   CONTINUE
      GAM=1./SQRT(1.-V2)
      TEMP=GAM*(SPV*GAM/(GAM+1.)+E1)
      DO 20 K=1,3
 20   P2(K)=P1(K)+V(K)*TEMP
      RETURN
      END
      SUBROUTINE ISOTR(ANL)
      DIMENSION ANL(3)
      CT=1.-2.*RNDMSMM(-1)
      ST=SQRT(ABS(1.-CT*CT))
      ANL(3)=CT
      FI=6.2831843*RNDMSMM(-1)
      ANL(1)=COS(FI)*ST
      ANL(2)=SIN(FI)*ST
      RETURN
      END
      SUBROUTINE DISIMP(K,AMK,PN0,TN)
C O[PE[E[EH[E [M[[[[COB K [PA[MEHTOB- PN0(3,1-K) ([[B/C) B C[CTEME [X
C [.[.  AMK(1-K) ([[B) -[X MACC[. TN ([[B) - [X [O[HA[ K[H. [HEP[[[.
C (AHA[O[[[HO [.[.  KO[[[OB[-1970, C.229-239)
      DIMENSION ANL(3),PNC(3),VRS(3),PN0(3,500),AMK(500)
      SMK=0.
      DO 18 I=1,K
 18   SMK=SMK+AMK(I)
      DO 11 I=1,3
 11   VRS(I)=0.
      TKN=TN
      KL=K-1
      DO 10 L=1,KL
      LK=K-L+1
      AMP=AMK(LK)
      SMK=SMK-AMP
      AMR=SMK
      TPR=TKN
      IF(LK.LT.3) GO TO 20
      TKM=TKN*RNKSI(LK-1)
      TPR=TKN-TKM
 20   PMC=SQRT(2.*((AMP*AMR)/(AMP+AMR))*TPR)
      CALL ISOTR(ANL)
      DO 12 I=1,3
      PNC(I)=PMC*ANL(I)
      PN0(I,LK)=VRS(I)*AMP+PNC(I)
      VRS(I)=VRS(I)-PNC(I)/AMR
 12   CONTINUE
      TKN=TKM
 10   CONTINUE
      DO 21 I=1,3
 21   PN0(I,1)=VRS(I)*AMR
      RETURN
      END
      FUNCTION RNKSI(K)
C HAXO[[EH[E RNKSI(K) O[PE[E[[[[EE K[H.[HEP[[[ K [ACT[[ -T(K) B C[CTEME
C [X [.[. [EPE[ K[H.[HEP[[[ K+1 [ACT[[ -T(K+1) B C[CTEMME [X [.[.
C           (   T(K)=RNKSI(K)*T(K+1)    )
      CSIM=(3.*K-5.)/(3.*K-4.)
      PEX=1.5*K-2.5
      FCSIM=SQRT(1.-CSIM)*CSIM**PEX
 20   CSI=RNDMSMM(-1)
      FCSI =SQRT(1.-CSI)*CSI**PEX
      RF=FCSIM*RNDMSMM(-1)
      IF(RF.GT.FCSI) GO TO 20
      RNKSI=CSI
      RETURN
      END
      SUBROUTINE POVRAZ(KSTOLD,KST1,KST2)
C  [OBTOPH[[ PA[BA[ HECTA[[[[H[X [PA[MEHTOB. BXO[:KST1 [ACT[[ B MACC[BE
C  SPTU(10,500), B[XO[: KST2 [ACT[[ B MACC[BE SFR(6,99)
      COMMON /BLOKC/SPTU(10,500) /BLOK79/SFR(6,99)
      DIMENSION P9(3,500),A9(500),PC9(3),PL9(3),V9(3),Z9(500)
      DO 1 I=1,6
      DO 1 J=1,99
 1    SFR(I,J)=0.
      KST2=0
      DO 2 I=KSTOLD,KST1
      CMN=SPTU(9,I)
      ZP=SPTU(8,I)
      TMN=SPTU(7,I)
      CF=SPTU(6,I)
      SF=SPTU(5,I)
      CT=SPTU(4,I)
      IF(CT.LT.1.) ST=SQRT(1.-CT*CT)
      IF(CT.GE.1.) ST=0.
      IA=INT(CMN/0.94+0.5)
      IZ=ZP
      GAM=1.+TMN/CMN
      V=SQRT((GAM**2-1.)/GAM**2)
      V9(3)=V*CT
      V9(2)=V*ST*SF
      V9(1)=V*ST*CF
      IF(IA.EQ.5.AND.IZ.EQ.2) GO TO 21
      IF(IA.EQ.5.AND.IZ.EQ.3) GO TO 22
      IF(IA.EQ.8.AND.IZ.EQ.4) GO TO 23
      IF(IA.EQ.9.AND.IZ.EQ.5) GO TO 24
      KST2=KST2+1
      DO 3 J=1,6
      J1=J+3
 3    SFR(J,KST2)=SPTU(J1,I)
      GO TO 2
 21   K9=2
      A9(1)=3.728173
      Z9(1)=2.
      A9(2)=0.939508
      Z9(2)=0.
      T9=0.001*(16.76+11.39-8.071-2.425)
      GO TO 100
 22   K9=2
      A9(1)=3.728173
      Z9(1)=2.
      A9(2)=0.938726
      Z9(2)=1.
      T9=0.001*(16.66+11.68-7.289-2.425)
      GO TO 100
 23   K9=2
      A9(1)=3.728173
      Z9(1)=2.
      A9(2)=3.728173
      Z9(2)=2.
      T9=0.001*(4.942-2*2.425)
      GO TO 100
 24   K9=3
      A9(1)=3.728173
      Z9(1)=2.
      A9(2)=3.728173
      Z9(2)=2.
      A9(3)=0.938726
      Z9(3)=1.
      T9=0.001*(12.416-7.289-2*2.425)
 100  CONTINUE
      CALL DISIMP(K9,A9,P9,T9)
      DO 101 J=1,K9
      DO 102 II=1,3
 102  PC9(II)=P9(II,J)
      E9=SQRT(PC9(1)**2+PC9(2)**2+PC9(3)**2+A9(J)**2)
      CALL CLPV(PC9,V9,PL9,E9)
      CALL PINT(PL9,C1,S1,C2,S2,T,A9(J))
      KST2=KST2+1
      SFR(1,KST2)=C1
      SFR(2,KST2)=S2
      SFR(3,KST2)=C2
      SFR(4,KST2)=T
      SFR(5,KST2)=Z9(J)
      SFR(6,KST2)=A9(J)
      IF(A9(J).GT.0.5) SFR(6,KST2)=0.94*INT(A9(J)/0.94+0.5)
 101  CONTINUE
 2    CONTINUE
C     PRINT 11,KST1,KST2
C11   FORMAT(25X,'[OC[E POVRAZ               KST1=',I3,' KST2=',I3)
C     DO 12 I=1,KST2
C     PRINT 10,SFR(6,I),SFR(5,I),SFR(4,I),SFR(1,I),SFR(3,I),SFR(2,I)
C10   FORMAT(2X,' A=',F7.3,'  Z=',F7.3,'  T=',F9.5,'  C1=',F9.5,
C    *'       C2,S2=',2F9.5)
C12   CONTINUE
      RETURN
      END
c *** EVANUC accounting version of Milazzo paper (at MILAZ=1) and possibil. 
c to leave EVANUC during evaporation for RAZVAL for A.le.16 ! See IEVAR.
c SUBROUTINE EVANUC(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART) see EVANU1
      SUBROUTINE DATEVP(I)
C I=1 (I<2) -[[ET OCHOBH[X COCTO[H[[ [C[AP[[[E[C[ [ACT[[[,I=2-[[ET
C [EPB[X BO[[[[[EHH[X COCTO[H[[ ([O [POBHE[,KOTOP[E [C[[CKA[T H[K[OH[),
C I=3 (I>2) -[CPE[HEHH[[ [[ET H[[H[X [POBHE[ [P[ B[COK[X [HEP[[[X BO[[.
      COMMON /BLGAM/ GAM1(35),GAM2(35) /BL1014/ GAM(35)
      COMMON /BL1020/GAM3(35) /BMILAZ/MILAZ
      IF(I-2) 1,1,2
 1    DO 3 J=1,35
 3    GAM(J)=GAM1(J)
      IF(I.EQ.2) CALL FILLEV
      GO TO 5
 2    DO 4 J=1,35
      GAM(J)=GAM2(J)
      IF(MILAZ.EQ.1) GAM(J)=GAM3(J)
 4    CONTINUE
 5    RETURN
      END
       FUNCTION COLOMB(L,RADNCL)
       COMMON /BL1006/ZJ(35)/BL1010/ZFJ(35)/BL1009/AFJ(35)
     */BL1005/AJ(35)/BL1003/U,A,Z
C B[[[C[EH[E K[[OHOBCKO[O [AP[EPA [C[[CKAH[[ [PA[MEHTA COPTA L (M[B)
       IF(L-1)1,1,2
1      COLOMB=0.
       RETURN
2      TEMP1=1.44/RADNCL
       COLOMB=TEMP1*((ZJ(L)*ZFJ(L))/(AJ(L)**.33333+AFJ(L)**.33333))
       IF(COLOMB) 3,3,4
3       COLOMB=0.
4       CONTINUE
       RETURN
       END
      SUBROUTINE ISANGL
C [[OTPO[H[[ PO[[[P[[ [[[OB B[[ETA [PA[MEHTA B C[CTEME OCTAT.[[PA.
      COMMON /BLANGL/ ANGL(4)
      ANGL(1)=1.-2.*RNDMSMM(-1)
      ANGL(4)=SQRT(1.-ANGL(1)**2)
      F=2.*3.1415926536*RNDMSMM(-1)
      ANGL(2)=SIN(F)
      ANGL(3)=COS(F)
      RETURN
      END
      FUNCTION GAMMAC(J,A,U,AM,AMC,AMF,RADNCL)
      COMMON /BLSEC/ISEC
C ISEC=2 - COOTBETCTB[ET [[ET[ [O[[AP[EPHO[O [C[[CKAH[[ [PA[MEHTOB C A.G
      IF(ISEC.NE.2.OR.J.LE.6) GAMMAC=
     *GAMMA1(J,A,U,AM,AMC,AMF,RADNCL)
      IF(ISEC.EQ.2.AND.J.GT.6) GAMMAC=
     *GAMMA2(J,A,U,AM,AMC,AMF,RADNCL)
      RETURN
      END
      FUNCTION TKIN(L,AMC,AMF)
      COMMON /BLSEC/ISEC
C ISEC=2 -COOTBETCTB[ET [[ET[ [O[[AP[EPHO[O [C[[CKAH[[ [PA[MEHTOB C A.GT
      IF(ISEC.NE.2.OR.L.LE.6) TKIN=TKIN1(L,AMC,AMF)
      IF(ISEC.EQ.2.AND.L.GT.6) TKIN=TKIN2(L,AMC,AMF)
      RETURN
      END
      FUNCTION GAMMA1(J,A,U,AM,AMC,AMF,RADNCL)
C  B[[[C[EH[E A[CO[[THO[ [[P[H[ [C[[CKAH[[ [PA[MEHTA COPTA J
C  ( B E[. (1./[P[BE[.[OCT.[[AHKA) M[B )
C  [[P[HA [E[EH[[ B TEX [E E[[H[[AX
       COMMON /BL1009/AFJ(35)/BL1015/RJ(35)/BL1014/GAM(35)
      COMMON /BL1011/VJ(35) /BL1005/AJ(35)/BL1006/ZJ(35)
      COMMON /BL1010/ZFJ(35)
      IF(RJ(J).LE.0.OR.U.LE.0.) GO TO 12
      PER=2.*SQRT(AM*A*U)
      IF(J.EQ.33) GO TO 10
      RN=1.5
      CC=0.2
      IF(J.GT.2.AND.J.LE.6)  CC=0.1
      IF(J.GT.6) CC=    (AJ(J)/AFJ(J))**0.6666667
       IF(J-1)1,2,1
2      ALFA=.76+2.2/AFJ(1)**.33333
       BETA=(2.12/AFJ(1)**.66667-.05)/ALFA
      GO TO 3
1      ALFA=1.+CC
       BETA=0.
       GO TO 3
3      Q1=AMC*AFJ(J)
       Q2=AMC*AFJ(J)*RJ(J)
       Q3=(GAM(J)*AFJ(J)**.66667)*(ALFA/Q1**2)*(AFJ(J)/(AFJ(J)+AJ(J)))
      Q3=Q3*(3.1416*RN**2)/(2.*41.5*3.1416**2)
       Q4=(2.*BETA*Q1-3.)/2.+Q2
       Q5=(2.*BETA*Q1-3.)*(SQRT(Q2)-.5)+2.*Q2
      IF(PER-160.) 20,20,21
 20   PEX1=Q4*EXP(-PER)
      GO TO 22
 21   PEX1=0
 22   PP2=PER-2.*SQRT(Q2)
      IF(PP2-160.) 23,23,24
 23   PEX2=Q5*EXP(-PP2)
      GO TO 25
 24   PEX2=0.
 25   GAMMA1=Q3*(PEX1+PEX2)
      RETURN
 10   Q1=2.*SQRT(AMF*A*RJ(J))
      Q2=1./(4.*3.1416)
      IF(PER-160.) 30,30,31
 30   PEX1=EXP(-PER)
      GO TO 32
 31   PEX1=0.
 32   PP2=PER-Q1
      IF(PP2-160.) 33,33,34
 33   PEX2=(Q1-1.)*EXP(-PP2)
      GO TO 35
 34   PEX2=0.
 35   GAMMA1=(Q2/(AMF*A))*(PEX1+PEX2)
      TFIS=1000.
      GFIS=0.21*940./TFIS
      IF(GAMMA1.GT.GFIS) GAMMA1=GFIS
      RETURN
 12   GAMMA1=0.
      RETURN
       END
       FUNCTION TKIN1(L,AMC,AMF)
C  PO[[[P[[ K[H.[HEP[[[ B[[ETEB[E[O [PA[MEHTA COPTA L B C.[.[. (M[B)
       COMMON /BL1009/AFJ(35)/BL1015/RJ(35)/BL1011/VJ(35)
       COMMON /BL1005/AJ(35)
       RJL=RJ(L)
       RB=4.*AMC*AFJ(L)*RJL
       PP1=SQRT(RB)
 5     B1=RNDMSMM(-1)
       IF(B1.LE.0.OR.B1.GT.1) B1=RNDMSMM(-1)
       IF(PP1-160.) 21,21,22
 21    PEX1=EXP(-PP1)
       GO TO 23
 22    PEX1=0.
 23    RK=1.+(1./PP1)*ALOG(B1+(1.-B1)*PEX1)
       IF(L-1) 1,2,1
2      BETA=(2.12/AFJ(1)**0.66667-0.05)/(0.76+2.2/AFJ(1)**0.33333)
       Q1=1.+BETA/RJL
       Q2=Q1*SQRT(Q1)
       FRK=(((3.*SQRT(3.))/2.)/Q2)*(Q1*RK-RK**3)
       GO TO 3
1     FRK=((3.*SQRT(3.))/2.)*(RK-RK**3)
       GO TO 3
 3     B2=RNDMSMM(-1)
       IF(B2-FRK) 4,4,5
4      TKIN1=   RJL*(1.-RK**2)+VJ(L)
       RETURN
      END
       FUNCTION TKIN2(L,AMC,AMF)
C  PO[[[P[[ K[H.[HEP[[[ B[[ETEB[E[O [PA[MEHTA COPTA L B C.[.[. (M[B)
       COMMON /BL1009/AFJ(35)/BL1015/RJ(35)/BL1011/VJ(35)
       COMMON /BL1005/AJ(35) /BL1010/ZFJ(35)
C  [[[T[BAETC[ BO[MO[HOCT[ [O[[AP[EPHO[O [C[[CKAH[[ [PA[MEHTOB.
      DCOL=1.
      DALF=0.869+9.91/ZFJ(L)
      RJM=RJ(L)+VJ(L)
      EX=VJ(L)+DCOL
      Q1=AMC*AFJ(L)
      EY=VJ(L)/5.
      PER=2.*SQRT(Q1*RJM)
      IF(RJ(L).LE.DCOL) GO TO 1
      EM=VJ(L)+(SQRT(1.+4.*Q1*RJ(L))-1.)/(2.*Q1)
      IF(EM-EX) 1,1,2
 2    FM=(EM-VJ(L))*EXP(2.*SQRT(Q1*(RJM-EM))-PER)
      GO TO 3
 1    EM=RJM-Q1/(DALF*DALF)
      IF(EM.GT.EX) EM=EX
      IF(EM.LE.EY) EM=EY
      FM=DCOL*EXP(2.*SQRT(Q1*(RJM-EM))+DALF*(EM-EX)-PER)
 3    ER=EY+(RJM-EY)*RNDMSMM(-1)
      FR=FM*RNDMSMM(-1)
      IF(ER.GT.EX) FTR=(ER-VJ(L))*EXP(2.*SQRT(Q1*(RJM-ER))-PER)
      IF(ER.LE.EX) FTR=DCOL*EXP(2.*SQRT(Q1*(RJM-ER))+DALF*(ER-EX)-PER)
      IF(FR-FTR) 4,4,3
 4    TKIN2=ER
       RETURN
      END
      FUNCTION GAMMA2(J,A,U,AM,AMC,AMF,RADNCL)
C  B[[[C[EH[E A[CO[[THO[ [[P[H[ [C[[CKAH[[ [PA[MEHTA COPTA J
C  ( B E[. (1./[P[BE[.[OCT.[[AHKA) M[B )
C  [[P[HA [E[EH[[ B TEX [E E[[H[[AX
       COMMON /BL1009/AFJ(35)/BL1015/RJ(35)/BL1014/GAM(35)
      COMMON /BL1011/VJ(35) /BL1005/AJ(35)/BL1006/ZJ(35)
      COMMON /BL1010/ZFJ(35)
C  [[[T[BAETC[ BO[MO[HOCT[ [O[[AP[EPHO[O [C[[CKAH[[ [PA[MEHTOB.
      IF(U.LE.0.) GO TO 12
      PER=2.*SQRT(AM*A*U)
      IF(J.EQ.33) GO TO 10
      DCOL=1.
      DALF=0.869+9.91/ZFJ(J)
      RJM=RJ(J)+VJ(J)
      EY=VJ(J)/5.
      IF(RJM.LE.EY.OR.J.EQ.1) GO TO 12
       CC=    (AJ(J)/AFJ(J))**0.6666667
       ALFA=1.+CC
       Q1=AMC*AFJ(J)
      BETA=DCOL
       Q3=(GAM(J)*AFJ(J)**.66667)*(ALFA/Q1**2)*(AFJ(J)/(AFJ(J)+AJ(J)))
      Q3=Q3*(3.1416*RADNCL**2)/(2.*41.5*3.1416**2)
      RJ(J)=RJ(J)-DCOL
      GAMMA3=0.
      IF(RJ(J).LE.0.) GO TO 8
       Q2=AMC*AFJ(J)*RJ(J)
       Q4=(2.*BETA*Q1-3.)/2.+Q2
       Q5=(2.*BETA*Q1-3.)*(SQRT(Q2)-.5)+2.*Q2
      GAMMA3=Q3*(Q4*EXP(-PER)+Q5*EXP(2.*SQRT(Q2)-PER))
 8    RJ(J)=RJ(J)+DCOL
      EX=VJ(J)+DCOL
      EM=RJM-Q1/(DALF*DALF)
      IF(EM.GE.EX) GO TO 13
      IF(EM.LT.EX.AND.EM.GT.EY) GO TO 16
      IF(EM.LE.EY) GO TO 17
 13   SQ=SQRT(Q1/(RJM-EX))
      F1X=DALF-SQ
      F2X=SQ/(2.*(RJM-EX))
      IF(F1X.GE.(0.5*F2X)) GO TO 14
      CSI=0.48/SQRT(0.5*F2X)
      F1CSI=DALF-SQRT(Q1/(RJM-EX+CSI))
      GAMMA4=Q3*Q1*Q1*DCOL*SQRT(6.2832/F2X)*
     #EXP(2.*SQRT(Q1*(RJM-EX))-PER-F1CSI*CSI)
      GO TO 15
 14   CSI=0.693/F1X
      SQCSI=SQRT(Q1/(RJM-EX+CSI))
      F2CSI=SQCSI/(2.*(RJM-EX+CSI))
      GAMMA4=Q3*2*Q1*Q1*(DCOL/F1X)*
     #EXP(2.*SQRT(Q1*(RJM-EX))-PER-F2CSI*CSI*CSI/2.)
      GO TO 15
 16   SQ=SQRT(Q1/(RJM-EM))
      F2M=SQ/(2.*(RJM-EM))
      CSI=0.48/SQRT(0.5*F2M)
      F1CSI=DALF-SQRT(Q1/(RJM-EM+CSI))
      GAMMA4=Q3*2*Q1*Q1*DCOL*SQRT(6.2832/F2M)*
     #EXP(DALF*(EM-EX)+2.*SQRT(Q1*(RJM-EM))-PER-F1CSI*CSI)
      GO TO 15
 17   GAMMA4=0.
      GO TO 15
 15   GAMMA2=GAMMA3+GAMMA4
      RETURN
 10   IF(RJ(J).LE.0.) GO TO 12
      Q1=2.*SQRT(AMF*A*RJ(J))
      Q2=1./(4.*3.1416)
      GAMMA2=(Q2/(AMF*A))*((Q1-1.)*EXP(Q1-PER)+EXP(-PER))
      RETURN
 12   GAMMA2=0.
      RETURN
       END
      SUBROUTINE FILLEV
C  [A[O[HEH[E BO[[[[[EHH[X [POBHE[ [E[K[X [PA[MEHTOB
      COMMON /EXILEV/ENLEV(20,35),SPLEV(20,35)
      ENLEV(1,10)=3.56
      SPLEV(1,10)=1.
      ENLEV(1,11)=0.48
      SPLEV(1,11)=2.
      ENLEV(1,12)=0.98
      SPLEV(1,12)=3.
      ENLEV(1,13)=0.43
      SPLEV(1,13)=2.
      ENLEV(1,16)=3.37
      SPLEV(1,16)=5.
      ENLEV(2,16)=5.96
      SPLEV(2,16)=8.
      ENLEV(3,16)=6.18
      SPLEV(3,16)=1.
      ENLEV(4,16)=6.26
      SPLEV(4,16)=5.
      ENLEV(1,18)=0.72
      SPLEV(1,18)=3.
      ENLEV(2,18)=1.74
      SPLEV(2,18)=1.
      ENLEV(3,18)=2.15
      SPLEV(3,18)=3.
      ENLEV(4,18)=3.59
      SPLEV(4,18)=5.
      ENLEV(1,19)=2.13
      SPLEV(1,19)=2.
      ENLEV(2,19)=4.44
      SPLEV(2,19)=6.
      ENLEV(3,19)=5.02
      SPLEV(3,19)=4.
      ENLEV(4,19)=6.76
      SPLEV(4,19)=10.
      ENLEV(5,19)=7.29
      SPLEV(5,19)=6.
      ENLEV(6,19)=7.98
      SPLEV(6,19)=4.
      ENLEV(7,19)=8.56
      SPLEV(7,19)=6.
      ENLEV(1,20)=0.95
      SPLEV(1,20)=5.
      ENLEV(2,20)=1.67
      SPLEV(2,20)=5.
      ENLEV(3,20)=2.65
      SPLEV(3,20)=4.
      ENLEV(1,21)=2.00
      SPLEV(1,21)=2.
      ENLEV(2,21)=4.32
      SPLEV(2,21)=6.
      ENLEV(3,21)=4.80
      SPLEV(3,21)=4.
      ENLEV(4,21)=6.34
      SPLEV(4,21)=2.
      ENLEV(5,21)=6.48
      SPLEV(5,21)=8.
      ENLEV(6,21)=6.90
      SPLEV(6,21)=6.
      ENLEV(7,21)=7.50
      SPLEV(7,21)=4.
      ENLEV(8,21)=8.10
      SPLEV(8,21)=4.
      ENLEV(9,21)=8.42
      SPLEV(9,21)=6.
      ENLEV(10,21)=8.66
      SPLEV(10,21)=8.
      ENLEV(1,22)=4.44
      SPLEV(1,22)=5.
      ENLEV(1,23)=3.09
      SPLEV(1,23)=2.
      ENLEV(2,23)=3.68
      SPLEV(2,23)=4.
      ENLEV(3,23)=3.85
      SPLEV(3,23)=6.
      ENLEV(1,24)=6.09
      SPLEV(1,24)=3.
      ENLEV(2,24)=6.69
      SPLEV(2,24)=8.
      ENLEV(3,24)=6.96
      SPLEV(3,24)=6.
      ENLEV(4,24)=7.34
      SPLEV(4,24)=5.
      ENLEV(1,26)=2.31
      SPLEV(1,26)=1.
      ENLEV(2,26)=3.95
      SPLEV(2,26)=3.
      ENLEV(3,26)=4.92
      SPLEV(3,26)=1.
      ENLEV(4,26)=5.11
      SPLEV(4,26)=5.
      ENLEV(5,26)=5.69
      SPLEV(5,26)=3.
      ENLEV(6,26)=5.83
      SPLEV(6,26)=7.
      ENLEV(7,26)=6.20
      SPLEV(7,26)=3.
      ENLEV(8,26)=6.44
      SPLEV(8,26)=7.
      ENLEV(9,26)=7.03
      SPLEV(9,26)=5.
      ENLEV(1,27)=5.28
      SPLEV(1,27)=8.
      ENLEV(2,27)=6.32
      SPLEV(2,27)=4.
      ENLEV(3,27)=7.22
      SPLEV(3,27)=10.
      ENLEV(4,27)=7.57
      SPLEV(4,27)=8.
      ENLEV(5,27)=8.31
      SPLEV(5,27)=2.
      ENLEV(6,27)=8.57
      SPLEV(6,27)=4.
      ENLEV(7,27)=9.15
      SPLEV(7,27)=14.
      ENLEV(8,27)=9.79
      SPLEV(8,27)=14.
      ENLEV(9,27)=10.00
      SPLEV(9,27)=8.
      ENLEV(1,28)=0.12
      SPLEV(1,28)=1.
      ENLEV(2,28)=0.30
      SPLEV(2,28)=7.
      ENLEV(3,28)=0.40
      SPLEV(3,28)=3.
      ENLEV(1,29)=5.22
      SPLEV(1,29)=8.
      ENLEV(2,29)=6.18
      SPLEV(2,29)=4.
      ENLEV(3,29)=6.83
      SPLEV(3,29)=10.
      ENLEV(4,29)=7.28
      SPLEV(4,29)=8.
      ENLEV(1,30)=6.10
      SPLEV(1,30)=8.
      ENLEV(2,30)=6.92
      SPLEV(2,30)=5.
      ENLEV(3,30)=7.12
      SPLEV(3,30)=3.
      ENLEV(1,31)=0.87
      SPLEV(1,31)=2.
      ENLEV(2,31)=3.06
      SPLEV(2,31)=2.
      ENLEV(3,31)=3.84
      SPLEV(3,31)=6.
      ENLEV(1,32)=1.98
      SPLEV(1,32)=5.
      ENLEV(2,32)=3.57
      SPLEV(2,32)=10.
      ENLEV(3,32)=3.92
      SPLEV(3,32)=5.
      ENLEV(4,32)=4.46
      SPLEV(4,32)=3.
      ENLEV(5,32)=5.10
      SPLEV(5,32)=7.
      ENLEV(6,32)=5.33
      SPLEV(6,32)=13.
      ENLEV(7,32)=5.53
      SPLEV(7,32)=5.
      ENLEV(8,32)=6.20
      SPLEV(8,32)=3.
      ENLEV(9,32)=6.38
      SPLEV(9,32)=12.
      ENLEV(10,32)=6.88
      SPLEV(10,32)=1.
      RETURN
      END
      SUBROUTINE FISION(ENEXT,ATWGHT,CHARGE,PFX,PFY,PFZ,KSTART)
C  FISSION  (IN - MEV, OUT - GEV)
      COMMON/BLOKC/SPTU(10,500)/BLANGL/ANGL(4)
      COMMON/BLFIS/FIS,EF,SNT(6,6)
      UT=ENEXT
      AT=ATWGHT
      ZT=CHARGE
      VFX=PFX/(940.*AT)
      VFY=PFY/(940.*AT)
      VFZ=PFZ/(940.*AT)
      SNT(1,2)=ENEXT*0.001
      SNT(2,2)=ATWGHT
      SNT(3,2)=CHARGE
      SNT(4,2)=PFX*0.001
      SNT(5,2)=PFY*0.001
      SNT(6,2)=PFZ*0.001
      JJ=0
 1    CONTINUE
      JJ=JJ+1
      IF(JJ.GT.100) GO TO 10
      AR=AFIS(UT,AT,ZT,EF)
      IA1=INT(AR+0.5)
      ZR=ZFIS(AT,ZT,AR)
      IZ1=INT(ZR+0.5)
      AF1=IA1
      ZF1=IZ1
      AF2=AT-AF1
      ZF2=ZT-ZF1
      IA2=INT(AF2+0.5)
      IZ2=INT(ZF2+0.5)
      EKF=FISKIN(UT,AT,ZT,AF1,AF2,ZF1,ZF2)
      AMAS1=940.*AF1
      AMAS2=940.*AF2
      EK1=AF2*EKF/AT
      EK2=AF1*EKF/AT
      CALL DELAM(AT,ZT,DL0,DSH0,BAR0)
      CALL DELAM(AF1,ZF1,DL1,DSH1,BAR1)
      CALL DELAM(AF2,ZF2,DL2,DSH2,BAR2)
      ET=UT+DL0-DL1-DL2
C      PRINT 2,AT,ZT,AF1,ZF1,AF2,ZF2,UT,DL0,DL1,DL2,ET,EKF
C 2    FORMAT(2X,'AT,ZT=',2F6.1,' AF1,ZF1=',2F6.1,' AF2,ZF2=',2F6.1,
C     *' UT,DL0=',2F6.1,' DL1,DL2=',2F6.1,' ET,EKF=',2F6.1)
      IF(ET.LT.EKF) GO TO 1
      U1=0.001*(ET-EKF)*AF1/AT
      U2=0.001*(ET-EKF)*AF2/AT
      CALL ISANGL
      VM=SQRT(2.*EK1/AMAS1)
      VX1=VM*ANGL(4)*ANGL(3)
      VY1=VM*ANGL(4)*ANGL(2)
      VZ1=VM*ANGL(1)
      PX1=AMAS1*(VX1+VFX)*0.001
      PY1=AMAS1*(VY1+VFY)*0.001
      PZ1=AMAS1*(VZ1+VFZ)*0.001
      TEMP=-1.*(AMAS1/AMAS2)
      VX2=TEMP*VX1
      VY2=TEMP*VY1
      VZ2=TEMP*VZ1
      PX2=AMAS2*(VX2+VFX)*0.001
      PY2=AMAS2*(VY2+VFY)*0.001
      PZ2=AMAS2*(VZ2+VFZ)*0.001
C  BEFORE EVAPORATION
      SNT(1,3)=U1
      SNT(2,3)=AF1
      SNT(3,3)=ZF1
      SNT(4,3)=PX1
      SNT(5,3)=PY1
      SNT(6,3)=PZ1
      SNT(1,4)=U2
      SNT(2,4)=AF2
      SNT(3,4)=ZF2
      SNT(4,4)=PX2
      SNT(5,4)=PY2
      SNT(6,4)=PZ2
C  AFTER EVAPORATION
C      PRINT 3,KSTART
C 3    FORMAT(2X,' BEFORE EVAP.FRAGM. KSTART=',I4)
      CALL EVAPIN(U1,AF1,ZF1,PX1,PY1,PZ1,KSTART)
      SNT(1,5)=U1
      SNT(2,5)=AF1
      SNT(3,5)=ZF1
      SNT(4,5)=PX1
      SNT(5,5)=PY1
      SNT(6,5)=PZ1
C      PRINT 4,KSTART
C 4    FORMAT(2X,'AFT.EVAP.FIRST, BEF.EVAP.SEC.FRAGM. KSTART=',I4)
      CALL EVAPIN(U2,AF2,ZF2,PX2,PY2,PZ2,KSTART)
      SNT(1,6)=U2
      SNT(2,6)=AF2
      SNT(3,6)=ZF2
      SNT(4,6)=PX2
      SNT(5,6)=PY2
      SNT(6,6)=PZ2
C      PRINT 5,KSTART
C 5    FORMAT(2X,' AFTER EVAP.FRAGM. KSTART=',I4)
      RETURN
 10   PRINT 11,ET,EKF,JJ,UT,AT,ZT
 11   FORMAT(2X,'ERROR IN FISION: ET=',F6.1,'.LT.EKF=',F6.1,
     *' JJ=',I4,' UT,AT,ZT=',3F6.1)
      RETURN
      END
      FUNCTION YIELDF(A0,A,F,AS,A1,A2,SIGS,SIG1,SIG2)
      XSIM=EXP(-0.5*(A-AS)**2/SIGS**2)
      XASIM=EXP(-0.5*(A-A2)**2/SIG2**2)
     *     +EXP(-0.5*(A-(A0-A2))**2/SIG2**2)
     * +0.5*EXP(-0.5*(A-A1)**2/SIG1**2)
     * +0.5*EXP(-0.5*(A-(A0-A1))**2/SIG1**2)
      IF(F.GT.1000.) YIELDF=XSIM
      IF(F.LT.0.001) YIELDF=XASIM
      IF(F.GE.0.001.AND.F.LE.1000) YIELDF=F*XSIM+XASIM
      RETURN
      END
      FUNCTION ZFIS(A,Z,AF)
      COMMON /BLFIS0/F,FH,AS,A1,A2,SIGS,SIG1,SIG2,ZP,SIGZ,EAVR,EMAX
      IF(AF.GE.134.) DZ=-0.45
      IF(AF.LE.(A-134.)) DZ=0.45
      IF(AF.GT.(A-134.).AND.AF.LT.134.) DZ=-0.45*(AF-0.5*A)/(134-0.5*A)
      ZP=AF*Z/A+DZ
      SIGZ=0.6
 3    CALL RANNOR(X,Y)
      XZ=ZP+SIGZ*X
      IF(XZ.LT.1.OR.XZ.GT.(Z-1).OR.XZ.GT.AF) XZ=ZP+SIGZ*Y
      IF(XZ.LT.1.OR.XZ.GT.(Z-1).OR.XZ.GT.AF) GO TO 3
      ZFIS=INT(XZ+0.5)
      RETURN
      END
       SUBROUTINE EVAPIN(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
C   EVAPORATION WITHOUT FISSION FOR SUBR.-FISION
       COMMON /BL0999/RNCL/BL1000/AM,AMF,AMCB(35)/AMNUCL/AMNEV(3)
       COMMON /BL1001/T1Y(130)/BL1002/T2XY(200)/BL1005/AJ(35)
     */BL1006/ZJ(35)/BL1014/GAM(35)/BL1011/VJ(35)/BL1015/RJ(35)
      COMMON /BL1003/U,A,Z/BL1009/AFJ(35)/BL1010/ZFJ(35)
      COMMON/BLOKC/SPTU(10,500)/BLANGL/ANGL(4)/BL1100/AMS,AMFS
      COMMON/BLFIS/FIS,EF,SNT(6,6) /BLCAN/ICAN
      COMMON /EXILEV/ ENLEV(20,35),SPLEV(20,35)
       DIMENSION GJ(35),BJ(35),GG(35),VN(3),PN(3),PNL(3),PP(3),PPL(3)
      DIMENSION DSH2(35)
      FIS=1.
      ILEVEL=3
      CALL DATEVP(ILEVEL)
      U=ENEXT*1000.
      A=ATWGHT
      Z=CHARGE
      AMNEV(1)=0.
      AMNEV(2)=0.
      AMNEV(3)=0.
      REMN=940.*A
      PNL(1)=PNX*1000.
      PNL(2)=PNY*1000.
      PNL(3)=PNZ*1000.
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+REMN**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      DO 20 K=KSTART,500
      IN=35
      DO 4 I=1,IN
      VJ(I)=0.
      AMCB(I)=0.
C      DSH2(I)=0.
 4    RJ(I)=-1000.
      CALL DELAM(A,Z,DL1,DSHEL1,BAR1)
      AM=AMS
C      IF(U.GT.0.) AM=AMS*(1.+(1.-EXP(-0.06*U))*DSHEL1/U)
      DO 6 I=1,IN
      IF(I.EQ.33) GO TO 6
      AFJ(I)=A-AJ(I)
      ZFJ(I)=Z-ZJ(I)
        IF(ICAN.EQ.0.AND.I.GT.6) GO TO 6
        IF(ICAN.EQ.1.AND.I.GT.32) GO TO 6
        IF(ICAN.EQ.2.AND.I.GT.6.AND.I.LE.32) GO TO 6
        IF(AFJ(I).LT.ZFJ(I)) GO TO 6
        IF(AFJ(I).LT.AJ(I).OR.ZFJ(I).LT.ZJ(I)) GO TO 6
      JAF=INT(AFJ(I)+0.5)
      JZF=INT(ZFJ(I)+0.5)
      JNF=JAF-JZF
      ODD=11.*(2+2*(JNF/2)-JNF+2*(JZF/2)-JZF)/SQRT(AFJ(I))
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      VJ(I)=COLOMB(I,RADNCL)
      CALL DELAM(AFJ(I),ZFJ(I),DL2,DSHEL2,BAR2)
C      DSH2(I)=DSHEL2
      CALL DELAM(AJ(I),ZJ(I),DL3,DSHEL3,BAR3)
      BJ(I)=DL2+DL3-DL1
c ******** in accordance with DELA8
      IF(A.LE.55.) RJ(I)=U-(BJ(I)+VJ(I))-ODD
      TCOEF=1.-(A-55.)/10.
      IF(A.GT.55.AND.A.LT.65.) RJ(I)=U-(BJ(I)+VJ(I))-ODD*TCOEF
      IF(A.GE.65.) RJ(I)=U-(BJ(I)+VJ(I))
c ********
C     RJ(I)=U-(BJ(I)+VJ(I))-ODD
C     RJ(I)=U-(BJ(I)+VJ(I))
C      IF(RJ(I).GT.0.)
C     *AMCB(I)=AMS*(1.+(1.-EXP(-0.06*RJ(I)))*DSHEL2/RJ(I))
 6    CONTINUE
      RJ(33)=-1001.
       DO 7 I=1,IN
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      AMC=AM
C      AMC=AMCB(I)
      GJ(I)=GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
      RJI=RJ(I)
      GAMI=GAM(I)
      DO 71 IL=1,20
      IF(SPLEV(IL,I).LT.0.1) GO TO 70
      GAM(I)=SPLEV(IL,I)*AJ(I)
      RJ(I)=RJI-ENLEV(IL,I)
C      IF(RJ(I).GT.0.)
C     *AMC=AMS*(1.+(1.-EXP(-0.06*RJ(I)))*DSH2(I)/RJ(I))
      GJ(I)=GJ(I)+GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
 71   CONTINUE
 70   RJ(I)=RJI
      GAM(I)=GAMI
7     CONTINUE
      G=0.
      DO 10 I=1,IN
10    G=G+GJ(I)
        IF(G) 11,11,12
 11   PNX=PNL(1)*0.001
      PNY=PNL(2)*0.001
      PNZ=PNL(3)*0.001
      ENEXT=U*0.001
      ATWGHT=A
      CHARGE=Z
      REMN=940.*A
      SPTU(9,K)=REMN*0.001
      SPTU(8,K)=Z
      CALL PINT(PNL,CT,ST,CF,SF,T,REMN)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(1,K)=1.
      SPTU(3,K)=FIS
      SPTU(2,K)=2.
      KSTART=K+1
      RETURN
 12   CONTINUE
      DO 13 J=2,IN
13    GJ(J)=GJ(J-1)+GJ(J)
      BB=RNDMSMM(-1)
      B=BB*G
      DO 14 J=1,IN
        IF(B-GJ(J)) 15,14,14
15    LM=J
      GO TO 16
 14   CONTINUE
 16     IF(LM-33) 18,17,18
 17   PRINT 300
 300  FORMAT(2X,' ERROR IN EPAPIN - FALSE FISSION')
      GO TO 11
 18   AMC=AM
C18    AMC=AMCB(LM)
      EP1=TKIN(LM,AMC,AMF)
      EP2=ZJ(LM)
      EP3=940.*AJ(LM)
      U=U-BJ(LM)-EP1
      A=AFJ(LM)
      Z=ZFJ(LM)
C  VPM-OTHOC[TE[[HA[ CKOPOCT[ [PA[MEHTA
      VPM=SQRT((2.*EP1)/(EP3*AFJ(LM)/(AFJ(LM)+AJ(LM))))
      CALL ISANGL
C  [M[[[[C [PA[MEHTA B C.[.[.
      PP(1)=VPM*ANGL(4)*ANGL(3)*EP3/(1.+AJ(LM)/A)
      PP(2)=VPM*ANGL(4)*ANGL(2)*EP3/(1.+AJ(LM)/A)
      PP(3)=VPM*ANGL(1)*EP3/(1.+AJ(LM)/A)
      PN(1)=-PP(1)
      PN(2)=-PP(2)
      PN(3)=-PP(3)
      EP=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+EP3**2)
      EN=SQRT(PN(1)**2+PN(2)**2+PN(3)**2+(940.*A)**2)
      CALL CLPV(PP,VN,PPL,EP)
      CALL CLPV(PN,VN,PNL,EN)
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+(940.*A)**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      CALL PINT(PPL,CT,ST,CF,SF,T,EP3)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(8,K)=EP2
      SPTU(9,K)=EP3*0.001
      SPTU(2,K)=2.
20    CONTINUE
c      PRINT 21,U,A,Z
c21    FORMAT(35X,37HMASSIV SPT EXCEEDED AFTER EVAPORATION/40X,2HU=,
c     *F10.5,4H  A=,F5.1,4H  Z=,F4.1)
       RETURN
       END
      FUNCTION AFIS(E,A,Z,EF)
C IMPROVED VERSION TAKING INTO ACCOUNT DEEXCIT. BEFORE FISSION
      COMMON /BLFIS0/F,FH,AS,A1,A2,SIGS,SIG1,SIG2,ZP,SIGZ,EAVR,EMAX
      A1=134.
      A2=141.
      AS=A/2.
      IZ=INT(Z+0.5)
      IF(A.GE.235.) SIG2=5.6
      IF(A.LT.235.) SIG2=5.6+0.096*(A-235.)
      SIG1=0.5*SIG2
C     IF(E.LE.15.) SIGS=EXP((0.2412*E+0.8252)/2.)
      SIGS=EXP((0.01106*E+4.2772)/2.)
      IF(SIGS.GT.20.) SIGS=20.
      YA=2.*EXP(-0.5*(A2-AS)**2/SIG2**2)+EXP(-0.5*(A1-AS)**2/SIG1**2)
      YS=EXP(-0.5*(AS-(A1+A2)/2.)**2/SIGS**2)
      IF(IZ.GE.90) GO TO 1
      IF(IZ.EQ.89) GO TO 2
      IF(IZ.LE.88.AND.IZ.GE.82) GO TO 3
      IF(IZ.LT.82) GO TO 4
 1    IF(E.LE.16.25) F=EXP(0.5385*E-9.9564)
      IF(E.GT.16.25) F=EXP(0.09197*E-2.7003)
      GO TO 60
 2    F=EXP(0.09197*E-1.0808)
      GO TO 60
 3    X=EF-7.5
      IF(X.LT.0.) X=0.
      F=EXP(0.09197*(E-X)-1.0808)
      T1=1.03*F-YA
      T2=1.-YS*F
      IF(T2.LE.0.0001) T2=0.0001
      IF(T1.LE.0.0001) T1=0.0001
      FH=T1/T2
      IF(A.LT.227.) FH=FH*EXP(0.3*(227-A))
      GO TO 5
 4    FH=1001.
      GO TO 5
 60   T1=1.03*F-YA
      T2=1.-YS*F
      IF(T2.LE.0.0001) T2=0.0001
      IF(T1.LE.0.0001) T1=0.0001
      FH=T1/T2
 5    CONTINUE
      C2A=A2+3.72*SIG2
      C2S=AS+3.72*SIGS
      C2=AMAX1(C2A,C2S)
      IF(FH.GT.1000.) C2=C2S
      IF(FH.LT.0.001) C2=C2A
      C1=A-C2
      IF(C1.LT.30.) C2=A-30.
      IF(C1.LT.30.) C1=30.
      AM1=(AS+A1)/2.
      AM2=(A1+A2)/2.
      XM1=YIELDF(A,AS,FH,AS,A1,A2,SIGS,SIG1,SIG2)
      XM2=YIELDF(A,AM1,FH,AS,A1,A2,SIGS,SIG1,SIG2)
      XM3=YIELDF(A,A1,FH,AS,A1,A2,SIGS,SIG1,SIG2)
      XM4=YIELDF(A,AM2,FH,AS,A1,A2,SIGS,SIG1,SIG2)
      XM5=YIELDF(A,A2,FH,AS,A1,A2,SIGS,SIG1,SIG2)
      PMAX=AMAX1(XM1,XM2,XM3,XM4,XM5)
 6    X=C1+RNDMSMM(-1)*(C2-C1)
      PX=YIELDF(A,X,FH,AS,A1,A2,SIGS,SIG1,SIG2)
      Y=RNDMSMM(-1)
      IF(Y-PX/PMAX)7,7,6
 7    AFIS=INT(X+0.5)
      RETURN
      END
      FUNCTION FISKIN(E,A,Z,AF1,AF2,ZF1,ZF2)
C IMPROVED VERSION TAKING INTO ACCOUNT THE CHANNELS SEPARATELY
      COMMON /BLFIS0/F,FH,AS,A1,A2,SIGS,SIG1,SIG2,ZP,SIGZ,EAVR,EMAX
      AFM=AF1
      IF(AF2.GT.AF1) AFM=AF2
      IF(AFM.LT.(A/2.)) AFM=A-AFM
      EAVR=0.1071*Z*Z/A**0.33333+22.2
      P1=0.5*EXP(-0.5*(AFM-A1)**2/SIG1**2)
      P2=EXP(-0.5*(AFM-A2)**2/SIG2**2)
      PS=FH*EXP(-0.5*(AFM-AS)**2/SIGS**2)
      PAS=P1+P2
      IF(FH.GT.1000.) PAS=0.
      IF(FH.LT.0.001) PS=0.
      PSY=PS/(PAS+PS)
      ISY=0
      BRND=RNDMSMM(-1)
      IF(BRND.LE.PSY) ISY=1
      IF(ISY.EQ.0) SIGE=10.
      IF(ISY.GE.1) SIGE=8.
      PPAS=2.*0.5*SIG1+2.*SIG2
      PPSY=FH*SIGS
      PPP=PPAS+PPSY
      XAS=PPAS/PPP
      XSY=PPSY/PPP
      EAVRSY=EAVR-12.5*XAS
      EAVRAS=EAVR+12.5*XSY
      IF(ISY.EQ.0) GO TO 10
      IF(ISY.GE.1) GO TO 11
 10   EAV0=EAVRAS
      A11=A1-0.7979*SIG1
      A12=A1+0.7979*SIG1
      A21=A2-0.7979*SIG2
      A22=A2+0.7979*SIG2
      EEF11=EEFIS(A,A11,ISY)
      EEF12=EEFIS(A,A12,ISY)
      EEF21=EEFIS(A,A21,ISY)
      EEF22=EEFIS(A,A22,ISY)
      TEMPL=0.5*SIG1*EEF11+0.5*SIG1*EEF12+SIG2*EEF21+SIG2*EEF22
      EMAX=EAV0*PPAS/TEMPL
      GO TO 12
 11   EAV0=EAVRSY
      AS0=AS+0.7979*SIGS
      EEF00=EEFIS(A,AS0,ISY)
      TEMPL=FH*SIGS*EEF00
      EMAX=EAV0*PPSY/TEMPL
 12   EKAFM=EMAX*EEFIS(A,AFM,ISY)
      JJJJ=0
 3    CALL RANNOR(X,Y)
      JJJJ=JJJJ+1
      IF(JJJJ.GT.100) EKIN=EAVR
      IF(JJJJ.GT.100) GO TO 650
      EKIN=EKAFM+SIGE*X
      IF(EKIN.LT.(EAVR-3.72*SIGE).OR.EKIN.GT.(EAVR+3.72*SIGE))
     *EKIN=EKAFM+SIGE*Y
      IF(EKIN.LT.(EAVR-3.72*SIGE).OR.EKIN.GT.(EAVR+3.72*SIGE))
     *GO TO 3
 650  FISKIN=EKIN
      RETURN
      END
      FUNCTION EEFIS(A,AFM,ISY)
C IMPROVED VERSION TAKING INTO ACCOUNT THE CHANNELS SEPARATELY
      IF(ISY.GE.1) GO TO 1
      A00=134.
      B1=23.5
      GO TO 2
 1    B1=5.32
      A00=A/2.
 2    TEMP1=10./A
      A0010=A00+10.
      AS=A/2.
      IF(AFM.GE.AS.AND.AFM.LE.A0010) EE=1.-B1*((AFM-A00)/A)**2
      IF(AFM.GT.A0010) EE=1.-B1*TEMP1**2-2.*TEMP1*B1*(AFM-A0010)/A
      EEFIS=EE
      RETURN
      END
      SUBROUTINE DELAM(ANUCL,ZNUCL,DM,SH,BARIER)
      COMMON /FUSR/ BARR,SMASS,SHLL /BLIDR/ILIDR
      COMMON /BICOLE/ICOLE
      IF(ICOLE.EQ.-1) GO TO 11
      IA=INT(ANUCL+0.5)
      IZ=INT(ZNUCL+0.5)
      IN=IA-IZ
      IF(IZ.LT.0.OR.IN.LT.0) GO TO 8
      ODD=-11.*(1+2*(IN/2)-IN+2*(IZ/2)-IZ)/SQRT(ANUCL)
      IF(IA.LT.65) GO TO 7
      IF(IN.GT.240.OR.IZ.GT.240) GO TO 7
      CM=0.
      SHLL=0.
      CBAR=0.
      NBAR=0
      CALL LYMASM(IZ,IA,CM,CBAR,NBAR)
      IF(NBAR.EQ.1) CBAR=BARR
      DM=CM
      SH=SHLL+ODD
      BARIER=CBAR
c ************* inclusion DELA8
      CALL DELA8(ANUCL,ZNUCL,DM8,SH8)
      DM=DM8
c ************* cold masses
      IF(ILIDR.GE.0) RETURN
      CALL DELA1(ANUCL,ZNUCL,DM1,SH1)
      DM=DM1
c 
      RETURN
 7    CONTINUE
      CALL DELA1(ANUCL,ZNUCL,DM1,SH1)
      BAR1=1001.
      IF(IA.GE.65) BAR1=BARIE1(ANUCL,ZNUCL)
      BARIER=BAR1
      DM=DM1
      SH=SH1
      IF(ILIDR.EQ.-1) RETURN
c ************* inclusion DELA8
      IF(ANUCL.GT.55.) CALL DELA8(ANUCL,ZNUCL,DM8,SH8)
      TCOEF=1.-(ANUCL-55.)/10.
      IF(ANUCL.GT.55.AND.ANUCL.LT.65.) DM=DM1*TCOEF+DM8*(1.-TCOEF)
c *************
      RETURN
 8    PRINT 9,IZ,IN
 9    FORMAT(2X,'ERROR IN DELAM: IZ=',I5,' IN=',I5)
      RETURN
 11   CONTINUE
      SH=0.
      BARIER=1001.
      CALL ELIDR(ANUCL,ZNUCL,DM)
      DM=DM+(8.071*ANUCL-0.782*ZNUCL)
      RETURN
      END
      SUBROUTINE DELA8(X,Y,DELTA8,DSHEL8)
      DSHEL8=0.
      I=INT(X+0.5)
      J=INT(Y+0.5)
      L=I-J
      DELTA8=1001.
      IF(I.LE.1.OR.J.LE.0.OR.L.LE.0) RETURN
      X03=X**0.3333333
      X06=X03*X03
      X13=X06*X06
      Y13=Y**1.3333333
      D=(X-2.*Y)/X
      DR=1-0.62025/X06
      ES=(25.8357-44.2355*D*D)*DR*DR*X06
      EC=0.779*(Y*(Y-1.)/X03)*(1.-1.5849/X06+1.2273/X+1.5772/X13)
      EEX=-0.4323*(Y13/X03)*(1.-0.57811/X03-0.14518/X06+0.49597/X)
      EV=X*(-17.0354+31.4506*D*D)
      DELTA8=8.071*X-0.783*Y+EV+ES+EC+EEX
      RETURN
      END
      SUBROUTINE DELA1(X,Y,DELTAM,DSHEL)
C  B[[[C[EH[E (M-A) CO[[ACTHO KAMEPOH[-57 (B [[[EPO[H[X E[[H[[AX)
C XOPO[EE COOTBETCTB[E [P[ Z.LE.8 [ CO[[ACOBAH[E [P[ [O[[[[X Z
C      ([[[ [E[E[ [C[APEH[[ [[ [E[K[X [[EP [ [X CAM[X)
      COMMON /BL1001/T1Y(130) /BL1002/T2XY(200)
      I=INT(X+0.5)
      J=INT(Y+0.5)
      L=I-J
      DELTAM=1001.
      IF(J.EQ.0) DELTAM=8.071*I
      IF(L.EQ.0) DELTAM=7.289*J
      IF(J.GT.10)  GO TO 11
      IF(I.EQ.1.AND.J.EQ.0) DELTAM=8.071
      IF(J.EQ.0)   GO TO 11
      GO TO (1,2,3,4,5,6,7,8,9,10),J
 1    IF(I.EQ.1.AND.J.EQ.1) DELTAM=7.289
      IF(I.EQ.2.AND.J.EQ.1) DELTAM=13.136
      IF(I.EQ.3.AND.J.EQ.1) DELTAM=14.950
      IF(I.EQ.4.AND.J.EQ.1) DELTAM=25.920
      IF(I.EQ.5.AND.J.EQ.1) DELTAM=33.790
      GO TO 11
 2    IF(I.EQ.3.AND.J.EQ.2) DELTAM=14.931
      IF(I.EQ.4.AND.J.EQ.2) DELTAM=2.425
      IF(I.EQ.5.AND.J.EQ.2) DELTAM=28.150
      IF(I.EQ.6.AND.J.EQ.2) DELTAM=17.593
      IF(I.EQ.7.AND.J.EQ.2) DELTAM=26.111
      IF(I.EQ.8.AND.J.EQ.2) DELTAM=31.599
      GO TO 11
 3    IF(I.EQ.5.AND.J.EQ.3) DELTAM=28.340
      IF(I.EQ.6.AND.J.EQ.3) DELTAM=14.087
      IF(I.EQ.7.AND.J.EQ.3) DELTAM=14.908
      IF(I.EQ.8.AND.J.EQ.3) DELTAM=20.947
      GO TO 11
 4    IF(I.EQ.6.AND.J.EQ.4) DELTAM=18.375
      IF(I.EQ.7.AND.J.EQ.4) DELTAM=15.769
      IF(I.EQ.8.AND.J.EQ.4) DELTAM=4.942
      IF(I.EQ.9.AND.J.EQ.4) DELTAM=11.348
      IF(I.EQ.10.AND.J.EQ.4) DELTAM=12.607
      IF(I.EQ.11.AND.J.EQ.4) DELTAM=20.176
      IF(I.EQ.12.AND.J.EQ.4) DELTAM=25.072
      GO TO 11
 5    IF(I.EQ.9.AND.J.EQ.5) DELTAM=12.415
      IF(I.EQ.10.AND.J.EQ.5) DELTAM=12.052
      IF(I.EQ.11.AND.J.EQ.5) DELTAM=8.668
      IF(I.EQ.12.AND.J.EQ.5) DELTAM=13.370
      IF(I.EQ.13.AND.J.EQ.5) DELTAM=16.562
      IF(I.EQ.14.AND.J.EQ.5) DELTAM=24.230
      GO TO 11
 6    IF(I.EQ.10.AND.J.EQ.6) DELTAM=15.702
      IF(I.EQ.11.AND.J.EQ.6) DELTAM=10.650
      IF(I.EQ.12.AND.J.EQ.6) DELTAM=0.
      IF(I.EQ.13.AND.J.EQ.6) DELTAM=3.125
      IF(I.EQ.14.AND.J.EQ.6) DELTAM=3.020
      GO TO 11
 7    IF(I.EQ.13.AND.J.EQ.7) DELTAM=5.346
      IF(I.EQ.14.AND.J.EQ.7) DELTAM=2.864
      IF(I.EQ.15.AND.J.EQ.7) DELTAM=0.102
      IF(I.EQ.16.AND.J.EQ.7) DELTAM=5.683
      IF(I.EQ.17.AND.J.EQ.7) DELTAM=7.871
      IF(I.EQ.18.AND.J.EQ.7) DELTAM=13.274
      IF(I.EQ.19.AND.J.EQ.7) DELTAM=15.790
      GO TO 11
 8    IF(I.EQ.14.AND.J.EQ.8) DELTAM=8.007
      IF(I.EQ.15.AND.J.EQ.8) DELTAM=2.863
      IF(I.EQ.16.AND.J.EQ.8) DELTAM=-4.737
      IF(I.EQ.17.AND.J.EQ.8) DELTAM=-0.809
      IF(I.EQ.18.AND.J.EQ.8) DELTAM=-0.783
      IF(I.EQ.19.AND.J.EQ.8) DELTAM=3.332
      IF(I.EQ.20.AND.J.EQ.8) DELTAM=3.799
      GO TO 11
 9    IF(I.EQ.17.AND.J.EQ.9) DELTAM=1.952
      IF(I.EQ.18.AND.J.EQ.9) DELTAM=0.873
      IF(I.EQ.19.AND.J.EQ.9) DELTAM=-1.486
      IF(I.EQ.20.AND.J.EQ.9) DELTAM=-0.016
      IF(I.EQ.21.AND.J.EQ.9) DELTAM=-0.046
      GO TO 11
 10   IF(I.EQ.19.AND.J.EQ.10) DELTAM=1.752
      IF(I.EQ.20.AND.J.EQ.10) DELTAM=-7.041
 11   DSHEL=0.
      IF(I.LE.1.OR.J.LE.0.OR.L.LE.0) RETURN
      X03=X**0.3333333
      X06=X03*X03
      X13=X06*X06
      Y13=Y**1.3333333
      D=(X-2.*Y)/X
      DR=1-0.62025/X06
      ES=(25.8357-44.2355*D*D)*DR*DR*X06
      EC=0.779*(Y*(Y-1.)/X03)*(1.-1.5849/X06+1.2273/X+1.5772/X13)
      EEX=-0.4323*(Y13/X03)*(1.-0.57811/X03-0.14518/X06+0.49597/X)
      EV=X*(-17.0354+31.4506*D*D)
      IF(J.LE.0.OR.J.GT.130.OR.L.LE.0.OR.L.GT.200) GO TO 22
      T1=T1Y(J)
      T2=T2XY(L)
      GO TO 23
 22   T1=0.
      T2=0.
 23   CONTINUE
      DELTA0=8.071*X-0.783*Y+EV+ES+EC+EEX+T1+T2
      IF(DELTAM.LT.1000.) GO TO 26
      DSHEL=T1+T2
      DELTAM=DELTA0
      RETURN
 26   DSHEL=DELTAM-DELTA0+T1+T2
      RETURN
      END
      BLOCK DATA EVAP
c ** corrected tables for GAM3(): 6He,... - sum over stable excited states
c (+ allowed by liquid-drop approx.) weighted with exp(-E/4.5MeV).
c October 99, Bologna. **
C [A[A[TC[ [APAMETP[ OCTAT.[[PA,[C[AP[[[[XC[ [PA[MEHTOB,O[PATHO[O
C CE[EH[[([OCTPOBCK[[-59),O[O[O[.[O[PABK[(KAMEPOH-57)
      COMMON /BL1001/T1Y(130)/BL1002/T2XY(200)/BL1014/GAM(35)
      COMMON /BL0999/RNCL  /BL1100/AMS,AMFS /BLGAM/GAM1(35),GAM2(35)
      COMMON /BL1005/AJ(35) /BL1006/ZJ(35) /BLCAN/ICAN /BLSEC/ISEC
      COMMON /EXILEV/ ENLEV(20,35),SPLEV(20,35)
      COMMON /BL1020/GAM3(35)
      DIMENSION TT11(65),TT12(65)
      DIMENSION TT21(50),TT22(50),TT23(50),TT24(50)
      EQUIVALENCE (T1Y(1),TT11(1)),(T1Y(66),TT12(1))
      EQUIVALENCE (T2XY(1),TT21(1)),(T2XY(51),TT22(1)),(T2XY(101),
     *TT23(1)),(T2XY(151),TT24(1))
      DATA GAM3/2.,2.,6.,6.,6.,4.,20., 6.,20.,22.,41.,59.,41.,8.,
     * 36., 34., 36.,144.,141.,153., 98.,34., 95., 25., 26.,187.,171.,
     *245., 68., 74.,190.,422.,0.,994.,216./
      DATA GAM2/2.,2.,6.,6.,6.,4.,20.,30.,20.,54.,73.,101.,73.,8.,
     *146.,100.,100.,343.,174.,393.,186.,61.,202.,113.,213.,233.,180.,
     *696.,194.,120.,458.,590.,0.,2790.,216./
      DATA GAM1/2.,2.,6.,6.,6.,4.,20., 6.,20.,18.,28., 40.,28.,8.,
     * 36., 10., 36., 70., 44., 36., 44.,12., 26., 14., 26., 42., 30.,
     * 80., 30., 16.,102., 18.,0.,54.,216./
      DATA GAM/2.,2.,6.,6.,6.,4.,20., 6.,20.,18.,28., 40.,28.,8.,
     * 36., 10., 36., 70., 44., 36., 44.,12., 26., 14., 26., 42., 30.,
     * 80., 30., 16.,102., 18.,0.,54.,216./
      DATA AJ/1.,1.,2.,3.,3.,4.,5.,6.,5.,6.,7.,8.,7.,8.,9.,10.,9.,
     *10.,11.,12.,11.,12.,13.,14.,13.,14.,15.,16.,15.,16.,17.,18.,0.,
     *18.,24./
      DATA ZJ/0.,1.,1.,1.,2.,2.,2.,2.,3.,3.,3.,3.,4.,4.,4.,4.,5.,5.,
     *5.,5.,6.,6.,6.,6.,7.,7.,7.,7.,8.,8.,8.,8.,0.,9.,11./
      DATA RNCL/0./,AMS/0.125/,AMFS/0.125/,ICAN/1/,ISEC/1/
      DATA ENLEV/700*0./,SPLEV/700*0./
      DATA TT11/
     *  20.80,  15.80,  21.00,  16.80,  19.80,
     *  16.50,  18.80,  16.50,  18.50,  17.20,
     *  18.26,  15.05,  16.01,  12.04,  13.27,
     *  11.09,  12.17,  10.26,  11.04,   8.41,
     *   9.79,   7.36,   8.15,   5.63,   5.88,
     *   3.17,   3.32,   0.82,   1.83,   0.97,
     *   2.33,   1.27,   2.92,   1.61,   2.91,
     *   1.35,   2.40,   0.89,   1.74,   0.36,
     *   0.95,  -0.65,  -0.04,  -1.73,  -0.96,
     *  -2.87,  -2.05,  -4.05,  -3.40,  -5.72,
     *  -3.75,  -4.13,  -2.42,  -2.85,  -1.01,
     *  -1.33,   0.54,  -0.02,   1.74,   0.75,
     *   2.24,   1.00,   1.98,   0.79,   1.54/
      DATA TT12/
     *   0.39,   1.08,   0.00,   0.78,  -0.35,
     *   0.58,  -0.55,   0.59,  -0.61,   0.59,
     *  -0.35,   0.32,  -0.96,  -0.52,  -2.08,
     *  -2.46,  -3.64,  -1.55,  -0.96,   0.97,
     *   0.88,   2.37,   1.75,   2.72,   1.90,
     *   2.55,   1.46,   1.93,   0.86,   1.17,
     *   0.08,   0.39,  -0.76,  -0.39,  -1.51,
     *  -1.17,  -2.36,  -1.95,  -3.06,  -2.62,
     *  -3.55,  -2.95,  -3.75,  -3.07,  -3.79,
     *  -3.06,  -3.77,  -3.05,  -3.78,  -3.12,
     *  -3.90,  -3.35,  -4.24,  -3.86,  -4.92,
     *  -5.06,  -6.77,  -7.41,  -9.18, -10.16,
     * -11.12,  -9.76,  -9.23,  -7.96,  -7.65/
      DATA TT21/
     *  -8.40, -12.90,  -8.00, -11.90,  -9.20,
     * -12.50, -10.80, -13.60, -11.20, -12.20,
     * -12.81, -15.40, -13.07, -15.80, -13.81,
     * -14.98, -12.63, -13.76, -11.37, -12.38,
     *  -9.23,  -9.65,  -7.64,  -9.17,  -8.05,
     *  -9.72,  -8.87, -10.76,  -8.64,  -8.89,
     *  -6.60,  -7.13,  -4.77,  -5.33,  -3.06,
     *  -3.79,  -1.72,  -2.79,  -0.93,  -2.19,
     *  -0.52,  -1.90,  -0.45,  -2.20,  -1.22,
     *  -3.07,  -2.42,  -4.37,  -3.94,  -6.08/
      DATA TT22/
     *  -4.49,  -4.50,  -3.14,  -2.93,  -1.04,
     *  -1.36,   0.69,   0.21,   2.11,   1.33,
     *   3.29,   2.46,   4.30,   3.32,   4.79,
     *   3.62,   4.97,   3.64,   4.63,   3.07,
     *   4.06,   2.49,   3.30,   1.46,   2.06,
     *   0.51,   0.74,  -1.18,  -1.26,  -3.54,
     *  -3.97,  -5.26,  -4.18,  -3.71,  -2.10,
     *  -1.70,  -0.08,  -0.18,   0.94,   0.27,
     *   1.13,   0.08,   0.91,  -0.31,   0.49,
     *  -0.78,   0.08,  -1.15,  -0.23,  -1.41/
      DATA TT23/
     *  -0.42,  -1.55,  -0.55,  -1.66,  -0.66,
     *  -1.73,  -0.75,  -1.74,  -0.78,  -1.69,
     *  -0.78,  -1.60,  -0.75,  -1.46,  -0.67,
     *  -1.26,  -0.51,  -1.04,  -0.53,  -1.84,
     *  -2.42,  -4.52,  -4.76,  -6.33,  -6.76,
     *  -7.81,  -5.80,  -5.37,  -3.63,  -3.35,
     *  -1.75,  -1.88,  -0.61,  -0.90,   0.09,
     *  -0.32,   0.55,  -0.13,   0.70,  -0.06,
     *   0.49,  -0.20,   0.40,  -0.22,   0.36,
     *  -0.09,   0.58,   0.12,   0.75,   0.15/
      DATA TT24/
     *   0.70,   0.17,   1.11,   0.89,   1.85,
     *   1.62,   2.54,   2.29,   3.20,   2.91,
     *   3.84,   3.53,   4.48,   4.15,   5.12,
     *   4.78,   5.75,   5.39,   6.31,   5.91,
     *   6.87,   6.33,   7.13,   6.61,   7.30,
     *   6.31,   6.27,   4.83,   4.49,   2.85,
     *   2.32,   0.58,  -0.11,  -0.98,   0.81,
     *   1.77,   3.37,   4.13,   5.60,   6.15,
     *   7.29,   7.35,   7.95,   7.67,   8.16,
     *   7.83,   8.31,   8.01,   8.53,   8.27/
       END
      FUNCTION BARIE1(A,Z)
C  B[[[C[EH[E [AP[EPA [E[EH[[ [[PA A,Z (M[B)
C  ( BARASHENKOV,ILJINOV,TONEEV -1972)
      COMMON /BL1001/T1Y(130) /BL1002/T2XY(200)
      I=INT(A+0.1)
      J=INT(Z+0.1)
      L=I-J
      X=Z*Z/A
      IF(X.LE.33.5) BF0=12.5+4.7*(33.5-X)**0.75
      IF(X.GT.33.5) BF0=12.5-2.7*(X-33.5)**0.666667
      IF((2*(J/2)).LT.J) D=0.
      IF((2*(J/2)).EQ.J) D=-0.5
      IF((2*(L/2)).EQ.L) D=D
      IF((2*(L/2)).LT.L) D=D+1.
      IF(J.LE.0.OR.J.GT.130.OR.L.LE.0.OR.L.GT.200) GO TO 22
      T1=T1Y(J)
      T2=T2XY(L)
      GO TO 23
 22   T1=0.
      T2=0.
 23   CONTINUE
      BARIE1=BF0+D-T1-T2
      IF(BARIE1.LE.0.) BARIE1=0.
      RETURN
      END
      SUBROUTINE LYMASM(IZ,IA,CMASS,CBARR,NOBARR)
C
C     WILLIAM D. MYERS - 6 JULY 1970
C
      COMMON /BLOCX/ IPARQ
      COMMON /FFSS/  ENEX
      COMMON /FUSR/   BARR,SMASS,SHLL
C     COMMON /BLOCXX/ ARQ,F1Q,F1MQ,SUFNUC
C     COMMON /CCC/    WOTNUC,VOLNUC,COULMB,
C    *                A,Z,UN,A1,A2,A3,GGMMA,A3RT2,A3RT,ZSQ,
C    *                ODDEV,SYM,PARMAS,ACOR
      DIMENSION EM(10),EMP(10),XK(10),Y(2),F(2)
      DATA ZVT/1.6666666666/, ZT/.3333333333/,
     1 ZTT/.6666666667/, SR5/2.2360679775/
      DATA EM/0.00,2.00,8.00,14.00,28.00,50.00,82.00,126.00,
     1        184.00,258.00/
      DATA CAY1/0.0/, CAY2/0.0/, CAY3/2.0/, CAY4/11.0/, CAY5/8.07144/,
     * CAY6/7.28899/,
     *            D/.444/, C/5.8/, SMALC/.325/
C
C     DMASS = REMAINDER AFTER CM - NO SHELL EFFECTS SUBTRACTED
C     SHLL = CALCULATED SHELL EFFECT
C     DIFMAS= DMASS - SHLL
C
C------------------------------
      A1 = 15.4941
      IPARQ=0
C..... IPARQ=0  PARAMETRS MYERS-SWIATECKI
      IF(IPARQ.NE.0) GO TO 121
      A2 = 17.9439
      A3 = 0.7053
      GAMMA = 1.7826
      GO TO 126
 121  CONTINUE
C..... IPARQ=1  PARAMETRS KRAPPE-NIX
      IF(IPARQ.NE.1) GO TO 123
      A2 = 24.70
      A3 = 0.74476032
      GAMMA = 4.0
      GO TO 126
 123  CONTINUE
C..... IPARQ=2  PARAMETRS PAULI-LEDERGERBER
      IF(IPARQ.NE.2) GO TO 124
      A2 = 19.008
      A3 = 0.720
      GAMMA = 2.840
      GO TO 126
 124  CONTINUE
C..... IPARQ=3  BF(T)   PARAMETRS MYERS-SWIATECKI
      ALEVEL=0.1
      AMPAR=ALEVEL*FLOAT(IA)
      TSQ=ENEX/AMPAR
      A2 = 17.9439*(1.-0.0063157*TSQ)
      A3 = 0.7053*(1.-0.001*TSQ)
      GAMMA = 1.7826
 126  CONTINUE
C------------------------------
      IF(IZ.NE.0) GO TO 15
      CMASS=0.0
      RETURN
   15 NOBARR=0
      DO 1 I=1,10
      EMP(I)=EM(I)**ZVT
    1 CONTINUE
      DO 2 I=1,9
      XK(I)=.600*(EMP(I+1)-EMP(I)) /(EM(I+1)-EM(I))
    2 CONTINUE
C
C     FOR DEFINITIONS OF CAY1 AND RZ,SEE UCRL-11980
C
      CAY1=3.28637900*A3**3
      RZ=.86398700/A3
    5 Z= FLOAT(IZ)
      ZSQ=Z**2
      N=IA-IZ
      UN= FLOAT(N)
      A= FLOAT(IA)
      A3RT=A**ZT
      A3RT2=A3RT**2
      A2RT= SQRT(A)
      SYM=((UN-Z)/A)**2
      ACOR=1.00-GAMMA*SYM
      PARMAS=CAY5*UN+CAY6*Z
      VOLNUC=-A1*ACOR*A
      SUFNUC=A2*ACOR*A3RT2
      COULMB=A3*ZSQ/A3RT
      FUZSUR=-CAY1*ZSQ/A
      ODDEV=-(1.00+2.00*(N/2)-UN+2.00*(IZ/2)-Z)/A2RT*CAY4
      WTERM=-CAY2*A3RT2* EXP(-CAY3*SYM)
      WOTNUC=PARMAS+COULMB+FUZSUR+ODDEV+WTERM
      SMASS=WOTNUC+VOLNUC+SUFNUC
      SPW=SUFNUC+WTERM
      C2=SPW/A3RT2
      X=.5*COULMB/SPW
      IF(X.GE.1.00) GO TO 4
C------------------------------
      ARQ=X
      IF(IPARQ.EQ.0) BARR=SUFNUC*XI(X)
      IF(IPARQ.EQ.2) BARR=SUFNUC*XI(X)
      IF(IPARQ.EQ.3) BARR=SUFNUC*XI(X)
      IF(IPARQ.EQ.1) BARR=SUFNUC*XIMOD(X)
      IF(IPARQ.EQ.0) F1Q=XI(X)
      IF(IPARQ.EQ.1) F1MQ=XIMOD(X)
C------------------------------
      GO TO 6
    4 BARR=0.0
    6 Y(1)=UN
      Y(2)=Z
      DO 31 J=1,2
      DO 32 I=1,9
      IF(Y(J)-EM(I+1)) 3,3,32
   32 CONTINUE
c$$$      PRINT 332,J
c$$$  332 FORMAT('1FAILURE IN LYMASS - Y(',I1,') EXCEEDS LAST MAGIC NO.')
      STOP
    3 F(J)=XK(I)*(Y(J)-EM(I))-.600*(Y(J)**ZVT-EMP(I))
   31 CONTINUE
      S=(2.00/A)**ZTT*(F(1)+F(2))-SMALC*A3RT
      C2D2=C2*D**2
      EE=(C2D2+C2D2)*(1.00-X)
      FF=.425917710*C2D2*D*(1.00+X+X)/A3RT
      SSHELL=C*S
      V=SSHELL/EE
      EPS=1.500*FF/EE
      IF(EE*(1.00-3.00*V).LE.0.00) GO TO 51
      QCALC=0.00
      THETA=0.00
      SHLL=SSHELL
      GO TO 52
C
C       ESTIMATE THETA
C
   51 TO=1.00
C
C       ITERATE TO FIND EQUILIBRIUM THETA
C
  101 DO 725 IPQ=1,10
      TO2=TO**2
C----------------------------------------
C     IF (TO2.GT.170.) PRINT 500, IZ,IA
C 500 FORMAT(1X,'LYMASM',2X,2I5)
C----------------------------------------
C     EXMT2= EXP(-TO2)
      EXMT2= 1.E-20
      IF((ABS(TO2)).LT.30.) EXMT2= EXP(-TO2)
C
      T=TO-(1.00-EPS*TO-V*(3.00-TO2-TO2)*EXMT2) /
     1(-EPS+V*TO*(10.00-4.00*TO2)*EXMT2)
      IF(T.LE.0.00) GO TO 728
      IF( ABS(T-TO) .LT.1.E-4) GO TO 732
      TO=T
  725 CONTINUE
      GO TO 729
  732 T2=T**2
C     EXT2= EXP(-T2)
      EXT2= 1.E-20
      IF((ABS(T2)).LT.30.) EXT2= EXP(-T2)
C
      TEST=EE*(1.00-EPS*(T+T)-V*((4.00*T2-12.00)*T2+3.00)* EXT2)
      IF(TEST.GT.0.00) GO TO 81
  728 TO=.100
      DO 100 I=1,20
      TO2=TO**2
      GL=EE*(1.00-EPS*TO-V*(3.00-TO2-TO2)* EXP(-TO2))
      IF(GL.GT.0.00) GO TO 101
  100 CONTINUE
  729 CMASS=SMASS
      CBARR=0.00
      NOBARR=1
      RETURN
   81 THETA=T
      ALPHA0=D*SR5/A3RT
      ALPHA=ALPHA0*THETA
      SIGMA=ALPHA*(1.00+ALPHA/14.00)
      EXS= EXP(SIGMA+SIGMA)- EXP(-SIGMA)
      QCALC=4.E-3*Z*(RZ*A3RT)**2*EXS
      T2=T**2
      SHLL=T2*(EE-FF*T) + SSHELL*(1.00-T2-T2)* EXP(-T2)
   52 CMASS=SMASS+SHLL
      CBARR=BARR-SHLL
      RETURN
      END
      FUNCTION XI(Z)
C
C     6-POINT LAGRANGE INTERPOLATION
C
      DIMENSION Y(51)
      DATA Y/.25900,.255200,.250700,.245100,.2400,.23400,.228500,
     1      .22200,.21600,.2100,.20300,.196800,.1900,.18300,.175800,
     2      .1692400,.1620300,.1547800,.147500,.1401900,.1328400,
     3      .1254500,.1180100,.1105200,.1029600,.0953500,.0876800,
     4      .0799900,.0722900,.064600,.0569500,.0493700,.0419300,
     5      .0347600,.0281100,.0223600,.0176200,.0137300,.0105600,
     6      .0079800,.0059100,.0042500,.0029600,.0019700,.0012300,
     7      7.1E-4,3.6E-4,1.5E-4,4.E-5,1.E-5,0.00/
C
C     THE X VALUES ARE EVENLY SPACED - X = 0(.02)1
C
      ZBH=Z*50.00
      M=IFIX(ZBH)
      DEL=ZBH- FLOAT(M)
      M=M+1
      IF(M.LE.51) GO TO 105
      M=51
  100 XI=Y(M)
      RETURN
  105 IF (DEL.LT.1.E-4) GO TO 100
      IF(M.GE.3) GO TO 110
      DEL=DEL- FLOAT(3-M)
      M=3
      GO TO 115
  110 IF(M.LE.48) GO TO 115
      DEL=DEL+ FLOAT(M-48)
      M=48
  115 DM3=DEL-3.00
      PROD=DM3*DEL
      W6=1.00/(1.2E2*DM3)
      DM2=DM3+1.00
      PROD=DM2*PROD
       W5=-1.00/(24.00*DM2)
      DM1=DM2+1.00
      PROD=DM1*PROD
      W4=1.00/(12.00*DM1)
      DP1=DM1+2.00
      PROD=DP1*PROD
      W2=1.00/(24.00*DP1)
      DP2=DP1+1.00
      PROD=DP2*PROD
      W1=-1.00/(1.2E2*DP2)
      W3=-1.00/(12.00*DEL)
      XI=PROD*(W1*Y(M-2)+W2*Y(M-1)+W3*Y(M)+W4*Y(M+1)+W5*Y(M+2)
     1 +W6*Y(M+3))
      RETURN
      END
      FUNCTION XIMOD(Z)
C
C     6-POINT LAGRANGE INTERPOLATION
C      IN MODIFIED LIQUID-DROP FORMULA
C         ( KRAPPE [ NIX --  IAEA-SM-174/12 )
C
      DIMENSION Y(51)
      DATA  Y/
     1    0.12200, 0.12100, 0.11980, 0.11830, 0.11690, 0.11520, 0.1133,
     2    0.11130, 0.10900, 0.10670, 0.10420, 0.10150, 0.09850, 0.09540,
     3    0.09180, 0.08780, 0.08350, 0.07900, 0.07460, 0.06960, 0.06470,
     4    0.05960, 0.05420, 0.04880, 0.04350, 0.03880, 0.03400, 0.02920,
     5    0.02460, 0.02020, 0.01580, 0.01220, 0.00900, 0.00660, 0.00490,
     6    0.00360, 0.00280, 0.00220, 0.00180, 0.00140, 0.00100, 0.00090,
     7    0.00060, 0.00040, 0.00020, 0.00010, 0.00000, 0.00000, 0.00000,
     8    0.00000, 0.00000/
C
C     THE X VALUES ARE EVENLY SPACED - X = 0(.02)1
C
      ZBH=Z*50.00
      M=IFIX(ZBH)
      DEL=ZBH- FLOAT(M)
      M=M+1
      IF(M.LE.51) GO TO 105
      M=51
  100 XIMOD=Y(M)
      RETURN
  105 IF (DEL.LT.1.E-4) GO TO 100
      IF(M.GE.3) GO TO 110
      DEL=DEL- FLOAT(3-M)
      M=3
      GO TO 115
  110 IF(M.LE.48) GO TO 115
      DEL=DEL+ FLOAT(M-48)
      M=48
  115 DM3=DEL-3.00
      PROD=DM3*DEL
      W6=1.00/(1.2E2*DM3)
      DM2=DM3+1.00
      PROD=DM2*PROD
       W5=-1.00/(24.00*DM2)
      DM1=DM2+1.00
      PROD=DM1*PROD
      W4=1.00/(12.00*DM1)
      DP1=DM1+2.00
      PROD=DP1*PROD
      W2=1.00/(24.00*DP1)
      DP2=DP1+1.00
      PROD=DP2*PROD
      W1=-1.00/(1.2E2*DP2)
      W3=-1.00/(12.00*DEL)
      XIMOD=PROD*(W1*Y(M-2)+W2*Y(M-1)+W3*Y(M)+W4*Y(M+1)+W5*Y(M+2)
     1 +W6*Y(M+3))
      RETURN
      END

c **** random number generator for kiae-computer *****

C***************** GGUBFS     *******************************
C   IMSL ROUTINE NAME   - GGUBFS
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - DG7/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1980
C
C   PURPOSE             - BASIC UNIFORM (0,1) RANDOM NUMBER GENERATOR
C                           FUNCTION FORM OF GGUBS
C
C   USAGE               - FUNCTION GGUBFS()
C
C   ARGUMENTS    GGUBFS - RESULTANT DEVIATE.
C                DSEED  - INPUT/OUTPUT DOUBLE PRECISION VARIABLE
C                           ASSIGNED AN INTEGER VALUE IN THE
C                           EXCLUSIVE RANGE (1.D0, 2147483647.D0).
C                           DSEED IS REPLACED BY A NEW VALUE TO BE
C                           USED IN A SUBSEQUENT CALL.
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      REAL FUNCTION GGUBFS()
#ifndef SMM_USE_USER_RNG
C                                  SPECIFICATIONS FOR ARGUMENTS
      DOUBLE PRECISION   DSEED
      COMMON /EE/   DSEED,RANCL,ISEED
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DOUBLE PRECISION   D2P31M,D2P31
C                                  D2P31M=(2**31) - 1
C                                  D2P31 =(2**31)(OR AN ADJUSTED VALUE)
      DATA               D2P31M/2147483647.D0/
      DATA               D2P31 /2147483711.D0/
      SAVE D2P31M,D2P31
C                                  FIRST EXECUTABLE STATEMENT
      DSEED = DMOD(16807.D0*DSEED,D2P31M)
      GGUBFS = DSEED / D2P31
      RANCL = RANCL + 1.
      RETURN
#else
      ggubfs = smmuserrng()
      return
#endif
      END

      FUNCTION RNDMSMM(IX)
      DOUBLE PRECISION   DSEED
      COMMON /EE/   DSEED,RANCL,ISEED
      RNDMSMM=GGUBFS()
      RETURN
      END

      SUBROUTINE RNDM1(I)
      DOUBLE PRECISION   DSEED
      COMMON /EE/   DSEED,RANCL,ISEED
      ISEED=I
      IF(ISEED.EQ.0) ISEED=711
      DSEED=DBLE(ISEED)
      RETURN
      END

      SUBROUTINE DISNE0(INET,IP0,AMP,PN0,T,TN)
c *** implem.of flow.and rotat. EFLOW, EMOM in GeV/N. ANMOM in h-bar ***
C HAXO[[EH[E [HEP[[[ [ [M[[[[COB INET HE[TPOHOB [O [X TEM[EPAT[PE T(MEV)
C [O[HO[ K[H.[HEP[[[ TN(GEV),C[[TA[ PAC[PE[E[EH[E MAKCBE[OBCK[M. AMP(IP0
C -[X MACC[ (B GEV);[M[[[[C[ (GEV/C),B C[MME [A[[[E 0,[O[AB[[[TC[ B MACC
C PN0(3,500) C (IP0+1).
c -- Correction Dec 03 TAMU : at IAMOM>0 changing signs of rotat.velocities 
c (+VZ,-VY) - since rotation (angular momentum) is assumed along X axis. 
      COMMON /BLFLOW/A00,EFLOW,IFLOW /BLFLCM/ALF0,FLOWC,XCM,YCM,ZCM
      COMMON /BLAMOM/ANMOM,EMOM,IAMOM /BLAMCM/BMOM,WR,EMOMC
      COMMON /BLPAT/PA(500),PAZ(500),IPT
      COMMON /BLCEN/XC(500),YC(500),ZC(500)
      DIMENSION AMP(500),PN0(3,500),ANL(3),PX(500),PY(500),PZ(500)
      DIMENSION PI(3),PJ(3),PN(3),AR(3),BR(3),VV(3)
      IF(INET.LE.0) RETURN
      IP01=IP0+1
      IP0M=IP0+INET
      IF(INET-1) 1,1,2
 1    P=SQRT(2.*AMP(IP01)*TN)
      CALL ISOTR(ANL)
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(IP01)-XCM)
      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(IP01)-YCM)
      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(IP01)-ZCM)
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(IP01)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(IP01)-ZCM)
      PN0(1,IP01)=P*ANL(1)+AMP(IP01)*VV(1)
      PN0(2,IP01)=P*ANL(2)+AMP(IP01)*VV(2)
      PN0(3,IP01)=P*ANL(3)+AMP(IP01)*VV(3)
      RETURN
 2    IF(INET-2) 3,3,4
 3    P=SQRT(2.*(AMP(IP01)*AMP(IP0M)/(AMP(IP01)+AMP(IP0M)))*TN)
      CALL ISOTR(ANL)
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(IP01)-XCM)
      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(IP01)-YCM)
      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(IP01)-ZCM)
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(IP01)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(IP01)-ZCM)
      PN0(1,IP01)=P*ANL(1)+AMP(IP01)*VV(1)
      PN0(2,IP01)=P*ANL(2)+AMP(IP01)*VV(2)
      PN0(3,IP01)=P*ANL(3)+AMP(IP01)*VV(3)
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(IP0M)-XCM)
      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(IP0M)-YCM)
      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(IP0M)-ZCM)
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(IP0M)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(IP0M)-ZCM)
      PN0(1,IP0M)=-P*ANL(1)+AMP(IP0M)*VV(1)
      PN0(2,IP0M)=-P*ANL(2)+AMP(IP0M)*VV(2)
      PN0(3,IP0M)=-P*ANL(3)+AMP(IP0M)*VV(3)
      RETURN
 4    IP0M2=IP0M-2
      ES=0.
      PSX=0.
      PSY=0.
      PSZ=0.
      FEMT=SQRT(0.5*T)*EXP(-0.5)
      DO 5 I=IP01,IP0M2
 7    E=RNDMSMM(-1)*9.*T
      FE=SQRT(E)*EXP(-E/T)
      FERAND=RNDMSMM(-1)*FEMT
      IF(FERAND-FE) 6,6,7
 6    P=SQRT(2.*E*0.001*AMP(I))
      CALL ISOTR(ANL)
      PX(I)=P*ANL(1)
      PY(I)=P*ANL(2)
      PZ(I)=P*ANL(3)
      ES=ES+E*0.001
      PSX=PSX+PX(I)
      PSY=PSY+PY(I)
      PSZ=PSZ+PZ(I)
 5    CONTINUE
      I1=IP0M2+1
      I2=IP0M2+2
      PPX=-PSX
      PPY=-PSY
      PPZ=-PSZ
      P=SQRT(PPX*PPX+PPY*PPY+PPZ*PPZ)
      EE=TN-ES
      EM=P*P/(2.*(AMP(I1)+AMP(I2)))
      IF(EE.LE.EM) GO TO 4
      H=1.+AMP(I2)/AMP(I1)
      CTM12=H*(1.-2.*AMP(I2)*EE/(P*P))
 11   CT1=1.-2.*RNDMSMM(-1)
      IF(CT1*CT1-CTM12) 11,11,12
 12   IF(CTM12) 13,17,17
 13   IZN=1
      GO TO 15
 17   IF(CT1) 11,14,14
 14   IF(RNDMSMM(-1)-0.5) 16,16,13
 16   IZN=-1
 15   CONTINUE
      P1=(P*CT1+IZN*SQRT(P*P*CT1*CT1-P*P*CTM12))/H
      P2=SQRT(P1*P1+P*P-2.*P1*P*CT1)
      PHI=6.28318*RNDMSMM(-1)
      ST1=SQRT(1.-CT1*CT1)
      CPHI1=COS(PHI)
      SPHI1=SIN(PHI)
      CPHI2=-CPHI1
      SPHI2=-SPHI1
      CT2=(P*P+P2*P2-P1*P1)/(2.*P*P2)
      IF(CT2.GT.-1.AND.CT2.LT.1) GO TO 20
      ST2=0.
      GO TO 21
 20   ST2=SQRT(1.-CT2*CT2)
 21   CONTINUE
      PI(1)=P1*ST1*CPHI1
      PI(2)=P1*ST1*SPHI1
      PI(3)=P1*CT1
      PJ(1)=P2*ST2*CPHI2
      PJ(2)=P2*ST2*SPHI2
      PJ(3)=P2*CT2
      AR(1)=PPX
      AR(2)=PPY
      AR(3)=PPZ
      BR(1)=1.
      BR(2)=0.
      BR(3)=0.
      CALL ROTOR(AR,BR,PI,PN)
      PX(I1)=PN(1)
      PY(I1)=PN(2)
      PZ(I1)=PN(3)
      CALL ROTOR(AR,BR,PJ,PN)
      PX(I2)=PN(1)
      PY(I2)=PN(2)
      PZ(I2)=PN(3)
      PSX=PSX+PX(I1)+PX(I2)
      PSY=PSY+PY(I1)+PY(I2)
      PSZ=PSZ+PZ(I1)+PZ(I2)
      ES=ES+(PX(I1)**2+PY(I1)**2+PZ(I1)**2)/(2.*AMP(I1))
     *+(PX(I2)**2+PY(I2)**2+PZ(I2)**2)/(2.*AMP(I2))
      DO 8 I=IP01,IP0M
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(I)-XCM)
      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(I)-YCM)
      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(I)-ZCM)
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(I)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(I)-ZCM)
      PN0(1,I)=PX(I)+AMP(I)*VV(1)
      PN0(2,I)=PY(I)+AMP(I)*VV(2)
      PN0(3,I)=PZ(I)+AMP(I)*VV(3)
 8    CONTINUE
      RETURN
      END
      SUBROUTINE CULIM0(IP0,A0,ZC0,AM,CH,PN0,TEMP,ECOLB)
      DIMENSION X0(199),Y0(199),Z0(199),VX0(199),VY0(199),VZ0(199),
     *VX(199),VY(199),VZ(199),AM(500),CH(500),VN(199),RS(199),
     *PN0(3,500),PNT(3,500)
      COMMON /BLPAT/PA(500),PAZ(500),IPT
      COMMON /BLCEN/XC(500),YC(500),ZC(500)  /BLDT/DT,IT
      COMMON /BLFLOW/A00,EFLOW,IFLOW /BLFLCM/ALF0,FLOWC,XCM,YCM,ZCM
      COMMON /BLAMOM/ANMOM,EMOM,IAMOM /BLAMCM/BMOM,WR,EMOMC
      COMMON /BDIFUS/EDIFUS,IDIFUS
      DT=2.
      IP=IP0
      DO 1 I=1,IP
      X0(I)=XC(I)
      Y0(I)=YC(I)
      Z0(I)=ZC(I)
 1    CONTINUE
c      ET=1.5*IP*TEMP*0.001
      ET=1.5*(IP-1)*TEMP*0.001
      IF(IDIFUS.EQ.1) ET=ET+0.001*EDIFUS
c      CALL DISNE0(IP,0,AM,PNT,TEMP,ET)
      CALL DISN02(IP,0,AM,PNT,TEMP,ET)
      CALL ECOR02(IP,0,AM,PNT,ET)
c --- statistic on energy of hot fragments before coulomb ---
      CALL BFREN(IP,0,AM,PNT)
c -----------------------------------------------------------
      DO 40 I=1,IP
      VX0(I)=PNT(1,I)/AM(I)
      VY0(I)=PNT(2,I)/AM(I)
      VZ0(I)=PNT(3,I)/AM(I)
 40   CONTINUE
      ETT=ET
      IF(IFLOW.GE.1) ETT=ETT+FLOWC
      IF(IAMOM.GE.1) ETT=ETT+EMOMC
      CALL CULON(X0,Y0,Z0,VX0,VY0,VZ0,VX,VY,VZ,AM,CH,VN,RS,IP,ECOLB,
     *ETT)
      DO 7 I=1,IP
      PN0(1,I)=AM(I)*VX(I)
      PN0(2,I)=AM(I)*VY(I)
      PN0(3,I)=AM(I)*VZ(I)
 7    CONTINUE
      RETURN
      END
      SUBROUTINE POS0(IPT,IP0,A0,ZC0,AM,CH)
c *** implem.of flow and rotat. EFLOW, EMOM in GeV/N. ANMOM in h-bar ***
      DIMENSION AM(500),CH(500)
      COMMON /BLPAT/PA(500),PAZ(500),IP
      COMMON /BLCEN/XC(500),YC(500),ZC(500)
      COMMON /BLFLOW/A00,EFLOW,IFLOW /BLFLCM/ALF0,FLOWC,XCM,YCM,ZCM
      COMMON /BLAMOM/ANMOM,EMOM,IAMOM /BLAMCM/BMOM,WR,EMOMC
      COMMON /BLFLZ/FLZ /BLFLY/FLY
c      FLZ=1.
      A00=A0
      RN=1.17
c      RSYS=2.0*RN*(A0**0.333333)
      RSYS=1.82*RN*(A0**0.333333)
      IP=IPT
      DO 50 I=1,IP
      PA(I)=AM(I)/0.94
 50   PAZ(I)=CH(I)
c      PRINT 101,IP,(PA(I),I=1,10)
c 101  FORMAT(1x,'ip=',I3,' pa=',10F7.1)
      CALL PLACE(RSYS,RN)
      XCM=0.
      YCM=0.
      ZCM=0.
      SPA=0.
      DO 1 I=1,IP
      XCM=XCM+PA(I)*XC(I)
      YCM=YCM+PA(I)*YC(I)
      ZCM=ZCM+PA(I)*ZC(I)
      SPA=SPA+PA(I)
 1    CONTINUE
      XCM=XCM/SPA
      YCM=YCM/SPA
      ZCM=ZCM/SPA
      SMR2=0.
      BMOM=0.
      DO 2 I=1,IP
c      RAD2=(XC(I)-XCM)**2+(YC(I)-YCM)**2+(ZC(I)-ZCM)**2
c -- for nonuniform flow: along Z-axis or Y-axis
      RAD2=(XC(I)-XCM)**2+FLY*FLY*(YC(I)-YCM)**2+FLZ*FLZ*(ZC(I)-ZCM)**2
c ------------------------------------
      RZY2=(ZC(I)-ZCM)**2+(YC(I)-YCM)**2
      SMR2=SMR2+AM(I)*RAD2
      BMOM=BMOM+AM(I)*RZY2
 2    CONTINUE
      ALF0=SQRT(2.*EFLOW*A00/SMR2)
      WR=SQRT(2.*EMOM*A00/BMOM)
c      WR=(ANMOM/5.06)/BMOM
c      EMOM=0.5*BMOM*WR*WR
      ANMOM=5.06*BMOM*WR
      EMOMC=0.
      FLOWC=0.
      DO 3 I=1,IP0
c      RAD2=(XC(I)-XCM)**2+(YC(I)-YCM)**2+(ZC(I)-ZCM)**2
c -- for nonuniform flow: along Z-axis or Y-axis
      RAD2=(XC(I)-XCM)**2+FLY*FLY*(YC(I)-YCM)**2+FLZ*FLZ*(ZC(I)-ZCM)**2
c ------------------------------------
      RZY2=(ZC(I)-ZCM)**2+(YC(I)-YCM)**2
      FLOWC=FLOWC+0.5*AM(I)*RAD2*ALF0*ALF0
      EMOMC=EMOMC+0.5*AM(I)*RZY2*WR*WR
3     CONTINUE
      RETURN
      END

c ***
      SUBROUTINE THELI0
      COMMON /BHELI1/Y6LI(46),Y7LI(46),Y3HE(46),Y4HE(46),
     *Y6LI0,Y7LI0,Y3HE0,Y4HE0,NUMB
      COMMON /BHELI2/A(6),B(6),IA1(6),IZ1(6),IA2(6),IZ2(6)
      COMMON /BHELI3/Y1(6),Y11(6),Y2(6),Y21(6)
      COMMON /BHELI4/Y1F(6),Y11F(6),Y2F(6),Y21F(6)
      COMMON /BHELI5/Y1E(6),Y11E(6),Y2E(6),Y21E(6)
      COMMON /BHELI6/Y1M(6),Y11M(6),Y2M(6),Y21M(6)
      COMMON /BLIBE/Y8LI0,Y7BE0,Y9BE0
      NUMB=0
      Y6LI0=0.
      Y7LI0=0.
      Y3HE0=0.
      Y4HE0=0.
      Y8LI0=0.
      Y7BE0=0.
      Y9BE0=0.
      DO 121 I=1,46
      Y6LI(I)=0.
      Y7LI(I)=0.
      Y3HE(I)=0.
      Y4HE(I)=0.
 121  CONTINUE
c --- ratio: R12=(Y(A1,Z1)/Y(A1+1,Z1))/(Y(A2,Z2)/Y(A2+1,Z2))
c --- assumption: R12=(1/a)*exp(B/T) , a - spin and mass factor, 
c --- B=BE(A1,Z1)-BE(A1+1,Z1)-BE(A2,Z2)+BE(A2+1,Z2) (Huang,Xi,Lynch,Tsang,...)
c   6,7-Li/3,4-He   : a=2.18 , B=13.32 (MeV)
c   9,10-Be/3,4-He  : a=0.38 , B=13.76
c   2,3-H/3,4-He    : a=1.59 , B=14.29
c   11,12-B/3,4-He  : a=1.11 , B=17.20  corrected
c   10,11-B/3,4-He  : a=0.86 , B= 9.12  corrected
c   7,8-Li/3,4-He   : a=1.98 , B=18.54
      DO 122 I=1,6
      Y1(I)=0.
      Y11(I)=0.
      Y2(I)=0.
      Y21(I)=0.
      Y1F(I)=0.
      Y11F(I)=0.
      Y2F(I)=0.
      Y21F(I)=0.
      Y1E(I)=0.
      Y11E(I)=0.
      Y2E(I)=0.
      Y21E(I)=0.
      Y1M(I)=0.
      Y11M(I)=0.
      Y2M(I)=0.
      Y21M(I)=0.
 122  CONTINUE
      RETURN
      END
      BLOCK DATA THELI
      COMMON /BHELI2/A(6),B(6),IA1(6),IZ1(6),IA2(6),IZ2(6)
      DATA A/ 2.18, 0.38, 1.59, 1.11, 0.86, 1.98/
      DATA B/13.32,13.76,14.29,17.20, 9.12,18.54/
      DATA IA1/ 6, 9, 2,11,10, 7/
      DATA IA2/ 3, 3, 3, 3, 3, 3/
      DATA IZ1/ 3, 4, 1, 5, 5, 3/
      DATA IZ2/ 2, 2, 2, 2, 2, 2/
      END
      SUBROUTINE THELIP
      COMMON /BLFINL/A0F,Z0F,E0F,TF,FL,SRF,WW3F
      COMMON /BHELI1/Y6LI(46),Y7LI(46),Y3HE(46),Y4HE(46),
     *Y6LI0,Y7LI0,Y3HE0,Y4HE0,NUMB
      COMMON /BHELI3/Y1(6),Y11(6),Y2(6),Y21(6)
      COMMON /BHELI4/Y1F(6),Y11F(6),Y2F(6),Y21F(6)
      COMMON /BHELI5/Y1E(6),Y11E(6),Y2E(6),Y21E(6)
      COMMON /BHELI6/Y1M(6),Y11M(6),Y2M(6),Y21M(6)
      COMMON /BLIBE/Y8LI0,Y7BE0,Y9BE0
      DIMENSION TX(40)
c      PRINT 13,A0F,Z0F,E0F,TF
c 13   FORMAT(2X,' A0F,Z0F=',2F6.1,'   E0F, TF =',2F9.3)
c      PRINT 1,NUMB
c  1   FORMAT(1X,'in THELI :',
c     *'  numb.of anal.ev. NUMB=',I7)
c      PRINT 8
c 8    FORMAT(1X,'yield of 3-He in excit.energy (MeV/N) ',
c     *' (from 0 to 20, step-0.5)   Y3HE:')
c      PRINT 5,(Y3HE(I),I=1,40)
c      PRINT 9,(Y3HE(I),I=41,46)
c      PRINT 10
c 10   FORMAT(1X,'yield of 4-He in excit.energy (MeV/N) ',
c     *' (from 0 to 20, step-0.5)   Y4HE:')
c      PRINT 5,(Y4HE(I),I=1,40)
c      PRINT 9,(Y4HE(I),I=41,46)
c      PRINT 11
c 11   FORMAT(1X,'yield of 6-Li in excit.energy (MeV/N) ',
c     *' (from 0 to 20, step-0.5)   Y6LI:')
c      PRINT 5,(Y6LI(I),I=1,40)
c      PRINT 9,(Y6LI(I),I=41,46)
c      PRINT 12
c 12   FORMAT(1X,'yield of 7-Li in excit.energy (MeV/N) ',
c     *' (from 0 to 20, step-0.5)   Y7LI:')
c      PRINT 5,(Y7LI(I),I=1,40)
c      PRINT 9,(Y7LI(I),I=41,46)
      DO 2 I=1,40
      TX(I)=0.
      XX=0.
      IF(Y6LI(I).GT.0.AND.Y7LI(I).GT.0.AND.Y3HE(I).GT.0.AND.
     *Y4HE(I).GT.0) XX=(Y6LI(I)*Y4HE(I))/(Y7LI(I)*Y3HE(I))
      IF(XX.GT.0.) TX(I)=16./(ALOG(2.18*XX))
 2    CONTINUE
c      PRINT 3
c 3    FORMAT(2X,'HE-LI Temperature(MeV) in excit.energy(MeV/N).'
c     *' (from 0 to 20, step-0.5)  TX:')
c      PRINT 4,(TX(I),I=1,40)
 4    FORMAT(1X,10F8.2)
 5    FORMAT(1X,10F8.0)
 9    FORMAT(1X,6F13.3)
c      PRINT 16,Y6LI0,Y8LI0,Y7BE0,Y9BE0
c 16   FORMAT(2X,'total yields: Y6LI0=',F7.0,'  Y8LI0=',F7.0,
c     *'  Y7BE0=',F6.0,'  Y9BE0=',F6.0)
      TEMBL0=0.
      XX0=0.
      IF(Y6LI0.GT.0.AND.Y7BE0.GT.0.AND.Y8LI0.GT.0.AND.
     *Y9BE0.GT.0) XX0=(Y9BE0*Y6LI0)/(Y7BE0*Y8LI0)
      IF(XX0.GT.0.) TEMBL0=11.3/(ALOG(1.76*XX0))
c      PRINT 17,TEMBL0
c 17   FORMAT(1X,'avr. Be-Li temperat.: TEMBL0=',F8.3)
c      PRINT 6,Y3HE0,Y4HE0,Y6LI0,Y7LI0
c 6    FORMAT(2X,'total yields: Y3HE0=',F7.0,'  Y4HE0=',F7.0,
c     *'  Y6LI0=',F6.0,'  Y7LI0=',F6.0)
      TEMHL0=0.
      XX0=0.
      IF(Y6LI0.GT.0.AND.Y7LI0.GT.0.AND.Y3HE0.GT.0.AND.
     *Y4HE0.GT.0) XX0=(Y6LI0*Y4HE0)/(Y7LI0*Y3HE0)
      IF(XX0.GT.0.) TEMHL0=16./(ALOG(2.18*XX0))
c      PRINT 7,TEMHL0
c 7    FORMAT(1X,'avr. He-Li temperat.(*1.2): TEMHL0=',F7.2,
c     *3X,'summary yields & temperatures:')
      CALL TISOT(Y1,Y11,Y2,Y21)
c      PRINT 30
c 30   FORMAT(1X,'yields & temperatures at freezout (multifragm.):')
c      CALL TISOT(Y1M,Y11M,Y2M,Y21M)
c      PRINT 31
c 31   FORMAT(1X,'yields & temperatures after fermi-break-up :')
c      CALL TISOT(Y1F,Y11F,Y2F,Y21F)
c      PRINT 32
c 32   FORMAT(1X,'yields & temperatures after evaporation :')
c      CALL TISOT(Y1E,Y11E,Y2E,Y21E)
      RETURN
      END
      SUBROUTINE TISOT(Y1,Y11,Y2,Y21)
      COMMON /BHELI2/A(6),B(6),IA1(6),IZ1(6),IA2(6),IZ2(6)
      DIMENSION Y1(6),Y11(6),Y2(6),Y21(6),RISO(6),TISO(6)
 15   FORMAT(11X,6(F7.0,1X))
c      PRINT 14
c 14   FORMAT(1X,'yields of ','  6-Li',3X,' 9-Be',3X,'  2-H',3X,
c     *' 11-B',3X,' 10-B',3X,' 7-Li') 
c      PRINT 15,(Y1(L),L=1,6)
c      PRINT 16
c 16   FORMAT(1X,'yields of ','  7-Li',3X,'10-Be',3X,'  3-H',3X,
c     *' 12-B',3X,' 11-B',3X,' 8-Li') 
c      PRINT 15,(Y11(L),L=1,6)
c      PRINT 17
c 17   FORMAT(1X,'yields of ','  3-He',3X,' 3-He',3X,' 3-He',3X,
c     *' 3-He',3X,' 3-He',3X,' 3-He') 
c      PRINT 15,(Y2(L),L=1,6)
c      PRINT 18
c 18   FORMAT(1X,'yields of ','  4-He',3X,' 4-He',3X,' 4-He',3X,
c     *' 4-He',3X,' 4-He',3X,' 4-He') 
c      PRINT 15,(Y21(L),L=1,6)
      DO 19 L=1,6
      TISO(L)=0.
      RISO(L)=0.
      IF(Y1(L).EQ.0.OR.Y11(L).EQ.0.OR.Y2(L).EQ.0.OR.Y21(L).EQ.0) 
     *GO TO 19
      RISO(L)=(Y1(L)/Y11(L))/(Y2(L)/Y21(L))
      TISO(L)=B(L)/ALOG(A(L)*RISO(L))
 19   CONTINUE
c$$$      PRINT 20,(RISO(L),L=1,6)
c$$$ 20   FORMAT(1X,'isotop.ratio RISO(1-6)=',6F8.3)
c$$$      PRINT 21,(TISO(L),L=1,6)
c$$$ 21   FORMAT(1X,'isot.temper. TISO(MeV)=',6F8.3)
      RETURN
      END
      SUBROUTINE THELI1(KSTART)
      COMMON /BLOKC/SPT(10,500) /BLFINL/A0F,Z0F,E0F,TF,FL,SRF,WW3F
      COMMON /BENTRO/SSR
      COMMON /BHELI1/Y6LI(46),Y7LI(46),Y3HE(46),Y4HE(46),
     *Y6LI0,Y7LI0,Y3HE0,Y4HE0,NUMB
      COMMON /BHELI2/A(6),B(6),IA1(6),IZ1(6),IA2(6),IZ2(6)
      COMMON /BHELI3/Y1(6),Y11(6),Y2(6),Y21(6)
      COMMON /BHELI4/Y1F(6),Y11F(6),Y2F(6),Y21F(6)
      COMMON /BHELI5/Y1E(6),Y11E(6),Y2E(6),Y21E(6)
      COMMON /BHELI6/Y1M(6),Y11M(6),Y2M(6),Y21M(6)
      COMMON /BLIBE/Y8LI0,Y7BE0,Y9BE0
      KST1=KSTART-1
      IF(KST1.LT.1) GO TO 410
      IF(A0F.LT.0.) GO TO 410
c      PRINT 8,A0F,E0F
c 8    FORMAT(1X,' in THELI,  BREAK UP.  A0F, E0F =',F6.1,F9.3)
      UA=E0F
      DO 105 J=1,KST1
c      PRINT 7,(SPT(JPER,J),JPER=1,10)
c 7    FORMAT(1X,'SPT=',10F8.3)
      IZ=INT(SPT(8,J)+0.5)
      IA=INT(SPT(9,J)/0.94+0.5)
      IF(IA.EQ.4.AND.IZ.EQ.2) Y4HE0=Y4HE0+1.
      IF(IA.EQ.3.AND.IZ.EQ.2) Y3HE0=Y3HE0+1.
      IF(IA.EQ.6.AND.IZ.EQ.3) Y6LI0=Y6LI0+1.
      IF(IA.EQ.7.AND.IZ.EQ.3) Y7LI0=Y7LI0+1.
      IF(IA.EQ.8.AND.IZ.EQ.3) Y8LI0=Y8LI0+1.
      IF(IA.EQ.7.AND.IZ.EQ.4) Y7BE0=Y7BE0+1.
      IF(IA.EQ.9.AND.IZ.EQ.4) Y9BE0=Y9BE0+1.
      IF(IA.EQ.4.AND.IZ.EQ.2) 
     *CALL HIST1(UA,0.,20.,0.5,Y4HE,46,1.)
      IF(IA.EQ.3.AND.IZ.EQ.2) 
     *CALL HIST1(UA,0.,20.,0.5,Y3HE,46,1.)
      IF(IA.EQ.6.AND.IZ.EQ.3) 
     *CALL HIST1(UA,0.,20.,0.5,Y6LI,46,1.)
      IF(IA.EQ.7.AND.IZ.EQ.3) 
     *CALL HIST1(UA,0.,20.,0.5,Y7LI,46,1.)
 105  CONTINUE
      NUMB=NUMB+1
      DO 106 J=1,KST1
      IZ=INT(SPT(8,J)+0.5)
      IA=INT(SPT(9,J)/0.94+0.5)
      ILAB=INT(SPT(2,J)+0.1)
      DO 107 L=1,6
      IF(IA.EQ.IA1(L).AND.IZ.EQ.IZ1(L)) Y1(L)=Y1(L)+1.
      IF(IA.EQ.(IA1(L)+1).AND.IZ.EQ.IZ1(L)) Y11(L)=Y11(L)+1.
      IF(IA.EQ.IA2(L).AND.IZ.EQ.IZ2(L)) Y2(L)=Y2(L)+1.
      IF(IA.EQ.(IA2(L)+1).AND.IZ.EQ.IZ2(L)) Y21(L)=Y21(L)+1.
      IF(ILAB) 108,108,109
 108  IF(IA.EQ.IA1(L).AND.IZ.EQ.IZ1(L)) Y1M(L)=Y1M(L)+1.
      IF(IA.EQ.(IA1(L)+1).AND.IZ.EQ.IZ1(L)) Y11M(L)=Y11M(L)+1.
      IF(IA.EQ.IA2(L).AND.IZ.EQ.IZ2(L)) Y2M(L)=Y2M(L)+1.
      IF(IA.EQ.(IA2(L)+1).AND.IZ.EQ.IZ2(L)) Y21M(L)=Y21M(L)+1.
      GO TO 107
 109  IF(ILAB-1) 110,110,111
 110  IF(IA.EQ.IA1(L).AND.IZ.EQ.IZ1(L)) Y1F(L)=Y1F(L)+1.
      IF(IA.EQ.(IA1(L)+1).AND.IZ.EQ.IZ1(L)) Y11F(L)=Y11F(L)+1.
      IF(IA.EQ.IA2(L).AND.IZ.EQ.IZ2(L)) Y2F(L)=Y2F(L)+1.
      IF(IA.EQ.(IA2(L)+1).AND.IZ.EQ.IZ2(L)) Y21F(L)=Y21F(L)+1.
      GO TO 107
 111  IF(ILAB-2) 112,112,107
 112  IF(IA.EQ.IA1(L).AND.IZ.EQ.IZ1(L)) Y1E(L)=Y1E(L)+1.
      IF(IA.EQ.(IA1(L)+1).AND.IZ.EQ.IZ1(L)) Y11E(L)=Y11E(L)+1.
      IF(IA.EQ.IA2(L).AND.IZ.EQ.IZ2(L)) Y2E(L)=Y2E(L)+1.
      IF(IA.EQ.(IA2(L)+1).AND.IZ.EQ.IZ2(L)) Y21E(L)=Y21E(L)+1.
 107  CONTINUE
 106  CONTINUE
 410  CONTINUE
      RETURN
      END
      SUBROUTINE RELCOR(IP,AMP,ZMP,PN0)
c recalculation of nonrelativistic momenta into relativistic 
c ones using kinetic energy of fragments found in nonrelat.way
      COMMON /BLERR/ERRMI,ERRMA,ERRFR,ERRRE 
      DIMENSION AMP(500),ZMP(500),PN0(3,500),P(3)
      TKS=0.
      CMS=0.
      TK2=0.
      P11=0.
      P12=0.
      P13=0.
      P21=0.
      P22=0.
      P23=0.
      V10=0.
      V20=0.
      DO 1 I=1,IP
      P(1)=PN0(1,I)
      P(2)=PN0(2,I)
      P(3)=PN0(3,I)
      P11=P11+P(1)
      P12=P12+P(2)
      P13=P13+P(3)
      CM=AMP(I)
      CMS=CMS+CM
      PQ=P(1)**2+P(2)**2+P(3)**2
      V10=V10+SQRT(PQ)/CM
      T=PQ/(2.*CM)
      TKS=TKS+T
 1    CONTINUE
c *** calc. coef. ALF for new momenta ***
      E0S=CMS+TKS
      HALF=0.1
      ALF=1.
      KK=0
      K1=0
      K2=0
      ID=0
 24   CONTINUE
      E0T=0.
      DO 10 IT=1,IP
      P00=PN0(1,IT)**2+PN0(2,IT)**2+PN0(3,IT)**2
      E0T=E0T+SQRT(AMP(IT)**2+(ALF**2)*P00)
 10   CONTINUE
      KK=KK+1
      D=(E0S-E0T)/E0S
c      PRINT 60,KK,K1,K2,ID,D,IP,ALF,E0S,E0T
c   60 FORMAT(2X,' *** KK,K1,K2=',3I3,' ID=',I2,' D=',E12.5,' IP=',
c     *I3,' ALF=',F5.2,' E0S,E0T=',2F8.3)
      IF(ABS(D).LT.0.001) GO TO 25
      IF(KK.GT.60.OR.ID.GT.30) GO TO 61
      H=SIGN(HALF,D)
      IF(D) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      ALF=ALF+H/2**ID
      GO TO 24
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      ALF=ALF+H/2**ID
      GO TO 24
   61 ERRRE=ERRRE+1
      PRINT 62,KK,ID,D,IP,ALF
   62 FORMAT(5X,'ERROR IN RELCOR  KK=',I2,' ID=',I2,' D=',E12.5,' IP=',
     *I3,' ALF=',F8.3)
      ALF=1.
 25   CONTINUE
c *************************
      DO 4 I=1,IP
      PN0(1,I)=ALF*PN0(1,I)
      PN0(2,I)=ALF*PN0(2,I)
      PN0(3,I)=ALF*PN0(3,I)
      P(1)=PN0(1,I)
      P(2)=PN0(2,I)
      P(3)=PN0(3,I)
      CM=AMP(I)
      P21=P21+P(1)
      P22=P22+P(2)
      P23=P23+P(3)
      PQ=P(1)**2+P(2)**2+P(3)**2
      TK2=TK2+PQ/(2.*CM)
      CM0=SQRT(PQ+CM**2)
      V20=V20+SQRT(PQ)/CM0
 4    CONTINUE
c      PRINT 2, IP,ALF,CMS,TKS,TK2,P11,P12,P13,P21,P22,P23
c 2    FORMAT(2X,'IP=',I3,' ALF=',F5.2,' CMS=',F8.3,
c     *' relat.transf.: TKS,TK2=',2F8.3,
c     *' P11,P12,P13=',3F8.3,' P21,P22,P23=',3F8.3)
      V10=V10/FLOAT(IP)
      V20=V20/FLOAT(IP)
c      PRINT 3, V10,V20
c 3    FORMAT(2X,' nonrelat.: V10=',F8.3,' relat.: V20=',F8.3)
      RETURN
      END
      SUBROUTINE DMR00
c ... Y0(1-Z0) - yield of fragm. at M_imf=0
c ... YF(1-10,1-Z0) - yield of fragm. at M_imf=1,2,3,4,5,6,7,8,10
c ... R23(1-Z0) = YF(2,1-Z0)/YF(3,1-Z0)
      COMMON /BDMR1/Y0(100),YF(10,100),YFS(10),MULT(20)
      COMMON /BDMR2/R12(100),R23(100),R34(100),R45(100)
     *,R56(100),R67(100),R78(100),R89(100)
      COMMON /BDMR3/Y0T(100),YFT(10,100),YFST(10)
      COMMON /BDMR4/R12T(100),R23T(100),R34T(100),R45T(100)
     *,R56T(100),R67T(100),R78T(100),R89T(100)
      COMMON /BDMR5/ZMAX,ZMA(10),ZIMF0,ZIMF(10),NIMF(10),NUMB,NIMF0
     *,ZMAI(10),ZMA2(10),EZ6(10),YZ6(10)
      ZMAX=0.
      ZIMF0=0.
      NUMB=0
      NIMF0=0
      DO 1 I=1,100
      IF(I.LE.20) MULT(I)=0
      IF(I.LE.10) YFS(I)=0.
      IF(I.LE.10) YFST(I)=0.
      IF(I.LE.10) ZMA(I)=0.
      IF(I.LE.10) NIMF(I)=0
      IF(I.LE.10) ZIMF(I)=0.
      IF(I.LE.10) ZMAI(I)=0.
      IF(I.LE.10) ZMA2(I)=0.
      IF(I.LE.10) EZ6(I)=0.
      IF(I.LE.10) YZ6(I)=0.
      Y0(I)=0.
      Y0T(I)=0.
      R12(I)=0.
      R23(I)=0.
      R34(I)=0.
      R45(I)=0.
      R56(I)=0.
      R67(I)=0.
      R78(I)=0.
      R89(I)=0.
      R12T(I)=0.
      R23T(I)=0.
      R34T(I)=0.
      R45T(I)=0.
      R56T(I)=0.
      R67T(I)=0.
      R78T(I)=0.
      R89T(I)=0.
      DO 1 J=1,10
      YF(J,I)=0.
      YFT(J,I)=0.
 1    CONTINUE
      RETURN
      END
      SUBROUTINE DMR
      COMMON /BDMR0/
     *PXX(200),PYY(200),PZZ(200),IAA(200),IZZ(200),NFRAG1
      COMMON /BDMR1/Y0(100),YF(10,100),YFS(10),MULT(20)
      COMMON /BDMR2/R12(100),R23(100),R34(100),R45(100)
     *,R56(100),R67(100),R78(100),R89(100)
      COMMON /BDMR3/Y0T(100),YFT(10,100),YFST(10)
      COMMON /BDMR4/R12T(100),R23T(100),R34T(100),R45T(100)
     *,R56T(100),R67T(100),R78T(100),R89T(100)
      COMMON /BDMR5/ZMAX,ZMA(10),ZIMF0,ZIMF(10),NIMF(10),NUMB,NIMF0
     *,ZMAI(10),ZMA2(10),EZ6(10),YZ6(10)
      MIMF=0
      ZX=0.
      JZX=0
      ZF=0.
      EK6=0.
      NZ6=0
      DO 1 IR=1,NFRAG1
      IA=IAA(IR)
      IZ=IZZ(IR)
      IF(IZ.GT.ZX) JZX=IR
      IF(IZ.GT.ZX) ZX=IZ
      IF(IZ.LT.3.OR.IZ.GT.20) GO TO 1
      IF(IZ.GE.3.AND.IZ.LE.20) MIMF=MIMF+1
      IF(IZ.GE.3.AND.IZ.LE.20) ZF=ZF+IZ
      IF(IZ.EQ.6) P00=PXX(IR)**2+PYY(IR)**2+PZZ(IR)**2
      IF(IZ.EQ.6) NZ6=NZ6+1
      IF(IZ.EQ.6) EK6=EK6+P00/(2.*938.*IA)
 1    CONTINUE
      ZX2=0.
      ZFX=0.
      DO 5 IR=1,NFRAG1
      IA=IAA(IR)
      IZ=IZZ(IR)
      IF(IR.EQ.JZX) GO TO 7
      IF(IZ.GT.ZX2) ZX2=IZ
 7    CONTINUE
      IF(IZ.LT.3.OR.IZ.GT.20) GO TO 5
      IF(IZ.GT.ZFX) ZFX=IZ
 5    CONTINUE
      ZMAX=ZMAX+ZX
      NUMB=NUMB+1
      IF(MIMF.LE.0) GO TO 6
      ZF=ZF/FLOAT(MIMF)
      ZIMF0=ZIMF0+ZF
      NIMF0=NIMF0+1
      IF(MIMF.GT.10) GO TO 6
      ZIMF(MIMF)=ZIMF(MIMF)+ZF
      ZMAI(MIMF)=ZMAI(MIMF)+ZFX
      NIMF(MIMF)=NIMF(MIMF)+1
      ZMA(MIMF)=ZMA(MIMF)+ZX
      ZMA2(MIMF)=ZMA2(MIMF)+ZX2
      EZ6(MIMF)=EZ6(MIMF)+EK6
      YZ6(MIMF)=YZ6(MIMF)+NZ6
 6    CONTINUE
      DO 2 IR=1,NFRAG1
      IA=IAA(IR)
      IZ=IZZ(IR)
      IF(IZ.LE.0.OR.IZ.GT.100) GO TO 4
      IF(MIMF.EQ.0) Y0T(IZ)=Y0T(IZ)+1.
      IF(MIMF.LE.0.OR.MIMF.GT.10) GO TO 4
      YFT(MIMF,IZ)=YFT(MIMF,IZ)+1.
      YFST(MIMF)=YFST(MIMF)+1.
 4    CONTINUE
      IF(IZ.LT.3.OR.IZ.GT.20) GO TO 3
      IF(MIMF.EQ.0) Y0(IZ)=Y0(IZ)+1.
      IF(MIMF.LE.0.OR.MIMF.GT.10) GO TO 3
      YF(MIMF,IZ)=YF(MIMF,IZ)+1.
      YFS(MIMF)=YFS(MIMF)+1.
 3    CONTINUE
 2    CONTINUE
      IF(MIMF.GE.0.AND.MIMF.LE.19) 
     *MULT(MIMF+1)=MULT(MIMF+1)+1
      RETURN
      END
      SUBROUTINE DMRPR
      COMMON /BDMR1/Y0(100),YF(10,100),YFS(10),MULT(20)
      COMMON /BDMR2/R12(100),R23(100),R34(100),R45(100)
     *,R56(100),R67(100),R78(100),R89(100)
      COMMON /BDMR3/Y0T(100),YFT(10,100),YFST(10)
      COMMON /BDMR4/R12T(100),R23T(100),R34T(100),R45T(100)
     *,R56T(100),R67T(100),R78T(100),R89T(100)
      COMMON /BDMR5/ZMAX,ZMA(10),ZIMF0,ZIMF(10),NIMF(10),NUMB,NIMF0
     *,ZMAI(10),ZMA2(10),EZ6(10),YZ6(10)
 2    FORMAT(2X,10F7.0)
 3    FORMAT(2X,10F7.4)
c$$$      PRINT 5,(MULT(I),I=1,20)
c$$$ 5    FORMAT(2X,'imf MULT(0-19)=',10I6)
c$$$      PRINT 6,(YFS(I),I=1,10)
c$$$ 6    FORMAT(2X,'YFS(1-10)=',10F7.0)
c$$$      PRINT 116,(YFST(I),I=1,10)
c$$$ 116  FORMAT(2X,'YFST(1-10)=',10F7.0)
      DO 7 J=1,10
      DO 8 II=1,100
      IF(YFS(J).GT.0) YF(J,II)=YF(J,II)/YFS(J)
      IF(YFST(J).GT.0) YFT(J,II)=YFT(J,II)/YFST(J)
 8    CONTINUE
 7    CONTINUE
      IZMT=79
      IZM=20
c$$$      PRINT 10
c$$$ 10   FORMAT(5X,'(at M_imf= 0)  charge yield:  Y0(1-ZM)  ')
c$$$      PRINT 2,(Y0(I),I=1,IZM)
c$$$      DO 11 J=1,10
c$$$      PRINT 12
c$$$ 12   FORMAT(2X,'-------------------------------------- ')
c$$$      PRINT 13,J,J
c$$$ 13   FORMAT(5X,'(at M_imf=',I2,')  chagre yiled:  YF(',I2,
c$$$     *',1-ZM)  ')
c$$$      PRINT 3,(YF(J,I),I=1,IZM)
c$$$ 11   CONTINUE
c$$$      PRINT 12
c$$$      PRINT 100
c$$$ 100  FORMAT(5X,'(at M_imf= 0)  charge yield:  Y0T(1-ZMT)  ')
c$$$      PRINT 2,(Y0T(I),I=1,IZMT)
c$$$      DO 101 J=1,10
c$$$      PRINT 12
c$$$      PRINT 103,J,J
c$$$ 103  FORMAT(5X,'(at M_imf=',I2,')  chagre yiled:  YFT(',I2,
c$$$     *',1-ZMT)  ')
c$$$      PRINT 3,(YFT(J,I),I=1,IZMT)
c$$$ 101  CONTINUE
c$$$      PRINT 12
      DO 1 III=1,100
      IF(YF(2,III).GT.0.) R12(III)=YF(1,III)/YF(2,III)
      IF(YF(3,III).GT.0.) R23(III)=YF(2,III)/YF(3,III)
      IF(YF(4,III).GT.0.) R34(III)=YF(3,III)/YF(4,III)
      IF(YF(5,III).GT.0.) R45(III)=YF(4,III)/YF(5,III)
      IF(YF(6,III).GT.0.) R56(III)=YF(5,III)/YF(6,III)
      IF(YF(7,III).GT.0.) R67(III)=YF(6,III)/YF(7,III)
      IF(YF(8,III).GT.0.) R78(III)=YF(7,III)/YF(8,III)
      IF(YF(9,III).GT.0.) R89(III)=YF(8,III)/YF(9,III)
 1    CONTINUE
      DO 104 III=1,100
      IF(YFT(2,III).GT.0.) R12T(III)=YFT(1,III)/YFT(2,III)
      IF(YFT(3,III).GT.0.) R23T(III)=YFT(2,III)/YFT(3,III)
      IF(YFT(4,III).GT.0.) R34T(III)=YFT(3,III)/YFT(4,III)
      IF(YFT(5,III).GT.0.) R45T(III)=YFT(4,III)/YFT(5,III)
      IF(YFT(6,III).GT.0.) R56T(III)=YFT(5,III)/YFT(6,III)
      IF(YFT(7,III).GT.0.) R67T(III)=YFT(6,III)/YFT(7,III)
      IF(YFT(8,III).GT.0.) R78T(III)=YFT(7,III)/YFT(8,III)
      IF(YFT(9,III).GT.0.) R89T(III)=YFT(8,III)/YFT(9,III)
 104  CONTINUE
c$$$      PRINT 15
c$$$ 15   FORMAT(5X,'R12(1-ZM)=YF(1,1-ZM)/YF(2,1-ZM) : ')
c$$$      PRINT 3,(R12(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 4
c$$$ 4    FORMAT(5X,'R23(1-ZM)=YF(2,1-ZM)/YF(3,1-ZM) : ')
c$$$      PRINT 3,(R23(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 9
c$$$ 9    FORMAT(5X,'R34(1-ZM)=YF(3,1-ZM)/YF(4,1-ZM) : ')
c$$$      PRINT 3,(R34(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 14
c$$$ 14   FORMAT(5X,'R45(1-ZM)=YF(4,1-ZM)/YF(5,1-ZM) : ')
c$$$      PRINT 3,(R45(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 16
c$$$ 16   FORMAT(5X,'R56(1-ZM)=YF(5,1-ZM)/YF(6,1-ZM) : ')
c$$$      PRINT 3,(R56(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 17
c$$$ 17   FORMAT(5X,'R67(1-ZM)=YF(6,1-ZM)/YF(7,1-ZM) : ')
c$$$      PRINT 3,(R67(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 18
c$$$ 18   FORMAT(5X,'R78(1-ZM)=YF(7,1-ZM)/YF(8,1-ZM) : ')
c$$$      PRINT 3,(R78(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 19
c$$$ 19   FORMAT(5X,'R89(1-ZM)=YF(8,1-ZM)/YF(9,1-ZM) : ')
c$$$      PRINT 3,(R89(I),I=1,IZM)
c$$$      PRINT 12
c$$$      PRINT 105
c$$$ 105  FORMAT(5X,'R12T(1-ZMT) : ')
c$$$      PRINT 3,(R12T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 106
c$$$ 106  FORMAT(5X,'R23T(1-ZMT) : ')
c$$$      PRINT 3,(R23T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 107
c$$$ 107  FORMAT(5X,'R34T(1-ZMT) : ')
c$$$      PRINT 3,(R34T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 108
c$$$ 108  FORMAT(5X,'R45T(1-ZMT) : ')
c$$$      PRINT 3,(R45T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 109
c$$$ 109  FORMAT(5X,'R56T(1-ZMT) : ')
c$$$      PRINT 3,(R56T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 110
c$$$ 110  FORMAT(5X,'R67T(1-ZMT) : ')
c$$$      PRINT 3,(R67T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 111
c$$$ 111  FORMAT(5X,'R78T(1-ZMT) : ')
c$$$      PRINT 3,(R78T(I),I=1,IZMT)
c$$$      PRINT 12
c$$$      PRINT 118
c$$$ 118  FORMAT(5X,'R89T(1-ZMT) : ')
c$$$      PRINT 3,(R89T(I),I=1,IZMT)
      IF(NIMF0.GT.0) ZIMF0=ZIMF0/FLOAT(NIMF0)
      IF(NUMB.GT.0) ZMAX=ZMAX/FLOAT(NUMB)
c$$$      PRINT 114,ZMAX,ZIMF0
c$$$ 114  FORMAT(2X,'max.charge ZMAX=',F6.2,
c$$$     *' avr. IMF charge ZIMF0=',F6.2)
c$$$      PRINT 113,(NIMF(I),I=1,10)
c$$$ 113  FORMAT(2X,'NIMF(1-10)=',10I7)
      DO 112 II=1,10
      IF(NIMF(II).GT.0) ZIMF(II)=ZIMF(II)/FLOAT(NIMF(II))
      IF(NIMF(II).GT.0) ZMA(II)=ZMA(II)/FLOAT(NIMF(II))
      IF(NIMF(II).GT.0) ZMA2(II)=ZMA2(II)/FLOAT(NIMF(II))
      IF(NIMF(II).GT.0) ZMAI(II)=ZMAI(II)/FLOAT(NIMF(II))
      IF(YZ6(II).GT.0) EZ6(II)=EZ6(II)/YZ6(II)
 112  CONTINUE
c$$$      PRINT 117,(ZMA(II),II=1,10)
c$$$ 117  FORMAT(2X,' ZMA(1-10)=',10F7.2)
c$$$      PRINT 120,(ZMA2(II),II=1,10)
c$$$ 120  FORMAT(2X,'ZMA2(1-10)=',10F7.2)
c$$$      PRINT 115,(ZIMF(II),II=1,10)
c$$$ 115  FORMAT(2X,'ZIMF(1-10)=',10F7.2)
c$$$      PRINT 119,(ZMAI(II),II=1,10)
c$$$ 119  FORMAT(2X,'ZMAI(1-10)=',10F7.2)
c$$$      PRINT 131,(YZ6(II),II=1,10)
c$$$ 131  FORMAT(2X,' YZ6(1-10)=',10F7.0)
c$$$      PRINT 130,(EZ6(II),II=1,10)
c$$$ 130  FORMAT(2X,' EZ6(1-10)=',10F7.2)
      RETURN
      END
      SUBROUTINE CPOCH1(NUMPAT)
      COMMON /BLOKC/SPT(10,500)
      ZMAX=0.
      ZMA2=0.
      ZMA3=0.
      JMAX=0
      JMA2=0
      JMA3=0
      NZ330=0
      DO 2 IT=1,NUMPAT
      IZ=INT(SPT(8,IT)+0.5)
      ZM=IZ
      IF(IZ.GE.3.AND.IZ.LE.30) NZ330=NZ330+1
      IF(ZM.GT.ZMAX) JMAX=IT
      IF(ZM.GT.ZMAX) ZMAX=ZM
 2    CONTINUE
      DO 3 IT=1,NUMPAT
      IF(IT.EQ.JMAX) GO TO 3
      ZM=INT(SPT(8,IT)+0.5)
      IF(ZM.GT.ZMA2) JMA2=IT
      IF(ZM.GT.ZMA2) ZMA2=ZM
 3    CONTINUE
      DO 4 IT=1,NUMPAT
      IF(IT.EQ.JMAX) GO TO 4
      IF(IT.EQ.JMA2) GO TO 4
      ZM=INT(SPT(8,IT)+0.5)
      IF(ZM.GT.ZMA3) JMA3=IT
      IF(ZM.GT.ZMA3) ZMA3=ZM
 4    CONTINUE
      CALL POCH1(NUMPAT,NZ330,ZMAX,ZMA2,ZMA3,JMAX,JMA2,JMA3)
      RETURN
      END
      SUBROUTINE BPOCH1
      COMMON /BLPOC1/IPOC0,IPOC(5) /BLPOC3/PDOM(26)
      COMMON /BLPOC2/EKTS(5),EKT2S(5),EKCS(5),EKC2S(5)
      IPOC0=0
      DO 1 I=1,5
      IPOC(I)=0
      EKTS(I)=0.
      EKT2S(I)=0.
      EKCS(I)=0.
      EKC2S(I)=0.
 1    CONTINUE
      DO 2 I=1,26
      PDOM(I)=0.
 2    CONTINUE
c --- for writing in Pochodzalla format
c      OPEN(60,NAME='FIL123') 
      RETURN
      END
      SUBROUTINE EPOCH1
      COMMON /BLPOC1/IPOC0,IPOC(5) /BLPOC3/PDOM(26)
      COMMON /BLPOC2/EKTS(5),EKT2S(5),EKCS(5),EKC2S(5)
      DIMENSION SIGET(5),SIGEC(5)
c      PRINT 1,IPOC0
c 1    FORMAT(2X,'number of events with N_imf.GE.3 and Z_ma3.GE.8 -',
c     *' IPOC0=',I6)
c      PRINT 2,(IPOC(I),I=1,5)
c 2    FORMAT(2X,'IPOC(1-5)=',5I8)
      DO 3 I=1,5
      SIGET(I)=0.
      IF(IPOC(I).GT.0) EKTS(I)=EKTS(I)/FLOAT(IPOC(I))
      IF(IPOC(I).GT.0) EKT2S(I)=EKT2S(I)/FLOAT(IPOC(I))
      TT=EKT2S(I)-EKTS(I)*EKTS(I)
      IF(TT.GT.0.) SIGET(I)=SQRT(TT)
      SIGEC(I)=0.
      IF(IPOC(I).GT.0) EKCS(I)=EKCS(I)/FLOAT(IPOC(I))
      IF(IPOC(I).GT.0) EKC2S(I)=EKC2S(I)/FLOAT(IPOC(I))
      TC=EKC2S(I)-EKCS(I)*EKCS(I)
      IF(TC.GT.0.) SIGEC(I)=SQRT(TC)
 3    CONTINUE
c$$$      PRINT 4,(EKTS(I),I=1,5)
c$$$ 4    FORMAT(2X,'EKTS(1-5)=',5F8.3)
c$$$      PRINT 5,(SIGET(I),I=1,5)
c$$$ 5    FORMAT(1X,'SIGET(1-5)=',5F8.3)
c$$$      PRINT 6,(EKCS(I),I=1,5)
c$$$ 6    FORMAT(2X,'EKCS(1-5)=',5F8.3)
c$$$      PRINT 7,(SIGEC(I),I=1,5)
c$$$ 7    FORMAT(1X,'SIGEC(1-5)=',5F8.3)
c$$$      PRINT 9
c$$$ 9    FORMAT(2X,'distribution in DOM (0-1, step-0.05), PDOM(1-26):')
c$$$      PRINT 8,(PDOM(I),I=1,26)
c$$$ 8    FORMAT(1X,10F8.3)
      RETURN
      END
      SUBROUTINE POCH1(KST1,NZ330,ZMAX,ZMA2,ZMA3,JMAX,JMA2,JMA3)
      COMMON /BLOKC/SPT(10,500)
      COMMON /BLPOC1/IPOC0,IPOC(5) /BLPOC3/PDOM(26)
      COMMON /BLPOC2/EKTS(5),EKT2S(5),EKCS(5),EKC2S(5)
      DIMENSION P1(3),P2(3),P3(3),P1C(3),P2C(3),P3C(3),V0(3)
      DIMENSION PSO(3),PSN(3),V1C(3),V2C(3),V3C(3)
c ---- for checking momentum balance and relat. momenta ----
      DO 50 III=1,3
      PSO(III)=0.
      PSN(III)=0.
      V1C(III)=0.
      V2C(III)=0.
      V3C(III)=0.
 50   CONTINUE
c ----
      IF(NZ330.GE.3) GO TO 1
      RETURN
 1    IF(ZMA3.GE.7.5) GO TO 2
      RETURN
 2    IPOC0=IPOC0+1
      AMAX=SPT(9,JMAX)/0.94
      AMA2=SPT(9,JMA2)/0.94
      AMA3=SPT(9,JMA3)/0.94
      EC=ZMAX*ZMA2/(AMAX**0.33333+AMA2**0.33333)+
     *   ZMAX*ZMA3/(AMAX**0.33333+AMA3**0.33333)+
     *   ZMA2*ZMA3/(AMA2**0.33333+AMA3**0.33333)
      EC=1.44*EC/1.4
      IC=0
      IF(EC.GE.30.AND.EC.LT.60.) IC=1
      IF(EC.GE.60.AND.EC.LT.90.) IC=2
      IF(EC.GE.90.AND.EC.LT.120.) IC=3
      IF(EC.GE.120.AND.EC.LT.150.) IC=4
      IF(EC.GE.150.AND.EC.LT.180.) IC=5
      IF(IC.EQ.0) RETURN
      IPOC(IC)=IPOC(IC)+1
      EKT=SPT(7,JMAX)+SPT(7,JMA2)+SPT(7,JMA3)
      EKT2=EKT*EKT
      EKTS(IC)=EKTS(IC)+EKT
      EKT2S(IC)=EKT2S(IC)+EKT2
      CM1=AMAX*0.94
      CM2=AMA2*0.94
      CM3=AMA3*0.94
      CT1=SPT(4,JMAX)
      ST1=SQRT(1.-CT1*CT1)
      CF1=SPT(6,JMAX)
      SF1=SPT(5,JMAX)
      CT2=SPT(4,JMA2)
      ST2=SQRT(1.-CT2*CT2)
      CF2=SPT(6,JMA2)
      SF2=SPT(5,JMA2)
      CT3=SPT(4,JMA3)
      ST3=SQRT(1.-CT3*CT3)
      CF3=SPT(6,JMA3)
      SF3=SPT(5,JMA3)
      CALL TINP(P1,CT1,ST1,CF1,SF1,SPT(7,JMAX),CM1)
      CALL TINP(P2,CT2,ST2,CF2,SF2,SPT(7,JMA2),CM2)
      CALL TINP(P3,CT3,ST3,CF3,SF3,SPT(7,JMA3),CM3)
      P01=P1(1)+P2(1)+P3(1)
      P02=P1(2)+P2(2)+P3(2)
      P03=P1(3)+P2(3)+P3(3)
c ----
      PR12O=SQRT((P1(1)-P2(1))**2+(P1(2)-P2(2))**2+
     *(P1(3)-P2(3))**2)
      PR23O=SQRT((P2(1)-P3(1))**2+(P2(2)-P3(2))**2+
     *(P2(3)-P3(3))**2)
      PR31O=SQRT((P3(1)-P1(1))**2+(P3(2)-P1(2))**2+
     *(P3(3)-P1(3))**2)
      PSO(1)=P01
      PSO(2)=P02
      PSO(3)=P03
c ----
      EM0=SQRT(P01*P01+P02*P02+P03*P03+(CM1+CM2+CM3)**2)
      V0(1)=-P01/EM0
      V0(2)=-P02/EM0
      V0(3)=-P03/EM0
      EM1=SQRT(P1(1)**2+P1(2)**2+P1(3)**2+CM1**2)
      EM2=SQRT(P2(1)**2+P2(2)**2+P2(3)**2+CM2**2)
      EM3=SQRT(P3(1)**2+P3(2)**2+P3(3)**2+CM3**2)
      CALL CLPV(P1,V0,P1C,EM1)
      CALL CLPV(P2,V0,P2C,EM2)
      CALL CLPV(P3,V0,P3C,EM3)
      EM1C=SQRT(P1C(1)**2+P1C(2)**2+P1C(3)**2+CM1**2)
      EM2C=SQRT(P2C(1)**2+P2C(2)**2+P2C(3)**2+CM2**2)
      EM3C=SQRT(P3C(1)**2+P3C(2)**2+P3C(3)**2+CM3**2)
      DO 57 JJ=1,3
      V1C(JJ)=P1C(JJ)/EM1C
      V2C(JJ)=P2C(JJ)/EM2C
      V3C(JJ)=P3C(JJ)/EM3C
 57   CONTINUE
      V12C=SQRT((V1C(1)-V2C(1))**2+(V1C(2)-V2C(2))**2+
     *(V1C(3)-V2C(3))**2)
      V23C=SQRT((V2C(1)-V3C(1))**2+(V2C(2)-V3C(2))**2+
     *(V2C(3)-V3C(3))**2)
      V31C=SQRT((V3C(1)-V1C(1))**2+(V3C(2)-V1C(2))**2+
     *(V3C(3)-V1C(3))**2)
      SSS=0.5*(V12C+V23C+V31C)
      VEQ=(V12C+V23C+V31C)/3.
      FEQ=(SQRT(3.)/4.)*VEQ*VEQ
      FSS=SQRT(SSS*(SSS-V12C)*(SSS-V23C)*(SSS-V31C))
      DOM=FSS/FEQ
      WW=1.
      CALL HIST1(DOM,0.,1.,0.05,PDOM,26,WW)
c ----
      PR12N=SQRT((P1C(1)-P2C(1))**2+(P1C(2)-P2C(2))**2+
     *(P1C(3)-P2C(3))**2)
      PR23N=SQRT((P2C(1)-P3C(1))**2+(P2C(2)-P3C(2))**2+
     *(P2C(3)-P3C(3))**2)
      PR31N=SQRT((P3C(1)-P1C(1))**2+(P3C(2)-P1C(2))**2+
     *(P3C(3)-P1C(3))**2)
      PSN(1)=P1C(1)+P2C(1)+P3C(1)
      PSN(2)=P1C(2)+P2C(2)+P3C(2)
      PSN(3)=P1C(3)+P2C(3)+P3C(3)
c      PRINT 51,PSO(1),PSO(2),PSO(3),PSN(1),PSN(2),PSN(3)
c 51   FORMAT(2X,' PSO(1-3)=',3F9.4,'  PSN(1-3)=',3F9.4)
c      PRINT 52,PR12O,PR23O,PR31O,PR12N,PR23N,PR31N
c 52   FORMAT(2X,' PR12O,PR23O,PR31O=',3F9.4,
c     *'  PR12N,PR23N,PR31N=',3F9.4)
c ----
      CALL PINT(P1C,CT1C,ST1C,CF1C,SF1C,T1C,CM1)
      CALL PINT(P2C,CT2C,ST2C,CF2C,SF2C,T2C,CM2)
      CALL PINT(P3C,CT3C,ST3C,CF3C,SF3C,T3C,CM3)
      EKC=T1C+T2C+T3C
      EKC2=EKC*EKC
      EKCS(IC)=EKCS(IC)+EKC
      EKC2S(IC)=EKC2S(IC)+EKC2
c --- writing for Pochodzalla evaluat.programm
      T1C=1000.*T1C
      T2C=1000.*T2C
      T3C=1000.*T3C
      EKC=1000.*EKC
c --- writing for Pochodzalla format
c      WRITE(60,*)(ZMAX,AMAX,T1C)
c      WRITE(60,*)(ZMA2,AMA2,T2C)
c      WRITE(60,*)(ZMA3,AMA3,T3C,EKC)
c --------------------------------------------
c      PRINT 53,IC,EKT,EKC
c 53   FORMAT(2X,' IC=',I2,'  EKT=',F8.4,' EKC=',F8.4)
c      PRINT 54,AMAX,ZMAX,SPT(7,JMAX),T1C
c 54   FORMAT(2X,' AMAX,ZMAX=',2F6.1,' T1O,T1C=',2F8.4)
c      PRINT 55,AMA2,ZMA2,SPT(7,JMA2),T2C
c 55   FORMAT(2X,' AMA2,ZMA2=',2F6.1,' T2O,T2C=',2F8.4)
c      PRINT 56,AMA3,ZMA3,SPT(7,JMA3),T3C
c 56   FORMAT(2X,' AMA3,ZMA3=',2F6.1,' T3O,T3C=',2F8.4)
      RETURN
      END
      SUBROUTINE BSPEC1
      COMMON /BLSPE1/EN(56),ENT(56),EP(56),EPT(56),EA(56),EAT(56)
      COMMON /BLSPE2/EDE(56),ETR(56),EHE3(56)
      COMMON /BLSPE3/SEN,SEP,SED,SET,SEH,SEA,NN,NP,ND,NT,NH,NA
      NN=0
      NP=0
      ND=0
      NT=0
      NH=0
      NA=0
      SEN=0.
      SEP=0.
      SED=0.
      SET=0.
      SEH=0.
      SEA=0.
      DO 1 I=1,56
      EN(I)=0.
      ENT(I)=0.
      EP(I)=0.
      EPT(I)=0.
      EA(I)=0.
      EAT(I)=0.
      EDE(I)=0.
      ETR(I)=0.
      EHE3(I)=0.
 1    CONTINUE
      RETURN
      END
      SUBROUTINE ESPEC1
      COMMON /BLSPE1/EN(56),ENT(56),EP(56),EPT(56),EA(56),EAT(56)
      COMMON /BLSPE2/EDE(56),ETR(56),EHE3(56)
      COMMON /BLSPE3/SEN,SEP,SED,SET,SEH,SEA,NN,NP,ND,NT,NH,NA
      IF(NN.GT.0) SEN=SEN/FLOAT(NN)
      IF(NP.GT.0) SEP=SEP/FLOAT(NP)
      IF(ND.GT.0) SED=SED/FLOAT(ND)
      IF(NT.GT.0) SET=SET/FLOAT(NT)
      IF(NH.GT.0) SEH=SEH/FLOAT(NH)
      IF(NA.GT.0) SEA=SEA/FLOAT(NA)
c$$$      PRINT 13, NN,NP,ND,NT,NH,NA
c$$$ 13   FORMAT(2X,'numb.of part. N,P,D,T,H,A =',6I7)
c$$$      PRINT 14, SEN,SEP,SED,SET,SEH,SEA
c$$$ 14   FORMAT(2X,'their avr.kin.energ.(MeV) =',6F7.2)
      TEMN=0.
      TEMP=0.
      TEMD=0.
      TEMT=0.
      TEMH=0.
      TEMA=0.
      TTT30=0.
      TTT60=0.
      TTT30=(EN(15)+EN(16)+EN(17))/3.
      TTT60=(EN(30)+EN(31)+EN(32))/3.
      IF(TTT60.GT.0.AND.TTT30.GT.0) TTT=ALOG(TTT30/TTT60)
      IF(TTT.GT.0.) TEMN=30./TTT
      TTT30=0.
      TTT60=0.
      TTT30=(EP(15)+EP(16)+EP(17))/3.
      TTT60=(EP(30)+EP(31)+EP(32))/3.
      IF(TTT60.GT.0.AND.TTT30.GT.0) TTT=ALOG(TTT30/TTT60)
      IF(TTT.GT.0.) TEMP=30./TTT
      TTT30=0.
      TTT60=0.
      TTT30=(EDE(15)+EDE(16)+EDE(17))/3.
      TTT60=(EDE(30)+EDE(31)+EDE(32))/3.
      IF(TTT60.GT.0.AND.TTT30.GT.0) TTT=ALOG(TTT30/TTT60)
      IF(TTT.GT.0.) TEMD=30./TTT
      TTT30=0.
      TTT60=0.
      TTT30=(ETR(15)+ETR(16)+ETR(17))/3.
      TTT60=(ETR(30)+ETR(31)+ETR(32))/3.
      IF(TTT60.GT.0.AND.TTT30.GT.0) TTT=ALOG(TTT30/TTT60)
      IF(TTT.GT.0.) TEMT=30./TTT
      TTT30=0.
      TTT60=0.
      TTT30=(EHE3(15)+EHE3(16)+EHE3(17))/3.
      TTT60=(EHE3(30)+EHE3(31)+EHE3(32))/3.
      IF(TTT60.GT.0.AND.TTT30.GT.0) TTT=ALOG(TTT30/TTT60)
      IF(TTT.GT.0.) TEMH=30./TTT
      TTT30=0.
      TTT60=0.
      TTT30=(EA(15)+EA(16)+EA(17))/3.
      TTT60=(EA(30)+EA(31)+EA(32))/3.
      IF(TTT60.GT.0.AND.TTT30.GT.0) TTT=ALOG(TTT30/TTT60)
      IF(TTT.GT.0.) TEMA=30./TTT
c$$$      PRINT 12, TEMN,TEMP,TEMD,TEMT,TEMH,TEMA
c$$$ 12   FORMAT(2X,'inver.slop.temper.(30/60) =',6F7.2)
c$$$ 10   FORMAT(1X,10F8.0)
c$$$ 11   FORMAT(1X,6F12.4)
c$$$      PRINT 1
c$$$ 1    FORMAT(2X,'energy spect. of neutrons, total: EN',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EN(I),I=1,50)
c$$$      PRINT 11,(EN(I),I=51,56)
c$$$      PRINT 2
c$$$ 2    FORMAT(2X,'energy spect. of neutrons, transv.: ENT',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(ENT(I),I=1,50)
c$$$      PRINT 11,(ENT(I),I=51,56)
c$$$      PRINT 3
c$$$ 3    FORMAT(2X,'energy spect. of protons, total: EP',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EP(I),I=1,50)
c$$$      PRINT 11,(EP(I),I=51,56)
c$$$      PRINT 4
c$$$ 4    FORMAT(2X,'energy spect. of protons, transv.: EPT',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EPT(I),I=1,50)
c$$$      PRINT 11,(EPT(I),I=51,56)
c$$$      PRINT 7
c$$$ 7    FORMAT(2X,'energy spect. of deutrons, total: EDE',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EDE(I),I=1,50)
c$$$      PRINT 11,(EDE(I),I=51,56)
c$$$      PRINT 8
c$$$ 8    FORMAT(2X,'energy spect. of tritons, total: ETR',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(ETR(I),I=1,50)
c$$$      PRINT 11,(ETR(I),I=51,56)
c$$$      PRINT 9
c$$$ 9    FORMAT(2X,'energy spect. of HE-3, total: EHE3',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EHE3(I),I=1,50)
c$$$      PRINT 11,(EHE3(I),I=51,56)
c$$$      PRINT 5
c$$$ 5    FORMAT(2X,'energy spect. of alphas, total: EA',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EA(I),I=1,50)
c$$$      PRINT 11,(EA(I),I=51,56)
c$$$      PRINT 6
c$$$ 6    FORMAT(2X,'energy spect. of alphas, transv.: EAT',
c$$$     *' (0-100MeV, step-2MeV)')
c$$$      PRINT 10,(EAT(I),I=1,50)
c$$$      PRINT 11,(EAT(I),I=51,56)
      RETURN
      END
      SUBROUTINE CSPEC1(KST1)
      COMMON /BLOKC/SPT(10,500)
      COMMON /BLSPE1/EN(56),ENT(56),EP(56),EPT(56),EA(56),EAT(56)
      COMMON /BLSPE2/EDE(56),ETR(56),EHE3(56)
      COMMON /BLSPE3/SEN,SEP,SED,SET,SEH,SEA,NN,NP,ND,NT,NH,NA
      DO 1 I=1,KST1
      IA=INT(SPT(9,I)/0.94+0.5)
      IZ=INT(SPT(8,I)+0.5)
      EK=1000.*SPT(7,I)
      COT=SPT(4,I)
      SIT2=1.-COT*COT
      ET=EK*SIT2
      IF(IA.EQ.1.AND.IZ.EQ.0) NN=NN+1
      IF(IA.EQ.1.AND.IZ.EQ.0) SEN=SEN+EK
      IF(IA.EQ.1.AND.IZ.EQ.1) NP=NP+1
      IF(IA.EQ.1.AND.IZ.EQ.1) SEP=SEP+EK
      IF(IA.EQ.2.AND.IZ.EQ.1) ND=ND+1
      IF(IA.EQ.2.AND.IZ.EQ.1) SED=SED+EK
      IF(IA.EQ.3.AND.IZ.EQ.1) NT=NT+1
      IF(IA.EQ.3.AND.IZ.EQ.1) SET=SET+EK
      IF(IA.EQ.3.AND.IZ.EQ.2) NH=NH+1
      IF(IA.EQ.3.AND.IZ.EQ.2) SEH=SEH+EK
      IF(IA.EQ.4.AND.IZ.EQ.2) NA=NA+1
      IF(IA.EQ.4.AND.IZ.EQ.2) SEA=SEA+EK
      IF(IA.EQ.1.AND.IZ.EQ.0) 
     *CALL HIST1(EK,0.,100.,2.,EN,56,1.)
      IF(IA.EQ.1.AND.IZ.EQ.0) 
     *CALL HIST1(ET,0.,100.,2.,ENT,56,1.)
      IF(IA.EQ.1.AND.IZ.EQ.1) 
     *CALL HIST1(EK,0.,100.,2.,EP,56,1.)
      IF(IA.EQ.1.AND.IZ.EQ.1) 
     *CALL HIST1(ET,0.,100.,2.,EPT,56,1.)
      IF(IA.EQ.4.AND.IZ.EQ.2) 
     *CALL HIST1(EK,0.,100.,2.,EA,56,1.)
      IF(IA.EQ.4.AND.IZ.EQ.2) 
     *CALL HIST1(ET,0.,100.,2.,EAT,56,1.)
      IF(IA.EQ.3.AND.IZ.EQ.2) 
     *CALL HIST1(EK,0.,100.,2.,EHE3,56,1.)
      IF(IA.EQ.2.AND.IZ.EQ.1) 
     *CALL HIST1(EK,0.,100.,2.,EDE,56,1.)
      IF(IA.EQ.3.AND.IZ.EQ.1) 
     *CALL HIST1(EK,0.,100.,2.,ETR,56,1.)
 1    CONTINUE
      RETURN
      END
      SUBROUTINE HOTFR(IP0,A0,Z0,AM,CH,PN0,TEMP,ECOLB)
c --- for hot fragments in the break-up vo;ume: their number,
c --- positions and the number of accompanied light part.
      DIMENSION XX(199),YY(199),ZZ(199),AM(500),CH(500),PN0(3,500)
      COMMON /BLPAT/PA(500),PAZ(500),IPT
      COMMON /BLCEN/XC(500),YC(500),ZC(500)
      COMMON /BLHFR1/YIMF(20),YZ710(20),DYZ710(20)
      COMMON /BLHFR2/YZT,RZT,YZF(20),RZF(20),DRZF(20)
      COMMON /BLHFR3/YLF(20),DYLF(20),YHF(20),DYHF(20),YSF(20)
      COMMON /BLHFR4/ZLF(20),ZHF(20),ZSF(20)
      COMMON /BFHFR5/CULC(20),TEMC(20),EF(20),ELF(20),E71(20),EHF(20)
      COMMON /BLHFR6/ALF(20),A71(20),AHF(20),ELFN(20),E71N(20),EHFN(20)
      COMMON /BLHFR7/YIZ(200),EKZ(200),VXCM,VYCM,VZCM,EKCM,ICM
      AMCM1=0.
      VXCM1=0.
      VYCM1=0.
      VZCM1=0.
      DO 1 I=1,IPT
      XX(I)=XC(I)
      YY(I)=YC(I)
      ZZ(I)=ZC(I)
 1    CONTINUE
      ILF=0
      IHF=0
      ISF=0
      IMF=0
      IZ710=0
      EF0=0.
      EL0=0.
      E70=0.
      EH0=0.
      AL0=0.
      A70=0.
      AH0=0.
      DO 40 I=1,IPT
      IZ=INT(PAZ(I)+0.5)
      IA=INT(PA(I)+0.5)
      IF(IZ.GE.1.AND.IZ.LE.6) ILF=ILF+1
      IF(IZ.GE.1.AND.IZ.LE.6) AL0=AL0+IA
      IF(IZ.GE.11) IHF=IHF+1
      IF(IZ.GE.11) AH0=AH0+IA
      IF(IZ.GE.7.AND.IZ.LE.10) IZ710=IZ710+1
      IF(IZ.GE.7.AND.IZ.LE.10) A70=A70+IA
      IF(IZ.GE.5.AND.IZ.LE.22) IMF=IMF+1
      IF(IZ.GT.22) ISF=ISF+1
      EN0=(PN0(1,I)**2+PN0(2,I)**2+PN0(3,I)**2)/(2.*AM(I))
      IF(IZ.GE.1) EF0=EF0+EN0
      IF(IZ.GE.1.AND.IZ.LE.6) EL0=EL0+EN0
      IF(IZ.GE.7.AND.IZ.LE.10) E70=E70+EN0
      IF(IZ.GE.11) EH0=EH0+EN0
      VXCM1=VXCM1+PN0(1,I)
      VYCM1=VYCM1+PN0(2,I)
      VZCM1=VZCM1+PN0(3,I)
      AMCM1=AMCM1+AM(I)
 40   CONTINUE
      VXCM1=VXCM1/AMCM1
      VYCM1=VYCM1/AMCM1
      VZCM1=VZCM1/AMCM1
      VXCM=VXCM+VXCM1
      VYCM=VYCM+VYCM1
      VZCM=VZCM+VZCM1
      ICM=ICM+1
      EKCM=EKCM+0.5*AMCM1*(VXCM1**2+VYCM1**2+VZCM1**2)
      DO 30 I=1,IPT
      IZ=INT(PAZ(I)+0.5)
      IA=INT(PA(I)+0.5)
      IF(IZ.LE.0.OR.IZ.GT.200) GO TO 30
      YIZ(IZ)=YIZ(IZ)+1.
      EKZ(IZ)=EKZ(IZ)+0.5*AM(I)*(((PN0(1,I)/AM(I))-VXCM1)**2
     #+((PN0(2,I)/AM(I))-VYCM1)**2+((PN0(3,I)/AM(I))-VZCM1)**2)
 30   CONTINUE
      IF(IZ710.EQ.0) GO TO 10
      YSF(IMF+1)=YSF(IMF+1)+ISF
      YIMF(IMF+1)=YIMF(IMF+1)+1.
      YLF(IMF+1)=YLF(IMF+1)+ILF
      DYLF(IMF+1)=DYLF(IMF+1)+ILF*ILF
      YZ710(IMF+1)=YZ710(IMF+1)+IZ710
      DYZ710(IMF+1)=DYZ710(IMF+1)+IZ710*IZ710
      YHF(IMF+1)=YHF(IMF+1)+IHF
      DYHF(IMF+1)=DYHF(IMF+1)+IHF*IHF
      CULC(IMF+1)=CULC(IMF+1)+ECOLB
      TEMC(IMF+1)=TEMC(IMF+1)+TEMP
      EF(IMF+1)=EF(IMF+1)+EF0
      ELF(IMF+1)=ELF(IMF+1)+EL0
      E71(IMF+1)=E71(IMF+1)+E70
      EHF(IMF+1)=EHF(IMF+1)+EH0
      ALF(IMF+1)=ALF(IMF+1)+AL0
      A71(IMF+1)=A71(IMF+1)+A70
      AHF(IMF+1)=AHF(IMF+1)+AH0
      DO 41 I=1,IPT
      RR=SQRT(XX(I)**2+YY(I)**2+ZZ(I)**2)
      IZ=INT(PAZ(I)+0.5)
      IA=INT(PA(I)+0.5)
      IF(IZ.GT.22) ZSF(IMF+1)=ZSF(IMF+1)+IZ
      IF(IZ.GE.1.AND.IZ.LE.6) ZLF(IMF+1)=ZLF(IMF+1)+IZ
      IF(IZ.GT.10) ZHF(IMF+1)=ZHF(IMF+1)+IZ
      IF(IZ.GE.7.AND.IZ.LE.10) YZF(IMF+1)=YZF(IMF+1)+1.
      IF(IZ.GE.7.AND.IZ.LE.10) RZF(IMF+1)=RZF(IMF+1)+RR
      IF(IZ.GE.7.AND.IZ.LE.10) DRZF(IMF+1)=DRZF(IMF+1)+RR*RR
      IF(IZ.GE.7.AND.IZ.LE.10) RZT=RZT+RR
      IF(IZ.GE.7.AND.IZ.LE.10) YZT=YZT+1.
 41   CONTINUE
 10   CONTINUE
      RETURN
      END
      SUBROUTINE HOTFRB
      COMMON /BLHFR1/YIMF(20),YZ710(20),DYZ710(20)
      COMMON /BLHFR2/YZT,RZT,YZF(20),RZF(20),DRZF(20)
      COMMON /BLHFR3/YLF(20),DYLF(20),YHF(20),DYHF(20),YSF(20)
      COMMON /BLHFR4/ZLF(20),ZHF(20),ZSF(20)
      COMMON /BFHFR5/CULC(20),TEMC(20),EF(20),ELF(20),E71(20),EHF(20)
      COMMON /BLHFR6/ALF(20),A71(20),AHF(20),ELFN(20),E71N(20),EHFN(20)
      COMMON /BLHFR7/YIZ(200),EKZ(200),VXCM,VYCM,VZCM,EKCM,ICM
      VXCM=0.
      VYCM=0.
      VZCM=0.
      EKCM=0.
      ICM=0
      DO 2 I=1,200
      YIZ(I)=0.
      EKZ(I)=0.
 2    CONTINUE
      YZT=0.
      RZT=0.
      DO 1 I=1,20
      ELFN(I)=0.
      E71N(I)=0.
      EHFN(I)=0.
      ALF(I)=0.
      A71(I)=0.
      AHF(I)=0.
      CULC(I)=0.
      TEMC(I)=0.
      EF(I)=0.
      ELF(I)=0.
      E71(I)=0.
      EHF(I)=0.
      YIMF(I)=0.
      YHF(I)=0.
      DYHF(I)=0.
      YLF(I)=0.
      DYLF(I)=0.
      YZ710(I)=0.
      DYZ710(I)=0.
      YSF(I)=0.
      YZF(I)=0.
      RZF(I)=0.
      DRZF(I)=0.
      ZSF(I)=0.
      ZHF(I)=0.
      ZLF(I)=0.
 1    CONTINUE
      RETURN
      END
      SUBROUTINE HOTFRE
      COMMON /BLHFR1/YIMF(20),YZ710(20),DYZ710(20)
      COMMON /BLHFR2/YZT,RZT,YZF(20),RZF(20),DRZF(20)
      COMMON /BLHFR3/YLF(20),DYLF(20),YHF(20),DYHF(20),YSF(20)
      COMMON /BLHFR4/ZLF(20),ZHF(20),ZSF(20)
      COMMON /BFHFR5/CULC(20),TEMC(20),EF(20),ELF(20),E71(20),EHF(20)
      COMMON /BLHFR6/ALF(20),A71(20),AHF(20),ELFN(20),E71N(20),EHFN(20)
      COMMON /BLHFR7/YIZ(200),EKZ(200),VXCM,VYCM,VZCM,EKCM,ICM
c$$$      PRINT 2
c$$$ 2    FORMAT(2X,' **** for hot fragments ****')
c ----------------------
      VXCM=VXCM/FLOAT(ICM)
      VYCM=VYCM/FLOAT(ICM)
      VZCM=VZCM/FLOAT(ICM)
      EKCM=EKCM/FLOAT(ICM)
c      PRINT 20,ICM,EKCM,VXCM,VYCM,VZCM
c 20   FORMAT(2X,'after second source - project.cent.mass: ICM=',I6,
c     *' EKCM(GeV)=',F8.3/2X,'veloc. V(x,y,z)_cm=',3F8.3,' c')
      DO 22 I=1,79
      IF(YIZ(I).LE.0.) GO TO 22
      EKZ(I)=1000.*EKZ(I)/(YIZ(I)*I*2.)
c      PRINT 21,I,YIZ(I),EKZ(I)
c 21   FORMAT(2X,'z=',I3,' Y_z=',F7.0,' EK_z_cm(MeV/2z)=',F7.3)
 22   CONTINUE
c ----------------------
      RSYS=1.82*1.17*(160.**0.3333333)
      IF(YZT.GT.0.) RZT=RZT/(YZT*RSYS)
      DO 1 I=1,20
      IF(ALF(I).GT.0.) ELFN(I)=ELF(I)/ALF(I)
      IF(AHF(I).GT.0.) EHFN(I)=EHF(I)/AHF(I)
      IF(A71(I).GT.0.) E71N(I)=E71(I)/A71(I)
      IF(YLF(I).GT.0.) ELF(I)=ELF(I)/YLF(I)
      IF(YHF(I).GT.0.) EHF(I)=EHF(I)/YHF(I)
      IF(YZ710(I).GT.0.) E71(I)=E71(I)/YZ710(I)
      IF(YSF(I).GT.0.) ZSF(I)=ZSF(I)/YSF(I)
      IF(YLF(I).GT.0.) ZLF(I)=ZLF(I)/YLF(I)
      IF(YHF(I).GT.0.) ZHF(I)=ZHF(I)/YHF(I)
      IF(YIMF(I).GT.0.) YLF(I)=YLF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) DYLF(I)=DYLF(I)/YIMF(I)
      DDD=DYLF(I)-YLF(I)**2
      IF(DDD.GT.0.) DYLF(I)=SQRT(DDD)
      IF(DDD.LE.0.) DYLF(I)=0.
      IF(YIMF(I).GT.0.) YHF(I)=YHF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) DYHF(I)=DYHF(I)/YIMF(I)
      DDD=DYHF(I)-YHF(I)**2
      IF(DDD.GT.0.) DYHF(I)=SQRT(DDD)
      IF(DDD.LE.0.) DYHF(I)=0.
      IF(YZF(I).GT.0.) RZF(I)=RZF(I)/(YZF(I)*RSYS)
      IF(YZF(I).GT.0.) DRZF(I)=DRZF(I)/(YZF(I)*RSYS*RSYS)
      DDD=DRZF(I)-RZF(I)**2
      IF(DDD.GT.0.) DRZF(I)=SQRT(DDD)
      IF(DDD.LE.0.) DRZF(I)=0.
      IF(YIMF(I).GT.0.) YZ710(I)=YZ710(I)/YIMF(I)
      IF(YIMF(I).GT.0.) DYZ710(I)=DYZ710(I)/YIMF(I)
      DDD=DYZ710(I)-YZ710(I)**2
      IF(DDD.GT.0.) DYZ710(I)=SQRT(DDD)
      IF(DDD.LE.0.) DYZ710(I)=0.
      IF(YIMF(I).GT.0.) YSF(I)=YSF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) CULC(I)=CULC(I)/YIMF(I)
      IF(YIMF(I).GT.0.) TEMC(I)=TEMC(I)/YIMF(I)
      IF(YIMF(I).GT.0.) EF(I)=EF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) ALF(I)=ALF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) AHF(I)=AHF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) A71(I)=A71(I)/YIMF(I)
 1    CONTINUE
      DO 15 I=1,20
      IF(EF(I).GT.0.) ELF(I)=ELF(I)/EF(I)
      IF(EF(I).GT.0.) E71(I)=E71(I)/EF(I)
      IF(EF(I).GT.0.) EHF(I)=EHF(I)/EF(I)
      IF(EF(I).GT.0.) ELFN(I)=ELFN(I)/EF(I)
      IF(EF(I).GT.0.) E71N(I)=E71N(I)/EF(I)
      IF(EF(I).GT.0.) EHFN(I)=EHFN(I)/EF(I)
 15   CONTINUE
c      PRINT 4,YZT,RZT
c 4    FORMAT(2X,'total number of "Z=7-10" YZT=',F9.0,
c     *'  their mean radius RZT/RSYS=',F9.4)
c      PRINT 6
c 6    FORMAT(1X,'#IMF',3X,'YIMF',4X,'YLF',3X,'DYLF',
c     *3X,'YZ710',1X,'DYZ710',5X,'YZF',4X,'RZF',3X,'DRZF',
c     *5X,'YHF',3X,'DYHF')
      DO 5 I=1,20
      IMF0=I-1
c      PRINT 7,IMF0,YIMF(I),YLF(I),DYLF(I),YZ710(I),DYZ710(I),
c     *YZF(I),RZF(I),DRZF(I),YHF(I),DYHF(I)
c 7    FORMAT(1X,I4,1X,F6.0,1X,F6.3,1X,F6.3,2X,F6.3,1X,F6.3,
c     *2X,F6.0,1X,F6.3,1X,F6.3,2X,F6.3,1X,F6.3)
 5    CONTINUE
c      PRINT 8
c 8    FORMAT(2X,' *****************************')
c      PRINT 9
c 9    FORMAT(1X,'#IMF',3X,'TEMC',3X,'CULC',5X,'EF',
c     *5X,'ELF',4X,'E71',4X,'EHF',4X,'ZLF',3X,'ZHF',3X,'ZSF',
c     *3X,'YSF')
      DO 10 I=1,20
      IMF0=I-1
c$$$      PRINT 11,IMF0,TEMC(I),CULC(I),EF(I),ELF(I),E71(I),EHF(I),
c$$$     *ZLF(I),ZHF(I),ZSF(I),YSF(I)
c$$$ 11   FORMAT(1X,I4,1X,F6.2,1X,F6.3,1X,F6.3,2X,F6.3,1X,F6.3,
c$$$     *1X,F6.3,2X,F5.2,1X,F5.2,1X,F5.2,1X,F5.3)
 10   CONTINUE
c      PRINT 8
c      PRINT 14
c 14   FORMAT(1X,'#IMF',5X,'ALF',4X,'A71',4X,'AHF',
c     *4X,'ELFN',3X,'E71N',3X,'EHFN')
      DO 12 I=1,20
      IMF0=I-1
c      PRINT 13,IMF0,ALF(I),A71(I),AHF(I),ELFN(I),E71N(I),EHFN(I)
c 13   FORMAT(1X,I4,2X,F6.1,1X,F6.1,1X,F6.1,2X,F6.4,1X,F6.4,
c     *1X,F6.4)
 12   CONTINUE
c      PRINT 8
      RETURN
      END
      SUBROUTINE HOTF6B
c --- for hot fragments (final as Z=6) in the break-up volume 
c  (and for accompany fragments: Z=1-5, Z>6, Z>20 in case of IMFs: Z=3-20)
      COMMON /BLHF61/YIMF(20),YZ6(20),DYZ6(20)
      COMMON /BLHF62/Y6T,R6T,Y6F(20),R6F(20),DR6F(20)
      COMMON /BLHF63/YLF(20),DYLF(20),YHF(20),DYHF(20),YSF(20)
      COMMON /BLHF64/ZLF(20),ZHF(20),ZSF(20),Z6F(20)
      COMMON /BLHF65/CULC(20),TEMC(20),EF(20),ELF(20),E6F(20),EHF(20)
      COMMON /BLHF66/ALF(20),A6F(20),AHF(20),ELFN(20),E6FN(20),EHFN(20)
      COMMON /BLHF67/YCLF(20),DYCLF(20),YCHF(20),DYCHF(20),YCSF(20)
      COMMON /BLACC1/NACLF(20,50),NAC6F(20,50),NACHF(20,50)
      COMMON /BLACC0/ACLF(20,50),AC6F(20,50),ACHF(20,50)
      Y6T=0.
      R6T=0.
      DO 1 I=1,20
      ELFN(I)=0.
      E6FN(I)=0.
      EHFN(I)=0.
      ALF(I)=0.
      A6F(I)=0.
      AHF(I)=0.
      CULC(I)=0.
      TEMC(I)=0.
      EF(I)=0.
      ELF(I)=0.
      E6F(I)=0.
      EHF(I)=0.
      YIMF(I)=0.
      YHF(I)=0.
      DYHF(I)=0.
      YCHF(I)=0.
      DYCHF(I)=0.
      YLF(I)=0.
      DYLF(I)=0.
      YCLF(I)=0.
      DYCLF(I)=0.
      YZ6(I)=0.
      DYZ6(I)=0.
      YSF(I)=0.
      YCSF(I)=0.
      Y6F(I)=0.
      R6F(I)=0.
      DR6F(I)=0.
      ZSF(I)=0.
      ZHF(I)=0.
      ZLF(I)=0.
      Z6F(I)=0.
      DO 2 J=1,50
      ACLF(I,J)=0.
      AC6F(I,J)=0.
      ACHF(I,J)=0.
      NACLF(I,J)=0
      NAC6F(I,J)=0
      NACHF(I,J)=0
 2    CONTINUE
 1    CONTINUE
      RETURN
      END
      SUBROUTINE HOTF6E
c --- for hot fragments (final as Z=6) in the break-up volume 
c  (and for accompany fragments: Z=1-5, Z>6, Z>20 in case of IMFs: Z=3-20)
      COMMON /BLHF61/YIMF(20),YZ6(20),DYZ6(20)
      COMMON /BLHF62/Y6T,R6T,Y6F(20),R6F(20),DR6F(20)
      COMMON /BLHF63/YLF(20),DYLF(20),YHF(20),DYHF(20),YSF(20)
      COMMON /BLHF64/ZLF(20),ZHF(20),ZSF(20),Z6F(20)
      COMMON /BLHF65/CULC(20),TEMC(20),EF(20),ELF(20),E6F(20),EHF(20)
      COMMON /BLHF66/ALF(20),A6F(20),AHF(20),ELFN(20),E6FN(20),EHFN(20)
      COMMON /BLHF67/YCLF(20),DYCLF(20),YCHF(20),DYCHF(20),YCSF(20)
      COMMON /BLACC1/NACLF(20,50),NAC6F(20,50),NACHF(20,50)
      COMMON /BLACC0/ACLF(20,50),AC6F(20,50),ACHF(20,50)
      COMMON /BLACCL/ACL(50,199),ITN(50),JJN,NSIGN,ZSIGN(199)
      RSYS=1.82*1.17*(160.**0.3333333)
      IF(Y6T.GT.0.) R6T=R6T/(Y6T*RSYS)
      DO 1 I=1,20
      IF(ALF(I).GT.0.) ELFN(I)=ELF(I)/ALF(I)
      IF(AHF(I).GT.0.) EHFN(I)=EHF(I)/AHF(I)
      IF(A6F(I).GT.0.) E6FN(I)=E6F(I)/A6F(I)
      IF(YLF(I).GT.0.) ELF(I)=ELF(I)/YLF(I)
      IF(YHF(I).GT.0.) EHF(I)=EHF(I)/YHF(I)
      IF(Y6F(I).GT.0.) E6F(I)=E6F(I)/Y6F(I)
      IF(YSF(I).GT.0.) ZSF(I)=ZSF(I)/YSF(I)
      IF(YLF(I).GT.0.) ZLF(I)=ZLF(I)/YLF(I)
      IF(Y6F(I).GT.0.) Z6F(I)=Z6F(I)/Y6F(I)
      IF(YHF(I).GT.0.) ZHF(I)=ZHF(I)/YHF(I)
      IF(YIMF(I).GT.0.) YLF(I)=YLF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) YCLF(I)=YCLF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) DYCLF(I)=DYCLF(I)/YIMF(I)
      DDD=DYCLF(I)-YCLF(I)**2
      IF(DDD.GT.0.) DYCLF(I)=SQRT(DDD)
      IF(DDD.LE.0.) DYCLF(I)=0.
      IF(YIMF(I).GT.0.) YHF(I)=YHF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) YCHF(I)=YCHF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) DYCHF(I)=DYCHF(I)/YIMF(I)
      DDD=DYCHF(I)-YCHF(I)**2
      IF(DDD.GT.0.) DYCHF(I)=SQRT(DDD)
      IF(DDD.LE.0.) DYCHF(I)=0.
      IF(Y6F(I).GT.0.) R6F(I)=R6F(I)/(Y6F(I)*RSYS)
      IF(Y6F(I).GT.0.) DR6F(I)=DR6F(I)/(Y6F(I)*RSYS*RSYS)
      DDD=DR6F(I)-R6F(I)**2
      IF(DDD.GT.0.) DR6F(I)=SQRT(DDD)
      IF(DDD.LE.0.) DR6F(I)=0.
      IF(YIMF(I).GT.0.) YZ6(I)=YZ6(I)/YIMF(I)
      IF(YIMF(I).GT.0.) DYZ6(I)=DYZ6(I)/YIMF(I)
      DDD=DYZ6(I)-YZ6(I)**2
      IF(DDD.GT.0.) DYZ6(I)=SQRT(DDD)
      IF(DDD.LE.0.) DYZ6(I)=0.
      IF(YIMF(I).GT.0.) Y6F(I)=Y6F(I)/YIMF(I)
      IF(YIMF(I).GT.0.) YSF(I)=YSF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) YCSF(I)=YCSF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) CULC(I)=CULC(I)/YIMF(I)
      IF(YIMF(I).GT.0.) TEMC(I)=TEMC(I)/YIMF(I)
      IF(YIMF(I).GT.0.) EF(I)=EF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) ALF(I)=ALF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) AHF(I)=AHF(I)/YIMF(I)
      IF(YIMF(I).GT.0.) A6F(I)=A6F(I)/YIMF(I)
 1    CONTINUE
      DO 15 I=1,20
      IF(EF(I).GT.0.) ELF(I)=ELF(I)/EF(I)
      IF(EF(I).GT.0.) E6F(I)=E6F(I)/EF(I)
      IF(EF(I).GT.0.) EHF(I)=EHF(I)/EF(I)
      IF(EF(I).GT.0.) ELFN(I)=ELFN(I)/EF(I)
      IF(EF(I).GT.0.) E6FN(I)=E6FN(I)/EF(I)
      IF(EF(I).GT.0.) EHFN(I)=EHFN(I)/EF(I)
 15   CONTINUE
c      PRINT 2
c 2    FORMAT(2X,' **** for hot fragments /new - HOTFR6/ ****')
c      PRINT 4,Y6T,R6T
c 4    FORMAT(2X,'tot.numb.of final "Z=6" Y6T=',F9.0,
c     *'  their mean radius R6T/RSYS=',F9.4)
c      PRINT 6
c 6    FORMAT(1X,'#IMF',3X,'YIMF',4X,'YLF',3X,'YCLF',
c     *5X,'YZ6',3X,'DYZ6',5X,'Y6F',4X,'R6F',3X,'DR6F',
c     *5X,'YHF',3X,'YCHF')
      DO 5 I=1,20
      IMF0=I-1
c      PRINT 7,IMF0,YIMF(I),YLF(I),YCLF(I),YZ6(I),DYZ6(I),
c     *Y6F(I),R6F(I),DR6F(I),YHF(I),YCHF(I)
c 7    FORMAT(1X,I4,1X,F6.0,1X,F6.3,1X,F6.3,2X,F6.3,1X,F6.3,
c     *2X,F6.2,1X,F6.3,1X,F6.3,2X,F6.3,1X,F6.3)
 5    CONTINUE
c      PRINT 8
c 8    FORMAT(2X,' *****************************')
c      PRINT 9
c 9    FORMAT(1X,'#IMF',3X,'TEMC',3X,'CULC',5X,'EF',
c     *5X,'ELF',4X,'E6F',4X,'EHF',4X,'ZLF',3X,'Z6F',3X,'ZHF',
c     *3X,'ZSF',3X,'YSF')
      DO 10 I=1,20
      IMF0=I-1
c      PRINT 11,IMF0,TEMC(I),CULC(I),EF(I),ELF(I),E6F(I),EHF(I),
c     *ZLF(I),Z6F(I),ZHF(I),ZSF(I),YSF(I)
c 11   FORMAT(1X,I4,1X,F6.2,1X,F6.3,1X,F6.3,2X,F6.3,1X,F6.3,
c     *1X,F6.3,2X,F5.2,1X,F5.2,1X,F5.2,1X,F5.2,1X,F5.3)
 10   CONTINUE
c      PRINT 8
c      PRINT 14
c 14   FORMAT(1X,'#IMF',5X,'ALF',4X,'A6F',4X,'AHF',
c     *4X,'ELFN',3X,'E6FN',3X,'EHFN')
      DO 12 I=1,20
      IMF0=I-1
c      PRINT 13,IMF0,ALF(I),A6F(I),AHF(I),ELFN(I),E6FN(I),EHFN(I)
c 13   FORMAT(1X,I4,2X,F6.1,1X,F6.1,1X,F6.1,2X,F6.4,1X,F6.4,
c     *1X,F6.4)
 12   CONTINUE
c      PRINT 16
c 16   FORMAT(5X,'******* for accelration ********')      
c      PRINT 21,(ITN(I),I=1,50)
c 21   FORMAT(1X,'time ITN(1-50)=',10I6)
      DO 17 I=1,20
      DO 17 J=1,50
      IF(NACLF(I,J).GT.0) ACLF(I,J)=100*ACLF(I,J)/FLOAT(NACLF(I,J))
      IF(NAC6F(I,J).GT.0) AC6F(I,J)=100*AC6F(I,J)/FLOAT(NAC6F(I,J))
      IF(NACHF(I,J).GT.0) ACHF(I,J)=100*ACHF(I,J)/FLOAT(NACHF(I,J))
 17   CONTINUE
c 19   FORMAT(1X,6(I4,1X,F7.5,1X))
c      PRINT 20
c 20   FORMAT(2X,'NACLF and avr.accel. ACLF*100 for dif.times',
c     *' at IMF=1,...,6')
c      DO 18 J=1,50
c      PRINT 19,(NACLF(I,J),ACLF(I,J),I=2,7)
c 18   CONTINUE
c      PRINT 22
c 22   FORMAT(2X,'NAC6F and avr.accel. AC6F*100 for dif.times',
c     *' at IMF=1,...,6')
c      DO 23 J=1,50
c      PRINT 19,(NAC6F(I,J),AC6F(I,J),I=2,7)
c 23   CONTINUE
c      PRINT 24
c 24   FORMAT(2X,'NACHF and avr.accel. ACHF*100 for dif.times',
c     *' at IMF=1,...,6')
c      DO 25 J=1,50
c      PRINT 19,(NACHF(I,J),ACHF(I,J),I=2,7)
c 25   CONTINUE
c      PRINT 8
      RETURN
      END
      SUBROUTINE HOTFR6(IPT,KST1,A0,Z0,AM,CH,PN0,TEMP,ECOLB)
c --- for hot fragments (final as Z=6) in the break-up volume 
c  (and for accompany fragments: Z=1-5, Z>6, Z>20 in case of IMFs: Z=3-20)
      DIMENSION XX(199),YY(199),ZZ(199),AM(500),CH(500),PN0(3,500)
      DIMENSION PA(500),PAZ(500)
      COMMON /BLCEN/XC(500),YC(500),ZC(500) /BLHKST/IHFKST(500,2)
      COMMON /BLOKC/SPTU(10,500)
      COMMON /BLHF61/YIMF(20),YZ6(20),DYZ6(20)
      COMMON /BLHF62/Y6T,R6T,Y6F(20),R6F(20),DR6F(20)
      COMMON /BLHF63/YLF(20),DYLF(20),YHF(20),DYHF(20),YSF(20)
      COMMON /BLHF64/ZLF(20),ZHF(20),ZSF(20),Z6F(20)
      COMMON /BLHF65/CULC(20),TEMC(20),EF(20),ELF(20),E6F(20),EHF(20)
      COMMON /BLHF66/ALF(20),A6F(20),AHF(20),ELFN(20),E6FN(20),EHFN(20)
      COMMON /BLHF67/YCLF(20),DYCLF(20),YCHF(20),DYCHF(20),YCSF(20)
      COMMON /BLACC0/ACLF(20,50),AC6F(20,50),ACHF(20,50)
      COMMON /BLACC1/NACLF(20,50),NAC6F(20,50),NACHF(20,50)
      COMMON /BLACCL/ACL(50,199),ITN(50),JJN,NSIGN,ZSIGN(199)
c -----------------
c      PRINT 26,JJN,NSIGN
c 26   FORMAT(2X,'hotfr6; c.accel.:  JJN=',I4,' NSIGN=',I4)
c      PRINT 27,(ITN(I),I=1,50)
c 27   FORMAT(1X,'times:',15I4)
c      PRINT 28,(ZSIGN(I),I=1,NSIGN)
c 28   FORMAT(1X,'ch.part.:',15F4.0)
c -----------------
c      IAT=0
c      IZT=0
c      IZHT=0
c      EKINT=0.
c      EKINH=0.
c -----------------
      IAHT=0
      RCMX=0.
      RCMY=0.
      RCMZ=0.
      DO 1 I=1,IPT
      XX(I)=XC(I)
      YY(I)=YC(I)
      ZZ(I)=ZC(I)
      IAH=INT(AM(I)/0.94+0.5)
      IZH=INT(CH(I)+0.5)
      PA(I)=IAH
      PAZ(I)=IZH
      IAHT=IAHT+IAH
      RCMX=RCMX+IAH*XX(I)
      RCMY=RCMY+IAH*YY(I)
      RCMZ=RCMZ+IAH*ZZ(I)
c ------------------
c      EN0=(PN0(1,I)**2+PN0(2,I)**2+PN0(3,I)**2)/(2.*AM(I))
c      EKINH=EKINH+EN0
c      IZHT=IZHT+IZH
c      PRINT 22,IAH,IZH
c 22   FORMAT(2X,'hotfr6:  IAH,IZH=',2I4)
c ------------------
 1    CONTINUE
      RCMX=RCMX/FLOAT(IAHT)
      RCMY=RCMY/FLOAT(IAHT)
      RCMZ=RCMZ/FLOAT(IAHT)
c ------------------
c      RCM=SQRT(RCMX**2+RCMY**2+RCMZ**2)
c      PRINT 21,IAHT,IZHT,EKINH,RCM
c 21   FORMAT(2X,'hotfr6:  IAHT,IZHT=',2I4,' EKINH(gev)=',F7.4,
c     *' RCM(fm)=',F6.2)
c ------------------
      IMF=0
      IZ6=0
      DO 2 I=1,KST1
      IZ=INT(SPTU(8,I)+0.5)
      IA=INT(SPTU(9,I)/0.94+0.5)
c ----------------------
c      EK=SPTU(7,I)
c      EKINT=EKINT+EK
c      IAT=IAT+IA
c      IZT=IZT+IZ
c      PRINT 20,IA,IZ,EK
c 20   FORMAT(2X,'hotfr6:  IA,IZ=',2I4,' EK=',F7.4)
c ----------------------
      IF(IZ.GE.3.AND.IZ.LE.20) IMF=IMF+1
      IF(IZ.EQ.6) IZ6=IZ6+1
 2    CONTINUE
c ----------------------
c      PRINT 23,IAT,IZT,IMF,IZ6,EKINT
c 23   FORMAT(2X,'hotfr6:  IAT,IZT=',2I4,' IMF=',I3,' IZ6=',I3,
c     *' EKINT(gev)=',F8.4)
c ----------------------
      IF(IZ6.EQ.0.OR.JJN.EQ.0) GO TO 4
      NILF=0
      NI6F=0
      NIHF=0
      NISF=0
      EF0=0.
      EL0=0.
      E60=0.
      EH0=0.
      AL0=0.
      A60=0.
      AH0=0.
      DO 5 I=1,IPT
      IAH=INT(PA(I)+0.5)
      IZH=INT(PAZ(I)+0.5)
      EN0=(PN0(1,I)**2+PN0(2,I)**2+PN0(3,I)**2)/(2.*AM(I))
      RR=SQRT((XX(I)-RCMX)**2+(YY(I)-RCMY)**2+(ZZ(I)-RCMZ)**2)
      J1=IHFKST(I,1)
      J2=IHFKST(I,2)
c -------------------
c      PRINT 25,IAH,IZH,EN0,RR,J1,J2
c 25   FORMAT(7X,'primar.fragm.:  IAH,IZH=',2I4,' EN0=',F7.4,
c     *' RR(fm)=',F5.2,' J1,J2=',2I4)
c -------------------
      ILF=0
      I6F=0
      IHF=0
      ISF=0
      DO 6 J=J1,J2
      IZ=INT(SPTU(8,J)+0.5)
      IA=INT(SPTU(9,J)/0.94+0.5)
      EK=SPTU(7,J)
c -------------------
c      PRINT 24,IA,IZ,EK
c 24   FORMAT(20X,'second.fragm.:  IA,IZ=',2I4,' EK=',F7.4)
c -------------------
      IF(IZ.GE.1.AND.IZ.LE.5) ILF=ILF+1
      IF(IZ.EQ.6) I6F=I6F+1
      IF(IZ.GE.7) IHF=IHF+1
      IF(IZ.GT.20) ISF=ISF+1
 6    CONTINUE
      NILF=NILF+ILF
      NI6F=NI6F+I6F
      NIHF=NIHF+IHF
      NISF=NISF+ISF
      IF(ILF.GE.1.AND.I6F.EQ.0.AND.IHF.EQ.0) AL0=AL0+IAH
      IF(ILF.GE.1.AND.I6F.EQ.0.AND.IHF.EQ.0) 
     *YLF(IMF+1)=YLF(IMF+1)+1.
      IF(I6F.GE.1.AND.IHF.EQ.0) A60=A60+IAH
      IF(I6F.GE.1.AND.IHF.EQ.0) Y6F(IMF+1)=Y6F(IMF+1)+1.
      IF(IHF.GE.1) AH0=AH0+IAH
      IF(IHF.GE.1) YHF(IMF+1)=YHF(IMF+1)+1.
      IF(ISF.GE.1) YSF(IMF+1)=YSF(IMF+1)+1.
      IF(ILF.GE.1.OR.I6F.GE.1.OR.IHF.GE.1) EF0=EF0+EN0
      IF(ILF.GE.1.AND.I6F.EQ.0.AND.IHF.EQ.0) EL0=EL0+EN0
      IF(I6F.GE.1.AND.IHF.EQ.0) E60=E60+EN0
      IF(IHF.GE.1) EH0=EH0+EN0
      IF(I6F.GE.1.AND.IHF.EQ.0) R6F(IMF+1)=R6F(IMF+1)+RR
      IF(I6F.GE.1.AND.IHF.EQ.0) DR6F(IMF+1)=DR6F(IMF+1)+RR*RR
      IF(I6F.GE.1.AND.IHF.EQ.0) R6T=R6T+RR
      IF(I6F.GE.1.AND.IHF.EQ.0) Y6T=Y6T+1.
      IF(ILF.GE.1.AND.I6F.EQ.0.AND.IHF.EQ.0) 
     *ZLF(IMF+1)=ZLF(IMF+1)+IZH
      IF(I6F.GE.1.AND.IHF.EQ.0) Z6F(IMF+1)=Z6F(IMF+1)+IZH
      IF(IHF.GE.1) ZHF(IMF+1)=ZHF(IMF+1)+IZH
      IF(ISF.GE.1) ZSF(IMF+1)=ZSF(IMF+1)+IZH
c --- acceleration of fragments at different moments ---
      IF(JJN.EQ.0.OR.I.GT.NSIGN) GO TO 3
      IZH2=INT(ZSIGN(I)+0.5)
c ----------------
c      PRINT 29,I,IZH,IZH2,ILF,I6F,IHF,ISF
c  29  FORMAT(2X,'before ACLF. I=',I2,' IZH,IZH2=',2I3,
c     *' ILF,I6F,IHF,ISF=',4I4)
c      PRINT 30,(ACL(J,I),J=1,50)
c 30   FORMAT(2X,'ACL=',5E11.3)
c ----------------
      IF(IZH.NE.IZH2) GO TO 3
      DO 11 JT=1,50
      IF(ILF.GE.1.AND.I6F.EQ.0.AND.IHF.EQ.0) 
     *ACLF(IMF+1,JT)=ACLF(IMF+1,JT)+ACL(JT,I)
      IF(ILF.GE.1.AND.I6F.EQ.0.AND.IHF.EQ.0) 
     *NACLF(IMF+1,JT)=NACLF(IMF+1,JT)+1
      IF(I6F.GE.1.AND.IHF.EQ.0) 
     *AC6F(IMF+1,JT)=AC6F(IMF+1,JT)+ACL(JT,I)
      IF(I6F.GE.1.AND.IHF.EQ.0) 
     *NAC6F(IMF+1,JT)=NAC6F(IMF+1,JT)+1
      IF(IHF.GE.1) ACHF(IMF+1,JT)=ACHF(IMF+1,JT)+ACL(JT,I)
      IF(IHF.GE.1) NACHF(IMF+1,JT)=NACHF(IMF+1,JT)+1
 11   CONTINUE
 3    CONTINUE
c -----------------
 5    CONTINUE
      YIMF(IMF+1)=YIMF(IMF+1)+1.
      YCSF(IMF+1)=YCSF(IMF+1)+NISF
      YCLF(IMF+1)=YCLF(IMF+1)+NILF
      DYCLF(IMF+1)=DYCLF(IMF+1)+NILF*NILF
      YZ6(IMF+1)=YZ6(IMF+1)+NI6F
      DYZ6(IMF+1)=DYZ6(IMF+1)+NI6F*NI6F
      YCHF(IMF+1)=YCHF(IMF+1)+NIHF
      DYCHF(IMF+1)=DYCHF(IMF+1)+NIHF*NIHF
      CULC(IMF+1)=CULC(IMF+1)+ECOLB
      TEMC(IMF+1)=TEMC(IMF+1)+TEMP
      EF(IMF+1)=EF(IMF+1)+EF0
      ELF(IMF+1)=ELF(IMF+1)+EL0
      E6F(IMF+1)=E6F(IMF+1)+E60
      EHF(IMF+1)=EHF(IMF+1)+EH0
      ALF(IMF+1)=ALF(IMF+1)+AL0
      A6F(IMF+1)=A6F(IMF+1)+A60
      AHF(IMF+1)=AHF(IMF+1)+AH0
 4    CONTINUE
      RETURN
      END
      SUBROUTINE FIXT(T,K,M,AMP,ZMP)
      REAL K,LT
      COMMON /BLTMIC/TMICR,TMICR2,TMICT,NMICR
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLOK20/BT2,DBT2 /BLSMIC/SMIC
      COMMON /BLTMI2/TDIS(206)
      COMMON /BSTRAN/ITRAN /BLIKAP/IKAPPA
      DIMENSION AMP(500),ZMP(500),IAM(500),IZM(500)
      DO 1 I=1,M
      IZM(I)=INT(ZMP(I)+0.5)
      IAM(I)=INT(AMP(I)/0.94+0.5)
 1    CONTINUE
      A013=A0**0.333333
c --- keep constant or vary with multiplic. translational volume ---
      IF(IKAPPA.EQ.1) VF=K*V0
      IF(IKAPPA.EQ.0) 
     *VF=V0*((1.+1.4*(M**0.333333-1)/(RADNCL*A013))**3-1.)
c ---
      M1=M-1
c      FAKT=1.
      FAKTL=0.
      IF(M1.LE.0) GO TO 35
      DO 32 I=1,M1
      FFF=1.
      IM=I+1
      DO 33 II=IM,M
      IF(IAM(I).EQ.IAM(II).AND.IZM(I).EQ.IZM(II)) FFF=FFF+1.
 33   CONTINUE
c      FAKT=FAKT*FFF
      FAKTL=FAKTL+ALOG(FFF)
 32   CONTINUE
 35   CONTINUE
c      PRFAKT=1.
c      PRFAKT=PRFAKT*FAKT
      PFAKTL=FAKTL
c      PRGA=1.
c      PRA32=1.
      PRGA=0.
      PRA32=0.
      DO 34 I=1,M
      IA=IAM(I)
      A=IA
      GAA=1.
      IF(IA.EQ.1) GAA=2.
      IF(IA.EQ.2) GAA=3.
      IF(IA.EQ.3) GAA=2.
cc      PRGA=PRGA*GA(IA)
c      PRGA=PRGA*GAA
c      PRA32=PRA32*(A*SQRT(A))
      PRGA=PRGA+ALOG(GAA)
      PRA32=PRA32+1.5*ALOG(A)
 34   CONTINUE
      SCON=0.
      DO 62 I=1,M
      IA=IAM(I)
      A=IA
      IF(IA-4) 63,63,64
 63   SAIN=0.
c      IF(IA.EQ.4) SAIN=2*T*4./E11(IA)
      GO TO 65
 64   SAIN=2*T*A/E11(IA)-DBT2*A**0.666667
 65   CONTINUE
      SCON=SCON+SAIN
 62   CONTINUE
      LT=16.15/SQRT(T)
c      STRAN=ALOG(PRA32/PRFAKT)+(M-1)*ALOG(VF/LT**3)+1.5*(M-1)-
c      STRAN=ALOG(PRA32)-PFAKTL+(M-1)*ALOG(VF/LT**3)+1.5*(M-1)-
c     *ALOG(A0*SQRT(A0))
c      STRAN=ALOG(PRA32)-PFAKTL+1.5*(M-1)-ALOG(A0*SQRT(A0))
      IF(ITRAN.EQ.1) GO TO 91
      STRAN=PRA32-PFAKTL+1.5*(M-1)-ALOG(A0*SQRT(A0))
      IF(M.GT.1) STRAN=STRAN+(M-1)*ALOG(VF/LT**3)
      GO TO 90
 91   CONTINUE
      IF(M.LE.1) STRAN=0.
      IF(M.LE.1) GO TO 90
      STRAN=PRA32+1.5*(M-1)-ALOG(A0*SQRT(A0))+(M-1)*ALOG(VF/LT**3)
      IF(STRAN.LT.10.) STRAN=ALOG(1.+EXP(STRAN))
      STRAN=STRAN-PFAKTL
 90   CONTINUE
c      STRAN=PRA32-PFAKTL+1.5*(M-1)-ALOG(A0*SQRT(A0))
c      IF(M.GT.1) STRAN=STRAN+(M-1)*ALOG(VF/LT**3)
c      IF(STRAN.LT.0.) STRAN=0.
c      SCON=SCON+ALOG(PRGA)+STRAN
      SCON=SCON+PRGA+STRAN
      SMIC=SMIC+SCON
      TMICT=T
      TMICR=TMICR+T
      NMICR=NMICR+1
      TMICR2=TMICR2+T*T
      CALL HIST1(T,0.,10.,0.05,TDIS,206,1.)
      RETURN
      END
      SUBROUTINE FIXTB
      COMMON /BLSMIC/SMIC
      COMMON /BLTMIC/TMICR,TMICR2,TMICT,NMICR
      COMMON /BLICOR/ YL5_0,YL5_16,YL6_2,YL6_4,YB8_3,YB8_17
      COMMON /BLTMI2/TDIS(206)
      DO 1 I=1,206
 1    TDIS(I)=0.
      SMIC=0.
      YL5_0=0.
      YL5_16=0.
      YL6_2=0.
      YL6_4=0.
      YB8_3=0.
      YB8_17=0.
      TMICR=0.
      NMICR=0.
      TMICR2=0.
      RETURN
      END
      SUBROUTINE FIXTE
      COMMON /BLSMIC/SMIC
      COMMON /BLTMIC/TMICR,TMICR2,TMICT,NMICR
      COMMON /BLICOR/ YL5_0,YL5_16,YL6_2,YL6_4,YB8_3,YB8_17
      COMMON /BENTRO/SSR
      COMMON /BLTMI2/TDIS(206)
c$$$      PRINT 3
c$$$ 3    FORMAT(2X,'distrib. microcan.temperat. TDIS(1-200)',
c$$$     *' (from 0 to 10MeV, step=0.05):')
c$$$      PRINT 4,(TDIS(I),I=1,200)
c$$$ 4    FORMAT(2X,10F6.0)
c$$$      PRINT 5,(TDIS(I),I=201,206)
c$$$ 5    FORMAT(2X,6F12.3)
      IF(NMICR.GT.0) TMICR=TMICR/FLOAT(NMICR)
      IF(NMICR.GT.0) SMIC=SMIC/FLOAT(NMICR)
      IF(NMICR.GT.0) TMICR2=TMICR2/FLOAT(NMICR)
      DDD=TMICR2-TMICR*TMICR
      IF(DDD.LE.0.) TMICR2=0.
      IF(DDD.GT.0.) TMICR2=SQRT(DDD)
c$$$      PRINT 1,NMICR,TMICR,TMICR2
c$$$ 1    FORMAT(2X,'over NMICR=',I6,' events: microcan.temp. TMICR=',
c$$$     *F6.2,' MeV, var. TMICR2=',F6.2)
c$$$      PRINT 2,SSR,SMIC
c$$$ 2    FORMAT(2X,'entropy: SSR=',F8.3,'  microcan. SMIC=',F8.3)
c ------------ temp. via unstable level ----------------
c      PRINT 112, YL5_0,YL5_16,YL6_2,YL6_4,YB8_3,YB8_17
c 112  FORMAT(1X,'excit.states: YL5_0,YL5_16=',F6.0,F5.0,
c     *' YL6_2,YL6_4=',F6.0,F5.0,' YB8_3,YB8_17=',F6.0,F5.0)
c      T_Li5=0.
c      T_Li6=0.
c      T_Be8=0.
c      IF(YL5_0.LE.0.OR.YL5_16.LE.0.) GO TO 120
c      T_Li5=16.66/ALOG(YL5_0/YL5_16)
c 120  CONTINUE
c      IF(YL6_2.LE.0.OR.YL6_4.LE.0.) GO TO 121
c      T_Li6=(4.31-2.17)/ALOG((2.*YL6_2)/(3.*YL6_4))
c 121  CONTINUE
c      IF(YB8_3.LE.0.OR.YB8_17.LE.0.) GO TO 122
c      T_Be8=(17.64-3.04)/ALOG((3.*YB8_3)/(5.*YB8_17))
c 122  CONTINUE
c      PRINT 111, T_Li5, T_Li6, T_Be8
c 111  FORMAT(2X,'temperature unstable states: T_Li5, T_Li6, T_Be8 =',
c     *3F7.2,' (MeV)')
c$$$      PRINT 113
c$$$ 113  FORMAT(2X,'================================================'/
c$$$     *2X,'            ')
      RETURN
      END
c 
      SUBROUTINE BFRENI
      COMMON /BFRE/ EHFR(500),SHFR(500),SEKHF,EHMAX,SHMAX
      DO 1 I=1,500
      EHFR(I)=0.
      SHFR(I)=0.
 1    CONTINUE
      SEKHF=0.
      EHMAX=0.
      SHMAX=0.
      RETURN
      END
      SUBROUTINE BFREN(INE,IP0,AM,PNT)
      COMMON /BFRE/ EHFR(500),SHFR(500),SEKHF,EHMAX,SHMAX
      DIMENSION AM(500),PNT(3,500)
      I1=IP0+1
      I2=INE+IP0
      IAMAX=0
      EEMAX=0
      DO 1 I=I1,I2
      IA=INT(AM(I)/0.94+0.1)
      P2=PNT(1,I)**2+PNT(2,I)**2+PNT(3,I)**2
      EHFR(IA)=EHFR(IA)+1000.*P2/(2.*AM(I))
      SEKHF=SEKHF+1000.*P2/(2.*AM(I))
      SHFR(IA)=SHFR(IA)+1.
      IF(IA.GT.IAMAX) EAMAX=1000.*P2/(2.*AM(I))
      IF(IA.GT.IAMAX) IAMAX=IA
 1    CONTINUE
      IF(IAMAX.GT.4) EEMAX=EAMAX
      IF(IAMAX.GT.4) EHMAX=EHMAX+EEMAX
      IF(IAMAX.GT.4) SHMAX=SHMAX+IAMAX
      RETURN
      END
      SUBROUTINE BFRENE(IA0,NFRAG)
      COMMON /BFRE/ EHFR(500),SHFR(500),SEKHF,EHMAX,SHMAX
      DO 1 I=1,IA0
      IF(SHFR(I).GT.0.) EHFR(I)=EHFR(I)/(I*SHFR(I))
 1    CONTINUE
      IF(NFRAG.GT.0) SEKHF=SEKHF/(FLOAT(IA0*NFRAG))
c$$$      PRINT 4,SEKHF
c$$$ 4    FORMAT(1X,'sum kin.energ.hot fragm.before Coulomb (MeV/n)',
c$$$     *' SEKHF=',F6.2)
      IF(SHMAX.GT.0.) EHMAX=EHMAX/SHMAX
c      PRINT 2,EHMAX
c 2    FORMAT(1X,' EHMAX(MeV/n)=',F6.2,
c     *' kin.energies (MeV/N) of hot fragm. before Coulomb')
c      PRINT 3,(EHFR(I),I=1,IA0)
c 3    FORMAT(2X,'EHFR=',10F7.2)
      RETURN
      END
c *** METROPOLIS microcanonical program of multifragmentation ***
cc ------- for including in ZVEZD1 - ZVEMET ! canceled, see smm_met5 -------
cc      SUBROUTINE METROP(A0,Z0,E0,IP,IP0,INEUTR,AMP,ZMP,RMP,TK,ECOLB) 
c ***
      SUBROUTINE ECB_GC
c --- calculation of average Coulomb barrier (ECBGC) in grand-canonics.
      REAL N,MU,K,LT,L
      COMMON /BLOK1/W0,TC,RADNCL,G0 /BLOK0/A0,Z0,V0,XZ0,E0,E0Q,IA0
      COMMON /BLOK2/B0,BT,DBT,LT,CP,PKP013 /BLOKN/N(500)
      COMMON /BLOK3/E11(500),XZ(500),GA(500)
      COMMON /BLECB0/ECBGC
      COMMON /BICOLE/ICOLE
      ECOEF=0.6*1.44/RADNCL
      EC=ECOEF*PKP013*Z0*Z0/(A0**0.3333333)
      DO 2 I=1,IA0
      A=I
      A23=A**0.66666667
      EC=EC-ECOEF*PKP013*A23*A*XZ(I)*XZ(I)*N(I)
 2    CONTINUE
      ECBGC=EC
      IF(ICOLE.EQ.-1) ECBGC=0.
      RETURN
      END
c ***
c ***
      SUBROUTINE DCR00
      COMMON /BCR1/ SZMAX,SRYMAX,SRRMAX,DRYMAX,DRRMAX,SVYMAX,
     *SVVMAX,DVYMAX,DVVMAX,RYMAX(46),RRMAX(26),VYMAX(46),VVMAX(26),SAMAX
     *,NZMAX
      COMMON /BCR2/ SZMA2,SRYMA2,SRRMA2,DRYMA2,DRRMA2,SVYMA2,
     *SVVMA2,DVYMA2,DVVMA2,RYMA2(46),RRMA2(26),VYMA2(46),VVMA2(26),SAMA2
     *,NZMA2
      COMMON /BCR3/ ZIMF,SRYIMF,SRRIMF,DRYIMF,DRRIMF,SVYIMF,
     *SVVIMF,DVYIMF,DVVIMF,RYIMF(46),RRIMF(26),VYIMF(46),VVIMF(26),AIMF
     *,NIMF
      COMMON /BCR4/ ACMMAX(26),ACMMA2(26),ACMIMF(26)
      COMMON /BCR5/ VYMAXS(56),VYMA2S(56),VYIMFS(56)
      COMMON /BCR6/ ROZ_VY(56),ROF_VY(56),ROB_VY(56),VYZ12(56),VYZ38(56)
      COMMON /BCR7/ PRYIMF(46),PVYIMF(46),PRYMAX(46),PVYMAX(46),
     *PVYTO1(46),CVYTO1(46),PVYTOT(46),CVYTOT(46),
     *PRYTO1(46),CRYTO1(46),PRYTOT(46),CRYTOT(46)
      COMMON /BCR8/SRY4HE,SRR4HE,DRY4HE,DRR4HE,SVY4HE,ACM4HE(26),
     *SVV4HE,DVY4HE,DVV4HE,RY4HE(46),RR4HE(26),VY4HE(46),VV4HE(26),
     *VY4HES(56)
     *,N4HE
      NZMAX=0
      SZMAX=0.
      SAMAX=0.
      SRYMAX=0.
      SRRMAX=0.
      DRYMAX=0.
      DRRMAX=0.
      SVYMAX=0.
      SVVMAX=0.
      DVYMAX=0.
      DVVMAX=0.
      NZMA2=0
      SZMA2=0.
      SAMA2=0.
      SRYMA2=0.
      SRRMA2=0.
      DRYMA2=0.
      DRRMA2=0.
      SVYMA2=0.
      SVVMA2=0.
      DVYMA2=0.
      DVVMA2=0.
      NIMF=0
      ZIMF=0.
      AIMF=0.
      SRYIMF=0.
      SRRIMF=0.
      DRYIMF=0.
      DRRIMF=0.
      SVYIMF=0.
      SVVIMF=0.
      DVYIMF=0.
      DVVIMF=0.
      N4HE=0
      SRY4HE=0.
      SRR4HE=0.
      DRY4HE=0.
      DRR4HE=0.
      SVY4HE=0.
      SVV4HE=0.
      DVY4HE=0.
      DVV4HE=0.
      DO 1 I=1,46
      RYMAX(I)=0.
      IF(I.LE.26) RRMAX(I)=0.
      VYMAX(I)=0.
      IF(I.LE.26) VVMAX(I)=0.
      RYMA2(I)=0.
      IF(I.LE.26) RRMA2(I)=0.
      VYMA2(I)=0.
      IF(I.LE.26) VVMA2(I)=0.
      RYIMF(I)=0.
      IF(I.LE.26) RRIMF(I)=0.
      VYIMF(I)=0.
      IF(I.LE.26) VVIMF(I)=0.
      IF(I.LE.26) ACMIMF(I)=0.
      RY4HE(I)=0.
      IF(I.LE.26) RR4HE(I)=0.
      VY4HE(I)=0.
      IF(I.LE.26) VV4HE(I)=0.
      IF(I.LE.26) ACM4HE(I)=0.
      IF(I.LE.26) ACMMA2(I)=0.
      IF(I.LE.26) ACMMAX(I)=0.
      PRYIMF(I)=0.
      PVYIMF(I)=0.
      PRYMAX(I)=0.
      PVYMAX(I)=0.
      PVYTO1(I)=0.
      CVYTO1(I)=0.
      PVYTOT(I)=0.
      CVYTOT(I)=0.
      PRYTO1(I)=0.
      CRYTO1(I)=0.
      PRYTOT(I)=0.
      CRYTOT(I)=0.
  1   CONTINUE
      DO 2 I=1,56
      VYZ12(I)=0.
      VYZ38(I)=0.
      ROZ_VY(I)=0.
      ROF_VY(I)=0.
      ROB_VY(I)=0.
      VYMAXS(I)=0.
      VYMA2S(I)=0.
      VYIMFS(I)=0.
      VY4HES(I)=0.
 2    CONTINUE
      RETURN
      END
      SUBROUTINE DCR(A0,Z0,IP0,AMP,ZMP,PN0,RMP)
c Analysis of hot fragments characteristics in freeze-out volume and 
c their velocities. Important: influence of the second source accounted !!
      COMMON /B1/ XX(200),YY(200),ZZ(200),PXX(200),PYY(200),PZZ(200),
     *IAA(200),IZZ(200)
      COMMON /BNUM/ IA0,IZ0,NFRAG1
      COMMON /BCR1/ SZMAX,SRYMAX,SRRMAX,DRYMAX,DRRMAX,SVYMAX,
     *SVVMAX,DVYMAX,DVVMAX,RYMAX(46),RRMAX(26),VYMAX(46),VVMAX(26),SAMAX
     *,NZMAX
      COMMON /BCR2/ SZMA2,SRYMA2,SRRMA2,DRYMA2,DRRMA2,SVYMA2,
     *SVVMA2,DVYMA2,DVVMA2,RYMA2(46),RRMA2(26),VYMA2(46),VVMA2(26),SAMA2
     *,NZMA2
      COMMON /BCR3/ ZIMF,SRYIMF,SRRIMF,DRYIMF,DRRIMF,SVYIMF,
     *SVVIMF,DVYIMF,DVVIMF,RYIMF(46),RRIMF(26),VYIMF(46),VVIMF(26),AIMF
     *,NIMF
      COMMON /BCR4/ ACMMAX(26),ACMMA2(26),ACMIMF(26)
      COMMON /BCR5/ VYMAXS(56),VYMA2S(56),VYIMFS(56)
      COMMON /BCR6/ ROZ_VY(56),ROF_VY(56),ROB_VY(56),VYZ12(56),VYZ38(56)
      COMMON /BCR7/ PRYIMF(46),PVYIMF(46),PRYMAX(46),PVYMAX(46),
     *PVYTO1(46),CVYTO1(46),PVYTOT(46),CVYTOT(46),
     *PRYTO1(46),CRYTO1(46),PRYTOT(46),CRYTOT(46)
      COMMON /BCR8/SRY4HE,SRR4HE,DRY4HE,DRR4HE,SVY4HE,ACM4HE(26),
     *SVV4HE,DVY4HE,DVV4HE,RY4HE(46),RR4HE(26),VY4HE(46),VV4HE(26),
     *VY4HES(56)
     *,N4HE
      COMMON /BDCR/VCMSP,VCMST
      DIMENSION AMP(500),ZMP(500),PN0(3,500),RMP(3,500)
cc      VCMS=0.25
c motion of projectile and target (for histogramming)
c -- 2 MeV/N 
c      VCMSP=0.25 
c      VCMST=0.02
c -- 3 MeV/N 
c      VCMSP=0.24 
c      VCMST=0.03
c -- 4 MeV/N 
c      VCMSP=0.23 
c      VCMST=0.04
c -- 5 MeV/N
c      VCMSP=0.22 
c      VCMST=0.05
c --
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
      NFRAG1=IP0
      DO 501 IR=1,NFRAG1
      IAA(IR)=INT(AMP(IR)/0.94+0.5)
      IZZ(IR)=INT(ZMP(IR)+0.1)
      PXX(IR)=1000.*PN0(1,IR)
      PYY(IR)=1000.*PN0(2,IR)
      PZZ(IR)=1000.*PN0(3,IR)
      XX(IR)=RMP(1,IR)
      YY(IR)=RMP(2,IR)
      ZZ(IR)=RMP(3,IR)
 501  CONTINUE
c --
      XCC=0.
      YCC=0.
      ZCC=0.
      CHC=0.
      PXCC=0.
      PYCC=0.
      PZCC=0.
      SAAA=0.
      IZMAX=0
      IZMA2=0
      ZBOU3=0.
      DO 1 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
cc -- exchanging of Y and Z coordinates in case of rotation along Z  
cc    and second source at Y (beam axis, see ALL4.for) -- not necessary!
cc      YK=YY(IR)
cc      ZK=ZZ(IR)
cc      PYK=PYY(IR)
cc      PZK=PZZ(IR)
cc      YY(IR)=ZK
cc      ZZ(IR)=YK
cc      PYY(IR)=PZK
cc      PZZ(IR)=PYK
c -----------------------------------------------------------
      IF(IZZZ.GE.3) ZBOU3=ZBOU3+IZZZ
c      CHC=CHC+IZZZ
c      XCC=XCC+IZZZ*XX(IR)
c      YCC=YCC+IZZZ*YY(IR)
c      ZCC=ZCC+IZZZ*ZZ(IR)
      XCC=XCC+IAAA*XX(IR)
      YCC=YCC+IAAA*YY(IR)
      ZCC=ZCC+IAAA*ZZ(IR)
      SAAA=SAAA+IAAA
      PXCC=PXCC+PXX(IR)
      PYCC=PYCC+PYY(IR)
      PZCC=PZCC+PZZ(IR)
      IF(IZZZ.GT.IZMAX) IRMAX=IR
      IF(IZZZ.GT.IZMAX) IZMAX=IZZZ
  1   CONTINUE
c -- respective to charge center --
c      XCC=XCC/CHC
c      YCC=YCC/CHC
c      ZCC=ZCC/CHC
c -- respective to mass center --
      XCC=XCC/SAAA
      YCC=YCC/SAAA
      ZCC=ZCC/SAAA
      VXCC=PXCC/(940.*SAAA)
      VYCC=PYCC/(940.*SAAA)
      VZCC=PZCC/(940.*SAAA)
c -- respective to geometrical center --
c      XCC=0
c      YCC=0.
c      ZCC=0.
c
c ------ limitation on analysed partitions ------
c      IF(IZMAX.LT.60) RETURN
c ------
      IF(IZMAX.GT.0) SZMAX=SZMAX+IZMAX
      IF(IZMAX.GT.0) SAMAX=SAMAX+IAA(IRMAX)
      IF(IZMAX.GT.0) NZMAX=NZMAX+1
      DO 2 IR=1,NFRAG1
      IF(IR.EQ.IRMAX) GO TO 2
      IZZZ=IZZ(IR)
      IF(IZZZ.GT.IZMA2) IRMA2=IR
      IF(IZZZ.GT.IZMA2) IZMA2=IZZZ
  2   CONTINUE
      IF(IZMA2.GT.0) SZMA2=SZMA2+IZMA2
      IF(IZMA2.GT.0) SAMA2=SAMA2+IAA(IRMA2)
      IF(IZMA2.GT.0) NZMA2=NZMA2+1
c ------- coordinates ------
      IF(IZMAX.LE.0) GO TO 3
      RX=XX(IRMAX)-XCC
      RY=YY(IRMAX)-YCC
      RZ=ZZ(IRMAX)-ZCC
      RR=SQRT(RX*RX+RY*RY+RZ*RZ)
      CALL HIST1(RY,-10.0,10.0,0.5,RYMAX,46,1.)
      CALL HIST1(RR,0.,10.0,0.5,RRMAX,26,1.)
      SRYMAX=SRYMAX+RY
      DRYMAX=DRYMAX+RY*RY
      SRRMAX=SRRMAX+RR
      DRRMAX=DRRMAX+RR*RR
c ------ velocities -------
c      VX=PXX(IRMAX)/(940.*IAA(IRMAX))
c      VY=PYY(IRMAX)/(940.*IAA(IRMAX))
c      VZ=PZZ(IRMAX)/(940.*IAA(IRMAX))
      VX=PXX(IRMAX)/(940.*IAA(IRMAX))-VXCC
      VY=PYY(IRMAX)/(940.*IAA(IRMAX))-VYCC
      VZ=PZZ(IRMAX)/(940.*IAA(IRMAX))-VZCC
      COST=VY/SQRT(VX**2+VY**2+VZ**2)
      CALL HIST1(COST,-1.,1.,0.1,ACMMAX,26,1.)
c      VY=VY+VCMS
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.25,0.25,0.0125,VYMAX,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VYMAXS,56,1.)
c      CALL HIST1(VYT,-0.1,0.4,0.01,VYMAXS,56,1.)
      CALL HIST1(VV,0.,0.5,0.025,VVMAX,26,1.)
      SVYMAX=SVYMAX+VY
      DVYMAX=DVYMAX+VY*VY
      SVVMAX=SVVMAX+VV
      DVVMAX=DVVMAX+VV*VV
c ------- for N/Z ratio -------
      PNZ=FLOAT(IAA(IRMAX)-IZZ(IRMAX))/FLOAT(IZZ(IRMAX))
      CALL HIST1(RY,-10.0,10.0,0.5,PRYMAX,46,PNZ)
      CALL HIST1(VY,-0.25,0.25,0.0125,PVYMAX,46,PNZ)
c -------------------------
 3    CONTINUE
c ------- coordinates ------
      IF(IZMA2.LE.0) GO TO 4
      RX=XX(IRMA2)-XCC
      RY=YY(IRMA2)-YCC
      RZ=ZZ(IRMA2)-ZCC
      RR=SQRT(RX*RX+RY*RY+RZ*RZ)
      CALL HIST1(RY,-10.0,10.0,0.5,RYMA2,46,1.)
      CALL HIST1(RR,0.,10.0,0.5,RRMA2,26,1.)
      SRYMA2=SRYMA2+RY
      DRYMA2=DRYMA2+RY*RY
      SRRMA2=SRRMA2+RR
      DRRMA2=DRRMA2+RR*RR
c ------ velocities -------
      VX=PXX(IRMA2)/(940.*IAA(IRMA2))-VXCC
      VY=PYY(IRMA2)/(940.*IAA(IRMA2))-VYCC
      VZ=PZZ(IRMA2)/(940.*IAA(IRMA2))-VZCC
      COST=VY/SQRT(VX**2+VY**2+VZ**2)
      CALL HIST1(COST,-1.,1.,0.1,ACMMA2,26,1.)
c      VY=VY+VCMS
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.25,0.25,0.0125,VYMA2,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VYMA2S,56,1.)
c      CALL HIST1(VYT,-0.1,0.4,0.01,VYMA2S,56,1.)
      CALL HIST1(VV,0.,0.5,0.025,VVMA2,26,1.)
      SVYMA2=SVYMA2+VY
      DVYMA2=DVYMA2+VY*VY
      SVVMA2=SVVMA2+VV
      DVVMA2=DVVMA2+VV*VV
 4    CONTINUE
c --------------------------
      DO 5 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
c      IF(IZZZ.LE.2.OR.IZZZ.GT.20) GO TO 5
      IF(IZZZ.NE.1.OR.IAAA.NE.1) GO TO 5
      NIMF=NIMF+1
      AIMF=AIMF+IAAA
      ZIMF=ZIMF+IZZZ
c ------- coordinates ------
      RX=XX(IR)-XCC
      RY=YY(IR)-YCC
      RZ=ZZ(IR)-ZCC
      RR=SQRT(RX*RX+RY*RY+RZ*RZ)
      SRYIMF=SRYIMF+RY
      DRYIMF=DRYIMF+RY*RY
      SRRIMF=SRRIMF+RR
      DRRIMF=DRRIMF+RR*RR
      CALL HIST1(RY,-10.0,10.0,0.5,RYIMF,46,1.)
      CALL HIST1(RR,0.,10.0,0.5,RRIMF,26,1.)
c ------ velocities -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      COST=VY/SQRT(VX**2+VY**2+VZ**2)
      CALL HIST1(COST,-1.,1.,0.1,ACMIMF,26,1.)
c      VY=VY+VCMS
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.25,0.25,0.0125,VYIMF,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VYIMFS,56,1.)
c      CALL HIST1(VYT,-0.1,0.4,0.01,VYIMFS,56,1.)
      CALL HIST1(VV,0.,0.5,0.025,VVIMF,26,1.)
      SVYIMF=SVYIMF+VY
      DVYIMF=DVYIMF+VY*VY
      SVVIMF=SVVIMF+VV
      DVVIMF=DVVIMF+VV*VV
c ------- for N/Z ratio -------
      PNZ=FLOAT(IAAA-IZZZ)/FLOAT(IZZZ)
      CALL HIST1(RY,-10.0,10.0,0.5,PRYIMF,46,PNZ)
      CALL HIST1(VY,-0.25,0.25,0.0125,PVYIMF,46,PNZ)
c -------------------------
  5   CONTINUE
c --------------------------
      DO 15 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.NE.2.OR.IAAA.NE.4) GO TO 15
      N4HE=N4HE+1
c ------- coordinates ------
      RX=XX(IR)-XCC
      RY=YY(IR)-YCC
      RZ=ZZ(IR)-ZCC
      RR=SQRT(RX*RX+RY*RY+RZ*RZ)
      SRY4HE=SRY4HE+RY
      DRY4HE=DRY4HE+RY*RY
      SRR4HE=SRR4HE+RR
      DRR4HE=DRR4HE+RR*RR
      CALL HIST1(RY,-10.0,10.0,0.5,RY4HE,46,1.)
      CALL HIST1(RR,0.,10.0,0.5,RR4HE,26,1.)
c ------ velocities -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      COST=VY/SQRT(VX**2+VY**2+VZ**2)
      CALL HIST1(COST,-1.,1.,0.1,ACM4HE,26,1.)
c      VY=VY+VCMS
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.25,0.25,0.0125,VY4HE,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VY4HES,56,1.)
      CALL HIST1(VV,0.,0.5,0.025,VV4HE,26,1.)
      SVY4HE=SVY4HE+VY
      DVY4HE=DVY4HE+VY*VY
      SVV4HE=SVV4HE+VV
      DVV4HE=DVV4HE+VV*VV
c -------------------------
 15   CONTINUE
c --------------------------
      DO 6 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
c ------ charge density in parallel velocity -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      VYP=VY+VCMSP
      VYT=VCMST-VY
      W=IZZZ
      CALL HIST1(VYP,-0.1,0.4,0.01,ROZ_VY,56,W)
c      CALL HIST1(VYT,-0.1,0.4,0.01,ROZ_VY,56,W)
      WFB=IZZZ/ZBOU3
      IF(IR.NE.IRMAX.AND.IZZZ.GE.3) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,ROF_VY,56,WFB)
c      IF(IR.NE.IRMAX.AND.IZZZ.GE.3) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,ROF_VY,56,WFB)
      IF(IR.EQ.IRMAX) CALL HIST1(VYP,-0.1,0.4,0.01,ROB_VY,56,WFB)
c      IF(IR.EQ.IRMAX) CALL HIST1(VYT,-0.1,0.4,0.01,ROB_VY,56,WFB)
  6   CONTINUE
c --------------------------
      DO 7 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
c ------ velocities -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      VYP=VY+VCMSP
      VYT=VCMST-VY
      IF(IZZZ.GE.1.AND.IZZZ.LE.2) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ12,56,1.)
c      IF(IZZZ.GE.1.AND.IZZZ.LE.2) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ12,56,1.)
      IF(IZZZ.GE.3.AND.IZZZ.LE.8) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ38,56,1.)
c      IF(IZZZ.GE.3.AND.IZZZ.LE.8) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ38,56,1.)
c ------- for N/Z ratio for TOT -------
c      IF(IAAA.LE.4.OR.IZZZ.LE.0) GO TO 7
      IF(IZZZ.LT.3.OR.IZZZ.GT.9) GO TO 7
      RX=XX(IR)-XCC
      RY=YY(IR)-YCC
      RZ=ZZ(IR)-ZCC
c      WAAA=FLOAT(IAAA)/FLOAT(IA0)
      WAAA=1.
      IF(IZZZ.EQ.8) CALL HIST1(RY,-10.0,10.0,0.5,CRYTOT,46,WAAA)
      IF(IZZZ.EQ.9) CALL HIST1(RY,-10.0,10.0,0.5,CRYTO1,46,WAAA)
      IF(IZZZ.EQ.8) CALL HIST1(VY,-0.25,0.25,0.0125,CVYTOT,46,WAAA)
      IF(IZZZ.EQ.9) CALL HIST1(VY,-0.25,0.25,0.0125,CVYTO1,46,WAAA)
c      WZAA=IZZZ*WAAA
c      CALL HIST1(VY,-0.25,0.25,0.0125,ZVYTOT,46,WZAA)
      PNZ=FLOAT(IAAA-IZZZ)/FLOAT(IZZZ)
      WPNZ=WAAA*PNZ
      IF(IZZZ.EQ.8) CALL HIST1(RY,-10.0,10.0,0.5,PRYTOT,46,WPNZ)
      IF(IZZZ.EQ.9) CALL HIST1(RY,-10.0,10.0,0.5,PRYTO1,46,WPNZ)
      IF(IZZZ.EQ.8) CALL HIST1(VY,-0.25,0.25,0.0125,PVYTOT,46,WPNZ)
      IF(IZZZ.EQ.9) CALL HIST1(VY,-0.25,0.25,0.0125,PVYTO1,46,WPNZ)
c -------------------------
  7   CONTINUE
c --------------------------
      RETURN
      END
      SUBROUTINE DCRPR
      COMMON /BCR1/ SZMAX,SRYMAX,SRRMAX,DRYMAX,DRRMAX,SVYMAX,
     *SVVMAX,DVYMAX,DVVMAX,RYMAX(46),RRMAX(26),VYMAX(46),VVMAX(26),SAMAX
     *,NZMAX
      COMMON /BCR2/ SZMA2,SRYMA2,SRRMA2,DRYMA2,DRRMA2,SVYMA2,
     *SVVMA2,DVYMA2,DVVMA2,RYMA2(46),RRMA2(26),VYMA2(46),VVMA2(26),SAMA2
     *,NZMA2
      COMMON /BCR3/ ZIMF,SRYIMF,SRRIMF,DRYIMF,DRRIMF,SVYIMF,
     *SVVIMF,DVYIMF,DVVIMF,RYIMF(46),RRIMF(26),VYIMF(46),VVIMF(26),AIMF
     *,NIMF
      COMMON /BCR4/ ACMMAX(26),ACMMA2(26),ACMIMF(26)
      COMMON /BCR5/ VYMAXS(56),VYMA2S(56),VYIMFS(56)
      COMMON /BCR6/ ROZ_VY(56),ROF_VY(56),ROB_VY(56),VYZ12(56),VYZ38(56)
      COMMON /BCR7/ PRYIMF(46),PVYIMF(46),PRYMAX(46),PVYMAX(46),
     *PVYTO1(46),CVYTO1(46),PVYTOT(46),CVYTOT(46),
     *PRYTO1(46),CRYTO1(46),PRYTOT(46),CRYTOT(46)
      COMMON /BCR8/SRY4HE,SRR4HE,DRY4HE,DRR4HE,SVY4HE,ACM4HE(26),
     *SVV4HE,DVY4HE,DVV4HE,RY4HE(46),RR4HE(26),VY4HE(46),VV4HE(26),
     *VY4HES(56)
     *,N4HE
      COMMON /BDCR/VCMSP,VCMST
      COMMON /BWRIT2/JWRIT2
      IF(NZMAX.LE.0) GO TO 9
      SZMAX=SZMAX/FLOAT(NZMAX)
      SAMAX=SAMAX/FLOAT(NZMAX)
      SRYMAX=SRYMAX/FLOAT(NZMAX)
      DRYMAX=DRYMAX/FLOAT(NZMAX)
      DDD=DRYMAX-SRYMAX*SRYMAX
      IF(DDD.GT.0.) DRYMAX=SQRT(DDD)
      IF(DDD.LE.0.) DRYMAX=0.
      SRRMAX=SRRMAX/FLOAT(NZMAX)
      DRRMAX=DRRMAX/FLOAT(NZMAX)
      DDD=DRRMAX-SRRMAX*SRRMAX
      IF(DDD.GT.0.) DRRMAX=SQRT(DDD)
      IF(DDD.LE.0.) DRRMAX=0.
      SVYMAX=SVYMAX/FLOAT(NZMAX)
      DVYMAX=DVYMAX/FLOAT(NZMAX)
      DDD=DVYMAX-SVYMAX*SVYMAX
      IF(DDD.GT.0.) DVYMAX=SQRT(DDD)
      IF(DDD.LE.0.) DVYMAX=0.
      SVVMAX=SVVMAX/FLOAT(NZMAX)
      DVVMAX=DVVMAX/FLOAT(NZMAX)
      DDD=DVVMAX-SVVMAX*SVVMAX
      IF(DDD.GT.0.) DVVMAX=SQRT(DDD)
      IF(DDD.LE.0.) DVVMAX=0.
c$$$      PRINT 300
c$$$ 300  FORMAT(2X,'---------- HOT FRAGMENTS ------------')
c$$$      PRINT 1,NZMAX,SZMAX,SAMAX
c$$$ 1    FORMAT(2X,'numb.max.fragm. NZMAX=',I6,' charge SZMAX=',F4.1,
c$$$     *' mass SAMAX=',F6.2/5X,'(all coordinates/velocities from ',
c$$$     *'mass center!)')
c$$$      PRINT 2,SRYMAX,DRYMAX,SRRMAX,DRRMAX
c$$$ 2    FORMAT(2X,'mean Y-coord. SRYMAX=',F7.2,'(fm)  variance DRYMAX=',
c$$$     *F7.2/2X,'mean radius SRRMAX=',F7.2,'(fm)  variance DRRMAX=',F7.2)
c$$$      PRINT 3,SVYMAX,DVYMAX,SVVMAX,DVVMAX
c$$$ 3    FORMAT(2X,'mean Y-veloc. SVYMAX=',F6.4,'(c)  variance DVYMAX=',
c$$$     *F6.4/2X,'mean veloc. SVVMAX=',F6.4,'(c)  variance DVVMAX=',F6.4)
c$$$      PRINT 4
c$$$ 4    FORMAT(1X,'distr.of max.fragm. in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm)  RYMAX:')
c$$$      PRINT 101,(RYMAX(J),J=1,40)
c$$$      PRINT 102,(RYMAX(J),J=41,46)
c$$$      PRINT 5
c$$$ 5    FORMAT(1X,'distr.of max.fragm. in radius, 0:+10 fm',
c$$$     *' (step=0.5fm)  RRMAX:')
c$$$      PRINT 101,(RRMAX(J),J=1,20)
c$$$      PRINT 102,(RRMAX(J),J=21,26)
c$$$      PRINT 6
c$$$ 6    FORMAT(1X,'Y-veloc.of max.fragm. , -0.25:+0.25 c',
c$$$     *' (step=0.0125c)  VYMAX:')
c$$$      PRINT 101,(VYMAX(J),J=1,40)
c$$$      PRINT 103,(VYMAX(J),J=41,46)
c$$$      PRINT 7
c$$$ 7    FORMAT(1X,'velocity of max.fragm. , 0:+0.5 c',
c$$$     *' (step=0.025c)  VVMAX:')
c$$$      PRINT 101,(VVMAX(J),J=1,20)
c$$$      PRINT 103,(VVMAX(J),J=21,26)
c$$$      PRINT 8
c$$$ 8    FORMAT(1X,'(cos)angle distr.of Y-veloc.max.fragm., -1:+1 ',
c$$$     *' (step=0.1) in c.m. ACMMAX:')
c$$$      PRINT 101,(ACMMAX(J),J=1,20)
c$$$      PRINT 103,(ACMMAX(J),J=21,26)
c ------------
      DO 210 J=1,40
      IF(RYMAX(J).GT.0.) PRYMAX(J)=PRYMAX(J)/RYMAX(J)
      IF(VYMAX(J).GT.0.) PVYMAX(J)=PVYMAX(J)/VYMAX(J)
 210  CONTINUE
c$$$      PRINT 201
c$$$ 201  FORMAT(1X,'N/Z ratio of MAX fragm. in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm)  PRYMAX:')
c$$$      PRINT 105,(PRYMAX(J),J=1,40)
c$$$      PRINT 102,(PRYMAX(J),J=41,46)
c$$$      PRINT 202
c$$$ 202  FORMAT(1X,'N/Z ratio of MAX in Y-veloc., -0.25:+0.25 c',
c$$$     *' (step=0.0125c)  PVYMAX:')
c$$$      PRINT 105,(PVYMAX(J),J=1,40)
c$$$      PRINT 103,(PVYMAX(J),J=41,46)
c ------------
 9    CONTINUE
c$$$ 101  FORMAT(1X,10F7.0)
c$$$ 104  FORMAT(1X,10F7.1)
c$$$ 105  FORMAT(1X,10F7.3)
c$$$ 102  FORMAT(1X,6F12.2)
c$$$ 103  FORMAT(1X,6F12.4)
      IF(NZMA2.LE.0) GO TO 19
      SZMA2=SZMA2/FLOAT(NZMA2)
      SAMA2=SAMA2/FLOAT(NZMA2)
      SRYMA2=SRYMA2/FLOAT(NZMA2)
      DRYMA2=DRYMA2/FLOAT(NZMA2)
      DDD=DRYMA2-SRYMA2*SRYMA2
      IF(DDD.GT.0.) DRYMA2=SQRT(DDD)
      IF(DDD.LE.0.) DRYMA2=0.
      SRRMA2=SRRMA2/FLOAT(NZMA2)
      DRRMA2=DRRMA2/FLOAT(NZMA2)
      DDD=DRRMA2-SRRMA2*SRRMA2
      IF(DDD.GT.0.) DRRMA2=SQRT(DDD)
      IF(DDD.LE.0.) DRRMA2=0.
      SVYMA2=SVYMA2/FLOAT(NZMA2)
      DVYMA2=DVYMA2/FLOAT(NZMA2)
      DDD=DVYMA2-SVYMA2*SVYMA2
      IF(DDD.GT.0.) DVYMA2=SQRT(DDD)
      IF(DDD.LE.0.) DVYMA2=0.
      SVVMA2=SVVMA2/FLOAT(NZMA2)
      DVVMA2=DVVMA2/FLOAT(NZMA2)
      DDD=DVVMA2-SVVMA2*SVVMA2
      IF(DDD.GT.0.) DVVMA2=SQRT(DDD)
      IF(DDD.LE.0.) DVVMA2=0.
c$$$      PRINT 11,NZMA2,SZMA2,SAMA2
c$$$ 11   FORMAT(2X,'numb.second fragm. NZMA2=',I6,' charge SZMA2=',F4.1,
c$$$     *' mass SAMA2=',F6.2)
c$$$      PRINT 12,SRYMA2,DRYMA2,SRRMA2,DRRMA2
c$$$ 12   FORMAT(2X,'mean Y-coord. SRYMA2=',F7.2,'(fm)  variance DRYMA2=',
c$$$     *F7.2/2X,'mean radius SRRMA2=',F7.2,'(fm)  variance DRRMA2=',F7.2)
c$$$      PRINT 13,SVYMA2,DVYMA2,SVVMA2,DVVMA2
c$$$ 13   FORMAT(2X,'mean Y-veloc. SVYMA2=',F6.4,'(c)  variance DVYMA2=',
c$$$     *F6.4/2X,'mean veloc. SVVMA2=',F6.4,'(c)  variance DVVMA2=',F6.4)
c$$$      PRINT 14
c$$$ 14   FORMAT(1X,'distr.of sec.fragm. in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm)  RYMA2:')
c$$$      PRINT 101,(RYMA2(J),J=1,40)
c$$$      PRINT 102,(RYMA2(J),J=41,46)
c$$$      PRINT 15
c$$$ 15   FORMAT(1X,'distr.of sec.fragm. in radius, 0:+10 fm',
c$$$     *' (step=0.5fm)  RRMA2:')
c$$$      PRINT 101,(RRMA2(J),J=1,20)
c$$$      PRINT 102,(RRMA2(J),J=21,26)
c$$$      PRINT 16
c$$$ 16   FORMAT(1X,'Y-veloc.of sec.fragm. , -0.25:+0.25 c',
c$$$     *' (step=0.0125c)  VYMA2:')
c$$$      PRINT 101,(VYMA2(J),J=1,40)
c$$$      PRINT 103,(VYMA2(J),J=41,46)
c$$$      PRINT 17
c$$$ 17   FORMAT(1X,'velocity of sec.fragm. , 0:+0.5 c',
c$$$     *' (step=0.025c)  VVMA2:')
c$$$      PRINT 101,(VVMA2(J),J=1,20)
c$$$      PRINT 103,(VVMA2(J),J=21,26)
c$$$      PRINT 18
c$$$ 18   FORMAT(1X,'(cos)angle distr.of Y-veloc.sec.fragm., -1:+1 ',
c$$$     *' (step=0.1) in c.m. ACMMA2:')
c$$$      PRINT 101,(ACMMA2(J),J=1,20)
c$$$      PRINT 103,(ACMMA2(J),J=21,26)
 19   CONTINUE
c ------------
      IF(NIMF.LE.0) GO TO 29
      ZIMF=ZIMF/FLOAT(NIMF)
      AIMF=AIMF/FLOAT(NIMF)
      SRYIMF=SRYIMF/FLOAT(NIMF)
      DRYIMF=DRYIMF/FLOAT(NIMF)
      DDD=DRYIMF-SRYIMF*SRYIMF
      IF(DDD.GT.0.) DRYIMF=SQRT(DDD)
      IF(DDD.LE.0.) DRYIMF=0.
      SRRIMF=SRRIMF/FLOAT(NIMF)
      DRRIMF=DRRIMF/FLOAT(NIMF)
      DDD=DRRIMF-SRRIMF*SRRIMF
      IF(DDD.GT.0.) DRRIMF=SQRT(DDD)
      IF(DDD.LE.0.) DRRIMF=0.
      SVYIMF=SVYIMF/FLOAT(NIMF)
      DVYIMF=DVYIMF/FLOAT(NIMF)
      DDD=DVYIMF-SVYIMF*SVYIMF
      IF(DDD.GT.0.) DVYIMF=SQRT(DDD)
      IF(DDD.LE.0.) DVYIMF=0.
      SVVIMF=SVVIMF/FLOAT(NIMF)
      DVVIMF=DVVIMF/FLOAT(NIMF)
      DDD=DVVIMF-SVVIMF*SVVIMF
      IF(DDD.GT.0.) DVVIMF=SQRT(DDD)
      IF(DDD.LE.0.) DVVIMF=0.
c$$$      PRINT 21,NIMF,ZIMF,AIMF
c$$$ 21   FORMAT(2X,'numb.IMF.fragm. NIMF=',I6,' charge ZIMF=',F4.1,
c$$$     *' mass AIMF=',F6.2)
c$$$      PRINT 22,SRYIMF,DRYIMF,SRRIMF,DRRIMF
c$$$ 22   FORMAT(2X,'mean Y-coord. SRYIMF=',F7.2,'(fm)  variance DRYIMF=',
c$$$     *F7.2/2X,'mean radius SRRIMF=',F7.2,'(fm)  variance DRRIMF=',F7.2)
c$$$      PRINT 23,SVYIMF,DVYIMF,SVVIMF,DVVIMF
c$$$ 23   FORMAT(2X,'mean Y-veloc. SVYIMF=',F6.4,'(c)  variance DVYIMF=',
c$$$     *F6.4/2X,'mean veloc. SVVIMF=',F6.4,'(c)  variance DVVIMF=',F6.4)
c$$$      PRINT 24
c$$$ 24   FORMAT(1X,'distr.of IMF.fragm. in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm)  RYIMF:')
c$$$      PRINT 101,(RYIMF(J),J=1,40)
c$$$      PRINT 102,(RYIMF(J),J=41,46)
c$$$      PRINT 25
c$$$ 25   FORMAT(1X,'distr.of IMF.fragm. in radius, 0:+10 fm',
c$$$     *' (step=0.5fm)  RRIMF:')
c$$$      PRINT 101,(RRIMF(J),J=1,20)
c$$$      PRINT 102,(RRIMF(J),J=21,26)
c$$$      PRINT 26
c$$$ 26   FORMAT(1X,'Y-veloc.of IMF.fragm. , -0.25:+0.25 c',
c$$$     *' (step=0.0125c)  VYIMF:')
c$$$      PRINT 101,(VYIMF(J),J=1,40)
c$$$      PRINT 103,(VYIMF(J),J=41,46)
c$$$      PRINT 27
c$$$ 27   FORMAT(1X,'velocity of IMF.fragm. , 0:+0.5 c',
c$$$     *' (step=0.025c)  VVIMF:')
c$$$      PRINT 101,(VVIMF(J),J=1,20)
c$$$      PRINT 103,(VVIMF(J),J=21,26)
c$$$      PRINT 28
c$$$ 28   FORMAT(1X,'(cos)angle distr.of Y-veloc.IMF.fragm., -1:+1 ',
c$$$     *' (step=0.1) in c.m. ACMIMF:')
c$$$      PRINT 101,(ACMIMF(J),J=1,20)
c$$$      PRINT 103,(ACMIMF(J),J=21,26)
c ------------
      DO 209 J=1,40
      IF(RYIMF(J).GT.0.) PRYIMF(J)=PRYIMF(J)/RYIMF(J)
      IF(VYIMF(J).GT.0.) PVYIMF(J)=PVYIMF(J)/VYIMF(J)
 209  CONTINUE
c      PRINT 203
c 203  FORMAT(1X,'N/Z ratio of IMF fragm. in Y-coord., -10:+10 fm',
c     *' (step=0.5fm)  PRYIMF:')
c      PRINT 105,(PRYIMF(J),J=1,40)
c      PRINT 102,(PRYIMF(J),J=41,46)
c      PRINT 204
c 204  FORMAT(1X,'N/Z ratio of IMF in Y-veloc., -0.25:+0.25 c',
c     *' (step=0.0125c)  PVYIMF:')
c      PRINT 105,(PVYIMF(J),J=1,40)
c      PRINT 103,(PVYIMF(J),J=41,46)
 29   CONTINUE
c ------------
      IF(N4HE.LE.0) GO TO 59
      SRY4HE=SRY4HE/FLOAT(N4HE)
      DRY4HE=DRY4HE/FLOAT(N4HE)
      DDD=DRY4HE-SRY4HE*SRY4HE
      IF(DDD.GT.0.) DRY4HE=SQRT(DDD)
      IF(DDD.LE.0.) DRY4HE=0.
      SRR4HE=SRR4HE/FLOAT(N4HE)
      DRR4HE=DRR4HE/FLOAT(N4HE)
      DDD=DRR4HE-SRR4HE*SRR4HE
      IF(DDD.GT.0.) DRR4HE=SQRT(DDD)
      IF(DDD.LE.0.) DRR4HE=0.
      SVY4HE=SVY4HE/FLOAT(N4HE)
      DVY4HE=DVY4HE/FLOAT(N4HE)
      DDD=DVY4HE-SVY4HE*SVY4HE
      IF(DDD.GT.0.) DVY4HE=SQRT(DDD)
      IF(DDD.LE.0.) DVY4HE=0.
      SVV4HE=SVV4HE/FLOAT(N4HE)
      DVV4HE=DVV4HE/FLOAT(N4HE)
      DDD=DVV4HE-SVV4HE*SVV4HE
      IF(DDD.GT.0.) DVV4HE=SQRT(DDD)
      IF(DDD.LE.0.) DVV4HE=0.
c$$$      PRINT 51,N4HE
c$$$ 51   FORMAT(2X,'numb.4HE.fragm. N4HE=',I6)
c$$$      PRINT 52,SRY4HE,DRY4HE,SRR4HE,DRR4HE
c$$$ 52   FORMAT(2X,'mean Y-coord. SRY4HE=',F7.2,'(fm)  variance DRY4HE=',
c$$$     *F7.2/2X,'mean radius SRR4HE=',F7.2,'(fm)  variance DRR4HE=',F7.2)
c$$$      PRINT 53,SVY4HE,DVY4HE,SVV4HE,DVV4HE
c$$$ 53   FORMAT(2X,'mean Y-veloc. SVY4HE=',F6.4,'(c)  variance DVY4HE=',
c$$$     *F6.4/2X,'mean veloc. SVV4HE=',F6.4,'(c)  variance DVV4HE=',F6.4)
c$$$      PRINT 54
c$$$ 54   FORMAT(1X,'distr.of 4HE.fragm. in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm)  RY4HE:')
c$$$      PRINT 101,(RY4HE(J),J=1,40)
c$$$      PRINT 102,(RY4HE(J),J=41,46)
c$$$      PRINT 55
c$$$ 55   FORMAT(1X,'distr.of 4HE.fragm. in radius, 0:+10 fm',
c$$$     *' (step=0.5fm)  RR4HE:')
c$$$      PRINT 101,(RR4HE(J),J=1,20)
c$$$      PRINT 102,(RR4HE(J),J=21,26)
c$$$      PRINT 56
c$$$ 56   FORMAT(1X,'Y-veloc.of 4HE.fragm. , -0.25:+0.25 c',
c$$$     *' (step=0.0125c)  VY4HE:')
c$$$      PRINT 101,(VY4HE(J),J=1,40)
c$$$      PRINT 103,(VY4HE(J),J=41,46)
c$$$      PRINT 57
c$$$ 57   FORMAT(1X,'velocity of 4HE.fragm. , 0:+0.5 c',
c$$$     *' (step=0.025c)  VV4HE:')
c$$$      PRINT 101,(VV4HE(J),J=1,20)
c$$$      PRINT 103,(VV4HE(J),J=21,26)
c$$$      PRINT 58
c$$$ 58   FORMAT(1X,'(cos)angle distr.of Y-veloc.4HE.fragm., -1:+1 ',
c$$$     *' (step=0.1) in c.m. ACM4HE:')
c$$$      PRINT 101,(ACM4HE(J),J=1,20)
c$$$      PRINT 103,(ACM4HE(J),J=21,26)
 59   CONTINUE
c ------------ overall fragments -----------
      DO 208 J=1,40
      IF(CVYTOT(J).GT.0.) PVYTOT(J)=PVYTOT(J)/CVYTOT(J)
      IF(CVYTO1(J).GT.0.) PVYTO1(J)=PVYTO1(J)/CVYTO1(J)
      IF(CRYTOT(J).GT.0.) PRYTOT(J)=PRYTOT(J)/CRYTOT(J)
      IF(CRYTO1(J).GT.0.) PRYTO1(J)=PRYTO1(J)/CRYTO1(J)
 208  CONTINUE
c$$$      PRINT 207
c$$$ 207  FORMAT(1X,'distr.fragm. Z=8 in Y-veloc., -0.25:+0.25c',
c$$$     *' (step=0.0125c) CVYTOT:')
c$$$      PRINT 101,(CVYTOT(J),J=1,40)
c$$$      PRINT 102,(CVYTOT(J),J=41,46)
c$$$      PRINT 206
c$$$ 206  FORMAT(1X,'N/Z ratio of Z=8 in Y-veloc., -0.25:+0.25c',
c$$$     *' (st=0.0125c) PVYTOT:')
c$$$      PRINT 105,(PVYTOT(J),J=1,40)
c$$$      PRINT 103,(PVYTOT(J),J=41,46)
c$$$      PRINT 211
c$$$ 211  FORMAT(1X,'distr.fragm. Z=9 in Y-veloc., -0.25:+0.25c',
c$$$     *' (step=0.0125c) CVYTO1:')
c$$$      PRINT 101,(CVYTO1(J),J=1,40)
c$$$      PRINT 102,(CVYTO1(J),J=41,46)
c$$$      PRINT 212
c$$$ 212  FORMAT(1X,'N/Z ratio of Z=9 in Y-veloc., -0.25:+0.25c',
c$$$     *' (st=0.0125c) PVYTO1:')
c$$$      PRINT 105,(PVYTO1(J),J=1,40)
c$$$      PRINT 103,(PVYTO1(J),J=41,46)
c$$$      PRINT 213
c$$$ 213  FORMAT(1X,'distr.fragm. Z=8 in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm) CRYTOT:')
c$$$      PRINT 101,(CRYTOT(J),J=1,40)
c$$$      PRINT 102,(CRYTOT(J),J=41,46)
c$$$      PRINT 214
c$$$ 214  FORMAT(1X,'N/Z ratio of Z=8 in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm) PRYTOT:')
c$$$      PRINT 105,(PRYTOT(J),J=1,40)
c$$$      PRINT 103,(PRYTOT(J),J=41,46)
c$$$      PRINT 215
c$$$ 215  FORMAT(1X,'distr.fragm. Z=9 in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm) CRYTO1:')
c$$$      PRINT 101,(CRYTO1(J),J=1,40)
c$$$      PRINT 102,(CRYTO1(J),J=41,46)
c$$$      PRINT 216
c$$$ 216  FORMAT(1X,'N/Z ratio of Z=9 in Y-coord., -10:+10 fm',
c$$$     *' (step=0.5fm) PRYTO1:')
c$$$      PRINT 105,(PRYTO1(J),J=1,40)
c$$$      PRINT 103,(PRYTO1(J),J=41,46)
c$$$c --------------------------------------------------------
c$$$      PRINT 30,VCMST,VCMSP
c$$$ 30   FORMAT(2X,'in lab. system taking into account motion of target:'/
c$$$     *2X,'VCMST=',F7.4,' c   and projectile: VCMSP=',F7.4,' c')
c$$$      PRINT 31
c$$$ 31   FORMAT(1X,'beam-dir.veloc.of max.fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYMAXS:')
c$$$      PRINT 101,(VYMAXS(J),J=1,50)
c$$$      PRINT 103,(VYMAXS(J),J=51,56)
c$$$      PRINT 32
c$$$ 32   FORMAT(1X,'beam-dir.veloc.of 2-d.fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYMA2S:')
c$$$      PRINT 101,(VYMA2S(J),J=1,50)
c$$$      PRINT 103,(VYMA2S(J),J=51,56)
c$$$      PRINT 33
c$$$ 33   FORMAT(1X,'beam-dir.veloc.of IMF fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYIMFS:')
c$$$      PRINT 101,(VYIMFS(J),J=1,50)
c$$$      PRINT 103,(VYIMFS(J),J=51,56)
c$$$      PRINT 41
c$$$ 41   FORMAT(1X,'beam-dir.veloc.of 4-HE fragm. , -0.1:+0.4c',
c$$$     *' (step=0.01c) VY4HES:')
c$$$      PRINT 101,(VY4HES(J),J=1,50)
c$$$      PRINT 103,(VY4HES(J),J=51,56)
c$$$      PRINT 39
c$$$ 39   FORMAT(1X,'beam-dir.veloc.of Z=1,2 fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ12:')
c$$$      PRINT 101,(VYZ12(J),J=1,50)
c$$$      PRINT 103,(VYZ12(J),J=51,56)
c$$$      PRINT 40
c$$$ 40   FORMAT(1X,'beam-dir.veloc.of Z=3,8 fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ38:')
c$$$      PRINT 101,(VYZ38(J),J=1,50)
c$$$      PRINT 103,(VYZ38(J),J=51,56)
c$$$      PRINT 34
c$$$ 34   FORMAT(2X,'total charg.in beam-dir. ; paral.veloc. -0.1:+0.4 c',
c$$$     *' (step=0.01c) ROZ_VY:')
c$$$      PRINT 101,(ROZ_VY(J),J=1,50)
c$$$      PRINT 103,(ROZ_VY(J),J=51,56)
c$$$      PRINT 37
c$$$ 37   FORMAT(2X,'fragm.(Z>2)dens.(no big); paral.veloc. -0.1:+0.4 c',
c$$$     *' (step=0.01c) ROF_VY:')
c$$$      PRINT 101,(ROF_VY(J),J=1,50)
c$$$      PRINT 103,(ROF_VY(J),J=51,56)
c$$$      PRINT 38
c$$$ 38   FORMAT(2X,'bigest fragm.dens.; paral.veloc. -0.1:+0.4 c',
c$$$     *' (step=0.01c) ROB_VY:')
c$$$      PRINT 101,(ROB_VY(J),J=1,50)
c$$$      PRINT 103,(ROB_VY(J),J=51,56)
c --- writing histogramms ---
c      DO 36 J=1,50
c      VY0=-0.1+0.01*(J-1)+0.005
c      WRITE(51,35),J,VY0,ROF_VY(J),ROB_VY(J),VYZ12(J),VYZ38(J),
c     *VYIMFS(J),VYMAXS(J)
c 35   FORMAT(1X,I8,1X,F10.4,1X,F10.4,1X,F10.4,1X,F8.2,1X,F8.2,
c     *1X,F8.2,1X,F8.2)
c 36   CONTINUE
c ---
c --- writing histogramms, 2-sources (hot fragments) ---
      IF(JWRIT2.EQ.0) GO TO 360
      DO 36 J=1,50
      VY0=-0.1+0.01*(J-1)+0.005
c      WRITE(53,35)J,VY0,ROF_VY(J),ROB_VY(J),VYZ12(J),VYZ38(J),
c     *VYIMFS(J),VYMAXS(J)
c 35   FORMAT(1X,I8,1X,F10.4,1X,F10.4,1X,F10.4,1X,F8.2,1X,F8.2,
c     *1X,F8.2,1X,F8.2)
 36   CONTINUE
 360  CONTINUE
c ---
      RETURN
      END
      SUBROUTINE ROTO2(XC0,YC0,ZC0,XR0,YR0,ZR0,PC,PR)
c finding new vector coordinates after rotation of the coordinate system
c XC(3),YC(3),ZC(3) - old coordinate axes
c XR(3),YR(3),ZR(3) - new coordinate axes
c PC(3) - vector in old coordinate system
c PR(3) - vector in new coordinate system
      DIMENSION XR(3),YR(3),ZR(3),XC(3),YC(3),ZC(3),PC(3),PR(3)
      DIMENSION XR0(3),YR0(3),ZR0(3),XC0(3),YC0(3),ZC0(3)
      XRR=SQRT(XR0(1)**2+XR0(2)**2+XR0(3)**2)
      YRR=SQRT(YR0(1)**2+YR0(2)**2+YR0(3)**2)
      ZRR=SQRT(ZR0(1)**2+ZR0(2)**2+ZR0(3)**2)
      XCC=SQRT(XC0(1)**2+XC0(2)**2+XC0(3)**2)
      YCC=SQRT(YC0(1)**2+YC0(2)**2+YC0(3)**2)
      ZCC=SQRT(ZC0(1)**2+ZC0(2)**2+ZC0(3)**2)
      DO 10 I=1,3
      XR(I)=XR0(I)/XRR
      YR(I)=YR0(I)/YRR
      ZR(I)=ZR0(I)/ZRR
      XC(I)=XC0(I)/XCC
      YC(I)=YC0(I)/YCC
      ZC(I)=ZC0(I)/ZCC
 10   CONTINUE
c TL1,2,3 ; TM1,2,3 ; TN1,2,3; - are cosines of the rotation matrix,
c since vectors XR,YR,ZR and XC,YC,ZC are unit lenth
      TL1=XR(1)*XC(1)+XR(2)*XC(2)+XR(3)*XC(3)
      TL2=YR(1)*XC(1)+YR(2)*XC(2)+YR(3)*XC(3)
      TL3=ZR(1)*XC(1)+ZR(2)*XC(2)+ZR(3)*XC(3)
      TM1=XR(1)*YC(1)+XR(2)*YC(2)+XR(3)*YC(3)
      TM2=YR(1)*YC(1)+YR(2)*YC(2)+YR(3)*YC(3)
      TM3=ZR(1)*YC(1)+ZR(2)*YC(2)+ZR(3)*YC(3)
      TN1=XR(1)*ZC(1)+XR(2)*ZC(2)+XR(3)*ZC(3)
      TN2=YR(1)*ZC(1)+YR(2)*ZC(2)+YR(3)*ZC(3)
      TN3=ZR(1)*ZC(1)+ZR(2)*ZC(2)+ZR(3)*ZC(3)
c --- rotation: PC - vector in the old (C) system, PR - in the new (R) ---
      PR(1)=TL1*PC(1)+TM1*PC(2)+TN1*PC(3)
      PR(2)=TL2*PC(1)+TM2*PC(2)+TN2*PC(3)
      PR(3)=TL3*PC(1)+TM3*PC(2)+TN3*PC(3)
c -------------------------------------
      RETURN
      END
c ***
      SUBROUTINE VVOCCU(II,VV)
c velocities of fragments in case of 'occured' ang.mom. Made EMPTY !
      DIMENSION VV(3)
      RETURN
      END
c * METR4 the total metropolis pass made on the basis of METRO4 (17.03.99) *
c (METRO4 restores correctly all partitions in A,Z-space with weight=1)
c-----------------------------------------------------
c ***
      SUBROUTINE WIGSE(IA0,IZ0,IP,IA,IZ,FKACOL,EWIGSE)
c -- calculation of average Coulomb barrier (EWIGSE) in Wigner-Seitz. --
      DIMENSION IA(500),IZ(500)
      RADNCL=1.17
      ECOEF=0.6*1.44/RADNCL
      PKP013=1./((1.+FKACOL)**0.3333333)
      A0=IA0
      EC=ECOEF*PKP013*IZ0*IZ0/(A0**0.3333333)
      DO 2 I=1,IP
      A=IA(I)
      A13=A**0.3333333
      EC=EC-ECOEF*PKP013*IZ(I)*IZ(I)/A13
 2    CONTINUE
      IF(EC.LT.0.) EC=0.
      EWIGSE=EC
      RETURN
      END
      SUBROUTINE DISNE2(INET,IP0,AMP,PN0,T,TN)
c modernization: instead of generation on Maxwell-Boltzmann distribution 
c (DISNET) the generation on dyrect phase space is used (DISIMP). Apr.98, Bo.
c (to avoid the problem of the last particle at Boltzmann generation).
      DIMENSION AMP(500),PN0(3,500),PN1(3,500),AMP1(500)
      IF(INET.LE.0) RETURN
      IF(IP0.LT.0.OR.(IP0+INET).GT.500) RETURN
      DO 1 I1=1,INET
      I0=I1+IP0
      AMP1(I1)=AMP(I0)
      PN1(1,I1)=0.
      PN1(2,I1)=0.
      PN1(3,I1)=0.
 1    CONTINUE
      CALL DISIMP(INET,AMP1,PN1,TN)
      DO 2 I1=1,INET
      I0=I1+IP0
      PN0(1,I0)=PN1(1,I1)
      PN0(2,I0)=PN1(2,I1)
      PN0(3,I0)=PN1(3,I1)
 2    CONTINUE
      RETURN
      END
      SUBROUTINE DISN02(INET,IP0,AMP,PN0,T,TN)
c *** implem.of flow.and rotat. EFLOW, EMOM in GeV/N. ANMOM in h-bar ***
c modernization: instead of generation on Maxwell-Boltzmann distribution 
c (DISNET) the generation on dyrect phase space is used (DISIMP). Apr.98, Bo.
c (to avoid the problem of the last particle at Boltzmann generation).
C HAXO[[EH[E [HEP[[[ [ [M[[[[COB INET HE[TPOHOB [O [X TEM[EPAT[PE T(MEV)
C [O[HO[ K[H.[HEP[[[ TN(GEV),C[[TA[ PAC[PE[E[EH[E MAKCBE[OBCK[M. AMP(IP0
C -[X MACC[ (B GEV);[M[[[[C[ (GEV/C),B C[MME [A[[[E 0,[O[AB[[[TC[ B MACC
C PN0(3,500) C (IP0+1).
c -- Dec.99 Ganil, add FLZ - assymetric flow along Z-axis --
c -- Correction Dec 03 TAMU : at IAMOM>0 changing signs of rotat.velocities 
c (+VZ,-VY) - since rotation (angular momentum) is assumed along X axis. 
      COMMON /BLFLOW/A00,EFLOW,IFLOW /BLFLCM/ALF0,FLOWC,XCM,YCM,ZCM
      COMMON /BLAMOM/ANMOM,EMOM,IAMOM /BLAMCM/BMOM,WR,EMOMC
      COMMON /BLPAT/PA(500),PAZ(500),IPT
      COMMON /BLCEN/XC(500),YC(500),ZC(500)
      COMMON /BLFLZ/FLZ /BLFLY/FLY
      COMMON /MIC2B8/AMRWX,AMRWY,AMRWZ,AMRW0X,AMRW0Y,AMRW0Z,IRWT
      DIMENSION AMP(500),PN0(3,500),ANL(3),PX(500),PY(500),PZ(500)
      DIMENSION PN1(3,500),AMP1(500),VV(3)
      IF(INET.LE.0) RETURN
      IF(IP0.LT.0.OR.(IP0+INET).GT.500) RETURN
c      FLZ=1.
      IP01=IP0+1
      IP0M=IP0+INET
      IF(INET-1) 1,1,2
 1    P=SQRT(2.*AMP(IP01)*TN)
      CALL ISOTR(ANL)
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(IP01)-XCM)
c      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(IP01)-YCM)
c -- for excessive flow along Y-axis
      IF(IFLOW.GE.1) VV(2)=VV(2)+FLY*ALF0*(YC(IP01)-YCM)
c      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(IP01)-ZCM)
c -- for nonuniform flow: along Z-axis
      IF(IFLOW.GE.1) VV(3)=VV(3)+FLZ*ALF0*(ZC(IP01)-ZCM)
c -----------------------
c ---- for implement. 'occured' ang. momentum. ----
      IF(IRWT.EQ.0) GO TO 15
      IF(IAMOM.LT.1) GO TO 16
      CALL VVOCCU(IP01,VV)
      GO TO 16
 15   CONTINUE
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(IP01)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(IP01)-ZCM)
 16   CONTINUE
      PN0(1,IP01)=P*ANL(1)+AMP(IP01)*VV(1)
      PN0(2,IP01)=P*ANL(2)+AMP(IP01)*VV(2)
      PN0(3,IP01)=P*ANL(3)+AMP(IP01)*VV(3)
      RETURN
 2    IF(INET-2) 3,3,4
 3    P=SQRT(2.*(AMP(IP01)*AMP(IP0M)/(AMP(IP01)+AMP(IP0M)))*TN)
      CALL ISOTR(ANL)
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(IP01)-XCM)
c      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(IP01)-YCM)
c -- for excessive flow along Y-axis
      IF(IFLOW.GE.1) VV(2)=VV(2)+FLY*ALF0*(YC(IP01)-YCM)
c      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(IP01)-ZCM)
c -- for nonuniform flow: along Z-axis
      IF(IFLOW.GE.1) VV(3)=VV(3)+FLZ*ALF0*(ZC(IP01)-ZCM)
c -----------------------
c ---- for implement. 'occured' ang. momentum. ----
      IF(IRWT.EQ.0) GO TO 9
      IF(IAMOM.LT.1) GO TO 10
      CALL VVOCCU(IP01,VV)
      GO TO 10
 9    CONTINUE
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(IP01)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(IP01)-ZCM)
 10   CONTINUE
      PN0(1,IP01)=P*ANL(1)+AMP(IP01)*VV(1)
      PN0(2,IP01)=P*ANL(2)+AMP(IP01)*VV(2)
      PN0(3,IP01)=P*ANL(3)+AMP(IP01)*VV(3)
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(IP0M)-XCM)
c      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(IP0M)-YCM)
c -- for excessive flow along Y-axis
      IF(IFLOW.GE.1) VV(2)=VV(2)+FLY*ALF0*(YC(IP0M)-YCM)
c      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(IP0M)-ZCM)
c -- for nonuniform flow: along Z-axis
      IF(IFLOW.GE.1) VV(3)=VV(3)+FLZ*ALF0*(ZC(IP0M)-ZCM)
c -----------------------
      IF(IRWT.EQ.0) GO TO 11
      IF(IAMOM.LT.1) GO TO 12
      CALL VVOCCU(IP0M,VV)
      GO TO 12
 11   CONTINUE
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(IP0M)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(IP0M)-ZCM)
 12   CONTINUE
      PN0(1,IP0M)=-P*ANL(1)+AMP(IP0M)*VV(1)
      PN0(2,IP0M)=-P*ANL(2)+AMP(IP0M)*VV(2)
      PN0(3,IP0M)=-P*ANL(3)+AMP(IP0M)*VV(3)
      RETURN
 4    CONTINUE
      DO 5 I1=1,INET
      I0=I1+IP0
      AMP1(I1)=AMP(I0)
      PN1(1,I1)=0.
      PN1(2,I1)=0.
      PN1(3,I1)=0.
 5    CONTINUE
      CALL DISIMP(INET,AMP1,PN1,TN)
      DO 6 I1=1,INET
      I0=I1+IP0
      PX(I0)=PN1(1,I1)
      PY(I0)=PN1(2,I1)
      PZ(I0)=PN1(3,I1)
 6    CONTINUE
      DO 8 I=IP01,IP0M
      VV(1)=0.
      VV(2)=0.
      VV(3)=0.
      IF(IFLOW.GE.1) VV(1)=VV(1)+ALF0*(XC(I)-XCM)
c      IF(IFLOW.GE.1) VV(2)=VV(2)+ALF0*(YC(I)-YCM)
c -- for excessive flow along Y-axis
      IF(IFLOW.GE.1) VV(2)=VV(2)+FLY*ALF0*(YC(I)-YCM)
c      IF(IFLOW.GE.1) VV(3)=VV(3)+ALF0*(ZC(I)-ZCM)
c -- for nonuniform flow: along Z-axis
      IF(IFLOW.GE.1) VV(3)=VV(3)+FLZ*ALF0*(ZC(I)-ZCM)
c -----------------------
      IF(IRWT.EQ.0) GO TO 13
      IF(IAMOM.LT.1) GO TO 14
      CALL VVOCCU(I,VV)
      GO TO 14
 13   CONTINUE
      IF(IAMOM.GE.1) VV(3)=VV(3)+WR*(YC(I)-YCM)
      IF(IAMOM.GE.1) VV(2)=VV(2)-WR*(ZC(I)-ZCM)
 14   CONTINUE
      PN0(1,I)=PX(I)+AMP(I)*VV(1)
      PN0(2,I)=PY(I)+AMP(I)*VV(2)
      PN0(3,I)=PZ(I)+AMP(I)*VV(3)
 8    CONTINUE
      RETURN
      END
      SUBROUTINE SELECA(N,IA0,NA,IP)
c -- newest, taking into account that multiplicity distribution should 
c be a Poisson in grand canonics. 24 Nov. 99, Bo.
C C[[[A[H[[ B[[OP [[C[A [PA[MEHTOB IP [ [X MHO[ECTBEHHOCTE[ [O A -NA(A)
C [[ [[C[A H[K[OHOB IA0 [ [HK[[[[BH[X MHO[ECTBEHHOCTE[ -N(A).
      REAL WPOIS(500)
      REAL GG(500),N(500)
      INTEGER NA(500)
c      IMAXMA=0
      IMAXMA=1
      IMAXMI=0
      GH=0.
      DO 2 I=1,IA0
 2    GH=GH+N(I)
c      SQGH=SQRT(GH)+0.5
cc      SQGH=SQRT(GH)+1.0
c      SQGH=2.*SQRT(GH)+1.0
c ------------------------------------
      WPOIS(1)=GH*EXP(-GH)
      DO 11 I=2,IA0
      WPOIS(I)=WPOIS(I-1)*GH/FLOAT(I)
 11   CONTINUE
      MMAX=INT(GH)
      WPMAX=WPOIS(MMAX)
c ------------------------------------
      GG(1)=N(1)
      DO 3 I=2,IA0
 3    GG(I)=GG(I-1)+N(I)
 4    ISA=0
      DO 1 I=1,IA0
 1    NA(I)=0
      IP=0
 5    BRND=RNDMSMM(-1)*GH
      DO 6 I=1,IA0
      IF(BRND-GG(I)) 7,6,6
 7    IA=I
      GO TO 8
 6    CONTINUE
 8    IP=IP+1
      NA(IA)=NA(IA)+1
      ISA=ISA+IA
      IAK=IA0-ISA
      IF(IAK.EQ.0) GO TO 10
      IF(IAK.GT.IMAXMA) GO TO 5
      IF(IAK.LT.IMAXMI) GO TO 4
      IP=IP+1
      NA(IAK)=NA(IAK)+1
 10   CONTINUE
c      IF(ABS(GH-IP).GT.SQGH) GO TO 4
c ------------------------------------
      BRNP=RNDMSMM(-1)*WPMAX
      IF(BRNP.GT.WPOIS(IP)) GO TO 4
c ------------------------------------
c      IF(IP.EQ.1) GO TO 4
      IF(IP.LE.2) GO TO 4
      RETURN
      END
      SUBROUTINE BSPEC2
      COMMON /BE1/YPT1(66),YPT2(66),YPT3(66),YPT4(66),YPT5(66),YPT6(66)
      COMMON /BE2/EPT1(66),EPT2(66),EPT3(66),EPT4(66),EPT5(66),EPT6(66)
      COMMON /BE3/YPT1B(66),YPT2B(66),YPT3B(66),YPT4B(66),YPT5B(66)
      COMMON /BE4/EPT1B(66),EPT2B(66),EPT3B(66),EPT4B(66),EPT5B(66)
      DO 1 I=1,66
      YPT1(I)=0.
      EPT1(I)=0.
      YPT2(I)=0.
      EPT2(I)=0.
      YPT3(I)=0.
      EPT3(I)=0.
      YPT4(I)=0.
      EPT4(I)=0.
      YPT5(I)=0.
      EPT5(I)=0.
      YPT6(I)=0.
      EPT6(I)=0.
      YPT1B(I)=0.
      EPT1B(I)=0.
      YPT2B(I)=0.
      EPT2B(I)=0.
      YPT3B(I)=0.
      EPT3B(I)=0.
      YPT4B(I)=0.
      EPT4B(I)=0.
      YPT5B(I)=0.
      EPT5B(I)=0.
 1    CONTINUE
      RETURN
      END
      SUBROUTINE ESPEC2
      COMMON /BE1/YPT1(66),YPT2(66),YPT3(66),YPT4(66),YPT5(66),YPT6(66)
      COMMON /BE2/EPT1(66),EPT2(66),EPT3(66),EPT4(66),EPT5(66),EPT6(66)
      COMMON /BE3/YPT1B(66),YPT2B(66),YPT3B(66),YPT4B(66),YPT5B(66)
      COMMON /BE4/EPT1B(66),EPT2B(66),EPT3B(66),EPT4B(66),EPT5B(66)
      DO 100 I=1,60
      IF(YPT1(I).GT.0.) EPT1(I)=EPT1(I)/YPT1(I)
      IF(YPT2(I).GT.0.) EPT2(I)=EPT2(I)/YPT2(I)
      IF(YPT3(I).GT.0.) EPT3(I)=EPT3(I)/YPT3(I)
      IF(YPT4(I).GT.0.) EPT4(I)=EPT4(I)/YPT4(I)
      IF(YPT5(I).GT.0.) EPT5(I)=EPT5(I)/YPT5(I)
      IF(YPT6(I).GT.0.) EPT6(I)=EPT6(I)/YPT6(I)
      IF(YPT1B(I).GT.0.) EPT1B(I)=EPT1B(I)/YPT1B(I)
      IF(YPT2B(I).GT.0.) EPT2B(I)=EPT2B(I)/YPT2B(I)
      IF(YPT3B(I).GT.0.) EPT3B(I)=EPT3B(I)/YPT3B(I)
      IF(YPT4B(I).GT.0.) EPT4B(I)=EPT4B(I)/YPT4B(I)
      IF(YPT5B(I).GT.0.) EPT5B(I)=EPT5B(I)/YPT5B(I)
 100  CONTINUE
 10   FORMAT(2X,10F7.0)
 11   FORMAT(2X,10F7.2)
c$$$      PRINT 1
c$$$ 1    FORMAT(2X,'yield of particl. with Z=1-60 in thet.= 0-12 deg.')
c$$$      PRINT 10,(YPT1(I),I=1,60)
c$$$      PRINT 2
c$$$ 2    FORMAT(2X,'mean energ.(MeV) part. Z=1-60 in thet.= 0-12 deg.')
c$$$      PRINT 11,(EPT1(I),I=1,60)
c$$$      PRINT 3
c$$$ 3    FORMAT(2X,'yield of particl. with Z=1-60 in thet.=12-25 deg.')
c$$$      PRINT 10,(YPT2(I),I=1,60)
c$$$      PRINT 4
c$$$ 4    FORMAT(2X,'mean energ.(MeV) part. Z=1-60 in thet.=12-25 deg.')
c$$$      PRINT 11,(EPT2(I),I=1,60)
c$$$      PRINT 5
c$$$ 5    FORMAT(2X,'yield of particl. with Z=1-60 in thet.=25-45 deg.')
c$$$      PRINT 10,(YPT3(I),I=1,60)
c$$$      PRINT 6
c$$$ 6    FORMAT(2X,'mean energ.(MeV) part. Z=1-60 in thet.=25-45 deg.')
c$$$      PRINT 11,(EPT3(I),I=1,60)
c$$$      PRINT 7
c$$$ 7    FORMAT(2X,'yield of particl. with Z=1-60 in thet.=45-60 deg.')
c$$$      PRINT 10,(YPT4(I),I=1,60)
c$$$      PRINT 8
c$$$ 8    FORMAT(2X,'mean energ.(MeV) part. Z=1-60 in thet.=45-60 deg.')
c$$$      PRINT 11,(EPT4(I),I=1,60)
c$$$      PRINT 13
c$$$ 13   FORMAT(2X,'yield of particl. with Z=1-60 in thet.=60-90 deg.')
c$$$      PRINT 10,(YPT5(I),I=1,60)
c$$$      PRINT 14
c$$$ 14   FORMAT(2X,'mean energ.(MeV) part. Z=1-60 in thet.=60-90 deg.')
c$$$      PRINT 11,(EPT5(I),I=1,60)
c$$$      PRINT 21
c$$$ 21   FORMAT(2X,'yield of particl.with Z=1-60 in thet.(BI)= 0-12 deg.')
c$$$      PRINT 10,(YPT1B(I),I=1,60)
c$$$      PRINT 22
c$$$ 22   FORMAT(2X,'mean energ.(MeV)part. Z=1-60 in thet.(BI)= 0-12 deg.')
c$$$      PRINT 11,(EPT1B(I),I=1,60)
c$$$      PRINT 23
c$$$ 23   FORMAT(2X,'yield of particl.with Z=1-60 in thet.(BI)=12-25 deg.')
c$$$      PRINT 10,(YPT2B(I),I=1,60)
c$$$      PRINT 24
c$$$ 24   FORMAT(2X,'mean energ.(MeV)part. Z=1-60 in thet.(BI)=12-25 deg.')
c$$$      PRINT 11,(EPT2B(I),I=1,60)
c$$$      PRINT 25
c$$$ 25   FORMAT(2X,'yield of particl.with Z=1-60 in thet.(BI)=25-45 deg.')
c$$$      PRINT 10,(YPT3B(I),I=1,60)
c$$$      PRINT 26
c$$$ 26   FORMAT(2X,'mean energ.(MeV)part. Z=1-60 in thet.(BI)=25-45 deg.')
c$$$      PRINT 11,(EPT3B(I),I=1,60)
c$$$      PRINT 27
c$$$ 27   FORMAT(2X,'yield of particl.with Z=1-60 in thet.(BI)=45-60 deg.')
c$$$      PRINT 10,(YPT4B(I),I=1,60)
c$$$      PRINT 28
c$$$ 28   FORMAT(2X,'mean energ.(MeV)part. Z=1-60 in thet.(BI)=45-60 deg.')
c$$$      PRINT 11,(EPT4B(I),I=1,60)
c$$$      PRINT 29
c$$$ 29   FORMAT(2X,'yield of particl.with Z=1-60 in thet.(BI)=60-90 deg.')
c$$$      PRINT 10,(YPT5B(I),I=1,60)
c$$$      PRINT 30
c$$$ 30   FORMAT(2X,'mean energ.(MeV)part. Z=1-60 in thet.(BI)=60-90 deg.')
c$$$      PRINT 11,(EPT5B(I),I=1,60)
      RETURN
      END
      SUBROUTINE CSPEC2(KST1,APAT,ZPAT,EKIP,TETP,PHIP)
      COMMON /BE1/YPT1(66),YPT2(66),YPT3(66),YPT4(66),YPT5(66),YPT6(66)
      COMMON /BE2/EPT1(66),EPT2(66),EPT3(66),EPT4(66),EPT5(66),EPT6(66)
      COMMON /BE3/YPT1B(66),YPT2B(66),YPT3B(66),YPT4B(66),YPT5B(66)
      COMMON /BE4/EPT1B(66),EPT2B(66),EPT3B(66),EPT4B(66),EPT5B(66)
      DIMENSION APAT(500),ZPAT(500),EKIP(500),TETP(500),PHIP(500)
      DIMENSION XR(3),YR(3),ZR(3),PI(3),PN(3),XC(3),YC(3),ZC(3)
      DIMENSION PXX(500),PYY(500),PZZ(500)
      DO 1 I=1,KST1
      IA=INT(APAT(I)+0.1)
      IZ=INT(ZPAT(I)+0.1)
      A=IA
      Z=IZ
      if(ekip(i).gt.0) then
        EK=EKIP(I)
      else
        ek=0.
      endif
      ANTET=TETP(I)
      ANPHI=PHIP(I)
      IF(ANTET.GE.0.AND.ANTET.LT.12.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT1(IZ)=YPT1(IZ)+1.
      IF(ANTET.GE.0.AND.ANTET.LT.12.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT1(IZ)=EPT1(IZ)+EK
      IF(ANTET.GE.12.AND.ANTET.LT.25.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT2(IZ)=YPT2(IZ)+1.
      IF(ANTET.GE.12.AND.ANTET.LT.25.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT2(IZ)=EPT2(IZ)+EK
      IF(ANTET.GE.25.AND.ANTET.LT.45.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT3(IZ)=YPT3(IZ)+1.
      IF(ANTET.GE.25.AND.ANTET.LT.45.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT3(IZ)=EPT3(IZ)+EK
      IF(ANTET.GE.45.AND.ANTET.LT.60.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT4(IZ)=YPT4(IZ)+1.
      IF(ANTET.GE.45.AND.ANTET.LT.60.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT4(IZ)=EPT4(IZ)+EK
      IF(ANTET.GE.60.AND.ANTET.LT.90.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT5(IZ)=YPT5(IZ)+1.
      IF(ANTET.GE.60.AND.ANTET.LT.90.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT5(IZ)=EPT5(IZ)+EK
      ANTE=(3.14159/180.)*ANTET
      ANPH=(3.14159/180.)*ANPHI
      PM=SQRT(EK*(EK+2.*A*940.))
      PZZ(I)=PM*COS(ANTE)
      PM=PM*SIN(ANTE)
      PXX(I)=PM*COS(ANPH)
      PYY(I)=PM*SIN(ANPH)
 1    CONTINUE
      IRMAX=0
      IZMAX=0
      AMAX=0.
      PXMAX=0.
      PYMAX=0.
      PZMAX=0.
      PXTOT=0.
      PYTOT=0.
      PZTOT=0.
      ATOT=0.
      DO 2 I=1,KST1
      IA=INT(APAT(I)+0.1)
      IZ=INT(ZPAT(I)+0.1)
      A=IA
      Z=IZ
      IF(IZ.GE.3) PXTOT=PXTOT+PXX(I)
      IF(IZ.GE.3) PYTOT=PYTOT+PYY(I)
      IF(IZ.GE.3) PZTOT=PZTOT+PZZ(I)
      IF(IZ.GE.3) ATOT=ATOT+A
      EK=EKIP(I)
      IF(IZ.GT.IZMAX) IRMAX=I
      IF(IZ.GT.IZMAX) AMAX=IA
      IF(IZ.GT.IZMAX) PXMAX=PXX(I)
      IF(IZ.GT.IZMAX) PYMAX=PYY(I)
      IF(IZ.GT.IZMAX) PZMAX=PZZ(I)
      IF(IZ.GT.IZMAX) IZMAX=IZ
 2    CONTINUE
      VXMAX=PXMAX/(940.*AMAX)
      VYMAX=PYMAX/(940.*AMAX)
      VZMAX=PZMAX/(940.*AMAX)
      if(atot.gt.0) then
      VXTOT=PXTOT/(940.*ATOT)
      VYTOT=PYTOT/(940.*ATOT)
      VZTOT=PZTOT/(940.*ATOT)
      else
      VXTOT=0.
      VYTOT=0.
      VZTOT=0.
      endif
      V0MAX=SQRT(VXMAX**2+VYMAX**2+VZMAX**2)
      V0TOT=SQRT(VXTOT**2+VYTOT**2+VZTOT**2)
c ****** ------- Finding ANTET respective to new axes -------- ******
cc -------  via transformation in new coordinate system --------
cc XC(3),YC(3),ZC(3) - initial coordinate system (laboratory system)
cc BEAMX,BEAMY,BEAMZ - beam direction,
cc VXMAX,VYMAX,VZMAX - vectors of largest fragment (new Z axis); 
cc ZR(3) = [beam*VMAX] - perpendicular direction (new Z axis)
cc XR(3),YR(3),ZR(3) - coordinates of new axes
c      XC(1)=1.
c      XC(2)=0.
c      XC(3)=0.
c      YC(1)=0.
c      YC(2)=1.
c      YC(3)=0.
c      ZC(1)=0.
c      ZC(2)=0.
c      ZC(3)=1.
cc ----------------
c      BEAMX=0.
c      BEAMY=0.
c      BEAMZ=1.
cc new axis X = [beam*VMAX]
c      XR(1)=BEAMY*VZMAX-BEAMZ*VYMAX
c      XR(2)=BEAMZ*VXMAX-BEAMX*VZMAX
c      XR(3)=BEAMX*VYMAX-BEAMY*VXMAX
c      IF(XR(1).EQ.0.AND.XR(2).EQ.0.AND.XR(3).EQ.0.) RETURN
cc new axis Z = VMAX
c      ZR(1)=VXMAX
c      ZR(2)=VYMAX
c      ZR(3)=VZMAX
c      IF(ZR(1).EQ.0.AND.ZR(2).EQ.0.AND.ZR(3).EQ.0.) RETURN
cc new axis Y = [Z*X]
c      YR(1)=ZR(2)*XR(3)-ZR(3)*XR(2)
c      YR(2)=ZR(3)*XR(1)-ZR(1)*XR(3)
c      YR(3)=ZR(1)*XR(2)-ZR(2)*XR(1)
c      IF(YR(1).EQ.0.AND.YR(2).EQ.0.AND.YR(3).EQ.0.) RETURN
cc -------------------------------------------------------------
c      DO 6 I=1,KST1
c      IA=INT(APAT(I)+0.1)
c      IZ=INT(ZPAT(I)+0.1)
c      A=IA
c      PI(1)=PXX(I)
c      PI(2)=PYY(I)
c      PI(3)=PZZ(I)
c      CALL ROTO2(XC,YC,ZC,XR,YR,ZR,PI,PN)
cc ----------------------------
cc      IF(NLYNA.GT.5) GO TO 5
cc      PRINT 3,XR(1),XR(2),XR(3),YR(1),YR(2),YR(3),ZR(1),ZR(2),ZR(3)
cc 3    FORMAT(2X,'vectors, new X-axis: XR(1,2,3)=',3F9.4/
cc     *10X,' new Y-axis: YR(1,2,3)=',3F9.4/
cc     *10X,' new Z-axis: ZR(1,2,3)=',3F9.4)
cc      PRINT 4,PI(1),PI(2),PI(3),PN(1),PN(2),PN(3)
cc 4    FORMAT(2X,'------'/
cc     *2X,'initial PI(1,2,3)=',3F9.4/
cc     *2X,'  final PN(1,2,3)=',3F9.4)
cc 5    CONTINUE
cc ----------------------------
c      PXX(I)=PN(1)
c      PYY(I)=PN(2)
c      PZZ(I)=PN(3)
c 6    CONTINUE
c      DO 7 I=1,KST1
c      IA=INT(APAT(I)+0.1)
c      IZ=INT(ZPAT(I)+0.1)
c      A=IA
c      EK=EKIP(I)
c      PPP=PXX(I)**2+PYY(I)**2+PZZ(I)**2
c      IF(PPP.LE.0.) GO TO 7
c      NPTRA=NPTRA+1
c      COTQ=PZZ(I)*PZZ(I)/PPP
c      IF(COTQ.GE.1.) COTQ=1.
c      COT=SQRT(COTQ)
c      ANTET=ACOS(COT)*180.0/3.14159
c 7    CONTINUE
c -------------------------------------------------------------
c ****** new ANTET respective to V_max or V_tot ******
      DO 8 I=1,KST1
      IA=INT(APAT(I)+0.1)
      IZ=INT(ZPAT(I)+0.1)
      A=IA
      EK=EKIP(I)
      VX=PXX(I)/(A*940.)
      VY=PYY(I)/(A*940.)
      VZ=PZZ(I)/(A*940.)
      V0=SQRT(VX**2+VY**2+VZ**2)
c      VVM=(VX+VXMAX)**2+(VY+VYMAX)**2+(VZ+VZMAX)**2
c      COT=(VVM-V0**2-V0MAX**2)/(2.*V0*V0MAX)
      VVM=(VX+VXTOT)**2+(VY+VYTOT)**2+(VZ+VZTOT)**2
      IF(V0.GT.0.AND.V0TOT.GT.0.) 
     *COT=(VVM-V0**2-V0TOT**2)/(2.*V0*V0TOT)
      IF(V0.LE.0.OR.V0TOT.LE.0.) COT=-1.
      IF(COT.LT.-1.) COT=-1.
      iF(COT.GT.1.) COT=1.
      ANTET=ACOS(COT)*180.0/3.14159
      IF(ANTET.GE.0.AND.ANTET.LT.12.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT1B(IZ)=YPT1B(IZ)+1.
      IF(ANTET.GE.0.AND.ANTET.LT.12.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT1B(IZ)=EPT1B(IZ)+EK
      IF(ANTET.GE.12.AND.ANTET.LT.25.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT2B(IZ)=YPT2B(IZ)+1.
      IF(ANTET.GE.12.AND.ANTET.LT.25.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT2B(IZ)=EPT2B(IZ)+EK
      IF(ANTET.GE.25.AND.ANTET.LT.45.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT3B(IZ)=YPT3B(IZ)+1.
      IF(ANTET.GE.25.AND.ANTET.LT.45.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT3B(IZ)=EPT3B(IZ)+EK
      IF(ANTET.GE.45.AND.ANTET.LT.60.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT4B(IZ)=YPT4B(IZ)+1.
      IF(ANTET.GE.45.AND.ANTET.LT.60.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT4B(IZ)=EPT4B(IZ)+EK
      IF(ANTET.GE.60.AND.ANTET.LT.90.AND.IZ.GE.1.AND.IZ.LE.60) 
     *YPT5B(IZ)=YPT5B(IZ)+1.
      IF(ANTET.GE.60.AND.ANTET.LT.90.AND.IZ.GE.1.AND.IZ.LE.60) 
     *EPT5B(IZ)=EPT5B(IZ)+EK
 8    CONTINUE
      RETURN
      END
      SUBROUTINE HOFPC(IPT,KST1,A0,Z0,AM,CH,UP,PN0,TEMP,ECOLB)
c *****   for correlation of cold fragments and light charged particles 
c produced after decay of hot fragments.  *****
c FPCY(1-IZ0) - number of these cold fragments, taken one (max) charge after 
c decay of a primary hot fragment. 
c HOFZ(1-IZ0) - mean charge of the corresponding hot fragment.
c HOFNZ(1-IZ0) - mean N/Z ratio of the corresponding hot fragment.
c HOFU(1-IZ0) - mean excit.energy of the corresponding hot fragment.
c FPCZ(6,1-IZ0) - numb. of emit. light charg.particles (n,p,d,t,3He,4He).
c FPCE(6,1-IZ0) - kin.energ. of emit. light charg.part. in c.m.s of the cold. 
      DIMENSION XX(199),YY(199),ZZ(199),AM(500),CH(500),PN0(3,500)
      DIMENSION PA(500),PAZ(500),UP(500),PR(3),VR(3),PN(3),PP(3)
      COMMON /BLCEN/XC(500),YC(500),ZC(500) /BLHKST/IHFKST(500,2)
      COMMON /BLOKC/SPTU(10,500)
      COMMON /BLHO1/FPCY(500),FPCZ(6,500),FPCE(6,500),HOFZ(500),
     *HOFU(500),HOFNZ(500)
      COMMON /BLJJJ/JJJ
      IZ0=INT(Z0+0.1)
c -----------------
      IAT=0
      IZT=0
      IZHT=0
      EKINT=0.
      EKINH=0.
c -----------------
      IAHT=0
      RCMX=0.
      RCMY=0.
      RCMZ=0.
      DO 1 I=1,IPT
      XX(I)=XC(I)
      YY(I)=YC(I)
      ZZ(I)=ZC(I)
      IAH=INT(AM(I)/0.94+0.5)
      IZH=INT(CH(I)+0.5)
      PA(I)=IAH
      PAZ(I)=IZH
      IAHT=IAHT+IAH
      RCMX=RCMX+IAH*XX(I)
      RCMY=RCMY+IAH*YY(I)
      RCMZ=RCMZ+IAH*ZZ(I)
c ------------------
c      EN0=(PN0(1,I)**2+PN0(2,I)**2+PN0(3,I)**2)/(2.*AM(I))
c      EKINH=EKINH+EN0
c      IZHT=IZHT+IZH
c      PRINT 22,IAH,IZH
c 22   FORMAT(2X,'hofpc:  IAH,IZH=',2I4)
c ------------------
 1    CONTINUE
      RCMX=RCMX/FLOAT(IAHT)
      RCMY=RCMY/FLOAT(IAHT)
      RCMZ=RCMZ/FLOAT(IAHT)
c ------------------
c      RCM=SQRT(RCMX**2+RCMY**2+RCMZ**2)
c      PRINT 21,IAHT,IZHT,EKINH,RCM
c 21   FORMAT(2X,'hofpc:  IAHT,IZHT=',2I4,' EKINH(gev)=',F7.4,
c     *' RCM(fm)=',F6.2)
c ------------------
      IMF=0
      DO 2 I=1,KST1
      IZ=INT(SPTU(8,I)+0.5)
      IA=INT(SPTU(9,I)/0.94+0.5)
c ----------------------
c      EK=SPTU(7,I)
c      EKINT=EKINT+EK
c      IAT=IAT+IA
c      IZT=IZT+IZ
c      PRINT 20,IA,IZ,EK
c 20   FORMAT(2X,'hofpc:  IA,IZ=',2I4,' EK=',F7.4)
c ----------------------
      IF(IZ.GE.3.AND.IZ.LE.20) IMF=IMF+1
 2    CONTINUE
c ----------------------
c      PRINT 23,IAT,IZT,IMF,EKINT
c 23   FORMAT(2X,'hofpc:  IAT,IZT=',2I4,' IMF=',I3,
c     *' sum EKINT(gev)=',F8.4)
c ----------------------
c      IF(IMF.EQ.0) GO TO 4
      DO 5 I=1,IPT
      IAH=INT(PA(I)+0.5)
      IZH=INT(PAZ(I)+0.5)
      EN0=(PN0(1,I)**2+PN0(2,I)**2+PN0(3,I)**2)/(2.*AM(I))
      RR=SQRT((XX(I)-RCMX)**2+(YY(I)-RCMY)**2+(ZZ(I)-RCMZ)**2)
      J1=IHFKST(I,1)
      J2=IHFKST(I,2)
c -------------------
c      PRINT 25,IAH,IZH,EN0,RR,J1,J2
c 25   FORMAT(7X,'primar.fragm.:  IAH,IZH=',2I4,' EN0=',F7.4,
c     *' RR(fm)=',F5.2,' J1,J2=',2I4)
c -------- cold fragment under study --------
      IZMAX=0
      JMAX=J1
      DO 7 J=J1,J2
      IZ=INT(SPTU(8,J)+0.5)
      IF(IZ.GT.IZMAX) JMAX=J
      IF(IZ.GT.IZMAX) IZMAX=IZ
 7    CONTINUE
      IF(JMAX.LT.J1.OR.JMAX.GT.J2) PRINT 8,JMAX,J1,J2,KST1,IPT
 8    FORMAT(1X,'error HOFPC: Jmax=',I3,' out of J1,J2=',I3,1X,I3,
     *' #part KST1=',I3,' #hot.frag IPT=',I3)
c --------- print for the case of mistake ---------
      IF(JMAX.GE.J1.AND.JMAX.LE.J2) GO TO 30
c      PRINT 31,JJJ,IAH,IZH,IZMAX
c 31   FORMAT(2X,'JJJ=',I6,' IAH=',I3,' IZH=',I3,' IZMAX=',I3)
c      DO 32 III=1,IPT
c      PRINT 33,PA(III),PAZ(III),IHFKST(III,1),IHFKST(III,2)
c 33   FORMAT(2X,'PA=',F5.1,' PAZ=',F5.1,' IHFKST=',2I4)
c 32   CONTINUE
      DO 34 III=1,KST1
      IZII=INT(SPTU(8,III)+0.5)
      IAII=INT(SPTU(9,III)/0.94+0.5)
c      PRINT 35,IZII,IAII
c 35   FORMAT(2X,'cold fragm. IZII,IAII=',2I4)
 34   CONTINUE
 30   CONTINUE
c -------------------------------------------------
      IF(JMAX.LT.J1.OR.JMAX.GT.J2) GO TO 5
      IF(IZMAX.LT.1.OR.IZMAX.GT.IZ0) GO TO 5
      COT=SPTU(4,JMAX)
      SIT=SQRT(1.-COT*COT)
      COF=SPTU(6,JMAX)
      SIF=SPTU(5,JMAX)
      CALL TINP(PR,COT,SIT,COF,SIF,SPTU(7,JMAX),SPTU(9,JMAX))
      ETMAX=SQRT(PR(1)**2+PR(2)**2+PR(3)**2+SPTU(9,JMAX)**2)
      VR(1)=-PR(1)/ETMAX
      VR(2)=-PR(2)/ETMAX
      VR(3)=-PR(3)/ETMAX
      FPCY(IZMAX)=FPCY(IZMAX)+1.
      HOFZ(IZMAX)=HOFZ(IZMAX)+PAZ(I)
      HOFNZ(IZMAX)=HOFNZ(IZMAX)+(PA(I)-PAZ(I))/PAZ(I)
      HOFU(IZMAX)=HOFU(IZMAX)+UP(I)
c -------- particles respective to the cold fragment --------
      DO 6 J=J1,J2
      IF(J.EQ.JMAX) GO TO 6
      IZ=INT(SPTU(8,J)+0.5)
      IA=INT(SPTU(9,J)/0.94+0.5)
      EK=SPTU(7,J)
      AMM=SPTU(9,J)
      COT=SPTU(4,J)
      SIT=SQRT(1.-COT*COT)
      COF=SPTU(6,J)
      SIF=SPTU(5,J)
      CALL TINP(PP,COT,SIT,COF,SIF,EK,AMM)
      EN=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+AMM**2)
      CALL CLPV(PP,VR,PN,EN)
      CALL PINT(PN,CT,ST,CF,SF,EKNEW,AMM)
c -------------------
c      PRINT 24,IA,IZ,EK,EKNEW
c 24   FORMAT(20X,'second.fragm.:  IA,IZ=',2I4,' EK=',F7.4,
c     *' EKNEW=',F7.4)
c -------------------
      IF(IA.EQ.1.AND.IZ.EQ.0) FPCZ(1,IZMAX)=FPCZ(1,IZMAX)+1.
      IF(IA.EQ.1.AND.IZ.EQ.1) FPCZ(2,IZMAX)=FPCZ(2,IZMAX)+1.
      IF(IA.EQ.2.AND.IZ.EQ.1) FPCZ(3,IZMAX)=FPCZ(3,IZMAX)+1.
      IF(IA.EQ.3.AND.IZ.EQ.1) FPCZ(4,IZMAX)=FPCZ(4,IZMAX)+1.
      IF(IA.EQ.3.AND.IZ.EQ.2) FPCZ(5,IZMAX)=FPCZ(5,IZMAX)+1.
      IF(IA.EQ.4.AND.IZ.EQ.2) FPCZ(6,IZMAX)=FPCZ(6,IZMAX)+1.
      IF(IA.EQ.1.AND.IZ.EQ.0) FPCE(1,IZMAX)=FPCE(1,IZMAX)+EKNEW
      IF(IA.EQ.1.AND.IZ.EQ.1) FPCE(2,IZMAX)=FPCE(2,IZMAX)+EKNEW
      IF(IA.EQ.2.AND.IZ.EQ.1) FPCE(3,IZMAX)=FPCE(3,IZMAX)+EKNEW
      IF(IA.EQ.3.AND.IZ.EQ.1) FPCE(4,IZMAX)=FPCE(4,IZMAX)+EKNEW
      IF(IA.EQ.3.AND.IZ.EQ.2) FPCE(5,IZMAX)=FPCE(5,IZMAX)+EKNEW
      IF(IA.EQ.4.AND.IZ.EQ.2) FPCE(6,IZMAX)=FPCE(6,IZMAX)+EKNEW
 6    CONTINUE
c -----------------
 5    CONTINUE
 4    CONTINUE
      RETURN
      END
      SUBROUTINE HOFPCB
      COMMON /BLHO1/FPCY(500),FPCZ(6,500),FPCE(6,500),HOFZ(500),
     *HOFU(500),HOFNZ(500)
      DO 1 I=1,500
      FPCY(I)=0.
      HOFZ(I)=0.
      HOFNZ(I)=0.
      HOFU(I)=0.
      DO 2 J=1,6
      FPCZ(J,I)=0.
      FPCE(J,I)=0.
 2    CONTINUE
 1    CONTINUE
      RETURN
      END
      SUBROUTINE HOFPCE(IZ0)
      COMMON /BLHO1/FPCY(500),FPCZ(6,500),FPCE(6,500),HOFZ(500),
     *HOFU(500),HOFNZ(500)
      COMMON /BWRITD/JWRITD /BWRITA/HISA(400),HISZ(200),HISZA(200)
      DO 1 I=1,IZ0
      IF(FPCY(I).LE.0) GO TO 1
      HOFU(I)=1000.*HOFU(I)/FPCY(I)
      HOFNZ(I)=HOFNZ(I)/FPCY(I)
      HOFZ(I)=HOFZ(I)/FPCY(I)
      DO 2 J=1,6
      IF(FPCZ(J,I).GT.0.) FPCE(J,I)=1000.*FPCE(J,I)/FPCZ(J,I)
      FPCZ(J,I)=FPCZ(J,I)/FPCY(I)
 2    CONTINUE
 1    CONTINUE
 4    FORMAT(2X,10F7.0)
 6    FORMAT(2X,10F7.2)
 8    FORMAT(2X,10F7.3)
 13   FORMAT(2X,10F7.1)
c      PRINT 3
c 3    FORMAT(2X,'** HOFPC: correlat. of secondary LCP with',
c     *' fragment from which they emited **'/
c     *2X,'-cold fragm. (max charges after decay of each hot fragm.)',
c     *' FPCY(1-IZ0):')
c      PRINT 4,(FPCY(I),I=1,IZ0)
c      PRINT 5
c 5    FORMAT(2X,'correspond. hot fragments- Z-distr. HOFZ(1-IZ0):')
c      PRINT 6,(HOFZ(I),I=1,IZ0)
c      PRINT 7
c 7    FORMAT(2X,'         hot fragments- N/Z-distr. HOFNZ(1-IZ0):')
c      PRINT 8,(HOFNZ(I),I=1,IZ0)
c      PRINT 9
c 9    FORMAT(2X,'   hot fragments- excit.energ.(MeV) HOFU(1-IZ0):')
c      PRINT 13,(HOFU(I),I=1,IZ0)
c      PRINT 15
c 15   FORMAT(2X,'avr.mass of cold fragm. HISZA(1-IZ0):')
c      PRINT 6,(HISZA(I),I=1,IZ0)
c -------  writing on unit 51  vs. fragment charge -------------
      IF(JWRITD.EQ.0) GO TO 102
c     DO 100 I=1,IZ0
c     WRITE(51,101)I,HISZ(I),FPCY(I),HOFZ(I),HOFNZ(I),HOFU(I)
c101  FORMAT(1X,I3,1X,F8.4,1X,F7.0,1X,F6.2,1X,F6.3,1X,F6.1)
c      DO 100 I=1,IZ0
c      WRITE(51,101)I,HISZ(I),HISZA(I)
c 101  FORMAT(1X,I3,1X,F8.4,1X,F8.4)
c 100  CONTINUE
 102  CONTINUE
c --------------------------------------------------------------
c ** temporary limitation of the print for correlat. particl. !!! **
c      PRINT 10
c 10   FORMAT(2X,'*character.of particles emit. in coins. with', 
c     *' the colds. Indexes:'/2X,
c     *'IP=1-neutrons. IP=2-protons. IP=3-deutrons.',
c     *'IP=4-tritons. IP=5-3He. IP=6-4He.')
c      DO 11 J=1,6
c      PRINT 12,J
c 12   FORMAT(2X,'  ------  for the particles IP=',I2,' ------'/
c     *2X,' number of particles FPCZ:')
c      PRINT 8,(FPCZ(J,I),I=1,IZ0)
c      PRINT 14
c 14   FORMAT(2X,' mean kin. energ.(MeV) in cms of the cold  FPCE:')
c      PRINT 6,(FPCE(J,I),I=1,IZ0)
c 11   CONTINUE
      RETURN
      END
      SUBROUTINE ELIDR(A,Z,DLM)
c finiding binding energies of nuclei in liquid-drop approximation
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00
      COMMON /BICOLE/ICOLE
      IA=INT(A+0.5)
      IZ=INT(Z+0.5)
c -------------------------------------
      IF(IA.GE.IZ.AND.IZ.GT.0) GO TO 3
      IF(IA.GT.0.AND.IZ.EQ.0) GO TO 3
      PRINT 2,IA,IZ
 2    FORMAT(2X,'ERROR in ELIDR: IA,IZ=',2I5)
      STOP
 3    CONTINUE
c -------------------------------------
      IF(IA.GT.4) GO TO 1
      IF(IZ.GE.3) GO TO 1
      IF(IA.GT.1.AND.IZ.EQ.0) GO TO 1
      IF(IA.EQ.2.AND.IZ.EQ.2) GO TO 1
c -------- for 'gas' particles -------
      IF(IA.EQ.1.AND.IZ.EQ.0) DLM=8.071
      IF(IA.EQ.1.AND.IZ.EQ.1) DLM=7.289
      IF(IA.EQ.2.AND.IZ.EQ.1) DLM=13.136
      IF(IA.EQ.3.AND.IZ.EQ.1) DLM=14.950
      IF(IA.EQ.4.AND.IZ.EQ.1) DLM=25.920
      IF(IA.EQ.3.AND.IZ.EQ.2) DLM=14.931
      IF(IA.EQ.4.AND.IZ.EQ.2) DLM=2.425
      DLM=DLM-(8.071*IA-0.782*IZ)
      RETURN
 1    CONTINUE
c ------ for 'liquid' particles ------
      W0=W00
c      W0=16.
      B0=B00
c      B0=18.
c      G0=25.
      G0=G00
      RADNCL=1.17
      A13=A**0.33333333
      A23=A13*A13
      R=RADNCL*A13
      XZ=Z/A
      EQ=A*(-W0+G0*(1.-2.*XZ)**2)+B0*A23+0.6*1.44*Z*Z/R
      IF(ICOLE.EQ.-1) EQ=A*(-W0+G0*(1.-2.*XZ)**2)+B0*A23
      DLM=EQ
      RETURN
      END
c -----------------------------------------------------
c *********************
      SUBROUTINE CDCR0
      COMMON /CBCR1/ SZMAX,SRYMAX,SRRMAX,DRYMAX,DRRMAX,SVYMAX,
     *SVVMAX,DVYMAX,DVVMAX,RYMAX(46),RRMAX(26),VYMAX(46),VVMAX(26),SAMAX
     *,NZMAX
      COMMON /CBCR2/ SZMA2,SRYMA2,SRRMA2,DRYMA2,DRRMA2,SVYMA2,
     *SVVMA2,DVYMA2,DVVMA2,RYMA2(46),RRMA2(26),VYMA2(46),VVMA2(26),SAMA2
     *,NZMA2
      COMMON /CBCR3/ ZIMF,SRYIMF,SRRIMF,DRYIMF,DRRIMF,SVYIMF,
     *SVVIMF,DVYIMF,DVVIMF,RYIMF(46),RRIMF(26),VYIMF(46),VVIMF(26),AIMF
     *,NIMF
      COMMON /CBCR4/ ACMMAX(26),ACMMA2(26),ACMIMF(26)
      COMMON /CBCR5/ VYMAXS(56),VYMA2S(56),VYIMFS(56)
      COMMON /CBCR6/ ROZ_VY(56),ROF_VY(56),ROB_VY(56),VYZ1(56),VYZ2(56)
      COMMON /CBCR7/ PVYIMF(46),PVYMAX(46),
     *PVYTO1(46),CVYTO1(46),PVYTOT(46),CVYTOT(46),PVYMA2(46)
      COMMON /CBCR8/VYZ1A1(56),VYZ1A2(56),VYZ1A3(56),VYZ2A3(56),
     *VYZ2A4(56),VYZ2A6(56),VYZ3(56),VYZ4(56),VYZ5(56),VYZ6(56)
     *,VYZ3A6(56),VYZ3A7(56),VYZ4A7(56),VYZ4A10(56)
     *,VYZ6A11(56),VYZ6A14(56)
      COMMON /CBCR9/PVYZ3(56)
      NZMAX=0
      SZMAX=0.
      SAMAX=0.
      SRYMAX=0.
      SRRMAX=0.
      DRYMAX=0.
      DRRMAX=0.
      SVYMAX=0.
      SVVMAX=0.
      DVYMAX=0.
      DVVMAX=0.
      NZMA2=0
      SZMA2=0.
      SAMA2=0.
      SRYMA2=0.
      SRRMA2=0.
      DRYMA2=0.
      DRRMA2=0.
      SVYMA2=0.
      SVVMA2=0.
      DVYMA2=0.
      DVVMA2=0.
      NIMF=0
      ZIMF=0.
      AIMF=0.
      SRYIMF=0.
      SRRIMF=0.
      DRYIMF=0.
      DRRIMF=0.
      SVYIMF=0.
      SVVIMF=0.
      DVYIMF=0.
      DVVIMF=0.
      DO 1 I=1,46
      RYMAX(I)=0.
      IF(I.LE.26) RRMAX(I)=0.
      VYMAX(I)=0.
      IF(I.LE.26) VVMAX(I)=0.
      RYMA2(I)=0.
      IF(I.LE.26) RRMA2(I)=0.
      VYMA2(I)=0.
      IF(I.LE.26) VVMA2(I)=0.
      RYIMF(I)=0.
      IF(I.LE.26) RRIMF(I)=0.
      VYIMF(I)=0.
      IF(I.LE.26) VVIMF(I)=0.
      IF(I.LE.26) ACMIMF(I)=0.
      IF(I.LE.26) ACMMA2(I)=0.
      IF(I.LE.26) ACMMAX(I)=0.
      PVYIMF(I)=0.
      PVYMAX(I)=0.
      PVYMA2(I)=0.
      PVYTO1(I)=0.
      CVYTO1(I)=0.
      PVYTOT(I)=0.
      CVYTOT(I)=0.
  1   CONTINUE
      DO 2 I=1,56
      VYZ1(I)=0.
      VYZ2(I)=0.
      ROZ_VY(I)=0.
      ROF_VY(I)=0.
      ROB_VY(I)=0.
      VYMAXS(I)=0.
      VYMA2S(I)=0.
      VYIMFS(I)=0.
      VYZ1A1(I)=0.
      VYZ1A2(I)=0.
      VYZ1A3(I)=0.
      VYZ2A3(I)=0.
      VYZ2A4(I)=0.
      VYZ2A6(I)=0.
      VYZ3(I)=0.
      VYZ4(I)=0.
      VYZ5(I)=0.
      VYZ6(I)=0.
      PVYZ3(I)=0.
      VYZ3A6(I)=0.
      VYZ3A7(I)=0.
      VYZ4A7(I)=0.
      VYZ4A10(I)=0.
      VYZ6A11(I)=0.
      VYZ6A14(I)=0.
 2    CONTINUE
      RETURN
      END
      SUBROUTINE CDCR(A0,Z0,IP0,AMP,ZMP,PN0,RMP)
c Analysis of cold fragments characteristics: velocities, N/Z, ...
c Influence of the second source is taken into account.
      COMMON /CB1/ XX(200),YY(200),ZZ(200),PXX(200),PYY(200),PZZ(200),
     *IAA(200),IZZ(200)
      COMMON /CBNUM/ IA0,IZ0,NFRAG1
      COMMON /CBCR1/ SZMAX,SRYMAX,SRRMAX,DRYMAX,DRRMAX,SVYMAX,
     *SVVMAX,DVYMAX,DVVMAX,RYMAX(46),RRMAX(26),VYMAX(46),VVMAX(26),SAMAX
     *,NZMAX
      COMMON /CBCR2/ SZMA2,SRYMA2,SRRMA2,DRYMA2,DRRMA2,SVYMA2,
     *SVVMA2,DVYMA2,DVVMA2,RYMA2(46),RRMA2(26),VYMA2(46),VVMA2(26),SAMA2
     *,NZMA2
      COMMON /CBCR3/ ZIMF,SRYIMF,SRRIMF,DRYIMF,DRRIMF,SVYIMF,
     *SVVIMF,DVYIMF,DVVIMF,RYIMF(46),RRIMF(26),VYIMF(46),VVIMF(26),AIMF
     *,NIMF
      COMMON /CBCR4/ ACMMAX(26),ACMMA2(26),ACMIMF(26)
      COMMON /CBCR5/ VYMAXS(56),VYMA2S(56),VYIMFS(56)
      COMMON /CBCR6/ ROZ_VY(56),ROF_VY(56),ROB_VY(56),VYZ1(56),VYZ2(56)
      COMMON /CBCR7/ PVYIMF(46),PVYMAX(46),
     *PVYTO1(46),CVYTO1(46),PVYTOT(46),CVYTOT(46),PVYMA2(46)
      COMMON /BDCR/VCMSP,VCMST
      COMMON /CBCR8/VYZ1A1(56),VYZ1A2(56),VYZ1A3(56),VYZ2A3(56),
     *VYZ2A4(56),VYZ2A6(56),VYZ3(56),VYZ4(56),VYZ5(56),VYZ6(56)
     *,VYZ3A6(56),VYZ3A7(56),VYZ4A7(56),VYZ4A10(56)
     *,VYZ6A11(56),VYZ6A14(56)
      COMMON /CBCR9/PVYZ3(56)
      DIMENSION AMP(500),ZMP(500),PN0(3,500),RMP(3,500)
c motion of projectile and target (for histogramming)
c -- 2 MeV/N 
c      VCMSP=0.25 
c      VCMST=0.02 ... see DCR
c --
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
      NFRAG1=IP0
      IF(NFRAG1.GT.200) NFRAG1=200
      IF(NFRAG1.LE.0) RETURN
      DO 501 IR=1,NFRAG1
      IAA(IR)=INT(AMP(IR)/0.94+0.5)
      IZZ(IR)=INT(ZMP(IR)+0.1)
      PXX(IR)=1000.*PN0(1,IR)
      PYY(IR)=1000.*PN0(2,IR)
      PZZ(IR)=1000.*PN0(3,IR)
      XX(IR)=RMP(1,IR)
      YY(IR)=RMP(2,IR)
      ZZ(IR)=RMP(3,IR)
 501  CONTINUE
c --
      XCC=0.
      YCC=0.
      ZCC=0.
      CHC=0.
      PXCC=0.
      PYCC=0.
      PZCC=0.
      SAAA=0.
      IZMAX=0
      IZMA2=0
      ZBOU3=0.
      DO 1 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.GE.3) ZBOU3=ZBOU3+IZZZ
c      CHC=CHC+IZZZ
c      XCC=XCC+IZZZ*XX(IR)
c      YCC=YCC+IZZZ*YY(IR)
c      ZCC=ZCC+IZZZ*ZZ(IR)
      XCC=XCC+IAAA*XX(IR)
      YCC=YCC+IAAA*YY(IR)
      ZCC=ZCC+IAAA*ZZ(IR)
      SAAA=SAAA+IAAA
      PXCC=PXCC+PXX(IR)
      PYCC=PYCC+PYY(IR)
      PZCC=PZCC+PZZ(IR)
      IF(IZZZ.GT.IZMAX) IRMAX=IR
      IF(IZZZ.GT.IZMAX) IZMAX=IZZZ
  1   CONTINUE
c -- respective to charge center --
c      XCC=XCC/CHC
c      YCC=YCC/CHC
c      ZCC=ZCC/CHC
c -- respective to mass center --
      XCC=XCC/SAAA
      YCC=YCC/SAAA
      ZCC=ZCC/SAAA
      VXCC=PXCC/(940.*SAAA)
      VYCC=PYCC/(940.*SAAA)
      VZCC=PZCC/(940.*SAAA)
c -- respective to geometrical center --
c      XCC=0
c      YCC=0.
c      ZCC=0.
c
c ------ limitation on analysed partitions ------
c      IF(IZMAX.LT.60) RETURN
c ------
      IF(IZMAX.GT.0) SZMAX=SZMAX+IZMAX
      IF(IZMAX.GT.0) SAMAX=SAMAX+IAA(IRMAX)
      IF(IZMAX.GT.0) NZMAX=NZMAX+1
c      DO 2 IR=1,NFRAG1
c      IF(IR.EQ.IRMAX) GO TO 2
c      IZZZ=IZZ(IR)
c      IF(IZZZ.GT.IZMA2) IRMA2=IR
c      IF(IZZZ.GT.IZMA2) IZMA2=IZZZ
c  2   CONTINUE
c      IF(IZMA2.GT.0) SZMA2=SZMA2+IZMA2
c      IF(IZMA2.GT.0) SAMA2=SAMA2+IAA(IRMA2)
c      IF(IZMA2.GT.0) NZMA2=NZMA2+1
      IF(IZMAX.LE.0) GO TO 3
c ------- coordinates ------
c ------ velocities -------
      VX=PXX(IRMAX)/(940.*IAA(IRMAX))-VXCC
      VY=PYY(IRMAX)/(940.*IAA(IRMAX))-VYCC
      VZ=PZZ(IRMAX)/(940.*IAA(IRMAX))-VZCC
      if(SQRT(VX**2+VY**2+VZ**2).ne.0) then
      COST=VY/SQRT(VX**2+VY**2+VZ**2)
      else
      cost=0.
      endif
      CALL HIST1(COST,-1.,1.,0.1,ACMMAX,26,1.)
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.2,0.2,0.01,VYMAX,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VYMAXS,56,1.)
c      CALL HIST1(VYT,-0.1,0.4,0.01,VYMAXS,56,1.)
      CALL HIST1(VV,0.,0.2,0.01,VVMAX,26,1.)
      SVYMAX=SVYMAX+VY
      DVYMAX=DVYMAX+VY*VY
      SVVMAX=SVVMAX+VV
      DVVMAX=DVVMAX+VV*VV
c ------- for N/Z ratio -------
      PNZ=FLOAT(IAA(IRMAX)-IZZ(IRMAX))/FLOAT(IZZ(IRMAX))
      CALL HIST1(VY,-0.2,0.2,0.01,PVYMAX,46,PNZ)
c -------------------------
 3    CONTINUE
      DO 4 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.NE.8) GO TO 4
      SZMA2=SZMA2+IZZZ
      SAMA2=SAMA2+IAAA
      NZMA2=NZMA2+1
c ------- coordinates ------
c ------ velocities -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      COST=VY/SQRT(VX**2+VY**2+VZ**2)
      CALL HIST1(COST,-1.,1.,0.1,ACMMA2,26,1.)
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.2,0.2,0.01,VYMA2,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VYMA2S,56,1.)
c      CALL HIST1(VYT,-0.1,0.4,0.01,VYMA2S,56,1.)
      CALL HIST1(VV,0.,0.2,0.01,VVMA2,26,1.)
      SVYMA2=SVYMA2+VY
      DVYMA2=DVYMA2+VY*VY
      SVVMA2=SVVMA2+VV
      DVVMA2=DVVMA2+VV*VV
c ------- for N/Z ratio -------
      PNZ=FLOAT(IAA(IR)-IZZ(IR))/FLOAT(IZZ(IR))
      CALL HIST1(VY,-0.2,0.2,0.01,PVYMA2,46,PNZ)
c -------------------------
 4    CONTINUE
c --------------------------
      DO 5 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.NE.3) GO TO 5
      NIMF=NIMF+1
      AIMF=AIMF+IAAA
      ZIMF=ZIMF+IZZZ
c ------- coordinates ------
c ------ velocities -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      vmodul=SQRT(VX**2+VY**2+VZ**2)
      if(vmodul.gt.0.) then
      COST=VY/vmodul
      else
      cost=sign(1.,vz)
      endif
      CALL HIST1(COST,-1.,1.,0.1,ACMIMF,26,1.)
      VYP=VY+VCMSP
      VYT=VCMST-VY
      VV=SQRT(VX*VX+VY*VY+VZ*VZ)
      CALL HIST1(VY,-0.2,0.2,0.01,VYIMF,46,1.)
      CALL HIST1(VYP,-0.1,0.4,0.01,VYIMFS,56,1.)
c      CALL HIST1(VYT,-0.1,0.4,0.01,VYIMFS,56,1.)
      CALL HIST1(VV,0.,0.2,0.01,VVIMF,26,1.)
      SVYIMF=SVYIMF+VY
      DVYIMF=DVYIMF+VY*VY
      SVVIMF=SVVIMF+VV
      DVVIMF=DVVIMF+VV*VV
c ------- for N/Z ratio -------
      PNZ=FLOAT(IAAA-IZZZ)/FLOAT(IZZZ)
      CALL HIST1(VY,-0.2,0.2,0.01,PVYIMF,46,PNZ)
c -------------------------
  5   CONTINUE
c --------------------------
      DO 6 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
c ------ charge density in parallel velocity -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      VYP=VY+VCMSP
      VYT=VCMST-VY
      W=IZZZ
      CALL HIST1(VYP,-0.1,0.4,0.01,ROZ_VY,56,W)
c      CALL HIST1(VYT,-0.1,0.4,0.01,ROZ_VY,56,W)
      if(zbou3.ne.0.) then
      WFB=IZZZ/ZBOU3
      else
      wfb=0.
      endif
      IF(IR.NE.IRMAX.AND.IZZZ.GE.3) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,ROF_VY,56,WFB)
c      IF(IR.NE.IRMAX.AND.IZZZ.GE.3) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,ROF_VY,56,WFB)
      IF(IR.EQ.IRMAX) CALL HIST1(VYP,-0.1,0.4,0.01,ROB_VY,56,WFB)
c      IF(IR.EQ.IRMAX) CALL HIST1(VYT,-0.1,0.4,0.01,ROB_VY,56,WFB)
  6   CONTINUE
c --------------------------
      DO 7 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
c ------ velocities -------
      VX=PXX(IR)/(940.*IAA(IR))-VXCC
      VY=PYY(IR)/(940.*IAA(IR))-VYCC
      VZ=PZZ(IR)/(940.*IAA(IR))-VZCC
      VYP=VY+VCMSP
      VYT=VCMST-VY
      IF(IZZZ.GT.0) PNZ=FLOAT(IAAA-IZZZ)/FLOAT(IZZZ)
      IF(IZZZ.EQ.1) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ1,56,1.)
c      IF(IZZZ.EQ.1) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ1,56,1.)
      IF(IZZZ.EQ.2) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ2,56,1.)
c      IF(IZZZ.EQ.2) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ2,56,1.)
      IF(IZZZ.EQ.1.AND.IAAA.EQ.1) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ1A1,56,1.)
c      IF(IZZZ.EQ.1.AND.IAAA.EQ.1) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ1A1,56,1.)
      IF(IZZZ.EQ.1.AND.IAAA.EQ.2) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ1A2,56,1.)
c      IF(IZZZ.EQ.1.AND.IAAA.EQ.2) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ1A2,56,1.)
      IF(IZZZ.EQ.1.AND.IAAA.EQ.3) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ1A3,56,1.)
c      IF(IZZZ.EQ.1.AND.IAAA.EQ.3) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ1A3,56,1.)
      IF(IZZZ.EQ.2.AND.IAAA.EQ.3) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ2A3,56,1.)
c      IF(IZZZ.EQ.2.AND.IAAA.EQ.3) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ2A3,56,1.)
      IF(IZZZ.EQ.2.AND.IAAA.EQ.4) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ2A4,56,1.)
c      IF(IZZZ.EQ.2.AND.IAAA.EQ.4) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ2A4,56,1.)
      IF(IZZZ.EQ.2.AND.IAAA.EQ.6) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ2A6,56,1.)
c      IF(IZZZ.EQ.2.AND.IAAA.EQ.6) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ2A6,56,1.)
      IF(IZZZ.EQ.3) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ3,56,1.)
c      IF(IZZZ.EQ.3) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ3,56,1.)
      IF(IZZZ.EQ.4) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ4,56,1.)
c      IF(IZZZ.EQ.4) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ4,56,1.)
      IF(IZZZ.EQ.5) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ5,56,1.)
c      IF(IZZZ.EQ.5) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ5,56,1.)
      IF(IZZZ.EQ.6) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ6,56,1.)
c      IF(IZZZ.EQ.6) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,VYZ6,56,1.)
      IF(IZZZ.EQ.3.AND.IAAA.EQ.6) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ3A6,56,1.)
      IF(IZZZ.EQ.3.AND.IAAA.EQ.7) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ3A7,56,1.)
      IF(IZZZ.EQ.4.AND.IAAA.EQ.7) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ4A7,56,1.)
      IF(IZZZ.EQ.4.AND.IAAA.EQ.10) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ4A10,56,1.)
      IF(IZZZ.EQ.6.AND.IAAA.EQ.11) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ6A11,56,1.)
      IF(IZZZ.EQ.6.AND.IAAA.EQ.14) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,VYZ6A14,56,1.)
c ----------- N/Z ratio -------------
      IF(IZZZ.EQ.3) 
     *CALL HIST1(VYP,-0.1,0.4,0.01,PVYZ3,56,PNZ)
c      IF(IZZZ.EQ.3) 
c     *CALL HIST1(VYT,-0.1,0.4,0.01,PVYZ3,56,PNZ)
c ------- for N/Z ratio for TOT,1 -------
c      IF(IAAA.LE.4.OR.IZZZ.LE.0) GO TO 7
      IF(IZZZ.LT.3.OR.IZZZ.GT.9) GO TO 7
      WAAA=1.
      IF(IZZZ.EQ.8) CALL HIST1(VY,-0.2,0.2,0.01,CVYTOT,46,WAAA)
      IF(IZZZ.EQ.3) CALL HIST1(VY,-0.2,0.2,0.01,CVYTO1,46,WAAA)
      PNZ=FLOAT(IAAA-IZZZ)/FLOAT(IZZZ)
      WPNZ=WAAA*PNZ
      IF(IZZZ.EQ.8) CALL HIST1(VY,-0.2,0.2,0.01,PVYTOT,46,WPNZ)
      IF(IZZZ.EQ.3) CALL HIST1(VY,-0.2,0.2,0.01,PVYTO1,46,WPNZ)
c -------------------------
  7   CONTINUE
c --------------------------
      RETURN
      END
      SUBROUTINE CDCRP
      COMMON /CBCR1/ SZMAX,SRYMAX,SRRMAX,DRYMAX,DRRMAX,SVYMAX,
     *SVVMAX,DVYMAX,DVVMAX,RYMAX(46),RRMAX(26),VYMAX(46),VVMAX(26),SAMAX
     *,NZMAX
      COMMON /CBCR2/ SZMA2,SRYMA2,SRRMA2,DRYMA2,DRRMA2,SVYMA2,
     *SVVMA2,DVYMA2,DVVMA2,RYMA2(46),RRMA2(26),VYMA2(46),VVMA2(26),SAMA2
     *,NZMA2
      COMMON /CBCR3/ ZIMF,SRYIMF,SRRIMF,DRYIMF,DRRIMF,SVYIMF,
     *SVVIMF,DVYIMF,DVVIMF,RYIMF(46),RRIMF(26),VYIMF(46),VVIMF(26),AIMF
     *,NIMF
      COMMON /CBCR4/ ACMMAX(26),ACMMA2(26),ACMIMF(26)
      COMMON /CBCR5/ VYMAXS(56),VYMA2S(56),VYIMFS(56)
      COMMON /CBCR6/ ROZ_VY(56),ROF_VY(56),ROB_VY(56),VYZ1(56),VYZ2(56)
      COMMON /CBCR7/ PVYIMF(46),PVYMAX(46),
     *PVYTO1(46),CVYTO1(46),PVYTOT(46),CVYTOT(46),PVYMA2(46)
      COMMON /BDCR/VCMSP,VCMST
      COMMON /BWRIT2/JWRIT2
      COMMON /CBCR8/VYZ1A1(56),VYZ1A2(56),VYZ1A3(56),VYZ2A3(56),
     *VYZ2A4(56),VYZ2A6(56),VYZ3(56),VYZ4(56),VYZ5(56),VYZ6(56)
     *,VYZ3A6(56),VYZ3A7(56),VYZ4A7(56),VYZ4A10(56)
     *,VYZ6A11(56),VYZ6A14(56)
      COMMON /CBCR9/PVYZ3(56)
      IF(NZMAX.LE.0) GO TO 9
      SZMAX=SZMAX/FLOAT(NZMAX)
      SAMAX=SAMAX/FLOAT(NZMAX)
      SVYMAX=SVYMAX/FLOAT(NZMAX)
      DVYMAX=DVYMAX/FLOAT(NZMAX)
      DDD=DVYMAX-SVYMAX*SVYMAX
      IF(DDD.GT.0.) DVYMAX=SQRT(DDD)
      IF(DDD.LE.0.) DVYMAX=0.
      SVVMAX=SVVMAX/FLOAT(NZMAX)
      DVVMAX=DVVMAX/FLOAT(NZMAX)
      DDD=DVVMAX-SVVMAX*SVVMAX
      IF(DDD.GT.0.) DVVMAX=SQRT(DDD)
      IF(DDD.LE.0.) DVVMAX=0.
c$$$      PRINT 300
c$$$ 300  FORMAT(2X,' ------------ COLD FRAGMENTS ------------')
c$$$      PRINT 1,NZMAX,SZMAX,SAMAX
c$$$ 1    FORMAT(2X,'numb.max.fragm. NZMAX=',I6,' charge SZMAX=',F4.1,
c$$$     *' mass SAMAX=',F6.2/5X,'(all coordinates/velocities from ',
c$$$     *'mass center!)')
c$$$      PRINT 3,SVYMAX,DVYMAX,SVVMAX,DVVMAX
c$$$ 3    FORMAT(2X,'mean Y-veloc. SVYMAX=',F6.4,'(c)  variance DVYMAX=',
c$$$     *F6.4/2X,'mean veloc. SVVMAX=',F6.4,'(c)  variance DVVMAX=',F6.4)
c$$$      PRINT 6
c$$$ 6    FORMAT(1X,'Y-veloc.of max.fragm. , -0.2:+0.2 c',
c$$$     *' (step=0.01c)  VYMAX:')
c$$$      PRINT 101,(VYMAX(J),J=1,40)
c$$$      PRINT 103,(VYMAX(J),J=41,46)
c$$$      PRINT 7
c$$$ 7    FORMAT(1X,'velocity of max.fragm. , 0:+0.2 c',
c$$$     *' (step=0.01c)  VVMAX:')
c$$$      PRINT 101,(VVMAX(J),J=1,20)
c$$$      PRINT 103,(VVMAX(J),J=21,26)
c$$$      PRINT 8
c$$$ 8    FORMAT(1X,'(cos)angle distr.of Y-veloc.max.fragm., -1:+1 ',
c$$$     *' (step=0.1) in c.m. ACMMAX:')
c$$$      PRINT 101,(ACMMAX(J),J=1,20)
c$$$      PRINT 103,(ACMMAX(J),J=21,26)
c ------------
      DO 210 J=1,40
      IF(VYMAX(J).GT.0.) PVYMAX(J)=PVYMAX(J)/VYMAX(J)
 210  CONTINUE
c      PRINT 202
c 202  FORMAT(1X,'N/Z ratio of MAX in Y-veloc., -0.2:+0.2 c',
c     *' (step=0.01c)  PVYMAX:')
c      PRINT 105,(PVYMAX(J),J=1,40)
c      PRINT 103,(PVYMAX(J),J=41,46)
c ------------
 9    CONTINUE
c 101  FORMAT(1X,10F7.0)
c 104  FORMAT(1X,10F7.1)
c 105  FORMAT(1X,10F7.3)
c 102  FORMAT(1X,6F12.2)
c 103  FORMAT(1X,6F12.4)
      IF(NZMA2.LE.0) GO TO 19
      SZMA2=SZMA2/FLOAT(NZMA2)
      SAMA2=SAMA2/FLOAT(NZMA2)
      SVYMA2=SVYMA2/FLOAT(NZMA2)
      DVYMA2=DVYMA2/FLOAT(NZMA2)
      DDD=DVYMA2-SVYMA2*SVYMA2
      IF(DDD.GT.0.) DVYMA2=SQRT(DDD)
      IF(DDD.LE.0.) DVYMA2=0.
      SVVMA2=SVVMA2/FLOAT(NZMA2)
      DVVMA2=DVVMA2/FLOAT(NZMA2)
      DDD=DVVMA2-SVVMA2*SVVMA2
      IF(DDD.GT.0.) DVVMA2=SQRT(DDD)
      IF(DDD.LE.0.) DVVMA2=0.
c$$$      PRINT 11,NZMA2,SZMA2,SAMA2
c$$$ 11   FORMAT(2X,'numb.second fragm. NZMA2=',I6,' charge SZMA2=',F4.1,
c$$$     *' mass SAMA2=',F7.3)
c$$$      PRINT 13,SVYMA2,DVYMA2,SVVMA2,DVVMA2
c$$$ 13   FORMAT(2X,'mean Y-veloc. SVYMA2=',F6.4,'(c)  variance DVYMA2=',
c$$$     *F6.4/2X,'mean veloc. SVVMA2=',F6.4,'(c)  variance DVVMA2=',F6.4)
c$$$      PRINT 16
c$$$ 16   FORMAT(1X,'Y-veloc.of Z=8 fragm. , -0.2:+0.2 c',
c$$$     *' (step=0.01c)  VYMA2:')
c$$$      PRINT 101,(VYMA2(J),J=1,40)
c$$$      PRINT 103,(VYMA2(J),J=41,46)
c$$$      PRINT 17
c$$$ 17   FORMAT(1X,'velocity of Z=8 fragm. , 0:+0.2 c',
c$$$     *' (step=0.01c)  VVMA2:')
c$$$      PRINT 101,(VVMA2(J),J=1,20)
c$$$      PRINT 103,(VVMA2(J),J=21,26)
c$$$      PRINT 18
c$$$ 18   FORMAT(1X,'(cos)angle distr.of Y-veloc.Z=8fragm., -1:+1 ',
c$$$     *' (step=0.1) in c.m. ACMMA2:')
c$$$      PRINT 101,(ACMMA2(J),J=1,20)
c$$$      PRINT 103,(ACMMA2(J),J=21,26)
c ------------
      DO 214 J=1,40
      IF(VYMA2(J).GT.0.) PVYMA2(J)=PVYMA2(J)/VYMA2(J)
 214  CONTINUE
c      PRINT 215
c 215  FORMAT(1X,'N/Z ratio of Z=8 in Y-veloc., -0.2:+0.2 c',
c     *' (step=0.01c)  PVYMA2:')
c      PRINT 105,(PVYMA2(J),J=1,40)
c      PRINT 103,(PVYMA2(J),J=41,46)
c ------------
 19   CONTINUE
      IF(NIMF.LE.0) GO TO 29
      ZIMF=ZIMF/FLOAT(NIMF)
      AIMF=AIMF/FLOAT(NIMF)
      SVYIMF=SVYIMF/FLOAT(NIMF)
      DVYIMF=DVYIMF/FLOAT(NIMF)
      DDD=DVYIMF-SVYIMF*SVYIMF
      IF(DDD.GT.0.) DVYIMF=SQRT(DDD)
      IF(DDD.LE.0.) DVYIMF=0.
      SVVIMF=SVVIMF/FLOAT(NIMF)
      DVVIMF=DVVIMF/FLOAT(NIMF)
      DDD=DVVIMF-SVVIMF*SVVIMF
      IF(DDD.GT.0.) DVVIMF=SQRT(DDD)
      IF(DDD.LE.0.) DVVIMF=0.
c      PRINT 21,NIMF,ZIMF,AIMF
c 21   FORMAT(2X,'numb.IMF.fragm. NIMF=',I6,' charge ZIMF=',F4.1,
c     *' mass AIMF=',F7.3)
c      PRINT 23,SVYIMF,DVYIMF,SVVIMF,DVVIMF
c 23   FORMAT(2X,'mean Y-veloc. SVYIMF=',F6.4,'(c)  variance DVYIMF=',
c     *F6.4/2X,'mean veloc. SVVIMF=',F6.4,'(c)  variance DVVIMF=',F6.4)
c      PRINT 26
c 26   FORMAT(1X,'Y-veloc.of Z=3 fragm. , -0.2:+0.2 c',
c     *' (step=0.01c)  VYIMF:')
c      PRINT 101,(VYIMF(J),J=1,40)
c      PRINT 103,(VYIMF(J),J=41,46)
c      PRINT 27
c 27   FORMAT(1X,'velocity of Z=3 fragm. , 0:+0.2 c',
c     *' (step=0.01c)  VVIMF:')
c      PRINT 101,(VVIMF(J),J=1,20)
c      PRINT 103,(VVIMF(J),J=21,26)
c      PRINT 28
c 28   FORMAT(1X,'(cos)angle distr.of Y-veloc.Z=3fragm., -1:+1 ',
c     *' (step=0.1) in c.m. ACMIMF:')
c      PRINT 101,(ACMIMF(J),J=1,20)
c      PRINT 103,(ACMIMF(J),J=21,26)
c ------------
      DO 209 J=1,40
      IF(VYIMF(J).GT.0.) PVYIMF(J)=PVYIMF(J)/VYIMF(J)
 209  CONTINUE
c$$$      PRINT 204
c$$$ 204  FORMAT(1X,'N/Z ratio of Z=3 in Y-veloc., -0.2:+0.2 c',
c$$$     *' (step=0.01c)  PVYIMF:')
c$$$      PRINT 105,(PVYIMF(J),J=1,40)
c$$$      PRINT 103,(PVYIMF(J),J=41,46)
c ------------
 29   CONTINUE
c ------------ overall fragments -----------
      DO 208 J=1,40
      IF(CVYTOT(J).GT.0.) PVYTOT(J)=PVYTOT(J)/CVYTOT(J)
      IF(CVYTO1(J).GT.0.) PVYTO1(J)=PVYTO1(J)/CVYTO1(J)
 208  CONTINUE
c      PRINT 207
c 207  FORMAT(1X,'distr.fragm. Z=8 in Y-veloc., -0.2:+0.2c',
c     *' (step=0.01c) CVYTOT:')
c      PRINT 101,(CVYTOT(J),J=1,40)
c      PRINT 102,(CVYTOT(J),J=41,46)
c      PRINT 206
c 206  FORMAT(1X,'N/Z ratio of Z=8 in Y-veloc., -0.2:+0.2c',
c     *' (st=0.01c) PVYTOT:')
c      PRINT 105,(PVYTOT(J),J=1,40)
c      PRINT 103,(PVYTOT(J),J=41,46)
c      PRINT 211
c 211  FORMAT(1X,'distr.fragm. Z=3 in Y-veloc., -0.2:+0.2c',
c     *' (step=0.01c) CVYTO1:')
c      PRINT 101,(CVYTO1(J),J=1,40)
c      PRINT 102,(CVYTO1(J),J=41,46)
c      PRINT 212
c 212  FORMAT(1X,'N/Z ratio of Z=3 in Y-veloc., -0.2:+0.2c',
c     *' (st=0.01c) PVYTO1:')
c      PRINT 105,(PVYTO1(J),J=1,40)
c      PRINT 103,(PVYTO1(J),J=41,46)
c --------------------------------------------------------
c$$$      PRINT 30,VCMST,VCMSP
c$$$ 30   FORMAT(2X,'in lab. system taking into account motion of target:'/
c$$$     *2X,'VCMST=',F7.4,' c   and projectile: VCMSP=',F7.4,' c')
c$$$      PRINT 31
c$$$ 31   FORMAT(1X,'beam-dir.veloc.of max.fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYMAXS:')
c$$$      PRINT 101,(VYMAXS(J),J=1,50)
c$$$      PRINT 103,(VYMAXS(J),J=51,56)
c$$$      PRINT 32
c$$$ 32   FORMAT(1X,'beam-dir.veloc.of Z=8 fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYMA2S:')
c$$$      PRINT 101,(VYMA2S(J),J=1,50)
c$$$      PRINT 103,(VYMA2S(J),J=51,56)
c$$$      PRINT 33
c$$$ 33   FORMAT(1X,'beam-dir.veloc.of Z=3 fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYIMFS:')
c$$$      PRINT 101,(VYIMFS(J),J=1,50)
c$$$      PRINT 103,(VYIMFS(J),J=51,56)
c$$$      PRINT 39
c$$$ 39   FORMAT(1X,'beam-dir.veloc.of Z=1 fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ1:')
c$$$      PRINT 101,(VYZ1(J),J=1,50)
c$$$      PRINT 103,(VYZ1(J),J=51,56)
c$$$      PRINT 40
c$$$ 40   FORMAT(1X,'beam-dir.veloc.of Z=2 fragm. , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ2:')
c$$$      PRINT 101,(VYZ2(J),J=1,50)
c$$$      PRINT 103,(VYZ2(J),J=51,56)
c$$$      PRINT 301
c$$$ 301  FORMAT(1X,'beam-dir.veloc.of Z=1 A=1   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ1A1:')
c$$$      PRINT 101,(VYZ1A1(J),J=1,50)
c$$$      PRINT 103,(VYZ1A1(J),J=51,56)
c$$$      PRINT 302
c$$$ 302  FORMAT(1X,'beam-dir.veloc.of Z=1 A=2   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ1A2:')
c$$$      PRINT 101,(VYZ1A2(J),J=1,50)
c$$$      PRINT 103,(VYZ1A2(J),J=51,56)
c$$$      PRINT 303
c$$$ 303  FORMAT(1X,'beam-dir.veloc.of Z=1 A=3   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ1A3:')
c$$$      PRINT 101,(VYZ1A3(J),J=1,50)
c$$$      PRINT 103,(VYZ1A3(J),J=51,56)
c$$$      PRINT 304
c$$$ 304  FORMAT(1X,'beam-dir.veloc.of Z=2 A=3   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ2A3:')
c$$$      PRINT 101,(VYZ2A3(J),J=1,50)
c$$$      PRINT 103,(VYZ2A3(J),J=51,56)
c$$$      PRINT 305
c$$$ 305  FORMAT(1X,'beam-dir.veloc.of Z=2 A=4   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ2A4:')
c$$$      PRINT 101,(VYZ2A4(J),J=1,50)
c$$$      PRINT 103,(VYZ2A4(J),J=51,56)
c$$$      PRINT 306
c$$$ 306  FORMAT(1X,'beam-dir.veloc.of Z=2 A=6   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ2A6:')
c$$$      PRINT 101,(VYZ2A6(J),J=1,50)
c$$$      PRINT 103,(VYZ2A6(J),J=51,56)
c$$$      PRINT 307
c$$$ 307  FORMAT(1X,'beam-dir.veloc.of Z=3   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ3:')
c$$$      PRINT 101,(VYZ3(J),J=1,50)
c$$$      PRINT 103,(VYZ3(J),J=51,56)
c$$$      PRINT 3071
c$$$ 3071 FORMAT(1X,'beam-dir.veloc.of Z=3 A=6 , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ3A6:')
c$$$      PRINT 101,(VYZ3A6(J),J=1,50)
c$$$      PRINT 103,(VYZ3A6(J),J=51,56)
c$$$      PRINT 3072
c$$$ 3072 FORMAT(1X,'beam-dir.veloc.of Z=3 A=7 , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ3A7:')
c$$$      PRINT 101,(VYZ3A7(J),J=1,50)
c$$$      PRINT 103,(VYZ3A7(J),J=51,56)
c$$$      PRINT 308
c$$$ 308  FORMAT(1X,'beam-dir.veloc.of Z=4   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ4:')
c$$$      PRINT 101,(VYZ4(J),J=1,50)
c$$$      PRINT 103,(VYZ4(J),J=51,56)
c$$$      PRINT 3081
c$$$ 3081 FORMAT(1X,'beam-dir.veloc.of Z=4 A=7   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ4A7:')
c$$$      PRINT 101,(VYZ4A7(J),J=1,50)
c$$$      PRINT 103,(VYZ4A7(J),J=51,56)
c$$$      PRINT 3082
c$$$ 3082 FORMAT(1X,'beam-dir.veloc.of Z=4 A=10 , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ4A10:')
c$$$      PRINT 101,(VYZ4A10(J),J=1,50)
c$$$      PRINT 103,(VYZ4A10(J),J=51,56)
c$$$      PRINT 309
c$$$ 309  FORMAT(1X,'beam-dir.veloc.of Z=5   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ5:')
c$$$      PRINT 101,(VYZ5(J),J=1,50)
c$$$      PRINT 103,(VYZ5(J),J=51,56)
c$$$      PRINT 310
c$$$ 310  FORMAT(1X,'beam-dir.veloc.of Z=6   , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ6:')
c$$$      PRINT 101,(VYZ6(J),J=1,50)
c$$$      PRINT 103,(VYZ6(J),J=51,56)
c$$$      PRINT 3101
c$$$ 3101 FORMAT(1X,'beam-dir.veloc.of Z=6 A=11 , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ6A11:')
c$$$      PRINT 101,(VYZ6A11(J),J=1,50)
c$$$      PRINT 103,(VYZ6A11(J),J=51,56)
c$$$      PRINT 3102
c$$$ 3102 FORMAT(1X,'beam-dir.veloc.of Z=6 A=14 , -0.1:+0.4 c',
c$$$     *' (step=0.01c) VYZ6A14:')
c$$$      PRINT 101,(VYZ6A14(J),J=1,50)
c$$$      PRINT 103,(VYZ6A14(J),J=51,56)
c ---------------------------
      DO 311 J=1,50
      IF(VYZ3(J).GT.0.) PVYZ3(J)=PVYZ3(J)/VYZ3(J)
 311  CONTINUE
c      PRINT 312
c 312  FORMAT(1X,'N/Z ratio of Z=3 in beam-dir.veloc. , -0.1:+0.4c',
c     *' (st=0.01c) PVYZ3:')
c      PRINT 105,(PVYZ3(J),J=1,50)
c      PRINT 103,(PVYZ3(J),J=51,56)
c ---------------------------
c      PRINT 34
c$$$ 34   FORMAT(2X,'total charg.in beam-dir. ; paral.veloc. -0.1:+0.4 c',
c$$$     *' (step=0.01c) ROZ_VY:')
c$$$      PRINT 101,(ROZ_VY(J),J=1,50)
c$$$      PRINT 103,(ROZ_VY(J),J=51,56)
c$$$      PRINT 37
c$$$ 37   FORMAT(2X,'fragm.(Z>2)dens.(no big); paral.veloc. -0.1:+0.4 c',
c$$$     *' (step=0.01c) ROF_VY:')
c$$$      PRINT 101,(ROF_VY(J),J=1,50)
c$$$      PRINT 103,(ROF_VY(J),J=51,56)
c$$$      PRINT 38
c$$$ 38   FORMAT(2X,'bigest fragm.dens.; paral.veloc. -0.1:+0.4 c',
c$$$     *' (step=0.01c) ROB_VY:')
c$$$      PRINT 101,(ROB_VY(J),J=1,50)
c$$$      PRINT 103,(ROB_VY(J),J=51,56)
c --- writing histogramms ---
c      DO 36 J=1,50
c      VY0=-0.1+0.01*(J-1)+0.005
c      WRITE(51,35),J,VY0,ROF_VY(J),ROB_VY(J),VYZ12(J),VYZ38(J),
c     *VYIMFS(J),VYMAXS(J)
c 35   FORMAT(1X,I8,1X,F10.4,1X,F10.4,1X,F10.4,1X,F8.2,1X,F8.2,
c     *1X,F8.2,1X,F8.2)
c 36   CONTINUE
c ---
c --- writing histogramms, 2-sources (cold fragments)---
      IF(JWRIT2.EQ.0) GO TO 360
      DO 36 J=1,50
      VY0=-0.1+0.01*(J-1)+0.005
c      WRITE(54,35)J,VY0,ROF_VY(J),ROB_VY(J),VYZ1(J),VYZ2(J),
c     *VYIMFS(J),VYMAXS(J)
c 35   FORMAT(1X,I8,1X,F10.4,1X,F10.4,1X,F10.4,1X,F8.2,1X,F8.2,
c     *1X,F8.2,1X,F8.2)
c      WRITE(55,350)J,VY0,VYZ1A1(J),VYZ1A2(J),VYZ1A3(J),
c     *VYZ2A3(J),VYZ2A4(J),VYZ2A6(J)
c 350  FORMAT(1X,I8,1X,F10.4,1X,F8.1,1X,F8.1,1X,F8.1,1X,F8.1,
c     *1X,F8.1,1X,F8.1)
c      WRITE(56,351)J,VY0,VYZ3(J),VYZ4(J),VYZ5(J),VYZ6(J),
c     *PVYZ3(J)
c 351  FORMAT(1X,I8,1X,F10.4,1X,F8.1,1X,F8.1,1X,F8.1,1X,F8.1,
c     *1X,F8.3)
 36   CONTINUE
 360  CONTINUE
c ---
      RETURN
      END
      SUBROUTINE CHACO(A0,Z0,IP0,AMP,ZMP)
c ---- charge-charge correlations of IMF ----
      COMMON /CHACO1/YZMIX(100),IZMIX(50000),NCOR,NZMIX
      COMMON /CHACO2/YCOR(100,100)
      DIMENSION AMP(500),ZMP(500),IAA(50),IZZ(50)
      REAL*8 YCOR
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
      IF(IP0.LE.0) RETURN
      DO 500 I=1,50
      IAA(I)=0
      IZZ(I)=0
 500  CONTINUE
c ------- selection of fragments -------
      NFRAG1=0
      DO 501 I=1,IP0
      IA=INT(AMP(I)/0.94+0.5)
      IZ=INT(ZMP(I)+0.1)
      IF(IZ.LE.2) GO TO 501
      NFRAG1=NFRAG1+1
      IF(NFRAG1.GT.50) GO TO 501
      IZZ(NFRAG1)=IZ
      IAA(NFRAG1)=IA
 501  CONTINUE
      IF(NFRAG1.GT.50) NFRAG1=50
c ------- for "mixed" events -------
c including all fragments in "mixed"
c      IF(NFRAG1.LE.0) RETURN
c      DO 502 I=1,NFRAG1
c      NZMIX=NZMIX+1
c      IF(NZMIX.GT.50000) GO TO 502
c      IZ=IZZ(I)
c      IZMIX(NZMIX)=IZ
c      IF(IZ.LE.100) YZMIX(IZ)=YZMIX(IZ)+1.
c 502  CONTINUE
c      IF(NZMIX.GT.50000) NZMIX=50000
c including only one fragments from one event in "mixed"
      IF(NFRAG1.LE.0) RETURN
      RFRAG=RNDMSMM(-1)*NFRAG1
      I=INT(RFRAG)+1
      IF(I.LT.1) I=1
      IF(I.GT.NFRAG1) I=NFRAG1
      NZMIX=NZMIX+1
      IF(NZMIX.GT.50000) GO TO 502
      IZ=IZZ(I)
      IZMIX(NZMIX)=IZ
      IF(IZ.LE.100) YZMIX(IZ)=YZMIX(IZ)+1.
 502  CONTINUE
      IF(NZMIX.GT.50000) NZMIX=50000
c ------- for correlations in events ---------
      IF(NFRAG1.LE.1) RETURN
c this algorithm needs to be doubled YC(I,L)=YC(I,L)+YC(L,I) !
c      DO 503 I=1,NFRAG1-1
c      IZOLD=IZZ(I)
c      IF(IZOLD.GT.100) GO TO 503
c      DO 504 L=I+1,NFRAG1
c      IZNEW=IZZ(L)
c      IF(IZNEW.GT.100) GO TO 504
c      YCOR(IZOLD,IZNEW)=YCOR(IZOLD,IZNEW)+1.
c      NCOR=NCOR+1
c 504  CONTINUE
c 503  CONTINUE
      DO 503 I=1,NFRAG1
      IZOLD=IZZ(I)
      IF(IZOLD.GT.100) GO TO 503
      DO 504 L=1,NFRAG1
      IF(L.EQ.I) GO TO 504
      IZNEW=IZZ(L)
      IF(IZNEW.GT.100) GO TO 504
      YCOR(IZOLD,IZNEW)=YCOR(IZOLD,IZNEW)+1.
      NCOR=NCOR+1
 504  CONTINUE
 503  CONTINUE
c -----------------------------------
      RETURN
      END
      SUBROUTINE CHACOB(IITT)
c ---- charge-charge correlations of IMF ----
      COMMON /CHACO1/YZMIX(100),IZMIX(50000),NCOR,NZMIX
      COMMON /CHACO2/YCOR(100,100)
      REAL*8 YCOR
      NZMIX=0
      NCOR=0
      DO 1 I=1,100
      YZMIX(I)=0.
      DO 1 J=1,100
      YCOR(J,I)=0.
 1    CONTINUE
      DO 2 I=1,50000
 2    IZMIX(I)=0
c temporary restriction for writing!
c      IF(IITT.EQ.1) 
c     *OPEN(57,NAME='/u/botvina/paw2dim/smm_chaco.dat1')
c      IF(IITT.EQ.2) 
c     *OPEN(57,NAME='/u/botvina/paw2dim/smm_chaco.dat2')
      RETURN
      END
      SUBROUTINE CHACOE
c ---- charge-charge correlations of IMF ----
      COMMON /CHACO1/YZMIX(100),IZMIX(50000),NCOR,NZMIX
      COMMON /CHACO2/YCOR(100,100)
      DIMENSION YMTRY(100,100),YMIX(100,100)
      REAL*8 SMIX,SCOR,YMIX,YCOR
c$$$      PRINT 1,NZMIX,NCOR
c$$$ 1    FORMAT(2X,'charge-charge correlations of fragmens. CHACO:'/
c$$$     *2X,'tot.numb.("mixed")fragm. NZMIX=',I6,' numb.corr. NCOR=',I9)
c$$$      IF(NZMIX.LE.0) RETURN
c$$$      DO 2 I=1,100
c$$$ 2    YZMIX(I)=YZMIX(I)/FLOAT(NZMIX)
c$$$      PRINT 3
c$$$ 3    FORMAT(2X,'mean yield of mixed fragments  YZMIX(1-100):')
c$$$      PRINT 4,(YZMIX(I),I=1,100)
c$$$ 4    FORMAT(2X,10F7.4)
      SMTRY=0.
      DO 5 I=1,100
      DO 5 J=1,100
      YMIX(I,J)=0.
      YMTRY(I,J)=YZMIX(I)*YZMIX(J)
      SMTRY=SMTRY+YMTRY(I,J)
 5    CONTINUE
      IF(SMTRY.LE.0.) GO TO 7
      DO 6 I=1,100
      DO 6 J=1,100
      YMTRY(I,J)=YMTRY(I,J)/SMTRY
 6    CONTINUE
c      PRINT 8
c 8    FORMAT(2X,'trial correlations of mixed events  YMTRY:')
      DO 9 I=1,10
      I1=1+(I-1)*10
      I2=I*10
      IF(I1.GT.(100/2)) GO TO 9
c      PRINT 11,I1,I2
c 11   FORMAT(2X,'YMTRY(I,L=1,100): from I=',I3,' to I=',I3)
c      DO 12 J2=1,100
c      PRINT 10,(YMTRY(J1,J2),J1=I1,I2)
c 12   CONTINUE
 9    CONTINUE
 7    CONTINUE
c 10   FORMAT(2X,10F7.4)
c ------- extraction of true mixed correlations ---------
      IF(NZMIX.LE.1) RETURN
c this algorithm needs to be doubled YM(I,L)=YM(I,L)+YM(L,I) !
c      DO 14 I=1,NZMIX-1
c      IZOLD=IZMIX(I)
c      IF(IZOLD.GT.100) GO TO 14
c      DO 15 L=I+1,NZMIX
c      IZNEW=IZMIX(L)
c      IF(IZNEW.GT.100) GO TO 15
c      YMIX(IZOLD,IZNEW)=YMIX(IZOLD,IZNEW)+1.
c 15   CONTINUE
c 14   CONTINUE
      DO 14 I=1,NZMIX
      IZOLD=IZMIX(I)
      IF(IZOLD.GT.100) GO TO 14
      DO 15 L=1,NZMIX
      IF(L.EQ.I) GO TO 15
      IZNEW=IZMIX(L)
      IF(IZNEW.GT.100) GO TO 15
      YMIX(IZOLD,IZNEW)=YMIX(IZOLD,IZNEW)+1.
 15   CONTINUE
 14   CONTINUE
      SMIX=0.
      DO 16 I=1,100
      DO 16 J=1,100
      SMIX=SMIX+YMIX(I,J)
 16   CONTINUE
      IF(SMIX.LE.0) GO TO 18
      DO 17 I=1,100
      DO 17 J=1,100
      YMIX(I,J)=YMIX(I,J)/SMIX
 17   CONTINUE
c      PRINT 19
c 19   FORMAT(2X,'true correlations of mixed events  YMIX:')
      DO 20 I=1,10
      I1=1+(I-1)*10
      I2=I*10
      IF(I1.GT.(100/2)) GO TO 20
c      PRINT 21,I1,I2
c 21   FORMAT(2X,'YMIX(I,L=1,100): from I=',I3,' to I=',I3)
c      DO 22 J2=1,100
c      PRINT 10,(YMIX(J1,J2),J1=I1,I2)
c 22   CONTINUE
 20   CONTINUE
 18   CONTINUE
c ------- correlated events ---------
      SCOR=0.
      DO 23 I=1,100
      DO 23 J=1,100
      SCOR=SCOR+YCOR(I,J)
 23   CONTINUE
      IF(SCOR.LE.0.) GO TO 24
      DO 25 I=1,100
      DO 25 J=1,100
      YCOR(I,J)=YCOR(I,J)/SCOR
 25   CONTINUE
c      PRINT 26
c 26   FORMAT(2X,'pure correlated events  YCOR*:')
      DO 27 I=1,10
      I1=1+(I-1)*10
      I2=I*10
      IF(I1.GT.(100/2)) GO TO 27
c      PRINT 28,I1,I2
c 28   FORMAT(2X,'YCOR*(I,L=1,100): from I=',I3,' to I=',I3)
c      DO 29 J2=1,100
c      PRINT 10,(YCOR(J1,J2),J1=I1,I2)
c 29   CONTINUE
 27   CONTINUE
 24   CONTINUE
c      PRINT 31,SMIX,SCOR
c 31   FORMAT(2X,'sum mixed and correl.: SMIX=',E11.4,' SCOR=',E11.4)
      DO 30 I=1,100
      DO 30 J=1,100
      IF(YMIX(I,J).GT.0.) YCOR(I,J)=YCOR(I,J)/YMIX(I,J)
 30   CONTINUE
c ---- writing to dataset --------
c      WRITE(57,*)((YCOR(I,L),I=1,100),L=1,100)
c      CLOSE(57)
c --------------------------------
c      PRINT 32
c 32   FORMAT(2X,'reduced correlated events  YCOR:')
      DO 33 I=1,10
      I1=1+(I-1)*10
      I2=I*10
      IF(I1.GT.(100/2)) GO TO 33
c      PRINT 34,I1,I2
c 34   FORMAT(2X,'YCOR(I,L=1,100): from I=',I3,' to I=',I3)
c      DO 35 J2=1,100
c      PRINT 36,(YCOR(J1,J2),J1=I1,I2)
c 35   CONTINUE
 33   CONTINUE
c 36   FORMAT(2X,10F7.3)
      RETURN
      END
      SUBROUTINE HOTFDA(AA,ZZ,EE,T,IP,IP0,INEUTR,AMP,ZMP,UP,PN0,ECOLB)
c collection of info about hot fragments produced in one event in oder to 
c write it in datafile (primary for D'Agostino, REVERSE collab., Feb.2001)
      DIMENSION AMP(500),ZMP(500),PN0(3,500),UP(500)
      COMMON /BLHFD1/THFD,IPHFD,INHFD,IAHFD(500),IZHFD(500),UHFD(500),
     *PXHFD(500),PYHFD(500),PZHFD(500),ECHFD
      THFD=T
      IF(IP.LE.1) GO TO 10
      IPHFD=IP0
      INHFD=INEUTR
      DO 1 I=1,IPHFD
      PXHFD(I)=PN0(1,I)
      PYHFD(I)=PN0(2,I)
      PZHFD(I)=PN0(3,I)
      IAHFD(I)=INT(AMP(I)/0.94+0.5)
      IZHFD(I)=INT(ZMP(I)+0.5)
      UHFD(I)=UP(I)
 1    CONTINUE
      ECHFD=ECOLB
      RETURN
 10   CONTINUE
      IPHFD=1
      INHFD=0
      PXHFD(1)=PN0(1,1)
      PYHFD(1)=PN0(2,1)
      PZHFD(1)=PN0(3,1)
      IAHFD(1)=INT(AA+0.5)
      IZHFD(1)=INT(ZZ+0.5)
      UHFD(1)=EE
      ECHFD=0.
      RETURN
      END
      SUBROUTINE DIFUS(IP,TEMP,AM,CH,RM,ECOLB)
c -- March 2001, GSI. "Diffusion" process of changing positions of fragments 
c during evolution from "saddle" to "scission" point: Metropolis over new 
c fragment coordinates (restricted by "cells" around old fragment positions) 
c taking into account new Coulomb and rotational energies. 
c Output: new coordinate of fragments, new ECOLB and EDIFUS=change of 
c potential energy = change of Coulomb + rotational energy (assumed rotat.
c along X-axis), it should be finally added to thermal energy.
      DIMENSION AM(500),CH(500),RM(3,500)
      DIMENSION IAP(500),IZP(500),XC(500),YC(500),ZC(500)
      DIMENSION XR(500),YR(500),ZR(500),RIR(500),R0(3,500)
      COMMON /BDIFUS/EDIFUS,IDIFUS
      COMMON /BLMEAM/AMEM,BMEM,EMEM,WMEM,IMEM
      COMMON /BLSECS/IASEC,IZSEC,RXSEC,RYSEC,RZSEC,CULSEC
      COMMON /BLSECT/IASET,IZSET,RXSET,RYSET,RZSET,CULSET
      COMMON /BVSECS/VXSEC,VYSEC,VZSEC,ISECS /BLJJJ/JJJ
      COMMON /BICOLE/ICOLE
      IF(IDIFUS.EQ.0.OR.IP.LE.1) EDIFUS=0.
      IF(IDIFUS.EQ.0.OR.IP.LE.1) RETURN
      IPAT=IP
c ------ time for the diffusion (fm/c) -------
      TAU=100.
      TAU2=99*TAU
c      IF(JJJ.LE.1) PRINT 58,TAU,TAU2
c 58   FORMAT(2X,'DIFUS: diffus.time: TAU(fm/c)=',F5.1,
c     *' posit.sec. TAU2=',F6.1)
c --- position of the second source in TAU2 ---
      IASET=IASEC
      IZSET=IZSEC
      RXSET=RXSEC+VXSEC*TAU2
      RYSET=RYSEC+VYSEC*TAU2
      RZSET=RZSEC+VZSEC*TAU2
c ----- initial positions  and energies -----
      XCM=0.
      YCM=0.
      ZCM=0.
      SPA=0.
      DO 50 I=1,IP
      IAA=INT(AM(I)/0.94+0.1)
      IZZ=INT(CH(I)+0.1)
      IAP(I)=IAA
      IZP(I)=IZZ
      R0(1,I)=RM(1,I)
      R0(2,I)=RM(2,I)
      R0(3,I)=RM(3,I)
      XC(I)=RM(1,I)
      YC(I)=RM(2,I)
      ZC(I)=RM(3,I)
      XCM=XCM+IAP(I)*XC(I)
      YCM=YCM+IAP(I)*YC(I)
      ZCM=ZCM+IAP(I)*ZC(I)
      SPA=SPA+IAP(I)
c --- motion is possible in small cells of radius RIR around initial 
c locations of fragments. "Diffusion" velocities assumed as thermal ones ---
      RIR(I)=TAU*SQRT((3.*TEMP)/(1000.*AM(I)))
c --------------------------------------------------------------------------
 50   CONTINUE
      XCM=XCM/SPA
      YCM=YCM/SPA
      ZCM=ZCM/SPA
      ANMO=0.
      BMOB=0.
      EMOB=0.
      DO 51 I=1,IP
      RZY2=(ZC(I)-ZCM)**2+(YC(I)-YCM)**2
      BMOB=BMOB+AM(I)*RZY2
 51   CONTINUE
      IF(IMEM.GE.1) WROB=(AMEM/5.06)/BMOB
      IF(IMEM.GE.1) EMOB=0.5*BMOB*WROB*WROB*1000.
      IF(IMEM.GE.1) ANMO=AMEM
      ECOLB=0.
      DO 54 J1=1,IP-1
      DO 54 J2=J1+1,IP
      RR=SQRT((XC(J1)-XC(J2))**2+(YC(J1)-YC(J2))**2+
     #(ZC(J1)-ZC(J2))**2)
      ECOLB=ECOLB+1.44*IZP(J1)*IZP(J2)/RR
 54   CONTINUE
      IF(ICOLE.EQ.-1) ECOLB=0.
      ECOLBI=ECOLB
c -- for the second source influence on positions --
      CULS=0.
      IF(ISECS.EQ.0) GO TO 60
      DO 56 J3=1,IP
      RR=SQRT((XC(J3)-RXSEC)**2+(YC(J3)-RYSEC)**2+
     #(ZC(J3)-RZSEC)**2)
      CULS=CULS+1.44*IZSEC*IZP(J3)/RR
 56   CONTINUE
      IF(ICOLE.EQ.-1) CULS=0.
 60   CONTINUE
c ---------------------------------------------------
c      IF(MOD(JJJ,500).EQ.0) 
c     *PRINT 52,SPA,IP,ANMO,EMOB,ECOLB,CULS
c      IF(JJJ.LE.3) 
c     *PRINT 52,SPA,IP,ANMO,EMOB,ECOLB,CULS
c 52   FORMAT(2X,'start difus: A0=',F4.0,' IP=',I3,' ANMO=',F4.0,
c     #' EMOB=',F7.2,' ECOLB=',F7.2,' CULS=',F7.2)
      ECOLB=ECOLB+CULS
      ECOLD=ECOLB
      EMOLD=EMOB
      EDIOLD=0.
c ---------- Try for new positions ---------------
      NTRY=IP*100
 9    CONTINUE
      DO 3 J=1,NTRY
      DO 8 I=1,IP
      XR(I)=XC(I)
      YR(I)=YC(I)
      ZR(I)=ZC(I)
 8    CONTINUE
 4    IR=INT(RNDMSMM(-1)*IP)+1
      IF(IR.LT.1) IR=1
      IF(IR.GT.IP) IR=IP
c motion of IR fragments in the limited region with radius RIR
      RSYSA=RIR(IR)
      CALL PLACY(RSYSA,IR,IY,IAP,IZP,IP,ECNEW,XR,YR,ZR,R0)
      IF(ICOLE.EQ.-1) ECNEW=0.
      IF(IY.EQ.1) GO TO 4
c ---
      XCM=0.
      YCM=0.
      ZCM=0.
      DO 1 I=1,IP
      XCM=XCM+IAP(I)*XR(I)
      YCM=YCM+IAP(I)*YR(I)
      ZCM=ZCM+IAP(I)*ZR(I)
 1    CONTINUE
      XCM=XCM/SPA
      YCM=YCM/SPA
      ZCM=ZCM/SPA
c --- 
      BMO=0.
      EMNEW=0.
      DO 2 I=1,IP
      RZY2=(ZR(I)-ZCM)**2+(YR(I)-YCM)**2
      BMO=BMO+AM(I)*RZY2
 2    CONTINUE
      IF(IMEM.GE.1) WRO=(AMEM/5.06)/BMO
      IF(IMEM.GE.1) EMNEW=0.5*BMO*WRO*WRO*1000.
      EDINEW=(ECOLD-ECNEW)+(EMOLD-EMNEW)
      IF(EDINEW.GE.0.) GO TO 5
      PROB=EXP(EDINEW/TEMP)
      XRND=RNDMSMM(-1)
      IF(XRND.GT.PROB) GO TO 7
 5    CONTINUE
      DO 6 I=1,IP
      XC(I)=XR(I)
      YC(I)=YR(I)
      ZC(I)=ZR(I)
 6    CONTINUE
      ECOLD=ECNEW
      EMOLD=EMNEW
      EDIOLD=(ECOLB-ECOLD)+(EMOB-EMOLD)
 7    CONTINUE
c ----------------
c      IF(MOD(J,50).EQ.0) GO TO 11
c      PRINT 12,EMOLD,ECOLD,EDIOLD
c 12   FORMAT(2X,'difus:   EMOLD=',F7.2,' ECOLD=',F7.2,
c     #' EDIOLD=',F7.2)
c 11   CONTINUE
c ----------------
 3    CONTINUE
      DO 10 I=1,IP
      RM(1,I)=XC(I)
      RM(2,I)=YC(I)
      RM(3,I)=ZC(I)
 10   CONTINUE
      ECOLB=0.
      DO 57 J1=1,IP-1
      DO 57 J2=J1+1,IP
      RR=SQRT((XC(J1)-XC(J2))**2+(YC(J1)-YC(J2))**2+
     #(ZC(J1)-ZC(J2))**2)
      ECOLB=ECOLB+1.44*IZP(J1)*IZP(J2)/RR
 57   CONTINUE
      IF(ICOLE.EQ.-1) ECOLB=0.
      EDIFUS=(ECOLBI-ECOLB)+(EMOB-EMOLD)
c      IF(MOD(JJJ,500).EQ.0) 
c     *PRINT 53,IP,EMOLD,ECOLD,EDIFUS,ECOLB
c      IF(JJJ.LE.3) 
c     *PRINT 53,IP,EMOLD,ECOLD,EDIFUS,ECOLB
c 53   FORMAT(2X,'end difus: IP=',I3,' MeV:',
c     #' EMOLD=',F7.2,' ECOLD=',F7.2,' EDIFUS=',F7.2,' ECOLB=',F7.2)
      IF(EDIFUS.LT.0.) NTRY=10
      IF(EDIFUS.LT.0.) GO TO 9
      RETURN
      END
      SUBROUTINE PLACY(RSYSA,JOLD,IY,IAP,IZP,IP,ECOL,XR,YR,ZR,R0)
c Placement for "diffusion" case:
c finding new random position of one (only!) JOLD fragment, 
c other fragments are in old positions. 
      COMMON /BLMET1/RSYS,RN,A0013
      DIMENSION XR(500),YR(500),ZR(500),R0(3,500)
      DIMENSION IAP(500),IZP(500),PA(500),PA13(500)
      COMMON /BLSECT/IASET,IZSET,RXSET,RYSET,RZSET,CULSET
      COMMON /BVSECS/VXSEC,VYSEC,VZSEC,ISECS 
      IY=0
      ECOL=0.
C FINDING FRAGMENT POSITIONS IN THE SYSTEM
      DO 101 J=1,IP
      PA(J)=IAP(J)
      PA13(J)=PA(J)**0.333333
 101  CONTINUE
c ------ random try -------
      KK=0
 24   CONTINUE
      KK=KK+1
      IF(KK.GT.30) GO TO 20
      R=RSYSA*(RNDMSMM(-1))**0.3333333
      CT=1.-2.*RNDMSMM(-1)
      PHI=6.28318*RNDMSMM(-1)
      ST=SQRT(1.-CT**2)
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
      XXCC=R*ST*CPHI
      YYCC=R*ST*SPHI
      ZZCC=R*CT
      XXCC=XXCC+R0(1,JOLD)
      YYCC=YYCC+R0(2,JOLD)
      ZZCC=ZZCC+R0(3,JOLD)
c ----------------------
      DO 25 J=1,IP
      IF(J.EQ.JOLD) GO TO 25
      RR=(XXCC-XR(J))**2+(YYCC-YR(J))**2+(ZZCC-ZR(J))**2
      RMIN=RN*PA13(JOLD)+RN*PA13(J)
      IF(RR-RMIN*RMIN) 24,25,25
 25   CONTINUE
      XR(JOLD)=XXCC
      YR(JOLD)=YYCC
      ZR(JOLD)=ZZCC
      IF(IP.LE.1) GO TO 112
      DO 104 J1=1,IP-1
      DO 104 J2=J1+1,IP
      RR=SQRT((XR(J1)-XR(J2))**2+(YR(J1)-YR(J2))**2+
     #(ZR(J1)-ZR(J2))**2)
      ECOL=ECOL+1.44*IZP(J1)*IZP(J2)/RR
 104  CONTINUE
 112  CONTINUE
c -- for the second source influence on positions --
      CULSET=0.
      IF(ISECS.EQ.0) RETURN
      DO 111 J3=1,IP
      RRSET=SQRT((XR(J3)-RXSET)**2+(YR(J3)-RYSET)**2+
     #(ZR(J3)-RZSET)**2)
      CULSET=CULSET+1.44*IZSET*IZP(J3)/RRSET
 111  CONTINUE
      ECOL=ECOL+CULSET
c --
      RETURN
 20   CONTINUE
      IY=1
      RETURN
      END
      SUBROUTINE CLPC00
      COMMON /BCLPC1/SZMAX,SZMA2,SVMAX,SVMA2,NLPC
      COMMON /BCLPC2/RASYM(26),SASYM,VREL(26),SVREL
      COMMON /BCLPC3/VTAS1,V1AS1,V2AS1,V3AS1,NTAS1,N1AS1,N2AS1,N3AS1
      COMMON /BCLPC4/VTAS2,V1AS2,V2AS2,V3AS2,NTAS2,N1AS2,N2AS2,N3AS2
      COMMON /BCLPC5/CTFIS(26),CTFIC(26)
      COMMON /BCLPC6/CTFIL(26),CTFIH(26),VTFIL(26),VTFIH(26)
      COMMON /BCLPC7/PRELZ(100),VRELZ(100),VRELZ3(26),VRELZ6(26),
     *VRELZ9(26),PRELZF(100),VRELZF(100),PRELZB(100),VRELZB(100),
     *CRELZ3(26),CRELZ6(26),CRELZ9(26)
      NTAS1=0
      VTAS1=0.
      N1AS1=0
      V1AS1=0.
      N2AS1=0
      V2AS1=0.
      N3AS1=0
      V3AS1=0.
      NTAS2=0
      VTAS2=0.
      N1AS2=0
      V1AS2=0.
      N2AS2=0
      V2AS2=0.
      N3AS2=0
      V3AS2=0.
      NLPC=0
      SZMAX=0.
      SZMA2=0.
      SVMAX=0.
      SVMA2=0.
      SASYM=0.
      SVREL=0.
      DO 1 I=1,26
      CTFIS(I)=0.
      CTFIC(I)=0.
      RASYM(I)=0.
      VREL(I)=0.
      CTFIL(I)=0.
      CTFIH(I)=0.
      VTFIL(I)=0.
      VTFIH(I)=0.
      VRELZ3(I)=0.
      VRELZ6(I)=0.
      VRELZ9(I)=0.
      CRELZ3(I)=0.
      CRELZ6(I)=0.
      CRELZ9(I)=0.
 1    CONTINUE 
      DO 2 I=1,100
      PRELZ(I)=0.
      VRELZ(I)=0.
      PRELZF(I)=0.
      VRELZF(I)=0.
      PRELZB(I)=0.
      VRELZB(I)=0.
 2    CONTINUE
      RETURN
      END
      SUBROUTINE CLPC(A0,Z0,IP0,AMP,ZMP,PN0,RMP)
      COMMON /CCB1/ XX(200),YY(200),ZZ(200),PXX(200),PYY(200),PZZ(200),
     *IAA(200),IZZ(200)
      COMMON /CCBNUM/ IA0,IZ0,NFRAG1
      COMMON /BCLPC1/SZMAX,SZMA2,SVMAX,SVMA2,NLPC
      COMMON /BCLPC2/RASYM(26),SASYM,VREL(26),SVREL
      COMMON /BCLPC3/VTAS1,V1AS1,V2AS1,V3AS1,NTAS1,N1AS1,N2AS1,N3AS1
      COMMON /BCLPC4/VTAS2,V1AS2,V2AS2,V3AS2,NTAS2,N1AS2,N2AS2,N3AS2
      COMMON /BCLPC5/CTFIS(26),CTFIC(26)
      COMMON /BCLPC6/CTFIL(26),CTFIH(26),VTFIL(26),VTFIH(26)
      COMMON /BCLPC7/PRELZ(100),VRELZ(100),VRELZ3(26),VRELZ6(26),
     *VRELZ9(26),PRELZF(100),VRELZF(100),PRELZB(100),VRELZB(100),
     *CRELZ3(26),CRELZ6(26),CRELZ9(26)
c ------- ** inclusion making it compatible with SMM ** ------------
      DIMENSION AMP(500),ZMP(500),PN0(3,500),RMP(3,500)
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
      NFRAG1=IP0
      DO 501 IR=1,NFRAG1
      IAA(IR)=INT(AMP(IR)/0.94+0.5)
      IZZ(IR)=INT(ZMP(IR)+0.1)
      PXX(IR)=1000.*PN0(1,IR)
      PYY(IR)=1000.*PN0(2,IR)
      PZZ(IR)=1000.*PN0(3,IR)
      XX(IR)=RMP(1,IR)
      YY(IR)=RMP(2,IR)
      ZZ(IR)=RMP(3,IR)
 501  CONTINUE
c ------ ** ----------------- ** ---------
      XCC=0.
      YCC=0.
      ZCC=0.
      CHC=0.
      NBIG=0
      IRMAX=0
      IZMAX=0
      AMAX=0.
      PXMAX=0.
      PYMAX=0.
      PZMAX=0.
c ------------------------------------
c finding center mass velocity VYCC
      SAAA=0.
      PYCC=0.
      DO 15 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      SAAA=SAAA+IAAA
      PYCC=PYCC+PYY(IR)
 15   CONTINUE
      VYCC=PYCC/(938.*SAAA)
c ------------------------------------
      DO 1 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
c      VY=PYY(IR)/(938.*IAA(IR))-VYCC
      IF(IZZZ.GE.3) NBIG=NBIG+1
      CHC=CHC+IZZZ
      XCC=XCC+IZZZ*XX(IR)
      YCC=YCC+IZZZ*YY(IR)
      ZCC=ZCC+IZZZ*ZZ(IR)
      IF(IZZZ.GT.IZMAX) IRMAX=IR
      IF(IZZZ.GT.IZMAX) AMAX=IAAA
      IF(IZZZ.GT.IZMAX) PXMAX=PXX(IR)
      IF(IZZZ.GT.IZMAX) PYMAX=PYY(IR)
      IF(IZZZ.GT.IZMAX) PZMAX=PZZ(IR)
      IF(IZZZ.GT.IZMAX) IZMAX=IZZZ
  1   CONTINUE
c -- charge center --
      XCC=XCC/CHC
      YCC=YCC/CHC
      ZCC=ZCC/CHC
c -------------------
      IRMA2=0
      IZMA2=0
      AMA2=0.
      PXMA2=0.
      PYMA2=0.
      PZMA2=0.
      DO 2 IR=1,NFRAG1
      IF(IR.EQ.IRMAX) GO TO 2
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.GT.IZMA2) IRMA2=IR
      IF(IZZZ.GT.IZMA2) AMA2=IAAA
      IF(IZZZ.GT.IZMA2) PXMA2=PXX(IR)
      IF(IZZZ.GT.IZMA2) PYMA2=PYY(IR)
      IF(IZZZ.GT.IZMA2) PZMA2=PZZ(IR)
      IF(IZZZ.GT.IZMA2) IZMA2=IZZZ
  2   CONTINUE
      IF(NBIG.LT.2) RETURN
c      IF(IZMAX.LT.33) RETURN
c      IF(IZMA2.LT.10) RETURN
      NLPC=NLPC+1
      SZMAX=SZMAX+IZMAX
      SZMA2=SZMA2+IZMA2
      ASYM=FLOAT(IZMAX-IZMA2)/FLOAT(IZMAX+IZMA2)
      SASYM=SASYM+ASYM
      CALL HIST1(ASYM,0.,1.,0.05,RASYM,26,1.)
c ------ velocities -------
      VXMAX=PXMAX/(938.*AMAX)
      VYMAX=PYMAX/(938.*AMAX)
      VZMAX=PZMAX/(938.*AMAX)
      VVMAX=SQRT(VXMAX**2+VYMAX**2+VZMAX**2)
      SVMAX=SVMAX+VVMAX
      VXMA2=PXMA2/(938.*AMA2)
      VYMA2=PYMA2/(938.*AMA2)
      VZMA2=PZMA2/(938.*AMA2)
      SVMA2=SVMA2+SQRT(VXMA2**2+VYMA2**2+VZMA2**2)
      VRELM2=SQRT((VXMAX-VXMA2)**2+(VYMAX-VYMA2)**2+(VZMAX-VZMA2)**2)
      SVREL=SVREL+VRELM2
      CALL HIST1(VRELM2,0.,0.2,0.01,VREL,26,1.)
c --------------------------------------------------------
c      VFISY=VYMAX-VYMA2
      VFISX=(VXMAX*IZMAX-VXMA2*IZMA2)/(FLOAT(IZMAX+IZMA2))
      VFISY=(VYMAX*IZMAX-VYMA2*IZMA2)/(FLOAT(IZMAX+IZMA2))
      VFISZ=(VZMAX*IZMAX-VZMA2*IZMA2)/(FLOAT(IZMAX+IZMA2))
      VFIS0=SQRT(VFISX**2+VFISY**2+VFISZ**2)
      CFIS=VFISY/VFIS0
      CALL HIST1(CFIS,-1.,1.,0.1,CTFIS,26,1.)
c --------- for c.m. of fission system -----------
c      VFICX=(VXMAX*IZMAX+VXMA2*IZMA2)/(FLOAT(IZMAX+IZMA2))
c      VFICY=(VYMAX*IZMAX+VYMA2*IZMA2)/(FLOAT(IZMAX+IZMA2))
c      VFICZ=(VZMAX*IZMAX+VZMA2*IZMA2)/(FLOAT(IZMAX+IZMA2))
c      VFIC0=SQRT(VFICX**2+VFICY**2+VFICZ**2)
c      CFIC=VFICY/VFIC0
c      CALL HIST1(CFIC,-1.,1.,0.1,CTFIC,26,1.)
c ------------------- LASSA ------------------------
      IF(IZMA2.LT.3) GO TO 30
      VFFX=(VXMAX-VXMA2)
      VFFY=(VYMAX-VYMA2)
      VFFZ=(VZMAX-VZMA2)
      VF00=SQRT(VFFX**2+VFFY**2+VFFZ**2)
      CF00=VFFY/VF00
      PRELZ(IZMA2)=PRELZ(IZMA2)+1.
      VRELZ(IZMA2)=VRELZ(IZMA2)+VF00
      IF(CF00.GT.0.) PRELZF(IZMA2)=PRELZF(IZMA2)+1.
      IF(CF00.GT.0.) VRELZF(IZMA2)=VRELZF(IZMA2)+VF00
      IF(CF00.LE.0.) PRELZB(IZMA2)=PRELZB(IZMA2)+1.
      IF(CF00.LE.0.) VRELZB(IZMA2)=VRELZB(IZMA2)+VF00
      IF(IZMA2.EQ.3)
     *CALL HIST1(CF00,-1.,1.,0.1,VRELZ3,26,VF00)
      IF(IZMA2.EQ.3)
     *CALL HIST1(CF00,-1.,1.,0.1,CRELZ3,26,1.)
      IF(IZMA2.EQ.6)
     *CALL HIST1(CF00,-1.,1.,0.1,VRELZ6,26,VF00)
      IF(IZMA2.EQ.6)
     *CALL HIST1(CF00,-1.,1.,0.1,CRELZ6,26,1.)
      IF(IZMA2.EQ.9)
     *CALL HIST1(CF00,-1.,1.,0.1,VRELZ9,26,VF00)
      IF(IZMA2.EQ.9)
     *CALL HIST1(CF00,-1.,1.,0.1,CRELZ9,26,1.)
 30   CONTINUE
c --------------------
      IF(ASYM.GE.0.0.AND.ASYM.LE.0.25) 
     *CALL HIST1(CFIS,-1.,1.,0.1,CTFIL,26,1.)
      IF(ASYM.GE.0.5.AND.ASYM.LE.0.75) 
     *CALL HIST1(CFIS,-1.,1.,0.1,CTFIH,26,1.)
      IF(ASYM.GE.0.0.AND.ASYM.LE.0.25) 
     *CALL HIST1(CFIS,-1.,1.,0.1,VTFIL,26,VRELM2)
      IF(ASYM.GE.0.5.AND.ASYM.LE.0.75) 
     *CALL HIST1(CFIS,-1.,1.,0.1,VTFIH,26,VRELM2)
c ------ relat. veloc. at different asym and angles ------
      IF(VVMAX.LE.0.) RETURN
c      COST=VYMAX/VVMAX
      COST=CFIS
      IF(ASYM.GE.0.AND.ASYM.LE.0.25) GO TO 10
      IF(ASYM.GE.0.5.AND.ASYM.LE.0.75) GO TO 20
      RETURN
 10   CONTINUE
      NTAS1=NTAS1+1
      VTAS1=VTAS1+VRELM2
      IF(COST.GE.0.5) N1AS1=N1AS1+1
      IF(COST.GE.0.5) V1AS1=V1AS1+VRELM2
      IF(COST.GT.-0.5.AND.COST.LT.0.5) N2AS1=N2AS1+1
      IF(COST.GT.-0.5.AND.COST.LT.0.5) V2AS1=V2AS1+VRELM2
      IF(COST.LE.-0.5) N3AS1=N3AS1+1
      IF(COST.LE.-0.5) V3AS1=V3AS1+VRELM2
      RETURN
 20   CONTINUE
      NTAS2=NTAS2+1
      VTAS2=VTAS2+VRELM2
      IF(COST.GE.0.5) N1AS2=N1AS2+1
      IF(COST.GE.0.5) V1AS2=V1AS2+VRELM2
      IF(COST.GT.-0.5.AND.COST.LT.0.5) N2AS2=N2AS2+1
      IF(COST.GT.-0.5.AND.COST.LT.0.5) V2AS2=V2AS2+VRELM2
      IF(COST.LE.-0.5) N3AS2=N3AS2+1
      IF(COST.LE.-0.5) V3AS2=V3AS2+VRELM2
      RETURN
      END
      SUBROUTINE CLPCPR
      COMMON /BCLPC1/SZMAX,SZMA2,SVMAX,SVMA2,NLPC
      COMMON /BCLPC2/RASYM(26),SASYM,VREL(26),SVREL
      COMMON /BCLPC3/VTAS1,V1AS1,V2AS1,V3AS1,NTAS1,N1AS1,N2AS1,N3AS1
      COMMON /BCLPC4/VTAS2,V1AS2,V2AS2,V3AS2,NTAS2,N1AS2,N2AS2,N3AS2
      COMMON /BCLPC5/CTFIS(26),CTFIC(26)
      COMMON /BCLPC6/CTFIL(26),CTFIH(26),VTFIL(26),VTFIH(26)
      COMMON /BCLPC7/PRELZ(100),VRELZ(100),VRELZ3(26),VRELZ6(26),
     *VRELZ9(26),PRELZF(100),VRELZF(100),PRELZB(100),VRELZB(100),
     *CRELZ3(26),CRELZ6(26),CRELZ9(26)
c      IF(NLPC.LT.1) PRINT 1,NLPC
      IF(NLPC.LT.1) RETURN
      SZMAX=SZMAX/FLOAT(NLPC)
      SZMA2=SZMA2/FLOAT(NLPC)
      SVMAX=SVMAX/FLOAT(NLPC)
      SVMA2=SVMA2/FLOAT(NLPC)
      SASYM=SASYM/FLOAT(NLPC)
      SVREL=SVREL/FLOAT(NLPC)
c      PRINT 1,NLPC,SZMAX,SZMA2,SASYM,SVMAX,SVMA2,SVREL
c 1    FORMAT(2X,'NLPC=',I7,'  SZMAX, SZMA2=',2F6.2,'  SASYM=',F5.3/
c     *2X,' veloc.(1/c): SVMAX, SVMA2=',2F7.4,' SVREL=',F7.4)
c      PRINT 2
c 2    FORMAT(1X,'assym. "fission" fragm., 0:1 ',
c     *' (step=0.05)  RASYM:')
c      PRINT 101,(RASYM(J),J=1,20)
c      PRINT 103,(RASYM(J),J=21,26)
c      PRINT 3
c 3    FORMAT(1X,'relat. veloc. fis.fragm., 0:+0.2 ',
c$$$     *' (step=0.01)  VREL:')
c$$$      PRINT 101,(VREL(J),J=1,20)
c$$$      PRINT 103,(VREL(J),J=21,26)
c$$$ 101  FORMAT(1X,10F7.0)
c$$$ 103  FORMAT(1X,6F12.4)
c$$$      PRINT 7
c$$$ 7    FORMAT(1X,'Cos(theta) of fis.axis resp.beam.(Y_axis), -1.:+1.',
c$$$     *' (step=0.1)  CTFIS:')
c$$$      PRINT 101,(CTFIS(J),J=1,20)
c$$$      PRINT 103,(CTFIS(J),J=21,26)
c -------------------------------------------------
      DO 10 I=1,20
      IF(CTFIL(I).GT.0.) VTFIL(I)=100.*VTFIL(I)/CTFIL(I)
      IF(CTFIH(I).GT.0.) VTFIH(I)=100.*VTFIH(I)/CTFIH(I)
 10   CONTINUE
c 8    FORMAT(1X,'Cos(theta) of fis.c.m. resp.beam.(Y_axis), -1.:+1.',
c     *' (step=0.1)  CTFIC:')
c$$$      PRINT 8
c$$$ 8    FORMAT(1X,'Cos(theta) of fis.axis for asym. 0.0-0.25 , -1.:+1.',
c$$$     *' (step=0.1)  CTFIL:')
c$$$      PRINT 101,(CTFIL(J),J=1,20)
c$$$      PRINT 103,(CTFIL(J),J=21,26)
c$$$      PRINT 11
c$$$ 11   FORMAT(1X,'Relat.veloc. vs. Cos(theta); asym. 0.0-0.25, -1.:+1.',
c$$$     *' (in 0.01c)  VTFIL:')
c$$$      PRINT 102,(VTFIL(J),J=1,20)
c$$$      PRINT 103,(VTFIL(J),J=21,26)
c$$$      PRINT 9
c$$$ 9    FORMAT(1X,'Cos(theta) of fis.axis for asym. 0.5-0.75 , -1.:+1.',
c$$$     *' (step=0.1)  CTFIH:')
c$$$      PRINT 101,(CTFIH(J),J=1,20)
c$$$      PRINT 103,(CTFIH(J),J=21,26)
c$$$      PRINT 12
c$$$ 12   FORMAT(1X,'Relat.veloc. vs. Cos(theta); asym. 0.5-0.75, -1.:+1.',
c$$$     *' (in 0.01c)  VTFIH:')
c$$$      PRINT 102,(VTFIH(J),J=1,20)
c$$$      PRINT 103,(VTFIH(J),J=21,26)
c$$$ 102  FORMAT(1X,10F7.2)
c ------------------------------------------------
      IF(NTAS1.GT.0) VTAS1=VTAS1/FLOAT(NTAS1)
      IF(N1AS1.GT.0) V1AS1=V1AS1/FLOAT(N1AS1)
      IF(N2AS1.GT.0) V2AS1=V2AS1/FLOAT(N2AS1)
      IF(N3AS1.GT.0) V3AS1=V3AS1/FLOAT(N3AS1)
      IF(NTAS2.GT.0) VTAS2=VTAS2/FLOAT(NTAS2)
      IF(N1AS2.GT.0) V1AS2=V1AS2/FLOAT(N1AS2)
      IF(N2AS2.GT.0) V2AS2=V2AS2/FLOAT(N2AS2)
      IF(N3AS2.GT.0) V3AS2=V3AS2/FLOAT(N3AS2)
c$$$      PRINT 4
c$$$ 4    FORMAT(2X,'relat.veloc. max-ma2 at diff.asymmetr and',
c$$$     *' diff.angl. fis. axis to beam')
c$$$c     *' diff.angl. max frag. to beam')
c$$$      PRINT 5,NTAS1,VTAS1,N1AS1,V1AS1,N2AS1,V2AS1,N3AS1,V3AS1
c$$$ 5    FORMAT(4X,'at assym.1 (0-0.25):  NTAS1=',I6,' VTAS1(1/c)=',F7.4/
c$$$     *15X,'at    0-60 deg.: N1AS1=',I6,' V1AS1(1/c)=',F7.4/
c$$$     *15X,'at  60-120 deg.: N2AS1=',I6,' V2AS1(1/c)=',F7.4/
c$$$     *15X,'at 120-180 deg.: N3AS1=',I6,' V3AS1(1/c)=',F7.4)
c$$$      PRINT 6,NTAS2,VTAS2,N1AS2,V1AS2,N2AS2,V2AS2,N3AS2,V3AS2
c$$$ 6    FORMAT(2X,'at assym.2 (0.5-0.75):  NTAS2=',I6,' VTAS2(1/c)=',F7.4/
c$$$     *15X,'at    0-60 deg.: N1AS2=',I6,' V1AS2(1/c)=',F7.4/
c$$$     *15X,'at  60-120 deg.: N2AS2=',I6,' V2AS2(1/c)=',F7.4/
c$$$     *15X,'at 120-180 deg.: N3AS2=',I6,' V3AS2(1/c)=',F7.4)
c ----------- relat.veloc. vs. min fragm. (of the two largest) -------------
c ------ for LASSA analysis -------
c$$$      PRINT 31
c$$$ 31   FORMAT(2X,'  Z ',' tot yield',' V_rel',' yield-F',' V_rel',
c$$$     *' yield-B',' V_rel')
      DO 30 I=1,100
      IF(PRELZ(I).LE.0.) GO TO 30
      IF(PRELZ(I).GT.0.) VRELZ(I)=30.*VRELZ(I)/PRELZ(I)
      IF(PRELZF(I).GT.0.) VRELZF(I)=30.*VRELZF(I)/PRELZF(I)
      IF(PRELZB(I).GT.0.) VRELZB(I)=30.*VRELZB(I)/PRELZB(I)
c      PRINT 32,I,PRELZ(I),VRELZ(I),PRELZF(I),VRELZF(I),
c     *PRELZB(I),VRELZB(I)
c 32   FORMAT(2X,I4,4X,F6.0,F6.2,2X,F6.0,F6.2,2X,F6.0,F6.2)
 30   CONTINUE
      DO 35 I=1,20
      IF(CRELZ3(I).GT.0.) VRELZ3(I)=30.*VRELZ3(I)/CRELZ3(I)
      IF(CRELZ6(I).GT.0.) VRELZ6(I)=30.*VRELZ6(I)/CRELZ6(I)
      IF(CRELZ9(I).GT.0.) VRELZ9(I)=30.*VRELZ9(I)/CRELZ9(I)
 35   CONTINUE
c$$$      PRINT 33
c$$$ 33   FORMAT(1X,'Yield vs.Cos(theta) of rel.vel., Z_ma2=3, -1.:+1.',
c$$$     *' (step=0.1)  CRELZ3:')
c$$$      PRINT 101,(CRELZ3(J),J=1,20)
c$$$      PRINT 103,(CRELZ3(J),J=21,26)
c$$$      PRINT 34
c$$$ 34   FORMAT(1X,'Relat.veloc. vs. Cos(theta), for Z_ma2=3, -1.:+1.',
c$$$     *' (in cm/ns) VRELZ3:')
c$$$      PRINT 102,(VRELZ3(J),J=1,20)
c$$$      PRINT 103,(VRELZ3(J),J=21,26)
c$$$      PRINT 36
c$$$ 36   FORMAT(1X,'Yield vs.Cos(theta) of rel.vel., Z_ma2=6, -1.:+1.',
c$$$     *' (step=0.1)  CRELZ6:')
c$$$      PRINT 101,(CRELZ6(J),J=1,20)
c$$$      PRINT 103,(CRELZ6(J),J=21,26)
c$$$      PRINT 37
c$$$ 37   FORMAT(1X,'Relat.veloc. vs. Cos(theta), for Z_ma2=6, -1.:+1.',
c$$$     *' (in cm/ns) VRELZ6:')
c$$$      PRINT 102,(VRELZ6(J),J=1,20)
c$$$      PRINT 103,(VRELZ6(J),J=21,26)
c$$$      PRINT 38
c$$$ 38   FORMAT(1X,'Yield vs.Cos(theta) of rel.vel., Z_ma2=9, -1.:+1.',
c$$$     *' (step=0.1)  CRELZ9:')
c$$$      PRINT 101,(CRELZ9(J),J=1,20)
c$$$      PRINT 103,(CRELZ9(J),J=21,26)
c$$$      PRINT 39
c$$$ 39   FORMAT(1X,'Relat.veloc. vs. Cos(theta), for Z_ma2=9, -1.:+1.',
c$$$     *' (in cm/ns) VRELZ9:')
c$$$      PRINT 102,(VRELZ9(J),J=1,20)
c$$$      PRINT 103,(VRELZ9(J),J=21,26)
c ----------------------
      RETURN
      END
      SUBROUTINE CINDR(A0,Z0,IP0,AMP,ZMP,PN0,RMP)
      COMMON /CIND1/XX(200),YY(200),ZZ(200),PXX(200),PYY(200),PZZ(200),
     *IAA(200),IZZ(200)
      COMMON /CIND2/SZMAX,SVMAX,NMAX
      COMMON /CIND3/PVTOT(4),SVTOT(4),SVREL(4),YZZZ(200)
     *,YZZF(200),YZZB(200),NMAXF,NMAXB
      COMMON /CIND4/VREL1(46),VREL2(46),VREL3(46),VREL4(46)
      DIMENSION AMP(500),ZMP(500),PN0(3,500),RMP(3,500)
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
      NFRAG1=IP0
      DO 501 IR=1,NFRAG1
      IAA(IR)=INT(AMP(IR)/0.94+0.5)
      IZZ(IR)=INT(ZMP(IR)+0.1)
      PXX(IR)=1000.*PN0(1,IR)
      PYY(IR)=1000.*PN0(2,IR)
      PZZ(IR)=1000.*PN0(3,IR)
      XX(IR)=RMP(1,IR)
      YY(IR)=RMP(2,IR)
      ZZ(IR)=RMP(3,IR)
 501  CONTINUE
c ------ ** ----------------- ** ---------
      XCC=0.
      YCC=0.
      ZCC=0.
      CHC=0.
      NBIG=0
      IRMAX=0
      IZMAX=0
      AMAX=0.
      PXMAX=0.
      PYMAX=0.
      PZMAX=0.
c ------------------------------------
c finding center mass velocity 
      SAAA=0.
      PYCC=0.
      DO 15 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      SAAA=SAAA+IAAA
      PYCC=PYCC+PYY(IR)
 15   CONTINUE
      VYCC=PYCC/(940.*SAAA)
c ------------------------------------
      DO 1 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.GE.3) NBIG=NBIG+1
      CHC=CHC+IZZZ
      XCC=XCC+IZZZ*XX(IR)
      YCC=YCC+IZZZ*YY(IR)
      ZCC=ZCC+IZZZ*ZZ(IR)
      IF(IZZZ.GT.IZMAX) IRMAX=IR
      IF(IZZZ.GT.IZMAX) AMAX=IAAA
      IF(IZZZ.GT.IZMAX) PXMAX=PXX(IR)
      IF(IZZZ.GT.IZMAX) PYMAX=PYY(IR)
      IF(IZZZ.GT.IZMAX) PZMAX=PZZ(IR)
      IF(IZZZ.GT.IZMAX) IZMAX=IZZZ
  1   CONTINUE
c -- charge center --
      XCC=XCC/CHC
      YCC=YCC/CHC
      ZCC=ZCC/CHC
c -------------------
c      IF(IZMAX.LT.50) RETURN
      IF(NBIG.LT.1) RETURN
      NMAX=NMAX+1
      SZMAX=SZMAX+IZMAX
      VXMAX=PXMAX/(940.*AMAX)
      VYMAX=PYMAX/(940.*AMAX)
      VZMAX=PZMAX/(940.*AMAX)
      VVMAX=SQRT(VXMAX**2+VYMAX**2+VZMAX**2)
      SVMAX=SVMAX+VVMAX
      DO 2 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.GT.0.AND.IZZZ.LE.200) YZZZ(IZZZ)=YZZZ(IZZZ)+1
      IF(IR.EQ.IRMAX) GO TO 2
      PXMA2=PXX(IR)
      PYMA2=PYY(IR)
      PZMA2=PZZ(IR)
      AMA2=IAAA
      VXMA2=PXMA2/(940.*AMA2)
      VYMA2=PYMA2/(940.*AMA2)
      VZMA2=PZMA2/(940.*AMA2)
      IF(VYMAX.GE.VYMA2) NMAXF=NMAXF+1
      IF(VYMAX.GE.VYMA2) YZZF(IZZZ)=YZZF(IZZZ)+1
      IF(VYMAX.LT.VYMA2) NMAXB=NMAXB+1
      IF(VYMAX.LT.VYMA2) YZZB(IZZZ)=YZZB(IZZZ)+1
      INDE=0
      IF(IZZZ.EQ.2) INDE=1
      IF(IZZZ.EQ.3) INDE=2
      IF(IZZZ.EQ.6) INDE=3
      IF(IZZZ.EQ.9) INDE=4
      IF(INDE.EQ.0) GO TO 2
      PVTOT(INDE)=PVTOT(INDE)+1.
      SVTOT(INDE)=SVTOT(INDE)+SQRT(VXMA2**2+VYMA2**2+VZMA2**2)
      VRELT=SQRT((VXMAX-VXMA2)**2+(VYMAX-VYMA2)**2+(VZMAX-VZMA2)**2)
      SVREL(INDE)=SVREL(INDE)+VRELT
      IF(INDE.EQ.1) CALL HIST1(VRELT,0.,0.4,0.01,VREL1,46,1.)
      IF(INDE.EQ.2) CALL HIST1(VRELT,0.,0.4,0.01,VREL2,46,1.)
      IF(INDE.EQ.3) CALL HIST1(VRELT,0.,0.4,0.01,VREL3,46,1.)
      IF(INDE.EQ.4) CALL HIST1(VRELT,0.,0.4,0.01,VREL4,46,1.)
  2   CONTINUE
      RETURN
      END
      SUBROUTINE CINDR0
      COMMON /CIND2/SZMAX,SVMAX,NMAX
      COMMON /CIND3/PVTOT(4),SVTOT(4),SVREL(4),YZZZ(200)
     *,YZZF(200),YZZB(200),NMAXF,NMAXB
      COMMON /CIND4/VREL1(46),VREL2(46),VREL3(46),VREL4(46)
      NMAX=0
      NMAXF=0
      NMAXB=0
      SZMAX=0.
      SVMAX=0.
      DO 1 IND=1,4
      PVTOT(IND)=0.
      SVTOT(IND)=0.
      SVREL(IND)=0.
 1    CONTINUE
      DO 2 I=1,46
      VREL1(I)=0.
      VREL2(I)=0.
      VREL3(I)=0.
      VREL4(I)=0.
 2    CONTINUE
      DO 3 I=1,200
      YZZZ(I)=0.
      YZZF(I)=0.
      YZZB(I)=0.
 3    CONTINUE
      RETURN
      END
      SUBROUTINE CINDRP
      COMMON /CIND2/SZMAX,SVMAX,NMAX
      COMMON /CIND3/PVTOT(4),SVTOT(4),SVREL(4),YZZZ(200)
     *,YZZF(200),YZZB(200),NMAXF,NMAXB
      COMMON /CIND4/VREL1(46),VREL2(46),VREL3(46),VREL4(46)
c      IF(NMAX.LE.0) PRINT 2,NMAX
c 2    FORMAT(2X,'NO EVENTS in CINDR: NMAX=',I6)
      SZMAX=SZMAX/FLOAT(NMAX)
      SVMAX=SVMAX/FLOAT(NMAX)
c      PRINT 1,NMAX,SZMAX,SVMAX
c 1    FORMAT(2X,'numb.events NMAX=',I6,' max.frag. SZMAX=',F5.2,
c     *' SVMAX(1/c)=',F7.4)
c      PRINT 11,NMAXF,NMAXB
c 11   FORMAT(2X,'numb.fragments @ big frag. forw. NMAXF=',I6,
c     *' backw. NMAXB=',I6)
      DO 100 I=1,200
      YZZZ(I)=YZZZ(I)/FLOAT(NMAX)
      YZZF(I)=YZZF(I)/FLOAT(NMAX)
      YZZB(I)=YZZB(I)/FLOAT(NMAX)
 100  CONTINUE
c      PRINT 7
c 7    FORMAT(2X,'tot.charge distrib.in coinsid. biggest frag.',
c     *' YZZZ(1-50):')
c      PRINT 102,(YZZZ(I),I=1,50)
c 102  FORMAT(1X,10F7.4)
c      PRINT 12
c 12   FORMAT(2X,'biggest-forward charge distrib.',
c     *' YZZF(1-50):')
c      PRINT 102,(YZZF(I),I=1,50)
c      PRINT 13
c 13   FORMAT(2X,'biggest-backward charge distrib.',
c     *' YZZB(1-50):')
c      PRINT 102,(YZZB(I),I=1,50)
c      PRINT 10
c 10   FORMAT(2X,'mean values of veloc. for different charge ranges:'/
c     *5X,'  PVTOT ',2X,' SVTOT(1/c)',2X,' SVREL(1/c)')
      DO 8 I=1,4
      IF(PVTOT(I).GT.0.) SVTOT(I)=SVTOT(I)/PVTOT(I)
      IF(PVTOT(I).GT.0.) SVREL(I)=SVREL(I)/PVTOT(I)
c      PRINT 9,PVTOT(I),SVTOT(I),SVREL(I)
c 9    FORMAT(5X,F8.0,2X,F11.5,2X,F11.5)
 8    CONTINUE
c ----------------------------------
c 101  FORMAT(1X,10F7.0)
c 103  FORMAT(1X,6F12.4)
c$$$      PRINT 3
c$$$ 3    FORMAT(1X,' relat.veloc. Zmax#Z=2, 0:+0.4 ',
c$$$     *' (step=0.01)  VREL1:')
c$$$      PRINT 101,(VREL1(J),J=1,40)
c$$$      PRINT 103,(VREL1(J),J=41,46)
c$$$      PRINT 4
c$$$ 4    FORMAT(1X,' relat.veloc. Zmax#Z=3, 0:+0.4 ',
c$$$     *' (step=0.01)  VREL2:')
c$$$      PRINT 101,(VREL2(J),J=1,40)
c$$$      PRINT 103,(VREL2(J),J=41,46)
c$$$      PRINT 5
c$$$ 5    FORMAT(1X,' relat.veloc. Zmax#Z=6, 0:+0.4 ',
c$$$     *' (step=0.01)  VREL3:')
c$$$      PRINT 101,(VREL3(J),J=1,40)
c$$$      PRINT 103,(VREL3(J),J=41,46)
c$$$      PRINT 6
c$$$ 6    FORMAT(1X,' relat.veloc. Zmax#Z=9, 0:+0.4 ',
c$$$     *' (step=0.01)  VREL4:')
c$$$      PRINT 101,(VREL4(J),J=1,40)
c$$$      PRINT 103,(VREL4(J),J=41,46)
c -----------------------------------
      RETURN
      END
      SUBROUTINE CLASSA(A0,Z0,IP0,AMP,ZMP,PN0,RMP)
      COMMON /CLAS1/XX(200),YY(200),ZZ(200),PXX(200),PYY(200),PZZ(200),
     *IAA(200),IZZ(200)
      COMMON /CLAS2/SZMAX,SVMAX,ZEMIT,SBIG,NMAX
      COMMON /CLAS3/YZZZ(200),YZZF(200),YZZB(200),NMAXF,NMAXB
      COMMON /CLAS4/TTOT1(46),TTOT2(46),TTOT3(46),TTOT4(46),TTOT5(46),
     *TTOT6(46),TTOT7(46)
      COMMON /CLAS5/TFWD1(46),TFWD2(46),TFWD3(46),TFWD4(46),TFWD5(46),
     *TFWD6(46),TFWD7(46)
      COMMON /CLAS6/TBWD1(46),TBWD2(46),TBWD3(46),TBWD4(46),TBWD5(46),
     *TBWD6(46),TBWD7(46)
      COMMON /CLAS7/PETOT(7),SETOT(7),PETOF(7),SETOF(7),PETOB(7),
     *SETOB(7)
      DIMENSION AMP(500),ZMP(500),PN0(3,500),RMP(3,500),PP2(3)
      IA0=INT(A0+0.5)
      IZ0=INT(Z0+0.5)
      NFRAG1=IP0
      DO 501 IR=1,NFRAG1
      IAA(IR)=INT(AMP(IR)/0.94+0.5)
      IZZ(IR)=INT(ZMP(IR)+0.1)
      PXX(IR)=1000.*PN0(1,IR)
      PYY(IR)=1000.*PN0(2,IR)
      PZZ(IR)=1000.*PN0(3,IR)
      XX(IR)=RMP(1,IR)
      YY(IR)=RMP(2,IR)
      ZZ(IR)=RMP(3,IR)
 501  CONTINUE
c ------ ** ----------------- ** ---------
      XCC=0.
      YCC=0.
      ZCC=0.
      CHC=0.
      NBIG=0
      IRMAX=0
      IZMAX=0
      AMAX=0.
      PXMAX=0.
      PYMAX=0.
      PZMAX=0.
c ------------------------------------
c finding center mass velocity 
      SAAA=0.
      PYCC=0.
      DO 15 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      SAAA=SAAA+IAAA
      PYCC=PYCC+PYY(IR)
 15   CONTINUE
      VYCC=PYCC/(940.*SAAA)
c ------------------------------------
      DO 1 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.GE.3) NBIG=NBIG+1
      CHC=CHC+IZZZ
      XCC=XCC+IZZZ*XX(IR)
      YCC=YCC+IZZZ*YY(IR)
      ZCC=ZCC+IZZZ*ZZ(IR)
      IF(IZZZ.GT.IZMAX) IRMAX=IR
      IF(IZZZ.GT.IZMAX) AMAX=IAAA
      IF(IZZZ.GT.IZMAX) PXMAX=PXX(IR)
      IF(IZZZ.GT.IZMAX) PYMAX=PYY(IR)
      IF(IZZZ.GT.IZMAX) PZMAX=PZZ(IR)
      IF(IZZZ.GT.IZMAX) IZMAX=IZZZ
  1   CONTINUE
c -- charge center --
      XCC=XCC/CHC
      YCC=YCC/CHC
      ZCC=ZCC/CHC
c -------------------
c      IF(IZMAX.LT.50) RETURN
c      IF(NBIG.LT.2) RETURN
c ----- emitted charge -----
      ZEMIT=ZEMIT+(IZ0-IZMAX)
      SBIG=SBIG+NBIG
      NMAX=NMAX+1
      SZMAX=SZMAX+IZMAX
      VXMAX=PXMAX/(940.*AMAX)
      VYMAX=PYMAX/(940.*AMAX)
      VZMAX=PZMAX/(940.*AMAX)
      VVMAX=SQRT(VXMAX**2+VYMAX**2+VZMAX**2)
      SVMAX=SVMAX+VVMAX
      DO 2 IR=1,NFRAG1
      IAAA=IAA(IR)
      IZZZ=IZZ(IR)
      IF(IZZZ.GT.0.AND.IZZZ.LE.200) YZZZ(IZZZ)=YZZZ(IZZZ)+1
      IF(IR.EQ.IRMAX) GO TO 2
      PXMA2=PXX(IR)
      PYMA2=PYY(IR)
      PZMA2=PZZ(IR)
      AMA2=IAAA
      VXMA2=PXMA2/(940.*AMA2)
      VYMA2=PYMA2/(940.*AMA2)
      VZMA2=PZMA2/(940.*AMA2)
      IF(VYMAX.GE.VYMA2) IFWD=1
      IF(VYMAX.GE.VYMA2) NMAXF=NMAXF+1
      IF(VYMAX.GE.VYMA2) YZZF(IZZZ)=YZZF(IZZZ)+1
      IF(VYMAX.LT.VYMA2) IFWD=0
      IF(VYMAX.LT.VYMA2) NMAXB=NMAXB+1
      IF(VYMAX.LT.VYMA2) YZZB(IZZZ)=YZZB(IZZZ)+1
      PP2(1)=PXMA2
      PP2(2)=PYMA2
      PP2(3)=PZMA2
      CM2=940.*AMA2
      CALL PINT(PP2,CT2,ST2,CF2,SF2,T2,CM2)
c 
      INDE=0
      IF(IZZZ.EQ.2.AND.IAAA.EQ.4) INDE=1
      IF(IZZZ.EQ.2.AND.IAAA.EQ.6) INDE=2
      IF(IZZZ.EQ.3.AND.IAAA.EQ.6) INDE=3
      IF(IZZZ.EQ.3.AND.IAAA.EQ.7) INDE=4
      IF(IZZZ.EQ.4.AND.IAAA.EQ.7) INDE=5
      IF(IZZZ.EQ.4.AND.IAAA.EQ.10) INDE=6
      IF(IZZZ.EQ.1.AND.IAAA.EQ.1) INDE=7
      IF(INDE.EQ.0) GO TO 2
      PETOT(INDE)=PETOT(INDE)+1.
      SETOT(INDE)=SETOT(INDE)+T2
      IF(INDE.EQ.1) CALL HIST1(T2,0.,80.,2.,TTOT1,46,1.)
      IF(INDE.EQ.2) CALL HIST1(T2,0.,80.,2.,TTOT2,46,1.)
      IF(INDE.EQ.3) CALL HIST1(T2,0.,80.,2.,TTOT3,46,1.)
      IF(INDE.EQ.4) CALL HIST1(T2,0.,80.,2.,TTOT4,46,1.)
      IF(INDE.EQ.5) CALL HIST1(T2,0.,80.,2.,TTOT5,46,1.)
      IF(INDE.EQ.6) CALL HIST1(T2,0.,80.,2.,TTOT6,46,1.)
      IF(INDE.EQ.7) CALL HIST1(T2,0.,80.,2.,TTOT7,46,1.)
      IF(IFWD.EQ.1) GO TO 3
      IF(IFWD.EQ.0) GO TO 4
      GO TO 2
 3    CONTINUE
      PETOF(INDE)=PETOF(INDE)+1.
      SETOF(INDE)=SETOF(INDE)+T2
      IF(INDE.EQ.1) CALL HIST1(T2,0.,80.,2.,TFWD1,46,1.)
      IF(INDE.EQ.2) CALL HIST1(T2,0.,80.,2.,TFWD2,46,1.)
      IF(INDE.EQ.3) CALL HIST1(T2,0.,80.,2.,TFWD3,46,1.)
      IF(INDE.EQ.4) CALL HIST1(T2,0.,80.,2.,TFWD4,46,1.)
      IF(INDE.EQ.5) CALL HIST1(T2,0.,80.,2.,TFWD5,46,1.)
      IF(INDE.EQ.6) CALL HIST1(T2,0.,80.,2.,TFWD6,46,1.)
      IF(INDE.EQ.7) CALL HIST1(T2,0.,80.,2.,TFWD7,46,1.)
      GO TO 2
 4    CONTINUE
      PETOB(INDE)=PETOB(INDE)+1.
      SETOB(INDE)=SETOB(INDE)+T2
      IF(INDE.EQ.1) CALL HIST1(T2,0.,80.,2.,TBWD1,46,1.)
      IF(INDE.EQ.2) CALL HIST1(T2,0.,80.,2.,TBWD2,46,1.)
      IF(INDE.EQ.3) CALL HIST1(T2,0.,80.,2.,TBWD3,46,1.)
      IF(INDE.EQ.4) CALL HIST1(T2,0.,80.,2.,TBWD4,46,1.)
      IF(INDE.EQ.5) CALL HIST1(T2,0.,80.,2.,TBWD5,46,1.)
      IF(INDE.EQ.6) CALL HIST1(T2,0.,80.,2.,TBWD6,46,1.)
      IF(INDE.EQ.7) CALL HIST1(T2,0.,80.,2.,TBWD7,46,1.)
 2    CONTINUE
      RETURN
      END
      SUBROUTINE CLASS0
      COMMON /CLAS2/SZMAX,SVMAX,ZEMIT,SBIG,NMAX
      COMMON /CLAS3/YZZZ(200),YZZF(200),YZZB(200),NMAXF,NMAXB
      COMMON /CLAS4/TTOT1(46),TTOT2(46),TTOT3(46),TTOT4(46),TTOT5(46),
     *TTOT6(46),TTOT7(46)
      COMMON /CLAS5/TFWD1(46),TFWD2(46),TFWD3(46),TFWD4(46),TFWD5(46),
     *TFWD6(46),TFWD7(46)
      COMMON /CLAS6/TBWD1(46),TBWD2(46),TBWD3(46),TBWD4(46),TBWD5(46),
     *TBWD6(46),TBWD7(46)
      COMMON /CLAS7/PETOT(7),SETOT(7),PETOF(7),SETOF(7),PETOB(7),
     *SETOB(7)
      NMAX=0
      NMAXF=0
      NMAXB=0
      SZMAX=0.
      SVMAX=0.
      ZEMIT=0.
      SBIG=0.
      DO 1 IND=1,7
      PETOT(IND)=0.
      PETOF(IND)=0.
      PETOB(IND)=0.
      SETOT(IND)=0.
      SETOF(IND)=0.
      SETOB(IND)=0.
 1    CONTINUE
      DO 2 I=1,46
      TTOT1(I)=0.
      TTOT2(I)=0.
      TTOT3(I)=0.
      TTOT4(I)=0.
      TTOT5(I)=0.
      TTOT6(I)=0.
      TTOT7(I)=0.
      TFWD1(I)=0.
      TFWD2(I)=0.
      TFWD3(I)=0.
      TFWD4(I)=0.
      TFWD5(I)=0.
      TFWD6(I)=0.
      TFWD7(I)=0.
      TBWD1(I)=0.
      TBWD2(I)=0.
      TBWD3(I)=0.
      TBWD4(I)=0.
      TBWD5(I)=0.
      TBWD6(I)=0.
      TBWD7(I)=0.
 2    CONTINUE
      DO 3 I=1,200
      YZZZ(I)=0.
      YZZF(I)=0.
      YZZB(I)=0.
 3    CONTINUE
      RETURN
      END
      SUBROUTINE CLASSP
      COMMON /CLAS2/SZMAX,SVMAX,ZEMIT,SBIG,NMAX
      COMMON /CLAS3/YZZZ(200),YZZF(200),YZZB(200),NMAXF,NMAXB
      COMMON /CLAS4/TTOT1(46),TTOT2(46),TTOT3(46),TTOT4(46),TTOT5(46),
     *TTOT6(46),TTOT7(46)
      COMMON /CLAS5/TFWD1(46),TFWD2(46),TFWD3(46),TFWD4(46),TFWD5(46),
     *TFWD6(46),TFWD7(46)
      COMMON /CLAS6/TBWD1(46),TBWD2(46),TBWD3(46),TBWD4(46),TBWD5(46),
     *TBWD6(46),TBWD7(46)
      COMMON /CLAS7/PETOT(7),SETOT(7),PETOF(7),SETOF(7),PETOB(7),
     *SETOB(7)
c      IF(NMAX.LE.0) PRINT 2,NMAX
c 2    FORMAT(2X,'NO EVENTS in CINDR: NMAX=',I6)
      IF(NMAX.LE.0) RETURN
      SZMAX=SZMAX/FLOAT(NMAX)
      SVMAX=SVMAX/FLOAT(NMAX)
      ZEMIT=ZEMIT/FLOAT(NMAX)
      SBIG=SBIG/FLOAT(NMAX)
c$$$      PRINT 1,NMAX,SZMAX,SVMAX
c$$$ 1    FORMAT(2X,'numb.events NMAX=',I6,' max.frag. SZMAX=',F5.2,
c$$$     *' veloc. SVMAX(1/c)=',F7.4)
c$$$      PRINT 11,NMAXF,NMAXB
c$$$ 11   FORMAT(2X,'numb.fragments @ big frag. forw. NMAXF=',I6,
c$$$     *' backw. NMAXB=',I6)
c$$$      PRINT 110,SBIG,ZEMIT
c$$$ 110  FORMAT(2X,'big frag.mult. SBIG=',F5.3,' emitted charge ZEMIT=',
c$$$     *F5.2)
      DO 100 I=1,200
      YZZZ(I)=YZZZ(I)/FLOAT(NMAX)
      YZZF(I)=YZZF(I)/FLOAT(NMAX)
      YZZB(I)=YZZB(I)/FLOAT(NMAX)
 100  CONTINUE
c$$$      PRINT 7
c$$$ 7    FORMAT(2X,'tot.charge distrib.  YZZZ(1-50):')
c$$$      PRINT 102,(YZZZ(I),I=1,50)
c$$$ 102  FORMAT(1X,10F7.4)
c$$$      PRINT 12
c$$$ 12   FORMAT(2X,'biggest-forward charge distrib.',
c$$$     *' YZZF(1-50):')
c$$$      PRINT 102,(YZZF(I),I=1,50)
c$$$      PRINT 13
c$$$ 13   FORMAT(2X,'biggest-backward charge distrib.',
c$$$     *' YZZB(1-50):')
c$$$      PRINT 102,(YZZB(I),I=1,50)
c$$$      PRINT 10
c$$$ 10   FORMAT(2X,'mean kin.energ. for differ. fragments: ',
c$$$     *'4He,6He,6Li,7Li,7Be,10Be,P (lines)'/
c$$$     *5X,'  PETOT ',2X,' SETOT(MeV)',5X,' PETOF ',2X,' SETOF(MeV)',
c$$$     *5X,'  PETOB ',2X,' SETOB(MeV)')
      DO 8 I=1,7
      IF(PETOT(I).GT.0.) SETOT(I)=SETOT(I)/PETOT(I)
      IF(PETOF(I).GT.0.) SETOF(I)=SETOF(I)/PETOF(I)
      IF(PETOB(I).GT.0.) SETOB(I)=SETOB(I)/PETOB(I)
c$$$      PRINT 9,PETOT(I),SETOT(I),PETOF(I),SETOF(I),PETOB(I),SETOB(I)
c$$$ 9    FORMAT(5X,F8.0,2X,F11.3,5X,F8.0,2X,F11.3,5X,F8.0,2X,F11.3)
 8    CONTINUE
c ----------------------------------
c 101  FORMAT(1X,10F7.0)
c 103  FORMAT(1X,6F12.4)
c$$$      PRINT 21
c$$$ 21   FORMAT(1X,' tot.kin.energ. 4He, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT1:')
c$$$      PRINT 101,(TTOT1(J),J=1,40)
c$$$      PRINT 103,(TTOT1(J),J=41,46)
c$$$      PRINT 22
c$$$ 22   FORMAT(1X,' tot.kin.energ. 6He, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT2:')
c$$$      PRINT 101,(TTOT2(J),J=1,40)
c$$$      PRINT 103,(TTOT2(J),J=41,46)
c$$$      PRINT 23
c$$$ 23   FORMAT(1X,' tot.kin.energ. 6Li, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT3:')
c$$$      PRINT 101,(TTOT3(J),J=1,40)
c$$$      PRINT 103,(TTOT3(J),J=41,46)
c$$$      PRINT 24
c$$$ 24   FORMAT(1X,' tot.kin.energ. 7Li, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT4:')
c$$$      PRINT 101,(TTOT4(J),J=1,40)
c$$$      PRINT 103,(TTOT4(J),J=41,46)
c$$$      PRINT 25
c$$$ 25   FORMAT(1X,' tot.kin.energ. 7Be, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT5:')
c$$$      PRINT 101,(TTOT5(J),J=1,40)
c$$$      PRINT 103,(TTOT5(J),J=41,46)
c$$$      PRINT 26
c$$$ 26   FORMAT(1X,' tot.kin.energ. 10Be, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT6:')
c$$$      PRINT 101,(TTOT6(J),J=1,40)
c$$$      PRINT 103,(TTOT6(J),J=41,46)
c$$$      PRINT 27
c$$$ 27   FORMAT(1X,' tot.kin.energ. P, 0:80MeV ',
c$$$     *' (step=2MeV)  TTOT7:')
c$$$      PRINT 101,(TTOT7(J),J=1,40)
c$$$      PRINT 103,(TTOT7(J),J=41,46)
c$$$      PRINT 31
c$$$ 31   FORMAT(1X,' fwd.kin.energ. 4He, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD1:')
c$$$      PRINT 101,(TFWD1(J),J=1,40)
c$$$      PRINT 103,(TFWD1(J),J=41,46)
c$$$      PRINT 32
c$$$ 32   FORMAT(1X,' fwd.kin.energ. 6He, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD2:')
c$$$      PRINT 101,(TFWD2(J),J=1,40)
c$$$      PRINT 103,(TFWD2(J),J=41,46)
c$$$      PRINT 33
c$$$ 33   FORMAT(1X,' fwd.kin.energ. 6Li, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD3:')
c$$$      PRINT 101,(TFWD3(J),J=1,40)
c$$$      PRINT 103,(TFWD3(J),J=41,46)
c$$$      PRINT 34
c$$$ 34   FORMAT(1X,' fwd.kin.energ. 7Li, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD4:')
c$$$      PRINT 101,(TFWD4(J),J=1,40)
c$$$      PRINT 103,(TFWD4(J),J=41,46)
c$$$      PRINT 35
c$$$ 35   FORMAT(1X,' fwd.kin.energ. 7Be, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD5:')
c$$$      PRINT 101,(TFWD5(J),J=1,40)
c$$$      PRINT 103,(TFWD5(J),J=41,46)
c$$$      PRINT 36
c$$$ 36   FORMAT(1X,' fwd.kin.energ. 10Be, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD6:')
c$$$      PRINT 101,(TFWD6(J),J=1,40)
c$$$      PRINT 103,(TFWD6(J),J=41,46)
c$$$      PRINT 37
c$$$ 37   FORMAT(1X,' fwd.kin.energ. P, 0:80MeV ',
c$$$     *' (step=2MeV)  TFWD7:')
c$$$      PRINT 101,(TFWD7(J),J=1,40)
c$$$      PRINT 103,(TFWD7(J),J=41,46)
c$$$      PRINT 41
c$$$ 41   FORMAT(1X,' bwd.kin.energ. 4He, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD1:')
c$$$      PRINT 101,(TBWD1(J),J=1,40)
c$$$      PRINT 103,(TBWD1(J),J=41,46)
c$$$      PRINT 42
c$$$ 42   FORMAT(1X,' bwd.kin.energ. 6He, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD2:')
c$$$      PRINT 101,(TBWD2(J),J=1,40)
c$$$      PRINT 103,(TBWD2(J),J=41,46)
c$$$      PRINT 43
c$$$ 43   FORMAT(1X,' bwd.kin.energ. 6Li, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD3:')
c$$$      PRINT 101,(TBWD3(J),J=1,40)
c$$$      PRINT 103,(TBWD3(J),J=41,46)
c$$$      PRINT 44
c$$$ 44   FORMAT(1X,' bwd.kin.energ. 7Li, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD4:')
c$$$      PRINT 101,(TBWD4(J),J=1,40)
c$$$      PRINT 103,(TBWD4(J),J=41,46)
c$$$      PRINT 45
c$$$ 45   FORMAT(1X,' bwd.kin.energ. 7Be, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD5:')
c$$$      PRINT 101,(TBWD5(J),J=1,40)
c$$$      PRINT 103,(TBWD5(J),J=41,46)
c$$$      PRINT 46
c$$$ 46   FORMAT(1X,' bwd.kin.energ. 10Be, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD6:')
c$$$      PRINT 101,(TBWD6(J),J=1,40)
c$$$      PRINT 103,(TBWD6(J),J=41,46)
c$$$      PRINT 47
c$$$ 47   FORMAT(1X,' bwd.kin.energ. P, 0:80MeV ',
c$$$     *' (step=2MeV)  TBWD7:')
c$$$      PRINT 101,(TBWD7(J),J=1,40)
c$$$      PRINT 103,(TBWD7(J),J=41,46)
c -----------------------------------
      RETURN
      END
c ------------ new evaporation with 2S Coulomb influence ------------
      SUBROUTINE PINT0(P,CT,ST,CF,SF,T,CM)
c -- nonrelativistic !
C O[PE[E[EH[E [O MACCE CM [ [M[[[[C[ P(3) [ACT[[[,EE K[H. [HEP[[[ T
C [ [[[OB - CT,ST,CF,SF ,O[PE[E[[[[[X HA[PAB[EH[E [O[ETA.
      DIMENSION P(3)
      PZ=P(3)**2
      PQ=P(1)**2+P(2)**2+PZ
      IF(PQ.LE.0.) GO TO 11
      CTQ=PZ/PQ
      T=PQ/(2.*CM)
      IF(CTQ.GE.1.) GO TO 10
      CT=SQRT(CTQ)
      IF(P(3).LE.0.) CT=-CT
      ST=SQRT(1.-CTQ)
      PMH=ST*SQRT(PQ)
      CF=P(1)/PMH
      SF=P(2)/PMH
      RETURN
 10   ST=0.
      CT=1.
      SF=0.
      CF=1.
      RETURN
 11   ST=0.
      CT=1.
      SF=0.
      CF=1.
      T=0.
      RETURN
      ENTRY TINP0(P,CT,ST,CF,SF,T,CM)
C O[PE[E[EH[E [O MACCE CM,K[H.[HEP[[[ T [ [[[AM [ACT[[[,EE [M[[[[CA P(3)
      PM=SQRT(T*2.*CM)
      P(3)=PM*CT
      PM=PM*ST
      P(1)=PM*CF
      P(2)=PM*SF
      RETURN
      END
      SUBROUTINE CLPV0(P1,V,P2,E1)
c -- nonrelativistic ! E1 - mass of particle (not total energy)
C O[PE[E[EH[E [M[[[[CA [ACT[[[ P2(3) B [.C.K ,C[[TA[,[TO CTAPA[ C.K.([DE
C [M[[[[C [ACT[[[ P1(3)) [B[[ETC[ CO CKOP.V(3).E1-[O[H.[HEP[.[ACT[[[ B C
      DIMENSION P1(3),V(3),P2(3)
      DO 20 K=1,3
 20   P2(K)=P1(K)+V(K)*E1
      RETURN
      END
      SUBROUTINE ECOR02(INNE,IPP0,AMP,PN0,TN)
c Sept. 2003 TAMU! Add after DISN02: Scaling of fragment velocities 
c to conserve energy (the conservation may be violated after superposition 
c of thermal and rotational/flow velocities!)
c INNE -number of evaluated particles ("neutrons"), IPP0 -number particles 
c skipped in the beginning ("charged"): In the code IPP0=0 means that all 
c particles are charged and EMOMC,FLOWC used for correction! Otherwise 
c (for neutrons) we use (EMOM*A00-EMOMC) and (EFLOW*A00-FLOWC). 
c *** implem.of flow.and rotat. EFLOW, EMOM in GeV/N. ANMOM in h-bar ***
c *** FLOWC, EMOMC in GeV. Thermal kin.energ.-TN in GeV.
      COMMON /BLFLOW/A00,EFLOW,IFLOW /BLFLCM/ALF0,FLOWC,XCM,YCM,ZCM
      COMMON /BLAMOM/ANMOM,EMOM,IAMOM /BLAMCM/BMOM,WR,EMOMC
      DIMENSION AMP(500),PN0(3,500),VX(500),VY(500),VZ(500)
      IF(INNE.LE.0) RETURN
      IF(IPP0.LT.0.OR.(IPP0+INNE).GT.500) RETURN
      IF(IFLOW.EQ.0.AND.IAMOM.EQ.0) RETURN
      IP01=IPP0+1
      IP0M=IPP0+INNE
      ECM=EMOMC
      ECF=FLOWC
      IF(IPP0.GT.0) ECM=EMOM*A00-EMOMC
      IF(IPP0.GT.0) ECF=EFLOW*A00-FLOWC
      IF(ECM.LT.0.) ECM=0.
      IF(ECF.LT.0.) ECF=0.
c
      ETOT=TN
      IF(IAMOM.GE.1) ETOT=ETOT+ECM
      IF(IFLOW.GE.1) ETOT=ETOT+ECF
      EE=0.
      DO 40 I=IP01,IP0M
      VX(I)=PN0(1,I)/AMP(I)
      VY(I)=PN0(2,I)/AMP(I)
      VZ(I)=PN0(3,I)/AMP(I)
      EE=EE+(AMP(I)*0.5)*(VX(I)**2+VY(I)**2+VZ(I)**2)
 40   CONTINUE
      ETA=SQRT(ETOT/EE)
c
c      PRINT 42,ETOT,EE,ETA
c 42   FORMAT(2X,'#ECOR02: ETOT=',E11.4,' EE=',E11.4,' ETA=',F9.4)
c
      DO 41 I=IP01,IP0M
      VX(I)=ETA*VX(I)
      VY(I)=ETA*VY(I)
      VZ(I)=ETA*VZ(I)
      PN0(1,I)=AMP(I)*VX(I)
      PN0(2,I)=AMP(I)*VY(I)
      PN0(3,I)=AMP(I)*VZ(I)
 41   CONTINUE
      RETURN
      END
c -- includ. these 3 subr. (EVANU1,EVANU2,DELAM0) instead of old EVANUC --
      SUBROUTINE EVANUC(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
      COMMON /BLEVP/IEVP
      IF(IEVP.EQ.1) CALL EVANU1(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
      IF(IEVP.EQ.2) CALL EVAN22(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
      IF(IEVP.EQ.3) CALL EVANU3(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
      RETURN
      END
c ***
      SUBROUTINE EVANU1(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
c EVANU1=old EVANUC, account.in Milazzo paper (at MILAZ=1) and possibil. 
c to leave EVANUC during evaporation for RAZVAL for A.le.16 ! See IEVAR.
      COMMON /BL0999/RNCL/BL1000/AM,AMF,AMCB(35)/AMNUCL/AMNEV(3)
      COMMON /BL1001/T1Y(130)/BL1002/T2XY(200)/BL1005/AJ(35)
     */BL1006/ZJ(35)/BL1014/GAM(35)/BL1011/VJ(35)/BL1015/RJ(35)
      COMMON /BL1003/U,A,Z/BL1009/AFJ(35)/BL1010/ZFJ(35)
      COMMON/BLOKC/SPTU(10,500)/BLANGL/ANGL(4)/BL1100/AMS,AMFS
      COMMON/BLFIS/FIS,EF,SNT(6,6)/BLCAN/ICAN /BLMULF/IMULF
      COMMON /EXILEV/ ENLEV(20,35),SPLEV(20,35)
      COMMON /BLSECON/LSECON /BLEVAR/IEVAR /BMILAZ/MILAZ
      COMMON /BLIEX/IEX
      DIMENSION GJ(35),BJ(35),GG(35),VN(3),PN(3),PNL(3),PP(3),PPL(3)
      DIMENSION DSH2(35)
C [C[APEH[E [E[K[X [PA[MEHTOB [[ T[[.[[PA [O BA[CKO[[[. [[[T[BAETC[
C COXPAHEH[E [HEP[[[,[M[[[[CA [ MOMEHTA [M[[[[CA(K[ACC[[.). [E[EH[E
C [[[T[BAETC[ KAK BO[MO[H[[ KAHA[ [PEKPA[A[[[[ [C[AP[TE[[H[[ KACKA[.
C PA[MEPHOCT[: [HEP[[[-[[B,[M[[[[C-[[B/C,CKOPOCT[-1/C,MACCA-AT.HOMEP.
C       ******************************
C  ICAN=0 -[[[T[BAETC[ 6 KAHA[OB [ [E[EH[E; ICAN=1 - 32 KAHA[A [ [E[EH[E
C  ICAN=2 - 6 KAHA[OB, [E[EH[E, 34 [ 35 KAHA[; ICAN=3 ([[[ [P.) -BCE KAH
C       ******************************
      IEVAR=0
      ILEVEL=3
      CALL DATEVP(ILEVEL)
      FIS=0.
      SNT(1,1)=ENEXT
      SNT(2,1)=ATWGHT
      SNT(3,1)=CHARGE
      SNT(4,1)=PNX
      SNT(5,1)=PNY
      SNT(6,1)=PNZ
      U=ENEXT*1000.
      A=ATWGHT
      Z=CHARGE
      AMNEV(1)=0.
      AMNEV(2)=0.
      AMNEV(3)=0.
      REMN=940.*A
      PNL(1)=PNX*1000.
      PNL(2)=PNY*1000.
      PNL(3)=PNZ*1000.
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+REMN**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      DO 20 K=KSTART,500
c ------- exit for hot fragments (into SPT) -----
      IF(IEX.EQ.1) GO TO 11
c ----- inclusion following Milazzo paper (last version smm_ba2) ------
cc avoiding RAZVAL at all at MILAZ=1:
cc     IF(K.GE.0) GO TO 80
cc ----------------------
      IF(IMULF.EQ.0.AND.A.LT.4.1) GO TO 11
      IF(IMULF.EQ.0) GO TO 80
      IF(MILAZ.NE.1) GO TO 80
      IF(A.GT.16.) GO TO 80
      UA=U/A
c transition to RAZVAL according to mass (.le.16)
c      IF(A.LE.16.) IEVAR=1
c      IF(IEVAR.EQ.1) GO TO 11
c transition to RAZVAL according to mass and energy
      IF(A.LE.6.) IEVAR=1
      UAR=4.0
      BUA=1.-EXP(-0.693*(UA/UAR)**4)
      BR=RNDMSMM(-1)
c -- transition to RAZVAL for large energies --
c UAR=0.01 - only RAZVAL, UAR=100. - only evaporation
c      IF(BR.LE.BUA) IEVAR=1
c -- transition to RAZVAL for small energies --
c UAR=0.01 - only evaporation, UAR=100. - only RAZVAL
      IF(BR.GT.BUA) IEVAR=1
      IF(IEVAR.EQ.1) GO TO 11
 80   CONTINUE
c --------------------------------------------------------------
      IN=35
      IF(A.LE.16) IN=6
      DO 4 I=1,IN
      VJ(I)=0.
      AMCB(I)=0.
C      DSH2(I)=0.
 4    RJ(I)=-1000.
      CALL DELAM(A,Z,DL1,DSHEL1,BARIER)
      AM=AMS
C      IF(U.GT.0.) AM=AMS*(1.+(1.-EXP(-0.06*U))*DSHEL1/U)
      IF(Z.GE.89.) AMF=1.04*AMS
      IF(Z.GT.85.AND.Z.LT.89) AMF=AMS*(1.04+0.01*(89.-Z))
      IF(Z.LE.85.) AMF=1.08*AMS
      IF(MILAZ.EQ.1) AMF=1.04*AMS
      DO 6 I=1,IN
      IF(I.EQ.33) GO TO 6
      AFJ(I)=A-AJ(I)
      ZFJ(I)=Z-ZJ(I)
        IF(ICAN.EQ.0.AND.I.GT.6) GO TO 6
        IF(ICAN.EQ.1.AND.I.GT.32) GO TO 6
        IF(ICAN.EQ.2.AND.I.GT.6.AND.I.LE.32) GO TO 6
        IF(AFJ(I).LT.ZFJ(I)) GO TO 6
        IF(AFJ(I).LT.AJ(I).OR.ZFJ(I).LT.ZJ(I)) GO TO 6
      JAF=INT(AFJ(I)+0.5)
      JZF=INT(ZFJ(I)+0.5)
      JNF=JAF-JZF
      ODD=11.*(2+2*(JNF/2)-JNF+2*(JZF/2)-JZF)/SQRT(AFJ(I))
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      VJ(I)=COLOMB(I,RADNCL)
      CALL DELAM(AFJ(I),ZFJ(I),DL2,DSHEL2,BAR2)
C      DSH2(I)=DSHEL2
      CALL DELAM(AJ(I),ZJ(I),DL3,DSHEL3,BAR3)
      BJ(I)=DL2+DL3-DL1
c ******** in accordance with DELA8
      IF(A.LE.55.) RJ(I)=U-(BJ(I)+VJ(I))-ODD
      TCOEF=1.-(A-55.)/10.
      IF(A.GT.55.AND.A.LT.65.) RJ(I)=U-(BJ(I)+VJ(I))-ODD*TCOEF
      IF(A.GE.65.) RJ(I)=U-(BJ(I)+VJ(I))
c ********
C     RJ(I)=U-(BJ(I)+VJ(I))-ODD
C     RJ(I)=U-(BJ(I)+VJ(I))
C      IF(RJ(I).GT.0.)
C     *AMCB(I)=AMS*(1.+(1.-EXP(-0.06*RJ(I)))*DSHEL2/RJ(I))
 6    CONTINUE
      EF=BARIER
C      AMCB(33)=AMF
      IF(A.GT.100.) RJ(33)=U-BARIER
       DO 7 I=1,IN
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      AMC=AM
C      AMC=AMCB(I)
      GJ(I)=GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
      RJI=RJ(I)
      GAMI=GAM(I)
      DO 71 IL=1,20
      IF(SPLEV(IL,I).LT.0.1) GO TO 70
      GAM(I)=SPLEV(IL,I)*AJ(I)
      RJ(I)=RJI-ENLEV(IL,I)
C      IF(RJ(I).GT.0.)
C     *AMC=AMS*(1.+(1.-EXP(-0.06*RJ(I)))*DSH2(I)/RJ(I))
      GJ(I)=GJ(I)+GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
 71   CONTINUE
 70   RJ(I)=RJI
      GAM(I)=GAMI
7     CONTINUE
      G=0.
      DO 10 I=1,IN
10    G=G+GJ(I)
        IF(G) 11,11,12
 11   PNX=PNL(1)*0.001
      PNY=PNL(2)*0.001
      PNZ=PNL(3)*0.001
      ENEXT=U*0.001
      ATWGHT=A
      CHARGE=Z
      IF(IEVAR.EQ.1) KSTART=K
      IF(IEVAR.EQ.1) RETURN
      REMN=940.*A
      SPTU(9,K)=REMN*0.001
      SPTU(8,K)=Z
      CALL PINT(PNL,CT,ST,CF,SF,T,REMN)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(1,K)=1.
      SPTU(3,K)=FIS
c      IF(K.GT.KSTART) SPTU(2,K)=2.
c      IF(LSECON.GT.0) SPTU(2,K)=2.
c      IF(IEX.EQ.1) SPTU(2,K)=U*0.001
      SPTU(2,K)=U*0.001
      KSTART=K+1
      RETURN
 12   CONTINUE
      DO 13 J=2,IN
13    GJ(J)=GJ(J-1)+GJ(J)
      BB=RNDMSMM(-1)
      B=BB*G
      DO 14 J=1,IN
        IF(B-GJ(J)) 15,14,14
15    LM=J
      GO TO 16
 14   CONTINUE
 16     IF(LM-33) 18,17,18
 17   FIS=1.
      KSTART=K
      CALL FISION(U,A,Z,PNL(1),PNL(2),PNL(3),KSTART)
      RETURN
 18   AMC=AM
C18    AMC=AMCB(LM)
      EP1=TKIN(LM,AMC,AMF)
      EP2=ZJ(LM)
      EP3=940.*AJ(LM)
C     ALMAX=0.219327*1.2*(AFJ(LM)**0.333333+AJ(LM)**0.333333)
C    +*SQRT((AJ(LM)*AFJ(LM)/(AJ(LM)+AFJ(LM)))*(EP1-VJ(LM)))
C     BR=RNDMSMM(-1)
C     AL=ALMAX*SQRT(BR)
C     BR1=1.-2.*RNDMSMM(-1)
C     BR2=6.283185*RNDMSMM(-1)
C     AMNEV(1)=AMNEV(1)-AL*SQRT(1.-BR1**2)*COS(BR2)
C     AMNEV(2)=AMNEV(2)-AL*SQRT(1.-BR1**2)*SIN(BR2)
C     AMNEV(3)=AMNEV(3)-AL*BR1
      UOLD=U
      U=U-BJ(LM)-EP1
      A=AFJ(LM)
      Z=ZFJ(LM)
C  VPM-OTHOC[TE[[HA[ CKOPOCT[ [PA[MEHTA
      VPM=SQRT((2.*EP1)/(EP3*AFJ(LM)/(AFJ(LM)+AJ(LM))))
      CALL ISANGL
C  [M[[[[C [PA[MEHTA B C.[.[.
      PP(1)=VPM*ANGL(4)*ANGL(3)*EP3/(1.+AJ(LM)/A)
      PP(2)=VPM*ANGL(4)*ANGL(2)*EP3/(1.+AJ(LM)/A)
      PP(3)=VPM*ANGL(1)*EP3/(1.+AJ(LM)/A)
      PN(1)=-PP(1)
      PN(2)=-PP(2)
      PN(3)=-PP(3)
      EP=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+EP3**2)
      EN=SQRT(PN(1)**2+PN(2)**2+PN(3)**2+(940.*A)**2)
      CALL CLPV(PP,VN,PPL,EP)
      CALL CLPV(PN,VN,PNL,EN)
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+(940.*A)**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      CALL PINT(PPL,CT,ST,CF,SF,T,EP3)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(8,K)=EP2
      SPTU(9,K)=EP3*0.001
      SPTU(2,K)=UOLD*0.001
20    CONTINUE
c      PRINT 21,U,A,Z
c21    FORMAT(35X,37HMASSIV SPT EXCEEDED AFTER EVAPORATION/40X,2HU=,
c     *F10.5,4H  A=,F5.1,4H  Z=,F4.1)
       RETURN
       END
      SUBROUTINE EVAN22(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
c changing EVANU2 into EVAN22, in order to keep energy balance (to avoid 
c increasing/decreasing energy because of changing masses of nuclei): 
c after emission of particle new available energy U is calculated by using 
c 'table' mass formulae. + Restriction to IN=6 + fission. 
c ---
c *** modernized EVANUC with l.d.masses for residues + accounting MILAZ=1 +
c possibil. leave EVANUC during evapor. for RAZVAL for A.le.16 ! See IEVAR.
      COMMON /BL0999/RNCL/BL1000/AM,AMF,AMCB(35)/AMNUCL/AMNEV(3)
      COMMON /BL1001/T1Y(130)/BL1002/T2XY(200)/BL1005/AJ(35)
     */BL1006/ZJ(35)/BL1014/GAM(35)/BL1011/VJ(35)/BL1015/RJ(35)
      COMMON /BL1003/U,A,Z/BL1009/AFJ(35)/BL1010/ZFJ(35)
      COMMON/BLOKC/SPTU(10,500)/BLANGL/ANGL(4)/BL1100/AMS,AMFS
      COMMON/BLFIS/FIS,EF,SNT(6,6)/BLCAN/ICAN /BLMULF/IMULF
      COMMON /EXILEV/ ENLEV(20,35),SPLEV(20,35)
      COMMON /BLSECON/LSECON /BLEVAR/IEVAR /BMILAZ/MILAZ
      COMMON /BLIEX/IEX
      DIMENSION GJ(35),BJ(35),GG(35),VN(3),PN(3),PNL(3),PP(3),PPL(3)
C [C[APEH[E [E[K[X [PA[MEHTOB [[ T[[.[[PA [O BA[CKO[[[. [[[T[BAETC[
C COXPAHEH[E [HEP[[[,[M[[[[CA [ MOMEHTA [M[[[[CA(K[ACC[[.). [E[EH[E
C [[[T[BAETC[ KAK BO[MO[H[[ KAHA[ [PEKPA[A[[[[ [C[AP[TE[[H[[ KACKA[.
C PA[MEPHOCT[: [HEP[[[-[[B,[M[[[[C-[[B/C,CKOPOCT[-1/C,MACCA-AT.HOMEP.
C       ******************************
C  ICAN=0 -[[[T[BAETC[ 6 KAHA[OB [ [E[EH[E; ICAN=1 - 32 KAHA[A [ [E[EH[E
C  ICAN=2 - 6 KAHA[OB, [E[EH[E, 34 [ 35 KAHA[; ICAN=3 ([[[ [P.) -BCE KAH
C       ******************************
      IEVAR=0
      ILEVEL=3
      CALL DATEVP(ILEVEL)
      FIS=0.
      SNT(1,1)=ENEXT
      SNT(2,1)=ATWGHT
      SNT(3,1)=CHARGE
      SNT(4,1)=PNX
      SNT(5,1)=PNY
      SNT(6,1)=PNZ
      U=ENEXT*1000.
      A=ATWGHT
      Z=CHARGE
      AMNEV(1)=0.
      AMNEV(2)=0.
      AMNEV(3)=0.
      REMN=940.*A
      PNL(1)=PNX*1000.
      PNL(2)=PNY*1000.
      PNL(3)=PNZ*1000.
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+REMN**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      DO 20 K=KSTART,500
      UA=U/A
c ------- exit for hot fragments (into SPT) -----
      IF(IEX.EQ.1) GO TO 11
c ----- inclusion following Milazzo paper (last version smm_ba2) ------
cc avoiding RAZVAL at all at MILAZ=1:
cc     IF(K.GE.0) GO TO 80
cc ----------------------
      IF(IMULF.EQ.0.AND.A.LT.4.1) GO TO 11
      IF(IMULF.EQ.0) GO TO 80
      IF(MILAZ.NE.1) GO TO 80
      IF(A.GT.16.) GO TO 80
c transition to RAZVAL according to mass (.le.16)
c      IF(A.LE.16.) IEVAR=1
c      IF(IEVAR.EQ.1) GO TO 11
c transition to RAZVAL according to mass and energy
      IF(A.LE.6.) IEVAR=1
      UAR=4.0
      BUA=1.-EXP(-0.693*(UA/UAR)**4)
      BR=RNDMSMM(-1)
c -- transition to RAZVAL for large energies --
c UAR=0.01 - only RAZVAL, UAR=100. - only evaporation
c      IF(BR.LE.BUA) IEVAR=1
c -- transition to RAZVAL for small energies --
c UAR=0.01 - only evaporation, UAR=100. - only RAZVAL
      IF(BR.GT.BUA) IEVAR=1
      IF(IEVAR.EQ.1) GO TO 11
 80   CONTINUE
c --------------------------------------------------------------
      IN=35
      IF(A.LE.16) IN=6
      DO 4 I=1,IN
      VJ(I)=0.
      AMCB(I)=0.
 4    RJ(I)=-1000.
      CALL DELAM0(A,Z,DL1,DSHEL1,BARIER,UA,WW0)
      UAOLD=UA
      AM=AMS
C      IF(U.GT.0.) AM=AMS*(1.+(1.-EXP(-0.06*U))*DSHEL1/U)
      IF(Z.GE.89.) AMF=1.04*AMS
      IF(Z.GT.85.AND.Z.LT.89) AMF=AMS*(1.04+0.01*(89.-Z))
      IF(Z.LE.85.) AMF=1.08*AMS
      IF(MILAZ.EQ.1) AMF=1.04*AMS
      DO 6 I=1,IN
      IF(I.GT.6) GO TO 6
c      IF(I.EQ.33) GO TO 6
      AFJ(I)=A-AJ(I)
      ZFJ(I)=Z-ZJ(I)
        IF(ICAN.EQ.0.AND.I.GT.6) GO TO 6
        IF(ICAN.EQ.1.AND.I.GT.32) GO TO 6
        IF(ICAN.EQ.2.AND.I.GT.6.AND.I.LE.32) GO TO 6
        IF(AFJ(I).LT.ZFJ(I)) GO TO 6
        IF(AFJ(I).LT.AJ(I).OR.ZFJ(I).LT.ZJ(I)) GO TO 6
      JAF=INT(AFJ(I)+0.5)
      JZF=INT(ZFJ(I)+0.5)
      JNF=JAF-JZF
      ODD=11.*(2+2*(JNF/2)-JNF+2*(JZF/2)-JZF)/SQRT(AFJ(I))
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      VJ(I)=COLOMB(I,RADNCL)
      CALL DELAM0(AFJ(I),ZFJ(I),DL2,DSHEL2,BAR2,UA,WW)
      CALL DELAM(AJ(I),ZJ(I),DL3,DSHEL3,BAR3)
      BJ(I)=DL2+DL3-DL1
      RJ(I)=U-(BJ(I)+VJ(I))-ODD*WW
c      RJ(I)=U-(BJ(I)+VJ(I))
 6    CONTINUE
      EF=BARIER
      IF(A.GT.100.) RJ(33)=U-BARIER
      DO 7 I=1,IN
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      AMC=AM
      GJ(I)=GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
      RJI=RJ(I)
      GAMI=GAM(I)
      DO 71 IL=1,20
      IF(SPLEV(IL,I).LT.0.1) GO TO 70
      GAM(I)=SPLEV(IL,I)*AJ(I)
      RJ(I)=RJI-ENLEV(IL,I)
      GJ(I)=GJ(I)+GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
 71   CONTINUE
 70   RJ(I)=RJI
      GAM(I)=GAMI
 7    CONTINUE
      G=0.
      DO 10 I=1,IN
 10   G=G+GJ(I)
      IF(G) 11,11,12
 11   PNX=PNL(1)*0.001
      PNY=PNL(2)*0.001
      PNZ=PNL(3)*0.001
      ENEXT=U*0.001
      ATWGHT=A
      CHARGE=Z
      IF(IEVAR.EQ.1) KSTART=K
      IF(IEVAR.EQ.1) RETURN
      REMN=940.*A
      SPTU(9,K)=REMN*0.001
      SPTU(8,K)=Z
      CALL PINT(PNL,CT,ST,CF,SF,T,REMN)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(1,K)=1.
      SPTU(3,K)=FIS
c      IF(K.GT.KSTART) SPTU(2,K)=2.
c      IF(LSECON.GT.0) SPTU(2,K)=2.
c      IF(IEX.EQ.1) SPTU(2,K)=U*0.001
      SPTU(2,K)=U*0.001
      KSTART=K+1
      RETURN
 12   CONTINUE
      DO 13 J=2,IN
 13   GJ(J)=GJ(J-1)+GJ(J)
      BB=RNDMSMM(-1)
      B=BB*G
      DO 14 J=1,IN
      IF(B-GJ(J)) 15,14,14
 15   LM=J
      GO TO 16
 14   CONTINUE
 16   IF(LM-33) 18,17,18
 17   FIS=1.
      KSTART=K
      CALL FISION(U,A,Z,PNL(1),PNL(2),PNL(3),KSTART)
      RETURN
 18   AMC=AM
      EP1=TKIN(LM,AMC,AMF)
      EP2=ZJ(LM)
      EP3=940.*AJ(LM)
      CALL DELAM(A,Z,DL1,DSHEL1,BAR1)
      CALL DELAM(AFJ(LM),ZFJ(LM),DL2,DSHEL2,BAR2)
      CALL DELAM(AJ(LM),ZJ(LM),DL3,DSHEL3,BAR3)
      A=AFJ(LM)
      Z=ZFJ(LM)
      UOLD=U
c      U=U-BJ(LM)-EP1
      U=U-(DL2+DL3-DL1)-EP1
      UANEW=U/A
c -- correct.excit.to mass change => contradict. detail balance: T=const!
c      CALL DELAM0(A,Z,DLOLD,DSHEL4,BARIE4,UAOLD,WW4)
c      CALL DELAM0(A,Z,DLNEW,DSHEL4,BARIE4,UANEW,WW4)
c      U=U+DLNEW-DLOLD
C  VPM-OTHOC[TE[[HA[ CKOPOCT[ [PA[MEHTA
      VPM=SQRT((2.*EP1)/(EP3*AFJ(LM)/(AFJ(LM)+AJ(LM))))
      CALL ISANGL
C  [M[[[[C [PA[MEHTA B C.[.[.
      PP(1)=VPM*ANGL(4)*ANGL(3)*EP3/(1.+AJ(LM)/A)
      PP(2)=VPM*ANGL(4)*ANGL(2)*EP3/(1.+AJ(LM)/A)
      PP(3)=VPM*ANGL(1)*EP3/(1.+AJ(LM)/A)
      PN(1)=-PP(1)
      PN(2)=-PP(2)
      PN(3)=-PP(3)
      EP=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+EP3**2)
      EN=SQRT(PN(1)**2+PN(2)**2+PN(3)**2+(940.*A)**2)
      CALL CLPV(PP,VN,PPL,EP)
      CALL CLPV(PN,VN,PNL,EN)
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+(940.*A)**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      CALL PINT(PPL,CT,ST,CF,SF,T,EP3)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(8,K)=EP2
      SPTU(9,K)=EP3*0.001
      SPTU(2,K)=UOLD*0.001
 20   CONTINUE
c      PRINT 21,U,A,Z
c 21   FORMAT(2X,'dimens. SPT exceeded after EVAN22',' U=',
c     *F10.5,' A=',F5.1,' Z=',F4.1)
       RETURN
       END
      SUBROUTINE DELAM0(A,Z,DLM,SHL,BAR,UA,WW)
c transition from liquid-drop masses to shell masses at small UA (MeV/N)
      COMMON /BGSYM/G00,G0G,FKACOG,B00,W00
      IA=INT(A+0.5)
      IZ=INT(Z+0.5)
c -------------------------------------
      IF(IA.GE.IZ.AND.IZ.GT.0) GO TO 3
      IF(IA.GT.0.AND.IZ.EQ.0) GO TO 3
      PRINT 2,IA,IZ
 2    FORMAT(2X,'ERROR in DELAM0: IA,IZ=',2I5)
      STOP
 3    CONTINUE
c -------------------------------------
      IF(IA.GT.4) GO TO 1
      IF(IZ.GT.2) GO TO 1
      IF(IA.GT.1.AND.IZ.EQ.0) GO TO 1
      IF(IA.EQ.2.AND.IZ.EQ.2) GO TO 1
c -------- for 'gas' particles -------
      IF(IA.EQ.1.AND.IZ.EQ.0) DLM=8.071
      IF(IA.EQ.1.AND.IZ.EQ.1) DLM=7.289
      IF(IA.EQ.2.AND.IZ.EQ.1) DLM=13.136
      IF(IA.EQ.3.AND.IZ.EQ.1) DLM=14.950
      IF(IA.EQ.4.AND.IZ.EQ.1) DLM=25.920
      IF(IA.EQ.3.AND.IZ.EQ.2) DLM=14.931
      IF(IA.EQ.4.AND.IZ.EQ.2) DLM=2.425
      WW=1.
      SHL=0.
      BAR=1001.
      RETURN
 1    CONTINUE
c ------ for nuclei with shells --------
      CALL DELA1(A,Z,DM1,SH1)
      BAR=1001.
      IF(IA.GE.65) BAR=BARIE1(A,Z)
      SHL=SH1
c ------ for 'liquid-drop' nuclei ------
      W0=W00
c      W0=16.
      B0=B00
c      B0=18.
      G0=G00
      RADNCL=1.17
      A13=A**0.33333333
      A23=A13*A13
      R=RADNCL*A13
      XZ=Z/A
      EQ=A*(-W0+G0*(1.-2.*XZ)**2)+B0*A23+0.6*1.44*Z*Z/R
      DM2=EQ+(8.071*IA-0.782*IZ)
c -- combination of their masses depending on excitation --
c -- 'critical' excit.energy (temperature!) is assumed 1 MeV/N ! --
      UACRIT=1.
      IF(UA.GT.UACRIT) WW=0.
      IF(UA.LE.UACRIT) WW=1.-UA/UACRIT
      IF(WW.LT.0.) WW=0.
      IF(WW.GT.1.) WW=1.
      DLM=WW*DM1+(1.-WW)*DM2
      RETURN
      END
      SUBROUTINE EVANU3(ENEXT,ATWGHT,CHARGE,PNX,PNY,PNZ,KSTART)
c 7 Dec 2004, INR.   New evaporation (with changed masses - DELAM0):
c EVANU2 (Nov 2003) --> EVANU3  taking into account changing mass of
c the residual during both finding probability of emission and after
c emission of particles with some kin.energy. Energy balance strictly
c conserved (checked!), but excitation energy is always defined from
c mass at given excitation energy. Tempor. limit: IN=6 (not 35)!
c *** modernized EVANUC with l.d.masses for residues + accounting MILAZ=1 +
c possibil. leave EVANUC during evapor. for RAZVAL for A.le.16 ! See IEVAR.
      COMMON /BL0999/RNCL/BL1000/AM,AMF,AMCB(35)/AMNUCL/AMNEV(3)
      COMMON /BL1001/T1Y(130)/BL1002/T2XY(200)/BL1005/AJ(35)
     */BL1006/ZJ(35)/BL1014/GAM(35)/BL1011/VJ(35)/BL1015/RJ(35)
      COMMON /BL1003/U,A,Z/BL1009/AFJ(35)/BL1010/ZFJ(35)
      COMMON/BLOKC/SPTU(10,500)/BLANGL/ANGL(4)/BL1100/AMS,AMFS
      COMMON/BLFIS/FIS,EF,SNT(6,6)/BLCAN/ICAN /BLMULF/IMULF
      COMMON /EXILEV/ ENLEV(20,35),SPLEV(20,35)
      COMMON /BLSECON/LSECON /BLEVAR/IEVAR /BMILAZ/MILAZ
      COMMON /BLIEX/IEX
      DIMENSION GJ(35),BJ(35),GG(35),VN(3),PN(3),PNL(3),PP(3),PPL(3)
C [C[APEH[E [E[K[X [PA[MEHTOB [[ T[[.[[PA [O BA[CKO[[[. [[[T[BAETC[
C COXPAHEH[E [HEP[[[,[M[[[[CA [ MOMEHTA [M[[[[CA(K[ACC[[.). [E[EH[E
C [[[T[BAETC[ KAK BO[MO[H[[ KAHA[ [PEKPA[A[[[[ [C[AP[TE[[H[[ KACKA[.
C PA[MEPHOCT[: [HEP[[[-[[B,[M[[[[C-[[B/C,CKOPOCT[-1/C,MACCA-AT.HOMEP.
C       ******************************
C  ICAN=0 -[[[T[BAETC[ 6 KAHA[OB [ [E[EH[E; ICAN=1 - 32 KAHA[A [ [E[EH[E
C  ICAN=2 - 6 KAHA[OB, [E[EH[E, 34 [ 35 KAHA[; ICAN=3 ([[[ [P.) -BCE KAH
C       ******************************
      IEVAR=0
      ILEVEL=3
      CALL DATEVP(ILEVEL)
      FIS=0.
      SNT(1,1)=ENEXT
      SNT(2,1)=ATWGHT
      SNT(3,1)=CHARGE
      SNT(4,1)=PNX
      SNT(5,1)=PNY
      SNT(6,1)=PNZ
      U=ENEXT*1000.
      A=ATWGHT
      Z=CHARGE
      AMNEV(1)=0.
      AMNEV(2)=0.
      AMNEV(3)=0.
      REMN=940.*A
      PNL(1)=PNX*1000.
      PNL(2)=PNY*1000.
      PNL(3)=PNZ*1000.
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+REMN**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      DO 20 K=KSTART,500
      UA=U/A
c ------- exit for hot fragments (into SPT) -----
      IF(IEX.EQ.1) GO TO 11
c ----- inclusion following Milazzo paper (last version smm_ba2) ------
cc avoiding RAZVAL at all at MILAZ=1:
cc     IF(K.GE.0) GO TO 80
cc ----------------------
      IF(IMULF.EQ.0.AND.A.LT.4.1) GO TO 11
      IF(IMULF.EQ.0) GO TO 80
      IF(MILAZ.NE.1) GO TO 80
      IF(A.GT.16.) GO TO 80
c transition to RAZVAL according to mass (.le.16)
c      IF(A.LE.16.) IEVAR=1
c      IF(IEVAR.EQ.1) GO TO 11
c transition to RAZVAL according to mass and energy
      IF(A.LE.6.) IEVAR=1
      UAR=4.0
      BUA=1.-EXP(-0.693*(UA/UAR)**4)
      BR=RNDMSMM(-1)
c -- transition to RAZVAL for large energies --
c UAR=0.01 - only RAZVAL, UAR=100. - only evaporation
c      IF(BR.LE.BUA) IEVAR=1
c -- transition to RAZVAL for small energies --
c UAR=0.01 - only evaporation, UAR=100. - only RAZVAL
      IF(BR.GT.BUA) IEVAR=1
      IF(IEVAR.EQ.1) GO TO 11
 80   CONTINUE
c --------------------------------------------------------------
c      IN=35
      IN=6
      IF(A.LE.16) IN=6
      DO 4 I=1,IN
      VJ(I)=0.
      AMCB(I)=0.
 4    RJ(I)=-1000.
      CALL DELAM0(A,Z,DL1,DSHEL1,BARIER,UA,WW0)
c
c      PRINT 123,A,Z,U,DL1
c 123  FORMAT(5X,' starting step A,Z=',2F5.1,' U=',F6.1,' DL1=',F6.1)
c
      UOLD=U
      UAOLD=UA
      AM=AMS
C      IF(U.GT.0.) AM=AMS*(1.+(1.-EXP(-0.06*U))*DSHEL1/U)
      IF(Z.GE.89.) AMF=1.04*AMS
      IF(Z.GT.85.AND.Z.LT.89) AMF=AMS*(1.04+0.01*(89.-Z))
      IF(Z.LE.85.) AMF=1.08*AMS
      IF(MILAZ.EQ.1) AMF=1.04*AMS
      DO 6 I=1,IN
      IF(I.EQ.33) GO TO 6
      AFJ(I)=A-AJ(I)
      ZFJ(I)=Z-ZJ(I)
        IF(ICAN.EQ.0.AND.I.GT.6) GO TO 6
        IF(ICAN.EQ.1.AND.I.GT.32) GO TO 6
        IF(ICAN.EQ.2.AND.I.GT.6.AND.I.LE.32) GO TO 6
        IF(AFJ(I).LT.ZFJ(I)) GO TO 6
        IF(AFJ(I).LT.AJ(I).OR.ZFJ(I).LT.ZJ(I)) GO TO 6
      JAF=INT(AFJ(I)+0.5)
      JZF=INT(ZFJ(I)+0.5)
      JNF=JAF-JZF
      ODD=11.*(2+2*(JNF/2)-JNF+2*(JZF/2)-JZF)/SQRT(AFJ(I))
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      VJ(I)=COLOMB(I,RADNCL)
      CALL DELAM(AJ(I),ZJ(I),DL3,DSHEL3,BAR3)
ccc      CALL DELAM0(AFJ(I),ZFJ(I),DL2,DSHEL2,BAR2,UA,WW)
      CALL FINDL2(UA,U,DL1,DL3,VJ(I),AFJ(I),ZFJ(I),DL2,WW)
      BJ(I)=DL2+DL3-DL1
      RJ(I)=U-(BJ(I)+VJ(I))-ODD*WW
c      RJ(I)=U-(BJ(I)+VJ(I))
 6    CONTINUE
      EF=BARIER
      IF(A.GT.100.) RJ(33)=U-BARIER
      DO 7 I=1,IN
      IF(RNCL.GE.0.1) RADNCL=RNCL
      IF(RNCL.LT.0.1)
     *RADNCL=2.173*(1+0.006103*ZJ(I)*ZFJ(I))/(1+0.009443*ZJ(I)*ZFJ(I))
      AMC=AM
      GJ(I)=GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
      RJI=RJ(I)
      GAMI=GAM(I)
      DO 71 IL=1,20
      IF(SPLEV(IL,I).LT.0.1) GO TO 70
      GAM(I)=SPLEV(IL,I)*AJ(I)
      RJ(I)=RJI-ENLEV(IL,I)
      GJ(I)=GJ(I)+GAMMAC(I,A,U,AM,AMC,AMF,RADNCL)
 71   CONTINUE
 70   RJ(I)=RJI
      GAM(I)=GAMI
 7    CONTINUE
      G=0.
      DO 10 I=1,IN
      GG(I)=GJ(I)
 10   G=G+GJ(I)
      IF(G) 11,11,12
 11   PNX=PNL(1)*0.001
      PNY=PNL(2)*0.001
      PNZ=PNL(3)*0.001
      ENEXT=U*0.001
      ATWGHT=A
      CHARGE=Z
      IF(IEVAR.EQ.1) KSTART=K
      IF(IEVAR.EQ.1) RETURN
      REMN=940.*A
      SPTU(9,K)=REMN*0.001
      SPTU(8,K)=Z
      CALL PINT(PNL,CT,ST,CF,SF,T,REMN)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(1,K)=1.
      SPTU(3,K)=FIS
c      IF(K.GT.KSTART) SPTU(2,K)=2.
c      IF(LSECON.GT.0) SPTU(2,K)=2.
c      IF(IEX.EQ.1) SPTU(2,K)=U*0.001
      SPTU(2,K)=U*0.001
      KSTART=K+1
      RETURN
 12   CONTINUE
c
      DO 120 J=1,IN
 120  GG(J)=GG(J)/G
c      PRINT 124,(GG(J),J=1,IN)
c 124  FORMAT(1X,'GG=',5F11.8)
c
      DO 13 J=2,IN
 13   GJ(J)=GJ(J-1)+GJ(J)
      BB=RNDMSMM(-1)
      B=BB*G
      DO 14 J=1,IN
      IF(B-GJ(J)) 15,14,14
 15   LM=J
      GO TO 16
 14   CONTINUE
 16   IF(LM-33) 18,17,18
 17   FIS=1.
      KSTART=K
      CALL FISION(U,A,Z,PNL(1),PNL(2),PNL(3),KSTART)
      RETURN
 18   AMC=AM
      EP1=TKIN(LM,AMC,AMF)
      EP2=ZJ(LM)
      EP3=940.*AJ(LM)
      A=AFJ(LM)
      Z=ZFJ(LM)
      UO=U
      UB=U-BJ(LM)-VJ(LM)
      UAB=UB/A
c      U=U-BJ(LM)-EP1
c -- checking correct.excit.to mass change =>
      CALL DELAM(AJ(LM),ZJ(LM),DL3,DSHEL3,BAR3)
      DLOLD=DL1
c      PRINT 121,A,Z,U,DLOLD,DL3
c 121  FORMAT(2X,'before correct. A,Z=',2F5.1,' U=',F6.1,' DLOLD=',F6.1,
c     *' DL3=',F6.1)
c
      CALL FINDL2(UAB,UO,DLOLD,DL3,EP1,AFJ(LM),ZFJ(LM),DL2,WW)
      U=U-(DL2+DL3-DL1)-EP1
c
c      UANEW=U/A
c      CALL DELAM0(A,Z,DLNEW,DSHEL4,BARIE4,UANEW,WW4)
c
c      PRINT 122,A,Z,U,DLNEW,LM,AJ(LM),ZJ(LM),BJ(LM),EP1
c 122  FORMAT(2X,'after emission: A,Z=',2F5.1,' U=',F6.1,' DLNEW=',F6.1/
c     *2X,'LM=',I2,' AJ,ZJ=',2F4.0,' BJ=',F7.2,' EP1=',F7.2)
c ---------------------------------
C  VPM-OTHOC[TE[[HA[ CKOPOCT[ [PA[MEHTA
      VPM=SQRT((2.*EP1)/(EP3*AFJ(LM)/(AFJ(LM)+AJ(LM))))
      CALL ISANGL
C  [M[[[[C [PA[MEHTA B C.[.[.
      PP(1)=VPM*ANGL(4)*ANGL(3)*EP3/(1.+AJ(LM)/A)
      PP(2)=VPM*ANGL(4)*ANGL(2)*EP3/(1.+AJ(LM)/A)
      PP(3)=VPM*ANGL(1)*EP3/(1.+AJ(LM)/A)
      PN(1)=-PP(1)
      PN(2)=-PP(2)
      PN(3)=-PP(3)
      EP=SQRT(PP(1)**2+PP(2)**2+PP(3)**2+EP3**2)
      EN=SQRT(PN(1)**2+PN(2)**2+PN(3)**2+(940.*A)**2)
      CALL CLPV(PP,VN,PPL,EP)
      CALL CLPV(PN,VN,PNL,EN)
      ENL=SQRT(PNL(1)**2+PNL(2)**2+PNL(3)**2+(940.*A)**2)
      VN(1)=PNL(1)/ENL
      VN(2)=PNL(2)/ENL
      VN(3)=PNL(3)/ENL
      CALL PINT(PPL,CT,ST,CF,SF,T,EP3)
      SPTU(4,K)=CT
      SPTU(5,K)=SF
      SPTU(6,K)=CF
      SPTU(7,K)=T*0.001
      SPTU(8,K)=EP2
      SPTU(9,K)=EP3*0.001
      SPTU(2,K)=UOLD*0.001
 20   CONTINUE
c      PRINT 21,U,A,Z
c 21   FORMAT(2X,'dimens. SPT exceeded after EVANU3',' U=',
c     *F10.5,' A=',F5.1,' Z=',F4.1)
       RETURN
       END
      SUBROUTINE FINDL2(UA,U,DL1,DL3,VC,AF,ZF,DL2,WW)
c  calculation DL2 taking into account changing mass with energy
c         (from invariant: UNEW+DLNEW=UOLD+DOLD)
      CALL DELAM0(AF,ZF,DLOLD,DSHEL4,BARIE4,UA,WW4)
      UNEW=U-(DLOLD+DL3-DL1)-VC
      UOLD=UNEW
      UFIN=UOLD+DLOLD
C *********
c      PRINT 112,AF,ZF,U,UOLD,DLOLD
c 112  FORMAT(5X,'*FINDL2* AF,ZF=',2F6.1,
c     *' U,UOLD=',2F8.2,' DLOLD=',F7.2)
c *********
      HE=2.
      KK=0
      K1=0
      K2=0
      ID=0
 24      CONTINUE
      UANEW=UNEW/AF
      CALL DELAM0(AF,ZF,DLNEW,DSHEL4,BARIE4,UANEW,WW4)
      DD=UFIN-(UNEW+DLNEW)
      IF(ABS(DD).LT.0.01) GO TO 25
      KK=KK+1
C *********
cc      PRINT 110,AF,ZF,U,UFIN,UNEW,DLNEW
cc 110  FORMAT(2X,'FINDL2* AF,ZF=',2F6.1,
cc     *' U,UFIN,UNEW=',3F8.2,' DLNEW=',F7.2)
C *********
      IF(KK.GT.400.OR.ID.GT.30) GO TO 61
      H=SIGN(HE,DD)
      IF(DD) 21,21,22
 21   K1=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      UNEW=UNEW+H/2**ID
      GO TO 24
 22   K2=1
      IF(K1.EQ.1.AND.K2.EQ.1) ID=ID+1
      UNEW=UNEW+H/2**ID
      GO TO 24
 25   CONTINUE
C *********
c      PRINT 113,AF,ZF,U,UFIN,UNEW,DLNEW
c 113  FORMAT(2X,'fit: AF,ZF=',2F6.1,
c     *' U,UFIN,UNEW=',3F8.2,' DLNEW=',F7.2)
C *********
      DL2=DLNEW
      WW=WW4
      RETURN
c
 61   PRINT 111,KK,ID,AF,ZF,UFIN,UNEW,DLNEW
 111  FORMAT(2X,'error in FINDL2: KK=',I4,' ID=',I4/
     *1X,' AF,ZF=',2F6.1,' UFIN=',F7.2,
     *' UNEW=',F7.2,' DLNEW=',F7.2)
      DL2=DLNEW
      WW=WW4
      RETURN
      END
      SUBROUTINE RESNUC(IT,E,Y)
C random calculations of the new residual nucleus ensemble
C taking into account the two different dependencies
      COMMON /RESNU0/EMIN,EMAX,YMIN,YMAX
c      IF(IT.EQ.1) PRINT 12
c 12   FORMAT(2X,'random calculation of the residual nucleus',
c     *' ensemble'/2X,' for y0=1-a*E-b*E*E, f=exp(-CE*E) (at E<ES)',
c     *' and f=exp(-CX*(1-y0)) (at E>ES) ; ES=5 MEV/N')
c      A=0.001 ! (for nucl. phys. A, 1995 calcul. Au(600MeV/n)+Cu)
c      B=0.0150 ! (for nucl. phys. A, 1995 calcul. Au(600MeV/n)+Cu)
      A=0.001
c      B=0.0090
      B=0.0150
C      CX=6.
c ***** main parameter of RESNUC, determining the energy slope
c      CE=0.02  ! (for nucl. phys. A, 1995 calcul. Au(600MeV/n)+Cu)
      CE=0.02
c *****
c      SIG=0.07 ! (for nucl. phys. A, 1995 calcul. Au(600MeV/n)+Cu)
      SIG=0.07
      EM=(SQRT(A*A+4.*B)-A)/(2.*B)
CCC      ES=(SQRT(2.*B/CX)-A)/(2.*B)
CCC      IF(ES.LT.0.001) ES=0.001
CCC      IF(ES.GT.EM) ES=EM
      ES=5.
      XS=A*ES+B*ES*ES
      IF(XS.LT.0.00001) XS=0.00001
      IF(XS.GT.1.) XS=1.
C      CE=CX*XS/ES
      CX=CE*ES/XS
      AE=A+2*B*ES
      P1=AE*(1.-EXP(-CE*ES))/CE
      P2=(EXP(-CX*XS)-EXP(-CX))/CX
      P1=P1/(P1+P2)
c      IF(IT.EQ.1) PRINT 11,CE,ES,XS,P1,SIG
c 11   FORMAT(2X,' first param.: CE=',F5.2,'  div.energ. ES=',F4.2,
c     *' MeV/n  XS=',F5.3,'  relat.weight P1=',F5.3,'  SIG=',F5.3)
c      IF(IT.EQ.1) PRINT 10,A,B,CX,EM
c 10   FORMAT(2X,' second param.: A=',F6.4,' B=',F6.4,
c     *' CX=',F5.2,'  max.energ. EM=',F5.2,' MeV/n')
 20   BR=RNDMSMM(-1)
      IF(BR.GT.P1) GO TO 2
      EI=EXP(-CE*ES)+(1.-EXP(-CE*ES))*RNDMSMM(-1)
      E=(1./CE)*ALOG(1./EI)
      X1=A*E+B*E*E
      Y1=1.-X1
      GO TO 3
 2    XI=EXP(-CX)+(EXP(-CX*XS)-EXP(-CX))*RNDMSMM(-1)
      X1=(1./CX)*ALOG(1./XI)
      Y1=1.-X1
      E=(SQRT(A*A+4.*B*X1)-A)/(2.*B)
 3    CALL RANNOR(BR1,BR2)
      IF(EMIN.LT.0.001.AND.EMAX.LT.0.001) GO TO 25
      IF(E.GT.EMAX.OR.E.LT.EMIN) GO TO 20
 25   SIG0=SIG*(1.+2.*(E/EM)**2)
      YMI=0.
      YMA=1.
      IF(YMIN.GT.0.001) YMI=YMIN
      IF(YMAX.GT.0.001) YMA=YMAX
      Y=BR1*SIG0+Y1
      IF(Y.GT.YMI.AND.Y.LT.YMA) GO TO 4
      Y=BR2*SIG0+Y1
      IF(Y.GT.YMI.AND.Y.LT.YMA) GO TO 4
      GO TO 3
 4    X=1.-Y
      RETURN
      END
      SUBROUTINE B0G0MS(IA,IZ,BMS,GMS)
c finding surface BMS and symmetry GMS coefficients for IA,IZ fragment 
c according to Myers-Swiatecki mass formula.
      A=IA
      Z=IZ
c      I=INT(A+0.5)
c      J=INT(Z+0.5)
c      L=I-J
      A03=A**0.3333333
      A06=A03*A03
c      A13=A06*A06
c      Z13=Z**1.3333333
      D2=((A-2.*Z)/A)**2
      C1=15.677
      C2=18.56
c total volume coeff.
      W0MYE=C1*(1.-1.79*D2)
c total surface coeff.
      B0MYE=C2*(1.-1.79*D2)
c total symmetry coeff.
      G0MYE=1.79*(C1*A-C2*A06)/A
c 
      BMS=B0MYE
      GMS=G0MYE
      RETURN
      END
